/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(j){for(var e=[],m=0,A=j.length;m<A;m++)e[m]=Q[j[m]];return e};define(Q[101],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function m(A,L){if(!A)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=m}),define(Q[52],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function m(w){return(p,n,y)=>{let E=null,S=null;if(typeof y.value=="function"?(E="value",S=y.value):typeof y.get=="function"&&(E="get",S=y.get),!S)throw new Error("not supported");y[E]=w(S,n)}}e.createDecorator=m;let A=0;function L(){const w=`$memoize${A++}`;let p;const n=function(E,S,d){let g=null,P=null;if(typeof d.value=="function"?(g="value",P=d.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",P=d.get),!P)throw new Error("not supported");const I=`${w}:${S}`;d[g]=function(...o){return p=this,this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!0,enumerable:!1,writable:!0,value:P.apply(this,o)}),this[I]}};return n.clear=()=>{typeof p!="undefined"&&Object.getOwnPropertyNames(p).forEach(y=>{y.indexOf(w)===0&&delete p[y]})},n}e.createMemoizer=L;function b(w,p,n){return L()(w,p,n)}e.memoize=b;function M(w,p,n){return m((y,E)=>{const S=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...g){this[d]||(this[d]=n?n():void 0),clearTimeout(this[S]),p&&(this[d]=p(this[d],...g),g=[this[d]]),this[S]=setTimeout(()=>{y.apply(this,g),this[d]=n?n():void 0},w)}})}e.debounce=M;function r(w,p,n){return m((y,E)=>{const S=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,g=`$throttle$lastRun$${E}`,P=`$throttle$pending$${E}`;return function(...I){if(this[d]||(this[d]=n?n():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),p&&(this[d]=p(this[d],...I)),!this[P]){const o=this[g]+w;o<=Date.now()?(this[g]=Date.now(),y.apply(this,[this[d]]),this[d]=n?n():void 0):(this[P]=!0,this[S]=setTimeout(()=>{this[P]=!1,this[g]=Date.now(),y.apply(this,[this[d]]),this[d]=n?n():void 0},o-Date.now()))}}})}e.throttle=r}),define(Q[19],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class m{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=m,e.errorHandler=new m;function A(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=A;function L(u){w(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=L;function b(u){w(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=b;function M(u){if(u instanceof Error){let{name:t,message:i}=u;const s=u.stacktrace||u.stack;return{$isError:!0,name:t,message:i,stack:s}}return u}e.transformErrorForSerialization=M;const r="Canceled";function w(u){return u instanceof Error&&u.name===r&&u.message===r}e.isPromiseCanceledError=w;class p extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=p;function n(){const u=new Error(r);return u.name=u.message,u}e.canceled=n;function y(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=y;function E(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=E;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function d(u){const t=new Error(`${u} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class P extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=P;class I extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=I;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function l(u){const t=u;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function a(u,t=Object.create(null)){const i=new Error(u);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=a}),define(Q[35],J([0,1,19]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function A(C,q=0){return C[C.length-(1+q)]}e.tail=A;function L(C){if(C.length===0)throw new Error("Invalid tail call");return[C.slice(0,C.length-1),C[C.length-1]]}e.tail2=L;function b(C,q,N=(_,R)=>_===R){if(C===q)return!0;if(!C||!q||C.length!==q.length)return!1;for(let _=0,R=C.length;_<R;_++)if(!N(C[_],q[_]))return!1;return!0}e.equals=b;function M(C,q,N){let _=0,R=C.length-1;for(;_<=R;){const W=(_+R)/2|0,k=N(C[W],q);if(k<0)_=W+1;else if(k>0)R=W-1;else return W}return-(_+1)}e.binarySearch=M;function r(C,q){let N=0,_=C.length;if(_===0)return 0;for(;N<_;){const R=Math.floor((N+_)/2);q(C[R])?_=R:N=R+1}return N}e.findFirstInSorted=r;function w(C,q,N){if(C=C|0,C>=q.length)throw new TypeError("invalid index");let _=q[Math.floor(q.length*Math.random())],R=[],W=[],k=[];for(let F of q){const B=N(F,_);B<0?R.push(F):B>0?W.push(F):k.push(F)}return C<R.length?w(C,R,N):C<R.length+k.length?k[0]:w(C-(R.length+k.length),W,N)}e.quickSelect=w;function p(C,q){const N=[];let _;for(const R of C.slice(0).sort(q))!_||q(_[0],R)!==0?(_=[R],N.push(_)):_.push(R);return N}e.groupBy=p;function n(C,q,N){const _=[];function R(F,B,V){if(!(B===0&&V.length===0)){const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=B,G.toInsert.push(...V)):_.push({start:F,deleteCount:B,toInsert:V})}}let W=0,k=0;for(;;){if(W===C.length){R(W,0,q.slice(k));break}if(k===q.length){R(W,C.length-W,[]);break}const F=C[W],B=q[k],V=N(F,B);V===0?(W+=1,k+=1):V<0?(R(W,1,[]),W+=1):V>0&&(R(W,0,[B]),k+=1)}return _}e.sortedDiff=n;function y(C,q,N){const _=n(C,q,N),R=[],W=[];for(const k of _)R.push(...C.slice(k.start,k.start+k.deleteCount)),W.push(...k.toInsert);return{removed:R,added:W}}e.delta=y;function E(C,q,N){if(N===0)return[];const _=C.slice(0,N).sort(q);return d(C,q,_,N,C.length),_}e.top=E;function S(C,q,N,_,R){return N===0?Promise.resolve([]):new Promise((W,k)=>{(async()=>{const F=C.length,B=C.slice(0,N).sort(q);for(let V=N,G=Math.min(N+_,F);V<F;V=G,G=Math.min(G+_,F)){if(V>N&&await new Promise(Y=>setTimeout(Y)),R&&R.isCancellationRequested)throw(0,m.canceled)();d(C,q,B,V,G)}return B})().then(W,k)})}e.topAsync=S;function d(C,q,N,_,R){for(const W=N.length;_<R;_++){const k=C[_];if(q(k,N[W-1])<0){N.pop();const F=r(N,B=>q(k,B)<0);N.splice(F,0,k)}}}function g(C){return C.filter(q=>!!q)}e.coalesce=g;function P(C){let q=0;for(let N=0;N<C.length;N++)C[N]&&(C[q]=C[N],q+=1);C.length=q}e.coalesceInPlace=P;function I(C,q,N){C.splice(N,0,C.splice(q,1)[0])}e.move=I;function o(C){return!Array.isArray(C)||C.length===0}e.isFalsyOrEmpty=o;function l(C){return Array.isArray(C)&&C.length>0}e.isNonEmptyArray=l;function a(C,q){if(!q)return C.filter((_,R)=>C.indexOf(_)===R);const N=Object.create(null);return C.filter(_=>{const R=q(_);return N[R]?!1:(N[R]=!0,!0)})}e.distinct=a;function u(C){const q=new Set;return C.filter(N=>q.has(N)?!1:(q.add(N),!0))}e.distinctES6=u;function t(C){const q=Object.create(null);return N=>{const _=C(N);return q[_]?!1:(q[_]=!0,!0)}}e.uniqueFilter=t;function i(C,q){for(let N=C.length-1;N>=0;N--){const _=C[N];if(q(_))return N}return-1}e.lastIndex=i;function s(C,q){return C.length>0?C[0]:q}e.firstOrDefault=s;function c(C,q,N=(_,R)=>_===R){let _=0;for(let R=0,W=Math.min(C.length,q.length);R<W&&N(C[R],q[R]);R++)_++;return _}e.commonPrefixLength=c;function h(C){return[].concat(...C)}e.flatten=h;function f(C,q){let N=typeof q=="number"?C:0;typeof q=="number"?N=C:(N=0,q=C);const _=[];if(N<=q)for(let R=N;R<q;R++)_.push(R);else for(let R=N;R>q;R--)_.push(R);return _}e.range=f;function v(C,q,N){return C.reduce((_,R)=>(_[q(R)]=N?N(R):R,_),Object.create(null))}e.index=v;function D(C,q){return C.push(q),()=>T(C,q)}e.insert=D;function T(C,q){const N=C.indexOf(q);if(N>-1)return C.splice(N,1),q}e.remove=T;function U(C,q,N){const _=C.slice(0,q),R=C.slice(q);return _.concat(N,R)}e.arrayInsert=U;function H(C,q){let N;if(typeof q=="number"){let _=q;N=()=>{const R=Math.sin(_++)*179426549;return R-Math.floor(R)}}else N=Math.random;for(let _=C.length-1;_>0;_-=1){const R=Math.floor(N()*(_+1)),W=C[_];C[_]=C[R],C[R]=W}}e.shuffle=H;function X(C,q){const N=C.indexOf(q);N>-1&&(C.splice(N,1),C.unshift(q))}e.pushToStart=X;function te(C,q){const N=C.indexOf(q);N>-1&&(C.splice(N,1),C.push(q))}e.pushToEnd=te;function se(C,q){return Array.isArray(C)?C.map(q):q(C)}e.mapArrayOrNot=se;function O(C){return Array.isArray(C)?C:[C]}e.asArray=O;function z(C){return C[Math.floor(Math.random()*C.length)]}e.getRandomElement=z;function $(C,q){for(const N of C){const _=q(N);if(_!==void 0)return _}}e.mapFind=$}),define(Q[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function m(A){const L=this;let b=!1,M;return function(){return b||(b=!0,M=A.apply(L,arguments)),M}}e.once=m}),define(Q[62],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var m;(function(A){function L(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}A.is=L;const b=Object.freeze([]);function M(){return b}A.empty=M;function*r(u){yield u}A.single=r;function w(u){return u||b}A.from=w;function p(u){return!u||u[Symbol.iterator]().next().done===!0}A.isEmpty=p;function n(u){return u[Symbol.iterator]().next().value}A.first=n;function y(u,t){for(const i of u)if(t(i))return!0;return!1}A.some=y;function E(u,t){for(const i of u)if(t(i))return i}A.find=E;function*S(u,t){for(const i of u)t(i)&&(yield i)}A.filter=S;function*d(u,t){for(const i of u)yield t(i)}A.map=d;function*g(...u){for(const t of u)for(const i of t)yield i}A.concat=g;function*P(u){for(const t of u)for(const i of t)yield i}A.concatNested=P;function I(u,t,i){let s=i;for(const c of u)s=t(s,c);return s}A.reduce=I;function*o(u,t,i=u.length){for(t<0&&(t+=u.length),i<0?i+=u.length:i>u.length&&(i=u.length);t<i;t++)yield u[t]}A.slice=o;function l(u,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,u];const s=u[Symbol.iterator]();for(let c=0;c<t;c++){const h=s.next();if(h.done)return[i,A.empty()];i.push(h.value)}return[i,{[Symbol.iterator](){return s}}]}A.consume=l;function a(u,t,i=(s,c)=>s===c){const s=u[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const h=s.next(),f=c.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!i(h.value,f.value))return!1}}A.equals=a})(m=e.Iterable||(e.Iterable={}))}),define(Q[43],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var m;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(m=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var b;(function(t){t.DEFAULT={allowTrailingComma:!0}})(b=e.ParseOptions||(e.ParseOptions={}));function M(t,i=!1){let s=0,c=t.length,h="",f=0,v=16,D=0;function T(z){let $=0,C=0;for(;$<z;){const q=t.charCodeAt(s);if(q>=48&&q<=57)C=C*16+q-48;else if(q>=65&&q<=70)C=C*16+q-65+10;else if(q>=97&&q<=102)C=C*16+q-97+10;else break;s++,$++}return $<z&&(C=-1),C}function U(z){s=z,h="",f=0,v=16,D=0}function H(){const z=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return D=3,t.substring(z,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;$=s}else D=3;return t.substring(z,$)}function X(){let z="",$=s;for(;;){if(s>=c){z+=t.substring($,s),D=2;break}const C=t.charCodeAt(s);if(C===34){z+=t.substring($,s),s++;break}if(C===92){if(z+=t.substring($,s),s++,s>=c){D=2;break}switch(t.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const N=T(4);N>=0?z+=String.fromCharCode(N):D=4;break;default:D=5}$=s;continue}if(C>=0&&C<=31)if(w(C)){z+=t.substring($,s),D=2;break}else D=6;s++}return z}function te(){if(h="",D=0,f=s,s>=c)return f=c,v=17;let z=t.charCodeAt(s);if(r(z)){do s++,h+=String.fromCharCode(z),z=t.charCodeAt(s);while(r(z));return v=15}if(w(z))return s++,h+=String.fromCharCode(z),z===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),v=14;switch(z){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,h=X(),v=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<c&&!w(t.charCodeAt(s));)s++;return h=t.substring($,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const C=c-1;let q=!1;for(;s<C;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,q=!0;break}s++}return q||(s++,D=1),h=t.substring($,s),v=13}return h+=String.fromCharCode(z),s++,v=16;case 45:if(h+=String.fromCharCode(z),s++,s===c||!p(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=H(),v=11;default:for(;s<c&&se(z);)s++,z=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return h+=String.fromCharCode(z),s++,v=16}}function se(z){if(r(z)||w(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function O(){let z;do z=te();while(z>=12&&z<=15);return z}return{setPosition:U,getPosition:()=>s,scan:i?O:te,getToken:()=>v,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>D}}e.createScanner=M;function r(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function y(t,i){const s=[],c=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function D(T,U,H,X){f.value=T,f.offset=U,f.length=H,f.type=X,f.colonOffset=void 0,h=f}try{l(t,{onObjectBegin:(T,U)=>{if(i<=T)throw c;h=void 0,v=i>T,s.push("")},onObjectProperty:(T,U,H)=>{if(i<U||(D(T,U,H,"property"),s[s.length-1]=T,i<=U+H))throw c},onObjectEnd:(T,U)=>{if(i<=T)throw c;h=void 0,s.pop()},onArrayBegin:(T,U)=>{if(i<=T)throw c;h=void 0,s.push(0)},onArrayEnd:(T,U)=>{if(i<=T)throw c;h=void 0,s.pop()},onLiteralValue:(T,U,H)=>{if(i<U||(D(T,U,H,u(T)),i<=U+H))throw c},onSeparator:(T,U,H)=>{if(i<=U)throw c;if(T===":"&&h&&h.type==="property")h.colonOffset=U,v=!1,h=void 0;else if(T===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(v=!0,s[s.length-1]=""),h=void 0}}})}catch(T){if(T!==c)throw T}return{path:s,previousNode:h,isAtPropertyKey:v,matches:T=>{let U=0;for(let H=0;U<T.length&&H<s.length;H++)if(T[U]===s[H]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=y;function E(t,i=[],s=b.DEFAULT){let c=null,h=[];const f=[];function v(T){Array.isArray(h)?h.push(T):c!==null&&(h[c]=T)}return l(t,{onObjectBegin:()=>{const T={};v(T),f.push(h),h=T,c=null},onObjectProperty:T=>{c=T},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const T=[];v(T),f.push(h),h=T,c=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:v,onError:(T,U,H)=>{i.push({error:T,offset:U,length:H})}},s),h[0]}e.parse=E;function S(t,i=[],s=b.DEFAULT){let c={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){c.type==="property"&&(c.length=T-c.offset,c=c.parent)}function f(T){return c.children.push(T),T}l(t,{onObjectBegin:T=>{c=f({type:"object",offset:T,length:-1,parent:c,children:[]})},onObjectProperty:(T,U,H)=>{c=f({type:"property",offset:U,length:-1,parent:c,children:[]}),c.children.push({type:"string",value:T,offset:U,length:H,parent:c})},onObjectEnd:(T,U)=>{c.length=T+U-c.offset,c=c.parent,h(T+U)},onArrayBegin:(T,U)=>{c=f({type:"array",offset:T,length:-1,parent:c,children:[]})},onArrayEnd:(T,U)=>{c.length=T+U-c.offset,c=c.parent,h(T+U)},onLiteralValue:(T,U,H)=>{f({type:u(T),offset:U,length:H,parent:c,value:T}),h(U+H)},onSeparator:(T,U,H)=>{c.type==="property"&&(T===":"?c.colonOffset=U:T===","&&h(U))},onError:(T,U,H)=>{i.push({error:T,offset:U,length:H})}},s);const D=c.children[0];return D&&delete D.parent,D}e.parseTree=S;function d(t,i){if(!!t){let s=t;for(let c of i)if(typeof c=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===c){s=f.children[1],h=!0;break}if(!h)return}else{const h=c;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}}e.findNodeAtLocation=d;function g(t){if(!t.parent||!t.parent.children)return[];const i=g(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=g;function P(t){switch(t.type){case"array":return t.children.map(P);case"object":const i=Object.create(null);for(let s of t.children){const c=s.children[1];c&&(i[s.children[0].value]=P(c))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=P;function I(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=I;function o(t,i,s=!1){if(I(t,i,s)){const c=t.children;if(Array.isArray(c))for(let h=0;h<c.length&&c[h].offset<=i;h++){const f=o(c[h],i,s);if(f)return f}return t}}e.findNodeAtOffset=o;function l(t,i,s=b.DEFAULT){const c=M(t,!1);function h(B){return B?()=>B(c.getTokenOffset(),c.getTokenLength()):()=>!0}function f(B){return B?V=>B(V,c.getTokenOffset(),c.getTokenLength()):()=>!0}const v=h(i.onObjectBegin),D=f(i.onObjectProperty),T=h(i.onObjectEnd),U=h(i.onArrayBegin),H=h(i.onArrayEnd),X=f(i.onLiteralValue),te=f(i.onSeparator),se=h(i.onComment),O=f(i.onError),z=s&&s.disallowComments,$=s&&s.allowTrailingComma;function C(){for(;;){const B=c.scan();switch(c.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:z||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(B){case 12:case 13:z?q(10):se();break;case 16:q(1);break;case 15:case 14:break;default:return B}}}function q(B,V=[],G=[]){if(O(B),V.length+G.length>0){let Y=c.getToken();for(;Y!==17;){if(V.indexOf(Y)!==-1){C();break}else if(G.indexOf(Y)!==-1)break;Y=C()}}}function N(B){const V=c.getTokenValue();return B?X(V):D(V),C(),!0}function _(){switch(c.getToken()){case 11:let B=0;try{B=JSON.parse(c.getTokenValue()),typeof B!="number"&&(q(2),B=0)}catch(V){q(2)}X(B);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return C(),!0}function R(){return c.getToken()!==10?(q(3,[],[2,5]),!1):(N(!1),c.getToken()===6?(te(":"),C(),F()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function W(){v(),C();let B=!1;for(;c.getToken()!==2&&c.getToken()!==17;){if(c.getToken()===5){if(B||q(4,[],[]),te(","),C(),c.getToken()===2&&$)break}else B&&q(6,[],[]);R()||q(4,[],[2,5]),B=!0}return T(),c.getToken()!==2?q(7,[2],[]):C(),!0}function k(){U(),C();let B=!1;for(;c.getToken()!==4&&c.getToken()!==17;){if(c.getToken()===5){if(B||q(4,[],[]),te(","),C(),c.getToken()===4&&$)break}else B&&q(6,[],[]);F()||q(4,[],[4,5]),B=!0}return H(),c.getToken()!==4?q(8,[4],[]):C(),!0}function F(){switch(c.getToken()){case 3:return k();case 1:return W();case 10:return N(!0);default:return _()}}return C(),c.getToken()===17?s.allowEmptyContent?!0:(q(4,[],[]),!1):F()?(c.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=l;function a(t,i){let s=M(t),c=[],h,f=0,v;do switch(v=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==v&&c.push(t.substring(f,v)),i!==void 0&&c.push(s.getTokenValue().replace(/[^\r\n]/g,i)),f=s.getPosition();break}while(h!==17);return c.join("")}e.stripComments=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Q[102],J([0,1,43]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function A(w,p,n){let y,E,S,d,g;if(p){for(d=p.offset,g=d+p.length,S=d;S>0&&!r(w,S-1);)S--;let f=g;for(;f<w.length&&!r(w,f);)f++;E=w.substring(S,f),y=b(E,n)}else E=w,y=0,S=0,d=0,g=w.length;const P=M(n,w);let I=!1,o=0,l;n.insertSpaces?l=L(" ",n.tabSize||4):l="	";const a=(0,m.createScanner)(E,!1);let u=!1;function t(){return P+L(l,y+o)}function i(){let f=a.scan();for(I=!1;f===15||f===14;)I=I||f===14,f=a.scan();return u=f===16||a.getTokenError()!==0,f}const s=[];function c(f,v,D){!u&&v<g&&D>d&&w.substring(v,D)!==f&&s.push({offset:v,length:D-v,content:f})}let h=i();if(h!==17){const f=a.getTokenOffset()+S,v=L(l,y);c(v,S,f)}for(;h!==17;){let f=a.getTokenOffset()+a.getTokenLength()+S,v=i(),D="";for(;!I&&(v===12||v===13);){const U=a.getTokenOffset()+S;c(" ",f,U),f=a.getTokenOffset()+a.getTokenLength()+S,D=v===12?t():"",v=i()}if(v===2)h!==1&&(o--,D=t());else if(v===4)h!==3&&(o--,D=t());else{switch(h){case 3:case 1:o++,D=t();break;case 5:case 12:D=t();break;case 13:I?D=t():D=" ";break;case 6:D=" ";break;case 10:if(v===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?D=" ":v!==5&&v!==17&&(u=!0);break;case 16:u=!0;break}I&&(v===12||v===13)&&(D=t())}const T=a.getTokenOffset()+S;c(D,f,T),h=v}return s}e.format=A;function L(w,p){let n="";for(let y=0;y<p;y++)n+=w;return n}function b(w,p){let n=0,y=0;const E=p.tabSize||4;for(;n<w.length;){const S=w.charAt(n);if(S===" ")y++;else if(S==="	")y+=E;else break;n++}return Math.floor(y/E)}function M(w,p){for(let n=0;n<p.length;n++){const y=p.charAt(n);if(y==="\r")return n+1<p.length&&p.charAt(n+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=M;function r(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=r}),define(Q[103],J([0,1,43,102]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(p,n,y){return b(p,n,void 0,y)}e.removeProperty=L;function b(p,n,y,E,S){const d=n.slice(),g=[],P=(0,m.parseTree)(p,g);let I,o;for(;d.length>0&&(o=d.pop(),I=(0,m.findNodeAtLocation)(P,d),I===void 0&&y!==void 0);)typeof o=="string"?y={[o]:y}:y=[y];if(I)if(I.type==="object"&&typeof o=="string"&&Array.isArray(I.children)){const l=(0,m.findNodeAtLocation)(I,[o]);if(l!==void 0)if(y===void 0){if(!l.parent)throw new Error("Malformed AST");const a=I.children.indexOf(l.parent);let u,t=l.parent.offset+l.parent.length;if(a>0){const i=I.children[a-1];u=i.offset+i.length}else u=I.offset+1,I.children.length>1&&(t=I.children[1].offset);return M(p,{offset:u,length:t-u,content:""},E)}else return M(p,{offset:l.offset,length:l.length,content:JSON.stringify(y)},E);else{if(y===void 0)return[];const a=`${JSON.stringify(o)}: ${JSON.stringify(y)}`,u=S?S(I.children.map(i=>i.children[0].value)):I.children.length;let t;if(u>0){const i=I.children[u-1];t={offset:i.offset+i.length,length:0,content:","+a}}else I.children.length===0?t={offset:I.offset+1,length:0,content:a}:t={offset:I.offset+1,length:0,content:a+","};return M(p,t,E)}}else if(I.type==="array"&&typeof o=="number"&&Array.isArray(I.children))if(y!==void 0){const l=`${JSON.stringify(y)}`;let a;if(I.children.length===0||o===0)a={offset:I.offset+1,length:0,content:I.children.length===0?l:l+","};else{const u=o===-1||o>I.children.length?I.children.length:o,t=I.children[u-1];a={offset:t.offset+t.length,length:0,content:","+l}}return M(p,a,E)}else{const l=o,a=I.children[l];let u;if(I.children.length===1)u={offset:I.offset+1,length:I.length-2,content:""};else if(I.children.length-1===l){const t=I.children[l-1],i=t.offset+t.length,s=I.offset+I.length;u={offset:i,length:s-2-i,content:""}}else u={offset:a.offset,length:I.children[l+1].offset-a.offset,content:""};return M(p,u,E)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${I.type}`);else{if(y===void 0)throw new Error("Can not delete in empty document");return M(p,{offset:P?P.offset:0,length:P?P.length:0,content:JSON.stringify(y)},E)}}e.setProperty=b;function M(p,n,y){let E=r(p,n),S=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;S>0&&!(0,A.isEOL)(E,S-1);)S--;for(;d<E.length&&!(0,A.isEOL)(E,d);)d++}const g=(0,A.format)(E,{offset:S,length:d-S},y);for(let I=g.length-1;I>=0;I--){const o=g[I];E=r(E,o),S=Math.min(S,o.offset),d=Math.max(d,o.offset+o.length),d+=o.content.length-o.length}const P=p.length-(E.length-d)-S;return[{offset:S,length:P,content:E.substring(S,d)}]}e.withFormatting=M;function r(p,n){return p.substring(0,n.offset)+n.content+p.substring(n.offset+n.length)}e.applyEdit=r;function w(p,n){let y=n.slice(0).sort((S,d)=>{const g=S.offset-d.offset;return g===0?S.length-d.length:g}),E=p.length;for(let S=y.length-1;S>=0;S--){let d=y[S];if(d.offset+d.length<=E)p=r(p,d);else throw new Error("Overlapping edit");E=d.offset}return p}e.applyEdits=w}),define(Q[57],J([0,1,19]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var A;(function(o){o[o.DependsOnKbLayout=-1]="DependsOnKbLayout",o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(A=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(l,a){this._keyCodeToStr[l]=a,this._strToKeyCode[a.toLowerCase()]=l}keyCodeToStr(l){return this._keyCodeToStr[l]}strToKeyCode(l){return this._strToKeyCode[l.toLowerCase()]||0}}const b=new L,M=new L,r=new L;(function(){function o(l,a,u=a,t=u){b.define(l,a),M.define(l,u),r.define(l,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var w;(function(o){function l(s){return b.keyCodeToStr(s)}o.toString=l;function a(s){return b.strToKeyCode(s)}o.fromString=a;function u(s){return M.keyCodeToStr(s)}o.toUserSettingsUS=u;function t(s){return r.keyCodeToStr(s)}o.toUserSettingsGeneral=t;function i(s){return M.strToKeyCode(s)||r.strToKeyCode(s)}o.fromUserSettings=i})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(p||(p={}));var n;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(n=e.KeyMod||(e.KeyMod={}));function y(o,l){const a=(l&65535)<<16>>>0;return(o|a)>>>0}e.KeyChord=y;function E(o,l){if(o===0)return null;const a=(o&65535)>>>0,u=(o&4294901760)>>>16;return u!==0?new g([S(a,l),S(u,l)]):new g([S(a,l)])}e.createKeybinding=E;function S(o,l){const a=!!(o&2048),u=!!(o&256),t=l===2?u:a,i=!!(o&1024),s=!!(o&512),c=l===2?a:u,h=o&255;return new d(t,i,s,c,h)}e.createSimpleKeybinding=S;class d{constructor(l,a,u,t,i){this.ctrlKey=l,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyCode=i}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",u=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${l}${a}${u}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new g([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class g{constructor(l){if(l.length===0)throw(0,m.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let a=0,u=this.parts.length;a<u;a++)a!==0&&(l+=";"),l+=this.parts[a].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let a=0;a<this.parts.length;a++)if(!this.parts[a].equals(l.parts[a]))return!1;return!0}}e.ChordKeybinding=g;class P{constructor(l,a,u,t,i,s){this.ctrlKey=l,this.shiftKey=a,this.altKey=u,this.metaKey=t,this.keyLabel=i,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=P;class I{}e.ResolvedKeybinding=I}),define(Q[2],J([0,1,42,62]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let b=null;function M(l){b=l}if(e.setDisposableTracker=M,L){const l="__is_disposable_tracked__";b=new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[l]||console.log(u)},3e3)}markTracked(a){if(a&&a!==g.None)try{a[l]=!0}catch(u){}}}}function r(l){!b||b.markTracked(l)}function w(l){return b&&b.trackDisposable(l),l}e.trackDisposable=w;class p extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=p;function n(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=n;function y(l){if(A.Iterable.is(l)){let a=[];for(const u of l)if(u){r(u);try{u.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new p(a);return Array.isArray(l)?[]:l}else if(l)return r(l),l.dispose(),l}e.dispose=y;function E(...l){return l.forEach(r),S(()=>y(l))}e.combinedDisposable=E;function S(l){const a=w({dispose:()=>{r(a),l()}});return a}e.toDisposable=S;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{y(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return r(a),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new d,w(this)}dispose(){r(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class P{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var u;this._isDisposed||a===this._value||((u=this._value)===null||u===void 0||u.dispose(),a&&r(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,r(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=P;class I{constructor(){this.references=new Map}acquire(a,...u){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...u)},this.references.set(a,t));const{object:i}=t,s=(0,m.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=I;class o{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=o}),define(Q[78],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class m{constructor(b){this.element=b,this.next=m.Undefined,this.prev=m.Undefined}}m.Undefined=new m(void 0);class A{constructor(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===m.Undefined}clear(){this._first=m.Undefined,this._last=m.Undefined,this._size=0}unshift(b){return this._insert(b,!1)}push(b){return this._insert(b,!0)}_insert(b,M){const r=new m(b);if(this._first===m.Undefined)this._first=r,this._last=r;else if(M){const p=this._last;this._last=r,r.prev=p,p.next=r}else{const p=this._first;this._first=r,r.next=p,p.prev=r}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(r))}}shift(){if(this._first!==m.Undefined){const b=this._first.element;return this._remove(this._first),b}}pop(){if(this._last!==m.Undefined){const b=this._last.element;return this._remove(this._last),b}}_remove(b){if(b.prev!==m.Undefined&&b.next!==m.Undefined){const M=b.prev;M.next=b.next,b.next.prev=M}else b.prev===m.Undefined&&b.next===m.Undefined?(this._first=m.Undefined,this._last=m.Undefined):b.next===m.Undefined?(this._last=this._last.prev,this._last.next=m.Undefined):b.prev===m.Undefined&&(this._first=this._first.next,this._first.prev=m.Undefined);this._size-=1}*[Symbol.iterator](){let b=this._first;for(;b!==m.Undefined;)yield b.element,b=b.next}}e.LinkedList=A});"use strict";(function(){function j(L){const b=[];typeof L=="number"&&b.push("code/timeOrigin",L);function M(w){b.push(w,Date.now())}function r(){const w=[];for(let p=0;p<b.length;p+=2)w.push({name:b[p],startTime:b[p+1]});return w}return{mark:M,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const b=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const M of performance.getEntriesByType("mark"))b.push({name:M.name,startTime:Math.round(L+M.startTime)});return b}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function m(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return m(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=m(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=m(A))})(),define(Q[3],J([0,1]),function(j,e){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const A="en";let L=!1,b=!1,M=!1,r=!1,w=!1,p=!1,n=!1,y,E=A,S,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const P=typeof((m=g==null?void 0:g.versions)===null||m===void 0?void 0:m.electron)=="string"&&g.type==="renderer";if(e.isElectronSandboxed=P&&(g==null?void 0:g.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const c=g==null?void 0:g.env.VSCODE_BROWSER_CODE_LOADING;if(typeof c=="string")return c==="none"||c==="code"||c==="bypassHeatCheck"||c==="bypassHeatCheckAndEagerCompile"?c:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!P)d=navigator.userAgent,L=d.indexOf("Windows")>=0,b=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=d.indexOf("Linux")>=0,p=!0,y=navigator.language,E=y;else if(typeof g=="object"){L=g.platform==="win32",b=g.platform==="darwin",M=g.platform==="linux",r=M&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,y=A,E=A;const c=g.env.VSCODE_NLS_CONFIG;if(c)try{const h=JSON.parse(c),f=h.availableLanguages["*"];y=h.locale,E=f||A,S=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var I;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(I=e.Platform||(e.Platform={}));function o(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let l=0;b?l=1:L?l=3:M&&(l=2),e.isWindows=L,e.isMacintosh=b,e.isLinux=M,e.isLinuxSnap=r,e.isNative=w,e.isWeb=p,e.isIOS=n,e.platform=l,e.userAgent=d,e.language=E;var a;(function(c){function h(){return e.language}c.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=f;function v(){return e.language==="en"}c.isDefault=v})(a=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",D=>{if(D.data&&D.data.vscodeSetImmediateId)for(let T=0,U=f.length;T<U;T++){const H=f[T];if(H.id===D.data.vscodeSetImmediateId){f.splice(T,1),H.callback();return}}});let v=0;return D=>{const T=++v;f.push({id:T,callback:D}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(g==null?void 0:g.nextTick)=="function")return g.nextTick.bind(g);const h=Promise.resolve();return f=>h.then(f)}();var u;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(u=e.OperatingSystem||(e.OperatingSystem={})),e.OS=b||n?2:L?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,t=new Uint16Array(c.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Q[32],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let A;if(typeof m.globals.vscode!="undefined"){const L=m.globals.vscode.process;A={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(b){return(0,m.setImmediate)(b)}}}else typeof process!="undefined"?A={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:A={get platform(){return m.isWindows?"win32":m.isMacintosh?"darwin":"linux"},nextTick(L){return(0,m.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.nextTick=A.nextTick}),define(Q[7],J([0,1,32]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,L=97,b=90,M=122,r=46,w=47,p=92,n=58,y=63;class E extends Error{constructor(a,u,t){let i;typeof u=="string"&&u.indexOf("not ")===0?(i="must not be",u=u.replace(/^not /,"")):i="must be";const s=a.indexOf(".")!==-1?"property":"argument";let c=`The "${a}" ${s} ${i} of type ${u}`;c+=`. Received type ${typeof t}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function S(l,a){if(typeof l!="string")throw new E(a,"string",l)}function d(l){return l===w||l===p}function g(l){return l===w}function P(l){return l>=A&&l<=b||l>=L&&l<=M}function I(l,a,u,t){let i="",s=0,c=-1,h=0,f=0;for(let v=0;v<=l.length;++v){if(v<l.length)f=l.charCodeAt(v);else{if(t(f))break;f=w}if(t(f)){if(!(c===v-1||h===1))if(h===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==r||i.charCodeAt(i.length-2)!==r){if(i.length>2){const D=i.lastIndexOf(u);D===-1?(i="",s=0):(i=i.slice(0,D),s=i.length-1-i.lastIndexOf(u)),c=v,h=0;continue}else if(i.length!==0){i="",s=0,c=v,h=0;continue}}a&&(i+=i.length>0?`${u}..`:"..",s=2)}else i.length>0?i+=`${u}${l.slice(c+1,v)}`:i=l.slice(c+1,v),s=v-c-1;c=v,h=0}else f===r&&h!==-1?++h:h=-1}return i}function o(l,a){if(a===null||typeof a!="object")throw new E("pathObject","Object",a);const u=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${t}`:`${u}${l}${t}`:t}e.win32={resolve(...l){let a="",u="",t=!1;for(let i=l.length-1;i>=-1;i--){let s;if(i>=0){if(s=l[i],S(s,"path"),s.length===0)continue}else a.length===0?s=m.cwd():(s=m.env[`=${a}`]||m.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==a.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${a}\\`));const c=s.length;let h=0,f="",v=!1;const D=s.charCodeAt(0);if(c===1)d(D)&&(h=1,v=!0);else if(d(D))if(v=!0,d(s.charCodeAt(1))){let T=2,U=T;for(;T<c&&!d(s.charCodeAt(T));)T++;if(T<c&&T!==U){const H=s.slice(U,T);for(U=T;T<c&&d(s.charCodeAt(T));)T++;if(T<c&&T!==U){for(U=T;T<c&&!d(s.charCodeAt(T));)T++;(T===c||T!==U)&&(f=`\\\\${H}\\${s.slice(U,T)}`,h=T)}}}else h=1;else P(D)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),h=2,c>2&&d(s.charCodeAt(2))&&(v=!0,h=3));if(f.length>0)if(a.length>0){if(f.toLowerCase()!==a.toLowerCase())continue}else a=f;if(t){if(a.length>0)break}else if(u=`${s.slice(h)}\\${u}`,t=v,v&&a.length>0)break}return u=I(u,!t,"\\",d),t?`${a}\\${u}`:`${a}${u}`||"."},normalize(l){S(l,"path");const a=l.length;if(a===0)return".";let u=0,t,i=!1;const s=l.charCodeAt(0);if(a===1)return g(s)?"\\":l;if(d(s))if(i=!0,d(l.charCodeAt(1))){let h=2,f=h;for(;h<a&&!d(l.charCodeAt(h));)h++;if(h<a&&h!==f){const v=l.slice(f,h);for(f=h;h<a&&d(l.charCodeAt(h));)h++;if(h<a&&h!==f){for(f=h;h<a&&!d(l.charCodeAt(h));)h++;if(h===a)return`\\\\${v}\\${l.slice(f)}\\`;h!==f&&(t=`\\\\${v}\\${l.slice(f,h)}`,u=h)}}}else u=1;else P(s)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),u=2,a>2&&d(l.charCodeAt(2))&&(i=!0,u=3));let c=u<a?I(l.slice(u),!i,"\\",d):"";return c.length===0&&!i&&(c="."),c.length>0&&d(l.charCodeAt(a-1))&&(c+="\\"),t===void 0?i?`\\${c}`:c:i?`${t}\\${c}`:`${t}${c}`},isAbsolute(l){S(l,"path");const a=l.length;if(a===0)return!1;const u=l.charCodeAt(0);return d(u)||a>2&&P(u)&&l.charCodeAt(1)===n&&d(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let a,u;for(let s=0;s<l.length;++s){const c=l[s];S(c,"path"),c.length>0&&(a===void 0?a=u=c:a+=`\\${c}`)}if(a===void 0)return".";let t=!0,i=0;if(typeof u=="string"&&d(u.charCodeAt(0))){++i;const s=u.length;s>1&&d(u.charCodeAt(1))&&(++i,s>2&&(d(u.charCodeAt(2))?++i:t=!1))}if(t){for(;i<a.length&&d(a.charCodeAt(i));)i++;i>=2&&(a=`\\${a.slice(i)}`)}return e.win32.normalize(a)},relative(l,a){if(S(l,"from"),S(a,"to"),l===a)return"";const u=e.win32.resolve(l),t=e.win32.resolve(a);if(u===t||(l=u.toLowerCase(),a=t.toLowerCase(),l===a))return"";let i=0;for(;i<l.length&&l.charCodeAt(i)===p;)i++;let s=l.length;for(;s-1>i&&l.charCodeAt(s-1)===p;)s--;const c=s-i;let h=0;for(;h<a.length&&a.charCodeAt(h)===p;)h++;let f=a.length;for(;f-1>h&&a.charCodeAt(f-1)===p;)f--;const v=f-h,D=c<v?c:v;let T=-1,U=0;for(;U<D;U++){const X=l.charCodeAt(i+U);if(X!==a.charCodeAt(h+U))break;X===p&&(T=U)}if(U!==D){if(T===-1)return t}else{if(v>D){if(a.charCodeAt(h+U)===p)return t.slice(h+U+1);if(U===2)return t.slice(h+U)}c>D&&(l.charCodeAt(i+U)===p?T=U:U===2&&(T=3)),T===-1&&(T=0)}let H="";for(U=i+T+1;U<=s;++U)(U===s||l.charCodeAt(U)===p)&&(H+=H.length===0?"..":"\\..");return h+=T,H.length>0?`${H}${t.slice(h,f)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,f))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const a=e.win32.resolve(l);if(a.length<=2)return l;if(a.charCodeAt(0)===p){if(a.charCodeAt(1)===p){const u=a.charCodeAt(2);if(u!==y&&u!==r)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(P(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===p)return`\\\\?\\${a}`;return l},dirname(l){S(l,"path");const a=l.length;if(a===0)return".";let u=-1,t=0;const i=l.charCodeAt(0);if(a===1)return d(i)?l:".";if(d(i)){if(u=t=1,d(l.charCodeAt(1))){let h=2,f=h;for(;h<a&&!d(l.charCodeAt(h));)h++;if(h<a&&h!==f){for(f=h;h<a&&d(l.charCodeAt(h));)h++;if(h<a&&h!==f){for(f=h;h<a&&!d(l.charCodeAt(h));)h++;if(h===a)return l;h!==f&&(u=t=h+1)}}}}else P(i)&&l.charCodeAt(1)===n&&(u=a>2&&d(l.charCodeAt(2))?3:2,t=u);let s=-1,c=!0;for(let h=a-1;h>=t;--h)if(d(l.charCodeAt(h))){if(!c){s=h;break}}else c=!1;if(s===-1){if(u===-1)return".";s=u}return l.slice(0,s)},basename(l,a){a!==void 0&&S(a,"ext"),S(l,"path");let u=0,t=-1,i=!0,s;if(l.length>=2&&P(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(u=2),a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let c=a.length-1,h=-1;for(s=l.length-1;s>=u;--s){const f=l.charCodeAt(s);if(d(f)){if(!i){u=s+1;break}}else h===-1&&(i=!1,h=s+1),c>=0&&(f===a.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=h))}return u===t?t=h:t===-1&&(t=l.length),l.slice(u,t)}for(s=l.length-1;s>=u;--s)if(d(l.charCodeAt(s))){if(!i){u=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(u,t)},extname(l){S(l,"path");let a=0,u=-1,t=0,i=-1,s=!0,c=0;l.length>=2&&l.charCodeAt(1)===n&&P(l.charCodeAt(0))&&(a=t=2);for(let h=l.length-1;h>=a;--h){const f=l.charCodeAt(h);if(d(f)){if(!s){t=h+1;break}continue}i===-1&&(s=!1,i=h+1),f===r?u===-1?u=h:c!==1&&(c=1):u!==-1&&(c=-1)}return u===-1||i===-1||c===0||c===1&&u===i-1&&u===t+1?"":l.slice(u,i)},format:o.bind(null,"\\"),parse(l){S(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const u=l.length;let t=0,i=l.charCodeAt(0);if(u===1)return d(i)?(a.root=a.dir=l,a):(a.base=a.name=l,a);if(d(i)){if(t=1,d(l.charCodeAt(1))){let T=2,U=T;for(;T<u&&!d(l.charCodeAt(T));)T++;if(T<u&&T!==U){for(U=T;T<u&&d(l.charCodeAt(T));)T++;if(T<u&&T!==U){for(U=T;T<u&&!d(l.charCodeAt(T));)T++;T===u?t=T:T!==U&&(t=T+1)}}}}else if(P(i)&&l.charCodeAt(1)===n){if(u<=2)return a.root=a.dir=l,a;if(t=2,d(l.charCodeAt(2))){if(u===3)return a.root=a.dir=l,a;t=3}}t>0&&(a.root=l.slice(0,t));let s=-1,c=t,h=-1,f=!0,v=l.length-1,D=0;for(;v>=t;--v){if(i=l.charCodeAt(v),d(i)){if(!f){c=v+1;break}continue}h===-1&&(f=!1,h=v+1),i===r?s===-1?s=v:D!==1&&(D=1):s!==-1&&(D=-1)}return h!==-1&&(s===-1||D===0||D===1&&s===h-1&&s===c+1?a.base=a.name=l.slice(c,h):(a.name=l.slice(c,s),a.base=l.slice(c,h),a.ext=l.slice(s,h))),c>0&&c!==t?a.dir=l.slice(0,c-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let a="",u=!1;for(let t=l.length-1;t>=-1&&!u;t--){const i=t>=0?l[t]:m.cwd();S(i,"path"),i.length!==0&&(a=`${i}/${a}`,u=i.charCodeAt(0)===w)}return a=I(a,!u,"/",g),u?`/${a}`:a.length>0?a:"."},normalize(l){if(S(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===w,u=l.charCodeAt(l.length-1)===w;return l=I(l,!a,"/",g),l.length===0?a?"/":u?"./":".":(u&&(l+="/"),a?`/${l}`:l)},isAbsolute(l){return S(l,"path"),l.length>0&&l.charCodeAt(0)===w},join(...l){if(l.length===0)return".";let a;for(let u=0;u<l.length;++u){const t=l[u];S(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(l,a){if(S(l,"from"),S(a,"to"),l===a||(l=e.posix.resolve(l),a=e.posix.resolve(a),l===a))return"";const u=1,t=l.length,i=t-u,s=1,c=a.length-s,h=i<c?i:c;let f=-1,v=0;for(;v<h;v++){const T=l.charCodeAt(u+v);if(T!==a.charCodeAt(s+v))break;T===w&&(f=v)}if(v===h)if(c>h){if(a.charCodeAt(s+v)===w)return a.slice(s+v+1);if(v===0)return a.slice(s+v)}else i>h&&(l.charCodeAt(u+v)===w?f=v:v===0&&(f=0));let D="";for(v=u+f+1;v<=t;++v)(v===t||l.charCodeAt(v)===w)&&(D+=D.length===0?"..":"/..");return`${D}${a.slice(s+f)}`},toNamespacedPath(l){return l},dirname(l){if(S(l,"path"),l.length===0)return".";const a=l.charCodeAt(0)===w;let u=-1,t=!0;for(let i=l.length-1;i>=1;--i)if(l.charCodeAt(i)===w){if(!t){u=i;break}}else t=!1;return u===-1?a?"/":".":a&&u===1?"//":l.slice(0,u)},basename(l,a){a!==void 0&&S(a,"ext"),S(l,"path");let u=0,t=-1,i=!0,s;if(a!==void 0&&a.length>0&&a.length<=l.length){if(a===l)return"";let c=a.length-1,h=-1;for(s=l.length-1;s>=0;--s){const f=l.charCodeAt(s);if(f===w){if(!i){u=s+1;break}}else h===-1&&(i=!1,h=s+1),c>=0&&(f===a.charCodeAt(c)?--c==-1&&(t=s):(c=-1,t=h))}return u===t?t=h:t===-1&&(t=l.length),l.slice(u,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===w){if(!i){u=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":l.slice(u,t)},extname(l){S(l,"path");let a=-1,u=0,t=-1,i=!0,s=0;for(let c=l.length-1;c>=0;--c){const h=l.charCodeAt(c);if(h===w){if(!i){u=c+1;break}continue}t===-1&&(i=!1,t=c+1),h===r?a===-1?a=c:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||t===-1||s===0||s===1&&a===t-1&&a===u+1?"":l.slice(a,t)},format:o.bind(null,"/"),parse(l){S(l,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return a;const u=l.charCodeAt(0)===w;let t;u?(a.root="/",t=1):t=0;let i=-1,s=0,c=-1,h=!0,f=l.length-1,v=0;for(;f>=t;--f){const D=l.charCodeAt(f);if(D===w){if(!h){s=f+1;break}continue}c===-1&&(h=!1,c=f+1),D===r?i===-1?i=f:v!==1&&(v=1):i!==-1&&(v=-1)}if(c!==-1){const D=s===0&&u?1:s;i===-1||v===0||v===1&&i===c-1&&i===s+1?a.base=a.name=l.slice(D,c):(a.name=l.slice(D,i),a.base=l.slice(D,c),a.ext=l.slice(i,c))}return s>0?a.dir=l.slice(0,s-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=m.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=m.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=m.platform==="win32"?e.win32.join:e.posix.join,e.resolve=m.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=m.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=m.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=m.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=m.platform==="win32"?e.win32.extname:e.posix.extname,e.format=m.platform==="win32"?e.win32.format:e.posix.format,e.parse=m.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=m.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=m.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=m.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[104],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var m;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(m=e.Source||(e.Source={}));var A;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(A=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(b,...M){const r=M.reduce((n,y)=>(n[y]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(n=>!r[n]).forEach(n=>{for(let y=0;y<w.length;y++)if(n.search(w[y])!==-1){delete b[n];break}})}e.sanitizeProcessEnvironment=L}),define(Q[79],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var m;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(m=e.ScanCode||(e.ScanCode={}));const A=[],L=Object.create(null),b=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>b[r]||0,toEnum:r=>L[r]||0,toString:r=>A[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class M{constructor(w,p,n,y,E){this.ctrlKey=w,this.shiftKey=p,this.altKey=n,this.metaKey=y,this.scanCode=E}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=M,function(){function r(w,p){A[w]=p,L[p]=w,b[p.toLowerCase()]=w}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function r(w,p){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(Q[105],J([0,1,57,79]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(M){M=M.toLowerCase().trim();let r=!1,w=!1,p=!1,n=!1,y;do y=!1,/^ctrl(\+|\-)/.test(M)&&(r=!0,M=M.substr("ctrl-".length),y=!0),/^shift(\+|\-)/.test(M)&&(w=!0,M=M.substr("shift-".length),y=!0),/^alt(\+|\-)/.test(M)&&(p=!0,M=M.substr("alt-".length),y=!0),/^meta(\+|\-)/.test(M)&&(n=!0,M=M.substr("meta-".length),y=!0),/^win(\+|\-)/.test(M)&&(n=!0,M=M.substr("win-".length),y=!0),/^cmd(\+|\-)/.test(M)&&(n=!0,M=M.substr("cmd-".length),y=!0);while(y);let E;const S=M.indexOf(" ");return S>0?(E=M.substring(0,S),M=M.substring(S)):(E=M,M=""),{remains:M,ctrl:r,shift:w,alt:p,meta:n,key:E}}static parseSimpleKeybinding(M){const r=this._readModifiers(M),w=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,w),r.remains]}static parseKeybinding(M,r){if(!M)return null;const w=[];let p;do[p,M]=this.parseSimpleKeybinding(M),w.push(p);while(M.length>0);return new m.ChordKeybinding(w)}static parseSimpleUserBinding(M){const r=this._readModifiers(M),w=r.key.match(/^\[([^\]]+)\]$/);if(w){const n=w[1],y=A.ScanCodeUtils.lowerCaseToEnum(n);return[new A.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,y),r.remains]}const p=m.KeyCodeUtils.fromUserSettings(r.key);return[new m.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,p),r.remains]}static parseUserBinding(M){if(!M)return[];const r=[];let w;for(;M.length>0;)[w,M]=this.parseSimpleUserBinding(M),r.push(w);return r}}e.KeybindingParser=L}),define(Q[106],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=m.globals.performance&&typeof m.globals.performance.now=="function";class L{constructor(M){this._highResolution=A&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new L(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?m.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Q[5],J([0,1,19,42,2,78,106]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(I){I.None=()=>L.Disposable.None;function o(O){return(z,$=null,C)=>{let q=!1,N;return N=O(_=>{if(!q)return N?N.dispose():q=!0,z.call($,_)},null,C),q&&N.dispose(),N}}I.once=o;function l(O,z){return c(($,C=null,q)=>O(N=>$.call(C,z(N)),null,q))}I.map=l;function a(O,z){return c(($,C=null,q)=>O(N=>{z(N),$.call(C,N)},null,q))}I.forEach=a;function u(O,z){return c(($,C=null,q)=>O(N=>z(N)&&$.call(C,N),null,q))}I.filter=u;function t(O){return O}I.signal=t;function i(...O){return(z,$=null,C)=>(0,L.combinedDisposable)(...O.map(q=>q(N=>z.call($,N),null,C)))}I.any=i;function s(O,z,$){let C=$;return l(O,q=>(C=z(C,q),C))}I.reduce=s;function c(O){let z;const $=new E({onFirstListenerAdd(){z=O($.fire,$)},onLastListenerRemove(){z.dispose()}});return $.event}I.snapshot=c;function h(O,z,$=100,C=!1,q){let N,_,R,W=0;const k=new E({leakWarningThreshold:q,onFirstListenerAdd(){N=O(F=>{W++,_=z(_,F),C&&!R&&(k.fire(_),_=void 0),clearTimeout(R),R=setTimeout(()=>{const B=_;_=void 0,R=void 0,(!C||W>1)&&k.fire(B),W=0},$)})},onLastListenerRemove(){N.dispose()}});return k.event}I.debounce=h;function f(O){const z=new Date().getTime();return l(o(O),$=>new Date().getTime()-z)}I.stopwatch=f;function v(O){let z=!0,$;return u(O,C=>{const q=z||C!==$;return z=!1,$=C,q})}I.latch=v;function D(O,z=!1,$=[]){let C=$.slice(),q=O(R=>{C?C.push(R):_.fire(R)});const N=()=>{C&&C.forEach(R=>_.fire(R)),C=null},_=new E({onFirstListenerAdd(){q||(q=O(R=>_.fire(R)))},onFirstListenerDidAdd(){C&&(z?setTimeout(N):N())},onLastListenerRemove(){q&&q.dispose(),q=null}});return _.event}I.buffer=D;class T{constructor(z){this.event=z}map(z){return new T(l(this.event,z))}forEach(z){return new T(a(this.event,z))}filter(z){return new T(u(this.event,z))}reduce(z,$){return new T(s(this.event,z,$))}latch(){return new T(v(this.event))}debounce(z,$=100,C=!1,q){return new T(h(this.event,z,$,C,q))}on(z,$,C){return this.event(z,$,C)}once(z,$,C){return o(this.event)(z,$,C)}}function U(O){return new T(O)}I.chain=U;function H(O,z,$=C=>C){const C=(...R)=>_.fire($(...R)),q=()=>O.on(z,C),N=()=>O.removeListener(z,C),_=new E({onFirstListenerAdd:q,onLastListenerRemove:N});return _.event}I.fromNodeEventEmitter=H;function X(O,z,$=C=>C){const C=(...R)=>_.fire($(...R)),q=()=>O.addEventListener(z,C),N=()=>O.removeEventListener(z,C),_=new E({onFirstListenerAdd:q,onLastListenerRemove:N});return _.event}I.fromDOMEventEmitter=X;function te(O){const z=new E;let $=!1;return O.then(void 0,()=>null).then(()=>{$?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),$=!0,z.event}I.fromPromise=te;function se(O){return new Promise(z=>o(O)(z))}I.toPromise=se})(r=e.Event||(e.Event={}));class w{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${w._idPool++}`}start(o){this._stopWatch=new M.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let p=-1;function n(I){const o=p;return p=I,{dispose(){p=o}}}e.setGlobalLeakWarningThreshold=n;class y{constructor(o,l=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let l=p;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),!(l<=0||o<l)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),u=this._stacks.get(a)||0;if(this._stacks.set(a,u+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,i=0;for(const[s,c]of this._stacks)(!t||i<c)&&(t=s,i=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class E{constructor(o){var l;this._disposed=!1,this._options=o,this._leakageMon=p>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(o,l,a)=>{var u;this._listeners||(this._listeners=new b.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(l?[o,l]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,l);const s=(u=this._leakageMon)===null||u===void 0?void 0:u.check(this._listeners.size);let c;return c={dispose:()=>{s&&s(),c.dispose=E._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof L.DisposableStore?a.add(c):Array.isArray(a)&&a.push(c),c}),this._event}fire(o){var l,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new b.LinkedList);for(let u of this._listeners)this._deliveryQueue.push([u,o]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[u,t]=this._deliveryQueue.shift();try{typeof u=="function"?u.call(void 0,t):u[0].call(u[1],t)}catch(i){(0,m.onUnexpectedError)(i)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var o,l,a;(o=this._listeners)===null||o===void 0||o.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(a=this._leakageMon)===null||a===void 0||a.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class S extends E{constructor(o){super(o);this._isPaused=0,this._eventQueue=new b.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=S;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const l={event:o,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const a=()=>{this.hasListeners&&this.unhook(l);const u=this.events.indexOf(l);this.events.splice(u,1)};return(0,L.toDisposable)((0,A.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(l=>this.emitter.fire(l))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class g{constructor(){this.buffers=[]}wrapEvent(o){return(l,a,u)=>o(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>l.call(a,t)):l.call(a,t)},void 0,u)}bufferEvents(o){const l=[];this.buffers.push(l);const a=o();return this.buffers.pop(),l.forEach(u=>u()),a}}e.EventBufferer=g;class P{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=P}),define(Q[26],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(r,w){const p=setTimeout(r.bind(w),0);return{dispose(){clearTimeout(p)}}});var L;(function(r){function w(p){return p===r.None||p===r.Cancelled||p instanceof b?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}r.isCancellationToken=w,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:m.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(L=e.CancellationToken||(e.CancellationToken={}));class b{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?A:(this._emitter||(this._emitter=new m.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new b),this._token}cancel(){this._token?this._token instanceof b&&this._token.cancel():this._token=L.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof b&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=M}),define(Q[107],J([0,1,5]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class A{constructor(){this._icons=new Map,this._onDidRegister=new m.Emitter}add(y){const E=this._icons.get(y.id);E?y.description?E.description=y.description:console.error(`Duplicate registration of codicon ${y.id}`):(this._icons.set(y.id,y),this._onDidRegister.fire(y))}get(y){return this._icons.get(y)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new A;e.iconRegistry=L;function b(n,y){return new r(n,y)}e.registerCodicon=b;function M(n){return n?n.replace(/\$\((.*?)\)/g,(y,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=M;class r{constructor(y,E,S){this.id=y,this.definition=E,this.description=S,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r;function w(n,y){const E=["codicon","codicon-"+n];return y&&E.push("codicon-modifier-"+y),E}e.getClassNamesArray=w;var p;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const y=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function E(g){if(g instanceof r)return["codicon","codicon-"+g.id];const P=y.exec(g.id);if(!P)return E(r.error);let[,I,o]=P;const l=["codicon","codicon-"+I];return o&&l.push("codicon-modifier-"+o.substr(1)),l}n.asClassNameArray=E;function S(g){return E(g).join(" ")}n.asClassName=S;function d(g){return"."+E(g).join(".")}n.asCSSSelector=d})(p=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(r=e.Codicon||(e.Codicon={}))}),define(Q[63],J([0,1,19,2]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(l){const a=l;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=L;function b(l){const a=l;return a?L(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=b;function M(l,a){return new r(l,a)}e.newWriteableStream=M;class r{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var u;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((u=this.options)===null||u===void 0?void 0:u.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,m.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(!this.state.destroyed){let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(u);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(l,a){const u=[];let t;for(;(t=l.read())!==null;)u.push(t);return a(u)}e.consumeReadable=w;function p(l,a,u){const t=[];let i;for(;(i=l.read())!==null&&t.length<u;)t.push(i);return i===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return l.read()}}}e.peekReadable=p;function n(l,a){return new Promise((u,t)=>{const i=[];y(l,{onData:s=>{a&&i.push(s)},onError:s=>{a?t(s):u(void 0)},onEnd:()=>{u(a?a(i):void 0)}})})}e.consumeStream=n;function y(l,a){l.on("error",u=>a.onError(u)),l.on("end",()=>a.onEnd()),l.on("data",u=>a.onData(u))}e.listenStream=y;function E(l,a){return new Promise((u,t)=>{const i=new A.DisposableStore,s=[],c=v=>{if(s.push(v),s.length>a)return i.dispose(),l.pause(),u({stream:l,buffer:s,ended:!1})},h=v=>t(v),f=()=>u({stream:l,buffer:s,ended:!0});i.add((0,A.toDisposable)(()=>l.removeListener("error",h))),l.on("error",h),i.add((0,A.toDisposable)(()=>l.removeListener("end",f))),l.on("end",f),i.add((0,A.toDisposable)(()=>l.removeListener("data",c))),l.on("data",c)})}e.peekStream=E;function S(l,a){const u=M(a);return u.end(l),u}e.toStream=S;function d(){const l=M(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=d;function g(l){let a=!1;return{read:()=>a?null:(a=!0,l)}}e.toReadable=g;function P(l,a,u){const t=M(u);return y(l,{onData:i=>t.write(a.data(i)),onError:i=>t.error(a.error?a.error(i):i),onEnd:()=>t.end()}),t}e.transform=P;function I(l,a,u){let t=!1;return{read:()=>{const i=a.read();return t?i:(t=!0,i!==null?u([l,i]):l)}}}e.prefixedReadable=I;function o(l,a,u){let t=!1;const i=M(u);return y(a,{onData:s=>t?i.write(s):(t=!0,i.write(u([l,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(l)),i.end()}}),i}e.prefixedStream=o}),define(Q[22],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function m(K){return!K||typeof K!="string"?!0:K.trim().length===0}e.isFalsyOrWhitespace=m;const A=/{(\d+)}/g;function L(K,...ie){return ie.length===0?K:K.replace(A,function(ae,le){const he=parseInt(le,10);return isNaN(he)||he<0||he>=ie.length?ae:ie[he]})}e.format=L;function b(K){return K.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=b;function M(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=M;function r(K,ie){let ae=0;const le=ie.charCodeAt(0);for(let he=K.length-1;he>=0;he--)K.charCodeAt(he)===le&&ae++;return ae}e.count=r;function w(K,ie,ae="\u2026"){return K.length<=ie?K:`${K.substr(0,ie)}${ae}`}e.truncate=w;function p(K,ie=" "){const ae=n(K,ie);return y(ae,ie)}e.trim=p;function n(K,ie){if(!K||!ie)return K;const ae=ie.length;if(ae===0||K.length===0)return K;let le=0;for(;K.indexOf(ie,le)===le;)le=le+ae;return K.substring(le)}e.ltrim=n;function y(K,ie){if(!K||!ie)return K;const ae=ie.length,le=K.length;if(ae===0||le===0)return K;let he=le,ye=-1;for(;ye=K.lastIndexOf(ie,he-1),!(ye===-1||ye+ae!==he);){if(ye===0)return"";he=ye}return K.substring(0,he)}e.rtrim=y;function E(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function S(K){return K.replace(/\*/g,"")}e.stripWildcards=S;function d(K,ie,ae={}){if(!K)throw new Error("Cannot create regex from empty string");ie||(K=M(K)),ae.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let le="";return ae.global&&(le+="g"),ae.matchCase||(le+="i"),ae.multiline&&(le+="m"),ae.unicode&&(le+="u"),new RegExp(K,le)}e.createRegExp=d;function g(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}e.regExpLeadsToEndlessLoop=g;function P(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=P;function I(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}e.regExpFlags=I;function o(K){return K.split(/\r\n|\r|\n/)}e.splitLines=o;function l(K){for(let ie=0,ae=K.length;ie<ae;ie++){const le=K.charCodeAt(ie);if(le!==32&&le!==9)return ie}return-1}e.firstNonWhitespaceIndex=l;function a(K,ie=0,ae=K.length){for(let le=ie;le<ae;le++){const he=K.charCodeAt(le);if(he!==32&&he!==9)return K.substring(ie,le)}return K.substring(ie,ae)}e.getLeadingWhitespace=a;function u(K,ie=K.length-1){for(let ae=ie;ae>=0;ae--){const le=K.charCodeAt(ae);if(le!==32&&le!==9)return ae}return-1}e.lastNonWhitespaceIndex=u;function t(K,ie){return K<ie?-1:K>ie?1:0}e.compare=t;function i(K,ie,ae=0,le=K.length,he=0,ye=ie.length){for(;ae<le&&he<ye;ae++,he++){let We=K.charCodeAt(ae),Ce=ie.charCodeAt(he);if(We<Ce)return-1;if(We>Ce)return 1}const Me=le-ae,Fe=ye-he;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstring=i;function s(K,ie){return c(K,ie,0,K.length,0,ie.length)}e.compareIgnoreCase=s;function c(K,ie,ae=0,le=K.length,he=0,ye=ie.length){for(;ae<le&&he<ye;ae++,he++){let We=K.charCodeAt(ae),Ce=ie.charCodeAt(he);if(We!==Ce){const $e=We-Ce;if(!($e===32&&f(Ce))&&!($e===-32&&f(We)))return h(We)&&h(Ce)?$e:i(K.toLowerCase(),ie.toLowerCase(),ae,le,he,ye)}}const Me=le-ae,Fe=ye-he;return Me<Fe?-1:Me>Fe?1:0}e.compareSubstringIgnoreCase=c;function h(K){return K>=97&&K<=122}e.isLowerAsciiLetter=h;function f(K){return K>=65&&K<=90}e.isUpperAsciiLetter=f;function v(K){return h(K)||f(K)}function D(K,ie){return K.length===ie.length&&T(K,ie)}e.equalsIgnoreCase=D;function T(K,ie,ae=K.length){for(let le=0;le<ae;le++){const he=K.charCodeAt(le),ye=ie.charCodeAt(le);if(he!==ye){if(v(he)&&v(ye)){const Me=Math.abs(he-ye);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(ye).toLowerCase())return!1}}return!0}function U(K,ie){const ae=ie.length;return ie.length>K.length?!1:T(K,ie,ae)}e.startsWithIgnoreCase=U;function H(K,ie){let ae,le=Math.min(K.length,ie.length);for(ae=0;ae<le;ae++)if(K.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return le}e.commonPrefixLength=H;function X(K,ie){let ae,le=Math.min(K.length,ie.length);const he=K.length-1,ye=ie.length-1;for(ae=0;ae<le;ae++)if(K.charCodeAt(he-ae)!==ie.charCodeAt(ye-ae))return ae;return le}e.commonSuffixLength=X;function te(K){return 55296<=K&&K<=56319}e.isHighSurrogate=te;function se(K){return 56320<=K&&K<=57343}e.isLowSurrogate=se;function O(K,ie){return(K-55296<<10)+(ie-56320)+65536}e.computeCodePoint=O;function z(K,ie,ae){const le=K.charCodeAt(ae);if(te(le)&&ae+1<ie){const he=K.charCodeAt(ae+1);if(se(he))return O(le,he)}return le}e.getNextCodePoint=z;function $(K,ie){const ae=K.charCodeAt(ie-1);if(se(ae)&&ie>1){const le=K.charCodeAt(ie-2);if(te(le))return O(le,ae)}return ae}function C(K,ie){const ae=Be.getInstance(),le=ie,he=K.length,ye=z(K,he,ie);ie+=ye>=65536?2:1;let Me=ae.getGraphemeBreakType(ye);for(;ie<he;){const Fe=z(K,he,ie),We=ae.getGraphemeBreakType(Fe);if(qe(Me,We))break;ie+=Fe>=65536?2:1,Me=We}return ie-le}e.nextCharLength=C;function q(K,ie){const ae=Be.getInstance(),le=ie,he=$(K,ie);ie-=he>=65536?2:1;let ye=ae.getGraphemeBreakType(he);for(;ie>0;){const Me=$(K,ie),Fe=ae.getGraphemeBreakType(Me);if(qe(Fe,ye))break;ie-=Me>=65536?2:1,ye=Fe}return le-ie}e.prevCharLength=q;function N(K,ie){const ae=Be.getInstance(),le=K.length,he=ie,ye=z(K,le,ie),Me=ae.getGraphemeBreakType(ye);ie+=ye>=65536?2:1;let Fe=Me;for(;ie<le;){const Ce=z(K,le,ie),$e=ae.getGraphemeBreakType(Ce);if(qe(Fe,$e))break;ie+=Ce>=65536?2:1,Fe=$e}const We=ie;for(ie=he,Fe=Me;ie>0;){const Ce=$(K,ie),$e=ae.getGraphemeBreakType(Ce);if(qe($e,Fe))break;ie-=Ce>=65536?2:1,Fe=$e}return[ie,We]}function _(K,ie){return ie>0&&se(K.charCodeAt(ie))?N(K,ie-1):N(K,ie)}e.getCharContainingOffset=_;function R(K){const ie=K.length;let ae=0,le=0;for(;le<ie;){const Me=z(K,ie,le);le+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);le=0;let ye=0;for(;le<ie;){const Me=z(K,ie,le);le+=Me>=65536?2:1,Me<128?he[ye++]=Me:Me<2048?(he[ye++]=192|(Me&1984)>>>6,he[ye++]=128|(Me&63)>>>0):Me<65536?(he[ye++]=224|(Me&61440)>>>12,he[ye++]=128|(Me&4032)>>>6,he[ye++]=128|(Me&63)>>>0):(he[ye++]=240|(Me&1835008)>>>18,he[ye++]=128|(Me&258048)>>>12,he[ye++]=128|(Me&4032)>>>6,he[ye++]=128|(Me&63)>>>0)}return he}e.encodeUTF8=R;function W(K){const ie=K.byteLength,ae=[];let le=0;for(;le<ie;){const he=K[le];let ye;if(he>=240&&le+3<ie?ye=(K[le++]&7)<<18>>>0|(K[le++]&63)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:he>=224&&le+2<ie?ye=(K[le++]&15)<<12>>>0|(K[le++]&63)<<6>>>0|(K[le++]&63)<<0>>>0:he>=192&&le+1<ie?ye=(K[le++]&31)<<6>>>0|(K[le++]&63)<<0>>>0:ye=K[le++],ye>=0&&ye<=55295||ye>=57344&&ye<=65535)ae.push(String.fromCharCode(ye));else if(ye>=65536&&ye<=1114111){const Me=ye-65536,Fe=55296+((Me&1047552)>>>10),We=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Fe)),ae.push(String.fromCharCode(We))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=W;const k=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(K){return k.test(K)}e.containsRTL=F;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function V(K){return B.test(K)}e.containsEmoji=V;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(K){return G.test(K)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(K){return e.UNUSUAL_LINE_TERMINATORS.test(K)}e.containsUnusualLineTerminators=Z;function re(K){for(let ie=0,ae=K.length;ie<ae;ie++)if(oe(K.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=re;function oe(K){return K=+K,K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}e.isFullWidthCharacter=oe;function x(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129003||K>=129280&&K<=129535||K>=129648&&K<=129750}e.isEmojiImprecise=x;function ne(K,ie){if(K.length<ie)return K;const ae=/\b/g;let le=0;for(;ae.test(K)&&!(K.length-ae.lastIndex<ie);)le=ae.lastIndex,ae.lastIndex+=1;return K.substring(le).replace(/^\s/,"")}e.lcut=ne;const ue=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Pe(K){return K&&(K=K.replace(ue,""),K=K.replace(be,""),K=K.replace(me,"")),K}e.removeAnsiEscapeCodes=Pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function we(K){return Ae(K)?K.substr(1):K}e.stripUTF8BOM=we;function ve(K,ie){if(!K||!ie||K.length<ie.length)return!1;const ae=ie.length,le=K.toLowerCase();let he=0,ye=-1;for(;he<ae;){const Me=le.indexOf(ie[he],ye+1);if(Me<0)return!1;ye=Me,he++}return!0}e.fuzzyContains=ve;function Ee(K,ie=!1){return K?(ie&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}e.containsUppercaseCharacter=Ee;function Re(K){return K.charAt(0).toUpperCase()+K.slice(1)}e.uppercaseFirstLetter=Re;function Te(K,ie=1){if(ie===0)return"";let ae=-1;do ae=K.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?K:(K[ae-1]==="\r"&&ae--,K.substr(0,ae))}e.getNLines=Te;function Ke(K){const ie=90-65+1;return K=K%(2*ie),K<ie?String.fromCharCode(97+K):String.fromCharCode(65+K-ie)}e.singleLetterHash=Ke;function Ze(K){return Be.getInstance().getGraphemeBreakType(K)}e.getGraphemeBreakType=Ze;function qe(K,ie){return K===0?ie!==5&&ie!==7:K===2&&ie===3?!1:K===4||K===2||K===3||ie===4||ie===2||ie===3?!0:!(K===8&&(ie===8||ie===9||ie===11||ie===12)||(K===11||K===9)&&(ie===9||ie===10)||(K===12||K===10)&&ie===10||ie===5||ie===13||ie===7||K===1||K===13&&ie===14||K===6&&ie===6)}e.breakBetweenGraphemeBreakType=qe;var ut;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(ut=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=st()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,le=ae.length/3;let he=1;for(;he<=le;)if(ie<ae[3*he])he=2*he;else if(ie>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}Be._INSTANCE=null;function st(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(Q[23],J([0,1,22,63]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",b=typeof TextEncoder!="undefined",M=typeof TextDecoder!="undefined";let r,w;class p{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return L?new p(Buffer.allocUnsafe(v)):new p(new Uint8Array(v))}static wrap(v){return L&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new p(v)}static fromString(v,D){return!((D==null?void 0:D.dontUseNodeBuffer)||!1)&&L?new p(Buffer.from(v)):b?(r||(r=new TextEncoder),new p(r.encode(v))):new p(m.encodeUTF8(v))}static concat(v,D){if(typeof D=="undefined"){D=0;for(let H=0,X=v.length;H<X;H++)D+=v[H].byteLength}const T=p.alloc(D);let U=0;for(let H=0,X=v.length;H<X;H++){const te=v[H];T.set(te,U),U+=te.byteLength}return T}toString(){return L?this.buffer.toString():M?(w||(w=new TextDecoder),w.decode(this.buffer)):m.decodeUTF8(this.buffer)}slice(v,D){return new p(this.buffer.subarray(v,D))}set(v,D){v instanceof p?this.buffer.set(v.buffer,D):this.buffer.set(v,D)}readUInt32BE(v){return E(this.buffer,v)}writeUInt32BE(v,D){S(this.buffer,v,D)}readUInt32LE(v){return d(this.buffer,v)}writeUInt32LE(v,D){g(this.buffer,v,D)}readUInt8(v){return P(this.buffer,v)}writeUInt8(v,D){I(this.buffer,v,D)}}e.VSBuffer=p;function n(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0}e.readUInt16LE=n;function y(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255}e.writeUInt16LE=y;function E(f,v){return f[v]*2**24+f[v+1]*2**16+f[v+2]*2**8+f[v+3]}e.readUInt32BE=E;function S(f,v,D){f[D+3]=v,v=v>>>8,f[D+2]=v,v=v>>>8,f[D+1]=v,v=v>>>8,f[D]=v}e.writeUInt32BE=S;function d(f,v){return f[v+0]<<0>>>0|f[v+1]<<8>>>0|f[v+2]<<16>>>0|f[v+3]<<24>>>0}e.readUInt32LE=d;function g(f,v,D){f[D+0]=v&255,v=v>>>8,f[D+1]=v&255,v=v>>>8,f[D+2]=v&255,v=v>>>8,f[D+3]=v&255}e.writeUInt32LE=g;function P(f,v){return f[v]}e.readUInt8=P;function I(f,v,D){f[D]=v}e.writeUInt8=I;function o(f){return A.consumeReadable(f,v=>p.concat(v))}e.readableToBuffer=o;function l(f){return A.toReadable(f)}e.bufferToReadable=l;function a(f){return A.consumeStream(f,v=>p.concat(v))}e.streamToBuffer=a;async function u(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await a(f.stream)])}e.bufferedStreamToBuffer=u;function t(f){return A.toStream(f,v=>p.concat(v))}e.bufferToStream=t;function i(f){return A.transform(f,{data:v=>typeof v=="string"?p.fromString(v):p.wrap(v)},v=>p.concat(v))}e.streamToBufferReadableStream=i;function s(f){return A.newWriteableStream(v=>p.concat(v),f)}e.newWriteableBufferStream=s;function c(f,v){return A.prefixedReadable(f,v,D=>p.concat(D))}e.prefixedBufferReadable=c;function h(f,v){return A.prefixedStream(f,v,D=>p.concat(D))}e.prefixedBufferStream=h}),define(Q[80],J([0,1,22]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function A(I){return L(I,0)}e.hash=A;function L(I,o){switch(typeof I){case"object":return I===null?b(349,o):Array.isArray(I)?w(I,o):p(I,o);case"string":return r(I,o);case"boolean":return M(I,o);case"number":return b(I,o);case"undefined":return b(937,o);default:return b(617,o)}}e.doHash=L;function b(I,o){return(o<<5)-o+I|0}function M(I,o){return b(I?433:863,o)}function r(I,o){o=b(149417,o);for(let l=0,a=I.length;l<a;l++)o=b(I.charCodeAt(l),o);return o}e.stringHash=r;function w(I,o){return o=b(104579,o),I.reduce((l,a)=>L(a,l),o)}function p(I,o){return o=b(181387,o),Object.keys(I).sort().reduce((l,a)=>(l=r(a,l),L(I[a],l)),o)}class n{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=L(o,this._value),this._value}}e.Hasher=n;var y;(function(I){I[I.BLOCK_SIZE=64]="BLOCK_SIZE",I[I.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function E(I,o,l=32){const a=l-o,u=~((1<<a)-1);return(I<<o|(u&I)>>>a)>>>0}function S(I,o=0,l=I.byteLength,a=0){for(let u=0;u<l;u++)I[o+u]=a}function d(I,o,l="0"){for(;I.length<o;)I=l+I;return I}function g(I,o=32){return I instanceof ArrayBuffer?Array.from(new Uint8Array(I)).map(l=>l.toString(16).padStart(2,"0")).join(""):d((I>>>0).toString(16),o/4)}e.toHexString=g;class P{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const l=o.length;if(l!==0){const a=this._buff;let u=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=o.charCodeAt(0),s=0);;){let c=i;if(m.isHighSurrogate(i))if(s+1<l){const h=o.charCodeAt(s+1);m.isLowSurrogate(h)?(s++,c=m.computeCodePoint(i,h)):c=65533}else{t=i;break}else m.isLowSurrogate(i)&&(c=65533);if(u=this._push(a,u,c),s++,s<l)i=o.charCodeAt(s);else break}this._buffLen=u,this._leftoverHighSurrogate=t}}_push(o,l,a){return a<128?o[l++]=a:a<2048?(o[l++]=192|(a&1984)>>>6,o[l++]=128|(a&63)>>>0):a<65536?(o[l++]=224|(a&61440)>>>12,o[l++]=128|(a&4032)>>>6,o[l++]=128|(a&63)>>>0):(o[l++]=240|(a&1835008)>>>18,o[l++]=128|(a&258048)>>>12,o[l++]=128|(a&4032)>>>6,o[l++]=128|(a&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=P._bigBlock32,l=this._buffDV;for(let v=0;v<64;v+=4)o.setUint32(v,l.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)o.setUint32(v,E(o.getUint32(v-12,!1)^o.getUint32(v-32,!1)^o.getUint32(v-56,!1)^o.getUint32(v-64,!1),1),!1);let a=this._h0,u=this._h1,t=this._h2,i=this._h3,s=this._h4,c,h,f;for(let v=0;v<80;v++)v<20?(c=u&t|~u&i,h=1518500249):v<40?(c=u^t^i,h=1859775393):v<60?(c=u&t|u&i|t&i,h=2400959708):(c=u^t^i,h=3395469782),f=E(a,5)+c+s+h+o.getUint32(v*4,!1)&4294967295,s=i,i=t,t=E(u,30),u=a,a=f;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=P,P._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function m(v){return Array.isArray(v)}e.isArray=m;function A(v){return typeof v=="string"}e.isString=A;function L(v){return Array.isArray(v)&&v.every(D=>A(D))}e.isStringArray=L;function b(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=b;function M(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=M;function r(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=r;function w(v){return v===!0||v===!1}e.isBoolean=w;function p(v){return typeof v=="undefined"}e.isUndefined=p;function n(v){return!y(v)}e.isDefined=n;function y(v){return p(v)||v===null}e.isUndefinedOrNull=y;function E(v,D){if(!v)throw new Error(D?`Unexpected type, expected '${D}'`:"Unexpected type")}e.assertType=E;function S(v){if(y(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=S;function d(...v){const D=[];for(let T=0;T<v.length;T++){const U=v[T];if(y(U))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);D.push(U)}return D}e.assertAllDefined=d;const g=Object.prototype.hasOwnProperty;function P(v){if(!b(v))return!1;for(let D in v)if(g.call(v,D))return!1;return!0}e.isEmptyObject=P;function I(v){return typeof v=="function"}e.isFunction=I;function o(...v){return v.length>0&&v.every(I)}e.areFunctions=o;function l(v,D){const T=Math.min(v.length,D.length);for(let U=0;U<T;U++)a(v[U],D[U])}e.validateConstraints=l;function a(v,D){if(A(D)){if(typeof v!==D)throw new Error(`argument does not match constraint: typeof ${D}`)}else if(I(D)){try{if(v instanceof D)return}catch(T){}if(!y(v)&&v.constructor===D||D.length===1&&D.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(v){let D=[],T=Object.getPrototypeOf(v);for(;Object.prototype!==T;)D=D.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return D}e.getAllPropertyNames=u;function t(v){const D=[];for(const T of u(v))typeof v[T]=="function"&&D.push(T);return D}e.getAllMethodNames=t;function i(v,D){const T=H=>function(){const X=Array.prototype.slice.call(arguments,0);return D(H,X)};let U={};for(const H of v)U[H]=T(H);return U}e.createProxyObject=i;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function c(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=c;function h(v){return class{constructor(){return new Proxy({},{get(D,T){if(D[T])return D[T];throw new Error(`Not Implemented: ${v}->${String(T)}`)}})}}}e.NotImplementedProxy=h;function f(v){throw new Error("Unreachable")}e.assertNever=f}),define(Q[30],J([0,1,3,22,7,13]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function M(i){return i===47||i===92}e.isPathSeparator=M;function r(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=r;function w(i,s=L.posix.sep){if(!i)return"";const c=i.length,h=i.charCodeAt(0);if(M(h)){if(M(i.charCodeAt(1))&&!M(i.charCodeAt(2))){let v=3;const D=v;for(;v<c&&!M(i.charCodeAt(v));v++);if(D!==v&&!M(i.charCodeAt(v+1))){for(v+=1;v<c;v++)if(M(i.charCodeAt(v)))return i.slice(0,v+1).replace(/[\\/]/g,s)}}return s}else if(P(h)&&i.charCodeAt(1)===58)return M(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<c;f++)if(M(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=w;function p(i){if(!m.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let c=2;const h=c;for(;c<i.length&&(s=i.charCodeAt(c),s!==92);c++);return!(h===c||(s=i.charCodeAt(c+1),isNaN(s)||s===92))}e.isUNC=p;const n=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(i,s=m.isWindows){const c=s?n:y;return!(!i||i.length===0||/^\s+$/.test(i)||(c.lastIndex=0,c.test(i))||s&&E.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=S;function d(i,s,c){const h=i===s;return!c||h?h:!i||!s?!1:(0,A.equalsIgnoreCase)(i,s)}e.isEqual=d;function g(i,s,c,h=L.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(c){if(!(0,A.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let v=s.length;return s.charAt(s.length-1)===h&&v--,i.charAt(v)===h}return s.charAt(s.length-1)!==h&&(s+=h),i.indexOf(s)===0}e.isEqualOrParent=g;function P(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=P;function I(i,s){return m.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(s,i)),i=(0,L.normalize)(i),m.isWindows?(i=(0,A.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,A.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=I;function o(i){const s=(0,L.normalize)(i);return m.isWindows?i.length>3?!1:l(s)&&(i.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=o;function l(i){return m.isWindows?P(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function a(i){return l(i)?i[0]:void 0}e.getDriveLetter=a;function u(i,s,c){return s.length>i.length?-1:i===s?0:(c&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=u;function t(i){const s=i.split(":");let c,h,f;if(s.forEach(v=>{const D=Number(v);(0,b.isNumber)(D)?h===void 0?h=D:f===void 0&&(f=D):c=c?[c,v].join(":"):v}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[44],J([0,1,13]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const P=Array.isArray(g)?[]:{};return Object.keys(g).forEach(I=>{g[I]&&typeof g[I]=="object"?P[I]=A(g[I]):P[I]=g[I]}),P}e.deepClone=A;function L(g){if(!g||typeof g!="object")return g;const P=[g];for(;P.length>0;){const I=P.shift();Object.freeze(I);for(const o in I)if(b.call(I,o)){const l=I[o];typeof l=="object"&&!Object.isFrozen(l)&&P.push(l)}}return g}e.deepFreeze=L;const b=Object.prototype.hasOwnProperty;function M(g,P){return r(g,P,new Set)}e.cloneAndChange=M;function r(g,P,I){if((0,m.isUndefinedOrNull)(g))return g;const o=P(g);if(typeof o!="undefined")return o;if((0,m.isArray)(g)){const l=[];for(const a of g)l.push(r(a,P,I));return l}if((0,m.isObject)(g)){if(I.has(g))throw new Error("Cannot clone recursive data-structure");I.add(g);const l={};for(let a in g)b.call(g,a)&&(l[a]=r(g[a],P,I));return I.delete(g),l}return g}function w(g,P,I=!0){return(0,m.isObject)(g)?((0,m.isObject)(P)&&Object.keys(P).forEach(o=>{o in g?I&&((0,m.isObject)(g[o])&&(0,m.isObject)(P[o])?w(g[o],P[o],I):g[o]=P[o]):g[o]=P[o]}),g):P}e.mixin=w;function p(g,P){if(g===P)return!0;if(g==null||P===null||P===void 0||typeof g!=typeof P||typeof g!="object"||Array.isArray(g)!==Array.isArray(P))return!1;let I,o;if(Array.isArray(g)){if(g.length!==P.length)return!1;for(I=0;I<g.length;I++)if(!p(g[I],P[I]))return!1}else{const l=[];for(o in g)l.push(o);l.sort();const a=[];for(o in P)a.push(o);if(a.sort(),!p(l,a))return!1;for(I=0;I<l.length;I++)if(!p(g[l[I]],P[l[I]]))return!1}return!0}e.equals=p;function n(g){const P=new Set;return JSON.stringify(g,(I,o)=>{if((0,m.isObject)(o)||Array.isArray(o)){if(P.has(o))return"[Circular]";P.add(o)}return o})}e.safeStringify=n;function y(g,P,I){const o=P(g);return typeof o=="undefined"?I:o}e.getOrDefault=y;function E(g,P){const I=Object.create(null);return!g||!P||Object.keys(P).forEach(l=>{const a=g[l],u=P[l];p(a,u)||(I[l]=u)}),I}e.distinct=E;function S(g,P){const I=P.toLowerCase(),o=Object.keys(g).find(l=>l.toLowerCase()===I);return o?g[o]:g[P]}e.getCaseInsensitive=S;function d(g,P){const I=Object.create(null);for(const o of Object.keys(g))P(o,g[o])&&(I[o]=g[o]);return I}e.filter=d}),define(Q[8],J([0,1,3,7]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,b=/^\//,M=/^\/\//;function r(s,c){if(!s.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!b.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,c){return!s&&!c?"file":s}function p(s,c){switch(s){case"https":case"http":case"file":c?c[0]!==y&&(c=y+c):c=y;break}return c}const n="",y="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(c,h,f,v,D,T=!1){typeof c=="object"?(this.scheme=c.scheme||n,this.authority=c.authority||n,this.path=c.path||n,this.query=c.query||n,this.fragment=c.fragment||n):(this.scheme=w(c,T),this.authority=h||n,this.path=p(this.scheme,f||n),this.query=v||n,this.fragment=D||n,r(this,T))}static isUri(c){return c instanceof S?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}get fsPath(){return l(this,!1)}with(c){if(!c)return this;let{scheme:h,authority:f,path:v,query:D,fragment:T}=c;return h===void 0?h=this.scheme:h===null&&(h=n),f===void 0?f=this.authority:f===null&&(f=n),v===void 0?v=this.path:v===null&&(v=n),D===void 0?D=this.query:D===null&&(D=n),T===void 0?T=this.fragment:T===null&&(T=n),h===this.scheme&&f===this.authority&&v===this.path&&D===this.query&&T===this.fragment?this:new g(h,f,v,D,T)}static parse(c,h=!1){const f=E.exec(c);return f?new g(f[2]||n,i(f[4]||n),i(f[5]||n),i(f[7]||n),i(f[9]||n),h):new g(n,n,n,n,n)}static file(c){let h=n;if(m.isWindows&&(c=c.replace(/\\/g,y)),c[0]===y&&c[1]===y){const f=c.indexOf(y,2);f===-1?(h=c.substring(2),c=y):(h=c.substring(2,f),c=c.substring(f)||y)}return new g("file",h,c,n,n)}static from(c){return new g(c.scheme,c.authority,c.path,c.query,c.fragment)}static joinPath(c,...h){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return m.isWindows&&c.scheme==="file"?f=S.file(A.win32.join(l(c,!0),...h)).path:f=A.posix.join(c.path,...h),c.with({path:f})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof S)return c;{const h=new g(c);return h._formatted=c.external,h._fsPath=c._sep===d?c.fsPath:null,h}}else return c}}e.URI=S;const d=m.isWindows?1:void 0;class g extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=d),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const P={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function I(s,c){let h,f=-1;for(let v=0;v<s.length;v++){const D=s.charCodeAt(v);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||c&&D===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,v)),f=-1),h!==void 0&&(h+=s.charAt(v));else{h===void 0&&(h=s.substr(0,v));const T=P[D];T!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,v)),f=-1),h+=T):f===-1&&(f=v)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function o(s){let c;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(c===void 0&&(c=s.substr(0,h)),c+=P[f]):c!==void 0&&(c+=s[h])}return c!==void 0?c:s}function l(s,c){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?c?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,m.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=l;function a(s,c){const h=c?o:I;let f="",{scheme:v,authority:D,path:T,query:U,fragment:H}=s;if(v&&(f+=v,f+=":"),(D||v==="file")&&(f+=y,f+=y),D){let X=D.indexOf("@");if(X!==-1){const te=D.substr(0,X);D=D.substr(X+1),X=te.indexOf(":"),X===-1?f+=h(te,!1):(f+=h(te.substr(0,X),!1),f+=":",f+=h(te.substr(X+1),!1)),f+="@"}D=D.toLowerCase(),X=D.indexOf(":"),X===-1?f+=h(D,!1):(f+=h(D.substr(0,X),!1),f+=D.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}f+=h(T,!0)}return U&&(f+="?",f+=h(U,!1)),H&&(f+="#",f+=c?H:I(H,!1)),f}function u(s){try{return decodeURIComponent(s)}catch(c){return s.length>3?s.substr(0,3)+u(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,c=>u(c)):s}}),define(Q[108],J([0,1,8]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(p){const n=p;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=A;function L(p){const n=[];let y;try{const E=JSON.parse(p.arguments),S=E[E.length-1];S&&S.__$stack&&(E.pop(),y=S.__$stack),n.push(...E)}catch(E){n.push("Unable to log remote console arguments",p.arguments)}return{args:n,stack:y}}e.parse=L;function b(p){if(typeof p!="string")return b(L(p).stack);const n=p;if(n){const y=M(n),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(E&&E.length===4)return{uri:m.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=b;function M(p){if(!p)return p;const n=p.indexOf(`
`);return n===-1?p:p.substring(0,n)}function r(p,n){const{args:y,stack:E}=L(p),S=typeof y[0]=="string"&&y.length===1;let d=M(E);d&&(d=`(${d.trim()})`);let g=[];if(typeof y[0]=="string"?d&&S?g=[`%c[${n}] %c${y[0]} %c${d}`,w("blue"),w(""),w("grey")]:g=[`%c[${n}] %c${y[0]}`,w("blue"),w(""),...y.slice(1)]:g=[`%c[${n}]%`,w("blue"),...y],d&&!S&&g.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,g)}e.log=r;function w(p){return`color: ${p}`}});var Pt=this&&this.__classPrivateFieldSet||function(j,e,m,A,L){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?L.call(j,m):L?L.value=m:e.set(j,m),m},Ve=this&&this.__classPrivateFieldGet||function(j,e,m,A){if(m==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!A:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return m==="m"?A:m==="a"?A.call(j):A?A.value:e.get(j)};define(Q[36],J([0,1,8,22]),function(j,e,m,A){"use strict";var L,b,M;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function r(t,i,s){let c=t.get(i);return c===void 0&&(c=s,t.set(i,c)),c}e.getOrSet=r;function w(t){const i=[];return t.forEach((s,c)=>{i.push(`${c} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=w;function p(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=p;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return s-c}value(){return this._value[this._pos]}}e.StringIterator=n;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class E{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,A.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,A.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var S;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(S||(S={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,A.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,A.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,A.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,A.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class g{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class P{constructor(i){this._iter=i}static forUris(i=()=>!1){return new P(new d(i))}static forPaths(){return new P(new E)}static forStrings(){return new P(new n)}static forConfigKeys(){return new P(new y)}clear(){this._root=void 0}set(i,s){const c=this._iter.reset(i);let h;for(this._root||(this._root=new g,this._root.segment=c.value()),h=this._root;;){const v=c.cmp(h.segment);if(v>0)h.left||(h.left=new g,h.left.segment=c.value()),h=h.left;else if(v<0)h.right||(h.right=new g,h.right.segment=c.value()),h=h.right;else if(c.hasNext())c.next(),h.mid||(h.mid=new g,h.mid.segment=c.value()),h=h.mid;else break}const f=h.value;return h.value=s,h.key=i,f}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let c=this._root;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else break}return c}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const c=this._iter.reset(i),h=[];let f=this._root;for(;f;){const v=c.cmp(f.segment);if(v>0)h.push([1,f]),f=f.left;else if(v<0)h.push([-1,f]),f=f.right;else if(c.hasNext())c.next(),h.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;h.length>0&&f.isEmpty();){let[D,T]=h.pop();switch(D){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(i){const s=this._iter.reset(i);let c=this._root,h;for(;c;){const f=s.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(s.hasNext())s.next(),h=c.value||h,c=c.mid;else break}return c&&c.value||h}findSuperstr(i){const s=this._iter.reset(i);let c=this._root;for(;c;){const h=s.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[s,c]of this)i(c,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=P;class I{constructor(i,s){this[L]="ResourceMap",i instanceof I?(this.map=new Map(i.map),this.toKey=s!=null?s:I.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:I.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[c,h]of this.map)i(h,m.URI.parse(c),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield m.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[m.URI.parse(i[0]),i[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[m.URI.parse(i[0]),i[1]]}}e.ResourceMap=I,I.defaultToKey=t=>t.toString();var o;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class l{constructor(){this[b]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const c=this._map.get(i);if(!!c)return s!==0&&this.touch(c,s),c.value}set(i,s,c=0){let h=this._map.get(i);if(h)h.value=s,c!==0&&this.touch(h,c);else{switch(h={key:i,value:s,next:void 0,previous:void 0},c){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,s){const c=this._state;let h=this._head;for(;h;){if(s?i.bind(s)(h.value,h.key,this):i(h.value,h.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.key,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return h}values(){const i=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:c.value,done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return h}entries(){const i=this,s=this._state;let c=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const f={value:[c.key,c.value],done:!1};return c=c.next,f}else return{value:void 0,done:!0}}};return h}[(b=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let s=this._head,c=this.size;for(;s&&c>i;)this._map.delete(s.key),s=s.next,c--;this._head=s,this._size=c,s&&(s.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,c=i.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const c=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(c.previous=h,h.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const c=i.next,h=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=h,h.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,c)=>{i.push([c,s])}),i}fromJSON(i){this.clear();for(const[s,c]of i)this.set(s,c)}}e.LinkedMap=l;class a extends l{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class u{constructor(i){M.set(this,void 0),Pt(this,M,i,"f")}get size(){return Ve(this,M,"f").size}forEach(i,s){Ve(this,M,"f").forEach(i,s)}get(i){return Ve(this,M,"f").get(i)}has(i){return Ve(this,M,"f").has(i)}entries(){return Ve(this,M,"f").entries()}keys(){return Ve(this,M,"f").keys()}values(){return Ve(this,M,"f").values()}[(M=new WeakMap,Symbol.iterator)](){return Ve(this,M,"f").entries()}}e.ReadonlyMapView=u}),define(Q[109],J([0,1,23,22,8]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function b(p){return JSON.stringify(p,r)}e.stringify=b;function M(p){let n=JSON.parse(p);return n=w(n),n}e.parse=M;function r(p,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,A.regExpFlags)(n)}:n}function w(p,n=0){if(!p||n>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return L.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof m.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let y=0;y<p.length;++y)p[y]=w(p[y],n+1);else for(const y in p)Object.hasOwnProperty.call(p,y)&&(p[y]=w(p[y],n+1))}return p}e.revive=w}),define(Q[10],J([0,1,8,3]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class b{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,p,n){this._hosts[w]=p,this._ports[w]=n}setConnectionToken(w,p){this._connectionTokens[w]=p}rewrite(w){if(this._delegate)return this._delegate(w);const p=w.authority;let n=this._hosts[p];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const y=this._ports[p],E=this._connectionTokens[p];let S=`path=${encodeURIComponent(w.path)}`;return typeof E=="string"&&(S+=`&tkn=${encodeURIComponent(E)}`),m.URI.from({scheme:A.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${y}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new b;class M{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,p,n){const y=this.toUri(w,p);return y.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(y):A.isNative&&(n||A.isPreferringBrowserCodeLoad)&&y.scheme===L.file?y.with({scheme:L.vscodeFileResource,authority:y.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):y}asFileUri(w,p){const n=this.toUri(w,p);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,p){return m.URI.isUri(w)?w:m.URI.parse(p.toUrl(w))}}e.FileAccess=new M}),define(Q[64],J([0,1,36]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const A=new m.LRUCache(1e4);function L(p){return w(p,"NFC",A)}e.normalizeNFC=L;const b=new m.LRUCache(1e4);function M(p){return w(p,"NFD",b)}e.normalizeNFD=M;const r=/[^\u0000-\u0080]/;function w(p,n,y){if(!e.canNormalize||!p)return p;const E=y.get(p);if(E)return E;let S;return r.test(p)?S=p.normalize(n):S=p,y.set(p,S),S}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(n){return M(n).replace(p,"")}}else return function(p){return p}}()}),define(Q[15],J([0,1,30,7,8,22,10,3]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(S){return(0,L.uriToFsPath)(S,!0)}e.originalFSPath=w;class p{constructor(d){this._ignorePathCasing=d}compare(d,g,P=!1){return d===g?0:(0,b.compare)(this.getComparisonKey(d,P),this.getComparisonKey(g,P))}isEqual(d,g,P=!1){return d===g?!0:!d||!g?!1:this.getComparisonKey(d,P)===this.getComparisonKey(g,P)}getComparisonKey(d,g=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,g,P=!1){if(d.scheme===g.scheme){if(d.scheme===M.Schemas.file)return m.isEqualOrParent(w(d),w(g),this._ignorePathCasing(d))&&d.query===g.query&&(P||d.fragment===g.fragment);if((0,e.isEqualAuthority)(d.authority,g.authority))return m.isEqualOrParent(d.path,g.path,this._ignorePathCasing(d),"/")&&d.query===g.query&&(P||d.fragment===g.fragment)}return!1}joinPath(d,...g){return L.URI.joinPath(d,...g)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return A.posix.basename(d.path)}extname(d){return A.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let g;return d.scheme===M.Schemas.file?g=L.URI.file(A.dirname(w(d))).path:(g=A.posix.dirname(d.path),d.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),g="/")),d.with({path:g})}normalizePath(d){if(!d.path.length)return d;let g;return d.scheme===M.Schemas.file?g=L.URI.file(A.normalize(w(d))).path:g=A.posix.normalize(d.path),d.with({path:g})}relativePath(d,g){if(!(d.scheme!==g.scheme||!(0,e.isEqualAuthority)(d.authority,g.authority))){if(d.scheme===M.Schemas.file){const o=A.relative(w(d),w(g));return r.isWindows?m.toSlashes(o):o}let P=d.path||"/",I=g.path||"/";if(this._ignorePathCasing(d)){let o=0;for(const l=Math.min(P.length,I.length);o<l&&!(P.charCodeAt(o)!==I.charCodeAt(o)&&P.charAt(o).toLowerCase()!==I.charAt(o).toLowerCase());o++);P=I.substr(0,o)+P.substr(o)}return A.posix.relative(P,I)}}resolvePath(d,g){if(d.scheme===M.Schemas.file){const P=L.URI.file(A.resolve(w(d),g));return d.with({authority:P.authority,path:P.path})}return g.indexOf("/")===-1&&(g=m.toSlashes(g),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g)),d.with({path:A.posix.resolve(d.path,g)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,g){return d===g||(0,b.equalsIgnoreCase)(d,g)}hasTrailingPathSeparator(d,g=A.sep){if(d.scheme===M.Schemas.file){const P=w(d);return P.length>m.getRoot(P).length&&P[P.length-1]===g}else{const P=d.path;return P.length>1&&P.charCodeAt(P.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,g=A.sep){return(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,g=A.sep){let P=!1;if(d.scheme===M.Schemas.file){const I=w(d);P=I!==void 0&&I.length===m.getRoot(I).length&&I[I.length-1]===g}else{g="/";const I=d.path;P=I.length===1&&I.charCodeAt(I.length-1)===47}return!P&&!(0,e.hasTrailingPathSeparator)(d,g)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(S=>S.scheme===M.Schemas.file?!r.isLinux:!0),e.extUriIgnorePathCase=new p(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(S,d){const g=[];for(let P=0;P<S.length;P++){const I=d(S[P]);S.some((o,l)=>l===P?!1:(0,e.isEqualOrParent)(I,d(o)))||g.push(S[P])}return g}e.distinctParents=n;var y;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function d(g){const P=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(l=>{const[a,u]=l.split(":");a&&u&&P.set(a,u)});const o=g.path.substring(0,g.path.indexOf(";"));return o&&P.set(S.META_DATA_MIME,o),P}S.parseMetaData=d})(y=e.DataUri||(e.DataUri={}));function E(S,d,g){if(d){let P=S.path;return P&&P[0]!==A.posix.sep&&(P=A.posix.sep+P),S.with({scheme:g,authority:d,path:P})}return S.with({scheme:g})}e.toLocalResource=E}),define(Q[9],J([0,1,26,19,5,2,78,15]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(N){return!!N&&typeof N.then=="function"}e.isThenable=w;function p(N){const _=new m.CancellationTokenSource,R=N(_.token),W=new Promise((k,F)=>{_.token.onCancellationRequested(()=>{F((0,A.canceled)())}),Promise.resolve(R).then(B=>{_.dispose(),k(B)},B=>{_.dispose(),F(B)})});return new class{cancel(){_.cancel()}then(k,F){return W.then(k,F)}catch(k){return this.then(void 0,k)}finally(k){return W.finally(k)}}}e.createCancelablePromise=p;function n(N,_,R){return Promise.race([N,new Promise(W=>_.onCancellationRequested(()=>W(R)))])}e.raceCancellation=n;async function y(N){let _=-1;const R=N.map((k,F)=>k.then(B=>(_=F,B))),W=await Promise.race(R);return N.forEach((k,F)=>{F!==_&&k.cancel()}),W}e.raceCancellablePromises=y;function E(N,_,R){let W;const k=setTimeout(()=>{W==null||W(void 0),R==null||R()},_);return Promise.race([N.finally(()=>clearTimeout(k)),new Promise(F=>W=F)])}e.raceTimeout=E;function S(N){return new Promise((_,R)=>{const W=N();w(W)?W.then(_,R):_(W)})}e.asPromise=S;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(R,R).then(W)})}return new Promise((R,W)=>{this.queuedPromise.then(R,W)})}return this.activePromise=_(),new Promise((R,W)=>{this.activePromise.then(k=>{this.activePromise=null,R(k)},k=>{this.activePromise=null,W(k)})})}}e.Throttler=d;class g{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=g;class P{constructor(){this.promiseMap=new Map}queue(_,R){var W;const F=((W=this.promiseMap.get(_))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=P;class I{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,R=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,k)=>{this.doResolve=W,this.doReject=k}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,A.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=I;class o{constructor(_){this.delayer=new I(_),this.throttler=new d}trigger(_,R){return this.delayer.trigger(()=>this.throttler.queue(_),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class l{constructor(){this._isOpen=!1,this._promise=new Promise((_,R)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class a extends l{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function u(N,_){return _?new Promise((R,W)=>{const k=setTimeout(R,N);_.onCancellationRequested(()=>{clearTimeout(k),W((0,A.canceled)())})}):p(R=>u(N,R))}e.timeout=u;function t(N,_=0){const R=setTimeout(N,_);return(0,b.toDisposable)(()=>clearTimeout(R))}e.disposableTimeout=t;function i(N){return N.then(void 0,_=>{})}e.ignoreErrors=i;function s(N){const _=[];let R=0;const W=N.length;function k(){return R<W?N[R++]():null}function F(B){B!=null&&_.push(B);const V=k();return V?V.then(F):Promise.resolve(_)}return Promise.resolve(null).then(F)}e.sequence=s;function c(N,_=W=>!!W,R=null){let W=0;const k=N.length,F=()=>{if(W>=k)return Promise.resolve(R);const B=N[W++];return Promise.resolve(B()).then(G=>_(G)?Promise.resolve(G):F())};return F()}e.first=c;function h(N,_=W=>!!W,R=null){if(N.length===0)return Promise.resolve(R);let W=N.length;const k=()=>{var F,B;W=-1;for(const V of N)(B=(F=V).cancel)===null||B===void 0||B.call(F)};return new Promise((F,B)=>{for(const V of N)V.then(G=>{--W>=0&&_(G)?(k(),F(G)):W===0&&F(R)}).catch(G=>{--W>=0&&(k(),B(G))})})}e.firstParallel=h;class f{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((R,W)=>{this.outstandingPromises.push({factory:_,c:R,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const R=_.factory();R.then(_.c,_.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class v extends f{constructor(){super(1)}}e.Queue=v;class D{constructor(){this.queues=new Map}queueFor(_,R=r.extUri){const W=R.getComparisonKey(_);let k=this.queues.get(W);return k||(k=new v,L.Event.once(k.onFinished)(()=>{k==null||k.dispose(),this.queues.delete(W)}),this.queues.set(W,k)),k}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=D;class T{constructor(_,R){this._token=-1,typeof _=="function"&&typeof R=="number"&&this.setIfNotSet(_,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},R)}setIfNotSet(_,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},R))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,R){this.cancel(),this._token=setInterval(()=>{_()},R)}}e.IntervalTimer=U;class H{constructor(_,R){this.timeoutToken=-1,this.runner=_,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=H;class X extends H{constructor(_,R){super(_,R);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const N=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=_=>{const R=setTimeout(()=>_(N));let W=!1;return{dispose(){W||(W=!0,clearTimeout(R))}}}}else e.runWhenIdle=(N,_)=>{const R=requestIdleCallback(N,typeof _=="number"?{timeout:_}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(R))}}}}();class te{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=te;async function se(N,_,R){let W;for(let k=0;k<R;k++)try{return await N()}catch(F){W=F,await u(_)}throw W}e.retry=se;class O{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var _;(_=this._pending)===null||_===void 0||_.cancel()}setPending(_,R,W){return this._pending={taskId:_,cancel:()=>W==null?void 0:W(),promise:R},R.then(()=>this.donePending(_),()=>this.donePending(_)),R}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let R,W;const k=new Promise((F,B)=>{R=F,W=B});this._next={run:_,promise:k,promiseResolve:R,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=O;class z{constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,R)=>{this.completeCallback=_,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(R=>{this.completeCallback(_),this.resolved=!0,R()})}error(_){return new Promise(R=>{this.errorCallback(_),this.rejected=!0,R()})}cancel(){new Promise(_=>{this.errorCallback((0,A.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=$;class C extends L.Emitter{async fireAsync(_,R,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const k of this._listeners)this._asyncDeliveryQueue.push([k,_]);for(;this._asyncDeliveryQueue.size>0&&!R.isCancellationRequested;){const[k,F]=this._asyncDeliveryQueue.shift(),B=[],V=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");W&&(G=W(G,typeof k=="function"?k:k[0])),B.push(G)}});try{typeof k=="function"?k.call(void 0,V):k[0].call(k[1],V)}catch(G){(0,A.onUnexpectedError)(G);continue}Object.freeze(B),await q.settled(B).catch(G=>(0,A.onUnexpectedError)(G))}}}}e.AsyncEmitter=C;var q;(function(N){async function _(F){return typeof Promise.allSettled=="function"?R(F):W(F)}N.allSettled=_;async function R(F){return Promise.allSettled(F)}async function W(F){return Promise.all(F.map(B=>B.then(V=>({status:"fulfilled",value:V}),V=>({status:"rejected",reason:V}))))}async function k(F){let B;const V=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{B||(B=Y)})));if(typeof B!="undefined")throw B;return V}N.settled=k})(q=e.Promises||(e.Promises={}))}),define(Q[110],J([0,1,22,30,7,36,9]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const w="**",p="/",n="[/\\\\]",y="[^/\\\\]",E=/\//g;function S(R){switch(R){case 0:return"";case 1:return`${y}*?`;default:return`(?:${n}|${y}+${n}|${n}${y}+)*?`}}function d(R,W){if(!R)return[];const k=[];let F=!1,B=!1,V="";for(const G of R){switch(G){case W:if(!F&&!B){k.push(V),V="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":B=!0;break;case"]":B=!1;break}V+=G}return V&&k.push(V),k}e.splitGlobAware=d;function g(R){if(!R)return"";let W="";const k=d(R,p);if(k.every(F=>F===w))W=".*";else{let F=!1;k.forEach((B,V)=>{if(B===w){F||(W+=S(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const oe of B){if(oe!=="}"&&G){Y+=oe;continue}if(Z&&(oe!=="]"||!re)){let x;oe==="-"?x=oe:(oe==="^"||oe==="!")&&!re?x="^":oe===p?x="":x=m.escapeRegExpCharacters(oe),re+=x;continue}switch(oe){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":W+=`(?:${d(Y,",").map(ue=>g(ue)).join("|")})`,G=!1,Y="";break;case"]":W+="["+re+"]",Z=!1,re="";break;case"?":W+=y;continue;case"*":W+=S(1);continue;default:W+=m.escapeRegExpCharacters(oe)}}V<k.length-1&&(k[V+1]!==w||V+2<k.length)&&(W+=n),F=!1})}return W}const P=/^\*\*\/\*\.[\w\.-]+$/,I=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new b.LRUCache(1e4),i=function(){return!1},s=function(){return null};function c(R,W){if(!R)return s;let k;typeof R!="string"?k=R.pattern:k=R,k=k.trim();const F=`${k}_${!!W.trimForExclusions}`;let B=t.get(F);if(B)return h(B,R);let V;if(P.test(k)){const G=k.substr(4);B=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?k:null}}else(V=I.exec(f(k,W)))?B=v(V[1],k):(W.trimForExclusions?l:o).test(k)?B=D(k,W):(V=a.exec(f(k,W)))?B=T(V[1].substr(1),k,!0):(V=u.exec(f(k,W)))?B=T(V[1],k,!1):B=U(k);return t.set(F,B),h(B,R)}function h(R,W){return typeof W=="string"?R:function(k,F){return A.isEqualOrParent(k,W.base)?R(L.relative(W.base,k),F):null}}function f(R,W){return W.trimForExclusions&&R.endsWith("/**")?R.substr(0,R.length-2):R}function v(R,W){const k=`/${R}`,F=`\\${R}`,B=function(G,Y){return typeof G!="string"?null:Y?Y===R?W:null:G===R||G.endsWith(k)||G.endsWith(F)?W:null},V=[R];return B.basenames=V,B.patterns=[W],B.allBasenames=V,B}function D(R,W){const k=_(R.slice(1,-1).split(",").map(Y=>c(Y,W)).filter(Y=>Y!==s),R),F=k.length;if(!F)return s;if(F===1)return k[0];const B=function(Y,Z){for(let re=0,oe=k.length;re<oe;re++)if(k[re](Y,Z))return R;return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function T(R,W,k){const F=L.sep===L.posix.sep,B=F?R:R.replace(E,L.sep),V=L.sep+B,G=L.posix.sep+R,Y=k?function(Z,re){return typeof Z=="string"&&(Z===B||Z.endsWith(V)||!F&&(Z===R||Z.endsWith(G)))?W:null}:function(Z,re){return typeof Z=="string"&&(Z===B||!F&&Z===R)?W:null};return Y.allPaths=[(k?"*/":"./")+R],Y}function U(R){try{const W=new RegExp(`^${g(R)}$`);return function(k){return W.lastIndex=0,typeof k=="string"&&W.test(k)?R:null}}catch(W){return s}}function H(R,W,k){return!R||typeof W!="string"?!1:X(R)(W,void 0,k)}e.match=H;function X(R,W={}){if(!R)return i;if(typeof R=="string"||z(R)){const k=c(R,W);if(k===s)return i;const F=function(B,V){return!!k(B,V)};return k.allBasenames&&(F.allBasenames=k.allBasenames),k.allPaths&&(F.allPaths=k.allPaths),F}return q(R,W)}e.parse=X;function te(R){if(!!R){let W;return k=>(W||(W=(R()||Promise.resolve([])).then(F=>F?O(F):{})),W.then(F=>!!F[k]))}}e.hasSiblingPromiseFn=te;function se(R){if(!!R){let W;return k=>{if(!W){const F=R();W=F?O(F):{}}return!!W[k]}}}e.hasSiblingFn=se;function O(R){const W={};for(const k of R)W[k]=!0;return W}function z(R){const W=R;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=z;function $(R){return R.allBasenames||[]}e.getBasenameTerms=$;function C(R){return R.allPaths||[]}e.getPathTerms=C;function q(R,W){const k=_(Object.getOwnPropertyNames(R).map(Y=>N(Y,R[Y],W)).filter(Y=>Y!==s)),F=k.length;if(!F)return s;if(!k.some(Y=>!!Y.requiresSiblings)){if(F===1)return k[0];const Y=function(oe,x){for(let ne=0,ue=k.length;ne<ue;ne++){const be=k[ne](oe,x);if(be)return be}return null},Z=k.find(oe=>!!oe.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=k.reduce((oe,x)=>x.allPaths?oe.concat(x.allPaths):oe,[]);return re.length&&(Y.allPaths=re),Y}const B=function(Y,Z,re){let oe;for(let x=0,ne=k.length;x<ne;x++){const ue=k[x];ue.requiresSiblings&&re&&(Z||(Z=L.basename(Y)),oe||(oe=Z.substr(0,Z.length-L.extname(Y).length)));const be=ue(Y,Z,oe,re);if(be)return be}return null},V=k.find(Y=>!!Y.allBasenames);V&&(B.allBasenames=V.allBasenames);const G=k.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(B.allPaths=G),B}function N(R,W,k){if(W===!1)return s;const F=c(R,k);if(F===s)return s;if(typeof W=="boolean")return F;if(W){const B=W.when;if(typeof B=="string"){const V=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const oe=B.replace("$(basename)",Z),x=re(oe);return(0,M.isThenable)(x)?x.then(ne=>ne?R:null):x?R:null};return V.requiresSiblings=!0,V}}return F}function _(R,W){const k=R.filter(Y=>!!Y.basenames);if(k.length<2)return R;const F=k.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let B;if(W){B=[];for(let Y=0,Z=F.length;Y<Z;Y++)B.push(W)}else B=k.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const V=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let oe;for(oe=Y.length;oe>0;oe--){const x=Y.charCodeAt(oe-1);if(x===47||x===92)break}Z=Y.substr(oe)}const re=F.indexOf(Z);return re!==-1?B[re]:null};V.basenames=F,V.patterns=B,V.allBasenames=F;const G=R.filter(Y=>!Y.basenames);return G.push(V),G}}),define(Q[39],J([0,1,8,7,22,10,3,15,30]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(c,h,f){if(typeof c=="string"&&(c=m.URI.file(c)),f){const D=f.getWorkspaceFolder(c);if(D){const T=f.getWorkspace().folders.length>1;let U;if((0,r.isEqual)(D.uri,c)?U="":U=(0,r.relativePath)(D.uri,c),T){const H=D.name?D.name:(0,r.basename)(D.uri);U=U?H+" \u2022 "+U:H}return U}}if(c.scheme!==b.Schemas.file&&c.scheme!==b.Schemas.untitled)return c.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(c.fsPath))return(0,A.normalize)(y(c.fsPath));let v=(0,A.normalize)(c.fsPath);return!M.isWindows&&(h==null?void 0:h.userHome)&&(v=S(v,h.userHome.fsPath)),v}e.getPathLabel=p;function n(c){if(!!c){typeof c=="string"&&(c=m.URI.file(c));const h=(0,r.basename)(c)||(c.scheme===b.Schemas.file?c.fsPath:c.path);return M.isWindows&&(0,w.isRootOrDriveLetter)(h)?y(h):h}}e.getBaseLabel=n;function y(c){return(0,w.hasDriveLetter)(c)?c.charAt(0).toUpperCase()+c.slice(1):c}e.normalizeDriveLetter=y;let E=Object.create(null);function S(c,h){if(M.isWindows||!c||!h)return c;let f=E.original===h?E.normalized:void 0;return f||(f=`${(0,L.rtrim)(h,A.posix.sep)}${A.posix.sep}`,E={original:h,normalized:f}),(M.isLinux?c.startsWith(f):(0,L.startsWithIgnoreCase)(c,f))&&(c=`~/${c.substr(f.length)}`),c}e.tildify=S;function d(c,h){return c.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const g="\u2026",P="\\\\",I="~";function o(c,h=A.sep){const f=new Array(c.length);let v=!1;for(let D=0;D<c.length;D++){let T=c[D];if(T===""){f[D]=`.${h}`;continue}if(!T){f[D]=T;continue}v=!0;let U="";T.indexOf(P)===0?(U=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length)):T.indexOf(h)===0?(U=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(I)===0&&(U=T.substr(0,T.indexOf(I)+I.length),T=T.substr(T.indexOf(I)+I.length));const H=T.split(h);for(let X=1;v&&X<=H.length;X++)for(let te=H.length-X;v&&te>=0;te--){v=!1;let se=H.slice(te,te+X).join(h);for(let O=0;!v&&O<c.length;O++)if(O!==D&&c[O]&&c[O].indexOf(se)>-1){const z=te+X===H.length,$=te>0&&c[O].indexOf(h)>-1?h+se:se,C=c[O].endsWith($);v=!z||C}if(!v){let O="";(H[0].endsWith(":")||U!=="")&&(te===1&&(te=0,X++,se=H[0]+h+se),te>0&&(O=H[0]+h),O=U+O),te>0&&(O=O+g+h),O=O+se,te+X<H.length&&(O=O+h+g),f[D]=O}}v&&(f[D]=T)}return f}e.shorten=o;var l;(function(c){c[c.TEXT=0]="TEXT",c[c.VARIABLE=1]="VARIABLE",c[c.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function a(c,h=Object.create(null)){const f=[];let v=!1,D="";for(const T of c)if(T==="$"||v&&T==="{")D&&f.push({value:D,type:l.TEXT}),D="",v=!0;else if(T==="}"&&v){const U=h[D];if(typeof U=="string")U.length&&f.push({value:U,type:l.VARIABLE});else if(U){const H=f[f.length-1];(!H||H.type!==l.SEPARATOR)&&f.push({value:U.label,type:l.SEPARATOR})}D="",v=!1}else D+=T;return D&&!v&&f.push({value:D,type:l.TEXT}),f.filter((T,U)=>{if(T.type===l.SEPARATOR){const H=f[U-1],X=f[U+1];return[H,X].every(te=>te&&(te.type===l.VARIABLE||te.type===l.TEXT)&&te.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=a;function u(c,h){return M.isMacintosh||h?c.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):c.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function t(c,h){return M.isMacintosh||h?c.replace(/\(&&\w\)|&&/g,""):M.isWindows?c.replace(/&&|&/g,f=>f==="&"?"&&":"&"):c.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(c){return c.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(c){const h=c.indexOf("/")!==-1?A.posix:A.win32,f=h.basename(c),v=h.dirname(c);return f.length?{name:f,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const m=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(w){return m.test(w)}e.isUUID=A;const L=new Uint8Array(16),b=[];for(let w=0;w<256;w++)b.push(w.toString(16).padStart(2,"0"));let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};function r(){M(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let w=0,p="";return p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p+="-",p+=b[L[w++]],p+=b[L[w++]],p+="-",p+=b[L[w++]],p+=b[L[w++]],p+="-",p+=b[L[w++]],p+=b[L[w++]],p+="-",p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p+=b[L[w++]],p}e.generateUuid=r}),define(Q[111],J([0,1,20,58,42]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function b(M,r){if(await new Promise((n,y)=>{const E=m.createReadStream(M),S=A.createHash("sha1");E.pipe(S);const d=(0,L.once)((g,P)=>{E.removeAllListeners(),S.removeAllListeners(),g?y(g):n(P)});E.once("error",d),E.once("end",d),S.once("error",d),S.once("data",g=>d(void 0,g.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=b}),define(Q[81],J([0,1,236]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class A{constructor(b="utf8"){this.stringDecoder=new m.StringDecoder(b),this.remaining=null}write(b){const M=[],r=this.remaining?this.remaining+this.stringDecoder.write(b):this.stringDecoder.write(b);if(r.length<1)return M;let w=0,p,n=w;for(;n<r.length;)if(p=r.charCodeAt(n),p===13||p===10){if(M.push(r.substring(w,n)),n++,n<r.length){const y=p;p=r.charCodeAt(n),(y===13&&p===10||y===10&&p===13)&&n++}w=n}else n++;return this.remaining=w<r.length?r.substr(w):null,M}end(){return this.remaining}}e.LineDecoder=A}),define(Q[112],J([0,1,27]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(r){const w=r.replace(/\-/g,":").toLowerCase();return!A.has(w)}function b(){return new Promise(async(r,w)=>{const p=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await M())}catch(n){w(n)}finally{clearTimeout(p)}})}e.getMac=b;function M(){return new Promise((r,w)=>{try{const p=(0,m.networkInterfaces)();for(let n in p){const y=p[n];if(y){for(const{mac:E}of y)if(L(E))return r(E)}}w("Unable to retrieve mac address (unexpected format)")}catch(p){w(p)}})}}),define(Q[65],J([0,1,19,28,27,36,112]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=b.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,y=0;const E=(0,L.networkInterfaces)();for(let S in E){const d=E[S];if(d)for(const{mac:g,internal:P}of d)P||(y+=1,this._isVirtualMachineMacAdress(g.toUpperCase())&&(n+=1))}this._value=y>0?n/y:0}return this._value}};let r;async function w(){return r||(r=(async()=>await p()||A.generateUuid())()),r}e.getMachineId=w;async function p(){try{const n=await new Promise((E,S)=>{j(["crypto"],E,S)}),y=await(0,M.getMac)();return n.createHash("sha256").update(y,"utf8").digest("hex")}catch(n){m.onUnexpectedError(n);return}}}),define(Q[16],J([0,1,20,27,7,9,3,30,28,64,15,8]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function S($,C=E.UNLINK){if((0,r.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return C===E.UNLINK?g($):d($)}e.rimraf=S;async function d($){try{const C=(0,L.join)((0,A.tmpdir)(),(0,w.generateUuid)());try{await m.promises.rename($,C)}catch(q){return g($)}g(C).catch(q=>{})}catch(C){if(C.code!=="ENOENT")throw C}}async function g($){return m.promises.rmdir($,{recursive:!0,maxRetries:3})}function P($){if((0,r.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");m.rmdirSync($,{recursive:!0})}e.rimrafSync=P;async function I($,C){return a(await(C?o($):m.promises.readdir($)))}e.readdir=I;async function o($){try{return await m.promises.readdir($,{withFileTypes:!0})}catch(N){console.warn("[node.js fs] readdir with filetypes failed with error: ",N)}const C=[],q=await I($);for(const N of q){let _=!1,R=!1,W=!1;try{const k=await m.promises.lstat((0,L.join)($,N));_=k.isFile(),R=k.isDirectory(),W=k.isSymbolicLink()}catch(k){console.warn("[node.js fs] unexpected error from lstat after readdir: ",k)}C.push({name:N,isFile:()=>_,isDirectory:()=>R,isSymbolicLink:()=>W})}return C}function l($){return a(m.readdirSync($))}e.readdirSync=l;function a($){return $.map(C=>typeof C=="string"?M.isMacintosh?(0,p.normalizeNFC)(C):C:(C.name=M.isMacintosh?(0,p.normalizeNFC)(C.name):C.name,C))}async function u($){const C=await I($),q=[];for(const N of C)await i.existsDirectory((0,L.join)($,N))&&q.push(N);return q}e.readDirsInDir=u;function t($,C=1e3){return new Promise(q=>{let N=!1;const _=setInterval(()=>{N||(N=!0,m.access($,R=>{N=!1,R&&(clearInterval(_),q(void 0))}))},C)})}e.whenDeleted=t;var i;(function($){async function C(_){let R;try{if(R=await m.promises.lstat(_),!R.isSymbolicLink())return{stat:R}}catch(W){}try{return{stat:await m.promises.stat(_),symbolicLink:(R==null?void 0:R.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};if(M.isWindows&&W.code==="EACCES")try{return{stat:await m.promises.stat(await m.promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(k){if(k.code==="ENOENT"&&R)return{stat:R,symbolicLink:{dangling:!0}};throw k}throw W}}$.stat=C;async function q(_){try{const{stat:R,symbolicLink:W}=await $.stat(_);return R.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}$.existsFile=q;async function N(_){try{const{stat:R,symbolicLink:W}=await $.stat(_);return R.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(R){}return!1}$.existsDirectory=N})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new b.ResourceQueue;function c($,C,q){return s.queueFor(y.URI.file($),n.extUriBiasedIgnorePathCase).queue(()=>{const N=D(q);return new Promise((_,R)=>f($,C,N,W=>W?R(W):_()))})}e.writeFile=c;let h=!0;function f($,C,q,N){if(!h)return m.writeFile($,C,{mode:q.mode,flag:q.flag},N);m.open($,q.flag,q.mode,(_,R)=>{if(_)return N(_);m.writeFile(R,C,W=>{if(W)return m.close(R,()=>N(W));m.fdatasync(R,k=>(k&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",k),h=!1),m.close(R,F=>N(F))))})})}function v($,C,q){const N=D(q);if(!h)return m.writeFileSync($,C,{mode:N.mode,flag:N.flag});const _=m.openSync($,N.flag,N.mode);try{m.writeFileSync(_,C);try{m.fdatasyncSync(_)}catch(R){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",R),h=!1}}finally{m.closeSync(_)}}e.writeFileSync=v;function D($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function T($,C){if($!==C){async function q(N){try{const _=await m.promises.lstat(N);if(_.isDirectory()||_.isSymbolicLink())return;const R=await m.promises.open(N,"a");try{await R.utimes(_.atime,new Date)}finally{await R.close()}}catch(_){}}try{await m.promises.rename($,C),await q(C)}catch(N){if($.toLowerCase()!==C.toLowerCase()&&N.code==="EXDEV"||$.endsWith("."))await U($,C,{preserveSymlinks:!1}),await S($,E.MOVE),await q(C);else throw N}}}e.move=T;async function U($,C,q){return X($,C,{root:{source:$,target:C},options:q,handledSourcePaths:new Set})}e.copy=U;const H=511;async function X($,C,q){if(!q.handledSourcePaths.has($)){q.handledSourcePaths.add($);const{stat:N,symbolicLink:_}=await i.stat($);if(_){if(q.options.preserveSymlinks)try{return await O($,C,q)}catch(R){console.warn("[node.js fs] copy of symlink failed: ",R)}if(_.dangling)return}return N.isDirectory()?te($,C,N.mode&H,q):se($,C,N.mode&H)}}async function te($,C,q,N){await m.promises.mkdir(C,{recursive:!0,mode:q});const _=await I($);for(const R of _)await X((0,L.join)($,R),(0,L.join)(C,R),N)}async function se($,C,q){await m.promises.copyFile($,C),await m.promises.chmod(C,q)}async function O($,C,q){let N=await m.promises.readlink($);(0,r.isEqualOrParent)(N,q.root.source,!M.isLinux)&&(N=(0,L.join)(q.root.target,N.substr(q.root.source.length+1))),await m.promises.symlink(N,C)}async function z($){try{return await m.promises.access($),!0}catch(C){return!1}}e.exists=z}),define(Q[113],J([0,1,20,114,22,7,16]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(y){const E=(0,b.dirname)(y);if(y===E)return y;const S=((0,b.basename)(y)||y).toLowerCase();try{const g=(0,M.readdirSync)(E).filter(P=>P.toLowerCase()===S);if(g.length===1){const P=r(E);if(P)return(0,b.join)(P,g[0])}else if(g.length>1){const P=g.indexOf(S);if(P>=0){const I=r(E);if(I)return(0,b.join)(I,g[P])}}}catch(d){}return null}e.realcaseSync=r;async function w(y){try{return await(0,A.promisify)(m.realpath)(y)}catch(E){const S=n(y);return await m.promises.access(S,m.constants.R_OK),S}}e.realpath=w;function p(y){try{return m.realpathSync(y)}catch(E){const S=n(y);return m.accessSync(S,m.constants.R_OK),S}}e.realpathSync=p;function n(y){return(0,L.rtrim)((0,b.normalize)(y),b.sep)}}),define(Q[115],J([0,1,59]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function A(){const w=1025;return w+Math.floor((65535-w)*Math.random())}e.randomPort=A;function L(w,p,n){let y=!1;return new Promise(E=>{const S=setTimeout(()=>{if(!y)return y=!0,E(0)},n);b(w,p,d=>{if(!y)return y=!0,clearTimeout(S),E(d)})})}e.findFreePort=L;function b(w,p,n){if(p===0)return n(0);const y=new m.Socket;y.once("connect",()=>(r(y),b(w+1,p-1,n))),y.once("data",()=>{}),y.once("error",E=>(r(y),E.code!=="ECONNREFUSED"?b(w+1,p-1,n):n(w))),y.connect(w,"127.0.0.1")}function M(w,p,n){let y=!1,E,S=1;const d=m.createServer({pauseOnConnect:!0});function g(P,I){y||(y=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),I(P))}return new Promise(P=>{E=setTimeout(()=>{g(0,P)},n),d.on("listening",()=>{g(w,P)}),d.on("error",I=>{I&&(I.code==="EADDRINUSE"||I.code==="EACCES")&&S<p?(w++,S++,d.listen(w,"127.0.0.1")):g(0,P)}),d.on("close",()=>{g(0,P)}),d.listen(w,"127.0.0.1")})}e.findFreePortFaster=M;function r(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(p){console.error(p)}}});var _e=this&&this.__await||function(j){return this instanceof _e?(this.v=j,this):new _e(j)},wt=this&&this.__asyncGenerator||function(j,e,m){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var A=m.apply(j,e||[]),L,b=[];return L={},M("next"),M("throw"),M("return"),L[Symbol.asyncIterator]=function(){return this},L;function M(E){A[E]&&(L[E]=function(S){return new Promise(function(d,g){b.push([E,S,d,g])>1||r(E,S)})})}function r(E,S){try{w(A[E](S))}catch(d){y(b[0][3],d)}}function w(E){E.value instanceof _e?Promise.resolve(E.value.v).then(p,n):y(b[0][2],E)}function p(E){r("next",E)}function n(E){r("throw",E)}function y(E,S){E(S),b.shift(),b.length&&r(b[0][0],b[0][1])}},pt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],m;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),m={},A("next"),A("throw"),A("return"),m[Symbol.asyncIterator]=function(){return this},m);function A(b){m[b]=j[b]&&function(M){return new Promise(function(r,w){M=j[b](M),L(r,w,M.done,M.value)})}}function L(b,M,r,w){Promise.resolve(w).then(function(p){b({value:p,done:r})},M)}};define(Q[116],J([0,1,16,27,7]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const b=/^\d+$/,M=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var w;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(w||(w={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class y{constructor(u,t,i){this.exePath=u,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await m.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:a=!1}={}){return a?p===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:a=!1,findPreview:u=!1}={}){const t=E({useAlternateBitness:a});if(!t)return null;const i=L.join(t,"PowerShell");if(!await m.SymlinkSupport.existsDirectory(i))return null;let s=-1,c=null;for(const v of await m.readdir(i)){let D=-1;if(u){const U=v.indexOf("-");if(U<0)continue;const H=v.substring(0,U);if(!b.test(H)||v.substring(U+1)!=="preview")continue;D=parseInt(H,10)}else{if(!b.test(v))continue;D=parseInt(v,10)}if(!(D<=s)){const T=L.join(i,v,"pwsh.exe");!await m.SymlinkSupport.existsFile(T)||(c=T,s=D)}}if(!c)return null;const h=t.includes("x86")?" (x86)":"",f=u?" Preview":"";return new y(c,`PowerShell${f}${h}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await m.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=a?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const s of await m.readdir(u))if(t.test(s)){const c=L.join(u,s,"pwsh.exe");return new y(c,i)}return null}function g(){const a=L.join(A.homedir(),".dotnet","tools","pwsh.exe");return new y(a,".NET Core PowerShell Global Tool")}function P(){const a=L.join(process.env.windir,p===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(a,"Windows PowerShell",!0)}function I(){return wt(this,arguments,function*(){let u=yield _e(S());u&&(yield yield _e(u)),u=yield _e(S({useAlternateBitness:!0})),u&&(yield yield _e(u)),u=yield _e(d()),u&&(yield yield _e(u)),u=g(),u&&(yield yield _e(u)),u=yield _e(S({findPreview:!0})),u&&(yield yield _e(u)),u=yield _e(d({findPreview:!0})),u&&(yield yield _e(u)),u=yield _e(S({useAlternateBitness:!0,findPreview:!0})),u&&(yield yield _e(u)),u=P(),u&&(yield yield _e(u))})}function o(){return wt(this,arguments,function*(){var u,t;try{for(var i=pt(I()),s;s=yield _e(i.next()),!s.done;){const c=s.value;(yield _e(c.exists()))&&(yield yield _e(c))}}catch(c){u={error:c}}finally{try{s&&!s.done&&(t=i.return)&&(yield _e(t.call(i)))}finally{if(u)throw u.error}}})}e.enumeratePowerShellInstallations=o;async function l(){var a,u;try{for(var t=pt(o()),i;i=await t.next(),!i.done;)return i.value}catch(s){a={error:s}}finally{try{i&&!i.done&&(u=t.return)&&await u.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=l}),define(Q[82],J([0,1,45,10]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(M){return new Promise((r,w)=>{let p;const n=new Map;function y(d,g,P,I,o){const l=n.get(g);if(d===M||l){const a={name:E(P),cmd:P,pid:d,ppid:g,load:I,mem:o};n.set(d,a),d===M&&(p=a),l&&(l.children||(l.children=[]),l.children.push(a),l.children.length>1&&(l.children=l.children.sort((u,t)=>u.pid-t.pid)))}}function E(d){const g=/--disable-blink-features=Auxclick/,P=/\\watcher\\win32\\CodeHelper\.exe/,I=/--crashes-directory/,o=/\\pipe\\winpty-control/,l=/conhost\.exe/,a=/--type=([a-zA-Z-]+)/;if(P.exec(d))return"watcherService ";if(I.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(l.exec(d))return"console-window-host (Windows internal process)";let u=a.exec(d);if(u&&u.length===2)return u[1]==="renderer"?g.exec(d)?"shared-process":"window":u[1];const t=/[a-zA-Z-]+\.js/g;let i="";do u=t.exec(d),u&&(i+=u+" ");while(u);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${i}`:d}if(process.platform==="win32"){const d=g=>g.indexOf("\\\\?\\")===0||g.indexOf("\\??\\")===0?g.substr(4):g.indexOf('"\\\\?\\')===0||g.indexOf('"\\??\\')===0?'"'+g.substr(5):g;new Promise((g,P)=>{j(["windows-process-tree"],g,P)}).then(g=>{g.getProcessList(M,P=>{g.getProcessCpuUsage(P,I=>{const o=new Map;I.forEach(l=>{const a=d(l.commandLine||"");o.set(l.pid,{name:E(a),cmd:a,pid:l.pid,ppid:l.ppid,load:l.cpu||0,mem:l.memory||0})}),p=o.get(M),p?(o.forEach(l=>{const a=o.get(l.ppid);a&&(a.children||(a.children=[]),a.children.push(l))}),o.forEach(l=>{l.children&&(l.children=l.children.sort((a,u)=>a.pid-u.pid))}),r(p)):w(new Error(`Root process ${M} not found`))})},g.ProcessDataFlag.CommandLine|g.ProcessDataFlag.Memory)})}else{function S(){let d=[p];const g=[];for(;d.length;){const I=d.shift();I&&(g.push(I.pid),I.children&&(d=d.concat(I.children)))}let P=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);P+=" "+g.join(" "),(0,m.exec)(P,{},(I,o,l)=>{if(I||l)w(I||new Error(l.toString()));else{const a=o.toString().split(`
`);for(let u=0;u<g.length;u++){const t=n.get(g[u]);t.load=parseFloat(a[u])}if(!p){w(new Error(`Root process ${M} not found`));return}r(p)}})}(0,m.exec)("which ps",{},(d,g,P)=>{if(d||P)if(process.platform!=="linux")w(d||new Error(P.toString()));else{const I=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,m.exec)(I,{},(o,l,a)=>{o||a?w(o||new Error(a.toString())):(b(l,y),S())})}else{const I=g.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,m.exec)(`${I} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(l,a,u)=>{l||u&&!u.includes("screen size is bogus")?w(l||new Error(u.toString())):(b(a,y),process.platform==="linux"?S():p?r(p):w(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=L;function b(M,r){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=M.toString().split(`
`);for(const n of p){const y=w.exec(n.trim());y&&y.length===6&&r(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Q[117],J([0,1,7,20,3,64,2,16]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(y,E,S){return n({path:y,isDirectory:!1},E,S)}e.watchFile=w;function p(y,E,S){return n({path:y,isDirectory:!0},E,S)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function n(y,E,S){const d=(0,m.basename)(y.path),g=new Map;let P=!1,I=[(0,M.toDisposable)(()=>{g.forEach(o=>(0,M.dispose)(o)),g.clear()})];try{const o=(0,A.watch)(y.path);I.push((0,M.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const l=new Set;y.isDirectory&&(0,r.readdir)(y.path).then(a=>a.forEach(u=>l.add(u))),o.on("error",(a,u)=>{P||S(`Failed to watch ${y.path} for changes using fs.watch() (${a}, ${u})`)}),o.on("change",(a,u)=>{if(!P){let t="";if(u&&(t=u.toString(),L.isMacintosh&&(t=(0,b.normalizeNFC)(t))),!(!t||a!=="change"&&a!=="rename")){const i=y.isDirectory?(0,m.join)(y.path,t):y.path;if(y.isDirectory)if(a==="rename"){const s=g.get(i);s&&(0,M.dispose)(s);const c=setTimeout(async()=>{g.delete(i);const h=await(0,r.exists)(i);if(!P){let f;h?l.has(t)?f="changed":(f="added",l.add(t)):(l.delete(t),f="deleted"),E(f,i)}},e.CHANGE_BUFFER_DELAY);g.set(i,(0,M.toDisposable)(()=>clearTimeout(c)))}else{let s;l.has(t)?s="changed":(s="added",l.add(t)),E(s,i)}else if(a==="rename"||t!==d){const s=setTimeout(async()=>{const c=await(0,r.exists)(i);P||(c?(E("changed",i),I=[n(y,E,S)]):E("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(I),I=[(0,M.toDisposable)(()=>clearTimeout(s))]}else E("changed",i)}}})}catch(o){(0,r.exists)(y.path).then(l=>{l&&!P&&S(`Failed to watch ${y.path} for changes using fs.watch() (${o.toString()})`)})}return(0,M.toDisposable)(()=>{P=!0,I=(0,M.dispose)(I)})}}),define(Q[118],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[119],J([0,1,14,118,13]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function b(){m.ipcMain.on(A.CONTEXT_MENU_CHANNEL,(r,w,p,n,y)=>{const E=M(r,n,p);E.popup({window:(0,L.withNullAsUndefined)(m.BrowserWindow.fromWebContents(r.sender)),x:y?y.x:void 0,y:y?y.y:void 0,positioningItem:y?y.positioningItem:void 0,callback:()=>{E&&r.sender.send(A.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=b;function M(r,w,p){const n=new m.Menu;return p.forEach(y=>{let E;y.type==="separator"?E=new m.MenuItem({type:y.type}):Array.isArray(y.submenu)?E=new m.MenuItem({submenu:M(r,w,y.submenu),label:y.label}):E=new m.MenuItem({label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:y.enabled,visible:y.visible,click:(S,d,g)=>r.sender.send(w,y.id,g)}),n.append(E)}),n}}),define(Q[33],J([0,1,5,2,9,26,19,23,35,13,109,22]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(N){N[N.Promise=100]="Promise",N[N.PromiseCancel=101]="PromiseCancel",N[N.EventListen=102]="EventListen",N[N.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function S(N){switch(N){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(N){N[N.Initialize=200]="Initialize",N[N.PromiseSuccess=201]="PromiseSuccess",N[N.PromiseError=202]="PromiseError",N[N.PromiseErrorObj=203]="PromiseErrorObj",N[N.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function g(N){switch(N){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(N){N[N.Uninitialized=0]="Uninitialized",N[N.Idle=1]="Idle"})(P||(P={}));class I{constructor(_){this.buffer=_,this.pos=0}read(_){const R=this.buffer.slice(this.pos,this.pos+_);return this.pos+=R.byteLength,R}}class o{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(_){this.buffers.push(_)}}var l;(function(N){N[N.Undefined=0]="Undefined",N[N.String=1]="String",N[N.Buffer=2]="Buffer",N[N.VSBuffer=3]="VSBuffer",N[N.Array=4]="Array",N[N.Object=5]="Object"})(l||(l={}));function a(N){const _=r.VSBuffer.alloc(4);return _.writeUInt32BE(N,0),_}function u(N){return N.read(4).readUInt32BE(0)}function t(N){const _=r.VSBuffer.alloc(1);return _.writeUInt8(N,0),_}const i={Undefined:t(l.Undefined),String:t(l.String),Buffer:t(l.Buffer),VSBuffer:t(l.VSBuffer),Array:t(l.Array),Object:t(l.Object)},s=typeof Buffer!="undefined";function c(N,_){if(typeof _=="undefined")N.write(i.Undefined);else if(typeof _=="string"){const R=r.VSBuffer.fromString(_);N.write(i.String),N.write(a(R.byteLength)),N.write(R)}else if(s&&Buffer.isBuffer(_)){const R=r.VSBuffer.wrap(_);N.write(i.Buffer),N.write(a(R.byteLength)),N.write(R)}else if(_ instanceof r.VSBuffer)N.write(i.VSBuffer),N.write(a(_.byteLength)),N.write(_);else if(Array.isArray(_)){N.write(i.Array),N.write(a(_.length));for(const R of _)c(N,R)}else{const R=r.VSBuffer.fromString(JSON.stringify(_));N.write(i.Object),N.write(a(R.byteLength)),N.write(R)}}function h(N){switch(N.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return N.read(u(N)).toString();case l.Buffer:return N.read(u(N)).buffer;case l.VSBuffer:return N.read(u(N));case l.Array:{const R=u(N),W=[];for(let k=0;k<R;k++)W.push(h(N));return W}case l.Object:return JSON.parse(N.read(u(N)).toString())}}class f{constructor(_,R,W=null,k=1e3){this.protocol=_,this.ctx=R,this.logger=W,this.timeoutDelay=k,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(F=>this.onRawMessage(F)),this.sendResponse({type:200})}registerChannel(_,R){this.channels.set(_,R),setTimeout(()=>this.flushPendingRequests(_),0)}sendResponse(_){switch(_.type){case 200:{const R=this.send([_.type]);this.logger&&this.logger.logOutgoing(R,0,1,g(_.type));return}case 201:case 202:case 204:case 203:{const R=this.send([_.type,_.id],_.data);this.logger&&this.logger.logOutgoing(R,_.id,1,g(_.type),_.data);return}}}send(_,R=void 0){const W=new o;return c(W,_),c(W,R),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(R){return 0}}onRawMessage(_){const R=new I(_),W=h(R),k=h(R),F=W[0];switch(F){case 100:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${S(F)}: ${W[2]}.${W[3]}`,k),this.onPromise({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 102:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${S(F)}: ${W[2]}.${W[3]}`,k),this.onEventListen({type:F,id:W[1],channelName:W[2],name:W[3],arg:k});case 101:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${S(F)}`),this.disposeActiveRequest({type:F,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],1,`${S(F)}`),this.disposeActiveRequest({type:F,id:W[1]})}}onPromise(_){const R=this.channels.get(_.channelName);if(!R){this.collectPendingRequest(_);return}const W=new b.CancellationTokenSource;let k;try{k=R.call(this.ctx,_.name,_.arg,W.token)}catch(V){k=Promise.reject(V)}const F=_.id;k.then(V=>{this.sendResponse({id:F,data:V,type:201}),this.activeRequests.delete(_.id)},V=>{V instanceof Error?this.sendResponse({id:F,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:F,data:V,type:203}),this.activeRequests.delete(_.id)});const B=(0,A.toDisposable)(()=>W.cancel());this.activeRequests.set(_.id,B)}onEventListen(_){const R=this.channels.get(_.channelName);if(!R){this.collectPendingRequest(_);return}const W=_.id,F=R.listen(this.ctx,_.name,_.arg)(B=>this.sendResponse({id:W,data:B,type:204}));this.activeRequests.set(_.id,F)}disposeActiveRequest(_){const R=this.activeRequests.get(_.id);R&&(R.dispose(),this.activeRequests.delete(_.id))}collectPendingRequest(_){let R=this.pendingRequests.get(_.channelName);R||(R=[],this.pendingRequests.set(_.channelName,R));const W=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.sendResponse({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);R.push({request:_,timeoutTimer:W})}flushPendingRequests(_){const R=this.pendingRequests.get(_);if(R){for(const W of R)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(_)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var v;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class D{constructor(_,R=null){this.protocol=_,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=R}getChannel(_){const R=this;return{call(W,k,F){return R.isDisposed?Promise.reject(M.canceled()):R.requestPromise(_,W,k,F)},listen(W,k){return R.isDisposed?Promise.reject(M.canceled()):R.requestEvent(_,W,k)}}}requestPromise(_,R,W,k=b.CancellationToken.None){const F=this.lastRequestId++,V={id:F,type:100,channelName:_,name:R,arg:W};if(k.isCancellationRequested)return Promise.reject(M.canceled());let G;return new Promise((Z,re)=>{if(k.isCancellationRequested)return re(M.canceled());const oe=()=>{const be=me=>{switch(me.type){case 201:this.handlers.delete(F),Z(me.data);break;case 202:this.handlers.delete(F);const Pe=new Error(me.data.message);Pe.stack=me.data.stack,Pe.name=me.data.name,re(Pe);break;case 203:this.handlers.delete(F),re(me.data);break}};this.handlers.set(F,be),this.sendRequest(V)};let x=null;this.state===P.Idle?oe():(x=(0,L.createCancelablePromise)(be=>this.whenInitialized()),x.then(()=>{x=null,oe()}));const ne=()=>{x?(x.cancel(),x=null):this.sendRequest({id:F,type:101}),re(M.canceled())},ue=k.onCancellationRequested(ne);G=(0,A.combinedDisposable)((0,A.toDisposable)(ne),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(_,R,W){const k=this.lastRequestId++,B={id:k,type:102,channelName:_,name:R,arg:W};let V=null;const G=new m.Emitter({onFirstListenerAdd:()=>{V=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete(G),this.sendRequest({id:k,type:103}))}}),Y=Z=>G.fire(Z.data);return this.handlers.set(k,Y),G.event}sendRequest(_){switch(_.type){case 100:case 102:{const R=this.send([_.type,_.id,_.channelName,_.name],_.arg);this.logger&&this.logger.logOutgoing(R,_.id,0,`${S(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const R=this.send([_.type,_.id]);this.logger&&this.logger.logOutgoing(R,_.id,0,S(_.type));return}}}send(_,R=void 0){const W=new o;return c(W,_),c(W,R),this.sendBuffer(W.buffer)}sendBuffer(_){try{return this.protocol.send(_),_.byteLength}catch(R){return 0}}onBuffer(_){const R=new I(_),W=h(R),k=h(R),F=W[0];switch(F){case 200:return this.logger&&this.logger.logIncoming(_.byteLength,0,0,g(F)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(_.byteLength,W[1],0,g(F),k),this.onResponse({type:W[0],id:W[1],data:k})}}onResponse(_){if(_.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const R=this.handlers.get(_.id);R&&R(_)}whenInitialized(){return this.state===P.Idle?Promise.resolve():m.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(_=>_.dispose()),this.activeRequests.clear()}}e.ChannelClient=D;class T{constructor(_){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,_(({protocol:R,onDidClientDisconnect:W})=>{m.Event.once(R.onMessage)(F=>{const B=new I(F),V=h(B),G=new f(R,V),Y=new D(R);this.channels.forEach((re,oe)=>G.registerChannel(oe,re));const Z={channelServer:G,channelClient:Y,ctx:V};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{G.dispose(),Y.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const _=[];return this._connections.forEach(R=>_.push(R)),_}getChannel(_,R){const W=this;return{call(k,F,B){let V;if((0,p.isFunction)(R)){let Y=(0,w.getRandomElement)(W.connections.filter(R));V=Y?Promise.resolve(Y):m.Event.toPromise(m.Event.filter(W.onDidAddConnection,R))}else V=R.routeCall(W,k,F);const G=V.then(Y=>Y.channelClient.getChannel(_));return H(G).call(k,F,B)},listen(k,F){if((0,p.isFunction)(R))return W.getMulticastEvent(_,R,k,F);const B=R.routeEvent(W,k,F).then(V=>V.channelClient.getChannel(_));return H(B).listen(k,F)}}}getMulticastEvent(_,R,W,k){const F=this;let B=new A.DisposableStore;const V=new m.Emitter({onFirstListenerAdd:()=>{B=new A.DisposableStore;const G=new m.EventMultiplexer,Y=new Map,Z=oe=>{const ne=oe.channelClient.getChannel(_).listen(W,k),ue=G.add(ne);Y.set(oe,ue)},re=oe=>{const x=Y.get(oe);!x||(x.dispose(),Y.delete(oe))};F.connections.filter(R).forEach(Z),m.Event.filter(F.onDidAddConnection,R)(Z,void 0,B),F.onDidRemoveConnection(re,void 0,B),G.event(V.fire,V,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(_,R){this.channels.set(_,R),this._connections.forEach(W=>{W.channelServer.registerChannel(_,R)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=T;class U{constructor(_,R,W=null){const k=new o;c(k,R),_.send(k.buffer),this.channelClient=new D(_,W),this.channelServer=new f(_,R,W)}getChannel(_){return this.channelClient.getChannel(_)}registerChannel(_,R){this.channelServer.registerChannel(_,R)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function H(N){return{call(_,R,W){return N.then(k=>k.call(_,R,W))},listen(_,R){const W=new m.Relay;return N.then(k=>W.input=k.listen(_,R)),W.event}}}e.getDelayedChannel=H;function X(N){let _=!1;return{call(R,W,k){return _?N.call(R,W,k):(0,L.timeout)(0).then(()=>_=!0).then(()=>N.call(R,W,k))},listen(R,W){if(_)return N.listen(R,W);const k=new m.Relay;return(0,L.timeout)(0).then(()=>_=!0).then(()=>k.input=N.listen(R,W)),k.event}}}e.getNextTickChannel=X;class te{constructor(_){this.fn=_}routeCall(_){return this.route(_)}routeEvent(_){return this.route(_)}async route(_){for(const R of _.connections)if(await Promise.resolve(this.fn(R.ctx)))return Promise.resolve(R);return await m.Event.toPromise(_.onDidAddConnection),await this.route(_)}}e.StaticRouter=te;var se;(function(N){function _(k,F){const B=k,V=F&&F.disableMarshalling,G=new Map;for(const Y in B)W(Y)&&G.set(Y,m.Event.buffer(B[Y],!0));return new class{listen(Y,Z){const re=G.get(Z);if(re)return re;throw new Error(`Event not found: ${Z}`)}call(Y,Z,re){const oe=B[Z];if(typeof oe=="function"){if(!V&&Array.isArray(re))for(let x=0;x<re.length;x++)re[x]=(0,n.revive)(re[x]);return oe.apply(B,re)}throw new Error(`Method not found: ${Z}`)}}}N.fromService=_;function R(k,F){const B=F&&F.disableMarshalling;return new Proxy({},{get(V,G){var Y;if(typeof G=="string")return((Y=F==null?void 0:F.properties)===null||Y===void 0?void 0:Y.has(G))?F.properties.get(G):W(G)?k.listen(G):async function(...Z){let re;F&&!(0,p.isUndefinedOrNull)(F.context)?re=[F.context,...Z]:re=Z;const oe=await k.call(G,re);return B?oe:(0,n.revive)(oe)};throw new Error(`Property not found: ${String(G)}`)}})}N.toService=R;function W(k){return k[0]==="o"&&k[1]==="n"&&y.isUpperAsciiLetter(k.charCodeAt(2))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const O=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(N){if(Array.isArray(N))return N;if(N&&typeof N=="object"&&typeof N.toString=="function"){let _=N.toString();if(_!=="[object Object]")return _}return N}function $(N){return Array.isArray(N)?N.map(z):z(N)}function C(N,_,R,W,k,F,B){B=$(B);const V=O[k],G=V[W%V.length];let Y=[`%c[${N}]%c[${String(_).padStart(7," ")}]%c[len: ${String(R).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(F)?(Y=Y.concat(B),Y.push(")")):Y.push(B),console.log.apply(console,Y)}e.logWithColors=C;class q{constructor(_,R){this._outgoingPrefix=_,this._incomingPrefix=R,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(_,R,W,k,F){this._totalOutgoing+=_,C(this._outgoingPrefix,this._totalOutgoing,_,R,W,k,F)}logIncoming(_,R,W,k,F){this._totalIncoming+=_,C(this._incomingPrefix,this._totalIncoming,_,R,W,k,F)}}e.IPCLogger=q}),define(Q[120],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class m{constructor(L,b){this.sender=L,this.onMessage=b}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(b){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=m}),define(Q[121],J([0,1,5,33,23]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class b{constructor(w){this.port=w,this.onMessage=m.Event.fromDOMEventEmitter(this.port,"message",p=>L.VSBuffer.wrap(p.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=b;class M extends A.IPCClient{constructor(w,p){const n=new b(w);super(n,p);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=M}),define(Q[83],J([0,1,5,33,2,23,3,32]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function p(){return w||(w=b.VSBuffer.alloc(0)),w}class n{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,c){if(s===0)return p();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const D=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=s),D}if(this._chunks[0].byteLength>s){const D=this._chunks[0].slice(0,s);return c&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),D}let h=b.VSBuffer.alloc(s),f=0,v=0;for(;s>0;){const D=this._chunks[v];if(D.byteLength>s){const T=D.slice(0,s);h.set(T,f),f+=s,c&&(this._chunks[v]=D.slice(s),this._totalLength-=s),s-=s}else h.set(D,f),f+=D.byteLength,c?(this._chunks.shift(),this._totalLength-=D.byteLength):v++,s-=D.byteLength}return h}}e.ChunkStream=n;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(y||(y={}));var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(s,c,h,f){this.type=s,this.id=c,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(s){super();this._onMessage=this._register(new m.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new n,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new S(h,f,v,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class g{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=b.VSBuffer.alloc(13);c.writeUInt8(s.type,0),c.writeUInt32BE(s.id,1),c.writeUInt32BE(s.ack,5),c.writeUInt32BE(s.data.byteLength,9),this._writeSoon(c,s.data)}}_bufferAdd(s,c){const h=this._totalLength===0;return this._data.push(s,c),this._totalLength+=s.byteLength+c.byteLength,h}_bufferTake(){const s=b.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,c){this._bufferAdd(s,c)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class P extends L.Disposable{constructor(s){super();this._onMessage=new m.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new m.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new g(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new S(1,0,0,s))}}e.Protocol=P;class I extends A.IPCClient{constructor(s,c,h=null){super(s,c,h);this.protocol=s}static fromSocket(s,c){return new I(new P(s),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=I;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new m.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class l{constructor(s){this.data=s,this.next=null}}class a{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],c=0,h=this._first;for(;h;)s[c++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const c=new l(s);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class u{constructor(){this.lastRuns=[];const s=Date.now();for(let c=0;c<u._HISTORY_LENGTH;c++)this.lastRuns[c]=s-1e3*c;setInterval(()=>{for(let c=u._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return u._INSTANCE||(u._INSTANCE=new u),u._INSTANCE}load(){const s=Date.now(),c=(1+u._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<u._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=c&&h++;return 1-h/u._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}u._HISTORY_LENGTH=10,u._INSTANCE=null;class t{constructor(s,c=null){this._loadEstimator=u.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new a,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),c&&this._socketReader.acceptChunk(c),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new S(5,0,0,p());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const c=new S(4,0,0,p());this._socketWriter.write(c),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,c){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new g(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let c=0,h=s.length;c<h;c++)this._socketWriter.write(s[c]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new S(6,0,0,p())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const c=this._outgoingUnackMsg.toArray();for(let h=0,f=c.length;h<f;h++)this._socketWriter.write(c[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new S(1,c,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const c=new S(2,0,0,s);this._socketWriter.write(c)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),c=Date.now()-s.writtenTime;if(c>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-c,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new S(3,0,this._incomingAckId,p());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(Q[122],J([0,1,14,5,33,120,2,23]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(n,y){const E=A.Event.fromNodeEventEmitter(m.ipcMain,y,(d,g)=>({event:d,message:g})),S=A.Event.filter(E,({event:d})=>d.sender.id===n);return A.Event.map(S,({message:d})=>d&&r.VSBuffer.wrap(d))}class p extends L.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const y=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:hello",({sender:E})=>E);return A.Event.map(y,E=>{const S=E.id,d=p.Clients.get(S);d&&d.dispose();const g=new A.Emitter;p.Clients.set(S,(0,M.toDisposable)(()=>g.fire()));const P=w(S,"vscode:message"),I=A.Event.any(A.Event.signal(w(S,"vscode:disconnect")),g.event);return{protocol:new b.Protocol(E,P),onDidClientDisconnect:I}})}}e.Server=p,p.Clients=new Map}),define(Q[84],J([0,1,14,5,28,121]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends b.Client{constructor(p,n){super({addEventListener:(y,E)=>p.addListener(y,E),removeEventListener:(y,E)=>p.removeListener(y,E),postMessage:y=>p.postMessage(y),start:()=>p.start(),close:()=>p.close()},n)}}e.Client=M;async function r(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,L.generateUuid)();w.webContents.send("vscode:createMessageChannel",p);const n=A.Event.fromNodeEventEmitter(m.ipcMain,"vscode:createMessageChannelResult",(E,S)=>({nonce:S,port:E.ports[0]})),{port:y}=await A.Event.toPromise(A.Event.once(A.Event.filter(n,E=>E.nonce===p)));return y}e.connect=r}),define(Q[85],J([0,1,2,5,9,13]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var M;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));var r;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(r||(r={}));class w extends m.Disposable{constructor(y,E=Object.create(null)){super();this.database=y,this.options=E,this._onDidChangeStorage=this._register(new A.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=r.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(y=>this.onDidChangeItemsExternal(y)))}onDidChangeItemsExternal(y){var E,S;(E=y.changed)===null||E===void 0||E.forEach((d,g)=>this.accept(g,d)),(S=y.deleted)===null||S===void 0||S.forEach(d=>this.accept(d,void 0))}accept(y,E){if(this.state!==r.Closed){let S=!1;(0,b.isUndefinedOrNull)(E)?S=this.cache.delete(y):this.cache.get(y)!==E&&(this.cache.set(y,E),S=!0),S&&this._onDidChangeStorage.fire(y)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===r.None&&(this.state=r.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(y,E){const S=this.cache.get(y);return(0,b.isUndefinedOrNull)(S)?E:S}getBoolean(y,E){const S=this.get(y);return(0,b.isUndefinedOrNull)(S)?E:S==="true"}getNumber(y,E){const S=this.get(y);return(0,b.isUndefinedOrNull)(S)?E:parseInt(S,10)}async set(y,E){if(this.state!==r.Closed){if((0,b.isUndefinedOrNull)(E))return this.delete(y);const S=String(E);if(this.cache.get(y)!==S)return this.cache.set(y,S),this.pendingInserts.set(y,S),this.pendingDeletes.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(y){if(this.state!==r.Closed&&!!this.cache.delete(y))return this.pendingDeletes.has(y)||this.pendingDeletes.add(y),this.pendingInserts.delete(y),this._onDidChangeStorage.fire(y),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=r.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(y){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const y={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(y).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(y=>this.whenFlushedCallbacks.push(y))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(y){y.insert&&y.insert.forEach((E,S)=>this.items.set(S,E)),y.delete&&y.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=p}),define(Q[123],J([0,1,20,5,9,36,7,16]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class w{constructor(y,E=Object.create(null)){this.path=y,this.options=E,this.name=(0,M.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return A.Event.None}async getItems(){const y=await this.whenConnected,E=new Map;return(await this.all(y,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(y){const E=await this.whenConnected;return this.doUpdateItems(E,y)}doUpdateItems(y,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,b.mapToString)(E.insert):"0"}), delete(${E.delete?(0,b.setToString)(E.delete):"0"})`),this.transaction(y,()=>{const S=E.insert,d=E.delete;if(S&&S.size>0){const g=[];g.push([]);let P=0;S.forEach((I,o)=>{let l=g[P];l.length>w.MAX_HOST_PARAMETERS&&(P++,l=[],g.push(l)),l.push(o,I)}),g.forEach(I=>{this.prepare(y,`INSERT INTO ItemTable VALUES ${new Array(I.length/2).fill("(?,?)").join(",")}`,o=>o.run(I),()=>{const o=[];let l=0;return S.forEach((a,u)=>{o.push(u),l+=a.length}),`Keys: ${o.join(", ")} Length: ${l}`})})}if(d&&d.size){const g=[];g.push([]);let P=0;d.forEach(I=>{let o=g[P];o.length>w.MAX_HOST_PARAMETERS&&(P++,o=[],g.push(o)),o.push(I)}),g.forEach(I=>{this.prepare(y,`DELETE FROM ItemTable WHERE key IN (${new Array(I.length).fill("?").join(",")})`,o=>o.run(I),()=>{const o=[];return d.forEach(l=>{o.push(l)}),`Keys: ${o.join(", ")}`})})}})}async close(y){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,y)}doClose(y,E){return new Promise((S,d)=>{y.db.close(g=>(g&&this.handleSQLiteError(y,`[storage ${this.name}] close(): ${g}`),this.path===w.IN_MEMORY_PATH?S():!y.isErroneous&&!y.isInMemory?this.backup().then(S,P=>(this.logger.error(`[storage ${this.name}] backup(): ${P}`),S())):typeof E=="function"?m.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(P=>{const I=()=>this.doClose(P,void 0);return this.doUpdateItems(P,{insert:E()}).then(()=>I(),o=>(I(),Promise.reject(o)))})).then(S,d):d(g||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const y=this.toBackupPath(this.path);return(0,r.copy)(this.path,y,{preserveSymlinks:!1})}toBackupPath(y){return`${y}.backup`}async checkIntegrity(y){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${y})`);const E=await this.whenConnected,S=await this.get(E,y?"PRAGMA integrity_check":"PRAGMA quick_check"),d=y?S.integrity_check:S.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(y,E=!0){this.logger.trace(`[storage ${this.name}] open(${y}, retryOnBusy: ${E})`);try{return await this.doConnect(y)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&E)return await(0,L.timeout)(w.BUSY_OPEN_TIMEOUT),this.connect(y,!1);try{await m.promises.unlink(y);try{await m.promises.rename(this.toBackupPath(y),y)}catch(d){}return await this.doConnect(y)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(w.IN_MEMORY_PATH)}}}handleSQLiteError(y,E){y.isErroneous=!0,y.lastError=E,this.logger.error(E)}doConnect(y){return new Promise((E,S)=>{new Promise((d,g)=>{j(["vscode-sqlite3"],d,g)}).then(d=>{const g={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(y,P=>P?g.db?g.db.close(()=>S(P)):S(P):this.exec(g,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(g),I=>g.db.close(()=>S(I)))),isInMemory:y===w.IN_MEMORY_PATH};g.db.on("error",P=>this.handleSQLiteError(g,`[storage ${this.name}] Error (event): ${P}`)),this.logger.isTracing&&g.db.on("trace",P=>this.logger.trace(`[storage ${this.name}] Trace (event): ${P}`))},S)})}exec(y,E){return new Promise((S,d)=>{y.db.exec(E,g=>g?(this.handleSQLiteError(y,`[storage ${this.name}] exec(): ${g}`),d(g)):S())})}get(y,E){return new Promise((S,d)=>{y.db.get(E,(g,P)=>g?(this.handleSQLiteError(y,`[storage ${this.name}] get(): ${g}`),d(g)):S(P))})}all(y,E){return new Promise((S,d)=>{y.db.all(E,(g,P)=>g?(this.handleSQLiteError(y,`[storage ${this.name}] all(): ${g}`),d(g)):S(P))})}transaction(y,E){return new Promise((S,d)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),E(),y.db.run("END TRANSACTION",g=>g?(this.handleSQLiteError(y,`[storage ${this.name}] transaction(): ${g}`),d(g)):S())})})}prepare(y,E,S,d){const g=y.db.prepare(E),P=I=>{this.handleSQLiteError(y,`[storage ${this.name}] prepare(): ${I} (${E}). Details: ${d()}`)};g.on("error",P),S(g),g.finalize(I=>{I&&P(I),g.removeListener("error",P)})}}e.SQLiteStorageDatabase=w,w.IN_MEMORY_PATH=":memory:",w.BUSY_OPEN_TIMEOUT=2e3,w.MAX_HOST_PARAMETERS=256;class p{constructor(y){y&&typeof y.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=y.logTrace),y&&typeof y.logError=="function"&&(this.logError=y.logError)}get isTracing(){return!!this.logTrace}trace(y){this.logTrace&&this.logTrace(y)}error(y){this.logError&&this.logError(y)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[124],J([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[125],J([0,1,124]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,L=A*60,b=L*24,M=b*7,r=b*30,w=b*365;function p(y,E){typeof y!="number"&&(y=y.getTime());const S=Math.round((new Date().getTime()-y)/1e3);if(S<-30)return(0,m.localize)(0,null,p(new Date().getTime()+S*1e3,!1));if(S<30)return(0,m.localize)(1,null);let d;return S<A?(d=S,E?d===1?(0,m.localize)(2,null,d):(0,m.localize)(3,null,d):d===1?(0,m.localize)(4,null,d):(0,m.localize)(5,null,d)):S<L?(d=Math.floor(S/A),E?d===1?(0,m.localize)(6,null,d):(0,m.localize)(7,null,d):d===1?(0,m.localize)(8,null,d):(0,m.localize)(9,null,d)):S<b?(d=Math.floor(S/L),E?d===1?(0,m.localize)(10,null,d):(0,m.localize)(11,null,d):d===1?(0,m.localize)(12,null,d):(0,m.localize)(13,null,d)):S<M?(d=Math.floor(S/b),E?d===1?(0,m.localize)(14,null,d):(0,m.localize)(15,null,d):d===1?(0,m.localize)(16,null,d):(0,m.localize)(17,null,d)):S<r?(d=Math.floor(S/M),E?d===1?(0,m.localize)(18,null,d):(0,m.localize)(19,null,d):d===1?(0,m.localize)(20,null,d):(0,m.localize)(21,null,d)):S<w?(d=Math.floor(S/r),E?d===1?(0,m.localize)(22,null,d):(0,m.localize)(23,null,d):d===1?(0,m.localize)(24,null,d):(0,m.localize)(25,null,d)):(d=Math.floor(S/w),E?d===1?(0,m.localize)(26,null,d):(0,m.localize)(27,null,d):d===1?(0,m.localize)(28,null,d):(0,m.localize)(29,null,d))}e.fromNow=p;function n(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Q[126],J([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[66],J([0,1,126,13,35]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function b(p,n){return n&&(p.stack||p.stacktrace)?m.localize(0,null,r(p),M(p.stack)||M(p.stacktrace)):r(p)}function M(p){return Array.isArray(p)?p.join(`
`):p}function r(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?m.localize(1,null,p.message):p.message||m.localize(2,null)}function w(p=null,n=!1){if(!p)return m.localize(3,null);if(Array.isArray(p)){const y=L.coalesce(p),E=w(y[0],n);return y.length>1?m.localize(4,null,E,y.length):E}if(A.isString(p))return p;if(p.detail){const y=p.detail;if(y.error)return b(y.error,n);if(y.exception)return b(y.exception,n)}return p.stack?b(p,n):p.message?p.message:m.localize(5,null)}e.toErrorMessage=w}),define(Q[127],J([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[128],J([0,1,127]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class A{constructor(M,r,w=r){this.modifierLabels=[null],this.modifierLabels[2]=M,this.modifierLabels[1]=r,this.modifierLabels[3]=w}toLabel(M,r,w){if(r.length===0)return null;const p=[];for(let n=0,y=r.length;n<y;n++){const E=r[n],S=w(E);if(S===null)return null;p[n]=L(E,S,this.modifierLabels[M])}return p.join(" ")}}e.ModifierLabelProvider=A,e.UILabelProvider=new A({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:m.localize(0,null),shiftKey:m.localize(1,null),altKey:m.localize(2,null),metaKey:m.localize(3,null),separator:"+"},{ctrlKey:m.localize(4,null),shiftKey:m.localize(5,null),altKey:m.localize(6,null),metaKey:m.localize(7,null),separator:"+"}),e.AriaLabelProvider=new A({ctrlKey:m.localize(8,null),shiftKey:m.localize(9,null),altKey:m.localize(10,null),metaKey:m.localize(11,null),separator:"+"},{ctrlKey:m.localize(12,null),shiftKey:m.localize(13,null),altKey:m.localize(14,null),metaKey:m.localize(15,null),separator:"+"},{ctrlKey:m.localize(16,null),shiftKey:m.localize(17,null),altKey:m.localize(18,null),metaKey:m.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new A({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new A({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(b,M,r){if(M===null)return"";const w=[];return b.ctrlKey&&w.push(r.ctrlKey),b.shiftKey&&w.push(r.shiftKey),b.altKey&&w.push(r.altKey),b.metaKey&&w.push(r.metaKey),M!==""&&w.push(M),w.join(r.separator)}}),define(Q[129],J([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[67],J([0,1,7,20,16,45,129,32,13,44,30,3,81,10]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(u){switch(u){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(u,t){if(y.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const s=b.execFile("taskkill",["/T","/F","/PID",u.pid.toString()],i);return new Promise(c=>{s.once("error",h=>{c({success:!1,error:h})}),s.once("exit",(h,f)=>{c(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(y.isLinux||y.isMacintosh)try{const i=S.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{b.execFile(i,[u.pid.toString()],{encoding:"utf8",shell:!0},(c,h,f)=>{s(c?{success:!1,error:c}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else u.kill("SIGKILL");return Promise.resolve({success:!0})}function P(u=r.env){return u.comspec||"cmd.exe"}e.getWindowsShell=P;class I{constructor(t,i,s,c){if(i!==void 0&&s!==void 0&&c!==void 0)this.cmd=t,this.args=i,this.shell=s,this.options=c;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(r.env).forEach(f=>{h[f]=r.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(m.sep);return i!==-1&&(t=t.substring(i+1)),I.WellKnowCommands[t]?t:"other"}start(t){return y.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(r.cwd()))?Promise.reject(new Error(M.localize(0,null))):this.useExec().then(i=>{let s,c;const h=new Promise((f,v)=>{s=f,c=v});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=b.exec(f,this.options,(v,D,T)=>{this.childProcess=null;const U=v;U&&U.killed?c({killed:this.terminateRequested,stdout:D.toString(),stderr:T.toString()}):this.handleExec(s,t,v,D,T)})}else{let f=null;const v=D=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(D,s,t,c);const T={terminated:this.terminateRequested};w.isNumber(D)&&(T.cmdCode=D),s(T)};if(this.shell&&y.isWindows){const D=p.deepClone(this.options);D.windowsVerbatimArguments=!0,D.detached=!1;let T=!1,U=!1;const H=[];let X=this.ensureQuotes(this.cmd);H.push(X.value),T=X.quoted,this.args&&this.args.forEach(se=>{X=this.ensureQuotes(se),H.push(X.value),U=U&&X.quoted});const te=["/s","/c"];T?U?te.push('"'+H.join(" ")+'"'):H.length>1?te.push('"'+H[0]+'" '+H.slice(1).join(" ")):te.push('"'+H[0]+'"'):te.push(H.join(" ")),f=b.spawn(P(),te,D)}else this.cmd&&(f=b.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(w.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",D=>{this.childProcess=null,c({terminated:this.terminateRequested,error:D})}),f.pid&&(this.childProcess.on("close",v),this.handleSpawn(f,s,t,c,!0)))}return h})}handleClose(t,i,s,c){}ensureQuotes(t){return I.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,g(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!y.isWindows)return t(!1);const i=b.spawn(P(),["/s","/c"]);i.on("error",s=>t(!0)),i.on("exit",s=>t(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class o extends I{constructor(t,i,s,c){super(t,i,s,c);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,s,c,h){[c,h].forEach((f,v)=>{const D=new E.LineDecoder;D.write(f).forEach(H=>{i({line:H,source:v===0?0:1})});const U=D.end();U&&i({line:U,source:v===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,i,s,c,h){const f=new E.LineDecoder,v=new E.LineDecoder;t.stdout.on("data",D=>{f.write(D).forEach(U=>s({line:U,source:0}))}),t.stderr.on("data",D=>{v.write(D).forEach(U=>s({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=v}handleClose(t,i,s,c){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&s({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=o;function l(u){let t=[],i=!1;const s=function(c){if(i){t.push(c);return}(!u.send(c,f=>{if(f&&console.error(f),i=!1,t.length>0){const v=t.slice(0);t=[],v.forEach(D=>s(D))}})||y.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=l;var a;(function(u){async function t(i,s,c){if(m.isAbsolute(i))return i;if(s===void 0&&(s=r.cwd()),m.dirname(i)!=="."||(c===void 0&&w.isString(r.env.PATH)&&(c=r.env.PATH.split(m.delimiter)),c===void 0||c.length===0))return m.join(s,i);async function f(v){return await L.exists(v)?!(await A.promises.stat(v)).isDirectory():!1}for(let v of c){let D;if(m.isAbsolute(v)?D=m.join(v,i):D=m.join(s,v,i),await f(D))return D;let T=D+".com";if(await f(T)||(T=D+".exe",await f(T)))return T}return m.join(s,i)}u.findExecutable=t})(a=e.win32||(e.win32={}))}),define(Q[130],J([0,1,27,3,116,67]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(S,d){return S===1?A.isWindows?y():b.getWindowsShell(d):p(S,d)}e.getSystemShell=M;function r(S,d){return S===1?A.isWindows?E(d):b.getWindowsShell(d):p(S,d)}e.getSystemShellSync=r;let w=null;function p(S,d){if(A.isLinux&&S===2||A.isMacintosh&&S===3)return"/bin/bash";if(!w){let g;if(A.isWindows)g="/bin/bash";else{if(g=d.SHELL,!g)try{g=(0,m.userInfo)().shell}catch(P){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}w=g}return w}let n=null;async function y(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function E(S){if(n)return n;const d=A.isWindows&&parseFloat((0,m.release)())>=10,g=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),P=`${S.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?P:b.getWindowsShell(S)}}),define(Q[86],J([0,1,45,2,9,44,5,67,33,108,26,19,23,3]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(I){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(l){}},onMessage:M.Event.fromNodeEventEmitter(process,"message",o=>E.VSBuffer.wrap(Buffer.from(o,"base64")))},I);process.once("disconnect",()=>this.dispose())}}e.Server=d;class g{constructor(I,o){this.modulePath=I,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new M.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const l=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new L.Delayer(l),this.child=null,this._client=null}getChannel(I){const o=this;return{call(l,a,u){return o.requestPromise(I,l,a,u)},listen(l,a){return o.requestEvent(I,l,a)}}}requestPromise(I,o,l,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(y.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(I),t=(0,L.createCancelablePromise)(c=>u.call(o,l,c)),i=a.onCancellationRequested(()=>t.cancel()),s=(0,A.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(I,o,l){if(!this.disposeDelayer)return M.Event.None;this.disposeDelayer.cancel();let a;const u=new M.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(I).listen(o,l)(u.fire,u),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const I=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,b.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),S.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,m.fork)(this.modulePath,I,o);const l=new M.Emitter;M.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,p.isRemoteConsoleLog)(h)){(0,p.log)(h,`IPC Library: ${this.options.serverName}`);return}l.fire(E.VSBuffer.wrap(Buffer.from(h,"base64")))});const u=this.options.useQueue?(0,r.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&u.send(h.buffer.toString("base64")),i=l.event,s={send:t,onMessage:i};this._client=new w.ChannelClient(s);const c=()=>this.disposeClient();process.once("exit",c),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",c),this.activeRequests.forEach(v=>(0,A.dispose)(v)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(I){let o=this.channels.get(I);return o||(o=this.client.getChannel(I),this.channels.set(I,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=g}),define(Q[131],J([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[132],J([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[133],J([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[134],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[135],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[136],J([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],J([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],J([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],J([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[140],J([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[141],J([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[142],J([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],J([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],J([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],J([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[146],J([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[147],J([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[148],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[149],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[150],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[151],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[152],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[153],J([0,1,5,2]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new m.Emitter,this._onReloadEmitter=new m.Emitter,this._onTerminateEmitter=new m.Emitter,this._onAttachEmitter=new m.Emitter}call(r,w,p){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(r,w,p){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class b extends A.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,w,p){this.channel.call("attach",[r,w,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,w){this.channel.call("terminate",[r,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[r,w||{},p])}}e.ExtensionHostDebugChannelClient=b}),define(Q[154],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class m{constructor(M){this.driver=M}listen(M,r){throw new Error(`No event found: ${r}`)}call(M,r,w){switch(r){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${r}`)}}e.WindowDriverChannel=m;class A{constructor(M){this.channel=M}click(M,r,w){return this.channel.call("click",[M,r,w])}doubleClick(M){return this.channel.call("doubleClick",M)}setValue(M,r){return this.channel.call("setValue",[M,r])}getTitle(){return this.channel.call("getTitle")}isActiveElement(M){return this.channel.call("isActiveElement",M)}getElements(M,r){return this.channel.call("getElements",[M,r])}getElementXY(M,r,w){return this.channel.call("getElementXY",[M,r,w])}typeInEditor(M,r){return this.channel.call("typeInEditor",[M,r])}getTerminalBuffer(M){return this.channel.call("getTerminalBuffer",M)}writeInTerminal(M,r){return this.channel.call("writeInTerminal",[M,r])}}e.WindowDriverChannelClient=A;class L{constructor(M){this.channel=M}registerWindowDriver(M){return this.channel.call("registerWindowDriver",M)}reloadWindowDriver(M){return this.channel.call("reloadWindowDriver",M)}}e.WindowDriverRegistryChannelClient=L});var ce=this&&this.__decorate||function(j,e,m,A){var L=arguments.length,b=L<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,m):A,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")b=Reflect.decorate(j,e,m,A);else for(var r=j.length-1;r>=0;r--)(M=j[r])&&(b=(L<3?M(b):L>3?M(e,m,b):M(e,m))||b);return L>3&&b&&Object.defineProperty(e,m,b),b};define(Q[155],J([0,1,7,15,52,125,10,8,32]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(d,g,P){this._args=d,this.paths=g,this.productService=P}get appRoot(){return(0,m.dirname)(M.FileAccess.asFileUri("",j).fsPath)}get userHome(){return r.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return r.URI.file((0,m.join)(this.userDataPath,"User"))}get tmpDir(){return r.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,A.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,m.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return r.URI.file((0,m.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.joinPath)(r.URI.file((0,m.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return r.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return r.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,A.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=w.env.VSCODE_PORTABLE;return d?r.URI.file((0,m.join)(d,"argv.json")):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,A.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return r.URI.file((0,m.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,m.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,m.resolve)(d):(0,m.normalize)((0,m.join)(M.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,m.resolve)(d):(0,m.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,m.resolve)(d);const g=w.env.VSCODE_EXTENSIONS;if(g)return g;const P=w.env.VSCODE_PORTABLE;return P?(0,m.join)(P,"extensions"):(0,A.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?r.URI.parse(g):r.URI.file((0,m.normalize)(g)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?r.URI.parse(d):r.URI.file((0,m.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,A.joinPath)(r.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return r.URI.file((0,m.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([L.memoize],p.prototype,"appRoot",null),ce([L.memoize],p.prototype,"userHome",null),ce([L.memoize],p.prototype,"userDataPath",null),ce([L.memoize],p.prototype,"appSettingsHome",null),ce([L.memoize],p.prototype,"tmpDir",null),ce([L.memoize],p.prototype,"userRoamingDataHome",null),ce([L.memoize],p.prototype,"settingsResource",null),ce([L.memoize],p.prototype,"userDataSyncHome",null),ce([L.memoize],p.prototype,"userDataSyncLogResource",null),ce([L.memoize],p.prototype,"sync",null),ce([L.memoize],p.prototype,"machineSettingsResource",null),ce([L.memoize],p.prototype,"globalStorageHome",null),ce([L.memoize],p.prototype,"workspaceStorageHome",null),ce([L.memoize],p.prototype,"keybindingsResource",null),ce([L.memoize],p.prototype,"keyboardLayoutResource",null),ce([L.memoize],p.prototype,"argvResource",null),ce([L.memoize],p.prototype,"snippetsHome",null),ce([L.memoize],p.prototype,"isExtensionDevelopment",null),ce([L.memoize],p.prototype,"untitledWorkspacesHome",null),ce([L.memoize],p.prototype,"installSourcePath",null),ce([L.memoize],p.prototype,"builtinExtensionsPath",null),ce([L.memoize],p.prototype,"extensionsPath",null),ce([L.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],p.prototype,"extensionDevelopmentKind",null),ce([L.memoize],p.prototype,"extensionTestsLocationURI",null),ce([L.memoize],p.prototype,"debugExtensionHost",null),ce([L.memoize],p.prototype,"serviceMachineIdResource",null),ce([L.memoize],p.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=p;function n(S,d){return E(S["inspect-extensions"],S["inspect-brk-extensions"],5870,d,S.debugId)}e.parseExtensionHostPort=n;function y(S,d){return E(S["inspect-search"],S["inspect-brk-search"],5876,d)}e.parseSearchPort=y;function E(S,d,g,P,I){const l=Number(d||S)||(P?null:g),a=l?Boolean(!!d):!1;return{port:l,break:a,debugId:I}}}),define(Q[87],J([0,1,237,134,3]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const b={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,A.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(14,null)},category:{type:"string",cat:"e",description:(0,A.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,A.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,A.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,A.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,A.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,A.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,A.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,A.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,A.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,A.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,g,P=M){const I={},o=[],l=[];for(let i in g){const s=g[i];s.alias&&(I[i]=s.alias),s.type==="string"||s.type==="string[]"?(o.push(i),s.deprecates&&o.push(s.deprecates)):s.type==="boolean"&&(l.push(i),s.deprecates&&l.push(s.deprecates))}const a=m(d,{string:o,boolean:l,alias:I}),u={},t=a;u._=a._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in g){const s=g[i];s.alias&&delete t[s.alias];let c=t[i];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(c||(c=t[s.deprecates]),delete t[s.deprecates]),typeof c!="undefined"&&(s.type==="string[]"?c&&!Array.isArray(c)&&(c=[c]):s.type==="string"&&Array.isArray(c)&&(c=c.pop(),P.onMultipleValues(i,c)),u[i]=c),delete t[i]}for(let i in t)P.onUnknownOption(i);return u}e.parseArgs=r;function w(d,g){let P="";return g.args&&(Array.isArray(g.args)?P=` <${g.args.join("> <")}>`:P=` <${g.args}>`),g.alias?`-${g.alias} --${d}${P}`:`--${d}${P}`}function p(d,g){let P=0,I=[];for(const u in d){const t=d[u],i=w(u,t);P=Math.max(P,i.length),I.push([i,t.description])}let o=P+2+1;if(g-o<25)return I.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let l=g-o-1,a=[];for(const u of I){let t=u[0],i=y(u[1],l),s=n(o-t.length-2);a.push("  "+t+s+i[0]);for(let c=1;c<i.length;c++)a.push(n(o)+i[c])}return a}e.formatOptions=p;function n(d){return" ".repeat(d)}function y(d,g){let P=[];for(;d.length;){let I=d.length<g?d.length:d.lastIndexOf(" ",g),o=d.slice(0,I).trim();d=d.slice(I),P.push(o)}return P}function E(d,g,P,I,o=!0){const l=process.stdout.isTTY&&process.stdout.columns||80;let a=[`${d} ${P}`];a.push(""),a.push(`${(0,A.localize)(32,null)}: ${g} [${(0,A.localize)(33,null)}][${(0,A.localize)(34,null)}...]`),a.push(""),o&&(L.isWindows?a.push((0,A.localize)(35,null,g)):a.push((0,A.localize)(36,null,g)),a.push(""));const u={};for(const t in I){const i=I[t];if(i.description&&i.cat){let s=u[i.cat];s||(u[i.cat]=s={}),s[t]=i}}for(let t in u){const i=t;let s=u[i];s&&(a.push(b[i]),a.push(...p(s,l)),a.push(""))}return a.join(`
`)}e.buildHelpMessage=E;function S(d,g){return`${d||(0,A.localize)(37,null)}
${g||(0,A.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=S}),define(Q[156],J([0,1,87,59,153]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class b extends L.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,w,p){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(r,w,p)}async openExtensionDevelopmentHostWindow(r,w,p){const n=(0,m.parseArgs)(r,m.OPTIONS);n.debugRenderer=p;const y=n.extensionDevelopmentPath;if(!y)return{success:!1};let E;const S=Object.keys(w);for(let l of S){let a=w[l];a===null||(E||(E=Object.create(null)),E[l]=a)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(y,{context:5,cli:n,userEnv:E});if(!p)return{success:!0};const g=d.win;if(!g)return{success:!0};const P=g.webContents.debugger;let I=P.isAttached()?Infinity:0;const o=(0,A.createServer)(l=>{I++==0&&P.attach();let a=!1;const u=s=>{a||l.write(JSON.stringify(s)+"\0")},t=(s,c,h,f)=>u({method:c,params:h,sessionId:f});g.on("close",()=>{P.removeListener("message",t),l.end(),a=!0}),P.addListener("message",t);let i=Buffer.alloc(0);l.on("data",s=>{i=Buffer.concat([i,s]);for(let c=i.indexOf(0);c!==-1;c=i.indexOf(0)){let h;try{const f=i.slice(0,c).toString("utf8");i=i.slice(c+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}P.sendCommand(h.method,h.params,h.sessionId).then(f=>u({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>u({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),l.on("error",s=>{console.error("error on cdp pipe:",s)}),l.on("close",()=>{a=!0,--I==0&&P.detach()})});return await new Promise(l=>o.listen(0,l)),g.on("close",()=>o.close()),{rendererDebugPort:o.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=b}),function(){"use strict";function j(e,m,A,L){function b(r){const w=M(r),p=[w];return e.isAbsolute(w)||p.unshift(L),e.resolve(...p)}function M(r){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const p=r["user-data-dir"];if(p)return p;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(y,"AppData","Roaming")}break;case"darwin":n=e.join(m.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(m.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,A)}return{getUserDataPath:b}}if(typeof define=="function")define(Q[157],J([0,158,27,10,15,32]),function(e,m,A,L,b,M){const r=b.dirname(L.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(b.joinPath(r,"package.json").fsPath);return j(m,A,w.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),m=require("path"),A=require("os");module.exports=j(m,A,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[159],J([0,1,27,157,155]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class b extends L.AbstractNativeEnvironmentService{constructor(r,w){super(r,{homeDir:(0,m.homedir)(),tmpDir:(0,m.tmpdir)(),userDataDir:(0,A.getUserDataPath)(r)},w)}}e.NativeEnvironmentService=b}),define(Q[160],J([0,1,20,27,7]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function b(M){const r=(0,L.join)((0,A.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return m.writeFileSync(r,""),M&&console.log(`Marker file for --wait created: ${r}`),r}catch(w){M&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=b}),define(Q[161],J([0,1,137]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(y){return y=y.trim(),y==="*"||A.test(y)}e.isValidVersionStr=L;function b(y){if(!L(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=y.match(A);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=b;function M(y){if(!y)return null;let E=y.majorBase,S=y.majorMustEqual,d=y.minorBase,g=y.minorMustEqual,P=y.patchBase,I=y.patchMustEqual;return y.hasCaret&&(E===0||(g=!1),I=!1),{majorBase:E,majorMustEqual:S,minorBase:d,minorMustEqual:g,patchBase:P,patchMustEqual:I,isMinimum:y.hasGreaterEquals}}e.normalizeVersion=M;function r(y,E){let S;typeof y=="string"?S=M(b(y)):S=y;let d;if(typeof E=="string"?d=M(b(E)):d=E,!S||!d)return!1;let g=S.majorBase,P=S.minorBase,I=S.patchBase,o=d.majorBase,l=d.minorBase,a=d.patchBase,u=d.majorMustEqual,t=d.minorMustEqual,i=d.patchMustEqual;return d.isMinimum?g>o?!0:g<o?!1:P>l?!0:P<l?!1:I>=a:(g===1&&o===0&&(!u||!t||!i)&&(o=1,l=0,a=0,u=!0,t=!1,i=!1),g<o?!1:g>o?!u:P<l?!1:P>l?!t:I<a?!1:I>a?!i:!0)}e.isValidVersion=r;function w(y,E,S){return E.isBuiltin||typeof E.main=="undefined"?!0:n(y,E.engines.vscode,S)}e.isValidExtensionVersion=w;function p(y,E){return y==="*"||n(E,y)}e.isEngineValid=p;function n(y,E,S=[]){let d=M(b(E));if(!d)return S.push(m.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return S.push(m.localize(1,null,E)),!1}else if(!d.majorMustEqual)return S.push(m.localize(2,null,E)),!1;return r(y,d)?!0:(S.push(m.localize(3,null,y,E)),!1)}e.isVersionValid=n}),define(Q[162],J([0,1,33,86,2,10]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(w,p,n,y){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=y,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(Q[163],J([0,1,33,86,2,10]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class M extends L.Disposable{constructor(w,p,n,y,E={}){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=y,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new A.Client(b.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=M.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=m.ProxyChannel.toService((0,m.getNextTickChannel)(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=M,M.MAX_RESTARTS=5}),define(Q[164],J([0,1,45,81,110,10]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class M{constructor(w,p,n,y,E){this.watchedFolder=w,this.eventCallback=n,this.logCallback=y,this.verboseLogging=E,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(S=>L.parse(S)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=m.spawn(b.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,w);const p=new A.LineDecoder;this.handle.stdout.on("data",n=>{const y=[];p.write(n).forEach(E=>{const S=E.split("|");if(S.length===2){const d=Number(S[0]),g=S[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(P=>P(g))){this.verboseLogging&&this.log(g);return}y.push({type:M.changeTypeMap[d],path:g})}else this.log(S[1])}}),y.length>0&&this.eventCallback(y)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,y)=>this.onExit(n,y))}onError(w){this.error("process error: "+w.toString())}onExit(w,p){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${p})`),this.restartCounter<=M.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=M,M.MAX_RESTARTS=5,M.changeTypeMap=[0,1,2]}),define(Q[165],J([0,1,164,7,22]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class b{constructor(r,w,p,n){this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=n,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(A.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,A.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new m.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=b}),define(Q[68],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class m{constructor(b,M=[],r=!1){this.ctor=b,this.staticArguments=M,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=m;const A=(L,...b)=>new m(L,b);e.createSyncDescriptor=A}),define(Q[166],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class m{constructor(b){this.incoming=new Map,this.outgoing=new Map,this.data=b}}e.Node=m;class A{constructor(b){this._hashFn=b,this._nodes=new Map}roots(){const b=[];for(let M of this._nodes.values())M.outgoing.size===0&&b.push(M);return b}insertEdge(b,M){const r=this.lookupOrInsertNode(b),w=this.lookupOrInsertNode(M);r.outgoing.set(this._hashFn(M),w),w.incoming.set(this._hashFn(b),r)}removeNode(b){const M=this._hashFn(b);this._nodes.delete(M);for(let r of this._nodes.values())r.outgoing.delete(M),r.incoming.delete(M)}lookupOrInsertNode(b){const M=this._hashFn(b);let r=this._nodes.get(M);return r||(r=new m(b),this._nodes.set(M,r)),r}lookup(b){return this._nodes.get(this._hashFn(b))}isEmpty(){return this._nodes.size===0}toString(){let b=[];for(let[M,r]of this._nodes)b.push(`${M}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return b.join(`
`)}findCycleSlow(){for(let[b,M]of this._nodes){const r=new Set([b]),w=this._findCycle(M,r);if(w)return w}}_findCycle(b,M){for(let[r,w]of b.outgoing){if(M.has(r))return[...M,r].join(" -> ");M.add(r);const p=this._findCycle(w,M);if(p)return p;M.delete(r)}}}e.Graph=A}),define(Q[4],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var m;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=w})(m=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function A(r,w,p,n){w[m.DI_TARGET]===w?w[m.DI_DEPENDENCIES].push({id:r,index:p,optional:n}):(w[m.DI_DEPENDENCIES]=[{id:r,index:p,optional:n}],w[m.DI_TARGET]=w)}function L(r){if(m.serviceIds.has(r))return m.serviceIds.get(r);const w=function(p,n,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(w,p,y,!1)};return w.toString=()=>r,m.serviceIds.set(r,w),w}e.createDecorator=L;function b(r){return r}e.refineServiceDecorator=b;function M(r){return function(w,p,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");A(r,w,n,!0)}}e.optional=M}),define(Q[69],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,m.createDecorator)(e.ID);function A(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=A}),define(Q[88],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,m.createDecorator)("encryptionMainService");class A{constructor(b){this.machineId=b}encryption(){return new Promise((b,M)=>j(["vscode-encrypt"],b,M))}async encrypt(b){try{return(await this.encryption()).encrypt(this.machineId,b)}catch(M){return b}}async decrypt(b){try{return(await this.encryption()).decrypt(this.machineId,b)}catch(M){return b}}}e.EncryptionMainService=A}),define(Q[53],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,m.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,m.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[167],J([0,1,136,4,10]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function b(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=b;var M;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=5]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(M=e.SortBy||(e.SortBy={}));var r;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(r=e.SortOrder||(e.SortOrder={}));var w;(function(y){y.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(E,S){super(E);this.code=S}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,m.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,m.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,A.createDecorator)("IExtensionManagementCLIService")}),define(Q[168],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,m.createDecorator)("extensionUrlTrustService")}),define(Q[169],J([0,1,22,4]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class M{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,y){if(typeof n=="undefined"||n===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof n=="string"||typeof y=="string"){let E=typeof n=="string"?n:n.value,S=typeof y=="string"?y:y.value;return m.equalsIgnoreCase(E,S)}return n._lower===y._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=M;function r(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=r;function w(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[170],J([0,1,22,169]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(S,d){return S.uuid&&d.uuid?S.uuid===d.uuid:S.id===d.id?!0:(0,m.compareIgnoreCase)(S.id,d.id)===0}e.areSameExtensions=L;class b{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof b?L(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=b;function M(S,d){return`${S}.${d}`}e.getExtensionId=M;function r(S){return S.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function w(S,d){return r(M(S,d))}e.getGalleryExtensionId=w;function p(S,d){const g=[],P=I=>{for(const o of g)if(o.some(l=>L(d(l),d(I))))return o;return null};for(const I of S){const o=P(I);o?o.push(I):g.push([I])}return g}e.groupByExtension=p;function n(S){return{id:S.identifier.id,name:S.manifest.name,galleryId:null,publisherId:S.publisherId,publisherName:S.manifest.publisher,publisherDisplayName:S.publisherDisplayName,dependencies:S.manifest.extensionDependencies&&S.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function y(S){return Object.assign({id:S.identifier.id,name:S.name,galleryId:S.identifier.uuid,publisherId:S.publisherId,publisherName:S.publisher,publisherDisplayName:S.publisherDisplayName,dependencies:!!(S.properties.dependencies&&S.properties.dependencies.length>0)},S.telemetryData)}e.getGalleryExtensionTelemetryData=y,e.BetterMergeId=new A.ExtensionIdentifier("pprice.better-merge");function E(S){const d=new Set;for(const g of S)g.malicious&&d.add(g.id.id);return d}e.getMaliciousExtensionsSet=E}),define(Q[89],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,m.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,m.createDecorator)("externalTerminal")}),define(Q[24],J([0,1,140,7,8,4,22,13,36]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function p(O){return O.create===!0}e.isFileOpenForWriteOptions=p;var n;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var y;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(y=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=E;function S(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=S;function d(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function g(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=g;var P;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(P=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(z,$){super(z);this.code=$}}e.FileSystemProviderError=I;function o(O,z){const $=new I(O.toString(),z);return a($,z),$}e.createFileSystemProviderError=o;function l(O){return O||o((0,m.localize)(0,null),P.Unknown)}e.ensureFileSystemProviderError=l;function a(O,z){return O.name=z?`${z} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=a;function u(O){if(!O)return P.Unknown;if(O instanceof I)return O.code;const z=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!z)return P.Unknown;switch(z[1]){case P.FileExists:return P.FileExists;case P.FileIsADirectory:return P.FileIsADirectory;case P.FileNotADirectory:return P.FileNotADirectory;case P.FileNotFound:return P.FileNotFound;case P.FileExceedsMemoryLimit:return P.FileExceedsMemoryLimit;case P.FileTooLarge:return P.FileTooLarge;case P.FileWriteLocked:return P.FileWriteLocked;case P.NoPermissions:return P.NoPermissions;case P.Unavailable:return P.Unavailable}return P.Unknown}e.toFileSystemProviderErrorCode=u;function t(O){if(O instanceof v)return O.fileOperationResult;switch(u(O)){case P.FileNotFound:return 1;case P.FileIsADirectory:return 0;case P.FileNotADirectory:return 10;case P.FileWriteLocked:return 5;case P.NoPermissions:return 6;case P.FileExists:return 4;case P.FileExceedsMemoryLimit:return 9;case P.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor(z,$,C){this.resource=z,this.operation=$,this.target=C}isOperation(z){return this.operation===z}}e.FileOperationEvent=s;var c;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class h{constructor(z,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const C of z)switch(C.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(C.resource,C);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(C.resource,C);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(C.resource,C);break}}contains(z,...$){return this.doContains(z,{includeChildren:!1},...$)}affects(z,...$){return this.doContains(z,{includeChildren:!0},...$)}doContains(z,$,...C){var q,N,_,R,W,k;if(!z)return!1;const F=C.length>0;return!!((!F||C.includes(1))&&(((q=this.added)===null||q===void 0?void 0:q.get(z))||$.includeChildren&&((N=this.added)===null||N===void 0?void 0:N.findSuperstr(z)))||(!F||C.includes(0))&&(((_=this.updated)===null||_===void 0?void 0:_.get(z))||$.includeChildren&&((R=this.updated)===null||R===void 0?void 0:R.findSuperstr(z)))||(!F||C.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(z))||$.includeChildren&&((k=this.deleted)===null||k===void 0?void 0:k.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const $=[],C=z===1?this.added:z===0?this.updated:this.deleted;if(C)for(const[,q]of C)$.push(q);return $}filter(z){return new h(this.changes.filter($=>z($)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(O,z,$){return!O||!z||O===z||z.length>O.length?!1:(z.charAt(z.length-1)!==A.sep&&(z+=A.sep),$?(0,M.startsWithIgnoreCase)(O,z):O.indexOf(z)===0)}e.isParent=f;class v extends Error{constructor(z,$,C){super(z);this.fileOperationResult=$,this.options=C}static isFileOperationError(z){return z instanceof Error&&!(0,r.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=v;var D;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(D=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=U;async function H(O,z){if(!z.canHandleResource(L.URI.from({scheme:O.scheme})))return new Promise($=>{const C=z.onDidChangeFileSystemProviderRegistrations(q=>{q.scheme===O.scheme&&q.added&&(C.dispose(),$())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize(z){return(0,r.isNumber)(z)||(z=0),z<X.KB?(0,m.localize)(1,null,z.toFixed(0)):z<X.MB?(0,m.localize)(2,null,(z/X.KB).toFixed(2)):z<X.GB?(0,m.localize)(3,null,(z/X.MB).toFixed(2)):z<X.TB?(0,m.localize)(4,null,(z/X.GB).toFixed(2)):(0,m.localize)(5,null,(z/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var te;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function se(O){return{maxFileSize:O===0?300*X.MB:16*X.GB,maxHeapSize:O===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=se}),define(Q[54],J([0,1,238,135,24,87]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function M(E,S){const d={onUnknownOption:P=>{console.warn((0,A.localize)(0,null,P))},onMultipleValues:(P,I)=>{console.warn((0,A.localize)(1,null,P,I))}},g=(0,b.parseArgs)(E,b.OPTIONS,S?d:void 0);return g.goto&&g._.forEach(P=>m(/^(\w:)?[^:]+(:\d*){0,2}$/.test(P),(0,A.localize)(2,null))),g["max-memory"]&&m(parseInt(g["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function r(E){const S=E.findIndex(d=>!/^-/.test(d));if(S>-1)return[...E.slice(0,S),...E.slice(S+1)]}function w(E){let[,...S]=E;process.env.VSCODE_DEV&&(S=r(S)||[]);const d=!y(process.env);return M(S,d)}e.parseMainProcessArgv=w;function p(E){const[,,...S]=E;return M(S,!0)}e.parseCLIProcessArgv=p;function n(E,...S){const d=E.indexOf("--");return d===-1?E.push(...S):E.splice(d,0,...S),E}e.addArg=n;function y(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=y}),define(Q[90],J([0,1,158,45,28,3,54,66,130]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function p(E,S,d){return S["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,M.isLaunchedFromCli)(d)&&!S["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,M.isLaunchedFromCli)(d)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=y(E)),n)}e.resolveShellEnv=p;let n;async function y(E){const S=new Promise(async(d,g)=>{const P=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",P);const I=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",I);const o=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),l=new RegExp(o+"(.*)"+o),a=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});E.trace("getUnixShellEnvironment#env",a);const u=await(0,w.getSystemShell)(b.OS,a);E.trace("getUnixShellEnvironment#shell",u);const t=m.basename(u);let i,s;/^pwsh(-preview)?$/.test(t)?(i=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,s=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,s=["-ilc"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),i);const c=(0,A.spawn)(u,[...s,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});c.on("error",v=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(v)),d({})});const h=[];c.stdout.on("data",v=>h.push(v));const f=[];c.stderr.on("data",v=>f.push(v)),c.on("close",(v,D)=>{const T=Buffer.concat(h).toString("utf8");E.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&E.trace("getUnixShellEnvironment#stderr",U),v||D)return g(new Error(`Failed to get environment (code ${v}, signal ${D})`));const H=l.exec(T),X=H?H[1]:"{}";try{const te=JSON.parse(X);P?te.ELECTRON_RUN_AS_NODE=P:delete te.ELECTRON_RUN_AS_NODE,I?te.ELECTRON_NO_ATTACH_CONSOLE=I:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",te),d(te)}catch(te){E.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(te)),g(te)}})});try{return await S}catch(d){return E.error("getUnixShellEnvironment#error",(0,r.toErrorMessage)(d)),{}}}}),define(Q[91],J([0,1,8,24,3]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function b(w){return w.map(p=>({type:p.type,resource:m.URI.file(p.path)}))}e.toFileChanges=b;function M(w){const p=new r;for(const n of w)p.processEvent(n);return p.normalize()}e.normalizeFileChanges=M;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const n=this.mapPathToChange.get(p.path);if(n){const y=n.type,E=p.type;y===1&&E===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(n),1)):y===2&&E===1?n.type=0:y===1&&E===0||(n.type=E)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],n=[];return this.normalized.filter(y=>y.type!==2?(p.push(y),!1):!0).sort((y,E)=>y.path.length-E.path.length).filter(y=>n.some(E=>(0,A.isParent)(y.path,E,!L.isLinux))?!1:(n.push(y.path),!0)).concat(p)}}}),define(Q[171],J([0,1,91,2,16,113,117,9,7]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends A.Disposable{constructor(y,E,S,d){super();this.path=y,this.onDidFilesChange=E,this.onLogMessage=S,this.verboseLogging=d,this.fileChangesDelayer=this._register(new r.ThrottledDelayer(M.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(y){this.verboseLogging=y}async startWatching(){try{const{stat:y,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(E)try{S=await(0,b.realpath)(S)}catch(d){if(this.onError(d),E.dangling)return}y.isDirectory()?this._register((0,M.watchFolder)(S,(d,g)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(g))})},d=>this.onError(d))):this._register((0,M.watchFile)(S,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(y){y.code!=="ENOENT"&&this.onError(y)}}onFileChange(y){this.fileChangesBuffer.push(y),this.verboseLogging&&this.onVerbose(`${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,m.normalizeFileChanges)(E);this.verboseLogging&&S.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),S.length>0&&this.onDidFilesChange(S)})}onError(y){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${y}`})}onVerbose(y){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${y}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(Q[70],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class m{constructor(...L){this._entries=new Map;for(let[b,M]of L)this.set(b,M)}set(L,b){const M=this._entries.get(L);return this._entries.set(L,b),M}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=m}),define(Q[172],J([0,1,19,166,68,4,70,9]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class p extends Error{constructor(d){var g;super("cyclic dependency between services");this.message=(g=d.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new M.ServiceCollection,g=!1,P){this._activeInstantiations=new Set,this._services=d,this._strict=g,this._parent=P,this._services.set(b.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...g){let P=E.traceInvocation(d),I=!1;try{return d({get:(l,a)=>{if(I)throw(0,m.illegalState)("service accessor is only valid during the invocation of its target method");const u=this._getOrCreateServiceInstance(l,P);if(!u&&a!==b.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return u}},...g)}finally{I=!0,P.stop()}}createInstance(d,...g){let P,I;return d instanceof L.SyncDescriptor?(P=E.traceCreation(d.ctor),I=this._createInstance(d.ctor,d.staticArguments.concat(g),P)):(P=E.traceCreation(d),I=this._createInstance(d,g,P)),P.stop(),I}_createInstance(d,g=[],P){let I=b._util.getServiceDependencies(d).sort((a,u)=>a.index-u.index),o=[];for(const a of I){let u=this._getOrCreateServiceInstance(a.id,P);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);o.push(u)}let l=I.length>0?I[0].index:g.length;if(g.length!==l){console.warn(`[createInstance] First service dependency of ${d.name} at position ${l+1} conflicts with ${g.length} static arguments`);let a=l-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,l)}return new d(...[...g,...o])}_setServiceInstance(d,g){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,g);else if(this._parent)this._parent._setServiceInstance(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let g=this._services.get(d);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):g}_getOrCreateServiceInstance(d,g){let P=this._getServiceInstanceOrDescriptor(d);return P instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,P,g.branch(d,!0)):(g.branch(d,!1),P)}_safeCreateAndCacheServiceInstance(d,g,P){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,g,P)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,g,P){const I=new A.Graph(a=>a.id.toString());let o=0;const l=[{id:d,desc:g,_trace:P}];for(;l.length;){const a=l.pop();if(I.lookupOrInsertNode(a),o++>1e3)throw new p(I);for(let u of b._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(u.id);if(!t&&!u.optional&&console.warn(`[createInstance] ${d} depends on ${u.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const i={id:u.id,desc:t,_trace:a._trace.branch(u.id,!0)};I.insertEdge(a,i),l.push(i)}}}for(;;){const a=I.roots();if(a.length===0){if(!I.isEmpty())throw new p(I);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,i)}I.removeNode(u)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,g,P=[],I,o){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(g,P,I,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,g,P,I,o);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(d,g=[],P,I){if(P){const o=new r.IdleValue(()=>this._createInstance(d,g,I));return new Proxy(Object.create(null),{get(l,a){if(a in l)return l[a];let u=o.value,t=u[a];return typeof t!="function"||(t=t.bind(u),l[a]=t),t},set(l,a,u){return o.value[a]=u,!0}})}else return this._createInstance(d,g,I)}}e.InstantiationService=n;var y;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(y||(y={}));class E{constructor(d,g){this.type=d,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return w?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return w?new E(0,d.name):E._None}branch(d,g){let P=new E(2,d.toString());return this._dep.push([d,g,P]),P}stop(){let d=Date.now()-this._start;E._totals+=d;let g=!1;function P(o,l){let a=[],u=new Array(o+1).join("	");for(const[t,i,s]of l._dep)if(i&&s){g=!0,a.push(`${u}CREATES -> ${t}`);let c=P(o+1,s);c&&a.push(c)}else a.push(`${u}uses -> ${t}`);return a.join(`
`)}let I=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${P(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||g)&&console.log(I.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[173],J([0,1,19,128,57]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class b extends L.ResolvedKeybinding{constructor(r,w){super();if(w.length===0)throw(0,m.illegalArgument)("parts");this._os=r,this._parts=w}getLabel(){return A.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return A.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:A.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return A.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new L.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=b}),define(Q[174],J([0,1,57,173]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends A.BaseResolvedKeybinding{constructor(M,r){super(r,M.parts)}_keyCodeToUILabel(M){if(this._os===2)switch(M){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return m.KeyCodeUtils.toString(M)}_getLabel(M){return M.isDuplicateModifierCase()?"":this._keyCodeToUILabel(M.keyCode)}_getAriaLabel(M){return M.isDuplicateModifierCase()?"":m.KeyCodeUtils.toString(M.keyCode)}_keyCodeToElectronAccelerator(M){if(M>=93&&M<=108)return null;switch(M){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return m.KeyCodeUtils.toString(M)}_getElectronAccelerator(M){return M.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(M.keyCode)}_getUserSettingsLabel(M){if(M.isDuplicateModifierCase())return"";const r=m.KeyCodeUtils.toUserSettingsUS(M.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(M){return L.getDispatchStr(M)}static getDispatchStr(M){if(M.isModifierKey())return null;let r="";return M.ctrlKey&&(r+="ctrl+"),M.shiftKey&&(r+="shift+"),M.altKey&&(r+="alt+"),M.metaKey&&(r+="meta+"),r+=m.KeyCodeUtils.toString(M.keyCode),r}_getSingleModifierDispatchPart(M){return M.keyCode===5&&!M.shiftKey&&!M.altKey&&!M.metaKey?"ctrl":M.keyCode===4&&!M.ctrlKey&&!M.altKey&&!M.metaKey?"shift":M.keyCode===6&&!M.ctrlKey&&!M.shiftKey&&!M.metaKey?"alt":M.keyCode===57&&!M.ctrlKey&&!M.shiftKey&&!M.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(Q[175],J([0,1,9]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function A(L,b){if(L.length===0)return Promise.resolve(!1);const M=[];let r=!1;for(let w of L){if(w===!0)return Promise.resolve(!0);(0,m.isThenable)(w)&&M.push(w.then(p=>{p&&(r=!0)},p=>{b(p),r=!0}))}return m.Promises.settled(M).then(()=>r)}e.handleVetos=A}),define(Q[6],J([0,1,4,2,3,5,66]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function r(){return new Date().toISOString()}var w;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class p extends A.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class n extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let c=t[s];if(typeof c=="object")try{c=JSON.stringify(c)}catch(h){}i+=(s>0?" ":"")+c}return i}}e.AbstractMessageLogger=n;class y extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}debug(t,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}info(t,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}warn(t,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,t,...i):console.warn(`[main ${r()}]`,t,...i))}error(t,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}critical(t,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class E extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class S extends p{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,M.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class d extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class g extends A.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=g;class P extends A.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?w.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class I{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=I;function o(u){if(u.verbose)return w.Trace;if(typeof u.logLevel=="string"){const t=l(u.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function l(u){switch(u){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=l;function a(u){switch(u){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=a}),define(Q[92],J([0,1,6]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function A(b,M){switch(M){case m.LogLevel.Trace:return b.trace;case m.LogLevel.Debug:return b.debug;case m.LogLevel.Info:return b.info;case m.LogLevel.Warning:return b.warn;case m.LogLevel.Error:return b.error;case m.LogLevel.Critical:return b.critical;default:throw new Error("Invalid log level")}}class L extends m.AbstractLogger{constructor(M=m.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(M){this._logger=M;for(const{level:r,args:w}of this.buffer)A(M,r).apply(M,w);this.buffer=[]}_log(M,...r){this._logger?A(this._logger,M).apply(this._logger,r):this.getLevel()<=M&&this.buffer.push({level:M,args:r})}trace(M,...r){this._log(m.LogLevel.Trace,M,...r)}debug(M,...r){this._log(m.LogLevel.Debug,M,...r)}info(M,...r){this._log(m.LogLevel.Info,M,...r)}warn(M,...r){this._log(m.LogLevel.Warning,M,...r)}error(M,...r){this._log(m.LogLevel.Error,M,...r)}critical(M,...r){this._log(m.LogLevel.Critical,M,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L});var ee=this&&this.__param||function(j,e){return function(m,A){e(m,A,j)}};define(Q[176],J([0,1,6,24,9,23,15,4,92]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*A.ByteSize.MB;let n=class extends m.AbstractLogger{constructor(S,d,g,P){super();this.name=S,this.resource=d,this.fileService=P,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=m.LogLevel.Trace&&this._log(m.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=m.LogLevel.Debug&&this._log(m.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=m.LogLevel.Info&&this._log(m.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=m.LogLevel.Warning&&this._log(m.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=m.LogLevel.Error){const S=arguments[0];if(S instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=S.stack,this._log(m.LogLevel.Error,this.format(d))}else this._log(m.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=m.LogLevel.Critical&&this._log(m.LogLevel.Critical,this.format(arguments))}flush(){}log(S,d){this._log(S,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(S){if(S.fileOperationResult!==3)throw S}}_log(S,d){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>p&&(await this.fileService.writeFile(this.getBackupResource(),b.VSBuffer.fromString(g)),g=""),g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(S)}] ${d}
`,await this.fileService.writeFile(this.resource,b.VSBuffer.fromString(g))})}getCurrentTimestamp(){const S=P=>P<10?`0${P}`:P,d=P=>P<10?`00${P}`:P<100?`0${P}`:P,g=new Date;return`${g.getFullYear()}-${S(g.getMonth()+1)}-${S(g.getDate())} ${S(g.getHours())}:${S(g.getMinutes())}:${S(g.getSeconds())}.${d(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,M.joinPath)((0,M.dirname)(this.resource),`${(0,M.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(S){return""}}stringifyLogLevel(S){switch(S){case m.LogLevel.Critical:return"critical";case m.LogLevel.Debug:return"debug";case m.LogLevel.Error:return"error";case m.LogLevel.Info:return"info";case m.LogLevel.Trace:return"trace";case m.LogLevel.Warning:return"warning"}return""}format(S){let d="";for(let g=0;g<S.length;g++){let P=S[g];if(typeof P=="object")try{P=JSON.stringify(P)}catch(I){}d+=(g>0?" ":"")+P}return d}};n=ce([ee(3,A.IFileService)],n),e.FileLogger=n;let y=class extends m.AbstractLoggerService{constructor(S,d,g){super(S.getLevel(),S.onDidChangeLogLevel);this.instantiationService=d,this.fileService=g}doCreateLogger(S,d){const g=new w.BufferLogService(d);return(0,A.whenProviderRegistered)(S,this.fileService).then(()=>g.logger=this.instantiationService.createInstance(n,(0,M.basename)(S),S,g.getLevel())),g}};y=ce([ee(0,m.ILogService),ee(1,r.IInstantiationService),ee(2,A.IFileService)],y),e.FileLoggerService=y}),define(Q[177],J([0,1,6,5,8]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class b{constructor(E){this.service=E,this.onDidChangeLogLevel=A.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(E,S,d){switch(S){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=b;class M{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){M.setLevel(this.channel,E)}static setLevel(E,S){return E.call("setLevel",S)}}e.LogLevelChannelClient=M;class r{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,S){throw new Error(`Event not found: ${S}`)}async call(E,S,d){switch(S){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${S}`)}createLogger(E,S){this.loggers.set(E.toString(),this.loggerService.createLogger(E,S))}consoleLog(E,S){let d=console.log;switch(E){case m.LogLevel.Error:d=console.error;break;case m.LogLevel.Warning:d=console.warn;break;case m.LogLevel.Info:d=console.info;break}d.call(console,...S)}log(E,S){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[g,P]of S)switch(g){case m.LogLevel.Trace:d.trace(P);break;case m.LogLevel.Debug:d.debug(P);break;case m.LogLevel.Info:d.info(P);break;case m.LogLevel.Warning:d.warn(P);break;case m.LogLevel.Error:d.error(P);break;case m.LogLevel.Critical:d.critical(P);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class w extends m.AbstractLoggerService{constructor(E,S,d){super(E,S);this.channel=d}createConsoleMainLogger(){return new m.AdapterLogger({log:(E,S)=>{this.channel.call("consoleLog",[E,S])}})}doCreateLogger(E,S,d){return new p(this.channel,E,S,d)}}e.LoggerChannelClient=w;class p extends m.AbstractMessageLogger{constructor(E,S,d,g){super(g==null?void 0:g.always);this.channel=E,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[S,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,S){const d=[[E,S]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class n extends m.LogService{constructor(E,S){super(S);this.parent=E,this._register(E.onDidChangeLogLevel(d=>S.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=n}),define(Q[93],J([0,1,6,24]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(w,p,n,y){try{const E=await new Promise((S,d)=>{j(["spdlog"],S,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(w,p,n,y)}catch(E){console.error(E)}return null}function b(w,p,n,y){return j.__$__nodeRequire("spdlog").createRotatingLogger(w,p,n,y)}e.createRotatingLogger=b;function M(w,p,n){switch(p){case m.LogLevel.Trace:w.trace(n);break;case m.LogLevel.Debug:w.debug(n);break;case m.LogLevel.Info:w.info(n);break;case m.LogLevel.Warning:w.warn(n);break;case m.LogLevel.Error:w.error(n);break;case m.LogLevel.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}}class r extends m.AbstractMessageLogger{constructor(p,n,y,E){super();this.name=p,this.filepath=n,this.rotating=y,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(S=>{this._logger&&this._logger.setLevel(S)}))}_createSpdLogLogger(){const p=this.rotating?6:1,n=30/p*A.ByteSize.MB;return L(this.name,this.filepath,n,p).then(y=>{if(y){this._logger=y,this._logger.setLevel(this.getLevel());for(const{level:E,message:S}of this.buffer)M(this._logger,E,S);this.buffer=[]}})}log(p,n){this._logger?M(this._logger,p,n):this.getLevel()<=p&&this.buffer.push({level:p,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(Q[178],J([0,1,6,15,10,176,93,24,28]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends m.AbstractLoggerService{constructor(y,E){super(y.getLevel(),y.onDidChangeLogLevel);this.fileService=E}doCreateLogger(y,E,S){var d;if(y.scheme===L.Schemas.file){const g=new M.SpdLogLogger((S==null?void 0:S.name)||(0,w.generateUuid)(),y.fsPath,!(S==null?void 0:S.donotRotate),E);return(S==null?void 0:S.donotUseFormatters)&&g.clearFormatters(),g}else return new b.FileLogger((d=S==null?void 0:S.name)!==null&&d!==void 0?d:(0,A.basename)(y),y,E,this.fileService)}};p=ce([ee(0,m.ILogService),ee(1,r.IFileService)],p),e.LoggerService=p}),define(Q[179],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function m(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=m;function A(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=A;function L(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function b(M){return!m(M)&&!A(M)&&!L(M)}e.isMenubarMenuItemAction=b}),define(Q[46],J([0,1,10,3,32,15]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof A.globals.vscode!="undefined"){const r=A.globals.vscode.context.configuration();if(r)M=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(j==null?void 0:j.__$__nodeRequire)=="function"){const r=(0,b.dirname)(m.FileAccess.asFileUri("",j));M=j.__$__nodeRequire((0,b.joinPath)(r,"product.json").fsPath);const w=j.__$__nodeRequire((0,b.joinPath)(r,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`}),Object.assign(M,{version:w.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.57.0-dev",nameShort:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:A.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=M}),define(Q[94],J([0,1,141,23,24,19,46]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(y,E,S,d,g,P){let I;try{await w(y,E,S,d,g,P)}catch(o){I=o}finally{I&&g.errorTransformer&&(I=g.errorTransformer(I)),typeof I!="undefined"&&S.error(I),S.end()}}e.readFileIntoStream=r;async function w(y,E,S,d,g,P){p(P);const I=await y.open(E,{create:!1});try{p(P);let o=0,l=0,a=g&&typeof g.length=="number"?g.length:void 0,u=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),t=g&&typeof g.position=="number"?g.position:0,i=0;do l=await y.read(I,t,u.buffer,i,u.byteLength-i),t+=l,i+=l,o+=l,typeof a=="number"&&(a-=l),i===u.byteLength&&(await S.write(d(u)),u=A.VSBuffer.alloc(Math.min(g.bufferSize,typeof a=="number"?a:g.bufferSize)),i=0);while(l>0&&(typeof a!="number"||a>0)&&p(P)&&n(o,g));if(i>0){let s=i;typeof a=="number"&&(s=Math.min(i,a)),S.write(d(u.slice(0,s)))}}catch(o){throw(0,L.ensureFileSystemProviderError)(o)}finally{await y.close(I)}}function p(y){if(y.isCancellationRequested)throw(0,b.canceled)();return!0}function n(y,E){if(E==null?void 0:E.limits){if(typeof E.limits.memory=="number"&&y>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,m.localize)(0,null,M.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&y>E.limits.size)throw(0,L.createFileSystemProviderError)((0,m.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[180],J([0,1,139,71,2,24,5,15,36,35,6,23,63,9,26,10,94,62]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends L.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new M.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new S.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,A.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const t=new L.DisposableStore;return t.add(u.onDidChangeFile(i=>this._onDidFilesChange.fire(new b.FileChangesEvent(i,!this.isPathCaseSensitive(u))))),t.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidErrorOccur=="function"&&t.add(u.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,L.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){u.push(t)}}),!this.provider.has(a)&&await S.Promises.settled(u)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,u){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,r.isAbsolutePath)(a))throw new b.FileOperationError((0,m.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const t=new Error;throw t.name="ENOPRO",t.message=(0,m.localize)(1,null,a.toString()),t}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(u)||(0,b.hasReadWriteCapability)(u)||(0,b.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,b.hasOpenReadWriteCloseCapability)(u)||(0,b.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(t){throw(0,b.toFileSystemProviderErrorCode)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.FileOperationError((0,m.localize)(2,null,this.resourceForError(a)),1):(0,b.ensureFileSystemProviderError)(t)}}async doResolveFile(a,u){const t=await this.withProvider(a),i=this.isPathCaseSensitive(t),s=u==null?void 0:u.resolveTo,c=u==null?void 0:u.resolveSingleChildDescendants,h=u==null?void 0:u.resolveMetadata,f=await t.stat(a);let v;return this.toFileStat(t,a,f,void 0,!!h,(D,T)=>(v||(v=w.TernarySearchTree.forUris(()=>!i),v.set(a,!0),(0,p.isNonEmptyArray)(s)&&s.forEach(U=>v.set(U,!0))),Boolean(v.findSuperstr(D.resource)||v.get(D.resource))?!0:D.isDirectory&&c?T===1:!1))}async toFileStat(a,u,t,i,s,c){const{providerExtUri:h}=this.getExtUri(a),f={resource:u,name:h.basename(u),isFile:(t.type&b.FileType.File)!=0,isDirectory:(t.type&b.FileType.Directory)!=0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,b.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&c(f,i)){try{const v=await a.readdir(u),D=await S.Promises.settled(v.map(async([T,U])=>{try{const H=h.joinPath(u,T),X=s?await a.stat(H):{type:U};return await this.toFileStat(a,H,X,v.length,s,c)}catch(H){return this.logService.trace(H),null}}));f.children=(0,p.coalesce)(D)}catch(v){this.logService.trace(v),f.children=[]}return f}return f}async resolveAll(a){return S.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(t){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(t){return t}return!0}async doValidateCreateFile(a,u){if(!(u==null?void 0:u.overwrite)&&await this.exists(a))throw new b.FileOperationError((0,m.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=y.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const i=await this.writeFile(a,u);return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,i)),i}async writeFile(a,u,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,a,t)||await this.mkdirp(i,s.dirname(a));let h;if((0,b.hasReadWriteCapability)(i)&&!(u instanceof y.VSBuffer))if((0,E.isReadableStream)(u)){const f=await(0,E.peekStream)(u,3);f.ended?h=y.VSBuffer.concat(f.buffer):h=f}else h=(0,E.peekReadable)(u,f=>y.VSBuffer.concat(f),3);else h=u;!(0,b.hasOpenReadWriteCloseCapability)(i)||(0,b.hasReadWriteCapability)(i)&&h instanceof y.VSBuffer?await this.doWriteUnbuffered(i,a,t,h):await this.doWriteBuffered(i,a,t,h instanceof y.VSBuffer?(0,y.bufferToReadable)(h):h)}catch(c){throw new b.FileOperationError((0,m.localize)(4,null,this.resourceForError(a),(0,b.ensureFileSystemProviderError)(c).toString()),(0,b.toFileOperationResult)(c),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(u)));let s;try{s=await a.stat(u)}catch(c){return}if((s.type&b.FileType.Directory)!=0)throw new b.FileOperationError((0,m.localize)(6,null,this.resourceForError(u)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,b.etag)({mtime:t.mtime,size:s.size}))throw new b.FileOperationError((0,m.localize)(7,null),3,t);return s}async readFile(a,u){const t=await this.withReadProvider(a);return(u==null?void 0:u.atomic)?this.doReadFileAtomic(t,a,u):this.doReadFile(t,a,u)}async doReadFileAtomic(a,u,t){return new Promise((i,s)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(a,u,t);i(c)}catch(c){s(c)}})})}async doReadFile(a,u,t){const i=await this.doReadFileStream(a,u,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,y.streamToBuffer)(i.value)})}async readFileStream(a,u){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,u)}async doReadFileStream(a,u,t){const i=new d.CancellationTokenSource,s=this.validateReadFile(u,t).then(h=>h,h=>{throw i.cancel(),h});let c;try{t&&typeof t.etag=="string"&&t.etag!==b.ETAG_DISABLED&&await s,!((0,b.hasOpenReadWriteCloseCapability)(a)||(0,b.hasFileReadStreamCapability)(a))||(0,b.hasReadWriteCapability)(a)&&(t==null?void 0:t.preferUnbuffered)?c=this.readFileUnbuffered(a,u,t):(0,b.hasFileReadStreamCapability)(a)?c=this.readFileStreamed(a,u,i.token,t):c=this.readFileBuffered(a,u,i.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:c})}catch(h){throw c&&await(0,E.consumeStream)(c),new b.FileOperationError((0,m.localize)(8,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(h).toString()),(0,b.toFileOperationResult)(h),t)}}readFileStreamed(a,u,t,i=Object.create(null)){const s=a.readFileStream(u,i,t);return(0,E.transform)(s,{data:c=>c instanceof y.VSBuffer?c:y.VSBuffer.wrap(c),error:c=>new b.FileOperationError((0,m.localize)(9,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(c).toString()),(0,b.toFileOperationResult)(c),i)},c=>y.VSBuffer.concat(c))}readFileBuffered(a,u,t,i=Object.create(null)){const s=(0,y.newWriteableBufferStream)();return(0,P.readFileIntoStream)(a,u,s,c=>c,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:c=>new b.FileOperationError((0,m.localize)(10,null,this.resourceForError(u),(0,b.ensureFileSystemProviderError)(c).toString()),(0,b.toFileOperationResult)(c),i)}),t),s}readFileUnbuffered(a,u,t){const i=(0,E.newWriteableStream)(s=>y.VSBuffer.concat(s));return(async()=>{try{let s=await a.readFile(u);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(u,s.byteLength,t),i.end(y.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(a,u){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new b.FileOperationError((0,m.localize)(11,null,this.resourceForError(a)),0,u);if(u&&typeof u.etag=="string"&&u.etag!==b.ETAG_DISABLED&&u.etag===t.etag)throw new b.FileOperationError((0,m.localize)(12,null),2,u);return this.validateReadFileLimits(a,t.size,u),t}validateReadFileLimits(a,u,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&u>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&u>t.limits.size&&(i=7),typeof i=="number")throw new b.FileOperationError((0,m.localize)(13,null,this.resourceForError(a)),i)}}async canMove(a,u,t){return this.doCanMoveCopy(a,u,"move",t)}async canCopy(a,u,t){return this.doCanMoveCopy(a,u,"copy",t)}async doCanMoveCopy(a,u,t,i){if(a.toString()!==u.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),c=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(s,a,c,u,t,i)}catch(s){return s}return!0}async move(a,u,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),c=await this.doMoveCopy(i,a,s,u,"move",!!t),h=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,c==="move"?2:3,h)),h}async copy(a,u,t){const i=await this.withReadProvider(a),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),c=await this.doMoveCopy(i,a,s,u,"copy",!!t),h=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,c==="copy"?3:2,h)),h}async doMoveCopy(a,u,t,i,s,c){if(u.toString()===i.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(a,u,t,i,s,c);if(h&&!f&&c&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(a===t&&(0,b.hasFileFolderCopyCapability)(a))await a.copy(u,i,{overwrite:c});else{const v=await this.resolve(u);v.isDirectory?await this.doCopyFolder(a,v,t,i):await this.doCopyFile(a,u,t,i)}return s}else return a===t?(await a.rename(u,i,{overwrite:c}),s):(await this.doMoveCopy(a,u,t,i,"copy",c),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,t,i){if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,u,t,i);if((0,b.hasOpenReadWriteCloseCapability)(a)&&(0,b.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,u,t,i);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,u,t,i);if((0,b.hasReadWriteCapability)(a)&&(0,b.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,u,t,i)}async doCopyFolder(a,u,t,i){await t.mkdir(i),Array.isArray(u.children)&&await S.Promises.settled(u.children.map(async s=>{const c=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(a,await this.resolve(s.resource),t,c):this.doCopyFile(a,s.resource,t,c)}))}async doValidateMoveCopy(a,u,t,i,s,c){let h=!1;if(a===t){const{providerExtUri:v,isPathCaseSensitive:D}=this.getExtUri(a);if(D||(h=v.isEqual(u,i)),h&&s==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(u),this.resourceForError(i)));if(!h&&v.isEqualOrParent(i,u))throw new Error((0,m.localize)(15,null,this.resourceForError(u),this.resourceForError(i)))}const f=await this.exists(i);if(f&&!h){if(!c)throw new b.FileOperationError((0,m.localize)(16,null,this.resourceForError(u),this.resourceForError(i)),4);if(a===t){const{providerExtUri:v}=this.getExtUri(a);if(v.isEqualOrParent(u,i))throw new Error((0,m.localize)(17,null,this.resourceForError(u),this.resourceForError(i)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?r.extUri:r.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new b.FileOperationEvent(a,0,t)),t}async mkdirp(a,u){const t=[],{providerExtUri:i}=this.getExtUri(a);for(;!i.isEqual(u,i.dirname(u));)try{if(((await a.stat(u)).type&b.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(u)));break}catch(s){if((0,b.toFileSystemProviderErrorCode)(s)!==b.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(u)),u=i.dirname(u)}for(let s=t.length-1;s>=0;s--){u=i.joinPath(u,t[s]);try{await a.mkdir(u)}catch(c){if((0,b.toFileSystemProviderErrorCode)(c)!==b.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(t){return t}return!0}async doValidateDelete(a,u){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(u==null?void 0:u.useTrash)&&!(t.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(a)));const s=await this.exists(a);if(!s)throw new b.FileOperationError((0,m.localize)(20,null,this.resourceForError(a)),1);if(!!!(u==null?void 0:u.recursive)&&s){const h=await this.resolve(a);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(a)))}return t}async del(a,u){const t=await this.doValidateDelete(a,u),i=!!(u==null?void 0:u.useTrash),s=!!(u==null?void 0:u.recursive);await t.delete(a,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new b.FileOperationEvent(a,1))}watch(a,u={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(a,u).then(s=>{t?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>i())}async doWatch(a,u){const t=await this.withProvider(a),i=this.toWatchKey(t,a,u),s=this.activeWatchers.get(i)||{count:0,disposable:t.watch(a,u)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(a,u,t){const{providerExtUri:i}=this.getExtUri(a);return[i.getComparisonKey(u),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,L.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,u,t,i){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{var s;const c=await a.open(u,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(a,c,i):await this.doWriteReadableBufferedQueued(a,c,i)}catch(h){throw(0,b.ensureFileSystemProviderError)(h)}finally{await a.close(c)}})}async doWriteStreamBufferedQueued(a,u,t){let i=0,s;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const c=y.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,u,c,c.byteLength,i,0),i+=c.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(c,h)=>{(0,E.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(a,u,f,f.byteLength,i,0)}catch(v){return h(v)}i+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>c()})})}async doWriteReadableBufferedQueued(a,u,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(a,u,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(a,u,t,i,s,c){let h=0;for(;h<i;)h+=await a.write(u,s+h,t.buffer,c+h,i-h)}async doWriteUnbuffered(a,u,t,i){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,t,i))}async doWriteUnbufferedQueued(a,u,t,i){var s;let c;i instanceof y.VSBuffer?c=i:(0,E.isReadableStream)(i)?c=await(0,y.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?c=await(0,y.bufferedStreamToBuffer)(i):c=(0,y.readableToBuffer)(i),await a.writeFile(u,c.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(a,u,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,t,i))}async doPipeBufferedQueued(a,u,t,i){let s,c;try{s=await a.open(u,{create:!1}),c=await t.open(i,{create:!0,unlock:!1});const h=y.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,v=0,D=0;do D=await a.read(s,f,h.buffer,v,h.byteLength-v),await this.doWriteBuffer(t,c,h,D,f,v),f+=D,v+=D,v===h.byteLength&&(v=0);while(D>0)}catch(h){throw(0,b.ensureFileSystemProviderError)(h)}finally{await S.Promises.settled([typeof s=="number"?a.close(s):Promise.resolve(),typeof c=="number"?t.close(c):Promise.resolve()])}}async doPipeUnbuffered(a,u,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,t,i))}async doPipeUnbufferedQueued(a,u,t,i){return t.writeFile(i,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,t,i))}async doPipeUnbufferedToBufferedQueued(a,u,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const c=await a.readFile(u);await this.doWriteBuffer(t,s,y.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,b.ensureFileSystemProviderError)(c)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(a,u,t,i){const s=await(0,y.streamToBuffer)(this.readFileBuffered(a,u,d.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new b.FileOperationError((0,m.localize)(22,null,this.resourceForError(u)),6);return a}resourceForError(a){return a.scheme===g.Schemas.file?a.fsPath:a.toString(!0)}};o=ce([ee(0,n.ILogService)],o),e.FileService=o}),define(Q[181],J([0,1,20,114,2,24,5,3,16,7,15,30,9,6,142,91,163,165,162,171,63,94,35,23]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(h,f){var v;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((v=this.options)===null||v===void 0?void 0:v.bufferSize)||64*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,r.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:v}=await w.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,v),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,w.readdir)(this.toFilePath(h),{withFileTypes:!0}),v=[];return await Promise.all(f.map(async D=>{try{let T;D.isSymbolicLink()?T=(await this.stat((0,n.joinPath)(h,D.name))).type:T=this.toType(D),v.push([D.name,T])}catch(T){this.logService.trace(T)}})),v}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let v;return(f==null?void 0:f.dangling)?v=b.FileType.Unknown:h.isFile()?v=b.FileType.File:h.isDirectory()?v=b.FileType.Directory:v=b.FileType.Unknown,f&&(v|=b.FileType.SymbolicLink),v}async readFile(h){try{const f=this.toFilePath(h);return await m.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,v){const D=(0,a.newWriteableStream)(T=>i.VSBuffer.concat(T.map(U=>i.VSBuffer.wrap(U))).buffer);return(0,u.readFileIntoStream)(this,h,D,T=>T.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),v),D}async writeFile(h,f,v){let D;try{const T=this.toFilePath(h);if(!v.create||!v.overwrite){if(await(0,w.exists)(T)){if(!v.overwrite)throw(0,b.createFileSystemProviderError)((0,d.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!v.create)throw(0,b.createFileSystemProviderError)((0,d.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(h,{create:!0,unlock:v.unlock}),await this.write(D,0,f,0,f.byteLength)}catch(T){throw await this.toFileSystemProviderWriteError(h,T)}finally{typeof D=="number"&&await this.close(D)}}async open(h,f){try{const v=this.toFilePath(h);if((0,b.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await w.SymlinkSupport.stat(v);U.mode&128||await m.promises.chmod(v,U.mode|128)}catch(U){this.logService.trace(U)}let D;if((0,b.isFileOpenForWriteOptions)(f)){if(r.isWindows)try{await m.promises.truncate(v,0),D="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}D||(D="w")}else D="r";const T=await(0,A.promisify)(m.open)(v,D);return this.mapHandleToPos.set(T,0),(0,b.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(T,h),T}catch(v){throw(0,b.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,v):this.toFileSystemProviderError(v)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,A.promisify)(m.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,A.promisify)(m.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,v,D,T){const U=this.normalizePos(h,f);let H=null;try{const X=await(0,A.promisify)(m.read)(h,v,D,T,U);return typeof X=="number"?H=X:H=X.bytesRead,H}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(h,U,H)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,v){const D=this.mapHandleToPos.get(h);typeof D=="number"&&(typeof f=="number"||(typeof v=="number"?this.mapHandleToPos.set(h,D+v):this.mapHandleToPos.delete(h)))}async write(h,f,v,D,T){return(0,E.retry)(()=>this.doWrite(h,f,v,D,T),100,3)}async doWrite(h,f,v,D,T){const U=this.normalizePos(h,f);let H=null;try{const X=await(0,A.promisify)(m.write)(h,v,D,T,U);return typeof X=="number"?H=X:H=X.bytesWritten,H}catch(X){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),X)}finally{this.updatePos(h,U,H)}}async mkdir(h){try{await m.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const v=this.toFilePath(h);await this.doDelete(v,f)}catch(v){throw this.toFileSystemProviderError(v)}}async doDelete(h,f){f.recursive?await(0,w.rimraf)(h,w.RimRafMode.MOVE):await m.promises.unlink(h)}async rename(h,f,v){const D=this.toFilePath(h),T=this.toFilePath(f);if(D!==T)try{await this.validateTargetDeleted(h,f,"move",v.overwrite),await(0,w.move)(D,T)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,p.basename)(D),(0,p.basename)((0,p.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(h,f,v){const D=this.toFilePath(h),T=this.toFilePath(f);if(D!==T)try{await this.validateTargetDeleted(h,f,"copy",v.overwrite),await(0,w.copy)(D,T,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,p.basename)(D),(0,p.basename)((0,p.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(h,f,v,D){const T=this.toFilePath(h),U=this.toFilePath(f);let H=!1;if(!!(this.capabilities&1024)||(H=(0,y.isEqual)(T,U,!0)),H&&v==="copy")throw(0,b.createFileSystemProviderError)((0,d.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(!H&&await(0,w.exists)(U)){if(!D)throw(0,b.createFileSystemProviderError)((0,d.localize)(5,null),b.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const v={path:this.toFilePath(h),excludes:f},D=(0,t.insert)(this.recursiveFoldersToWatch,v);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{D(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,v;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let D,T;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(D=P.FileWatcher,T=(v=this.options)===null||v===void 0?void 0:v.watcher):this.recursiveFoldersToWatch.length===1?r.isWindows?D=I.FileWatcher:D=P.FileWatcher:D=o.FileWatcher,this.recursiveWatcher=new D(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,g.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===S.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new l.FileWatcher(this.toFilePath(h),D=>this._onDidChangeFile.fire((0,g.toFileChanges)(D)),D=>{D.type==="error"&&this._onDidWatchErrorOccur.fire(D.message),this.logService[D.type](D.message)},this.logService.getLevel()===S.LogLevel.Trace),v=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===S.LogLevel.Trace)});return(0,L.combinedDisposable)(f,v)}toFilePath(h){return(0,p.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof b.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=b.FileSystemProviderErrorCode.NoPermissions;break;default:f=b.FileSystemProviderErrorCode.Unknown}return(0,b.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let v=this.toFileSystemProviderError(f);if(h&&v.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:D}=await w.SymlinkSupport.stat(this.toFilePath(h));D.mode&128||(v=(0,b.createFileSystemProviderError)(f,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(D){this.logService.trace(D)}return v}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Q[21],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,m.createDecorator)("productService")}),define(Q[182],J([0,1,58,6,21]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let b=class{constructor(r,w){this.productService=r,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(w);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,n,y]=p;let E=this.trustedExtensionUrlPublicKeys.get(r);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[r],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...E])}const S=Buffer.from(decodeURIComponent(y),"base64");if(S.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=S.slice(0,6),g=S.readUIntBE(0,6),P=Date.now()-g;if(P<0||P>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const I=S.slice(6),o=m.createVerify("SHA256");o.write(d),o.write(Buffer.from(n)),o.end();for(let l=0;l<E.length;l++){let a=E[l];if(a!==null){if(typeof a=="string")try{a=m.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),E[l]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${l+1} for ${r}:`,u),E[l]=null;continue}if(o.verify(a,I))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};b=ce([ee(0,L.IProductService),ee(1,A.ILogService)],b),e.ExtensionUrlTrustService=b}),define(Q[55],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,m.createDecorator)("protocolMainService")}),define(Q[183],J([0,1,2,10,8,53,14,6,36,3,15,28]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends m.Disposable{constructor(d,g){super();this.logService=g,this.validRoots=w.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(L.URI.file(d.appRoot)),this.addValidFileRoot(L.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=M.session;d.protocol.registerFileProtocol(A.Schemas.vscodeFileResource,(g,P)=>this.handleResourceRequest(g,P)),d.protocol.interceptFileProtocol(A.Schemas.file,(g,P)=>this.handleFileRequest(g,P)),this._register((0,m.toDisposable)(()=>{d.protocol.unregisterProtocol(A.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(A.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?m.Disposable.None:(this.validRoots.set(d,!0),(0,m.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,g){const P=L.URI.parse(d.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})):this.validRoots.findSubstr(P)?g({path:P.fsPath}):this.validExtensions.has((0,n.extname)(P))?g({path:P.fsPath}):(this.logService.error(`${A.Schemas.file}: Refused to load resource ${P.fsPath} from ${A.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3}))}handleResourceRequest(d,g){const P=L.URI.parse(d.url),I=A.FileAccess.asFileUri(P);return this.validRoots.findSubstr(I)?g({path:I.fsPath}):this.validExtensions.has((0,n.extname)(I))?g({path:I.fsPath}):(this.logService.error(`${A.Schemas.vscodeFileResource}: Refused to load resource ${I.fsPath} from ${A.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}createIPCObjectUrl(){let d;const g=L.URI.from({scheme:"vscode",path:(0,y.generateUuid)()}),P=g.toString(),I=async()=>d;return M.ipcMain.handle(P,I),this.logService.trace(`IPC Object URL: Registered new channel ${P}.`),{resource:g,update:o=>d=o,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${P}.`),M.ipcMain.removeHandler(P)}}}};E=ce([ee(0,b.INativeEnvironmentService),ee(1,r.ILogService)],E),e.ProtocolMainService=E}),define(Q[37],J([0,1,13,101]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(M,r){A.ok(m.isString(M)),A.ok(m.isObject(r)),A.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,r)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new L}),define(Q[184],J([0,1,37,5]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class b{constructor(){this._onDidChangeSchema=new A.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,p){this.schemasById[L(w)]=p,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new b;m.Registry.add(e.Extensions.JSONContribution,M)}),define(Q[47],J([0,1,132,5,37,13,184]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var r;(function(P){P[P.APPLICATION=1]="APPLICATION",P[P.MACHINE=2]="MACHINE",P[P.WINDOW=3]="WINDOW",P[P.RESOURCE=4]="RESOURCE",P[P.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",P[P.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(r=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=L.Registry.as(M.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new A.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new A.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:m.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(I,o=!0){this.registerConfigurations([I],o)}registerConfigurations(I,o=!0){const l=[];I.forEach(a=>{l.push(...this.validateAndRegisterProperties(a,o,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(I){const o=[],l=a=>{if(a.properties)for(const u in a.properties)o.push(u),delete this.configurationProperties[u],this.removeFromSchema(u,a.properties[u]);a.allOf&&a.allOf.forEach(u=>l(u))};for(const a of I){l(a);const u=this.configurationContributors.indexOf(a);u!==-1&&this.configurationContributors.splice(u,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(I){const o=[],l=[];for(const a of I)for(const u in a)if(o.push(u),e.OVERRIDE_PROPERTY_PATTERN.test(u)){this.defaultValues[u]=Object.assign(Object.assign({},this.defaultValues[u]||{}),a[u]);const t={type:"object",default:this.defaultValues[u],description:m.localize(1,null,u),$ref:e.resourceLanguageSettingsSchemaId};l.push(y(u)),this.configurationProperties[u]=t,this.defaultLanguageConfigurationOverridesNode.properties[u]=t}else{this.defaultValues[u]=a[u];const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(I){const o=[];for(const l of I)for(const a in l)if(o.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const u=this.configurationProperties[a];u&&(this.updatePropertyDefaultValue(a,u),this.updateSchema(a,u))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...I){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(I){for(const o of I)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(I,o=!0,l,a=3){var u;a=b.isUndefinedOrNull(I.scope)?a:I.scope;let t=[],i=I.properties;if(i)for(let c in i){if(o&&d(c)){delete i[c];continue}const h=i[c];if(this.updatePropertyDefaultValue(c,h),e.OVERRIDE_PROPERTY_PATTERN.test(c)?h.scope=void 0:(h.scope=b.isUndefinedOrNull(h.scope)?a:h.scope,h.restricted=b.isUndefinedOrNull(h.restricted)?!!((u=l==null?void 0:l.restrictedConfigurations)===null||u===void 0?void 0:u.includes(c)):h.restricted),i[c].hasOwnProperty("included")&&!i[c].included){this.excludedConfigurationProperties[c]=i[c],delete i[c];continue}else this.configurationProperties[c]=i[c];!i[c].deprecationMessage&&i[c].markdownDeprecationMessage&&(i[c].deprecationMessage=i[c].markdownDeprecationMessage),t.push(c)}let s=I.allOf;if(s)for(let c of s)t.push(...this.validateAndRegisterProperties(c,o,l,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(I){const o=l=>{let a=l.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let u=l.allOf;u&&u.forEach(o)};o(I)}updateSchema(I,o){switch(e.allSettings.properties[I]=o,o.scope){case 1:e.applicationSettings.properties[I]=o;break;case 2:e.machineSettings.properties[I]=o;break;case 6:e.machineOverridableSettings.properties[I]=o;break;case 3:e.windowSettings.properties[I]=o;break;case 4:e.resourceSettings.properties[I]=o;break;case 5:e.resourceSettings.properties[I]=o,this.resourceLanguageSettingsSchema.properties[I]=o;break}}removeFromSchema(I,o){switch(delete e.allSettings.properties[I],o.scope){case 1:delete e.applicationSettings.properties[I];break;case 2:delete e.machineSettings.properties[I];break;case 6:delete e.machineOverridableSettings.properties[I];break;case 3:delete e.windowSettings.properties[I];break;case 4:case 5:delete e.resourceSettings.properties[I];break}}updateOverridePropertyPatternKey(){for(const I of this.overrideIdentifiers.values()){const o=`[${I}]`,l={type:"object",description:m.localize(2,null),errorMessage:m.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,l),e.allSettings.properties[o]=l,e.applicationSettings.properties[o]=l,e.machineSettings.properties[o]=l,e.machineOverridableSettings.properties[o]=l,e.windowSettings.properties[o]=l,e.resourceSettings.properties[o]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(I,o){let l=this.defaultValues[I];b.isUndefined(l)&&(l=o.default),b.isUndefined(l)&&(l=E(o.type)),o.default=l}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function y(P){return P.substring(1,P.length-1)}e.overrideIdentifierFromKey=y;function E(P){switch(Array.isArray(P)?P[0]:P){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const S=new p;L.Registry.add(e.Extensions.Configuration,S);function d(P){return P.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(P)?m.localize(5,null,P):S.getConfigurationProperties()[P]!==void 0?m.localize(6,null,P):null:m.localize(4,null)}e.validateProperty=d;function g(){const P=[],I=S.getConfigurationProperties();for(const o of Object.keys(I))P.push([o,I[o].scope]);return P.push(["launch",4]),P.push(["task",4]),P}e.getScopes=g}),define(Q[17],J([0,1,44,13,8,37,4,47]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,M.createDecorator)("configurationService");function w(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.isConfigurationOverrides=w;var p;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function y(i,s){const c=s?i?s.keys.filter(H=>i.keys.indexOf(H)===-1):[...s.keys]:[],h=i?s?i.keys.filter(H=>s.keys.indexOf(H)===-1):[...i.keys]:[],f=[];if(s&&i){for(const H of i.keys)if(s.keys.indexOf(H)!==-1){const X=I(i.contents,H),te=I(s.contents,H);m.equals(X,te)||f.push(H)}}const v=[],D=H=>{const X={};for(const te of H)for(const se of te.identifiers)X[u(se)]=te;return X},T=s?D(s.overrides):{},U=i?D(i.overrides):{};if(Object.keys(T).length)for(const H of c){const X=T[H];X&&v.push([(0,r.overrideIdentifierFromKey)(H),X.keys])}if(Object.keys(U).length)for(const H of h){const X=U[H];X&&v.push([(0,r.overrideIdentifierFromKey)(H),X.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const H of f){const X=U[H],te=T[H];if(X&&te){const se=y({contents:X.contents,keys:X.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});v.push([(0,r.overrideIdentifierFromKey)(H),[...se.added,...se.removed,...se.updated]])}}return{added:c,removed:h,updated:f,overrides:v}}e.compare=y;function E(i,s){const c=[];for(const h of Object.keys(i))if(r.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const v in i[h])f[v]=i[h][v];c.push({identifiers:[(0,r.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:S(f,s)})}return c}e.toOverrides=E;function S(i,s){const c=Object.create(null);for(let h in i)d(c,h,i[h],s);return c}e.toValuesTree=S;function d(i,s,c,h){const f=s.split("."),v=f.pop();let D=i;for(let T=0;T<f.length;T++){let U=f[T],H=D[U];switch(typeof H){case"undefined":H=D[U]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(H)}`);return}D=H}if(typeof D=="object"&&D!==null)try{D[v]=c}catch(T){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(D)}`)}e.addToValueTree=d;function g(i,s){const c=s.split(".");P(i,c)}e.removeFromValueTree=g;function P(i,s){const c=s.shift();if(s.length===0){delete i[c];return}if(Object.keys(i).indexOf(c)!==-1){const h=i[c];typeof h=="object"&&!Array.isArray(h)&&(P(h,s),Object.keys(h).length===0&&delete i[c])}}function I(i,s,c){function h(D,T){let U=D;for(const H of T){if(typeof U!="object"||U===null)return;U=U[H]}return U}const f=s.split("."),v=h(i,f);return typeof v=="undefined"?c:v}e.getConfigurationValue=I;function o(i,s,c){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in i?A.isObject(i[h])&&A.isObject(s[h])?o(i[h],s[h],c):c&&(i[h]=s[h]):i[h]=s[h])})}e.merge=o;function l(){const i=b.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=l;function a(){const i=Object.create(null),s=b.Registry.as(r.Extensions.Configuration).getConfigurationProperties();for(let c in s){let h=s[c].default;d(i,c,h,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=a;function u(i){return`[${i}]`}e.keyFromOverrideIdentifier=u;function t(i,s,c){const h=i.inspect(s),f=i.inspect(c);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Q[185],J([0,1,43,36,35,13,44,8,47,17,37,2,5]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,p.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,p.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const c of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[c],f=i[c];f&&(typeof h=="object"&&typeof f=="object"?(h=M.deepClone(h),this.mergeContents(h,f)):h=f),s[c]=h}return new S(s,this.keys,this.overrides)}merge(...t){const i=M.deepClone(this.contents),s=M.deepClone(this.overrides),c=[...this.keys];for(const h of t){this.mergeContents(i,h.contents);for(const f of h.overrides){const[v]=s.filter(D=>L.equals(D.identifiers,f.identifiers));v?this.mergeContents(v.contents,f.contents):s.push(M.deepClone(f))}for(const f of h.keys)c.indexOf(f)===-1&&c.push(f)}return new S(i,c,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&b.isObject(t[s])&&b.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=M.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?M.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,p.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,p.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=S;class d extends S{constructor(){const t=(0,p.getDefaultValues)(),i=(0,p.getConfigurationKeys)(),s=[];for(const c of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(c)&&s.push({identifiers:[(0,w.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(t[c]),contents:(0,p.toValuesTree)(t[c],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,i,s)}}e.DefaultConfigurationModel=d;class g{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!b.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:c,overrides:h,restricted:f}=this.doParseRaw(t,i);this._configurationModel=new S(s,c,h),this._restrictedConfigurations=f||[]}doParseContent(t){let i={},s=null,c=[],h=[],f=[];function v(T){Array.isArray(c)?c.push(T):s&&(c[s]=T)}let D={onObjectBegin:()=>{let T={};v(T),h.push(c),c=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{c=h.pop()},onArrayBegin:()=>{let T=[];v(T),h.push(c),c=T,s=null},onArrayEnd:()=>{c=h.pop()},onLiteralValue:v,onError:(T,U,H)=>{f.push({error:T,offset:U,length:H})}};if(t)try{m.visit(t,D),i=c[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(t,i){const s=n.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),c=this.filter(t,s,!0,i);t=c.raw;const h=(0,p.toValuesTree)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`)),f=Object.keys(t),v=(0,p.toOverrides)(t,D=>console.error(`Conflict in settings file ${this._name}: ${D}`));return{contents:h,keys:f,overrides:v,restricted:c.restricted}}filter(t,i,s,c){if(!(c==null?void 0:c.scopes)&&!(c==null?void 0:c.skipRestricted))return{raw:t,restricted:[]};const h={},f=[];for(let v in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const D=this.filter(t[v],i,!1,c);h[v]=D.raw,f.push(...D.restricted)}else{const D=i[v],T=D?typeof D.scope!="undefined"?D.scope:3:void 0;(D==null?void 0:D.restricted)&&f.push(v),(T===void 0||c.scopes===void 0||c.scopes.includes(T))&&(c.skipRestricted&&(D==null?void 0:D.restricted)||(h[v]=t[v]))}return{raw:h,restricted:f}}}e.ConfigurationModelParser=g;class P extends y.Disposable{constructor(t,i,s,c){super();this.userSettingsResource=t,this.scopes=i,this.fileService=c,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=P;class I{constructor(t,i,s=new S,c=new S,h=new A.ResourceMap,f=new S,v=new A.ResourceMap,D=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=c,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=v,this._freeze=D,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let c;s.resource?(c=this._memoryConfigurationByResource.get(s.resource),c||(c=new S,this._memoryConfigurationByResource.set(s.resource,c))):c=this._memoryConfiguration,i===void 0?c.removeValue(t):c.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const c=this.getConsolidateConfigurationModel(i,s),h=this.getFolderConfigurationModelForResource(i.resource,s),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),D=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),H=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,te=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),se=c.getValue(t),O=L.distinct(L.flatten(c.overrides.map(z=>z.identifiers))).filter(z=>c.getOverrideValue(t,z)!==void 0);return{defaultValue:v,userValue:D,userLocalValue:T,userRemoteValue:U,workspaceValue:H,workspaceFolderValue:X,memoryValue:te,value:se,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:D!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:H!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:i.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(c=>w.OVERRIDE_PROPERTY_PATTERN.test(c)).map(c=>{const h=(0,w.overrideIdentifierFromKey)(c),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),v=t.getKeysForOverrideIdentifier(h),D=[...v.filter(T=>f.indexOf(T)===-1),...f.filter(T=>v.indexOf(T)===-1),...f.filter(T=>!M.equals(this._defaultConfiguration.override(h).getValue(T),t.override(h).getValue(T)))];return[h,D]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:c,overrides:h}=(0,p.compare)(this.localUserConfiguration,t),f=[...i,...s,...c];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:c,overrides:h}=(0,p.compare)(this.remoteUserConfiguration,t);let f=[...i,...s,...c];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:c,overrides:h}=(0,p.compare)(this.workspaceConfiguration,t);let f=[...i,...s,...c];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:c,updated:h,removed:f,overrides:v}=(0,p.compare)(s,i);let D=[...c,...h,...f];return(D.length||!s)&&this.updateFolderConfiguration(t,i),{keys:D,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:c,removed:h,overrides:f}=(0,p.compare)(i,void 0);return{keys:[...s,...c,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const c=i.getFolder(t);c&&(s=this.getFolderConsolidatedConfiguration(c.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),c=this._folderConfigurations.get(t);c?(i=s.merge(c),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:c,keys:h}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:c,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(c=>i.add(c))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),c=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,v)=>(f.set(r.URI.revive(v[0]),this.parseConfigurationModel(v[1])),f),new A.ResourceMap);return new I(i,s,new S,c,h,new S,new A.ResourceMap,!1)}static parseConfigurationModel(t){return new S(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=I;function o(...u){if(u.length===0)return{keys:[],overrides:[]};if(u.length===1)return u[0];const t=new Set,i=new Map;for(const c of u)c.keys.forEach(h=>t.add(h)),c.overrides.forEach(([h,f])=>{const v=(0,A.getOrSet)(i,h,new Set);f.forEach(D=>v.add(D))});const s=[];return i.forEach((c,h)=>s.push([h,[...c.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=o;class l{constructor(t,i,s,c){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=c,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(v=>h.add(v)),t.overrides.forEach(([,v])=>v.forEach(D=>h.add(D))),this.affectedKeys=[...h.values()];const f=new S;this.affectedKeys.forEach(v=>f.setValue(v,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=I.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const c=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!M.equals(c,h)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,p.toValuesTree)({[i]:!0},()=>{}),c;for(;typeof s=="object"&&(c=Object.keys(s)[0]);){if(t=t[c],!t)return!1;s=s[c]}return!0}}e.ConfigurationChangeEvent=l;class a extends l{constructor(t,i,s,c){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=c}}e.AllKeysConfigurationChangeEvent=a}),define(Q[186],J([0,1,37,47,2,17,185,5,9,15]),function(j,e,m,A,L,b,M,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(E,S){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new M.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,S)),this.configuration=new M.Configuration(new M.DefaultConfigurationModel,new M.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(m.Registry.as(A.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new M.Configuration(new M.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,S){const d=typeof E=="string"?E:void 0,g=(0,b.isConfigurationOverrides)(E)?E:(0,b.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(d,g,void 0)}updateValue(E,S,d,g){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,S,1)}onDidDefaultConfigurationChange(E){const S=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new M.DefaultConfigurationModel,E);this.trigger(d,S,6)}trigger(E,S,d){const g=new M.ConfigurationChangeEvent(E,{data:S},this.configuration);g.source=d,g.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Q[187],J([0,1,45,7,67,138,16,3,89,17,4,10,104]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const S=b.localize(0,null);class d{async getDefaultTerminalForPlatforms(){const t=await I.getDefaultTerminalLinuxReady();return{windows:g.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let g=class Qe extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,L.getWindowsShell(),t)}spawnTerminal(t,i,s,c){const h=i.terminal.external,f=(h==null?void 0:h.windowsExec)||Qe.getDefaultTerminalWindows();c&&c[1]===":"&&(c=c[0].toUpperCase()+c.substr(1));const v=A.basename(f).toLowerCase();if(v==="cmder"||v==="cmder.exe")return t.spawn(f,c?[c]:void 0),Promise.resolve(void 0);const D=["/c","start","/wait"];return f.indexOf(" ")>=0&&D.push('""'),D.push(f),(v==="wt"||v==="wt.exe")&&D.push("-d ."),new Promise((T,U)=>{const H=o(process),X=t.spawn(s,D,{cwd:c,env:H});X.on("error",U),X.on("exit",()=>T())})}runInTerminal(t,i,s,c,h){const f=h.windowsExec||Qe.getDefaultTerminalWindows();return new Promise((v,D)=>{const T=`"${i} - ${S}"`,U=`""${s.join('" "')}" & pause"`,H=["/c","start",T,"/wait",f,"/c",U],X=Object.assign({},o(process),c);Object.keys(X).filter(O=>X[O]===null).forEach(O=>delete X[O]);const te={cwd:i,env:X,windowsVerbatimArguments:!0};m.spawn(Qe.CMD,H,te).on("error",O=>{D(l(O))}),v(void 0)})}static getDefaultTerminalWindows(){if(!Qe._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Qe._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Qe._DEFAULT_TERMINAL_WINDOWS}};g.CMD="cmd.exe",g=ce([ee(0,(0,n.optional)(p.IConfigurationService))],g),e.WindowsExternalTerminalService=g;let P=class bt extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,t)}runInTerminal(t,i,s,c,h){const f=h.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((v,D)=>{if(f===w.DEFAULT_TERMINAL_OSX||f==="iTerm.app"){const T=f===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",H=[y.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${T}.scpt`,j).fsPath,"-t",t||S,"-w",i];for(let se of s)H.push("-a"),H.push(se);if(c)for(let se in c){const O=c[se];O===null?(H.push("-u"),H.push(se)):(H.push("-e"),H.push(`${se}=${O}`))}let X="";const te=m.spawn(bt.OSASCRIPT,H);te.on("error",se=>{D(l(se))}),te.stderr.on("data",se=>{X+=se.toString()}),te.on("exit",se=>{if(se===0)v(void 0);else if(X){const O=X.split(`
`,1);D(new Error(O[0]))}else D(new Error(b.localize(1,null,T,se)))})}else D(new Error(b.localize(2,null,f)))})}spawnTerminal(t,i,s){const c=i.terminal.external,h=(c==null?void 0:c.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((f,v)=>{const D=["-a",h];s&&D.push(s);const T=t.spawn("/usr/bin/open",D);T.on("error",v),T.on("exit",()=>f())})}};P.OSASCRIPT="/usr/bin/osascript",P=ce([ee(0,(0,n.optional)(p.IConfigurationService))],P),e.MacExternalTerminalService=P;let I=class Je extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(m,i,t)}runInTerminal(t,i,s,c,h){const f=h.linuxExec?Promise.resolve(h.linuxExec):Je.getDefaultTerminalLinuxReady();return new Promise((v,D)=>{let T=[];f.then(U=>{U.indexOf("gnome-terminal")>=0?T.push("-x"):T.push("-e"),T.push("bash"),T.push("-c");const H=`${a(s)}; echo; read -p "${Je.WAIT_MESSAGE}" -n1;`;T.push(`''${H}''`);const X=Object.assign({},process.env,c);Object.keys(X).filter(z=>X[z]===null).forEach(z=>delete X[z]);const te={cwd:i,env:X};let se="";const O=m.spawn(U,T,te);O.on("error",z=>{D(l(z))}),O.stderr.on("data",z=>{se+=z.toString()}),O.on("exit",z=>{if(z===0)v(void 0);else if(se){const $=se.split(`
`,1);D(new Error($[0]))}else D(new Error(b.localize(4,null,U,z)))})})})}static async getDefaultTerminalLinuxReady(){return Je._DEFAULT_TERMINAL_LINUX_READY||(Je._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{r.isLinux?await M.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Je._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,i,s){const c=i.terminal.external,h=(c==null?void 0:c.linuxExec)?Promise.resolve(c.linuxExec):Je.getDefaultTerminalLinuxReady();return new Promise((f,v)=>{h.then(D=>{const T=o(process),U=t.spawn(D,[],{cwd:s,env:T});U.on("error",v),U.on("exit",()=>f())})})}};I.WAIT_MESSAGE=b.localize(3,null),I=ce([ee(0,(0,n.optional)(p.IConfigurationService))],I),e.LinuxExternalTerminalService=I;function o(u){const t=u.env;return(0,E.sanitizeProcessEnvironment)(t),t}function l(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(b.localize(5,null,u.path)):u}function a(u){let t="";for(let i of u)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Q[188],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,m.createDecorator)("remoteAuthorityResolverService");var A;(function(M){M[M.Unknown=0]="Unknown",M[M.DisableTrust=1]="DisableTrust",M[M.MachineTrusted=2]="MachineTrusted"})(A=e.RemoteTrustOption||(e.RemoteTrustOption={}));var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class b extends Error{constructor(r,w=L.Unknown,p){super(r);this._message=r,this._code=w,this._detail=p,this.isHandled=w===L.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,b.prototype)}static isTemporarilyNotAvailable(r){return r instanceof b&&r._code===L.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof b&&r._code===L.NoResolverFound}static isHandled(r){return r instanceof b&&r.isHandled}}e.RemoteAuthorityResolverError=b}),define(Q[189],J([0,1,83,28,2,23,5,188,19,9,26]),function(j,e,m,A,L,b,M,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var E;(function(k){k[k.Management=1]="Management",k[k.ExtensionHost=2]="ExtensionHost",k[k.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function S(k){switch(k){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(k){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),k),F.token}function g(k,F){if(k.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const B=new n.CancellationTokenSource;return k.onCancellationRequested(()=>B.cancel()),F.onCancellationRequested(()=>B.cancel()),B.token}class P{constructor(F){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((B,V)=>{this._resolvePromise=B,this._rejectPromise=V}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function I(k,F){const B=new P(F);return B.registerDisposable(k.onControlMessage(V=>{const G=JSON.parse(V.toString()),Y=q(G);Y?B.reject(Y):B.resolve(G)})),B.promise}function o(k,F,B,V,G,Y){const Z=new P(Y);return F.connect(B,V,G,(re,oe)=>{Z.didTimeout?(re&&k.error(re),oe==null||oe.dispose()):re||!oe?Z.reject(re):Z.resolve(oe)}),Z.promise}function l(k,F){const B=new P(F);return k.then(V=>{B.didTimeout||B.resolve(V)},V=>{B.didTimeout||B.reject(V)}),B.promise}async function a(k,F,B,V){const G=R(k,F);k.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await o(k.logService,k.socketFactory,k.host,k.port,`reconnectionToken=${k.reconnectionToken}&reconnection=${k.reconnectionProtocol?"true":"false"}`,V)}catch(x){throw k.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),k.logService.error(x),x}k.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;k.reconnectionProtocol?(k.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=k.reconnectionProtocol,re=!1):(Z=new m.PersistentProtocol(Y,null),re=!0),k.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const oe={type:"auth",auth:k.connectionToken||"00000000000000000000"};Z.sendControl(b.VSBuffer.fromString(JSON.stringify(oe)));try{const x=await I(Z,g(V,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}k.logService.trace(`${G} 4/6. received SignRequest control message.`);const ne=await l(k.signService.sign(x.data),V),ue={type:"connectionType",commit:k.commit,signedData:ne,desiredConnectionType:F};return B&&(ue.args=B),k.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(b.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(k.logService.error(`${G} the handshake timed out. Error:`),k.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(k.logService.error(`${G} received error control message when negotiating connection. Error:`),k.logService.error(x)),re&&C(Z),x}}async function u(k,F,B,V){const G=Date.now(),Y=R(k,F),{protocol:Z,ownsProtocol:re}=await a(k,F,B,V),oe=new P(V);return oe.registerDisposable(Z.onControlMessage(x=>{const ne=JSON.parse(x.toString()),ue=q(ne);ue?(k.logService.error(`${Y} received error control message when negotiating connection. Error:`),k.logService.error(ue),re&&C(Z),oe.reject(ue)):(k.reconnectionProtocol&&k.reconnectionProtocol.endAcceptReconnection(),k.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${W(G)}!`),oe.resolve({protocol:Z,firstMessage:ne}))})),oe.promise}async function t(k,F){const{protocol:B}=await u(k,1,void 0,F);return{protocol:B}}async function i(k,F,B){const{protocol:V,firstMessage:G}=await u(k,2,F,B),Y=G&&G.debugPort;return{protocol:V,debugPort:Y}}async function s(k,F,B){const V=Date.now(),G=R(k,3),{protocol:Y}=await a(k,3,F,B);return k.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${W(V)}!`),Y}async function c(k,F,B){const{host:V,port:G,connectionToken:Y}=await k.addressProvider.getAddress();return{commit:k.commit,host:V,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:B,socketFactory:k.socketFactory,signService:k.signService,logService:k.logService}}async function h(k,F,B){try{const V=(0,A.generateUuid)(),G=await c(k,V,null),{protocol:Y}=await t(G,n.CancellationToken.None);return new z(k,F,B,V,Y)}catch(V){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(V),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(V)),V}}e.connectRemoteAgentManagement=h;async function f(k,F){try{const B=(0,A.generateUuid)(),V=await c(k,B,null),{protocol:G,debugPort:Y}=await i(V,F,n.CancellationToken.None);return new $(k,F,B,G,Y)}catch(B){throw k.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),k.logService.error(B),O.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function v(k,F){const B=await c(k,(0,A.generateUuid)(),null);return await s(B,{port:F},n.CancellationToken.None)}e.connectRemoteAgentTunnel=v;function D(k){return(0,p.createCancelablePromise)(F=>new Promise((B,V)=>{const G=setTimeout(B,k*1e3);F.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var T;(function(k){k[k.ConnectionLost=0]="ConnectionLost",k[k.ReconnectionWait=1]="ReconnectionWait",k[k.ReconnectionRunning=2]="ReconnectionRunning",k[k.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",k[k.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,B){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class H{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.durationSeconds=V,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=H;class X{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=2}}e.ReconnectionRunningEvent=X;class te{constructor(F,B,V){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.type=4}}e.ConnectionGainEvent=te;class se{constructor(F,B,V,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=B,this.attempt=V,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=se;class O extends L.Disposable{constructor(F,B,V,G){super();this._connectionType=F,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=V,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),O._instances.push(this),O._permanentFailure&&this._gotoPermanentFailure(O._permanentFailureMillisSinceLastIncomingData,O._permanentFailureAttempt,O._permanentFailureHandled)}static triggerPermanentFailure(F,B,V){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=B,this._permanentFailureHandled=V,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!O._permanentFailure){const F=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],V=Date.now();let G=-1;do{G++;const Y=G<B.length?B[G]:B[B.length-1];try{if(Y>0){const re=D(Y);this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(oe){}}if(O._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await c(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(y)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-V>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(r.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,w.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof r.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,r.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),O.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!O._permanentFailure)}}_gotoPermanentFailure(F,B,V){this._onDidStateChange.fire(new se(this.reconnectionToken,F,B,V)),C(this.protocol)}}O._permanentFailure=!1,O._permanentFailureMillisSinceLastIncomingData=0,O._permanentFailureAttempt=0,O._permanentFailureHandled=!1,O._instances=[];class z extends O{constructor(F,B,V,G,Y){super(1,F,G,Y);this.client=this._register(new m.Client(Y,{remoteAuthority:B,clientId:V},F.ipcLogger))}async _reconnect(F,B){await t(F,B)}}e.ManagementPersistentConnection=z;class $ extends O{constructor(F,B,V,G,Y){super(2,F,V,G);this._startArguments=B,this.debugPort=Y}async _reconnect(F,B){await i(F,this._startArguments,B)}}e.ExtensionHostPersistentConnection=$;function C(k){try{k.acceptDisconnect();const F=k.getSocket();k.dispose(),F.dispose()}catch(F){(0,w.onUnexpectedError)(F)}}function q(k){if(k&&k.type==="error"){const F=new Error(`Connection error: ${k.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function N(k,F){for(;k.length<F;)k+=" ";return k}function _(k,F,B){return`[remote-connection][${N(S(k),13)}][${F.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function R(k,F){return`${_(F,k.reconnectionToken,!!k.reconnectionProtocol)}[${k.host}:${k.port}]`}function W(k){return`${Date.now()-k} ms`}}),define(Q[72],J([0,1,10]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function A(w){return w.scheme===m.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=A;function L(w){if(!!w){const p=w.indexOf("+");return p<0?w:w.substr(0,p)}}e.getRemoteName=L;function b(w){return w.scheme!==m.Schemas.file&&w.scheme!==m.Schemas.vscodeRemote}function M(w){if(w.folders.length)return w.folders.every(p=>b(p.uri))?w.folders[0].uri:void 0;if(w.configuration&&b(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=M;function r(w){var p;return(p=M(w))===null||p===void 0?void 0:p.scheme}e.getVirtualWorkspaceScheme=r}),define(Q[73],J([0,1,5,3,4,6]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var M;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(M=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function r(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const S=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!S)return{address:S[1],port:+S[2]}}}e.extractLocalHostUriMetaDataForPortMapping=r,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=p;function n(E,S){return S?S!==1&&E<1024:!A.isWindows&&E<1024}e.isPortPrivileged=n;let y=class{constructor(S){this.logService=S,this._onTunnelOpened=new m.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new m.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(S,d){return this._tunnelProvider=S,S?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async S=>{const d=[],g=Array.from(this._tunnels.values());for(let P of g){const I=Array.from(P.values());for(let o of I){const l=await o.value;l&&d.push(l)}}S(d)})}async dispose(){for(const S of this._tunnels.values()){for(const{value:d}of S.values())await d.then(g=>g==null?void 0:g.dispose());S.clear()}this._tunnels.clear()}openTunnel(S,d,g,P,I=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${g} on local port ${P}.`),!!S){d||(d="localhost");const l=this.retainOrCreateTunnel(S,d,g,P,I,o);return l?l.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.makeTunnel(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(u),u}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),l)}}makeTunnel(S){return{tunnelRemotePort:S.tunnelRemotePort,tunnelRemoteHost:S.tunnelRemoteHost,tunnelLocalPort:S.tunnelLocalPort,localAddress:S.localAddress,public:S.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${S.tunnelRemoteHost}:${S.tunnelRemotePort} `);const d=this._tunnels.get(S.tunnelRemoteHost);if(d){const g=d.get(S.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(S.tunnelRemoteHost,S.tunnelRemotePort,g))}}}}async tryDisposeTunnel(S,d,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${S}:${d}.`);const P=g.value.then(async I=>{I&&(await I.dispose(!0),this._onTunnelClosed.fire({host:I.tunnelRemoteHost,port:I.tunnelRemotePort}))});return this._tunnels.has(S)&&this._tunnels.get(S).delete(d),P}}async closeTunnel(S,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${S}:${d} `);const g=this._tunnels.get(S);if(g&&g.has(d)){const P=g.get(d);P.refcount=0,await this.tryDisposeTunnel(S,d,P)}}addTunnelToMap(S,d,g){this._tunnels.has(S)||this._tunnels.set(S,new Map),this._tunnels.get(S).set(d,{refcount:1,value:g})}async removeEmptyTunnelFromMap(S,d){const g=this._tunnels.get(S);g&&(await g.get(d)||g.delete(d),g.size===0&&this._tunnels.delete(S))}getTunnelFromMap(S,d){let g=[S];w(S)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):p(S)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const P=g.map(I=>this._tunnels.get(I));for(const I of P){const o=I==null?void 0:I.get(d);if(o)return o}}canTunnel(S){return!!r(S)}createWithProvider(S,d,g,P,I,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${g} on local port ${P}.`);const a={elevationRequired:I?n(P===void 0?g:P):!1},u={remoteAddress:{host:d,port:g},localAddressPort:P,public:o},t=S.forwardPort(u,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,g,t),t}};y=ce([ee(0,b.ILogService)],y),e.AbstractTunnelService=y}),define(Q[48],J([0,1,145,4,47,37,23]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,A.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function w(d){return d.res.statusCode===204}async function p(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return w(d)?null:(await(0,M.streamToBuffer)(d.stream)).toString()}e.asText=p;async function n(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(w(d))return null;const P=(await(0,M.streamToBuffer)(d.stream)).toString();try{return JSON.parse(P)}catch(I){throw I.message+=`:
`+P,I}}e.asJson=n;function y(d){S(d)}e.updateProxyConfigurationsScope=y;let E;function S(d){const g=b.Registry.as(L.Extensions.Configuration);E&&g.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,m.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,m.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,m.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,m.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,m.localize)(4,null),(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],default:"override",description:(0,m.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,m.localize)(9,null),restricted:!0}}},g.registerConfiguration(E)}S(2)}),define(Q[190],J([0,1,191,13]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(M,r){return M.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:M.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function b(M,r,w={}){const p=(0,m.parse)(M),n=w.proxyUrl||L(p,r);if(!n)return null;const y=(0,m.parse)(n);if(!/^https?:$/.test(y.protocol||""))return null;const E={host:y.hostname||"",port:y.port||(y.protocol==="https"?"443":"80"),auth:y.auth,rejectUnauthorized:(0,A.isBoolean)(w.strictSSL)?w.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((S,d)=>{j(["http-proxy-agent"],S,d)}))(E):new(await new Promise((S,d)=>{j(["https-proxy-agent"],S,d)}))(E)}e.getProxyAgent=b}),define(Q[192],J([0,1,28,23]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(b,M,r){let w=r&&r.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await M.readFile(b.serviceMachineIdResource)).value.toString();w=(0,m.isUUID)(n)?n:null}catch(p){w=null}if(!w){w=(0,m.generateUuid)();try{await M.writeFile(b.serviceMachineIdResource,A.VSBuffer.fromString(w))}catch(p){}}return r&&r.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=L}),define(Q[74],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,m.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[193],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class m{vsda(){return new Promise((L,b)=>j(["vsda"],L,b))}async sign(L){try{const b=await this.vsda(),M=new b.signer;if(M)return M.sign(L)}catch(b){}return L}}e.SignService=m}),define(Q[38],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,m.createDecorator)("stateMainService")}),define(Q[18],J([0,1,14,6,38,5,4,175,3,2,9,13,32]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,M.createDecorator)("lifecycleMainService");var S;(function(P){P[P.CLOSE=1]="CLOSE",P[P.QUIT=2]="QUIT",P[P.RELOAD=3]="RELOAD",P[P.LOAD=4]="LOAD"})(S=e.UnloadReason||(e.UnloadReason={}));var d;(function(P){P[P.Starting=1]="Starting",P[P.Ready=2]="Ready",P[P.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let g=class lt extends p.Disposable{constructor(I,o){super();this.logService=I,this.stateMainService=o,this._onBeforeShutdown=this._register(new b.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new b.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new b.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new b.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new b.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(lt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(lt.QUIT_AND_RESTART_KEY)}registerListeners(){const I=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};m.app.addListener("before-quit",I);const o=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&m.app.quit()};m.app.addListener("window-all-closed",o),m.app.once("will-quit",l=>{this.logService.trace("Lifecycle#app.on(will-quit)"),l.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),m.app.removeListener("before-quit",I),m.app.removeListener("window-all-closed",o),m.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[this.stateMainService.flush()];return this._onWillShutdown.fire({join(o){I.push(o)}}),this.pendingWillShutdownPromise=n.Promises.settled(I).then(()=>{},o=>this.logService.error(o)),this.pendingWillShutdownPromise}set phase(I){if(I<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==I){this.logService.trace(`lifecycle (main): phase changed (value: ${I})`),this._phase=I;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}}async when(I){if(!(I<=this._phase)){let o=this.phaseWhen.get(I);o||(o=new n.Barrier,this.phaseWhen.set(I,o)),await o.wait()}}registerWindow(I){const o=new p.DisposableStore;this.windowCounter++,o.add(I.onWillLoad(a=>this._onWillLoadWindow.fire({window:I,workspace:a.workspace})));const l=(0,y.assertIsDefined)(I.win);l.on("close",a=>{const u=I.id;if(this.windowToCloseRequest.has(u)){this.windowToCloseRequest.delete(u);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${I.id}`),a.preventDefault(),this.unload(I,1).then(t=>{if(t){this.windowToCloseRequest.delete(u);return}this.windowToCloseRequest.add(u),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${u}`),this._onBeforeCloseWindow.fire(I),I.close()})}),l.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${I.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(I,o){await this.unload(I,3)||I.reload(o)}async unload(I,o){if(!I.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${I.id}`);const l=this._quitRequested?2:o;let a=await this.onBeforeUnloadWindowInRenderer(I,l);return a?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${I.id})`),this.handleWindowUnloadVeto(a)):(a=await this.onBeforeUnloadWindowInMain(I,l),a?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${I.id})`),this.handleWindowUnloadVeto(a)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${I.id})`),await this.onWillUnloadWindowInRenderer(I,l),!1))}handleWindowUnloadVeto(I){return I?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(I){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(I),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(I,o){return new Promise(l=>{const a=this.oneTimeListenerTokenGenerator++,u=`vscode:ok${a}`,t=`vscode:cancel${a}`;m.ipcMain.once(u,()=>{l(!1)}),m.ipcMain.once(t,()=>{l(!0)}),I.send("vscode:onBeforeUnload",{okChannel:u,cancelChannel:t,reason:o})})}onBeforeUnloadWindowInMain(I,o){const l=[];return this._onBeforeUnloadWindow.fire({reason:o,window:I,veto(a){l.push(a)}}),(0,r.handleVetos)(l,a=>this.logService.error(a))}onWillUnloadWindowInRenderer(I,o){return new Promise(l=>{const u=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;m.ipcMain.once(u,()=>l()),I.send("vscode:onWillUnload",{replyChannel:u,reason:o})})}quit(I){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${I}`),I&&this.stateMainService.setItem(lt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.logService.trace("Lifecycle#quit() - calling app.quit()"),m.app.quit()}),this.pendingQuitPromise)}async relaunch(I){this.logService.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if((I==null?void 0:I.addArgs)&&o.push(...I.addArgs),I==null?void 0:I.removeArgs)for(const u of I.removeArgs){const t=o.indexOf(u);t>=0&&o.splice(t,1)}const l=()=>{try{if(w.isWindows){const u=(0,E.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.logService.error(u)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),m.app.relaunch({args:o})};m.app.once("quit",l),await this.quit(!0)&&m.app.removeListener("quit",l)}async kill(I){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const o of m.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let l;o.webContents&&!o.webContents.isDestroyed()?l=new Promise(a=>o.once("closed",a)):l=Promise.resolve(),o.destroy(),await l}})()]),m.app.exit(I)}};g.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",g=ce([ee(0,A.ILogService),ee(1,L.IStateMainService)],g),e.LifecycleMainService=g}),define(Q[194],J([0,1,4,5,2,18]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,m.createDecorator)("keyboardLayoutMainService");let M=class extends L.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new A.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((n,y)=>{j(["native-keymap"],n,y)});this._keyboardLayoutData=r(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};M=ce([ee(0,b.ILifecycleMainService)],M),e.KeyboardLayoutMainService=M;function r(w){const p=w.getKeyMap(),n=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:n}}}),define(Q[95],J([0,1,4,5,2,13,85,9]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,m.createDecorator)("storageService");var p;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class E extends L.Disposable{constructor(P={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=P,this._onDidChangeValue=this._register(new A.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new A.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new A.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(P,I){I===w?(P===0?this._globalKeyTargets=void 0:P===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:P})):this._onDidChangeValue.fire({scope:P,key:I,target:this.getKeyTargets(P)[I]})}emitWillSaveState(P){this._onWillSaveState.fire({reason:P})}get(P,I,o){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.get(P,o)}getBoolean(P,I,o){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getBoolean(P,o)}getNumber(P,I,o){var l;return(l=this.getStorage(I))===null||l===void 0?void 0:l.getNumber(P,o)}store(P,I,o,l){if((0,b.isUndefinedOrNull)(I)){this.remove(P,o);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(P,o,l),(a=this.getStorage(o))===null||a===void 0||a.set(P,I)})}remove(P,I){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(P,I,void 0),(o=this.getStorage(I))===null||o===void 0||o.delete(P)})}withPausedEmitters(P){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{P()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(P,I){const o=[],l=this.getKeyTargets(P);for(const a of Object.keys(l))l[a]===I&&o.push(a);return o}updateKeyTarget(P,I,o){var l,a;const u=this.getKeyTargets(I);typeof o=="number"?u[P]!==o&&(u[P]=o,(l=this.getStorage(I))===null||l===void 0||l.set(w,JSON.stringify(u))):typeof u[P]=="number"&&(delete u[P],(a=this.getStorage(I))===null||a===void 0||a.set(w,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(P){return P===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(P){const I=this.get(w,P);if(I)try{return JSON.parse(I)}catch(o){}return Object.create(null)}isNew(P){return this.getBoolean(e.IS_NEW_KEY,P)===!0}async flush(){var P,I,o,l;this._onWillSaveState.fire({reason:p.NONE}),await r.Promises.settled([(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.whenFlushed())!==null&&I!==void 0?I:Promise.resolve(),(l=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&l!==void 0?l:Promise.resolve()])}async logStorage(){var P,I,o,l,a,u;const t=(I=(P=this.getStorage(0))===null||P===void 0?void 0:P.items)!==null&&I!==void 0?I:new Map,i=(l=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&l!==void 0?l:new Map;return d(t,i,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(u=this.getLogDetails(1))!==null&&u!==void 0?u:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class S extends E{constructor(){super();this.globalStorage=new M.Storage(new M.InMemoryStorageDatabase),this.workspaceStorage=new M.Storage(new M.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(P=>this.emitDidChangeValue(1,P))),this._register(this.globalStorage.onDidChangeStorage(P=>this.emitDidChangeValue(0,P)))}getStorage(P){return P===0?this.globalStorage:this.workspaceStorage}getLogDetails(P){return P===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(P){}}e.InMemoryStorageService=S;async function d(g,P,I,o){const l=h=>{try{return JSON.parse(h)}catch(f){return h}},a=new Map,u=new Map;g.forEach((h,f)=>{a.set(f,h),u.set(f,l(h))});const t=new Map,i=new Map;P.forEach((h,f)=>{t.set(f,h),i.set(f,l(h))}),console.group(`Storage: Global (path: ${I})`);let s=[];a.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(u),console.group(`Storage: Workspace (path: ${o})`);let c=[];t.forEach((h,f)=>{c.push({key:f,value:h})}),console.table(c),console.groupEnd(),console.log(i)}e.logStorage=d}),define(Q[195],J([0,1,3,32,28,8]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function M(p){if(m.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function r(p,n,y,E,S,d,g,P,I,o){const l=Object.create(null);l["common.machineId"]=g,l.sessionID=(0,L.generateUuid)()+Date.now(),l.commitHash=S,l.version=d,l["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,m.PlatformToString)(m.platform),l["common.nodePlatform"]=A.platform,l["common.nodeArch"]=E,l["common.product"]=o||"desktop";const a=w(P||[]);a&&(l["common.msftInternal"]=a);let u=0;const t=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),m.isLinuxSnap&&(l["common.snap"]="true");const i=M(y);i&&(l["common.platformDetail"]=i);try{const s=await p.readFile(b.URI.file(I));l["common.source"]=s.value.toString().slice(0,30)}catch(s){}return l}e.resolveCommonProperties=r;function w(p){const n=A.env.USERDNSDOMAIN;if(!n)return!1;const y=n.toLowerCase();return p.some(E=>y===E)}}),define(Q[31],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,m.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,m.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[196],J([0,1,27,65,69,20,7,43,82,21,3,8,31,62,10,24,16]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function I(t,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],c=new Map,h=new Map,f=2e4;function v(U,H,X,te){const se=H.substring(U.length+1);return new Promise(async O=>{var z,$,C;let q;try{q=await(0,P.readdir)(H,{withFileTypes:!0})}catch(R){O();return}if(te.count>=f){te.count+=q.length,te.maxReached=!0,O();return}let N=q.length;if(N===0){O();return}let _=q;te.count+q.length>f&&(te.maxReached=!0,N=f-te.count,_=q.slice(0,N)),te.count+=q.length;for(const R of _)if(R.isDirectory()){if(X.includes(R.name)||await v(U,(0,M.join)(H,R.name),X,te),--N==0){O();return}}else{const W=R.name.lastIndexOf(".");if(W>=0){const k=R.name.substring(W+1);k&&c.set(k,((z=c.get(k))!==null&&z!==void 0?z:0)+1)}for(const k of s)(($=k.relativePathPattern)===null||$===void 0?void 0:$.test(se))!==!1&&k.filePattern.test(R.name)&&h.set(k.tag,((C=h.get(k.tag))!==null&&C!==void 0?C:0)+1);if(--N==0){O();return}}})}const D={count:0,maxReached:!1};await v(t,t,i,D);const T=await a(t);return{configFiles:o(h),fileTypes:o(c),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=I;function o(t){return[...S.Iterable.map(t.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function l(){const t={os:`${m.type()} ${m.arch()} ${m.release()}`,memory:`${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(A.virtualMachineHint.value()*100)}%`},i=m.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=l;function a(t){let i=new Map,s=(0,M.join)(t,".vscode","launch.json");return new Promise((c,h)=>{(0,b.exists)(s,f=>{if(f)(0,b.readFile)(s,(v,D)=>{if(v)return c([]);const T=[],U=(0,r.parse)(D.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),c([]);if((0,r.getNodeType)(U)==="object"&&U.configurations)for(const H of U.configurations){const X=H.type;X&&(i.has(X)?i.set(X,i.get(X)+1):i.set(X,1))}return c(o(i))});else return c([])})})}e.collectLaunchConfigs=a;let u=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${m.type()} ${m.arch()} ${m.release()}`);const c=m.cpus();return c&&c.length>0&&s.push(`CPUs:             ${c[0].model} (${c.length} x ${c[0].speed})`),s.push(`Memory (System):  ${(m.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(m.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${m.loadavg().map(h=>Math.round(h)).join(", ")}`),s.push(`VM:               ${Math.round(A.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,w.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async c=>{let[h,f]=c,v=this.formatProcessList(i,h);return s.forEach(D=>{if((0,L.isRemoteDiagnosticError)(D))v+=`
${D.errorMessage}`,f+=`
${D.errorMessage}`;else if(v+=`

Remote: ${D.hostName}`,D.processes&&(v+=`
${this.formatProcessList(i,D.processes)}`),D.workspaceMetadata){f+=`
|  Remote: ${D.hostName}`;for(const T of Object.keys(D.workspaceMetadata)){const U=D.workspaceMetadata[T];let H=`${U.fileCount} files`;U.maxFilesReached&&(H=`more than ${H}`),f+=`|    Folder (${T}): ${H}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:v,workspaceInfo:f}})}async getSystemInfo(i,s){const{memory:c,vmHint:h,os:f,cpus:v}=l(),D={os:f,memory:c,cpus:v,vmHint:h,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(D.load=`${m.loadavg().map(T=>Math.round(T)).join(", ")}`),n.isLinux&&(D.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(D)}async getDiagnostics(i,s){const c=[];return(0,w.listProcesses)(i.mainPID).then(async h=>(c.push(""),c.push(this.formatEnvironment(i)),c.push(""),c.push(this.formatProcessList(i,h)),i.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(c.push(""),c.push("Workspace Stats: "),c.push(await this.formatWorkspaceMetadata(i))),s.forEach(f=>{if((0,L.isRemoteDiagnosticError)(f))c.push(`
${f.errorMessage}`);else if(c.push(`

`),c.push(`Remote:           ${f.hostName}`),c.push(this.formatMachineInfo(f.machineInfo)),f.processes&&c.push(this.formatProcessList(i,f.processes)),f.workspaceMetadata)for(const v of Object.keys(f.workspaceMetadata)){const D=f.workspaceMetadata[v];let T=`${D.fileCount} files`;D.maxFilesReached&&(T=`more than ${T}`),c.push(`Folder (${v}): ${T}`),c.push(this.formatWorkspaceStats(D))}}),c.push(""),c.push(""),c.join(`
`)))}formatWorkspaceStats(i){const s=[],c=60;let h=0;const f=(U,H)=>{const X=` ${U}(${H})`;h+X.length>c?(s.push(v),v="|                 ",h=v.length):h+=X.length,v+=X};let v="|      File types:";const D=10;let T=i.fileTypes.length>D?D:i.fileTypes.length;for(let U=0;U<T;U++){const H=i.fileTypes[U];f(H.name,H.count)}if(s.push(v),i.configFiles.length>=0&&(v="|      Conf files:",h=0,i.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(v)),i.launchConfigFiles.length>0){let U="|      Launch Configs:";i.launchConfigFiles.forEach(H=>{U+=H.count>1?` ${H.name}(${H.count})`:` ${H.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(c=>c.length));return Object.keys(i).map(c=>`${c}:  ${" ".repeat(s-c.length)}  ${i[c]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],c=[];return i.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(s.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const v=y.URI.revive(f);if(v.scheme===d.Schemas.file){const D=v.fsPath;c.push(I(D,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,M.basename)(D)}): ${U}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${D} (${T.toString()})`)}))}else s.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(c).then(h=>s.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(i,s){const c=new Map;i.windows.forEach(f=>c.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,c,h,s,0),h.join(`
`)}formatProcessItem(i,s,c,h,f){const v=f===0;let D;v?D=h.pid===i?`${this.productService.applicationName} main`:"remote agent":(D=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(D=`${D} (${s.get(h.pid)})`));const T=process.platform==="win32"?h.mem:m.totalmem()*(h.mem/100);c.push(`${h.load.toFixed(0).padStart(5," ")}	${(T/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${D}`),Array.isArray(h.children)&&h.children.forEach(U=>this.formatProcessItem(i,s,c,U,f+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const c=y.URI.revive(s);if(c.scheme===d.Schemas.file){const h=c.fsPath;try{const f=await I(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),f.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),f.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})})}catch(f){}}}}};u=ce([ee(0,E.ITelemetryService),ee(1,p.IProductService)],u),e.DiagnosticsService=u}),define(Q[197],J([0,1,19,167,170,44,31,48,161,53,26,6,24,8,21,95,192,4,15]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var l;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(l||(l={}));function a(..._){return String(_.reduce((R,W)=>R|W,0))}var u;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},c={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:l.None,criteria:[],assetTypes:[]};class h{constructor(R=c){this.state=R}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(R,W=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:R,pageSize:W}))}withFilter(R,...W){const k=[...this.state.criteria,...W.length?W.map(F=>({filterType:R,value:F})):[{filterType:R}]];return new h(Object.assign(Object.assign({},this.state),{criteria:k}))}withSortBy(R){return new h(Object.assign(Object.assign({},this.state),{sortBy:R}))}withSortOrder(R){return new h(Object.assign(Object.assign({},this.state),{sortOrder:R}))}withFlags(...R){return new h(Object.assign(Object.assign({},this.state),{flags:R.reduce((W,k)=>W|k,0)}))}withAssetTypes(...R){return new h(Object.assign(Object.assign({},this.state),{assetTypes:R}))}get raw(){const{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B,flags:V,assetTypes:G}=this.state;return{filters:[{criteria:R,pageNumber:W,pageSize:k,sortBy:F,sortOrder:B}],assetTypes:G,flags:V}}get searchText(){const R=this.state.criteria.filter(W=>W.filterType===u.SearchText)[0];return R&&R.value?R.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(R=>String(R.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(_,R){const W=(_||[]).filter(k=>k.statisticName===R)[0];return W?W.value:0}function v(_){const R="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(k=>k.assetType.indexOf(R)===0).reduce((k,F)=>{const B=H(_,F.assetType);return B&&k.push([F.assetType.substring(R.length),B]),k},[])}function D(_){if(_.properties){const R=_.properties.filter(F=>F.key===t.Repository),W=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),k=R.filter(F=>W.test(F.value))[0];return k?{uri:k.value,fallbackUri:k.value}:null}return H(_,t.Repository)}function T(_){return{uri:`${_.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${t.VSIX}`}}function U(_){const R=H(_,t.Icon);if(R)return R;const W=A.DefaultIconPath;return{uri:W,fallbackUri:W}}function H(_,R){return _.files.filter(k=>k.assetType===R)[0]?{uri:`${_.assetUri}/${R}`,fallbackUri:`${_.fallbackAssetUri}/${R}`}:null}function X(_,R){const W=_.properties?_.properties.filter(F=>F.key===R):[],k=W.length>0&&W[0].value;return k?k.split(",").map(F=>(0,L.adoptToGalleryExtensionId)(F)):[]}function te(_){const R=_.properties?_.properties.filter(W=>W.key===i.Engine):[];return R.length>0&&R[0].value||""}function se(_){const R=_.properties?_.properties.filter(k=>k.key===i.LocalizedLanguages):[],W=R.length>0&&R[0].value||"";return W?W.split(","):[]}function O(_){return _.indexOf("preview")!==-1}function z(_){const R=_.properties?_.properties.find(W=>W.key===i.WebExtension):void 0;return!!R&&R.value==="true"}function $(_){return _.files.some(R=>R.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(S.URI.parse(_.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function C(_,R,W,k,F){const B={manifest:H(R,t.Manifest),readme:H(R,t.Details),changelog:H(R,t.Changelog),license:H(R,t.License),repository:D(R),download:T(R),icon:U(R),coreTranslations:v(R)};return{identifier:{id:(0,L.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:R.version,date:R.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:f(_.statistics,"install"),rating:f(_.statistics,"averagerating"),ratingCount:f(_.statistics,"ratingcount"),assetUri:S.URI.parse(R.assetUri),webResource:$(R),assetTypes:R.files.map(({assetType:V})=>V),assets:B,properties:{dependencies:X(R,i.Dependency),extensionPack:X(R,i.ExtensionPack),engine:te(R),localizedLanguages:se(R),webExtension:z(R)},telemetryData:{index:(k.pageNumber-1)*k.pageSize+W,querySource:F},preview:O(_.flags)}}let q=class{constructor(R,W,k,F,B,V,G){this.requestService=R,this.logService=W,this.environmentService=k,this.telemetryService=F,this.fileService=B,this.productService=V;const Y=V.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=N(V.version,this.environmentService,this.fileService,G)}api(R=""){return`${this.extensionsGalleryUrl}${R}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(R,W){const k=[];let{total:F,firstPage:B,getPage:V}=await this.query({names:R,pageSize:R.length},W);k.push(...B);for(let G=1;k.length<F&&(B=await V(G,W),B.length);G++)k.push(...B);return k}async getCompatibleExtension(R,W){const k=await this.getCompatibleExtensionByEngine(R,W);return(k==null?void 0:k.properties.webExtension)?k.webResource?k:null:k}async getCompatibleExtensionByEngine(R,W){const k=(0,A.isIExtensionIdentifier)(R)?null:R;if(k&&k.properties.engine&&(0,w.isEngineValid)(k.properties.engine,this.productService.version))return k;const{id:F,uuid:B}=k?k.identifier:R;let V=new h().withFlags(l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");B?V=V.withFilter(u.ExtensionId,B):V=V.withFilter(u.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(V,n.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(W){const re=Y.versions.filter(oe=>oe.version===W)[0];if(re){const oe=C(Y,re,0,V);if(oe.properties.engine&&(0,w.isEngineValid)(oe.properties.engine,this.productService.version))return oe}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?C(Y,Z,0,V):null}async query(R,W){const k=n.CancellationToken.isCancellationToken(R)?{}:R,F=n.CancellationToken.isCancellationToken(R)?R:W;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=k.text||"";const V=(0,b.getOrDefault)(k,x=>x.pageSize,50);let G=new h().withFlags(l.IncludeLatestVersionOnly,l.IncludeAssetUri,l.IncludeStatistics,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,V).withFilter(u.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(u.Category,ue||ne),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(u.Tag,ue||ne),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(u.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(u.SearchText,B)),G=G.withSortBy(0)):k.ids?G=G.withFilter(u.ExtensionId,...k.ids):k.names?G=G.withFilter(u.ExtensionName,...k.names):G=G.withSortBy(4),typeof k.sortBy=="number"&&(G=G.withSortBy(k.sortBy)),typeof k.sortOrder=="number"&&(G=G.withSortOrder(k.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ne)=>C(x,x.versions[0],ne,G,k.source)),oe=async(x,ne)=>{if(ne.isCancellationRequested)throw(0,m.canceled)();const ue=G.withPage(x+1),{galleryExtensions:be}=await this.queryGallery(ue,ne);return be.map((me,Pe)=>C(me,me.versions[0],Pe,ue,k.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:oe}}async queryGallery(R,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");R=R.withFlags(R.flags,l.ExcludeNonValidated).withFilter(u.ExcludeWithFlags,a(l.Unpublished));const k=await this.commonHeadersPromise,F=JSON.stringify(R.raw),B=Object.assign(Object.assign({},k),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),V=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:B},W),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,r.asJson)(G);if(re){const oe=re.results[0],x=oe.extensions,ne=oe.resultMetadata&&oe.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ne&&ne.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},R.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-V,success:!!G&&(0,r.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,m.isPromiseCanceledError)(Y)?"canceled":(0,m.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(R,W,k,F){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,V=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${R}/extensions/${W}/${k}/stats?statType=${F}`),headers:V},n.CancellationToken.None)}catch(G){}}}async download(R,W,k){this.logService.trace("ExtensionGalleryService#download",R.identifier.id);const F=(0,L.getGalleryExtensionTelemetryData)(R),B=new Date().getTime(),V=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=k===1?"install":k===2?"update":"",Y=G?{uri:`${R.assets.download.uri}&${G}=true`,fallbackUri:`${R.assets.download.fallbackUri}?${G}=true`}:R.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(W,Z.stream),V(new Date().getTime()-B)}async getReadme(R,W){if(R.assets.readme){const k=await this.getAsset(R.assets.readme,{},W);return await(0,r.asText)(k)||""}return""}async getManifest(R,W){if(R.assets.manifest){const k=await this.getAsset(R.assets.manifest,{},W),F=await(0,r.asText)(k);return F?JSON.parse(F):null}return null}async getCoreTranslation(R,W){const k=R.assets.coreTranslations.filter(F=>F[0]===W.toUpperCase())[0];if(k){const F=await this.getAsset(k[1]),B=await(0,r.asText)(F);return B?JSON.parse(B):null}return null}async getChangelog(R,W){if(R.assets.changelog){const k=await this.getAsset(R.assets.changelog,{},W);return await(0,r.asText)(k)||""}return""}async getAllVersions(R,W){let k=new h().withFlags(l.IncludeVersions,l.IncludeFiles,l.IncludeVersionProperties).withPage(1,1).withFilter(u.Target,"Microsoft.VisualStudio.Code");R.identifier.uuid?k=k.withFilter(u.ExtensionId,R.identifier.uuid):k=k.withFilter(u.ExtensionName,R.identifier.id);const F=[],{galleryExtensions:B}=await this.queryGallery(k,n.CancellationToken.None);return B.length&&(W?await Promise.all(B[0].versions.map(async V=>{let G;try{G=await this.getEngine(V)}catch(Y){}G&&(0,w.isEngineValid)(G,this.productService.version)&&F.push({version:V.version,date:V.lastUpdated})})):F.push(...B[0].versions.map(V=>({version:V.version,date:V.lastUpdated})))),F}async getAsset(R,W={},k=n.CancellationToken.None){const F=await this.commonHeadersPromise,B={type:"GET"},V=Object.assign(Object.assign({},F),W.headers||{});W=Object.assign(Object.assign(Object.assign({},W),B),{headers:V});const G=R.uri,Y=R.fallbackUri,Z=Object.assign(Object.assign({},W),{url:G});try{const re=await this.requestService.request(Z,k);if(re.res.statusCode===200)return re;const oe=await(0,r.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${oe}`)}catch(re){if((0,m.isPromiseCanceledError)(re))throw re;const oe=(0,m.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:oe});const x=Object.assign(Object.assign({},W),{url:Y});return this.requestService.request(x,k)}}async getLastValidExtensionVersion(R,W){const k=this.getLastValidExtensionVersionFromProperties(R,W);return k||this.getLastValidExtensionVersionRecursively(R,W)}getLastValidExtensionVersionFromProperties(R,W){for(const k of W){const F=te(k);if(!F)return null;if((0,w.isEngineValid)(F,this.productService.version))return k}return null}async getEngine(R){const W=te(R);if(W)return W;const k=H(R,t.Manifest);if(!k)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},B=await this.getAsset(k,{headers:F}),V=await(0,r.asJson)(B);if(V)return V.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(R,W){if(!W.length)return null;const k=W[0],F=await this.getEngine(k);return(0,w.isEngineValid)(F,this.productService.version)?(k.properties=k.properties||[],k.properties.push({key:i.Engine,value:F}),k):this.getLastValidExtensionVersionRecursively(R,W.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const R=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(R.res.statusCode!==200)throw new Error("Could not get extensions report.");const W=await(0,r.asJson)(R),k=new Map;if(W)for(const F of W.malicious){const B=k.get(F)||{id:{id:F},malicious:!0,slow:!1};B.malicious=!0,k.set(F,B)}return[...k.values()]}};q=ce([ee(0,r.IRequestService),ee(1,y.ILogService),ee(2,p.IEnvironmentService),ee(3,M.ITelemetryService),ee(4,E.IFileService),ee(5,d.IProductService),ee(6,(0,I.optional)(g.IStorageService))],q),e.ExtensionGalleryService=q;async function N(_,R,W,k){const F={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},B=await(0,P.getServiceMachineId)(R,W,k);return F["X-Market-User-Id"]=B,F}e.resolveMarketplaceHeaders=N}),define(Q[198],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class m{constructor(b){this.appender=b}listen(b,M){throw new Error(`Event not found: ${M}`)}call(b,M,{eventName:r,data:w}){return this.appender.log(r,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=m;class A{constructor(b){this.channel=b}log(b,M){return this.channel.call("log",{eventName:b,data:M}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=A}),define(Q[199],J([0,1,46,146,22,4,17,47,2,44,37]),function(j,e,m,A,L,b,M,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(d,g){this._configurationService=g,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(P),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(P=>{const I=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!I})}))}setExperimentProperty(d,g){this._experimentProperties[d]=g}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const g=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let g=d.sessionID,P=d["common.instanceId"],I=d["common.machineId"],o=d["common.firstSessionDate"],l=d["common.msftInternal"];return{sessionId:g,instanceId:P,machineId:I,firstSessionDate:o,msftInternal:l}}dispose(){this._disposables.dispose()}publicLog(d,g,P){return this.isOptedIn?this._commonProperties.then(I=>{g=(0,p.mixin)(g,I),g=(0,p.mixin)(g,this._experimentProperties),g=(0,p.cloneAndChange)(g,o=>{if(typeof o=="string")return this._cleanupInfo(o,P)}),this._appender.log(d,g)},I=>{console.error(I)}):Promise.resolve(void 0)}publicLog2(d,g,P){return this.publicLog(d,g,P)}publicLogError(d,g){return this.sendErrorTelemetry?this.publicLog(d,g,!0):Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}_cleanupInfo(d,g){let P=d;if(g){const I=[];for(let u of this._cleanupPatterns)for(;;){const t=u.exec(d);if(!t)break;I.push([t.index,u.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(P="";;){const u=l.exec(d);if(!u)break;!o.test(u[0])&&I.every(([t,i])=>u.index<t||u.index>=i)&&(P+=d.substring(a,u.index)+"<REDACTED: user-file-path>",a=l.lastIndex)}a<d.length&&(P+=d.substr(a))}for(let I of this._cleanupPatterns)P=P.replace(I,"");return P}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ce([ee(1,(0,b.optional)(M.IConfigurationService))],y),e.TelemetryService=y;const E="telemetry";n.Registry.as(r.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:m.default.privacyStatementUrl?(0,A.localize)(2,null,m.default.privacyStatementUrl):(0,A.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[96],J([0,1,17,44,13,9]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,g){return Promise.resolve(void 0)}publicLog2(d,g){return this.publicLog(d,g)}publicLogError(d,g){return Promise.resolve(void 0)}publicLogError2(d,g){return this.publicLogError(d,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class M{async publicLog(g,P,I){}async publicLogError(g,P,I){}}e.NullEndpointTelemetryService=M;function r(...d){return{log:(g,P)=>d.forEach(I=>I.log(g,P)),flush:()=>b.Promises.settled(d.map(g=>g.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(d,g){return g.onDidChangeConfiguration(P=>{P.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,m.ConfigurationTargetToString)(P.source),configurationKeys:E(P.sourceConfig)})})}e.configurationTelemetry=w;function p(d){const g=Object.create(null),P=Object.create(null),I=Object.create(null);y(d,I);for(let o in I){o=o.length>150?o.substr(o.length-149):o;const l=I[o];typeof l=="number"?P[o]=l:typeof l=="boolean"?P[o]=l?1:0:typeof l=="string"?g[o]=l.substring(0,1023):typeof l!="undefined"&&l!==null&&(g[o]=l)}return{properties:g,measurements:P}}e.validateTelemetryData=p;function n(d){if(!d)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(I=>{d.indexOf(`${I}+`)===0&&(g=I)}),g}e.cleanRemoteAuthority=n;function y(d,g,P=0,I){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const l=d[o],a=I?I+o:o;Array.isArray(l)?g[a]=(0,A.safeStringify)(l):l instanceof Date?g[a]=l.toISOString():(0,L.isObject)(l)?P<2?y(l,g,P+1,a+"."):g[a]=(0,A.safeStringify)(l):g[a]=l}}function E(d){if(!d)return[];const g=[];return S(g,"",d),g}function S(d,g,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(I=>S(d,g?`${g}.${I}`:I,P[I])):d.push(g)}}),define(Q[200],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var m;(function(A){A.DARK="dark",A.LIGHT="light",A.HIGH_CONTRAST="hc"})(m=e.ColorScheme||(e.ColorScheme={}))}),define(Q[201],J([0,1,4,2,37,5,200,107]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,m.createDecorator)("themeService");var w;(function(P){function I(o){return o&&typeof o=="object"&&typeof o.id=="string"}P.isThemeColor=I})(w=e.ThemeColor||(e.ThemeColor={}));function p(P){return{id:P}}e.themeColorFromId=p;var n;(function(P){function I(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||w.isThemeColor(t.color))}P.isThemeIcon=I;const o=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function l(t){const i=o.exec(t);if(!!i){let[,s]=i;return{id:s}}}P.fromString=l;function a(t,i){let s=t.id;const c=s.lastIndexOf("~");return c!==-1&&(s=s.substring(0,c)),i&&(s=`${s}~${i}`),{id:s}}P.modify=a;function u(t,i){var s,c;return t.id===i.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((c=i.color)===null||c===void 0?void 0:c.id)}P.isEqual=u,P.asClassNameArray=r.CSSIcon.asClassNameArray,P.asClassName=r.CSSIcon.asClassName,P.asCSSSelector=r.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function y(P){switch(P){case M.ColorScheme.DARK:return"vs-dark";case M.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new b.Emitter}onColorThemeChange(I){return this.themingParticipants.push(I),this.onThemingParticipantAddedEmitter.fire(I),(0,A.toDisposable)(()=>{const o=this.themingParticipants.indexOf(I);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new E;L.Registry.add(e.Extensions.ThemingContribution,S);function d(P){return S.onColorThemeChange(P)}e.registerThemingParticipant=d;class g extends A.Disposable{constructor(I){super();this.themeService=I,this.theme=I.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(I){this.theme=I,this.updateStyles()}updateStyles(){}getColor(I,o){let l=this.theme.getColor(I);return l&&o&&(l=o(l,this.theme)),l?l.toString():null}}e.Themable=g}),define(Q[75],J([0,1,3,14,38,4]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const M="#FFFFFF",r="#1E1E1E",w="#000000",p="theme",n="themeBackground";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let y=class{constructor(S){this.stateMainService=S,A.ipcMain.on("vscode:changeColorTheme",(d,g,P)=>{if(typeof P=="string"){const I=JSON.parse(P);this.storeBackgroundColor(I),this.updateBackgroundColor(g,I)}})}storeBackgroundColor(S){this.stateMainService.setItem(p,S.baseTheme),this.stateMainService.setItem(n,S.background)}updateBackgroundColor(S,d){A.BrowserWindow.getAllWindows().forEach(g=>{g.id===S&&g.setBackgroundColor(d.background)})}getBackgroundColor(){if((m.isWindows||m.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme)return w;let S=this.stateMainService.getItem(n,null);if(!S){let d;(m.isWindows||m.isMacintosh)&&A.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],S=d==="hc-black"?w:d==="vs"?M:r}return m.isMacintosh&&S.toUpperCase()===r&&(S="#171717"),S}};y=ce([ee(0,L.IStateMainService)],y),e.ThemeMainService=y}),define(Q[40],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var A;(function(b){b.Uninitialized="uninitialized",b.Idle="idle",b.CheckingForUpdates="checking for updates",b.AvailableForDownload="available for download",b.Downloading="downloading",b.Downloaded="downloaded",b.Updating="updating",b.Ready="ready"})(A=e.StateType||(e.StateType={}));var L;(function(b){b[b.Setup=0]="Setup",b[b.Archive=1]="Archive",b[b.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(b,M)=>({type:"idle",updateType:b,error:M}),CheckingForUpdates:b=>({type:"checking for updates",explicit:b}),AvailableForDownload:b=>({type:"available for download",update:b}),Downloading:b=>({type:"downloading",update:b}),Downloaded:b=>({type:"downloaded",update:b}),Updating:b=>({type:"updating",update:b}),Ready:b=>({type:"ready",update:b})},e.IUpdateService=(0,m.createDecorator)("updateService")}),define(Q[202],J([0,1,37,47,147,3]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),m.Registry.as(A.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:b.isWindows&&!b.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[203],J([0,1,5,40]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(r){this.service=r}listen(r,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=L;class b{constructor(r){this.channel=r,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,this._state=A.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=b}),define(Q[97],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,m.createDecorator)("urlService")}),define(Q[204],J([0,1,8]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class A{constructor(r){this.handler=r}listen(r,w){throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"handleURL":return this.handler.handleURL(m.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=A;class L{constructor(r){this.channel=r}handleURL(r,w){return this.channel.call("handleURL",[r.toJSON(),w])}}e.URLHandlerChannelClient=L;class b{constructor(r){this.next=r}async routeCall(r,w,p,n){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(p){const y=m.URI.revive(p);if(y&&y.query){const E=/\bwindowId=(\d+)/.exec(y.query);if(E){const S=E[1],d=new RegExp(`window:${S}`),g=r.connections.find(P=>d.test(P.ctx));if(g)return g}}}return this.next.routeCall(r,w,p,n)}routeEvent(r,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=b}),define(Q[205],J([0,1,8,9,2,21]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,n){const y=[...this.handlers.values()];return(0,A.first)(y.map(E=>()=>E.handleURL(p,n)),void 0,!1).then(E=>E||!1)}registerHandler(p){return this.handlers.add(p),(0,L.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=M;let r=class extends M{constructor(p){super();this.productService=p}create(p){let{authority:n,path:y,query:E,fragment:S}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return n&&y&&y.indexOf("/")!==0&&(y=`/${y}`),m.URI.from({scheme:this.productService.urlProtocol,authority:n,path:y,query:E,fragment:S})}};r=ce([ee(0,b.IProductService)],r),e.NativeURLService=r}),define(Q[206],J([0,1,5,14,8,2,3,9]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(n){try{return L.URI.parse(n)}catch(y){return null}}class p{constructor(y,E,S,d,g){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=b.Disposable.None,this.disposables=new b.DisposableStore,this.uris=y,M.isWindows){const o=d.isBuilt?[]:[`"${d.appRoot}"`];o.push("--open-url","--"),A.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,o)}const P=m.Event.map(m.Event.fromNodeEventEmitter(A.app,"open-url",(o,l)=>({event:o,url:l})),({event:o,url:l})=>(o.preventDefault(),l));this.disposables.add(P(o=>{const l=w(o);!l||this.urlService.open(l,{originalUrl:o})})),S.getWindows().filter(o=>o.isReady).length>0?this.flush():m.Event.once(S.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const y=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||y.push(E);y.length!==0&&(this.uris=y,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Q[76],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,m.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(Q[207],J([0,1,14,2,10,8,76]),function(j,e,m,A,L,b,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends A.Disposable{constructor(){super();const p=m.session.fromPartition(M.webviewPartitionId),n=this.handleWebviewRequest.bind(this);m.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n),p.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n)}async handleWebviewRequest(p,n){try{const y=b.URI.parse(p.url),E=r.validWebviewFilePaths.get(y.path);if(typeof E=="string"){const S=y.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${E}`:`vs/workbench/contrib/webview/browser/pre/${E}`,d=L.FileAccess.asFileUri(S,j);return n(decodeURIComponent(d.fsPath))}}catch(y){}n({error:-10})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(Q[60],J([0,1,3]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function A(p){return!!p.workspaceUri}e.isWorkspaceToOpen=A;function L(p){return!!p.folderUri}e.isFolderToOpen=L;function b(p){return!!p.fileUri}e.isFileToOpen=b;function M(p){const n=r(p),y=p.getValue("window.menuBarVisibility");return y==="default"||n==="native"&&y==="compact"||m.isMacintosh&&m.isNative?"classic":y}e.getMenuBarVisibility=M;function r(p){if(m.isWeb)return"custom";const n=p.getValue("window");if(n){if(m.isMacintosh&&n.nativeTabs===!0||m.isMacintosh&&n.nativeFullScreen===!1)return"native";const S=n.titleBarStyle;if(S==="native"||S==="custom")return S}return m.isLinux?"native":"custom"}e.getTitleBarStyle=r;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(Q[34],J([0,1,4]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var A;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(A=e.OpenContext||(e.OpenContext={}));const L=function(r=1){return{width:1024,height:768,mode:r}};e.defaultWindowState=L;var b;(function(r){r[r.Maximized=0]="Maximized",r[r.Normal=1]="Normal",r[r.Minimized=2]="Minimized",r[r.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var M;(function(r){r[r.UNRESPONSIVE=1]="UNRESPONSIVE",r[r.CRASHED=2]="CRASHED",r[r.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,m.createDecorator)("windowsMainService")}),define(Q[208],J([0,1,14,2,73,76,207,34]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends A.Disposable{constructor(n,y){super();this.windowsMainService=y,this._register(new M.WebviewProtocolProvider);const E=m.session.fromPartition(b.webviewPartitionId);E.setPermissionRequestHandler((S,d,g)=>g(d==="clipboard-read")),E.setPermissionCheckHandler((S,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(n,y){let E;if(typeof n.windowId=="number"){const{windowId:S}=n,d=this.windowsMainService.getWindowById(S);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${S}`);E=d.win.webContents}else{const{webContentsId:S}=n;if(E=m.webContents.fromId(S),!E)throw new Error(`Invalid webContentsId: ${S}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(y)}};w=ce([ee(0,L.ITunnelService),ee(1,r.IWindowsMainService)],w),e.WebviewMainService=w}),define(Q[209],J([0,1,5,2,9]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class b extends A.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:w,getActiveWindowId:p}){super();this.disposables=this._register(new A.DisposableStore),m.Event.latch(m.Event.any(r,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>p()),(async()=>{try{const y=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:y}catch(y){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=b}),define(Q[210],J([0,1,8,15,4,36]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var M;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(M=e.WorkbenchState||(e.WorkbenchState={}));function r(E){const S=E;return!!(S&&typeof S=="object"&&typeof S.id=="string"&&Array.isArray(S.folders))}e.isWorkspace=r;function w(E){const S=E;return!!(S&&typeof S=="object"&&m.URI.isUri(S.uri)&&typeof S.name=="string"&&typeof S.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(S,d,g,P){this._id=S,this._configuration=g,this._ignorePathCasing=P,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(S){this._id=S.id,this._configuration=S.configuration,this._ignorePathCasing=S._ignorePathCasing,this.folders=S.folders}get folders(){return this._folders}set folders(S){this._folders=S,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(S){this._configuration=S}getFolder(S){return S&&this._foldersMap.findSubstr(S.with({scheme:S.scheme,authority:S.authority,path:S.path}))||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing);for(const S of this.folders)this._foldersMap.set(S.uri,S)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class n{constructor(S,d){this.raw=d,this.uri=S.uri,this.index=S.index,this.name=S.name}toResource(S){return(0,A.joinPath)(this.uri,S)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function y(E){return new n({uri:E,index:0,name:(0,A.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=y}),define(Q[29],J([0,1,4,150,210,8,3,7,15,103,43,10,39,30,72]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function P($){return(typeof $=="string"?(0,r.extname)($):(0,w.extname)($))===g}e.hasWorkspaceFileExtension=P,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function I($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=I;function o($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=o;function l($){return $.hasOwnProperty("fileUri")}e.isRecentFile=l;function a($){const C=$;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.uri)}e.isSingleFolderWorkspaceIdentifier=a;function u($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=u;function t($){const C=$;return typeof(C==null?void 0:C.id)=="string"&&b.URI.isUri(C.configPath)}e.isWorkspaceIdentifier=t;function i($){const C=$;if(C==null?void 0:C.uri)return{id:C.id,uri:b.URI.revive(C.uri)};const q=$;if(q==null?void 0:q.configPath)return{id:q.id,configPath:b.URI.revive(q.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=i;function s($,C){return w.extUriBiasedIgnorePathCase.isEqualOrParent($,C.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function c($){return h($)||f($)}e.isStoredWorkspaceFolder=c;function h($){const C=$;return typeof(C==null?void 0:C.path)=="string"&&(!C.name||typeof C.name=="string")}e.isRawFileWorkspaceFolder=h;function f($){const C=$;return typeof(C==null?void 0:C.uri)=="string"&&(!C.name||typeof C.name=="string")}e.isRawUriWorkspaceFolder=f;function v($,C,q,N,_=!M.isWindows,R){if($.scheme!==N.scheme)return{name:q,uri:$.toString(!0)};let W=C?void 0:R.relativePath(N,$);if(W!==void 0)W.length===0?W=".":M.isWindows&&$.scheme===y.Schemas.file&&!_&&(W=W.replace(/\//g,"\\"));else if($.scheme===y.Schemas.file)W=$.fsPath,M.isWindows&&(W=(0,E.normalizeDriveLetter)(W),_&&(W=(0,S.toSlashes)(W)));else{if(!R.isEqualAuthority($.authority,N.authority))return{name:q,uri:$.toString(!0)};W=$.path}return{name:q,path:W}}e.getStoredWorkspaceFolder=v;function D($,C,q){let N=[],_=new Set;const R=q.dirname(C);for(let W of $){let k;if(h(W))W.path&&(k=q.resolvePath(R,W.path));else if(f(W))try{k=b.URI.parse(W.uri),k.path[0]!=="/"&&(k=k.with({path:"/"+k.path}))}catch(F){console.warn(F)}if(k){let F=q.getComparisonKey(k);if(!_.has(F)){_.add(F);const B=W.name||q.basenameOrAuthority(k);N.push(new L.WorkspaceFolder({uri:k,name:B,index:N.length},W))}}}return N}e.toWorkspaceFolders=D;function T($,C,q,N,_){let R=U(C,$);const W=_.dirname(C),k=_.dirname(N),F=[],B=H(R.folders);for(const Z of R.folders){const re=h(Z)?_.resolvePath(W,Z.path):b.URI.parse(Z.uri);let oe;q?oe=!1:oe=!h(Z)||(0,r.isAbsolute)(Z.path),F.push(v(re,oe,Z.name,k,B,_))}const V={insertSpaces:!1,tabSize:4,eol:M.isLinux||M.isMacintosh?`
`:`\r
`},G=p.setProperty($,["folders"],F,V);let Y=p.applyEdits($,G);return R.remoteAuthority===(0,d.getRemoteAuthority)(N)&&(Y=p.applyEdits(Y,p.removeProperty(Y,["remoteAuthority"],V))),Y}e.rewriteWorkspaceFileForNewLocation=T;function U($,C){let q=n.parse(C);if(q&&Array.isArray(q.folders))q.folders=q.folders.filter(N=>c(N));else throw new Error(`${$} looks like an invalid workspace file.`);return q}function H($){return M.isWindows?$.some(C=>h(C)&&C.path.indexOf("/")>=0):!0}e.useSlashForPath=H;function X($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function te($){return typeof $.folderUri=="string"}function se($){return typeof $.fileUri=="string"}function O($,C){const q={workspaces:[],files:[]};if($){const N=function(R,W){for(let k=0;k<R.length;k++)try{W(R[k],k)}catch(F){C.warn(`Error restoring recent entry ${JSON.stringify(R[k])}: ${F.toString()}. Skip entry.`)}},_=$;if(Array.isArray(_.entries))N(_.entries,R=>{const W=R.label,k=R.remoteAuthority;X(R)?q.workspaces.push({label:W,remoteAuthority:k,workspace:{id:R.workspace.id,configPath:b.URI.parse(R.workspace.configPath)}}):te(R)?q.workspaces.push({label:W,remoteAuthority:k,folderUri:b.URI.parse(R.folderUri)}):se(R)&&q.files.push({label:W,remoteAuthority:k,fileUri:b.URI.parse(R.fileUri)})});else{const R=$;Array.isArray(R.workspaces3)&&N(R.workspaces3,(W,k)=>{const F=Array.isArray(R.workspaceLabels)&&R.workspaceLabels[k]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?q.workspaces.push({label:F,workspace:{id:W.id,configPath:b.URI.parse(W.configURIPath)}}):typeof W=="string"&&q.workspaces.push({label:F,folderUri:b.URI.parse(W)})}),Array.isArray(R.files2)&&N(R.files2,(W,k)=>{const F=Array.isArray(R.fileLabels)&&R.fileLabels[k]||void 0;typeof W=="string"&&q.files.push({label:F,fileUri:b.URI.parse(W)})})}}return q}e.restoreRecentlyOpened=O;function z($){const C={entries:[]};for(const q of $.workspaces)o(q)?C.entries.push({folderUri:q.folderUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority}):C.entries.push({workspace:{id:q.workspace.id,configPath:q.workspace.configPath.toString()},label:q.label,remoteAuthority:q.remoteAuthority});for(const q of $.files)C.entries.push({fileUri:q.fileUri.toString(),label:q.label,remoteAuthority:q.remoteAuthority});return C}e.toStoreData=z}),define(Q[49],J([0,1,4,29]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,m.createDecorator)("backupMainService");function L(b){const M=b;return M&&(0,A.isWorkspaceIdentifier)(M.workspace)}e.isWorkspaceBackupInfo=L}),define(Q[50],J([0,1,4,14,9,38,3,7,64,16,13,133,29,39,2,80]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let P=class gt{constructor(o){this.stateMainService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(o,l){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)}),l)}pickFolder(o,l){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,y.localize)(1,null)}),l)}pickFile(o,l){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,y.localize)(2,null)}),l)}pickWorkspace(o,l){const a=(0,y.localize)(3,null),u=(0,S.mnemonicButtonLabel)((0,y.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:a,filters:t,buttonLabel:u}),l)}async doPick(o,l){const a={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};a.defaultPath=o.defaultPath||this.stateMainService.getItem(gt.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(a.properties=void 0,o.pickFiles&&o.pickFolders&&(a.properties=["multiSelections","openDirectory","openFile","createDirectory"])),a.properties||(a.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),M.isMacintosh&&a.properties.push("treatPackageAsDirectory");const u=l||A.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(a,(0,n.withNullAsUndefined)(u));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(gt.workingDirPickerStorageKey,(0,r.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let l=this.windowDialogQueues.get(o.id);return l||(l=new L.Queue,this.windowDialogQueues.set(o.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(o,l){return this.getWindowDialogQueue(l).queue(async()=>l?A.dialog.showMessageBox(l,o):A.dialog.showMessageBox(o))}async showSaveDialog(o,l){const a=this.acquireFileDialogLock(o,l);if(!a)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let u;return l?u=await A.dialog.showSaveDialog(l,o):u=await A.dialog.showSaveDialog(o),u.filePath=this.normalizePath(u.filePath),u})}finally{(0,d.dispose)(a)}}normalizePath(o){return o&&M.isMacintosh&&(o=(0,w.normalizeNFC)(o)),o}normalizePaths(o){return o.map(l=>this.normalizePath(l))}async showOpenDialog(o,l){o.defaultPath&&(await(0,p.exists)(o.defaultPath)||(o.defaultPath=void 0));const a=this.acquireFileDialogLock(o,l);if(!a)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(l).queue(async()=>{let u;return l?u=await A.dialog.showOpenDialog(l,o):u=await A.dialog.showOpenDialog(o),u.filePaths=this.normalizePaths(u.filePaths),u})}finally{(0,d.dispose)(a)}}acquireFileDialogLock(o,l){if(!l)return d.Disposable.None;let a=this.windowFileDialogLocks.get(l.id);a||(a=new Set,this.windowFileDialogLocks.set(l.id,a));const u=(0,g.hash)(o);if(!a.has(u))return a.add(u),(0,d.toDisposable)(()=>{a==null||a.delete(u),(a==null?void 0:a.size)===0&&this.windowFileDialogLocks.delete(l.id)})}};P.workingDirPickerStorageKey="pickerWorkingDir",P=ce([ee(0,b.IStateMainService)],P),e.DialogMainService=P}),define(Q[211],J([0,1,5,2,29]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class b extends A.Disposable{constructor(r,w){super();this.logService=r,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new m.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(m.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,w)=>(r?r.push(w):r=[w],r),b.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const w=new Map,p=new Set;return r.forEach(n=>{const y=this.storageMainService.globalStorage.get(n.key);typeof y=="string"?w.set(n.key,y):p.add(n.key)}),{changed:Array.from(w.entries()),deleted:Array.from(p.values())}}listen(r,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(r,w,p){const n=(0,L.reviveIdentifier)(p.workspace),y=await this.withStorageInitialized(n);switch(w){case"getItems":return Array.from(y.items.entries());case"updateItems":{const E=p;if(E.insert)for(const[S,d]of E.insert)y.set(S,d);E.delete&&E.delete.forEach(S=>y.delete(S));break}case"close":{if(n)return y.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(r){const w=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await w.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${p}`)}return w}}e.StorageDatabaseChannel=b,b.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[212],J([0,1,20,16,5,2,6,123,85,7,95,31,28,29]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends b.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new w.Storage(new w.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(a=>this._onDidChangeStorage.fire({key:a}))),await this.doInit(o);const l=o.getBoolean(n.IS_NEW_KEY);l===void 0?o.set(n.IS_NEW_KEY,!0):l&&o.set(n.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===M.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,l){return this.storage.get(o,l)}set(o,l){return this.storage.set(o,l)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class g extends d{constructor(o,l,a){super(l);this.options=o,this.environmentService=a}async doCreate(){let o;return this.options.useInMemoryStorage?o=r.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,p.join)(this.environmentService.globalStorageHome.fsPath,g.STORAGE_NAME),new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(y.instanceStorageKey,void 0)===void 0&&o.set(y.instanceStorageKey,(0,E.generateUuid)()),o.get(y.firstSessionDateStorageKey,void 0)===void 0&&o.set(y.firstSessionDateStorageKey,new Date().toUTCString());const u=o.get(y.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(y.lastSessionDateStorageKey,typeof u=="undefined"?null:u),o.set(y.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=g,g.STORAGE_NAME="state.vscdb";class P extends d{constructor(o,l,a,u){super(a);this.workspace=o,this.options=l,this.environmentService=u}async doCreate(){const{storageFilePath:o,wasCreated:l}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:l?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:r.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),l=(0,p.join)(o,P.WORKSPACE_STORAGE_NAME);return await(0,A.exists)(o)?{storageFilePath:l,wasCreated:!1}:(await m.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:l,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let l;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?l={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(l={workspace:this.workspace.configPath.toString()}),l)try{const a=(0,p.join)(o,P.WORKSPACE_META_NAME);await(0,A.exists)(a)||await(0,A.writeFile)(a,JSON.stringify(l,void 0,2))}catch(a){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${a}`)}}}e.WorkspaceStorageMain=P,P.WORKSPACE_STORAGE_NAME="state.vscdb",P.WORKSPACE_META_NAME="workspace.json"}),define(Q[98],J([0,1,42,2,53,4,18,6,212]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,b.createDecorator)("storageMainService");let p=class extends A.Disposable{constructor(y,E,S){super();this.logService=y,this.environmentService=E,this.lifecycleMainService=S,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async y=>{y.workspace&&this.workspaceStorage(y.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(y=>{y.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)y.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const y=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,m.once)(y.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),y}createWorkspaceStorage(y){return new w.WorkspaceStorageMain(y,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(y){let E=this.mapWorkspaceToStorage.get(y.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${y.id})`),E=this.createWorkspaceStorage(y),this.mapWorkspaceToStorage.set(y.id,E),(0,m.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${y.id})`),this.mapWorkspaceToStorage.delete(y.id)})),E}};p=ce([ee(0,r.ILogService),ee(1,L.IEnvironmentService),ee(2,M.ILifecycleMainService)],p),e.StorageMainService=p}),define(Q[99],J([0,1,8,29,15]),function(j,e,m,A,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function b(w,p,n){for(const E of w){const S=E.openedWorkspace;if((0,A.isWorkspaceIdentifier)(S)){const d=n(S);if(d){if(d.folders.some(g=>L.extUriBiasedIgnorePathCase.isEqualOrParent(p,g.uri)))return E}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(p,S.configPath))return E}}const y=w.filter(E=>(0,A.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(p,E.openedWorkspace.uri));if(y.length)return y.sort((E,S)=>-(E.openedWorkspace.uri.path.length-S.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=b;function M(w,p){for(const n of w)if((0,A.isWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,p)||(0,A.isSingleFolderWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.uri,p))return n}e.findWindowOnWorkspaceOrFolder=M;function r(w,p){var n,y;const E=S=>p.some(d=>L.extUriBiasedIgnorePathCase.isEqual(m.URI.file(d),m.URI.file(S)));for(const S of w)if((y=(n=S.config)===null||n===void 0?void 0:n.extensionDevelopmentPath)===null||y===void 0?void 0:y.some(d=>E(d)))return S}e.findWindowOnExtensionDevelopmentPath=r}),define(Q[213],J([0,1,14,2,3,15,8,17,18,6,38,34,29]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let S=class mt extends A.Disposable{constructor(l,a,u,t,i){super();this.windowsMainService=l,this.stateMainService=a,this.lifecycleMainService=u,this.logService=t,this.configurationService=i,this._state=d(this.stateMainService.getItem(mt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){m.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(l=>this.onBeforeCloseWindow(l)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(l=>{l.newCount-l.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(l=>this.onBeforeCloseWindow(l))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const l={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!l.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),t&&(l.lastActiveWindow=this.toWindowState(t))}const a=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);a&&(l.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(l.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const u=P(l);this.stateMainService.setItem(mt.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(l){if(!this.lifecycleMainService.quitRequested){const a=this.toWindowState(l);l.isExtensionDevelopmentHost&&!l.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!l.isExtensionDevelopmentHost&&l.openedWorkspace&&this._state.openedWindows.forEach(u=>{var t;const i=(0,E.isWorkspaceIdentifier)(l.openedWorkspace)&&((t=u.workspace)===null||t===void 0?void 0:t.id)===l.openedWorkspace.id,s=(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)&&u.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(u.folderUri,l.openedWorkspace.uri);(i||s)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}}toWindowState(l){return{workspace:(0,E.isWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(l.openedWorkspace)?l.openedWorkspace.uri:void 0,backupPath:l.backupPath,remoteAuthority:l.remoteAuthority,uiState:l.serializeWindowState()}}getNewWindowState(l){const a=this.doGetNewWindowState(l),u=this.configurationService.getValue("window");let t;return a.hasDefaultState?t=!!((u==null?void 0:u.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(u==null?void 0:u.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(t=!1)),a.mode===3&&!t&&(a.mode=1),a}doGetNewWindowState(l){const a=this.windowsMainService.getLastActiveWindow();if(!l.extensionTestsPath){if(!!l.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=l.workspace;if((0,E.isWorkspaceIdentifier)(h)){const v=this.state.openedWindows.filter(D=>D.workspace&&D.workspace.id===h.id).map(D=>D.uiState);if(v.length)return v[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(h)){const v=this.state.openedWindows.filter(D=>D.folderUri&&b.extUriBiasedIgnorePathCase.isEqual(D.folderUri,h.uri)).map(D=>D.uiState);if(v.length)return v[0]}else if(l.backupPath){const v=this.state.openedWindows.filter(D=>D.backupPath===l.backupPath).map(D=>D.uiState);if(v.length)return v[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!a&&f)return f.uiState}let u;const t=m.screen.getAllDisplays();if(t.length===1)u=t[0];else{if(L.isMacintosh){const h=m.screen.getCursorScreenPoint();u=m.screen.getDisplayNearestPoint(h)}!u&&a&&(u=m.screen.getDisplayMatching(a.getBounds())),u||(u=m.screen.getPrimaryDisplay()||t[0])}let i=(0,y.defaultWindowState)();i.x=Math.round(u.bounds.x+u.bounds.width/2-i.width/2),i.y=Math.round(u.bounds.y+u.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let c=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,c=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,c=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&a){const h=a.serializeWindowState();h.mode===3?i.mode=3:i=h,c=i.mode!==3&&s.newWindowDimensions==="offset"}}return c&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(l){if(this.windowsMainService.getWindows().length===0)return l;l.x=typeof l.x=="number"?l.x:0,l.y=typeof l.y=="number"?l.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===l.x||u.y===l.y);)l.x+=30,l.y+=30;return l}};S.windowsStateStorageKey="windowsState",S=ce([ee(0,y.IWindowsMainService),ee(1,n.IStateMainService),ee(2,w.ILifecycleMainService),ee(3,p.ILogService),ee(4,r.IConfigurationService)],S),e.WindowsStateHandler=S;function d(o){const l={openedWindows:[]},a=o||{openedWindows:[]};return a.lastActiveWindow&&(l.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(l.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(l.openedWindows=a.openedWindows.map(u=>g(u))),l}e.restoreWindowsState=d;function g(o){const l={uiState:o.uiState};return o.backupPath&&(l.backupPath=o.backupPath),o.remoteAuthority&&(l.remoteAuthority=o.remoteAuthority),o.folder&&(l.folderUri=M.URI.parse(o.folder)),o.workspaceIdentifier&&(l.workspace={id:o.workspaceIdentifier.id,configPath:M.URI.parse(o.workspaceIdentifier.configURIPath)}),l}function P(o){return{lastActiveWindow:o.lastActiveWindow&&I(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&I(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(l=>I(l))}}e.getWindowsStateStoreData=P;function I(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(Q[56],J([0,1,58,59,214,5,33,7,27,28,2,23,83,19,3]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(v){this.socket=v,this._errorListener=D=>{if(D){if(D.code==="EPIPE")return;(0,S.onUnexpectedError)(D)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const D=T=>v(y.VSBuffer.wrap(T));return this.socket.on("data",D),{dispose:()=>this.socket.off("data",D)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,D=>{if(D){if(D.code==="EPIPE")return;(0,S.onUnexpectedError)(D)}})}catch(D){if(D.code==="EPIPE")return;(0,S.onUnexpectedError)(D)}}end(){this.socket.end()}drain(){return new Promise((v,D)=>{if(this.socket.bufferSize===0){v();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),v()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=g;var P;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(P||(P={}));var I;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(I||(I={}));class o extends n.Disposable{constructor(v,D,T,U){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=D,this._recordInflateBytes=U,D?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",H=>{console.error(H),(0,S.onUnexpectedError)(H),this._onClose.fire()}),this._zlibInflate.on("data",H=>{this._pendingInflateData.push(H)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",H=>{console.error(H),(0,S.onUnexpectedError)(H),this._onClose.fire()}),this._zlibDeflate.on("data",H=>{this._pendingDeflateData.push(H)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(H=>this._acceptChunk(H))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?y.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):y.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let D=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,D=D.slice(0,D.length-4),this._isEnded||this._write(y.VSBuffer.wrap(D),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,D){let T=2;v.byteLength<126?T+=0:v.byteLength<2**16?T+=2:T+=8;const U=y.VSBuffer.alloc(T);if(D?U.writeUInt8(194,0):U.writeUInt8(130,0),v.byteLength<126)U.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){U.writeUInt8(126,1);let H=1;U.writeUInt8(v.byteLength>>>8&255,++H),U.writeUInt8(v.byteLength>>>0&255,++H)}else{U.writeUInt8(127,1);let H=1;U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(0,++H),U.writeUInt8(v.byteLength>>>24&255,++H),U.writeUInt8(v.byteLength>>>16&255,++H),U.writeUInt8(v.byteLength>>>8&255,++H),U.writeUInt8(v.byteLength>>>0&255,++H)}this._totalOutgoingWireBytes+=U.byteLength+v.byteLength,this.socket.write(y.VSBuffer.concat([U,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const D=this._incomingData.peek(this._state.readLen),U=(D.readUInt8(0)&128)>>>7,H=D.readUInt8(1),X=(H&128)>>>7,te=H&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const D=this._incomingData.read(this._state.readLen),T=D.readUInt8(1),U=(T&128)>>>7;let H=T&127,X=1;H===126?H=D.readUInt8(++X)*2**8+D.readUInt8(++X):H===127&&(H=D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*0+D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X));let te=0;U&&(te=D.readUInt8(++X)*2**24+D.readUInt8(++X)*2**16+D.readUInt8(++X)*2**8+D.readUInt8(++X)),this._state.state=3,this._state.readLen=H,this._state.mask=te}else if(this._state.state===3){const D=this._incomingData.read(this._state.readLen);l(D,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(D.buffer)),this._zlibInflate.write(D.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(y.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=D.byteLength,this._onData.fire(D))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function l(f,v){if(v!==0){let D=f.byteLength>>>2;for(let se=0;se<D;se++){const O=f.readUInt32BE(se*4);f.writeUInt32BE(O^v,se*4)}let T=D*4,U=f.byteLength-T;const H=v>>>24&255,X=v>>>16&255,te=v>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(T)^H,T),U>=2&&f.writeUInt8(f.readUInt8(T+1)^X,T+1),U>=3&&f.writeUInt8(f.readUInt8(T+2)^te,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function u(){const f=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let v;return e.XDG_RUNTIME_DIR?v=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):v=(0,r.join)((0,w.tmpdir)(),`vscode-ipc-${f}.sock`),i(v),v}e.createRandomIPCHandle=u;function t(f,v,D){const T=(0,m.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${D}-${v}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${D}-${v}.sock`):U=(0,r.join)(f,`${D}-${v}.sock`),i(U),U}e.createStaticIPCHandle=t;function i(f){const v=a[d.platform];typeof v=="number"&&f.length>=v&&console.warn(`WARNING: IPC handle "${f}" is longer than ${v} chars, try a shorter --user-data-dir`)}class s extends M.IPCServer{constructor(v){super(s.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const D=b.Event.fromNodeEventEmitter(v,"connection");return b.Event.map(D,T=>({protocol:new E.Protocol(new g(T)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function c(f){return new Promise((v,D)=>{const T=(0,A.createServer)();T.on("error",D),T.listen(f,()=>{T.removeListener("error",D),v(new s(T))})})}e.serve=c;function h(f,v){return new Promise((D,T)=>{const U=(0,A.createConnection)(f,()=>{U.removeListener("error",T),D(E.Client.fromSocket(new g(U),v))});U.once("error",T)})}e.connect=h}),define(Q[215],J([0,1,56]),function(j,e,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class A{constructor(w){this.driver=w}listen(w,p){throw new Error("No event found")}call(w,p,n){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(n);case"reloadWindow":return this.driver.reloadWindow(n);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(n[0],n[1]);case"click":return this.driver.click(n[0],n[1],n[2],n[3]);case"doubleClick":return this.driver.doubleClick(n[0],n[1]);case"setValue":return this.driver.setValue(n[0],n[1],n[2]);case"getTitle":return this.driver.getTitle(n[0]);case"isActiveElement":return this.driver.isActiveElement(n[0],n[1]);case"getElements":return this.driver.getElements(n[0],n[1],n[2]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1],n[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n[0],n[1]);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1],n[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=A;class L{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,p){return this.channel.call("dispatchKeybinding",[w,p])}click(w,p,n,y){return this.channel.call("click",[w,p,n,y])}doubleClick(w,p){return this.channel.call("doubleClick",[w,p])}setValue(w,p,n){return this.channel.call("setValue",[w,p,n])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,p){return this.channel.call("isActiveElement",[w,p])}getElements(w,p,n){return this.channel.call("getElements",[w,p,n])}getElementXY(w,p,n,y){return this.channel.call("getElementXY",[w,p,n,y])}typeInEditor(w,p,n){return this.channel.call("typeInEditor",[w,p,n])}getTerminalBuffer(w,p){return this.channel.call("getTerminalBuffer",[w,p])}writeInTerminal(w,p,n){return this.channel.call("writeInTerminal",[w,p,n])}}e.DriverChannelClient=L;class b{constructor(w){this.registry=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,n){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(n);case"reloadWindowDriver":return this.registry.reloadWindowDriver(n)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=b;async function M(r){const w=await(0,m.connect)(r,"driverClient"),p=w.getChannel("driver"),n=new L(p);return{client:w,driver:n}}e.connect=M}),define(Q[25],J([0,1,7,52,4,53,159,56]),function(j,e,m,A,L,b,M,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(b.IEnvironmentService);class w extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,m.join)(this.userDataPath,"clp")}get backupHome(){return(0,m.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,m.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,m.join)(this.userDataPath,"Code Cache")}}ce([A.memoize],w.prototype,"cachedLanguagesPath",null),ce([A.memoize],w.prototype,"backupHome",null),ce([A.memoize],w.prototype,"backupWorkspacesPath",null),ce([A.memoize],w.prototype,"mainIPCHandle",null),ce([A.memoize],w.prototype,"sandbox",null),ce([A.memoize],w.prototype,"driverVerbose",null),ce([A.memoize],w.prototype,"disableUpdates",null),ce([A.memoize],w.prototype,"disableKeytar",null),ce([A.memoize],w.prototype,"nodeCachedDataDir",null),ce([A.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(Q[216],J([0,1,20,58,7,3,16,49,25,17,24,6,29,8,30,10,15]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(l,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=P.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,i)=>(0,d.isEqual)(t,i,!b.isLinux)},this.backupHome=l.backupHome,this.workspacesJsonPath=l.backupWorkspacesPath}async initialize(){let l;try{l=JSON.parse(await m.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){l=Object.create(null)}l.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(l.emptyWorkspaceInfos));let a=[];try{Array.isArray(l.rootURIWorkspaces)&&(a=l.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:S.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(l.folderURIWorkspaces)&&(u=l.folderURIWorkspaces.map(t=>S.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==n.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===n.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var l;const a=this.configurationService.getValue();return((l=a==null?void 0:a.files)===null||l===void 0?void 0:l.hotExit)||n.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(l,a){this.workspaces.some(t=>l.workspace.id===t.workspace.id)||(this.workspaces.push(l),this.saveSync());const u=this.getBackupPath(l.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(l,a){if(m.existsSync(l)&&this.convertToEmptyWindowBackupSync(l),m.existsSync(a))try{m.renameSync(a,l)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(l){const a=l.id,u=this.workspaces.findIndex(t=>t.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(l){return this.folders.some(a=>this.backupUriComparer.isEqual(l,a))||(this.folders.push(l),this.saveSync()),this.getBackupPath(this.getFolderHash(l))}unregisterFolderBackupSync(l){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(l,u));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(l,a){const u=l||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(l){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,l));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(l){return(0,L.join)(this.backupHome,l)}async validateWorkspaces(l){if(!Array.isArray(l))return[];const a=new Set,u=[];for(let t of l){const i=t.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!a.has(i.id)){a.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==g.Schemas.file||await(0,M.exists)(i.configPath.fsPath)?u.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return u}async validateFolders(l){if(!Array.isArray(l))return[];const a=[],u=new Set;for(let t of l){const i=this.backupUriComparer.getComparisonKey(t);if(!u.has(i)){u.add(i);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==g.Schemas.file||await(0,M.exists)(t.fsPath)?a.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return a}async validateEmptyWorkspaces(l){if(!Array.isArray(l))return[];const a=[],u=new Set;for(let t of l){const i=t.backupFolder;if(typeof i!="string")return[];if(!u.has(i)){u.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?a.push(t):await this.deleteStaleBackup(s)}}return a}async deleteStaleBackup(l){try{await(0,M.exists)(l)&&await(0,M.rimraf)(l,M.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(l){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await m.promises.rename(l,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(l){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{m.renameSync(l,u)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const l=[];for(const a of this.workspaces)await this.hasBackups(a)&&l.push(a.workspace);for(const a of this.folders)await this.hasBackups(a)&&l.push(a);return l}hasBackups(l){let a;return S.URI.isUri(l)?a=this.getBackupPath(this.getFolderHash(l)):(0,r.isWorkspaceBackupInfo)(l)?a=this.getBackupPath(l.workspace.id):a=l.backupFolder,this.doHasBackups(a)}async doHasBackups(l){try{const a=await(0,M.readdir)(l);for(const u of a)try{if((await(0,M.readdir)((0,L.join)(l,u))).length>0)return!0}catch(t){}}catch(a){}return!1}saveSync(){try{(0,M.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}async save(){try{await(0,M.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(l){this.logService.error(`Backup: Could not save workspaces.json: ${l.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(l=>({id:l.workspace.id,configURIPath:l.workspace.configPath.toString(),remoteAuthority:l.remoteAuthority})),folderURIWorkspaces:this.folders.map(l=>l.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(l){let a;return l.scheme===g.Schemas.file?a=b.isLinux?l.fsPath:l.fsPath.toLowerCase():a=l.toString().toLowerCase(),(0,A.createHash)("md5").update(a).digest("hex")}};I=ce([ee(0,w.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,y.ILogService)],I),e.BackupMainService=I}),define(Q[41],J([0,1,5,34,14,18,3,25,50,16,8,31,4,27,65,6,7,21,52,2]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let a=class ct extends l.Disposable{constructor(t,i,s,c,h,f,v,D){super();this.sharedProcess=t,this.windowsMainService=i,this.dialogMainService=s,this.lifecycleMainService=c,this.environmentMainService=h,this.telemetryService=f,this.logService=v,this.productService=D,this.onDidOpenWindow=m.Event.map(this.windowsMainService.onDidOpenWindow,T=>T.id),this.onDidMaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidUnmaximizeWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidBlurWindow=m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T)),this.onDidFocusWindow=m.Event.any(m.Event.map(m.Event.filter(m.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),T=>!!T),T=>T.id),m.Event.filter(m.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(T,U)=>U.id),T=>!!this.windowsMainService.getWindowById(T))),this.onDidResumeOS=m.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new m.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new m.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=m.Event.debounce(m.Event.any(m.Event.filter(m.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(T,U,H)=>H),T=>!(Array.isArray(T)&&T.length===1&&T[0]==="workArea")),m.Event.fromNodeEventEmitter(L.screen,"display-added"),m.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(i=>{var s,c;return{id:i.id,workspace:i.openedWorkspace,title:(c=(s=i.win)===null||s===void 0?void 0:s.getTitle())!==null&&c!==void 0?c:"",filename:i.getRepresentedFilename(),dirty:i.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const i=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(i)return i.id}openWindow(t,i,s){return Array.isArray(i)?this.doOpenWindow(t,i,s):this.doOpenEmptyWindow(t,i)}async doOpenWindow(t,i,s=Object.create(null)){i.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:i,cli:this.environmentMainService.args,forceNewWindow:s.forceNewWindow,forceReuseWindow:s.forceReuseWindow,preferNewWindow:s.preferNewWindow,diffMode:s.diffMode,addMode:s.addMode,gotoLineMode:s.gotoLineMode,noRecentEntry:s.noRecentEntry,waitMarkerFileURI:s.waitMarkerFileURI,remoteAuthority:s.remoteAuthority||void 0})}async doOpenEmptyWindow(t,i){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},i)}async toggleFullScreen(t){const i=this.windowById(t);i&&i.toggleFullScreen()}async handleTitleDoubleClick(t){const i=this.windowById(t);i&&i.handleTitleDoubleClick()}async isMaximized(t){const i=this.windowById(t);return(i==null?void 0:i.win)?i.win.isMaximized():!1}async maximizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.maximize()}async unmaximizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.unmaximize()}async minimizeWindow(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.minimize()}async focusWindow(t,i){var s;i&&typeof i.windowId=="number"&&(t=i.windowId);const c=this.windowById(t);c&&c.focus({force:(s=i==null?void 0:i.force)!==null&&s!==void 0?s:!1})}async setMinimumSize(t,i,s){const c=this.windowById(t);if(c==null?void 0:c.win){const[h,f]=c.win.getSize(),[v,D]=c.win.getMinimumSize(),[T,U]=[i!=null?i:v,s!=null?s:D],[H,X]=[Math.max(h,T),Math.max(f,U)];(v!==T||D!==U)&&c.win.setMinimumSize(T,U),(h!==H||f!==X)&&c.win.setSize(H,X)}}async showMessageBox(t,i){return this.dialogMainService.showMessageBox(i,this.toBrowserWindow(t))}async showSaveDialog(t,i){return this.dialogMainService.showSaveDialog(i,this.toBrowserWindow(t))}async showOpenDialog(t,i){return this.dialogMainService.showOpenDialog(i,this.toBrowserWindow(t))}toBrowserWindow(t){const i=this.windowById(t);if(i==null?void 0:i.win)return i.win}async pickFileFolderAndOpen(t,i){const s=await this.dialogMainService.pickFileFolder(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFileFolder",i.telemetryExtraData),this.doOpenPicked(await Promise.all(s.map(async c=>await p.SymlinkSupport.existsDirectory(c)?{folderUri:n.URI.file(c)}:{fileUri:n.URI.file(c)})),i,t))}async pickFolderAndOpen(t,i){const s=await this.dialogMainService.pickFolder(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFolder",i.telemetryExtraData),this.doOpenPicked(s.map(c=>({folderUri:n.URI.file(c)})),i,t))}async pickFileAndOpen(t,i){const s=await this.dialogMainService.pickFile(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openFile",i.telemetryExtraData),this.doOpenPicked(s.map(c=>({fileUri:n.URI.file(c)})),i,t))}async pickWorkspaceAndOpen(t,i){const s=await this.dialogMainService.pickWorkspace(i);s&&(this.sendPickerTelemetry(s,i.telemetryEventName||"openWorkspace",i.telemetryExtraData),this.doOpenPicked(s.map(c=>({workspaceUri:n.URI.file(c)})),i,t))}doOpenPicked(t,i,s){this.windowsMainService.open({context:3,contextWindowId:s,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:i.forceNewWindow})}sendPickerTelemetry(t,i,s){const c=t?t.length:0;this.telemetryService.publicLog(i,Object.assign(Object.assign({},s),{outcome:c?"success":"canceled",numberOfPaths:c}))}async showItemInFolder(t,i){L.shell.showItemInFolder(i)}async setRepresentedFilename(t,i){const s=this.windowById(t);s&&s.setRepresentedFilename(i)}async setDocumentEdited(t,i){const s=this.windowById(t);s&&s.setDocumentEdited(i)}async openExternal(t,i){return M.isLinuxSnap?this.safeSnapOpenExternal(i):L.shell.openExternal(i),!0}safeSnapOpenExternal(t){const i=process.env.GDK_PIXBUF_MODULE_FILE,s=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=i,process.env.GDK_PIXBUF_MODULEDIR=s}moveItemToTrash(t,i){return L.shell.trashItem(i)}async isAdmin(){let t;return M.isWindows?t=(await new Promise((i,s)=>{j(["native-is-elevated"],i,s)}))():t=process.getuid()===0,t}async writeElevated(t,i,s,c){const h=await new Promise((f,v)=>{j(["sudo-prompt"],f,v)});return new Promise((f,v)=>{const D=[`"${this.cliPath}"`];(c==null?void 0:c.unlock)&&D.push("--file-chmod"),D.push("--file-write",`"${i.fsPath}"`,`"${s.fsPath}"`);const T={name:this.productService.nameLong.replace("-",""),icns:M.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};h.exec(D.join(" "),T,(U,H,X)=>{H&&this.logService.trace(`[sudo-prompt] received stdout: ${H}`),X&&this.logService.trace(`[sudo-prompt] received stderr: ${X}`),U?v(U):f(void 0)})})}get cliPath(){return M.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):M.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,S.totalmem)(),freemem:(0,S.freemem)(),loadavg:(0,S.loadavg)()}}async getOSProperties(){return{arch:(0,S.arch)(),platform:(0,S.platform)(),release:(0,S.release)(),type:(0,S.type)(),cpus:(0,S.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,i,s){process.kill(i,s)}async readClipboardText(t,i){return L.clipboard.readText(i)}async writeClipboardText(t,i,s){return L.clipboard.writeText(i,s)}async readClipboardFindText(t){return L.clipboard.readFindText()}async writeClipboardFindText(t,i){return L.clipboard.writeFindText(i)}async writeClipboardBuffer(t,i,s,c){return L.clipboard.writeBuffer(i,Buffer.from(s),c)}async readClipboardBuffer(t,i){return L.clipboard.readBuffer(i)}async hasClipboard(t,i,s){return L.clipboard.has(i,s)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,i){const s=this.windowById(t);s&&s.updateTouchBar(i)}async notifyReady(t){const i=this.windowById(t);i&&i.setReady()}async relaunch(t,i){return this.lifecycleMainService.relaunch(i)}async reload(t,i){const s=this.windowById(t);if(s)return this.lifecycleMainService.reload(s,(i==null?void 0:i.disableExtensions)!==void 0?{_:[],"disable-extensions":i==null?void 0:i.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,i){const s=this.windowById(i);if(s==null?void 0:s.win)return s.win.close()}async quit(t){const i=this.windowsMainService.getLastActiveWindow();(i==null?void 0:i.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&i.win?i.win.close():this.lifecycleMainService.quit()}async exit(t,i){await this.lifecycleMainService.kill(i)}async resolveProxy(t,i){var s,c;const h=this.windowById(t),f=(c=(s=h==null?void 0:h.win)===null||s===void 0?void 0:s.webContents)===null||c===void 0?void 0:c.session;if(f)return f.resolveProxy(i)}async openDevTools(t,i){const s=this.windowById(t);(s==null?void 0:s.win)&&s.win.webContents.openDevTools(i)}async toggleDevTools(t){const i=this.windowById(t);(i==null?void 0:i.win)&&i.win.webContents.toggleDevTools()}async sendInputEvent(t,i){const s=this.windowById(t);(s==null?void 0:s.win)&&(i.type==="mouseDown"||i.type==="mouseUp")&&s.win.webContents.sendInputEvent(i)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,i,s,c){if(!!M.isWindows){const h=await new Promise((f,v)=>{j(["vscode-windows-registry"],f,v)});try{return h.GetStringRegKey(i,s,c)}catch(f){return}}}async getPassword(t,i,s){const c=await this.withKeytar(),h=await c.getPassword(i,s);if(h)try{let{content:f,hasNextChunk:v}=JSON.parse(h);if(!f||!v)return h;let D=1;for(;v;){const T=await c.getPassword(i,`${s}-${D}`),U=JSON.parse(T);f+=U.content,v=U.hasNextChunk}return f}catch(f){return h}return h}async setPassword(t,i,s,c){const h=await this.withKeytar();if(M.isWindows&&c.length>ct.MAX_PASSWORD_LENGTH){let f=0,v=0,D=!0;for(;D;){const T=c.substring(f,f+ct.PASSWORD_CHUNK_SIZE);f+=ct.PASSWORD_CHUNK_SIZE,D=c.length-f>0;const U={content:T,hasNextChunk:D};await h.setPassword(i,v?`${s}-${v}`:s,JSON.stringify(U)),v++}}else await h.setPassword(i,s,c);this._onDidChangePassword.fire({service:i,account:s})}async deletePassword(t,i,s){const h=await(await this.withKeytar()).deletePassword(i,s);return h&&this._onDidChangePassword.fire({service:i,account:s}),h}async findPassword(t,i){return(await this.withKeytar()).findPassword(i)}async findCredentials(t,i){return(await this.withKeytar()).findCredentials(i)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,i)=>{j(["keytar"],t,i)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};a.MAX_PASSWORD_LENGTH=2500,a.PASSWORD_CHUNK_SIZE=a.MAX_PASSWORD_LENGTH-100,ce([o.memoize],a.prototype,"cliPath",null),a=ce([ee(1,A.IWindowsMainService),ee(2,w.IDialogMainService),ee(3,b.ILifecycleMainService),ee(4,r.IEnvironmentMainService),ee(5,y.ITelemetryService),ee(6,g.ILogService),ee(7,I.IProductService)],a),e.NativeHostMainService=a}),define(Q[217],J([0,1,2,5,80,14,6,34,41,88,28,21,26]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var S;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(S||(S={}));let d=class extends m.Disposable{constructor(P,I,o,l,a){super();this.logService=P,this.windowsMainService=I,this.nativeHostMainService=o,this.encryptionMainService=l,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=S.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const P=A.Event.fromNodeEventEmitter(b.app,"login",(I,o,l,a,u)=>({event:I,webContents:o,req:l,authInfo:a,callback:u}));this._register(P(this.onLogin,this))}async onLogin({event:P,authInfo:I,req:o,callback:l}){if(!!I.isProxy){if(!this.pendingProxyResolve&&this.state===S.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}P.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(I);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}l(a==null?void 0:a.username,a==null?void 0:a.password)}}async resolveProxyCredentials(P){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const I=await this.doResolveProxyCredentials(P);if(I)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),I;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(P){var I,o,l,a;this.logService.trace("auth#doResolveProxyCredentials - enter",P);const u=String((0,L.hash)({scheme:P.scheme,host:P.host,port:P.port}));let t,i;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,u);if(f){const v=JSON.parse(await this.encryptionMainService.decrypt(f));t=v.username,i=v.password}}catch(f){this.logService.error(f)}if(this.state!==S.StoredCredentialsUsed&&typeof t=="string"&&typeof i=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=S.StoredCredentialsUsed,{username:t,password:i};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const c={authInfo:P,username:(o=(I=this.sessionCredentials)===null||I===void 0?void 0:I.username)!==null&&o!==void 0?o:t,password:(a=(l=this.sessionCredentials)===null||l===void 0?void 0:l.password)!==null&&a!==void 0?a:i,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,c),this.state=S.LoginDialogShown;const h=await new Promise(f=>{var v;const D=async(T,U,H)=>{var X;if(U===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",D),H){const te={username:H.username,password:H.password};try{if(H.remember){const se=await this.encryptionMainService.encrypt(JSON.stringify(te));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,u,se)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,u)}catch(se){this.logService.error(se)}f({username:te.username,password:te.password})}else f(void 0)};(v=s.win)===null||v===void 0||v.webContents.on("ipc-message",D)});return this.sessionCredentials=h,h}};d=ce([ee(0,M.ILogService),ee(1,r.IWindowsMainService),ee(2,w.INativeHostMainService),ee(3,p.IEncryptionMainService),ee(4,y.IProductService)],d),e.ProxyAuthHandler=d}),define(Q[218],J([0,1,215,154,34,56,2,33,57,174,3,5,79,105,9,18,41]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function I(a){return a<21}let o=class{constructor(u,t,i,s,c){this.windowServer=u,this.options=t,this.windowsMainService=i,this.lifecycleMainService=s,this.nativeHostMainService=c,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new y.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const t=this.windowsMainService.getWindowById(u);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(u,t){await this.whenUnfrozen(u);const i=S.KeybindingParser.parseUserBinding(t);for(let s of i)await this._dispatchKeybinding(u,s)}async _dispatchKeybinding(u,t){if(t instanceof E.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(u);if(!(i==null?void 0:i.win))throw new Error("Invalid window");const s=i.win.webContents,c=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new p.USLayoutResolvedKeybinding(c.toChord(),n.OS).getElectronAccelerator(),v=[];t.ctrlKey&&v.push("ctrl"),t.metaKey&&v.push("meta"),t.shiftKey&&v.push("shift"),t.altKey&&v.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:v}),I(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:v}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:v}),await(0,d.timeout)(100)}async click(u,t,i,s){await(await this.getWindowDriver(u)).click(t,i,s)}async doubleClick(u,t){await(await this.getWindowDriver(u)).doubleClick(t)}async setValue(u,t,i){await(await this.getWindowDriver(u)).setValue(t,i)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,t){return await(await this.getWindowDriver(u)).isActiveElement(t)}async getElements(u,t,i){return await(await this.getWindowDriver(u)).getElements(t,i)}async getElementXY(u,t,i,s){return await(await this.getWindowDriver(u)).getElementXY(t,i,s)}async typeInEditor(u,t,i){await(await this.getWindowDriver(u)).typeInEditor(t,i)}async getTerminalBuffer(u,t){return await(await this.getWindowDriver(u)).getTerminalBuffer(t)}async writeInTerminal(u,t,i){await(await this.getWindowDriver(u)).writeInTerminal(t,i)}async getWindowDriver(u){await this.whenUnfrozen(u);const t=`window:${u}`,i=new r.StaticRouter(c=>c===t),s=this.windowServer.getChannel("windowDriver",i);return new A.WindowDriverChannelClient(s)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await y.Event.toPromise(this.onDidReloadingChange.event)}};o=ce([ee(2,L.IWindowsMainService),ee(3,g.ILifecycleMainService),ee(4,P.INativeHostMainService)],o),e.Driver=o;async function l(a,u,t,i){const s=t.driverVerbose,c=i.createInstance(o,a,{verbose:s}),h=new m.WindowDriverRegistryChannel(c);a.registerChannel("windowDriverRegistry",h);const f=await(0,b.serve)(u),v=new m.DriverChannel(c);return f.registerChannel("driver",v),(0,M.combinedDisposable)(f,a)}e.serve=l}),define(Q[219],J([0,1,59,56]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,b,M,r){const w=n=>r(n,void 0),p=m.createConnection({host:L,port:b},()=>{p.removeListener("error",w);const n=Buffer.alloc(16);for(let d=0;d<16;d++)n[d]=Math.round(Math.random()*256);const y=n.toString("base64");let E=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${b}/?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];p.write(E.join(`\r
`)+`\r
\r
`);const S=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",S),r(void 0,new A.NodeSocket(p)))};p.on("data",S)});p.once("error",w)}}}),define(Q[220],J([0,1,59,9,2,115,6,21,189,73,219,74]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(P,I,o,l){return new S(P,I,o,l).waitForReady()}class S extends L.Disposable{constructor(I,o,l,a){super();this.suggestedLocalPort=a,this.public=!1,this._socketsDispose=new Map,this._options=I,this._server=m.createServer(),this._barrier=new A.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=u=>this._onConnection(u),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=l,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var I;let o=await(0,b.findFreePortFaster)((I=this.suggestedLocalPort)!==null&&I!==void 0?I:this.tunnelRemotePort,2,1e3),l=null;return l=this._server.listen(o).address(),l||(o=0,l=this._server.listen(o).address()),this.tunnelLocalPort=l.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(I){I.pause();const o=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),l=o.getSocket().socket,a=o.readEntireBuffer();o.dispose(),a.byteLength>0&&I.write(a.buffer),I.on("end",()=>{this._socketsDispose.delete(I.localAddress),l.end()}),I.on("close",()=>l.end()),I.on("error",()=>{this._socketsDispose.delete(I.localAddress),l.destroy()}),l.on("end",()=>I.end()),l.on("close",()=>I.end()),l.on("error",()=>{I.destroy()}),I.pipe(l),l.pipe(I),this._socketsDispose.set(I.localAddress,()=>{I.end(),l.end()})}}let d=class extends p.AbstractTunnelService{constructor(I,o,l,a){super(o);this.socketFactory=I,this.signService=l,this.productService=a}retainOrCreateTunnel(I,o,l,a,u,t){const i=this.getTunnelFromMap(o,l);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,l,a,u,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${l} on local port ${a}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:I,signService:this.signService,logService:this.logService,ipcLogger:null},c=E(s,o,l,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,l,c),c}}};d=ce([ee(1,M.ILogService),ee(2,y.ISignService),ee(3,r.IProductService)],d),e.BaseTunnelService=d;let g=class extends d{constructor(I,o,l){super(n.nodeSocketFactory,I,o,l)}};g=ce([ee(0,M.ILogService),ee(1,y.ISignService),ee(2,r.IProductService)],g),e.TunnelService=g}),define(Q[221],J([0,1,214,191,2,13,19,190,17,6,23,53,90]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let S=class extends L.Disposable{constructor(g,P,I){super();this.environmentService=P,this.logService=I,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,P){this.logService.trace("RequestService#request",g.url);const{proxyUrl:I,strictSSL:o}=this,l=Object.assign(Object.assign({},process.env),await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),a=g.agent?g.agent:await(0,r.getProxyAgent)(g.url||"",l,{proxyUrl:I,strictSSL:o});return g.agent=a,g.strictSSL=o,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,P)}async getNodeRequest(g){return((0,A.parse)(g.url).protocol==="https:"?await new Promise((o,l)=>{j(["https"],o,l)}):await new Promise((o,l)=>{j(["http"],o,l)})).request}_request(g,P){return new Promise(async(I,o)=>{let l;const a=(0,A.parse)(g.url),u=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),t={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,b.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(t.auth=g.user+":"+g.password),l=u(t,i=>{const s=(0,b.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request(Object.assign(Object.assign({},g),{url:i.headers.location,followRedirects:s-1}),P).then(I,o);else{let c=i;i.headers["content-encoding"]==="gzip"&&(c=i.pipe((0,m.createGunzip)())),I({res:i,stream:(0,n.streamToBufferReadableStream)(c)})}}),l.on("error",o),g.timeout&&l.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&l.write(g.data),l.end(),P.onCancellationRequested(()=>{l.abort(),o((0,M.canceled)())})})}async resolveProxy(g){}};S=ce([ee(0,w.IConfigurationService),ee(1,y.INativeEnvironmentService),ee(2,p.ILogService)],S),e.RequestService=S}),define(Q[222],J([0,1,221,14]),function(j,e,m,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(M){return A.net.request}class b extends m.RequestService{request(r,w){return super.request(Object.assign(Object.assign({},r||{}),{getRawRequest:L}),w)}}e.RequestMainService=b}),define(Q[223],J([0,1,46,14,25,9,6,18,75,10,3,2,84,13,5,55]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let P=class extends y.Disposable{constructor(o,l,a,u,t,i,s){super();this.machineId=o,this.userEnv=l,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=t,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new b.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),A.ipcMain.on("vscode:createSharedProcessMessageChannel",async(o,l)=>this.onWindowConnection(o,l))}async onWindowConnection(o,l){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(o.sender.isDestroyed())return a.close();o.sender.postMessage("vscode:createSharedProcessMessageChannelResult",l,[a])}onWillShutdown(){const o=this.window;!o||(!o.isDestroyed()&&!o.webContents.isDestroyed()&&o.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(o.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{o.close()}catch(l){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(o=>A.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),o()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(o=>A.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),o()}))})()),this._whenIpcReady}createWindow(){const o=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new A.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`],v8CacheOptions:n.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),o.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=o=>{var l;this.logService.trace("SharedProcess#close prevented"),o.preventDefault(),((l=this.window)===null||l===void 0?void 0:l.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(o,l)=>this._onDidError.fire({type:2,details:l})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(o,l,a)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${a}`})))}async connect(){await this.whenIpcReady;const o=(0,S.assertIsDefined)(this.window);return(0,E.connect)(o)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var o,l;return(l=(o=this.window)===null||o===void 0?void 0:o.isVisible())!==null&&l!==void 0?l:!1}};P=ce([ee(2,L.IEnvironmentMainService),ee(3,r.ILifecycleMainService),ee(4,M.ILogService),ee(5,w.IThemeMainService),ee(6,g.IProtocolMainService)],P),e.SharedProcess=P}),define(Q[224],J([0,1,7,20,16,13,6,25,9]),function(j,e,m,A,L,b,M,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class p{constructor(E,S){this.dbPath=E,this.logService=S,this.database=Object.create(null),this.lastFlushedSerializedDatabase=void 0,this.flushDelayer=new w.ThrottledDelayer(100)}async init(){this.database=await this.load()}async load(){try{return this.lastFlushedSerializedDatabase=(await A.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(E){return E.code!=="ENOENT"&&this.logService.error(E),Object.create(null)}}getItem(E,S){const d=this.database[E];return(0,b.isUndefinedOrNull)(d)?S:d}setItem(E,S){if((0,b.isUndefinedOrNull)(S))return this.removeItem(E);(typeof S=="string"||typeof S=="number"||typeof S=="boolean")&&this.database[E]===S||(this.database[E]=S,this.save())}setItems(E){let S=!1;for(const{key:d,data:g}of E)if((0,b.isUndefinedOrNull)(g))this.database[d]=void 0,S=!0;else{if((typeof g=="string"||typeof g=="number"||typeof g=="boolean")&&this.database[d]===g)continue;this.database[d]=g,S=!0}S&&this.save()}removeItem(E){(0,b.isUndefined)(this.database[E])||(this.database[E]=void 0,this.save())}save(E){return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){const E=JSON.stringify(this.database,null,4);if(E!==this.lastFlushedSerializedDatabase)try{await(0,L.writeFile)(this.dbPath,E),this.lastFlushedSerializedDatabase=E}catch(S){this.logService.error(S)}}flush(){return this.save(0)}}e.FileStorage=p;let n=class Et{constructor(E,S){this.logService=S,this.storageDidInit=!1,this.fileStorage=new p((0,m.join)(E.userDataPath,Et.STATE_FILE),S)}async init(){if(!this.storageDidInit)return this.storageDidInit=!0,this.fileStorage.init()}checkInit(){this.storageDidInit||this.logService.warn("StateMainService used before init()")}getItem(E,S){return this.checkInit(),this.fileStorage.getItem(E,S)}setItem(E,S){this.checkInit(),this.fileStorage.setItem(E,S)}setItems(E){this.checkInit(),this.fileStorage.setItems(E)}removeItem(E){this.checkInit(),this.fileStorage.removeItem(E)}flush(){return this.checkInit(),this.fileStorage.flush()}};n.STATE_FILE="storage.json",n=ce([ee(0,r.IEnvironmentMainService),ee(1,M.ILogService)],n),e.StateMainService=n}),define(Q[77],J([0,1,5,9,17,18,21,40,25,6,48,26]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,g,P){return`${P.updateUrl}/api/update/${d}/${g}/${P.commit}`}e.createUpdateURL=E;let S=class{constructor(g,P,I,o,l,a){this.lifecycleMainService=g,this.configurationService=P,this.environmentMainService=I,this.requestService=o,this.logService=l,this.productService=a,this._state=r.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),P=this.getProductQuality(g);if(!P){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(P),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(r.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,A.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},y.CancellationToken.None).then(g=>g.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};S=ce([ee(0,b.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,w.IEnvironmentMainService),ee(3,n.IRequestService),ee(4,p.ILogService),ee(5,M.IProductService)],S),e.AbstractUpdateService=S}),define(Q[225],J([0,1,14,2,5,52,17,18,40,31,25,6,77,48,21]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends E.AbstractUpdateService{constructor(I,o,l,a,u,t,i){super(I,o,a,u,t,i);this.telemetryService=l,this.disposables=new A.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"error",(I,o)=>o)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-available",(I,o,l)=>({url:o,version:l,productVersion:l}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(m.autoUpdater,"update-downloaded",(I,o,l,a)=>({releaseNotes:o,version:l,productVersion:l,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(I){this.logService.error("UpdateService error:",I);const l=(this.state.type==="checking for updates"?this.state.explicit:!0)?I:void 0;this.setState(w.State.Idle(1,l))}buildUpdateFeedUrl(I){let o;this.productService.darwinUniversalAssetId?o=this.productService.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const l=(0,E.createUpdateURL)(o,I,this.productService);try{m.autoUpdater.setFeedURL({url:l})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return l}doCheckForUpdates(I){this.setState(w.State.CheckingForUpdates(I)),m.autoUpdater.checkForUpdates()}onUpdateAvailable(I){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(I))}onUpdateDownloaded(I){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:I.version}),this.setState(w.State.Ready(I)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),m.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([b.memoize],g.prototype,"onRawError",null),ce([b.memoize],g.prototype,"onRawUpdateNotAvailable",null),ce([b.memoize],g.prototype,"onRawUpdateAvailable",null),ce([b.memoize],g.prototype,"onRawUpdateDownloaded",null),g=ce([ee(0,r.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,p.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,S.IRequestService),ee(5,y.ILogService),ee(6,d.IProductService)],g),e.DarwinUpdateService=g}),define(Q[226],J([0,1,21,17,18,40,31,25,6,77,48,26,41]),function(j,e,m,A,L,b,M,r,w,p,n,y,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let S=class extends p.AbstractUpdateService{constructor(g,P,I,o,l,a,u,t){super(g,P,o,l,a,t);this.telemetryService=I,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,p.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},y.CancellationToken.None).then(n.asJson).then(P=>{!P||!P.url||!P.version||!P.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(P))}).then(void 0,P=>{this.logService.error(P),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const I=g?P.message||P:void 0;this.setState(b.State.Idle(1,I))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};S=ce([ee(0,L.ILifecycleMainService),ee(1,A.IConfigurationService),ee(2,M.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,n.IRequestService),ee(5,w.ILogService),ee(6,E.INativeHostMainService),ee(7,m.IProductService)],S),e.LinuxUpdateService=S}),define(Q[227],J([0,1,5,9,18,40,25,6,7,20,45,31]),function(j,e,m,A,L,b,M,r,w,p,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(g,P,I){if(this.lifecycleMainService=g,this.logService=I,this._state=b.State.Uninitialized,this._onStateChange=new m.Emitter,this.onStateChange=this._onStateChange.event,P.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,A.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([ee(0,L.ILifecycleMainService),ee(1,M.IEnvironmentMainService),ee(2,r.ILogService)],E);let S=class extends E{constructor(g,P,I,o,l,a){super(I,o,l);this.snap=g,this.snapRevision=P,this.telemetryService=a;const u=(0,p.watch)(w.dirname(this.snap)),t=m.Event.fromNodeEventEmitter(u,"change",(h,f)=>f),i=m.Event.filter(t,h=>h==="current"),c=m.Event.debounce(i,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));I.onWillShutdown(()=>{c.dispose(),u.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((I,o)=>(0,p.realpath)(`${w.dirname(this.snap)}/current`,(l,a)=>l?o(l):I(a))),P=w.basename(g);return this.snapRevision!==P}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};S=ce([ee(2,L.ILifecycleMainService),ee(3,M.IEnvironmentMainService),ee(4,r.ILogService),ee(5,y.ITelemetryService)],S),e.SnapUpdateService=S}),define(Q[228],J([0,1,20,7,16,52,17,18,21,40,31,25,6,77,48,111,27,45,26,9,24,8,41]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function i(f,v=1e3){for(;!f();)await(0,l.timeout)(v)}let s;function c(){return typeof s=="undefined"&&(s=m.existsSync(A.join(A.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends S.AbstractUpdateService{constructor(v,D,T,U,H,X,te,se,O){super(v,D,U,H,X,O);this.telemetryService=T,this.fileService=te,this.nativeHostMainService=se}get cachePath(){const v=A.join((0,P.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return m.promises.mkdir(v,{recursive:!0}).then(()=>v)}initialize(){super.initialize(),c()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(v){let D="win32";return process.arch!=="ia32"&&(D+=`-${process.arch}`),c()===1?D+="-archive":this.productService.target==="user"&&(D+="-user"),(0,S.createUpdateURL)(D,v,this.productService)}doCheckForUpdates(v){!this.url||(this.setState(p.State.CheckingForUpdates(v)),this.requestService.request({url:this.url},o.CancellationToken.None).then(d.asJson).then(D=>{const T=c();return!D||!D.url||!D.version||!D.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v}),this.setState(p.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(p.State.AvailableForDownload(D)),Promise.resolve(null)):(this.setState(p.State.Downloading(D)),this.cleanup(D.version).then(()=>this.getUpdatePackagePath(D.version).then(U=>L.exists(U).then(H=>{if(H)return Promise.resolve(U);const X=D.url,te=D.hash,se=`${U}.tmp`;return this.requestService.request({url:X},o.CancellationToken.None).then(O=>this.fileService.writeFile(u.URI.file(se),O.stream)).then(te?()=>(0,g.checksum)(se,D.hash):()=>{}).then(()=>m.promises.rename(se,U)).then(()=>U)})).then(U=>{const H=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},H&&D.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(D)):this.setState(p.State.Ready(D))})))}).then(void 0,D=>{this.logService.error(D),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!v});const T=v?D.message||D:void 0;this.setState(p.State.Idle(c(),T))}))}async doDownloadUpdate(v){v.update.url&&this.nativeHostMainService.openExternal(void 0,v.update.url),this.setState(p.State.Idle(c()))}async getUpdatePackagePath(v){const D=await this.cachePath;return A.join(D,`CodeSetup-${this.productService.quality}-${v}.exe`)}async cleanup(v=null){const D=v?X=>!new RegExp(`${this.productService.quality}-${v}\\.exe$`).test(X):()=>!0,T=await this.cachePath,H=(await L.readdir(T)).filter(D).map(async X=>{try{await m.promises.unlink(A.join(T,X))}catch(te){}});await Promise.all(H)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const v=this.state.update;this.setState(p.State.Updating(v));const D=await this.cachePath;this.availableUpdate.updateFilePath=A.join(D,`CodeSetup-${this.productService.quality}-${v.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,I.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(c()))});const U=`${this.productService.win32MutexName}-ready`,H=await new Promise((X,te)=>{j(["windows-mutex"],X,te)});i(()=>H.isActive(U)).then(()=>this.setState(p.State.Ready(v)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?m.unlinkSync(this.availableUpdate.updateFilePath):(0,I.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return c()}};ce([b.memoize],h.prototype,"cachePath",null),h=ce([ee(0,r.ILifecycleMainService),ee(1,M.IConfigurationService),ee(2,n.ITelemetryService),ee(3,y.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,E.ILogService),ee(6,a.IFileService),ee(7,t.INativeHostMainService),ee(8,w.IProductService)],h),e.Win32UpdateService=h}),define(Q[51],J([0,1,29,25,7,16,20,3,5,6,58,43,10,2,15,4,152,21,14,13,49,50,99]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,g.createDecorator)("workspacesManagementMainService");let i=class extends S.Disposable{constructor(f,v,D,T,U){super();this.environmentMainService=f,this.logService=v,this.backupMainService=D,this.dialogMainService=T,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!!this.isWorkspacePath(f)&&f.scheme===E.Schemas.file){let v;try{v=(0,M.readFileSync)(f.fsPath,"utf8")}catch(D){return}return this.doResolveWorkspace(f,v)}}isWorkspacePath(f){return(0,m.isUntitledWorkspace)(f,this.environmentMainService)||(0,m.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,v){try{const D=this.doParseStoredWorkspace(f,v),T=s(f);return{id:T.id,configPath:T.configPath,folders:(0,m.toWorkspaceFolders)(D.folders,T.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:D.remoteAuthority}}catch(D){this.logService.warn(D.toString())}}doParseStoredWorkspace(f,v){const D=(0,y.parse)(v);if(D&&Array.isArray(D.folders))D.folders=D.folders.filter(T=>(0,m.isStoredWorkspaceFolder)(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return D}async createUntitledWorkspace(f,v){const{workspace:D,storedWorkspace:T}=this.newUntitledWorkspace(f,v),U=D.configPath.fsPath;return await M.promises.mkdir((0,L.dirname)(U),{recursive:!0}),await(0,b.writeFile)(U,JSON.stringify(T,null,"	")),D}createUntitledWorkspaceSync(f,v){const{workspace:D,storedWorkspace:T}=this.newUntitledWorkspace(f,v),U=D.configPath.fsPath;return(0,M.mkdirSync)((0,L.dirname)(U),{recursive:!0}),(0,b.writeFileSync)(U,JSON.stringify(T,null,"	")),D}newUntitledWorkspace(f=[],v){const D=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,d.joinPath)(this.untitledWorkspacesHome,D),U=(0,d.joinPath)(T,m.UNTITLED_WORKSPACE_NAME),H=[];for(const X of f)H.push((0,m.getStoredWorkspaceFolder)(X.uri,!0,X.name,T,!r.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:H,remoteAuthority:v}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,m.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const v=(0,d.originalFSPath)(f.configPath);try{(0,b.rimrafSync)((0,L.dirname)(v));const D=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,M.existsSync)(D)&&(0,b.writeFileSync)((0,L.join)(D,"obsolete"),"")}catch(D){this.logService.warn(`Unable to delete untitled workspace ${v} (${D}).`)}}getUntitledWorkspacesSync(){const f=[];try{const v=(0,b.readdirSync)(this.untitledWorkspacesHome.fsPath).map(D=>(0,d.joinPath)(this.untitledWorkspacesHome,D,m.UNTITLED_WORKSPACE_NAME));for(const D of v){const T=s(D),U=this.resolveLocalWorkspaceSync(D);U?f.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(v){v.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${v}).`)}return f}async enterWorkspace(f,v,D){if(!(!f||!f.win||!f.isReady)&&!!await this.isValidTargetWorkspacePath(f,v,D)){const U=this.doEnterWorkspace(f,s(D));if(!!U)return this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U}}async isValidTargetWorkspacePath(f,v,D){if(!D)return!0;if((0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,D))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(v,D)){const T={title:this.productService.nameLong,type:"info",buttons:[(0,P.localize)(0,null)],message:(0,P.localize)(1,null,(0,d.basename)(D)),detail:(0,P.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,l.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,v){if(!!f.config){f.focus();let D;return f.config.extensionDevelopmentPath||(D=this.backupMainService.registerWorkspaceBackupSync({workspace:v,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,m.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=v,f.config.backupPath=D,{workspace:v,backupPath:D}}}};i=ce([ee(0,A.IEnvironmentMainService),ee(1,p.ILogService),ee(2,a.IBackupMainService),ee(3,u.IDialogMainService),ee(4,I.IProductService)],i),e.WorkspacesManagementMainService=i;function s(h){function f(){let v=h.scheme===E.Schemas.file?(0,d.originalFSPath)(h):h.toString();return r.isLinux||(v=v.toLowerCase()),(0,n.createHash)("md5").update(v).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function c(h,f){function v(){if(h.scheme!==E.Schemas.file)return(0,n.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,M.statSync)(h.fsPath)}catch(U){return}let T;return r.isLinux?T=f.ino:r.isMacintosh?T=f.birthtime.getTime():r.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),(0,n.createHash)("md5").update(h.fsPath).update(T?String(T):"").digest("hex")}const D=v();if(typeof D=="string")return{id:D,uri:h}}e.getSingleFolderWorkspaceIdentifier=c}),define(Q[100],J([0,1,6,97,3,4,34,16,51,17,8,14,35,54,26,29,13]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let I=class{constructor(l,a,u,t,i){this.logService=l,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=t,this.configurationService=i}async start(l,a){this.logService.trace("Received data from other instance: ",l,a),L.isMacintosh&&y.app.focus({steal:!0});const u=this.parseOpenUrl(l);if(u.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:i,url:s}of u)this.urlService.open(i,{originalUrl:s})})}else return this.startOpenWindow(l,a)}parseOpenUrl(l){return l["open-url"]&&l._urls&&l._urls.length>0?(0,E.coalesce)(l._urls.map(a=>{try{return{uri:n.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(l,a){const u=(0,S.isLaunchedFromCli)(a)?0:4;let t=[];const i=l.wait&&l.waitMarkerFilePath?n.URI.file(l.waitMarkerFilePath):void 0,s=l.remote||void 0;if(l.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(l.extensionDevelopmentPath,{context:u,cli:l,userEnv:a,waitMarkerFileURI:i,remoteAuthority:s});else if(!l._.length&&!l["folder-uri"]&&!l["file-uri"]){let c=!1;if(l["new-window"]||l["unity-launch"])c=!0;else if(l["reuse-window"])c=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":c=!0;break;case"off":c=!1;break;default:c=!L.isMacintosh}}if(c)t=this.windowsMainService.open({context:u,cli:l,userEnv:a,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:i,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:u,cli:l,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:u,cli:l,userEnv:a,forceNewWindow:l["new-window"],preferNewWindow:!l["reuse-window"]&&!l.wait,forceReuseWindow:l["reuse-window"],diffMode:l.diff,addMode:l.add,noRecentEntry:!!l["skip-add-to-recently-opened"],waitMarkerFileURI:i,gotoLineMode:l.goto,remoteAuthority:s});if(i&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,r.whenDeleted)(i.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const l=[];return y.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?l.push(this.codeWindowToInfo(u)):l.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:l,screenReader:!!y.app.accessibilitySupportEnabled,gpuFeatureStatus:y.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(l){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(t=>new Promise(i=>{const s=t.remoteAuthority;if(s){const c=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:l.includeProcesses,folders:l.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:c,args:h}),y.ipcMain.once(c,(f,v)=>{v||i({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),i(v)}),setTimeout(()=>{i({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else i(void 0)})))).filter(t=>!!t)}getFolderURIs(l){const a=[],u=l.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);t&&t.folders.forEach(s=>{a.push(s.uri)})}return a}codeWindowToInfo(l){const a=this.getFolderURIs(l),u=(0,P.assertIsDefined)(l.win);return this.browserWindowToInfo(u,a,l.remoteAuthority)}browserWindowToInfo(l,a=[],u){return{pid:l.webContents.getOSProcessId(),title:l.getTitle(),folderURIs:a,remoteAuthority:u}}};I=ce([ee(0,m.ILogService),ee(1,M.IWindowsMainService),ee(2,A.IURLService),ee(3,w.IWorkspacesManagementMainService),ee(4,p.IConfigurationService)],I),e.LaunchMainService=I}),define(Q[229],J([0,1,143,27,46,14,100,69,25,3,6,82,50,4,60,10,41,55,2]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,S.createDecorator)("issueMainService");let l=class It{constructor(u,t,i,s,c,h,f,v){this.userEnv=u,this.environmentMainService=t,this.launchMainService=i,this.logService=s,this.diagnosticsService=c,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=v,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){b.ipcMain.on("vscode:issueSystemInfoRequest",async u=>{const[t,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,i);this.safeSend(u,"vscode:issueSystemInfoResponse",s)}),b.ipcMain.on("vscode:listProcesses",async u=>{const t=[];try{const i=await this.launchMainService.getMainProcessId();t.push({name:(0,m.localize)(0,null),rootProcess:await(0,y.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(c=>{(0,r.isRemoteDiagnosticError)(c)?t.push({name:c.hostName,rootProcess:c}):c.processes&&t.push({name:c.hostName,rootProcess:c.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(u,"vscode:listProcessesResponse",t)}),b.ipcMain.on("vscode:issueReporterClipboard",async u=>{const t={message:(0,m.localize)(1,null),type:"warning",buttons:[(0,m.localize)(2,null),(0,m.localize)(3,null)]};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(u,"vscode:issueReporterClipboardResponse",i.response===0)}}),b.ipcMain.on("vscode:issuePerformanceInfoRequest",async u=>{const t=await this.getPerformanceInfo();this.safeSend(u,"vscode:issuePerformanceInfoResponse",t)}),b.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const u={message:(0,m.localize)(4,null),type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(u,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),b.ipcMain.on("vscode:workbenchCommand",(u,t)=>{const{id:i,from:s,args:c}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:i,from:s,args:c})}),b.ipcMain.on("vscode:openExternal",(u,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),b.ipcMain.on("vscode:closeIssueReporter",u=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),b.ipcMain.on("vscode:closeProcessExplorer",u=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),b.ipcMain.on("vscode:windowsInfoRequest",async u=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(u,"vscode:windowsInfoResponse",t.windows)})}safeSend(u,t,...i){u.sender.isDestroyed()||u.sender.send(t,...i)}async openReporter(u){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=b.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,s,u.styles.backgroundColor,(0,m.localize)(7,null),u.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:u,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,A.type)(),arch:(0,A.arch)(),release:(0,A.release)()},product:L.default}),this.issueReporterWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(u){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=b.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,s,u.styles.backgroundColor,(0,m.localize)(8,null),u.zoomLevel),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:u,product:L.default}),this.processExplorerWindow.loadURL(g.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(u,t,i,s,c){const h=new b.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:u.width,height:u.height,minWidth:300,minHeight:200,x:u.x,y:u.y,title:s,backgroundColor:i||It.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(c),sandbox:!0,contextIsolation:!0}});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[u,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(u,t)}getWindowPosition(u,t,i){let s;const c=b.screen.getAllDisplays();if(c.length===1)s=c[0];else{if(p.isMacintosh){const v=b.screen.getCursorScreenPoint();s=b.screen.getDisplayNearestPoint(v)}!s&&u&&(s=b.screen.getDisplayMatching(u.getBounds())),s||(s=b.screen.getPrimaryDisplay()||c[0])}const h={width:t,height:i},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[u,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(u,t)}catch(u){throw this.logService.warn("issueService#getPerformanceInfo ",u.message),u}}};l.DEFAULT_BACKGROUND_COLOR="#1E1E1E",l=ce([ee(1,w.IEnvironmentMainService),ee(2,M.ILaunchMainService),ee(3,n.ILogService),ee(4,r.IDiagnosticsService),ee(5,E.IDialogMainService),ee(6,P.INativeHostMainService),ee(7,I.IProtocolMainService)],l),e.IssueMainService=l}),define(Q[230],J([0,1,7,148,71,5,8,14,25,6,17,21,60,2,3,34,29,51,49,197,75,31,50,39,201,18,98,24,10,54,26,41,55]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t,i,s,c,h,f,v,D,T,U,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(se){se[se.NONE=0]="NONE",se[se.LOADING=1]="LOADING",se[se.NAVIGATING=2]="NAVIGATING",se[se.READY=3]="READY"})(X||(X={}));let te=class extends S.Disposable{constructor(O,z,$,C,q,N,_,R,W,k,F,B,V,G,Y){super();this.logService=z,this.environmentMainService=$,this.fileService=C,this.configurationService=N,this.themeMainService=_,this.workspacesManagementMainService=R,this.backupMainService=W,this.telemetryService=k,this.dialogMainService=F,this.lifecycleMainService=B,this.nativeHostMainService=V,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new b.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new b.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new b.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new b.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(O.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const oe=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!oe,title:this.productService.nameLong,webPreferences:Object.assign({preload:v.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,E.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?ne.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,m.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),d.isMacintosh&&(ne.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ne.acceptFirstMouse=!1));const ue=d.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ne.tabbingIdentifier=this.productService.nameShort);const be=(0,E.getTitleBarStyle)(this.configurationService)==="custom";if(be&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ne.frame=!1)),(0,L.mark)("code/willCreateCodeBrowserWindow"),this._win=new r.BrowserWindow(ne),(0,L.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&be&&this._win.setSheetOffset(22),d.isMacintosh&&re&&(!ue||r.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}oe&&((0,L.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,L.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,l.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>q.globalStorage.get(Z),store:(Z,re)=>q.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.backupPath}get openedWorkspace(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.workspace}get remoteAuthority(){var O;return(O=this.currentConfig)===null||O===void 0?void 0:O.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionDevelopmentPath)}get isExtensionTestHost(){var O;return!!((O=this.currentConfig)===null||O===void 0?void 0:O.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var O;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((O=this.currentConfig)===null||O===void 0?void 0:O.debugId)}setRepresentedFilename(O){d.isMacintosh?this._win.setRepresentedFilename(O):this.representedFilename=O}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(O){d.isMacintosh&&this._win.setDocumentEdited(O),this.documentEdited=O}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(O){d.isMacintosh&&(O==null?void 0:O.force)&&r.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.whenReadyCallbacks.push(O)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(O=>{function z(){$.dispose(),C.dispose(),O()}const $=this.onDidClose(()=>z()),C=this.onWillLoad(()=>z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(C,q)=>this.onWindowError(2,q)),this._win.webContents.on("did-fail-load",(C,q,N)=>this.onWindowError(3,N)),this._win.webContents.on("will-prevent-unload",C=>{C.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const O=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,"devtools"]),z=C=>{for(let q=C;q;q=q.parent)if(q.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((C,q)=>{const N=M.URI.parse(C.url);if(N.path.endsWith(".svg")&&!(O.has(N.scheme)||N.path.includes(v.Schemas.vscodeRemoteResource))){const R=z(C.frame);return q({cancel:!R})}return q({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((C,q)=>{const N=C.responseHeaders,_=N["content-type"]||N["Content-Type"];if(_&&Array.isArray(_)){const R=M.URI.parse(C.url);if(R.path.endsWith(".svg")&&O.has(R.scheme))return N["Content-Type"]=["image/svg+xml"],q({cancel:!1,responseHeaders:N});if(!R.path.includes(v.Schemas.vscodeRemoteResource)&&_.some(W=>W.toLowerCase().includes("image/svg"))){const W=z(C.frame);return q({cancel:!W})}}return q({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!0),r.app.emit("browser-window-maximize",C,this._win)}),this._win.on("unmaximize",C=>{this.currentConfig&&(this.currentConfig.maximized=!1),r.app.emit("browser-window-unmaximize",C,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(C=>this.onDidDeleteUntitledWorkspace(C)));const $=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:$},async(C,q)=>{const N=await this.marketplaceHeadersPromise;q({cancel:!1,requestHeaders:Object.assign(C.requestHeaders,N)})})}async onWindowError(O,z){var $;switch(O){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof z=="string"?z:z==null?void 0:z.reason}, code: ${typeof z=="string"?"<unknown>":($=z==null?void 0:z.exitCode)!==null&&$!==void 0?$:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof z=="string"?z:z==null?void 0:z.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:O,reason:typeof z!="string"?z==null?void 0:z.reason:void 0}),O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const C=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,A.localize)(0,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(1,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(2,null))],message:(0,A.localize)(3,null),detail:(0,A.localize)(4,null),noLink:!0},this._win);if(!this._win)return;C.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):C.response===2&&this.destroyWindow()}else if(O===2){let C;typeof z=="string"||!z?C=(0,A.localize)(5,null):C=(0,A.localize)(6,null,z.reason);const q=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,A.localize)(7,null)),(0,i.mnemonicButtonLabel)((0,A.localize)(8,null))],message:C,detail:(0,A.localize)(9,null),noLink:!0},this._win);if(!this._win)return;q.response===0?this.reload():q.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(O){var z;((z=this.openedWorkspace)===null||z===void 0?void 0:z.id)===O.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const O=this.getMenuBarVisibility();O!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=O,this.setMenuBarVisibility(O));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(z==null?void 0:z.endsWith("/"))&&(z=z.substr(0,z.length-1));const $=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||$!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=$;const C=z||"",q=$?`${$},<local>`:"<local>";this.logService.trace(`Setting proxy to '${C}', bypassing '${q}'`),this._win.webContents.session.setProxy({proxyRules:C,proxyBypassRules:q,pacScript:""})}}addTabbedWindow(O){d.isMacintosh&&O.win&&this._win.addTabbedWindow(O.win)}load(O,z=Object.create(null)){this.isDocumentEdited()&&(!z.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(O,z),this.readyState===0?this.currentConfig=O:(this.pendingLoadConfig=O,this.readyState=2),this._win.loadURL(v.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:O.workspace})}updateConfiguration(O,z){var $,C;const q=(C=($=this.currentConfig)!==null&&$!==void 0?$:this.pendingLoadConfig)===null||C===void 0?void 0:C.userEnv;q&&(0,D.isLaunchedFromCli)(q)&&!(0,D.isLaunchedFromCli)(O.userEnv)&&(O.userEnv=Object.assign(Object.assign({},q),O.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(O["disable-extensions"]=z.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this._win.isMaximized(),(0,L.mark)("code/willOpenNewWindow"),O.perfMarks=(0,L.getMarks)(),this.configObjectUrl.update(O)}async reload(O){const z=Object.assign({},this.currentConfig);z.workspace=await this.validateWorkspace(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToWait,this.isExtensionDevelopmentHost&&O&&(z.verbose=O.verbose,z.debugId=O.debugId,z["inspect-extensions"]=O["inspect-extensions"],z["inspect-brk-extensions"]=O["inspect-brk-extensions"],z["extensions-dir"]=O["extensions-dir"]),z.isInitialStartup=!1,this.load(z,{isReload:!0,disableExtensions:O==null?void 0:O["disable-extensions"]})}async validateWorkspace(O){if((0,P.isWorkspaceIdentifier)(O.workspace)){const z=O.workspace.configPath;if(z.scheme===v.Schemas.file&&!await this.fileService.exists(z))return}else if((0,P.isSingleFolderWorkspaceIdentifier)(O.workspace)){const z=O.workspace.uri;if(z.scheme===v.Schemas.file&&!await this.fileService.exists(z))return}return O.workspace}serializeWindowState(){if(!this._win)return(0,g.defaultWindowState)();if(this.isFullScreen){let $;try{$=r.screen.getDisplayMatching(this.getBounds())}catch(N){}const C=(0,g.defaultWindowState)();return{mode:3,display:$?$.id:void 0,width:this.windowState.width||C.width,height:this.windowState.height||C.height,x:this.windowState.x||0,y:this.windowState.y||0}}const O=Object.create(null);let z;if(!d.isMacintosh&&this._win.isMaximized()?z=0:z=1,z===0?O.mode=0:O.mode=1,z===1||z===0){let $;z===1?$=this.getBounds():$=this._win.getNormalBounds(),O.x=$.x,O.y=$.y,O.width=$.width,O.height=$.height}return O}restoreWindowState(O){(0,L.mark)("code/willRestoreCodeWindowState");let z=!1;if(O)try{const $=r.screen.getAllDisplays();z=$.length>1,O=this.validateWindowState(O,$)}catch($){this.logService.warn(`Unexpected error validating window state: ${$}
${$.stack}`)}return(0,L.mark)("code/didRestoreCodeWindowState"),[O||(0,g.defaultWindowState)(),z]}validateWindowState(O,z){var $,C;if(this.logService.trace(`window#validateWindowState: validating window state on ${z.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(z.length===1){const R=this.getWorkingArea(z[0]);if(R){this.logService.trace("window#validateWindowState: 1 monitor working area",R);function q(){!O||typeof O.x!="number"||typeof O.y!="number"||!R||(O.x<R.x&&(O.x=R.x),O.y<R.y&&(O.y=R.y))}q(),O.width>R.width&&(O.width=R.width),O.height>R.height&&(O.height=R.height),O.x>R.x+R.width-128&&(O.x=R.x+R.width-O.width),O.y>R.y+R.height-128&&(O.y=R.y+R.height-O.height),q()}return O}if(O.display&&O.mode===3){const R=z.find(W=>W.id===O.display);if(R&&typeof(($=R.bounds)===null||$===void 0?void 0:$.x)=="number"&&typeof((C=R.bounds)===null||C===void 0?void 0:C.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const W=(0,g.defaultWindowState)(3);return W.x=R.bounds.x,W.y=R.bounds.y,W}}let N,_;try{N=r.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),_=this.getWorkingArea(N)}catch(R){}if(N&&_&&O.x+O.width>_.x&&O.y+O.height>_.y&&O.x<_.x+_.width&&O.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),O}getWorkingArea(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,z]=this._win.getPosition(),[$,C]=this._win.getSize();return{x:O,y:z,width:$,height:C}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(O){this.useNativeFullScreen()?this.setNativeFullScreen(O):this.setSimpleFullScreen(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(O){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(O)}setSimpleFullScreen(O){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(O),this._win.webContents.focus()}useNativeFullScreen(){const O=this.configurationService.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let O=(0,E.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}setMenuBarVisibility(O,z=!0){d.isMacintosh||(O==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,A.localize)(10,null)),O==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(O)}):this.doSetMenuBarVisibility(O))}doSetMenuBarVisibility(O){const z=this.isFullScreen;switch(O){case"classic":this._win.setMenuBarVisibility(!z),this._win.autoHideMenuBar=z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(r.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(O,z,...$){this.isReady?this.send(O,...$):this.ready().then(()=>{z.isCancellationRequested||this.send(O,...$)})}send(O,...z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${O} for window that is destroyed`);return}this._win.webContents.send(O,...z)}}updateTouchBar(O){!d.isMacintosh||this.touchBarGroups.forEach((z,$)=>{const C=O[$];z.segments=this.createTouchBarGroupSegments(C)})}createTouchBar(){if(!!d.isMacintosh){for(let O=0;O<10;O++){const z=this.createTouchBarGroup();this.touchBarGroups.push(z)}this._win.setTouchBar(new r.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(O=[]){const z=this.createTouchBarGroupSegments(O),$=new r.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:C=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:$.segments[C].id,from:"touchbar"})}});return $}createTouchBarGroupSegments(O=[]){return O.map($=>{var C,q;let N;$.icon&&!s.ThemeIcon.isThemeIcon($.icon)&&((q=(C=$.icon)===null||C===void 0?void 0:C.dark)===null||q===void 0?void 0:q.scheme)===v.Schemas.file&&(N=r.nativeImage.createFromPath(M.URI.revive($.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let _;return typeof $.title=="string"?_=$.title:_=$.title.value,{id:$.id,label:N?void 0:_,icon:N}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};te=ce([ee(1,p.ILogService),ee(2,w.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,n.IConfigurationService),ee(6,a.IThemeMainService),ee(7,I.IWorkspacesManagementMainService),ee(8,o.IBackupMainService),ee(9,u.ITelemetryService),ee(10,t.IDialogMainService),ee(11,c.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,y.IProductService),ee(14,H.IProtocolMainService)],te),e.CodeWindow=te}),define(Q[61],J([0,1,151,35,38,14,6,39,5,3,29,51,9,15,8,10,16,18,4,2]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,o.createDecorator)("workspacesHistoryMainService");let a=class He extends l.Disposable{constructor(f,v,D,T){super();this.stateMainService=f,this.logService=v,this.workspacesManagementMainService=D,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const v=[],D=[];for(let T of f)if((0,n.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&i(v,T.workspace)===-1&&v.push(T);else if((0,n.isRecentFolder)(T))s(v,T.folderUri)===-1&&v.push(T);else{const U=c(D,T.fileUri)>=0,H=T.fileUri.scheme===g.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,S.basename)(T.fileUri))>=0;!U&&!H&&(D.push(T),p.isWindows&&T.fileUri.scheme===g.Schemas.file&&b.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(v,D),v.length>He.MAX_TOTAL_RECENT_ENTRIES&&(v.length=He.MAX_TOTAL_RECENT_ENTRIES),D.length>He.MAX_TOTAL_RECENT_ENTRIES&&(D.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:v,files:D}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const v=H=>{const X=t(H);for(const te of f)if(S.extUriBiasedIgnorePathCase.isEqual(te,X))return!1;return!0},D=this.getRecentlyOpened(),T=D.workspaces.filter(v),U=D.files.filter(v);(T.length!==D.workspaces.length||U.length!==D.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!p.isMacintosh){b.app.clearRecentDocuments();const f=this.getRecentlyOpened(),v=[];let D=0;for(let U=0;U<f.workspaces.length&&D<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const H=t(f.workspaces[U]);if(H.scheme===g.Schemas.file){const X=(0,S.originalFSPath)(H);await(0,P.exists)(X)&&(v.push(X),D++)}}const T=[];for(let U=0;U<f.files.length&&D<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const H=t(f.files[U]);if(H.scheme===g.Schemas.file){const X=(0,S.originalFSPath)(H);if(He.COMMON_FILES_FILTER.includes((0,S.basename)(H))||v.includes(X))continue;await(0,P.exists)(X)&&(T.push(X),D++)}}T.reverse().forEach(U=>b.app.addRecentDocument(U)),v.reverse().forEach(U=>b.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),b.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var v,D;const T=[],U=[],H=(v=f==null?void 0:f.config)===null||v===void 0?void 0:v.workspace;(0,n.isWorkspaceIdentifier)(H)&&!this.workspacesManagementMainService.isUntitledWorkspace(H)?T.push({workspace:H}):(0,n.isSingleFolderWorkspaceIdentifier)(H)&&T.push({folderUri:H.uri});const X=(D=f==null?void 0:f.config)===null||D===void 0?void 0:D.filesToOpenOrCreate;if(X)for(let te of X){const se=te.fileUri;se&&c(U,se)===-1&&U.push({fileUri:se})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(f,v){let D=this.getRecentlyOpenedFromStorage();for(let T of D.workspaces){let U=(0,n.isRecentFolder)(T)?s(f,T.folderUri):i(f,T.workspace);U>=0?f[U].label=f[U].label||T.label:f.push(T)}for(let T of D.files){let U=c(v,T.fileUri);U>=0?v[U].label=v[U].label||T.label:v.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(He.recentlyOpenedStorageKey);return(0,n.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const v=(0,n.toStoreData)(f);this.stateMainService.setItem(He.recentlyOpenedStorageKey,v)}updateWindowsJumpList(){if(!!p.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let v=[];for(let U of b.app.getJumpListSettings().removedItems){const H=U.args;if(H){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(H);X&&v.push(d.URI.parse(X[2]))}}this.removeRecentlyOpened(v);let D=!1;const T=(0,A.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const H=(0,n.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:X,description:te}=this.getWindowsJumpListLabel(H,U.label);let se;return d.URI.isUri(H)?se=`--folder-uri "${H.toString()}"`:(D=!0,se=`--file-uri "${H.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:te.substr(0,255),program:process.execPath,args:se,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:D?(0,m.localize)(2,null):(0,m.localize)(3,null),items:T})}f.push({type:"recent"});try{b.app.setJumpList(f)}catch(v){this.logService.warn("updateWindowsJumpList#setJumpList",v)}}}getWindowsJumpListLabel(f,v){if(v)return{title:(0,r.splitName)(v).name,description:v};if(d.URI.isUri(f))return{title:(0,S.basename)(f),description:u(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let D=(0,S.basename)(f.configPath);return D.endsWith(n.WORKSPACE_EXTENSION)&&(D=D.substr(0,D.length-n.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,D),description:u(f.configPath)}}};a.MAX_TOTAL_RECENT_ENTRIES=100,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=ce([ee(0,L.IStateMainService),ee(1,M.ILogService),ee(2,y.IWorkspacesManagementMainService),ee(3,I.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a;function u(h){return h.scheme==="file"?(0,r.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,n.isRecentFolder)(h)?h.folderUri:(0,n.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function i(h,f){return h.findIndex(v=>(0,n.isRecentWorkspace)(v)&&v.workspace.id===f.id)}function s(h,f){return h.findIndex(v=>(0,n.isRecentFolder)(v)&&S.extUriBiasedIgnorePathCase.isEqual(v.folderUri,f))}function c(h,f){return h.findIndex(v=>S.extUriBiasedIgnorePathCase.isEqual(v.fileUri,f))}}),define(Q[231],J([0,1,144,3,25,14,60,17,31,40,21,9,6,39,34,61,179,8,38,18,41,26]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let i=class vt{constructor(h,f,v,D,T,U,H,X,te,se,O){this.updateService=h,this.configurationService=f,this.windowsMainService=v,this.environmentMainService=D,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateMainService=H,this.lifecycleMainService=X,this.logService=te,this.nativeHostMainService=se,this.productService=O,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new y.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new y.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(A.isMacintosh||(0,M.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(vt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,H,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:H==null?void 0:H.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,H,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,H,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const v=this.productService.reportIssueUrl;v&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(v,"openReportIssues"));const D=this.productService.licenseUrl;D&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${D}${U}lang=${A.language}`,"openLicenseUrl")}else this.openUrl(D,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&D&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(A.language){const U=D.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${A.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!A.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(vt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!A.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!A.isMacintosh||(this.noActiveWindow=!b.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=b.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){b.Menu.setApplicationMenu(A.isMacintosh?new b.Menu:null);return}const f=new b.Menu;let v;if(A.isMacintosh){const F=new b.Menu;v=new b.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(v)}if(A.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new b.Menu;F.append(new b.MenuItem({label:this.mnemonicLabel(m.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),b.app.dock.setMenu(F)}const D=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(m.localize(1,null)),submenu:D});this.setMenuById(D,"File"),f.append(T);const U=new b.Menu,H=new b.MenuItem({label:this.mnemonicLabel(m.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(H);const X=new b.Menu,te=new b.MenuItem({label:this.mnemonicLabel(m.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),f.append(te);const se=new b.Menu,O=new b.MenuItem({label:this.mnemonicLabel(m.localize(4,null)),submenu:se});this.setMenuById(se,"View"),f.append(O);const z=new b.Menu,$=new b.MenuItem({label:this.mnemonicLabel(m.localize(5,null)),submenu:z});this.setMenuById(z,"Go"),f.append($);const C=new b.Menu,q=new b.MenuItem({label:this.mnemonicLabel(m.localize(6,null)),submenu:C});this.setMenuById(C,"Run"),f.append(q);const N=new b.Menu,_=new b.MenuItem({label:this.mnemonicLabel(m.localize(7,null)),submenu:N});this.setMenuById(N,"Terminal"),f.append(_);let R;if(this.shouldDrawMenu("Window")){const F=new b.Menu;R=new b.MenuItem({label:this.mnemonicLabel(m.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}R&&f.append(R);const W=new b.Menu,k=new b.MenuItem({label:this.mnemonicLabel(m.localize(9,null)),submenu:W,role:"help"});this.setMenuById(W,"Help"),f.append(k),f.items&&f.items.length>0?b.Menu.setApplicationMenu(f):b.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(m.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),v=this.getUpdateMenuItems();let D;if(this.shouldDrawMenu("Preferences")){const z=new b.Menu;this.setMenuById(z,"Preferences"),D=new b.MenuItem({label:this.mnemonicLabel(m.localize(11,null)),submenu:z})}const T=new b.Menu,U=new b.MenuItem({label:m.localize(12,null),role:"services",submenu:T}),H=new b.MenuItem({label:m.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new b.MenuItem({label:m.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new b.MenuItem({label:m.localize(15,null),role:"unhide"}),se=new b.MenuItem(this.likeAction("workbench.action.quit",{label:m.localize(16,null,this.productService.nameLong),click:()=>{const z=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!b.BrowserWindow.getFocusedWindow()||(z==null?void 0:z.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),O=[f];O.push(...v),D&&O.push(s(),D),O.push(s(),U,s(),H,X,te,s(),se),O.forEach(z=>h.append(z))}shouldDrawMenu(h){if(!A.isMacintosh&&(0,M.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(A.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(v=>{if((0,P.isMenubarMenuItemSeparator)(v))h.append(s());else if((0,P.isMenubarMenuItemSubmenu)(v)){const D=new b.Menu,T=new b.MenuItem({label:this.mnemonicLabel(v.label),submenu:D});this.setMenu(D,v.submenu.items),h.append(T)}else(0,P.isMenubarMenuItemRecentAction)(v)?h.append(this.createOpenRecentMenuItem(v)):(0,P.isMenubarMenuItemAction)(v)&&(v.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),A.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[v.id]?h.append(new b.MenuItem(this.likeAction(v.id,{label:this.mnemonicLabel(v.label),click:this.fallbackMenuHandlers[v.id]}))):h.append(this.createMenuItem(v.label,v.id,!1,v.checked)):h.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)):h.append(this.createMenuItem(v.label,v.id,v.enabled!==!1,!!v.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(v=>h.append(v)),h.append(s()))}createOpenRecentMenuItem(h){const f=I.URI.revive(h.uri),v=h.id,D=v==="openRecentFile"?{fileUri:f}:v==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new b.MenuItem(this.likeAction(v,{label:h.label,click:(T,U,H)=>{const X=this.isOptionClick(H);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[D],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!A.isMacintosh&&(h.ctrlKey||h.shiftKey)||A.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,v){const D={label:this.mnemonicLabel(h),role:v,enabled:!0};return new b.MenuItem(this.withKeybinding(f,D))}setMacWindowMenu(h){const f=new b.MenuItem({label:m.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),v=new b.MenuItem({label:m.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),D=new b.MenuItem({label:m.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(m.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(m.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(m.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(m.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(m.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(m.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,v,s(),T,...U,s(),D].forEach(H=>h.append(H))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new b.MenuItem({label:m.localize(27,null),enabled:!1})];case"available for download":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new b.MenuItem({label:m.localize(29,null),enabled:!1})];case"downloaded":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new b.MenuItem({label:m.localize(31,null),enabled:!1})];case"ready":return[new b.MenuItem({label:this.mnemonicLabel(m.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,v,D){const T=this.mnemonicLabel(h),U=typeof f=="function"?f:(O,z,$)=>{const C=O?O.userSettingsLabel:null;let q=f;Array.isArray(f)&&(q=this.isOptionClick($)?f[1]:f[0]),C&&$.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:C}):this.runActionInRenderer({type:"commandId",commandId:q})},H=typeof v=="boolean"?v:this.windowsMainService.getWindowCount()>0,X=typeof D=="boolean"?D:!1,te={label:T,click:U,enabled:H};X&&(te.type="checkbox",te.checked=X);let se;return typeof f=="string"?se=f:Array.isArray(f)&&(se=f[0]),A.isMacintosh&&(se==="editor.action.clipboardCutAction"?te.role="cut":se==="editor.action.clipboardCopyAction"?te.role="copy":se==="editor.action.clipboardPasteAction"&&(te.role="paste"),se==="undo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.undo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("undo:")}):se==="redo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.redo(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("redo:")}):se==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(U,{inDevTools:O=>O.selectAll(),inNoWindow:()=>b.Menu.sendActionToFirstResponder("selectAll:")}))),new b.MenuItem(this.withKeybinding(se,te))}makeContextAwareClickHandler(h,f){return(v,D,T)=>{const U=b.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);h(v,D||U,T)}}runActionInRenderer(h){let f=b.BrowserWindow.getFocusedWindow();if(!f){const D=this.windowsMainService.getLastActiveWindow();(D==null?void 0:D.isMinimized())&&(f=D.win)}const v=f?this.windowsMainService.getWindowById(f.id):void 0;if(v){if(this.logService.trace("menubar#runActionInRenderer",h),A.isMacintosh&&!this.environmentMainService.isBuilt&&!v.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const D={id:h.commandId,from:"menu"};v.sendWhenReady("vscode:runAction",u.CancellationToken.None,D)}else{const D={userSettingsLabel:h.userSettingsLabel};v.sendWhenReady("vscode:runKeybinding",u.CancellationToken.None,D)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const v=typeof h=="string"?this.keybindings[h]:void 0;if(v==null?void 0:v.label){if(v.isNative!==!1)f.accelerator=v.label,f.userSettingsLabel=v.userSettingsLabel;else if(typeof f.label=="string"){const D=f.label.indexOf("[");D>=0?f.label=`${f.label.substr(0,D)} [${v.label}]`:f.label=`${f.label} [${v.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,v=!f.accelerator){v&&(f=this.withKeybinding(h,f));const D=f.click;return f.click=(T,U,H)=>{this.reportMenuActionTelemetry(h),D&&D(T,U,H)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,S.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};i.lastKnownMenubarStorageKey="lastKnownMenubarData",i=ce([ee(0,p.IUpdateService),ee(1,r.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,w.ITelemetryService),ee(5,g.IWorkspacesHistoryMainService),ee(6,o.IStateMainService),ee(7,l.ILifecycleMainService),ee(8,E.ILogService),ee(9,a.INativeHostMainService),ee(10,n.IProductService)],i),e.Menubar=i;function s(){return new b.MenuItem({type:"separator"})}}),define(Q[232],J([0,1,231,6,4,18]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let M=class{constructor(w,p,n){this.instantiationService=w,this.lifecycleMainService=p,this.logService=n,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(m.Menubar)}async updateMenubar(w,p){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(p,w)}};M=ce([ee(0,L.IInstantiationService),ee(1,b.ILifecycleMainService),ee(2,A.ILogService)],M),e.MenubarMainService=M}),define(Q[233],J([0,1,20,27,46,71,7,149,35,49,25,38,230,14,18,17,6,60,99,5,21,61,3,29,4,10,8,15,72,213,51,42,2,50,13,30,39,26,24,32,55]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t,i,s,c,h,f,v,D,T,U,H,X,te,se,O,z,$,C,q){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function N(W){return(0,i.isWorkspaceIdentifier)(W==null?void 0:W.workspace)}function _(W){return(0,i.isSingleFolderWorkspaceIdentifier)(W==null?void 0:W.workspace)}let R=class et extends H.Disposable{constructor(k,F,B,V,G,Y,Z,re,oe,x,ne,ue,be,me,Pe){super();this.machineId=k,this.initialUserEnv=F,this.logService=B,this.stateMainService=V,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=x,this.instantiationService=ne,this.dialogMainService=ue,this.fileService=be,this.productService=me,this.protocolMainService=Pe,this._onDidOpenWindow=this._register(new l.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new l.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new l.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new l.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new D.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(k=>this._onDidSignalReadyWindow.fire(k.window))),this._register(this.onDidSignalReadyWindow(k=>{var F,B;if(((F=k.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((B=k.config)===null||B===void 0?void 0:B.extensionTestsPath)){const V=new H.DisposableStore;if(V.add(l.Event.any(k.onDidClose,k.onDidDestroy)(()=>V.dispose())),k.config.extensionDevelopmentPath)for(const G of k.config.extensionDevelopmentPath)V.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));k.config.extensionTestsPath&&V.add(this.protocolMainService.addValidFileRoot(h.URI.file(k.config.extensionTestsPath)))}}))}openEmptyWindow(k,F){let B=this.environmentMainService.args;const V=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},k),{cli:B,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:V}))}open(k){this.logService.trace("windowsManager#open"),k.addMode&&(k.initialStartup||!this.getLastActiveWindow())&&(k.addMode=!1);const F=[],B=[],V=[],G=[],Y=[];let Z,re=0;const oe=this.getPathsToOpen(k);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const me of oe)_(me)?k.addMode?F.push(me):B.push(me):N(me)?V.push(me):me.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),Z.filesToOpenOrCreate.push(me)):me.backupPath?Y.push({backupFolder:(0,M.basename)(me.backupPath),remoteAuthority:me.remoteAuthority}):re++;k.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&k.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:k.waitMarkerFileURI}),k.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),V.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ne}=this.doOpen(k,V,B,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${V.length}, foldersToOpen: ${B.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ne)ne.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!k.forceEmpty&&!k.cli._.length&&!k.cli["file-uri"]&&!k.cli["folder-uri"]&&!(k.urisToOpen&&k.urisToOpen.length);let Pe=!0,Ae=!0;if(me){const we=x.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Pe=!1,Ae=!1)}if(Pe)for(let we=x.length-1;we>=0;we--){const ve=x[we];if(!(ve.openedWorkspace&&G.some(Ee=>ve.openedWorkspace&&Ee.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Y.some(Ee=>ve.backupPath&&Ee.backupFolder===(0,M.basename)(ve.backupPath)))){ve.focus(),Ae=!1;break}}Ae&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(me=>me.isExtensionDevelopmentHost)&&!ue&&!k.noRecentEntry){const me=[];for(const Pe of oe)N(Pe)?me.push({label:Pe.label,workspace:Pe.workspace,remoteAuthority:Pe.remoteAuthority}):_(Pe)?me.push({label:Pe.label,folderUri:Pe.workspace.uri,remoteAuthority:Pe.remoteAuthority}):Pe.fileUri&&me.push({label:Pe.label,fileUri:Pe.fileUri,remoteAuthority:Pe.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const be=k.waitMarkerFileURI;return k.context===0&&be&&x.length===1&&x[0]&&(async()=>{await x[0].whenClosedOrLoaded;try{await this.fileService.del(be)}catch(me){}})(),x}doOpen(k,F,B,V,G,Y,Z){const re=[];let oe;function x(we,ve){re.push(we),ve&&(oe=we,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(k);if(!k.initialStartup&&Z.length>0){const we=Z[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(we);ve&&x(this.doAddFoldersToExistingWindow(ve,Z.map(Ee=>Ee.workspace.uri)))}const be=B.length+F.length+V.length;if(Y&&be===0){const we=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],ve=this.getWindows().filter(Re=>Y&&Re.remoteAuthority===Y.remoteAuthority);let Ee;(we==null?void 0:we.fileUri)&&!ue&&((k.context===4||k.context===0||k.context===1)&&(Ee=(0,o.findWindowOnFile)(ve,we.fileUri,Re=>Re.configPath.scheme===c.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),Ee||(Ee=this.doGetLastActiveWindow(ve))),Ee?(0,i.isWorkspaceIdentifier)(Ee.openedWorkspace)?F.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):(0,i.isSingleFolderWorkspaceIdentifier)(Ee.openedWorkspace)?B.push({workspace:Ee.openedWorkspace,remoteAuthority:Ee.remoteAuthority}):x(this.doOpenFilesInExistingWindow(k,Ee,Y),!0):x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:k.forceNewTabbedWindow}),!0)}const me=(0,w.distinct)(F,we=>we.workspace.id);if(me.length>0){const we=(0,w.coalesce)(me.map(ve=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(we.length>0){const ve=we[0],Ee=(Y==null?void 0:Y.remoteAuthority)===ve.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,ve,Ee),!!Ee),ne=!0}me.forEach(ve=>{if(!we.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===ve.workspace.id)){const Ee=ve.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ee?Y:void 0;x(this.doOpenFolderOrWorkspace(k,ve,ne,Re),!!Re),ne=!0}})}const Pe=(0,w.distinct)(B,we=>f.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Pe.length>0){const we=(0,w.coalesce)(Pe.map(ve=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(we.length>0){const ve=we[0],Ee=(Y==null?void 0:Y.remoteAuthority)===ve.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(k,ve,Ee),!!Ee),ne=!0}Pe.forEach(ve=>{if(!we.some(Te=>(0,i.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,ve.workspace.uri))){const Ee=ve.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ee?Y:void 0;x(this.doOpenFolderOrWorkspace(k,ve,ne,Re),!!Re),ne=!0}})}const Ae=(0,w.distinct)(V,we=>we.backupFolder);if(Ae.length>0&&Ae.forEach(we=>{const ve=we.remoteAuthority,Ee=(Y==null?void 0:Y.remoteAuthority)===ve?Y:void 0;x(this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,filesToOpen:Ee,remoteAuthority:ve,forceNewWindow:!0,forceNewTabbedWindow:k.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ee),ne=!0}),re.length===0||Y){Y&&!G&&G++;const we=Y?Y.remoteAuthority:k.remoteAuthority;for(let ve=0;ve<G;ve++)x(this.doOpenEmpty(k,ne,we,Y),!!Y),ne=!0}return{windows:(0,w.distinct)(re),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(k,F,B){var V;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:B==null?void 0:B.filesToOpenOrCreate,filesToDiff:B==null?void 0:B.filesToDiff,filesToWait:B==null?void 0:B.filesToWait,termProgram:(V=k==null?void 0:k.userEnv)===null||V===void 0?void 0:V.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",z.CancellationToken.None,G),F}doAddFoldersToExistingWindow(k,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),k.focus();const B={foldersToAdd:F};return k.sendWhenReady("vscode:addFolders",z.CancellationToken.None,B),k}doOpenEmpty(k,F,B,V,G){return!F&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:B,forceNewWindow:F,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}doOpenFolderOrWorkspace(k,F,B,V,G){return!B&&!G&&typeof k.contextWindowId=="number"&&(G=this.getWindowById(k.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:k.userEnv,cli:k.cli,initialStartup:k.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:B,forceNewTabbedWindow:k.forceNewTabbedWindow,filesToOpen:V,windowToUse:G})}getPathsToOpen(k){var F;let B,V=!1,G=!1;if(k.urisToOpen&&k.urisToOpen.length>0?(B=this.doExtractPathsFromAPI(k),V=!0):k.forceEmpty?B=[Object.create(null)]:k.cli._.length||k.cli["folder-uri"]||k.cli["file-uri"]?(B=this.doExtractPathsFromCLI(k.cli),B.length===0&&B.push(Object.create(null)),V=!0):(B=this.doGetPathsFromLastSession(),B.length===0&&B.push(Object.create(null)),G=!0),!k.addMode&&V){const Y=B.filter(Z=>_(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(oe=>({uri:oe.workspace.uri})));B.push({workspace:re,remoteAuthority:Z}),B=B.filter(oe=>!_(oe))}}}return k.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&B.unshift(...this.doGetPathsFromLastSession().filter(Y=>N(Y)||_(Y)||Y.backupPath)),B}doExtractPathsFromAPI(k){const F=[],B={gotoLineMode:k.gotoLineMode,remoteAuthority:k.remoteAuthority};for(const V of(0,w.coalesce)(k.urisToOpen||[])){const G=this.resolveOpenable(V,B);if(G)G.label=V.label,F.push(G);else{const Y=this.resourceFromOpenable(V),Z={title:this.productService.nameLong,type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===c.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===c.Schemas.file?(0,r.localize)(3,null,(0,O.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,r.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,te.withNullAsUndefined)(S.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(k){const F=[],B={ignoreFileNotFound:!0,gotoLineMode:k.goto,remoteAuthority:k.remote||void 0,forceOpenWorkspaceAsFile:!1},V=k["folder-uri"];if(V)for(const Z of V){const re=this.cliArgToUri(Z);if(re){const oe=this.resolveOpenable({folderUri:re},B);oe&&F.push(oe)}}const G=k["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const oe=this.resolveOpenable((0,i.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},B);oe&&F.push(oe)}}const Y=k._;for(const Z of Y){const re=B.remoteAuthority?this.doResolvePathRemote(Z,B):this.doResolveFilePath(Z,B);re&&F.push(re)}return F}cliArgToUri(k){try{const F=h.URI.parse(k);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${k}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${k}, ${F.message}`)}}doGetPathsFromLastSession(){const k=this.getRestoreWindowsSetting();switch(k){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];k!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const B=[];for(const V of F)if(V.workspace){const G=this.resolveOpenable({workspaceUri:V.workspace.configPath},{remoteAuthority:V.remoteAuthority});N(G)&&B.push(G)}else if(V.folderUri){const G=this.resolveOpenable({folderUri:V.folderUri},{remoteAuthority:V.remoteAuthority});_(G)&&B.push(G)}else k!=="folders"&&V.backupPath&&B.push({backupPath:V.backupPath,remoteAuthority:V.remoteAuthority});return B}}getRestoreWindowsSetting(){let k;if(this.lifecycleMainService.wasRestarted)k="all";else{const F=this.configurationService.getValue("window");k=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(k)||(k="all")}return k}resolveOpenable(k,F={}){let B=this.resourceFromOpenable(k);return B.scheme===c.Schemas.file?((0,I.isFileToOpen)(k)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(B.fsPath,F)):this.doResolveRemoteOpenable(k,F)}doResolveRemoteOpenable(k,F){let B=this.resourceFromOpenable(k);const V=(0,v.getRemoteAuthority)(B)||F.remoteAuthority;if(B=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(B)),(0,I.isFileToOpen)(k)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,se.parseLineAndColumnAware)(B.path);return{fileUri:B.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:V}}return{fileUri:B,remoteAuthority:V}}else if((0,I.isWorkspaceToOpen)(k))return{workspace:(0,T.getWorkspaceIdentifier)(B),remoteAuthority:V};return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(B),remoteAuthority:V}}resourceFromOpenable(k){return(0,I.isWorkspaceToOpen)(k)?k.workspaceUri:(0,I.isFolderToOpen)(k)?k.folderUri:k.fileUri}doResolveFilePath(k,F){let B,V;F.gotoLineMode&&({path:k,line:B,column:V}=(0,se.parseLineAndColumnAware)(k)),k=(0,se.sanitizeFilePath)((0,M.normalize)(k),(0,C.cwd)());try{const G=(0,m.statSync)(k);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(k));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(k),lineNumber:B,columnNumber:V,exists:!0}}else if(G.isDirectory())return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(h.URI.file(k),G),exists:!0}}catch(G){const Y=h.URI.file(k);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(k,F){const B=k.charCodeAt(0),V=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:k,line:G,column:Y}=(0,se.parseLineAndColumnAware)(k)),B!==47&&((0,se.isWindowsDriveLetter)(B)&&k.charCodeAt(k.charCodeAt(1))===58&&(k=(0,se.toSlashes)(k)),k=`/${k}`);const Z=h.URI.from({scheme:c.Schemas.vscodeRemote,authority:V,path:k});if(k.charCodeAt(k.length-1)!==47){if((0,i.hasWorkspaceFileExtension)(k))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,T.getWorkspaceIdentifier)(Z),remoteAuthority:V};if(F.gotoLineMode||M.posix.basename(k).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:V}}return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:V}}shouldOpenNewWindow(k){const F=this.configurationService.getValue("window"),B=(F==null?void 0:F.openFoldersInNewWindow)||"default",V=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(k.preferNewWindow||k.forceNewWindow)&&!k.forceReuseWindow;!k.forceNewWindow&&!k.forceReuseWindow&&(B==="on"||B==="off")&&(G=B==="on");let Y=!1;return k.forceNewWindow||k.forceReuseWindow?Y=!!k.forceNewWindow&&!k.forceReuseWindow:(t.isMacintosh?k.context===1&&(Y=!0):k.context!==3&&k.context!==2&&!(k.userEnv&&k.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!k.cli.extensionDevelopmentPath&&(V==="on"||V==="off")&&(Y=V==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(k,F){const B=(0,o.findWindowOnExtensionDevelopmentPath)(this.getWindows(),k);if(B)return this.lifecycleMainService.reload(B,F.cli),B.focus(),[B];let V=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!V.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=x&&(x.workspace||x.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===c.Schemas.file?Y=[ne.fsPath]:V=[ne.toString()]:ne.configPath.scheme===c.Schemas.file?Y=[(0,f.originalFSPath)(ne.configPath)]:G=[ne.configPath.toString()])}let Z=F.remoteAuthority;for(const x of k)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(x),ue=(0,v.getRemoteAuthority)(ne);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ne=h.URI.file(x);return(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,v.getRemoteAuthority)(ne)===Z}),V=V.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.getRemoteAuthority)(ne)===Z:!1}),G=G.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,v.getRemoteAuthority)(ne)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=V,F.cli["file-uri"]=G;const re=!Y.length&&!V.length&&!G.length,oe={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(oe)}openInBrowserWindow(k){var F,B,V,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),k.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,partsSplashPath:(0,M.join)(this.environmentMainService.userDataPath,"rapid_render.json"),backupPath:k.emptyWindowBackupInfo?(0,M.join)(this.environmentMainService.backupHome,k.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:k.remoteAuthority,workspace:k.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),k.userEnv),filesToOpenOrCreate:(F=k.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(B=k.filesToOpen)===null||B===void 0?void 0:B.filesToDiff,filesToWait:(V=k.filesToOpen)===null||V===void 0?void 0:V.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:k.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,A.release)(),hostname:(0,A.hostname)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:S.app.accessibilitySupportEnabled,colorScheme:{dark:S.nativeTheme.shouldUseDarkColors,highContrast:S.nativeTheme.shouldUseInvertedColorScheme||S.nativeTheme.shouldUseHighContrastColors}});let oe;if(!k.forceNewWindow&&!k.forceNewTabbedWindow&&(oe=k.windowToUse||this.getLastActiveWindow(),oe&&oe.focus()),oe){const x=oe.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,b.mark)("code/willCreateCodeWindow");const ne=oe=this.instantiationService.createInstance(E.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,b.mark)("code/didCreateCodeWindow"),k.forceNewTabbedWindow){const be=this.getLastActiveWindow();be&&be.addTabbedWindow(ne)}et.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,U.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,U.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne));const ue=(0,te.assertIsDefined)((Y=ne.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return re.windowId=oe.id,oe.isReady?this.lifecycleMainService.unload(oe,4).then(x=>{x||this.doOpenInBrowserWindow(oe,re,k)}):this.doOpenInBrowserWindow(oe,re,k),oe}doOpenInBrowserWindow(k,F,B){if(!F.extensionDevelopmentPath)if((0,i.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,i.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const V=B.emptyWindowBackupInfo&&B.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(V,F.remoteAuthority)}k.load(F)}onWindowClosed(k){const F=et.WINDOWS.indexOf(k);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const k=S.BrowserWindow.getFocusedWindow();if(k)return this.getWindowById(k.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(k){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===k))}doGetLastActiveWindow(k){const F=Math.max.apply(Math,k.map(B=>B.lastFocusTime));return k.find(B=>B.lastFocusTime===F)}sendToFocused(k,...F){const B=this.getFocusedWindow()||this.getLastActiveWindow();B&&B.sendWhenReady(k,z.CancellationToken.None,...F)}sendToAll(k,F,B){for(const V of this.getWindows())B&&B.indexOf(V.id)>=0||V.sendWhenReady(k,z.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(k){const F=this.getWindows().filter(B=>B.id===k);return(0,w.firstOrDefault)(F)}getWindowByWebContents(k){const F=S.BrowserWindow.fromWebContents(k);if(!!F)return this.getWindowById(F.id)}};R.WINDOWS=[],R=ce([ee(2,P.ILogService),ee(3,y.IStateMainService),ee(4,n.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,p.IBackupMainService),ee(7,g.IConfigurationService),ee(8,u.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,X.IDialogMainService),ee(12,$.IFileService),ee(13,a.IProductService),ee(14,q.IProtocolMainService)],R),e.WindowsMainService=R}),define(Q[234],J([0,1,51,34,61,49]),function(j,e,m,A,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(w,p,n,y){this.workspacesManagementMainService=w,this.windowsMainService=p,this.workspacesHistoryMainService=n,this.backupMainService=y,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,p){const n=this.windowsMainService.getWindowById(w);if(n)return this.workspacesManagementMainService.enterWorkspace(n,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(w,p,n){return this.workspacesManagementMainService.createUntitledWorkspace(p,n)}deleteUntitledWorkspace(w,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(w,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(w,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=ce([ee(0,m.IWorkspacesManagementMainService),ee(1,A.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,b.IBackupMainService)],M),e.WorkspacesMainService=M}),define(Q[235],J([0,1,27,20,14,3,233,18,90,40,203,33,122,84,223,100,4,70,68,6,38,25,17,97,204,31,96,198,199,195,21,217,2,34,8,29,234,65,228,226,225,229,177,19,206,218,232,119,7,15,131,10,227,98,211,216,49,61,205,51,69,156,41,50,13,39,208,76,24,43,28,23,88,209,194,54,30,9,168,182,42,72,74,89,187]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t,i,s,c,h,f,v,D,T,U,H,X,te,se,O,z,$,C,q,N,_,R,W,k,F,B,V,G,Y,Z,re,oe,x,ne,ue,be,me,Pe,Ae,we,ve,Ee,Re,Te,Ke,Ze,qe,ut,Be,st,K,ie,ae,le,he,ye,Me,Fe,We,Ce,$e,ot,ht){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends H.Disposable{constructor(de,pe,fe,ge,Se,Le,De,ke,Ie,Ue){super();this.mainProcessNodeIpcServer=de,this.userEnv=pe,this.mainInstantiationService=fe,this.logService=ge,this.environmentMainService=Se,this.lifecycleMainService=Le,this.configurationService=De,this.stateMainService=ke,this.fileService=Ie,this.productService=Ue,this.registerListeners()}registerListeners(){(0,R.setUnexpectedErrorHandler)(fe=>this.onUnexpectedError(fe)),process.on("uncaughtException",fe=>this.onUnexpectedError(fe)),process.on("unhandledRejection",fe=>(0,R.onUnexpectedError)(fe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(fe,ge)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",ge)}),L.app.on("activate",(fe,ge)=>{var Se;this.logService.trace("app#activate"),ge||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),L.app.on("remote-require",(fe,ge,Se)=>{this.logService.trace("app#on(remote-require): prevented"),fe.preventDefault()}),L.app.on("remote-get-global",(fe,ge,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),fe.preventDefault()}),L.app.on("remote-get-builtin",(fe,ge,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&fe.preventDefault()}),L.app.on("remote-get-current-window",fe=>{this.logService.trace("app#on(remote-get-current-window): prevented"),fe.preventDefault()}),L.app.on("remote-get-current-web-contents",fe=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),fe.preventDefault())}),L.app.on("web-contents-created",(fe,ge)=>{ge.on("will-attach-webview",(Le,De,ke)=>{const Ie=Ue=>{if(!Ue)return!1;const ze=te.URI.parse(Ue);if(ze.scheme===Z.Schemas.vscodeWebview)return ze.path==="/index.html"||ze.path==="/electron-browser-index.html";const Ge=ze.fsPath.toLowerCase(),Ye=te.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ge.startsWith(Ye+V.sep)};delete De.preload,De.nodeIntegration=!1,!(Ie(ke.src)&&Ie(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Le.preventDefault())}),ge.on("will-navigate",Le=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Le.preventDefault()}),ge.on("new-window",(Le,De)=>{var ke;Le.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,De)});const Se=Le=>Le.startsWith(`${Z.Schemas.vscodeWebview}://`);L.session.defaultSession.setPermissionRequestHandler((Le,De,ke,Ie)=>Se(Ie.requestingUrl)?ke(De==="clipboard-read"):ke(!1)),L.session.defaultSession.setPermissionCheckHandler((Le,De,ke,Ie)=>Se(Ie.requestingUrl)?De==="clipboard-read":!1)});let de=[],pe;L.app.on("open-file",(fe,ge)=>{this.logService.trace("app#open-file: ",ge),fe.preventDefault(),de.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:de,gotoLineMode:!1,preferNewWindow:!0}),de=[],pe=void 0},100)}),L.app.on("new-window-for-tab",()=>{var fe;(fe=this.windowsMainService)===null||fe===void 0||fe.openEmptyWindow({context:4})}),L.ipcMain.handle("vscode:fetchShellEnv",fe=>{var ge;const Se=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(fe.sender);let Le,De;return(Se==null?void 0:Se.config)?(Le=Se.config,De=Object.assign(Object.assign({},process.env),Se.config.userEnv)):(Le=this.environmentMainService.args,De=process.env),(0,w.resolveShellEnv)(this.logService,Le,De)}),L.ipcMain.handle("vscode:writeNlsFile",(fe,ge,Se)=>{const Le=this.validateNlsPath([ge]);if(!Le||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Le,st.VSBuffer.fromString(Se))}),L.ipcMain.handle("vscode:readNlsFile",async(fe,...ge)=>{const Se=this.validateNlsPath(ge);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",fe=>fe.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",fe=>fe.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",fe=>fe.sender.reload())}validateNlsPath(de){let pe;for(const fe of de)typeof fe=="string"&&(typeof pe!="string"?pe=fe:pe=(0,V.join)(pe,fe));if(!(typeof pe!="string"||!(0,V.isAbsolute)(pe)||!(0,he.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!b.isLinux)))return te.URI.file(pe)}onUnexpectedError(de){var pe;if(de){const fe={message:`[uncaught exception in main]: ${de.message}`,stack:de.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(fe))}this.logService.error(`[uncaught exception in main]: ${de}`),de.stack&&this.logService.error(de.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Ie=te.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Ie.fsPath}`),await this.fileService.del(Ie,{recursive:!0})}catch(Ie){Ie.fileOperationResult!==1&&this.logService.error(Ie)}const de=this.productService.win32AppUserModelId;b.isWindows&&de&&L.app.setAppUserModelId(de);try{b.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ie){this.logService.error(Ie)}const pe=new E.Server;this.logService.trace("Resolving machine identifier...");const fe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${fe}`);const{sharedProcess:ge,sharedProcessReady:Se,sharedProcessClient:Le}=this.setupSharedProcess(fe),De=await this.initServices(fe,ge,Se);if(this.environmentMainService.driverHandle){const Ie=await(0,k.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ie)}this._register(De.createInstance(U.ProxyAuthHandler)),De.invokeFunction(Ie=>this.initChannels(Ie,pe,Le));const ke=De.invokeFunction(Ie=>this.openFirstWindow(Ie,pe));De.invokeFunction(Ie=>this.afterWindowOpen(Ie,ge)),this.environmentMainService.args.trace&&De.invokeFunction(Ie=>this.stopTracingEventually(Ie,ke))}async resolveMachineId(){let de=this.stateMainService.getItem(c.machineIdKey);return(!de||b.isMacintosh&&de==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(de=await(0,z.getMachineId)(),this.stateMainService.setItem(c.machineIdKey,de)),de}setupSharedProcess(de){const pe=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,de,this.userEnv)),fe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Se=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new S.Client(Se,"main")})(),ge=(async()=>(await pe.whenReady(),fe))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:fe}}async initServices(de,pe,fe){const ge=new I.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new o.SyncDescriptor($.Win32UpdateService));break;case"linux":b.isLinuxSnap?ge.set(p.IUpdateService,new o.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new o.SyncDescriptor(C.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new o.SyncDescriptor(q.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new o.SyncDescriptor(M.WindowsMainService,[de,this.userEnv])),ge.set(Ee.IDialogMainService,new o.SyncDescriptor(Ee.DialogMainService)),ge.set(g.ILaunchMainService,new o.SyncDescriptor(g.LaunchMainService)),ge.set(Ae.IDiagnosticsService,y.ProxyChannel.toService((0,y.getDelayedChannel)(fe.then(Le=>Le.getChannel("diagnostics"))))),ge.set(N.IIssueMainService,new o.SyncDescriptor(N.IssueMainService,[this.userEnv])),ge.set(K.IEncryptionMainService,new o.SyncDescriptor(K.EncryptionMainService,[de])),ge.set(ae.IKeyboardLayoutMainService,new o.SyncDescriptor(ae.KeyboardLayoutMainService)),ge.set(ve.INativeHostMainService,new o.SyncDescriptor(ve.NativeHostMainService,[pe])),ge.set(Ze.IWebviewManagerService,new o.SyncDescriptor(Ke.WebviewMainService)),ge.set(se.IWorkspacesService,new o.SyncDescriptor(O.WorkspacesMainService)),ge.set(Pe.IWorkspacesManagementMainService,new o.SyncDescriptor(Pe.WorkspacesManagementMainService)),ge.set(be.IWorkspacesHistoryMainService,new o.SyncDescriptor(be.WorkspacesHistoryMainService)),ge.set(F.IMenubarMainService,new o.SyncDescriptor(F.MenubarMainService)),ge.set(Me.IExtensionUrlTrustService,new o.SyncDescriptor(Fe.ExtensionUrlTrustService)),ge.set(oe.IStorageMainService,new o.SyncDescriptor(oe.StorageMainService)),b.isWindows?ge.set(ot.IExternalTerminalMainService,new o.SyncDescriptor(ht.WindowsExternalTerminalService)):b.isMacintosh?ge.set(ot.IExternalTerminalMainService,new o.SyncDescriptor(ht.MacExternalTerminalService)):b.isLinux&&ge.set(ot.IExternalTerminalMainService,new o.SyncDescriptor(ht.LinuxExternalTerminalService));const Se=new ne.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(ue.IBackupMainService,Se),ge.set(i.IURLService,new o.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Le=(0,y.getDelayedChannel)(fe.then(ze=>ze.getChannel("telemetryAppender"))),De=new f.TelemetryAppenderClient(Le),ke=(0,D.resolveCommonProperties)(this.fileService,(0,m.release)(),(0,m.hostname)(),process.arch,this.productService.commit,this.productService.version,de,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ie=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ue={appender:De,commonProperties:ke,piiPaths:Ie,sendErrorTelemetry:!0};ge.set(c.ITelemetryService,new o.SyncDescriptor(v.TelemetryService,[Ue]))}else ge.set(c.ITelemetryService,h.NullTelemetryService);return await Se.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(de,pe,fe){const ge=y.ProxyChannel.fromService(de.get(g.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Se=new n.UpdateChannel(de.get(p.IUpdateService));pe.registerChannel("update",Se);const Le=y.ProxyChannel.fromService(de.get(N.IIssueMainService));pe.registerChannel("issue",Le);const De=y.ProxyChannel.fromService(de.get(K.IEncryptionMainService));pe.registerChannel("encryption",De);const ke=y.ProxyChannel.fromService(de.get($e.ISignService));pe.registerChannel("sign",ke);const Ie=y.ProxyChannel.fromService(de.get(ae.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Ie),this.nativeHostMainService=de.get(ve.INativeHostMainService);const Ue=y.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ue),fe.then(je=>je.registerChannel("nativeHost",Ue));const ze=y.ProxyChannel.fromService(de.get(se.IWorkspacesService));pe.registerChannel("workspaces",ze);const Ge=y.ProxyChannel.fromService(de.get(F.IMenubarMainService));pe.registerChannel("menubar",Ge);const Ye=y.ProxyChannel.fromService(de.get(i.IURLService));pe.registerChannel("url",Ye);const Oe=y.ProxyChannel.fromService(de.get(Me.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Oe);const at=y.ProxyChannel.fromService(de.get(Ze.IWebviewManagerService));pe.registerChannel("webview",at);const xe=this._register(new x.StorageDatabaseChannel(this.logService,de.get(oe.IStorageMainService)));pe.registerChannel("storage",xe),fe.then(je=>je.registerChannel("storage",xe));const tt=y.ProxyChannel.fromService(de.get(ot.IExternalTerminalMainService));pe.registerChannel("externalTerminal",tt);const it=new _.LogLevelChannel(de.get(l.ILogService));pe.registerChannel("logLevel",it),fe.then(je=>je.registerChannel("logLevel",it));const nt=new _.LoggerChannel(de.get(l.ILoggerService));pe.registerChannel("logger",nt),fe.then(je=>je.registerChannel("logger",nt));const rt=new we.ElectronExtensionHostDebugBroadcastChannel(de.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",rt)}openFirstWindow(de,pe){const fe=this.windowsMainService=de.get(X.IWindowsMainService),ge=de.get(i.IURLService),Se=de.get(ve.INativeHostMainService);this.lifecycleMainService.phase=2;const Le=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ne=>{try{return{uri:te.URI.parse(Ne),url:Ne}}catch(Xe){return null}}).filter(Ne=>{if(!Ne||this.shouldBlockURI(Ne.uri))return!1;const Xe=this.getWindowOpenableFromProtocolLink(Ne.uri);return Xe?(Le.push(Xe),!1):!0}),ke=this,Ie=this.environmentMainService;ge.registerHandler({async handleURL(Ne,Xe){if(ke.shouldBlockURI(Ne))return!0;const St=ke.getWindowOpenableFromProtocolLink(Ne);if(St){const[ft]=fe.open({context:5,cli:Object.assign({},Ie.args),urisToOpen:[St],gotoLineMode:!0});return ft.focus(),!0}if(b.isMacintosh&&fe.getWindowCount()===0){const[ft]=fe.open({context:5,cli:Object.assign({},Ie.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(Ne)});return await ft.ready(),ge.open(Ne,Xe)}return!1}});const Ue=this._register(new ie.ActiveWindowManager({onDidOpenWindow:Se.onDidOpenWindow,onDidFocusWindow:Se.onDidFocusWindow,getActiveWindowId:()=>Se.getActiveWindowId(-1)})),ze=new y.StaticRouter(Ne=>Ue.getActiveClientId().then(Xe=>Ne===Xe)),Ge=new s.URLHandlerRouter(ze),Ye=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Ye)),this._register(new W.ElectronURLListener(De,ge,fe,this.environmentMainService,this.productService));const Oe=this.environmentMainService.args,at=global.macOpenFiles,xe=(0,le.isLaunchedFromCli)(process.env)?0:4,tt=Oe._.length,it=!!Oe["folder-uri"],nt=!!Oe["file-uri"],rt=Oe["skip-add-to-recently-opened"]===!0,je=Oe.wait&&Oe.waitMarkerFilePath?te.URI.file(Oe.waitMarkerFilePath):void 0,yt=Oe.remote||void 0;return Le.length>0?fe.open({context:xe,cli:Oe,urisToOpen:Le,gotoLineMode:!0,initialStartup:!0}):Oe["new-window"]&&!tt&&!it&&!nt?fe.open({context:xe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:rt,waitMarkerFileURI:je,initialStartup:!0,remoteAuthority:yt}):at.length&&!tt&&!it&&!nt?fe.open({context:1,cli:Oe,urisToOpen:at.map(Ne=>this.getWindowOpenableFromPathSync(Ne)),noRecentEntry:rt,waitMarkerFileURI:je,initialStartup:!0}):fe.open({context:xe,cli:Oe,forceNewWindow:Oe["new-window"]||!tt&&Oe["unity-launch"],diffMode:Oe.diff,noRecentEntry:rt,waitMarkerFileURI:je,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:yt})}shouldBlockURI(de){return!!(de.authority===Z.Schemas.file&&b.isWindows&&L.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Te.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,Te.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,Te.getPathLabel)(de.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(de){if(!!de.path){if(de.authority===Z.Schemas.file)return{fileUri:te.URI.file(de.fsPath)};if(de.authority===Z.Schemas.vscodeRemote){const pe=de.path.indexOf(V.posix.sep,1);if(pe!==-1){const fe=de.path.substring(1,pe),ge=de.path.substring(pe),Se=te.URI.from({scheme:Z.Schemas.vscodeRemote,authority:fe,path:ge,query:de.query,fragment:de.fragment});return(0,se.hasWorkspaceFileExtension)(ge)?{workspaceUri:Se}:/:[\d]+$/.test(ge)?{fileUri:Se}:{folderUri:Se}}}}}getWindowOpenableFromPathSync(de){try{if((0,A.statSync)(de).isDirectory())return{folderUri:te.URI.file(de)};if((0,se.hasWorkspaceFileExtension)(de))return{workspaceUri:te.URI.file(de)}}catch(pe){}return{fileUri:te.URI.file(de)}}async afterWindowOpen(de,pe){var fe;this.lifecycleMainService.phase=3;let ge=!1;(0,We.once)(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Se=de.get(c.ITelemetryService);this._register(pe.onDidError(({type:ke,details:Ie})=>{let Ue;typeof Ie=="string"?Ue=Ie:Ue=`SharedProcess: crashed (detail: ${Ie.reason}, code: ${Ie.exitCode})`,(0,R.onUnexpectedError)(new Error(Ue)),Se.publicLog2("sharedprocesserror",{type:ke,reason:typeof Ie!="string"?Ie==null?void 0:Ie.reason:void 0,visible:pe.isVisible(),shuttingdown:ge})}));const Le=this.productService.win32MutexName;if(b.isWindows&&Le)try{const ke=j.__$__nodeRequire("windows-mutex").Mutex,Ie=new ke(Le);(0,We.once)(this.lifecycleMainService.onWillShutdown)(()=>Ie.release())}catch(ke){this.logService.error(ke)}L.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(ke,Ie)=>{Ie({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const De=de.get(p.IUpdateService);(De instanceof $.Win32UpdateService||De instanceof C.LinuxUpdateService||De instanceof q.DarwinUpdateService)&&De.initialize(),(async()=>{const ke=this._register(new ye.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));ke.schedule(),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env),ke.dispose()})();try{const Ie=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,ut.stripComments)(Ie))["enable-crash-reporter"]===void 0){const ze=(fe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&fe!==void 0?fe:!0,Ge=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],Ye=Ie.substring(0,Ie.length-2).concat(`,
`,Ge.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,st.VSBuffer.fromString(Ye))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(de,pe){this.logService.info("Tracing: waiting for windows to get ready...");const fe=de.get(Ee.IDialogMainService);let ge=!1;const Se=async De=>{if(!ge){ge=!0;const ke=await L.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${ke}`):fe.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,ke),buttons:[(0,Y.localize)(6,null)]},(0,Re.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},Le=setTimeout(()=>Se(!0),3e4);Promise.all(pe.map(De=>De.ready())).then(()=>{clearTimeout(Le),Se(!1)})}};dt=ce([ee(2,P.IInstantiationService),ee(3,l.ILogService),ee(4,u.IEnvironmentMainService),ee(5,r.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,a.IStateMainService),ee(8,qe.IFileService),ee(9,T.IProductService)],dt),e.CodeApplication=dt}),define(Q[239],J([0,1,14,20,11,3,71,46,54,160,18,33,56,172,70,68,6,224,38,17,186,48,222,235,39,93,92,19,75,42,74,193,196,180,181,10,24,73,220,21,30,22,7,35,25,66,96,178,32,55,183,202]),function(j,e,m,A,L,b,M,r,w,p,n,y,E,S,d,g,P,I,o,l,a,u,t,i,s,c,h,f,v,D,T,U,H,X,te,se,O,z,$,C,q,N,_,R,W,k,F,B,V,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),m.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(we=>console.error(we));const[x,ne,ue,be,me,Pe,Ae]=this.createServices();try{try{await this.initServices(ue,be,me)}catch(we){throw this.handleStartupDataDirError(ue,Ae.nameLong,we),we}await x.invokeFunction(async we=>{const ve=we.get(P.ILogService),Ee=we.get(n.ILifecycleMainService),Re=we.get(O.IFileService),Te=await this.claimInstance(ve,ue,Ee,x,Ae,!0);return Pe.logger=new c.SpdLogLogger("main",(0,_.join)(ue.logsPath,"main.log"),!0,Pe.getLevel()),(0,D.once)(Ee.onWillShutdown)(()=>{Re.dispose(),be.dispose()}),x.createInstance(i.CodeApplication,Te,ne).startup()})}catch(we){x.invokeFunction(this.quit,we)}}createServices(){const x=new d.ServiceCollection,ne=Object.assign({_serviceBrand:void 0},r.default);x.set(C.IProductService,ne);const ue=new W.EnvironmentMainService(this.resolveArgs(),ne),be=this.patchEnvironment(ue);x.set(W.IEnvironmentMainService,ue);const me=new h.BufferLogService,Pe=new P.MultiplexLogService([new P.ConsoleMainLogger((0,P.getLogLevel)(ue)),me]);process.once("exit",()=>Pe.dispose()),x.set(P.ILogService,Pe);const Ae=new X.FileService(Pe);x.set(O.IFileService,Ae);const we=new te.DiskFileSystemProvider(Pe);Ae.registerProvider(se.Schemas.file,we),x.set(P.ILoggerService,new B.LoggerService(Pe,Ae));const ve=new a.ConfigurationService(ue.settingsResource,Ae);x.set(l.IConfigurationService,ve),x.set(n.ILifecycleMainService,new g.SyncDescriptor(n.LifecycleMainService));const Ee=new I.StateMainService(ue,Pe);return x.set(o.IStateMainService,Ee),x.set(u.IRequestService,new g.SyncDescriptor(t.RequestMainService)),x.set(v.IThemeMainService,new g.SyncDescriptor(v.ThemeMainService)),x.set(T.ISignService,new g.SyncDescriptor(U.SignService)),x.set(z.ITunnelService,new g.SyncDescriptor($.TunnelService)),x.set(G.IProtocolMainService,new g.SyncDescriptor(Y.ProtocolMainService)),[new S.InstantiationService(x,!0),be,ue,ve,Ee,me,ne]}patchEnvironment(x){const ne={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const be=process.env[ue];typeof be=="string"&&(ne[ue]=be)}),Object.assign(process.env,ne),ne}initServices(x,ne,ue){const be=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Ae=>Ae?A.promises.mkdir(Ae,{recursive:!0}):void 0)),me=ne.initialize(),Pe=ue.init();return Promise.all([be,me,Pe])}async claimInstance(x,ne,ue,be,me,Pe){let Ae;try{(0,M.mark)("code/willStartMainServer"),Ae=await(0,E.serve)(ne.mainIPCHandle),(0,M.mark)("code/didStartMainServer"),(0,D.once)(ue.onWillShutdown)(()=>Ae.dispose())}catch(we){if(we.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ne,me.nameLong,we),we;let ve;try{ve=await(0,E.connect)(ne.mainIPCHandle,"main")}catch(Te){if(!Pe||b.isWindows||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,me.nameShort),(0,L.localize)(1,null),me.nameLong),Te;try{(0,A.unlinkSync)(ne.mainIPCHandle)}catch(Ke){throw x.warn("Could not delete obsolete instance handle",Ke),Ke}return this.claimInstance(x,ne,ue,be,me,!1)}if(ne.extensionTestsLocationURI&&!ne.debugExtensionHost.break){const Te="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(Te),ve.dispose(),new Error(Te)}let Ee;!ne.args.wait&&!ne.args.status&&(Ee=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,me.nameShort),(0,L.localize)(3,null),me.nameLong)},1e4));const Re=y.ProxyChannel.toService(ve.getChannel("launch"),{disableMarshalling:!0});if(ne.args.status)return be.invokeFunction(async()=>{const Te=new H.DiagnosticsService(F.NullTelemetryService,me),Ke=await Re.getMainProcessInfo(),Ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),qe=await Te.getDiagnostics(Ke,Ze);throw console.log(qe),new f.ExpectedError});throw b.isWindows&&await this.windowsAllowSetForegroundWindow(Re,x),x.trace("Sending env to running instance..."),await Re.start(ne.args,process.env),ve.dispose(),Ee&&clearTimeout(Ee),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ne.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ae}handleStartupDataDirError(x,ne,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const be=(0,R.coalesce)([x.userDataPath,x.extensionsPath,E.XDG_RUNTIME_DIR]).map(me=>(0,s.getPathLabel)(me,x));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,k.toErrorMessage)(ue),be.join(`
`)),ne)}}showStartupWarningDialog(x,ne,ue){m.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,L.localize)(6,null))],message:x,detail:ne,noLink:!0})}async windowsAllowSetForegroundWindow(x,ne){if(b.isWindows){const ue=await x.getMainProcessId();ne.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((be,me)=>{j(["windows-foreground-love"],be,me)})).allowSetForegroundWindow(ue)}catch(be){ne.error(be)}}}quit(x,ne){const ue=x.get(P.ILogService),be=x.get(n.ILifecycleMainService);let me=0;ne&&(ne.isExpected?ne.message&&ue.trace(ne.message):(me=1,ne.stack?ue.error(ne.stack):ue.error(`Startup error: ${ne.toString()}`))),be.kill(me)}resolveArgs(){const x=this.validatePaths((0,w.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ne=(0,p.createWaitMarkerFile)(x.verbose);ne&&((0,w.addArg)(process.argv,"--waitMarkerFilePath",ne),x.waitMarkerFilePath=ne)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ne=this.doValidatePaths(x._,x.goto);x._=ne}return x}doValidatePaths(x,ne){const ue=(0,V.cwd)(),be=x.map(Ae=>{let we=String(Ae),ve;ne&&(ve=(0,q.parseLineAndColumnAware)(we),we=ve.path),we&&(we=this.preparePath(ue,we));const Ee=(0,q.sanitizeFilePath)(we,ue),Re=(0,_.basename)(Ee);return Re&&!(0,q.isValidBasename)(Re)?null:ne&&ve?(ve.path=Ee,this.toPath(ve)):Ee}),me=b.isWindows||b.isMacintosh,Pe=(0,R.distinct)(be,Ae=>Ae&&me?Ae.toLowerCase():Ae||"");return(0,R.coalesce)(Pe)}preparePath(x,ne){return b.isWindows&&(ne=(0,N.rtrim)(ne,'"')),ne=(0,N.trim)((0,N.trim)(ne," "),"	"),b.isWindows&&(ne=(0,_.resolve)(x,ne),ne=(0,N.rtrim)(ne,".")),ne}toPath(x){const ne=[x.path];return typeof x.line=="number"&&ne.push(String(x.line)),typeof x.column=="number"&&ne.push(String(x.column)),ne.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b95b73b7b074f5dddccd57e5e290617f1a767ec1/core/vs/code/electron-main/main.js.map
