/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(Q){for(var e=[],w=0,P=Q.length;w<P;w++)e[w]=we[Q[w]];return e};define(we[42],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function w(P,A){if(!P)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=w}),define(we[51],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const w=Object.prototype.hasOwnProperty;function P(I){const d=[];for(let h in I)w.call(I,h)&&d.push(I[h]);return d}e.values=P;function A(I,d){for(let h in I)if(w.call(I,h)&&d({key:h,value:I[h]},function(){delete I[h]})===!1)return}e.forEach=A;function T(I,d){const h=Object.create(null);for(const r of I){const o=d(r);let g=h[o];g||(g=h[o]=[]),g.push(r)}return h}e.groupBy=T;function S(I,d){const h=new Map;for(const r of I){const o=d(r);let g=h.get(o);g||(g=[],h.set(o,g)),g.push(r)}return h}e.groupByNumber=S;function C(I){const d=Object.create(null);return I&&I.forEach((h,r)=>{d[r]=h}),d}e.fromMap=C;function D(I,d){const h=[],r=[];for(let o of I)d.has(o)||h.push(o);for(let o of d)I.has(o)||r.push(o);return{removed:h,added:r}}e.diffSets=D;function k(I,d){const h=[],r=[];for(let[o,g]of I)d.has(o)||h.push(g);for(let[o,g]of d)I.has(o)||r.push(g);return{removed:h,added:r}}e.diffMaps=k;class i{constructor(){this.map=new Map}add(d,h){let r=this.map.get(d);r||(r=new Set,this.map.set(d,r)),r.add(h)}delete(d,h){const r=this.map.get(d);!r||(r.delete(h),r.size===0&&this.map.delete(d))}forEach(d,h){const r=this.map.get(d);!r||r.forEach(h)}}e.SetMap=i}),define(we[52],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function w(D){return(k,i,I)=>{let d=null,h=null;if(typeof I.value=="function"?(d="value",h=I.value):typeof I.get=="function"&&(d="get",h=I.get),!h)throw new Error("not supported");I[d]=D(h,i)}}e.createDecorator=w;let P=0;function A(){const D=`$memoize${P++}`;let k;const i=function(d,h,r){let o=null,g=null;if(typeof r.value=="function"?(o="value",g=r.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof r.get=="function"&&(o="get",g=r.get),!g)throw new Error("not supported");const m=`${D}:${h}`;r[o]=function(...E){return k=this,this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!0,enumerable:!1,writable:!0,value:g.apply(this,E)}),this[m]}};return i.clear=()=>{typeof k!="undefined"&&Object.getOwnPropertyNames(k).forEach(I=>{I.indexOf(D)===0&&delete k[I]})},i}e.createMemoizer=A;function T(D,k,i){return A()(D,k,i)}e.memoize=T;function S(D,k,i){return w((I,d)=>{const h=`$debounce$${d}`,r=`$debounce$result$${d}`;return function(...o){this[r]||(this[r]=i?i():void 0),clearTimeout(this[h]),k&&(this[r]=k(this[r],...o),o=[this[r]]),this[h]=setTimeout(()=>{I.apply(this,o),this[r]=i?i():void 0},D)}})}e.debounce=S;function C(D,k,i){return w((I,d)=>{const h=`$throttle$timer$${d}`,r=`$throttle$result$${d}`,o=`$throttle$lastRun$${d}`,g=`$throttle$pending$${d}`;return function(...m){if(this[r]||(this[r]=i?i():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),k&&(this[r]=k(this[r],...m)),!this[g]){const E=this[o]+D;E<=Date.now()?(this[o]=Date.now(),I.apply(this,[this[r]]),this[r]=i?i():void 0):(this[g]=!0,this[h]=setTimeout(()=>{this[g]=!1,this[o]=Date.now(),I.apply(this,[this[r]]),this[r]=i?i():void 0},E-Date.now()))}}})}e.throttle=C}),define(we[12],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class w{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=w,e.errorHandler=new w;function P(b){e.errorHandler.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=P;function A(b){D(b)||e.errorHandler.onUnexpectedError(b)}e.onUnexpectedError=A;function T(b){D(b)||e.errorHandler.onUnexpectedExternalError(b)}e.onUnexpectedExternalError=T;function S(b){if(b instanceof Error){let{name:t,message:n}=b;const l=b.stacktrace||b.stack;return{$isError:!0,name:t,message:n,stack:l}}return b}e.transformErrorForSerialization=S;const C="Canceled";function D(b){return b instanceof Error&&b.name===C&&b.message===C}e.isPromiseCanceledError=D;class k extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=k;function i(){const b=new Error(C);return b.name=b.message,b}e.canceled=i;function I(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.illegalArgument=I;function d(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.illegalState=d;function h(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function r(b){const t=new Error(`${b} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function o(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.getErrorMessage=o;class g extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=g;class m extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=m;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function f(b){const t=b;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=f;function u(b,t=Object.create(null)){const n=new Error(b);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=u}),define(we[15],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P($,R=0){return $[$.length-(1+R)]}e.tail=P;function A($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}e.tail2=A;function T($,R,L=(M,U)=>M===U){if($===R)return!0;if(!$||!R||$.length!==R.length)return!1;for(let M=0,U=$.length;M<U;M++)if(!L($[M],R[M]))return!1;return!0}e.equals=T;function S($,R,L){let M=0,U=$.length-1;for(;M<=U;){const G=(M+U)/2|0,J=L($[G],R);if(J<0)M=G+1;else if(J>0)U=G-1;else return G}return-(M+1)}e.binarySearch=S;function C($,R){let L=0,M=$.length;if(M===0)return 0;for(;L<M;){const U=Math.floor((L+M)/2);R($[U])?M=U:L=U+1}return L}e.findFirstInSorted=C;function D($,R,L){if($=$|0,$>=R.length)throw new TypeError("invalid index");let M=R[Math.floor(R.length*Math.random())],U=[],G=[],J=[];for(let re of R){const pe=L(re,M);pe<0?U.push(re):pe>0?G.push(re):J.push(re)}return $<U.length?D($,U,L):$<U.length+J.length?J[0]:D($-(U.length+J.length),G,L)}e.quickSelect=D;function k($,R){const L=[];let M;for(const U of $.slice(0).sort(R))!M||R(M[0],U)!==0?(M=[U],L.push(M)):M.push(U);return L}e.groupBy=k;function i($,R,L){const M=[];function U(re,pe,Te){if(!(pe===0&&Te.length===0)){const xe=M[M.length-1];xe&&xe.start+xe.deleteCount===re?(xe.deleteCount+=pe,xe.toInsert.push(...Te)):M.push({start:re,deleteCount:pe,toInsert:Te})}}let G=0,J=0;for(;;){if(G===$.length){U(G,0,R.slice(J));break}if(J===R.length){U(G,$.length-G,[]);break}const re=$[G],pe=R[J],Te=L(re,pe);Te===0?(G+=1,J+=1):Te<0?(U(G,1,[]),G+=1):Te>0&&(U(G,0,[pe]),J+=1)}return M}e.sortedDiff=i;function I($,R,L){const M=i($,R,L),U=[],G=[];for(const J of M)U.push(...$.slice(J.start,J.start+J.deleteCount)),G.push(...J.toInsert);return{removed:U,added:G}}e.delta=I;function d($,R,L){if(L===0)return[];const M=$.slice(0,L).sort(R);return r($,R,M,L,$.length),M}e.top=d;function h($,R,L,M,U){return L===0?Promise.resolve([]):new Promise((G,J)=>{(async()=>{const re=$.length,pe=$.slice(0,L).sort(R);for(let Te=L,xe=Math.min(L+M,re);Te<re;Te=xe,xe=Math.min(xe+M,re)){if(Te>L&&await new Promise(Ae=>setTimeout(Ae)),U&&U.isCancellationRequested)throw(0,w.canceled)();r($,R,pe,Te,xe)}return pe})().then(G,J)})}e.topAsync=h;function r($,R,L,M,U){for(const G=L.length;M<U;M++){const J=$[M];if(R(J,L[G-1])<0){L.pop();const re=C(L,pe=>R(J,pe)<0);L.splice(re,0,J)}}}function o($){return $.filter(R=>!!R)}e.coalesce=o;function g($){let R=0;for(let L=0;L<$.length;L++)$[L]&&($[R]=$[L],R+=1);$.length=R}e.coalesceInPlace=g;function m($,R,L){$.splice(L,0,$.splice(R,1)[0])}e.move=m;function E($){return!Array.isArray($)||$.length===0}e.isFalsyOrEmpty=E;function f($){return Array.isArray($)&&$.length>0}e.isNonEmptyArray=f;function u($,R){if(!R)return $.filter((M,U)=>$.indexOf(M)===U);const L=Object.create(null);return $.filter(M=>{const U=R(M);return L[U]?!1:(L[U]=!0,!0)})}e.distinct=u;function b($){const R=new Set;return $.filter(L=>R.has(L)?!1:(R.add(L),!0))}e.distinctES6=b;function t($){const R=Object.create(null);return L=>{const M=$(L);return R[M]?!1:(R[M]=!0,!0)}}e.uniqueFilter=t;function n($,R){for(let L=$.length-1;L>=0;L--){const M=$[L];if(R(M))return L}return-1}e.lastIndex=n;function l($,R){return $.length>0?$[0]:R}e.firstOrDefault=l;function a($,R,L=(M,U)=>M===U){let M=0;for(let U=0,G=Math.min($.length,R.length);U<G&&L($[U],R[U]);U++)M++;return M}e.commonPrefixLength=a;function s($){return[].concat(...$)}e.flatten=s;function c($,R){let L=typeof R=="number"?$:0;typeof R=="number"?L=$:(L=0,R=$);const M=[];if(L<=R)for(let U=L;U<R;U++)M.push(U);else for(let U=L;U>R;U--)M.push(U);return M}e.range=c;function p($,R,L){return $.reduce((M,U)=>(M[R(U)]=L?L(U):U,M),Object.create(null))}e.index=p;function y($,R){return $.push(R),()=>v($,R)}e.insert=y;function v($,R){const L=$.indexOf(R);if(L>-1)return $.splice(L,1),R}e.remove=v;function _($,R,L){const M=$.slice(0,R),U=$.slice(R);return M.concat(L,U)}e.arrayInsert=_;function F($,R){let L;if(typeof R=="number"){let M=R;L=()=>{const U=Math.sin(M++)*179426549;return U-Math.floor(U)}}else L=Math.random;for(let M=$.length-1;M>0;M-=1){const U=Math.floor(L()*(M+1)),G=$[M];$[M]=$[U],$[U]=G}}e.shuffle=F;function x($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.unshift(R))}e.pushToStart=x;function Y($,R){const L=$.indexOf(R);L>-1&&($.splice(L,1),$.push(R))}e.pushToEnd=Y;function me($,R){return Array.isArray($)?$.map(R):R($)}e.mapArrayOrNot=me;function j($){return Array.isArray($)?$:[$]}e.asArray=j;function z($){return $[Math.floor(Math.random()*$.length)]}e.getRandomElement=z;function te($,R){for(const L of $){const M=R(L);if(M!==void 0)return M}}e.mapFind=te}),define(we[53],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function w(P){const A=this;let T=!1,S;return function(){return T||(T=!0,S=P.apply(A,arguments)),S}}e.once=w}),define(we[54],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class w{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=w,e.defaultGenerator=new w("id#")}),define(we[43],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(P){function A(b){return b&&typeof b=="object"&&typeof b[Symbol.iterator]=="function"}P.is=A;const T=Object.freeze([]);function S(){return T}P.empty=S;function*C(b){yield b}P.single=C;function D(b){return b||T}P.from=D;function k(b){return!b||b[Symbol.iterator]().next().done===!0}P.isEmpty=k;function i(b){return b[Symbol.iterator]().next().value}P.first=i;function I(b,t){for(const n of b)if(t(n))return!0;return!1}P.some=I;function d(b,t){for(const n of b)if(t(n))return n}P.find=d;function*h(b,t){for(const n of b)t(n)&&(yield n)}P.filter=h;function*r(b,t){for(const n of b)yield t(n)}P.map=r;function*o(...b){for(const t of b)for(const n of t)yield n}P.concat=o;function*g(b){for(const t of b)for(const n of t)yield n}P.concatNested=g;function m(b,t,n){let l=n;for(const a of b)l=t(l,a);return l}P.reduce=m;function*E(b,t,n=b.length){for(t<0&&(t+=b.length),n<0?n+=b.length:n>b.length&&(n=b.length);t<n;t++)yield b[t]}P.slice=E;function f(b,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,b];const l=b[Symbol.iterator]();for(let a=0;a<t;a++){const s=l.next();if(s.done)return[n,P.empty()];n.push(s.value)}return[n,{[Symbol.iterator](){return l}}]}P.consume=f;function u(b,t,n=(l,a)=>l===a){const l=b[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const s=l.next(),c=a.next();if(s.done!==c.done)return!1;if(s.done)return!0;if(!n(s.value,c.value))return!1}}P.equals=u})(w=e.Iterable||(e.Iterable={}))}),define(we[44],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(w=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function S(t,n=!1){let l=0,a=t.length,s="",c=0,p=16,y=0;function v(z){let te=0,$=0;for(;te<z;){const R=t.charCodeAt(l);if(R>=48&&R<=57)$=$*16+R-48;else if(R>=65&&R<=70)$=$*16+R-65+10;else if(R>=97&&R<=102)$=$*16+R-97+10;else break;l++,te++}return te<z&&($=-1),$}function _(z){l=z,s="",c=0,p=16,y=0}function F(){const z=l;if(t.charCodeAt(l)===48)l++;else for(l++;l<t.length&&k(t.charCodeAt(l));)l++;if(l<t.length&&t.charCodeAt(l)===46)if(l++,l<t.length&&k(t.charCodeAt(l)))for(l++;l<t.length&&k(t.charCodeAt(l));)l++;else return y=3,t.substring(z,l);let te=l;if(l<t.length&&(t.charCodeAt(l)===69||t.charCodeAt(l)===101))if(l++,(l<t.length&&t.charCodeAt(l)===43||t.charCodeAt(l)===45)&&l++,l<t.length&&k(t.charCodeAt(l))){for(l++;l<t.length&&k(t.charCodeAt(l));)l++;te=l}else y=3;return t.substring(z,te)}function x(){let z="",te=l;for(;;){if(l>=a){z+=t.substring(te,l),y=2;break}const $=t.charCodeAt(l);if($===34){z+=t.substring(te,l),l++;break}if($===92){if(z+=t.substring(te,l),l++,l>=a){y=2;break}switch(t.charCodeAt(l++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:const L=v(4);L>=0?z+=String.fromCharCode(L):y=4;break;default:y=5}te=l;continue}if($>=0&&$<=31)if(D($)){z+=t.substring(te,l),y=2;break}else y=6;l++}return z}function Y(){if(s="",y=0,c=l,l>=a)return c=a,p=17;let z=t.charCodeAt(l);if(C(z)){do l++,s+=String.fromCharCode(z),z=t.charCodeAt(l);while(C(z));return p=15}if(D(z))return l++,s+=String.fromCharCode(z),z===13&&t.charCodeAt(l)===10&&(l++,s+=`
`),p=14;switch(z){case 123:return l++,p=1;case 125:return l++,p=2;case 91:return l++,p=3;case 93:return l++,p=4;case 58:return l++,p=6;case 44:return l++,p=5;case 34:return l++,s=x(),p=10;case 47:const te=l-1;if(t.charCodeAt(l+1)===47){for(l+=2;l<a&&!D(t.charCodeAt(l));)l++;return s=t.substring(te,l),p=12}if(t.charCodeAt(l+1)===42){l+=2;const $=a-1;let R=!1;for(;l<$;){if(t.charCodeAt(l)===42&&t.charCodeAt(l+1)===47){l+=2,R=!0;break}l++}return R||(l++,y=1),s=t.substring(te,l),p=13}return s+=String.fromCharCode(z),l++,p=16;case 45:if(s+=String.fromCharCode(z),l++,l===a||!k(t.charCodeAt(l)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=F(),p=11;default:for(;l<a&&me(z);)l++,z=t.charCodeAt(l);if(c!==l){switch(s=t.substring(c,l),s){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return s+=String.fromCharCode(z),l++,p=16}}function me(z){if(C(z)||D(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function j(){let z;do z=Y();while(z>=12&&z<=15);return z}return{setPosition:_,getPosition:()=>l,scan:n?j:Y,getToken:()=>p,getTokenValue:()=>s,getTokenOffset:()=>c,getTokenLength:()=>l-c,getTokenError:()=>y}}e.createScanner=S;function C(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const l=[],a=new Object;let s;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function y(v,_,F,x){c.value=v,c.offset=_,c.length=F,c.type=x,c.colonOffset=void 0,s=c}try{f(t,{onObjectBegin:(v,_)=>{if(n<=v)throw a;s=void 0,p=n>v,l.push("")},onObjectProperty:(v,_,F)=>{if(n<_||(y(v,_,F,"property"),l[l.length-1]=v,n<=_+F))throw a},onObjectEnd:(v,_)=>{if(n<=v)throw a;s=void 0,l.pop()},onArrayBegin:(v,_)=>{if(n<=v)throw a;s=void 0,l.push(0)},onArrayEnd:(v,_)=>{if(n<=v)throw a;s=void 0,l.pop()},onLiteralValue:(v,_,F)=>{if(n<_||(y(v,_,F,b(v)),n<=_+F))throw a},onSeparator:(v,_,F)=>{if(n<=_)throw a;if(v===":"&&s&&s.type==="property")s.colonOffset=_,p=!1,s=void 0;else if(v===","){const x=l[l.length-1];typeof x=="number"?l[l.length-1]=x+1:(p=!0,l[l.length-1]=""),s=void 0}}})}catch(v){if(v!==a)throw v}return{path:l,previousNode:s,isAtPropertyKey:p,matches:v=>{let _=0;for(let F=0;_<v.length&&F<l.length;F++)if(v[_]===l[F]||v[_]==="*")_++;else if(v[_]!=="**")return!1;return _===v.length}}}e.getLocation=I;function d(t,n=[],l=T.DEFAULT){let a=null,s=[];const c=[];function p(v){Array.isArray(s)?s.push(v):a!==null&&(s[a]=v)}return f(t,{onObjectBegin:()=>{const v={};p(v),c.push(s),s=v,a=null},onObjectProperty:v=>{a=v},onObjectEnd:()=>{s=c.pop()},onArrayBegin:()=>{const v=[];p(v),c.push(s),s=v,a=null},onArrayEnd:()=>{s=c.pop()},onLiteralValue:p,onError:(v,_,F)=>{n.push({error:v,offset:_,length:F})}},l),s[0]}e.parse=d;function h(t,n=[],l=T.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(v){a.type==="property"&&(a.length=v-a.offset,a=a.parent)}function c(v){return a.children.push(v),v}f(t,{onObjectBegin:v=>{a=c({type:"object",offset:v,length:-1,parent:a,children:[]})},onObjectProperty:(v,_,F)=>{a=c({type:"property",offset:_,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:v,offset:_,length:F,parent:a})},onObjectEnd:(v,_)=>{a.length=v+_-a.offset,a=a.parent,s(v+_)},onArrayBegin:(v,_)=>{a=c({type:"array",offset:v,length:-1,parent:a,children:[]})},onArrayEnd:(v,_)=>{a.length=v+_-a.offset,a=a.parent,s(v+_)},onLiteralValue:(v,_,F)=>{c({type:b(v),offset:_,length:F,parent:a,value:v}),s(_+F)},onSeparator:(v,_,F)=>{a.type==="property"&&(v===":"?a.colonOffset=_:v===","&&s(_))},onError:(v,_,F)=>{n.push({error:v,offset:_,length:F})}},l);const y=a.children[0];return y&&delete y.parent,y}e.parseTree=h;function r(t,n){if(!!t){let l=t;for(let a of n)if(typeof a=="string"){if(l.type!=="object"||!Array.isArray(l.children))return;let s=!1;for(const c of l.children)if(Array.isArray(c.children)&&c.children[0].value===a){l=c.children[1],s=!0;break}if(!s)return}else{const s=a;if(l.type!=="array"||s<0||!Array.isArray(l.children)||s>=l.children.length)return;l=l.children[s]}return l}}e.findNodeAtLocation=r;function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const l=t.parent.children[0].value;n.push(l)}else if(t.parent.type==="array"){const l=t.parent.children.indexOf(t);l!==-1&&n.push(l)}return n}e.getNodePath=o;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const n=Object.create(null);for(let l of t.children){const a=l.children[1];a&&(n[l.children[0].value]=g(a))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=g;function m(t,n,l=!1){return n>=t.offset&&n<t.offset+t.length||l&&n===t.offset+t.length}e.contains=m;function E(t,n,l=!1){if(m(t,n,l)){const a=t.children;if(Array.isArray(a))for(let s=0;s<a.length&&a[s].offset<=n;s++){const c=E(a[s],n,l);if(c)return c}return t}}e.findNodeAtOffset=E;function f(t,n,l=T.DEFAULT){const a=S(t,!1);function s(pe){return pe?()=>pe(a.getTokenOffset(),a.getTokenLength()):()=>!0}function c(pe){return pe?Te=>pe(Te,a.getTokenOffset(),a.getTokenLength()):()=>!0}const p=s(n.onObjectBegin),y=c(n.onObjectProperty),v=s(n.onObjectEnd),_=s(n.onArrayBegin),F=s(n.onArrayEnd),x=c(n.onLiteralValue),Y=c(n.onSeparator),me=s(n.onComment),j=c(n.onError),z=l&&l.disallowComments,te=l&&l.allowTrailingComma;function $(){for(;;){const pe=a.scan();switch(a.getTokenError()){case 4:R(14);break;case 5:R(15);break;case 3:R(13);break;case 1:z||R(11);break;case 2:R(12);break;case 6:R(16);break}switch(pe){case 12:case 13:z?R(10):me();break;case 16:R(1);break;case 15:case 14:break;default:return pe}}}function R(pe,Te=[],xe=[]){if(j(pe),Te.length+xe.length>0){let Ae=a.getToken();for(;Ae!==17;){if(Te.indexOf(Ae)!==-1){$();break}else if(xe.indexOf(Ae)!==-1)break;Ae=$()}}}function L(pe){const Te=a.getTokenValue();return pe?x(Te):y(Te),$(),!0}function M(){switch(a.getToken()){case 11:let pe=0;try{pe=JSON.parse(a.getTokenValue()),typeof pe!="number"&&(R(2),pe=0)}catch(Te){R(2)}x(pe);break;case 7:x(null);break;case 8:x(!0);break;case 9:x(!1);break;default:return!1}return $(),!0}function U(){return a.getToken()!==10?(R(3,[],[2,5]),!1):(L(!1),a.getToken()===6?(Y(":"),$(),re()||R(4,[],[2,5])):R(5,[],[2,5]),!0)}function G(){p(),$();let pe=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),a.getToken()===2&&te)break}else pe&&R(6,[],[]);U()||R(4,[],[2,5]),pe=!0}return v(),a.getToken()!==2?R(7,[2],[]):$(),!0}function J(){_(),$();let pe=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(pe||R(4,[],[]),Y(","),$(),a.getToken()===4&&te)break}else pe&&R(6,[],[]);re()||R(4,[],[4,5]),pe=!0}return F(),a.getToken()!==4?R(8,[4],[]):$(),!0}function re(){switch(a.getToken()){case 3:return J();case 1:return G();case 10:return L(!0);default:return M()}}return $(),a.getToken()===17?l.allowEmptyContent?!0:(R(4,[],[]),!1):re()?(a.getToken()!==17&&R(9,[],[]),!0):(R(4,[],[]),!1)}e.visit=f;function u(t,n){let l=S(t),a=[],s,c=0,p;do switch(p=l.getPosition(),s=l.scan(),s){case 12:case 13:case 17:c!==p&&a.push(t.substring(c,p)),n!==void 0&&a.push(l.getTokenValue().replace(/[^\r\n]/g,n)),c=l.getPosition();break}while(s!==17);return a.join("")}e.stripComments=u;function b(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=b}),define(we[106],_e([0,1,44]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(D,k,i){let I,d,h,r,o;if(k){for(r=k.offset,o=r+k.length,h=r;h>0&&!C(D,h-1);)h--;let c=o;for(;c<D.length&&!C(D,c);)c++;d=D.substring(h,c),I=T(d,i)}else d=D,I=0,h=0,r=0,o=D.length;const g=S(i,D);let m=!1,E=0,f;i.insertSpaces?f=A(" ",i.tabSize||4):f="	";const u=(0,w.createScanner)(d,!1);let b=!1;function t(){return g+A(f,I+E)}function n(){let c=u.scan();for(m=!1;c===15||c===14;)m=m||c===14,c=u.scan();return b=c===16||u.getTokenError()!==0,c}const l=[];function a(c,p,y){!b&&p<o&&y>r&&D.substring(p,y)!==c&&l.push({offset:p,length:y-p,content:c})}let s=n();if(s!==17){const c=u.getTokenOffset()+h,p=A(f,I);a(p,h,c)}for(;s!==17;){let c=u.getTokenOffset()+u.getTokenLength()+h,p=n(),y="";for(;!m&&(p===12||p===13);){const _=u.getTokenOffset()+h;a(" ",c,_),c=u.getTokenOffset()+u.getTokenLength()+h,y=p===12?t():"",p=n()}if(p===2)s!==1&&(E--,y=t());else if(p===4)s!==3&&(E--,y=t());else{switch(s){case 3:case 1:E++,y=t();break;case 5:case 12:y=t();break;case 13:m?y=t():y=" ";break;case 6:y=" ";break;case 10:if(p===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?y=" ":p!==5&&p!==17&&(b=!0);break;case 16:b=!0;break}m&&(p===12||p===13)&&(y=t())}const v=u.getTokenOffset()+h;a(y,c,v),s=p}return l}e.format=P;function A(D,k){let i="";for(let I=0;I<k;I++)i+=D;return i}function T(D,k){let i=0,I=0;const d=k.tabSize||4;for(;i<D.length;){const h=D.charAt(i);if(h===" ")I++;else if(h==="	")I+=d;else break;i++}return Math.floor(I/d)}function S(D,k){for(let i=0;i<k.length;i++){const I=k.charAt(i);if(I==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=S;function C(D,k){return`\r
`.indexOf(D.charAt(k))!==-1}e.isEOL=C}),define(we[107],_e([0,1,44,106]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(k,i,I){return T(k,i,void 0,I)}e.removeProperty=A;function T(k,i,I,d,h){const r=i.slice(),o=[],g=(0,w.parseTree)(k,o);let m,E;for(;r.length>0&&(E=r.pop(),m=(0,w.findNodeAtLocation)(g,r),m===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(m)if(m.type==="object"&&typeof E=="string"&&Array.isArray(m.children)){const f=(0,w.findNodeAtLocation)(m,[E]);if(f!==void 0)if(I===void 0){if(!f.parent)throw new Error("Malformed AST");const u=m.children.indexOf(f.parent);let b,t=f.parent.offset+f.parent.length;if(u>0){const n=m.children[u-1];b=n.offset+n.length}else b=m.offset+1,m.children.length>1&&(t=m.children[1].offset);return S(k,{offset:b,length:t-b,content:""},d)}else return S(k,{offset:f.offset,length:f.length,content:JSON.stringify(I)},d);else{if(I===void 0)return[];const u=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,b=h?h(m.children.map(n=>n.children[0].value)):m.children.length;let t;if(b>0){const n=m.children[b-1];t={offset:n.offset+n.length,length:0,content:","+u}}else m.children.length===0?t={offset:m.offset+1,length:0,content:u}:t={offset:m.offset+1,length:0,content:u+","};return S(k,t,d)}}else if(m.type==="array"&&typeof E=="number"&&Array.isArray(m.children))if(I!==void 0){const f=`${JSON.stringify(I)}`;let u;if(m.children.length===0||E===0)u={offset:m.offset+1,length:0,content:m.children.length===0?f:f+","};else{const b=E===-1||E>m.children.length?m.children.length:E,t=m.children[b-1];u={offset:t.offset+t.length,length:0,content:","+f}}return S(k,u,d)}else{const f=E,u=m.children[f];let b;if(m.children.length===1)b={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===f){const t=m.children[f-1],n=t.offset+t.length,l=m.offset+m.length;b={offset:n,length:l-2-n,content:""}}else b={offset:u.offset,length:m.children[f+1].offset-u.offset,content:""};return S(k,b,d)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${m.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return S(k,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(I)},d)}}e.setProperty=T;function S(k,i,I){let d=C(k,i),h=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;h>0&&!(0,P.isEOL)(d,h-1);)h--;for(;r<d.length&&!(0,P.isEOL)(d,r);)r++}const o=(0,P.format)(d,{offset:h,length:r-h},I);for(let m=o.length-1;m>=0;m--){const E=o[m];d=C(d,E),h=Math.min(h,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const g=k.length-(d.length-r)-h;return[{offset:h,length:g,content:d.substring(h,r)}]}e.withFormatting=S;function C(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=C;function D(k,i){let I=i.slice(0).sort((h,r)=>{const o=h.offset-r.offset;return o===0?h.length-r.length:o}),d=k.length;for(let h=I.length-1;h>=0;h--){let r=I[h];if(r.offset+r.length<=d)k=C(k,r);else throw new Error("Overlapping edit");d=r.offset}return k}e.applyEdits=D}),define(we[108],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class w{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new w(()=>A(this.getValue()))}}e.Lazy=w}),define(we[6],_e([0,1,53,43]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function S(f){T=f}if(e.setDisposableTracker=S,A){const f="__is_disposable_tracked__";T=new class{trackDisposable(u){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[f]||console.log(b)},3e3)}markTracked(u){if(u&&u!==o.None)try{u[f]=!0}catch(b){}}}}function C(f){!T||T.markTracked(f)}function D(f){return T&&T.trackDisposable(f),f}e.trackDisposable=D;class k extends Error{constructor(u){super(`Encountered errors while disposing of store. Errors: [${u.join(", ")}]`);this.errors=u}}e.MultiDisposeError=k;function i(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=i;function I(f){if(P.Iterable.is(f)){let u=[];for(const b of f)if(b){C(b);try{b.dispose()}catch(t){u.push(t)}}if(u.length===1)throw u[0];if(u.length>1)throw new k(u);return Array.isArray(f)?[]:f}else if(f)return C(f),f.dispose(),f}e.dispose=I;function d(...f){return f.forEach(C),h(()=>I(f))}e.combinedDisposable=d;function h(f){const u=D({dispose:()=>{C(u),f()}});return u}e.toDisposable=h;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(C(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return C(u),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(u),u}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class o{constructor(){this._store=new r,D(this)}dispose(){C(this),this._store.dispose()}_register(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(u)}}e.Disposable=o,o.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(u){var b;this._isDisposed||u===this._value||((b=this._value)===null||b===void 0||b.dispose(),u&&C(u),this._value=u)}clear(){this.value=void 0}dispose(){var u;this._isDisposed=!0,C(this),(u=this._value)===null||u===void 0||u.dispose(),this._value=void 0}}e.MutableDisposable=g;class m{constructor(){this.references=new Map}acquire(u,...b){let t=this.references.get(u);t||(t={counter:0,object:this.createReferencedObject(u,...b)},this.references.set(u,t));const{object:n}=t,l=(0,w.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(u,t.object),this.references.delete(u))});return t.counter++,{object:n,dispose:l}}}e.ReferenceCollection=m;class E{constructor(u){this.object=u}dispose(){}}e.ImmortalReference=E}),define(we[45],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class w{constructor(T){this.element=T,this.next=w.Undefined,this.prev=w.Undefined}}w.Undefined=new w(void 0);class P{constructor(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===w.Undefined}clear(){this._first=w.Undefined,this._last=w.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,S){const C=new w(T);if(this._first===w.Undefined)this._first=C,this._last=C;else if(S){const k=this._last;this._last=C,C.prev=k,k.next=C}else{const k=this._first;this._first=C,C.next=k,k.prev=C}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(C))}}shift(){if(this._first!==w.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==w.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==w.Undefined&&T.next!==w.Undefined){const S=T.prev;S.next=T.next,T.next.prev=S}else T.prev===w.Undefined&&T.next===w.Undefined?(this._first=w.Undefined,this._last=w.Undefined):T.next===w.Undefined?(this._last=this._last.prev,this._last.next=w.Undefined):T.prev===w.Undefined&&(this._first=this._first.next,this._first.prev=w.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==w.Undefined;)yield T.element,T=T.next}}e.LinkedList=P}),function(Q,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(Q=typeof globalThis!="undefined"?globalThis:Q||self,Q.marked=e())}(this,function(){"use strict";function Q(W,ie){for(var ce=0;ce<ie.length;ce++){var V=ie[ce];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(W,V.key,V)}}function e(W,ie,ce){return ie&&Q(W.prototype,ie),ce&&Q(W,ce),W}function w(W,ie){if(!!W){if(typeof W=="string")return P(W,ie);var ce=Object.prototype.toString.call(W).slice(8,-1);if(ce==="Object"&&W.constructor&&(ce=W.constructor.name),ce==="Map"||ce==="Set")return Array.from(W);if(ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ce))return P(W,ie)}}function P(W,ie){(ie==null||ie>W.length)&&(ie=W.length);for(var ce=0,V=new Array(ie);ce<ie;ce++)V[ce]=W[ce];return V}function A(W,ie){var ce;if(typeof Symbol=="undefined"||W[Symbol.iterator]==null){if(Array.isArray(W)||(ce=w(W))||ie&&W&&typeof W.length=="number"){ce&&(W=ce);var V=0;return function(){return V>=W.length?{done:!0}:{done:!1,value:W[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return ce=W[Symbol.iterator](),ce.next.bind(ce)}function T(W){var ie={exports:{}};return W(ie,ie.exports),ie.exports}var S=T(function(W){function ie(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function ce(V){W.exports.defaults=V}W.exports={defaults:ie(),getDefaults:ie,changeDefaults:ce}}),C=/[&<>"']/,D=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ie){return I[ie]};function h(W,ie){if(ie){if(C.test(W))return W.replace(D,d)}else if(k.test(W))return W.replace(i,d);return W}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(W){return W.replace(r,function(ie,ce){return ce=ce.toLowerCase(),ce==="colon"?":":ce.charAt(0)==="#"?ce.charAt(1)==="x"?String.fromCharCode(parseInt(ce.substring(2),16)):String.fromCharCode(+ce.substring(1)):""})}var g=/(^|[^\[])\^/g;function m(W,ie){W=W.source||W,ie=ie||"";var ce={replace:function(X,ae){return ae=ae.source||ae,ae=ae.replace(g,"$1"),W=W.replace(X,ae),ce},getRegex:function(){return new RegExp(W,ie)}};return ce}var E=/[^\w:]/g,f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(W,ie,ce){if(W){var V;try{V=decodeURIComponent(o(ce)).replace(E,"").toLowerCase()}catch(X){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}ie&&!f.test(ce)&&(ce=a(ie,ce));try{ce=encodeURI(ce).replace(/%25/g,"%")}catch(X){return null}return ce}var b={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(W,ie){b[" "+W]||(t.test(W)?b[" "+W]=W+"/":b[" "+W]=y(W,"/",!0)),W=b[" "+W];var ce=W.indexOf(":")===-1;return ie.substring(0,2)==="//"?ce?ie:W.replace(n,"$1")+ie:ie.charAt(0)==="/"?ce?ie:W.replace(l,"$1")+ie:W+ie}var s={exec:function(){}};function c(W){for(var ie=1,ce,V;ie<arguments.length;ie++){ce=arguments[ie];for(V in ce)Object.prototype.hasOwnProperty.call(ce,V)&&(W[V]=ce[V])}return W}function p(W,ie){var ce=W.replace(/\|/g,function(ae,he,ye){for(var ze=!1,Be=he;--Be>=0&&ye[Be]==="\\";)ze=!ze;return ze?"|":" |"}),V=ce.split(/ \|/),X=0;if(V.length>ie)V.splice(ie);else for(;V.length<ie;)V.push("");for(;X<V.length;X++)V[X]=V[X].trim().replace(/\\\|/g,"|");return V}function y(W,ie,ce){var V=W.length;if(V===0)return"";for(var X=0;X<V;){var ae=W.charAt(V-X-1);if(ae===ie&&!ce)X++;else if(ae!==ie&&ce)X++;else break}return W.substr(0,V-X)}function v(W,ie){if(W.indexOf(ie[1])===-1)return-1;for(var ce=W.length,V=0,X=0;X<ce;X++)if(W[X]==="\\")X++;else if(W[X]===ie[0])V++;else if(W[X]===ie[1]&&(V--,V<0))return X;return-1}function _(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(W,ie){if(ie<1)return"";for(var ce="";ie>1;)ie&1&&(ce+=W),ie>>=1,W+=W;return ce+W}var x={escape:h,unescape:o,edit:m,cleanUrl:u,resolveUrl:a,noopTest:s,merge:c,splitCells:p,rtrim:y,findClosingBracket:v,checkSanitizeDeprecation:_,repeatString:F},Y=S.defaults,me=x.rtrim,j=x.splitCells,z=x.escape,te=x.findClosingBracket;function $(W,ie,ce){var V=ie.href,X=ie.title?z(ie.title):null,ae=W[1].replace(/\\([\[\]])/g,"$1");return W[0].charAt(0)!=="!"?{type:"link",raw:ce,href:V,title:X,text:ae}:{type:"image",raw:ce,href:V,title:X,text:z(ae)}}function R(W,ie){var ce=W.match(/^(\s+)(?:```)/);if(ce===null)return ie;var V=ce[1];return ie.split(`
`).map(function(X){var ae=X.match(/^\s+/);if(ae===null)return X;var he=ae[0];return he.length>=V.length?X.slice(V.length):X}).join(`
`)}var L=function(){function W(ce){this.options=ce||Y}var ie=W.prototype;return ie.space=function(V){var X=this.rules.block.newline.exec(V);if(X)return X[0].length>1?{type:"space",raw:X[0]}:{raw:`
`}},ie.code=function(V){var X=this.rules.block.code.exec(V);if(X){var ae=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?ae:me(ae,`
`)}}},ie.fences=function(V){var X=this.rules.block.fences.exec(V);if(X){var ae=X[0],he=R(ae,X[3]||"");return{type:"code",raw:ae,lang:X[2]?X[2].trim():X[2],text:he}}},ie.heading=function(V){var X=this.rules.block.heading.exec(V);if(X){var ae=X[2].trim();if(/#$/.test(ae)){var he=me(ae,"#");(this.options.pedantic||!he||/ $/.test(he))&&(ae=he.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:ae}}},ie.nptable=function(V){var X=this.rules.block.nptable.exec(V);if(X){var ae={type:"table",header:j(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[],raw:X[0]};if(ae.header.length===ae.align.length){var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=j(ae.cells[ye],ae.header.length);return ae}}},ie.hr=function(V){var X=this.rules.block.hr.exec(V);if(X)return{type:"hr",raw:X[0]}},ie.blockquote=function(V){var X=this.rules.block.blockquote.exec(V);if(X){var ae=X[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:X[0],text:ae}}},ie.list=function(V){var X=this.rules.block.list.exec(V);if(X){var ae=X[0],he=X[2],ye=he.length>1,ze={type:"list",raw:ae,ordered:ye,start:ye?+he.slice(0,-1):"",loose:!1,items:[]},Be=X[0].match(this.rules.block.item),Ne=!1,Ge,nt,dt,it,Je,mt,bt,be,de=Be.length;dt=this.rules.block.listItemStart.exec(Be[0]);for(var oe=0;oe<de;oe++){if(Ge=Be[oe],ae=Ge,oe!==de-1){if(it=this.rules.block.listItemStart.exec(Be[oe+1]),this.options.pedantic?it[1].length>dt[1].length:it[1].length>dt[0].length||it[1].length>3){Be.splice(oe,2,Be[oe]+`
`+Be[oe+1]),oe--,de--;continue}else(!this.options.pedantic||this.options.smartLists?it[2][it[2].length-1]!==he[he.length-1]:ye===(it[2].length===1))&&(Je=Be.slice(oe+1).join(`
`),ze.raw=ze.raw.substring(0,ze.raw.length-Je.length),oe=de-1);dt=it}nt=Ge.length,Ge=Ge.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ge.indexOf(`
 `)&&(nt-=Ge.length,Ge=this.options.pedantic?Ge.replace(/^ {1,4}/gm,""):Ge.replace(new RegExp("^ {1,"+nt+"}","gm"),"")),mt=Ne||/\n\n(?!\s*$)/.test(Ge),oe!==de-1&&(Ne=Ge.charAt(Ge.length-1)===`
`,mt||(mt=Ne)),mt&&(ze.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(Ge),be=void 0,bt&&(be=Ge[1]!==" ",Ge=Ge.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:ae,task:bt,checked:be,loose:mt,text:Ge})}return ze}},ie.html=function(V){var X=this.rules.block.html.exec(V);if(X)return{type:this.options.sanitize?"paragraph":"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):z(X[0]):X[0]}},ie.def=function(V){var X=this.rules.block.def.exec(V);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var ae=X[1].toLowerCase().replace(/\s+/g," ");return{tag:ae,raw:X[0],href:X[2],title:X[3]}}},ie.table=function(V){var X=this.rules.block.table.exec(V);if(X){var ae={type:"table",header:j(X[1].replace(/^ *| *\| *$/g,"")),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:X[3]?X[3].replace(/\n$/,"").split(`
`):[]};if(ae.header.length===ae.align.length){ae.raw=X[0];var he=ae.align.length,ye;for(ye=0;ye<he;ye++)/^ *-+: *$/.test(ae.align[ye])?ae.align[ye]="right":/^ *:-+: *$/.test(ae.align[ye])?ae.align[ye]="center":/^ *:-+ *$/.test(ae.align[ye])?ae.align[ye]="left":ae.align[ye]=null;for(he=ae.cells.length,ye=0;ye<he;ye++)ae.cells[ye]=j(ae.cells[ye].replace(/^ *\| *| *\| *$/g,""),ae.header.length);return ae}}},ie.lheading=function(V){var X=this.rules.block.lheading.exec(V);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1]}},ie.paragraph=function(V){var X=this.rules.block.paragraph.exec(V);if(X)return{type:"paragraph",raw:X[0],text:X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1]}},ie.text=function(V){var X=this.rules.block.text.exec(V);if(X)return{type:"text",raw:X[0],text:X[0]}},ie.escape=function(V){var X=this.rules.inline.escape.exec(V);if(X)return{type:"escape",raw:X[0],text:z(X[1])}},ie.tag=function(V,X,ae){var he=this.rules.inline.tag.exec(V);if(he)return!X&&/^<a /i.test(he[0])?X=!0:X&&/^<\/a>/i.test(he[0])&&(X=!1),!ae&&/^<(pre|code|kbd|script)(\s|>)/i.test(he[0])?ae=!0:ae&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(he[0])&&(ae=!1),{type:this.options.sanitize?"text":"html",raw:he[0],inLink:X,inRawBlock:ae,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]}},ie.link=function(V){var X=this.rules.inline.link.exec(V);if(X){var ae=X[2].trim();if(!this.options.pedantic&&/^</.test(ae)){if(!/>$/.test(ae))return;var he=me(ae.slice(0,-1),"\\");if((ae.length-he.length)%2==0)return}else{var ye=te(X[2],"()");if(ye>-1){var ze=X[0].indexOf("!")===0?5:4,Be=ze+X[1].length+ye;X[2]=X[2].substring(0,ye),X[0]=X[0].substring(0,Be).trim(),X[3]=""}}var Ne=X[2],Ge="";if(this.options.pedantic){var nt=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);nt&&(Ne=nt[1],Ge=nt[3])}else Ge=X[3]?X[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(ae)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),$(X,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Ge&&Ge.replace(this.rules.inline._escapes,"$1")},X[0])}},ie.reflink=function(V,X){var ae;if((ae=this.rules.inline.reflink.exec(V))||(ae=this.rules.inline.nolink.exec(V))){var he=(ae[2]||ae[1]).replace(/\s+/g," ");if(he=X[he.toLowerCase()],!he||!he.href){var ye=ae[0].charAt(0);return{type:"text",raw:ye,text:ye}}return $(ae,he,ae[0])}},ie.emStrong=function(V,X,ae){ae===void 0&&(ae="");var he=this.rules.inline.emStrong.lDelim.exec(V);if(!!he&&!(he[3]&&ae.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ye=he[1]||he[2]||"";if(!ye||ye&&(ae===""||this.rules.inline.punctuation.exec(ae))){var ze=he[0].length-1,Be,Ne,Ge=ze,nt=0,dt=he[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(dt.lastIndex=0,X=X.slice(-1*V.length+ze);(he=dt.exec(X))!=null;)if(Be=he[1]||he[2]||he[3]||he[4]||he[5]||he[6],!!Be){if(Ne=Be.length,he[3]||he[4]){Ge+=Ne;continue}else if((he[5]||he[6])&&ze%3&&!((ze+Ne)%3)){nt+=Ne;continue}if(Ge-=Ne,!(Ge>0)){if(Ge+nt-Ne<=0&&!X.slice(dt.lastIndex).match(dt)&&(Ne=Math.min(Ne,Ne+Ge+nt)),Math.min(ze,Ne)%2)return{type:"em",raw:V.slice(0,ze+he.index+Ne+1),text:V.slice(1,ze+he.index+Ne)};if(Math.min(ze,Ne)%2==0)return{type:"strong",raw:V.slice(0,ze+he.index+Ne+1),text:V.slice(2,ze+he.index+Ne-1)}}}}}},ie.codespan=function(V){var X=this.rules.inline.code.exec(V);if(X){var ae=X[2].replace(/\n/g," "),he=/[^ ]/.test(ae),ye=/^ /.test(ae)&&/ $/.test(ae);return he&&ye&&(ae=ae.substring(1,ae.length-1)),ae=z(ae,!0),{type:"codespan",raw:X[0],text:ae}}},ie.br=function(V){var X=this.rules.inline.br.exec(V);if(X)return{type:"br",raw:X[0]}},ie.del=function(V){var X=this.rules.inline.del.exec(V);if(X)return{type:"del",raw:X[0],text:X[2]}},ie.autolink=function(V,X){var ae=this.rules.inline.autolink.exec(V);if(ae){var he,ye;return ae[2]==="@"?(he=z(this.options.mangle?X(ae[1]):ae[1]),ye="mailto:"+he):(he=z(ae[1]),ye=he),{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.url=function(V,X){var ae;if(ae=this.rules.inline.url.exec(V)){var he,ye;if(ae[2]==="@")he=z(this.options.mangle?X(ae[0]):ae[0]),ye="mailto:"+he;else{var ze;do ze=ae[0],ae[0]=this.rules.inline._backpedal.exec(ae[0])[0];while(ze!==ae[0]);he=z(ae[0]),ae[1]==="www."?ye="http://"+he:ye=he}return{type:"link",raw:ae[0],text:he,href:ye,tokens:[{type:"text",raw:he,text:he}]}}},ie.inlineText=function(V,X,ae){var he=this.rules.inline.text.exec(V);if(he){var ye;return X?ye=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):z(he[0]):he[0]:ye=z(this.options.smartypants?ae(he[0]):he[0]),{type:"text",raw:he[0],text:ye}}},W}(),M=x.noopTest,U=x.edit,G=x.merge,J={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};J._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,J._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,J.def=U(J.def).replace("label",J._label).replace("title",J._title).getRegex(),J.bullet=/(?:[*+-]|\d{1,9}[.)])/,J.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,J.item=U(J.item,"gm").replace(/bull/g,J.bullet).getRegex(),J.listItemStart=U(/^( *)(bull)/).replace("bull",J.bullet).getRegex(),J.list=U(J.list).replace(/bull/g,J.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+J.def.source+")").getRegex(),J._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",J._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,J.html=U(J.html,"i").replace("comment",J._comment).replace("tag",J._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),J.paragraph=U(J._paragraph).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.blockquote=U(J.blockquote).replace("paragraph",J.paragraph).getRegex(),J.normal=G({},J),J.gfm=G({},J.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),J.gfm.nptable=U(J.gfm.nptable).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.gfm.table=U(J.gfm.table).replace("hr",J.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",J._tag).getRegex(),J.pedantic=G({},J.normal,{html:U(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",J._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:U(J.normal._paragraph).replace("hr",J.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",J.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var re={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};re._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",re.punctuation=U(re.punctuation).replace(/punctuation/g,re._punctuation).getRegex(),re.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,re.escapedEmSt=/\\\*|\\_/g,re._comment=U(J._comment).replace("(?:-->|$)","-->").getRegex(),re.emStrong.lDelim=U(re.emStrong.lDelim).replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimAst=U(re.emStrong.rDelimAst,"g").replace(/punct/g,re._punctuation).getRegex(),re.emStrong.rDelimUnd=U(re.emStrong.rDelimUnd,"g").replace(/punct/g,re._punctuation).getRegex(),re._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,re._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,re._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,re.autolink=U(re.autolink).replace("scheme",re._scheme).replace("email",re._email).getRegex(),re._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,re.tag=U(re.tag).replace("comment",re._comment).replace("attribute",re._attribute).getRegex(),re._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,re._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,re._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,re.link=U(re.link).replace("label",re._label).replace("href",re._href).replace("title",re._title).getRegex(),re.reflink=U(re.reflink).replace("label",re._label).getRegex(),re.reflinkSearch=U(re.reflinkSearch,"g").replace("reflink",re.reflink).replace("nolink",re.nolink).getRegex(),re.normal=G({},re),re.pedantic=G({},re.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:U(/^!?\[(label)\]\((.*?)\)/).replace("label",re._label).getRegex(),reflink:U(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",re._label).getRegex()}),re.gfm=G({},re.normal,{escape:U(re.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),re.gfm.url=U(re.gfm.url,"i").replace("email",re.gfm._extended_email).getRegex(),re.breaks=G({},re.gfm,{br:U(re.br).replace("{2,}","*").getRegex(),text:U(re.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var pe={block:J,inline:re},Te=S.defaults,xe=pe.block,Ae=pe.inline,We=x.repeatString;function B(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(W){var ie="",ce,V,X=W.length;for(ce=0;ce<X;ce++)V=W.charCodeAt(ce),Math.random()>.5&&(V="x"+V.toString(16)),ie+="&#"+V+";";return ie}var ne=function(){function W(ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=ce||Te,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var V={block:xe.normal,inline:Ae.normal};this.options.pedantic?(V.block=xe.pedantic,V.inline=Ae.pedantic):this.options.gfm&&(V.block=xe.gfm,this.options.breaks?V.inline=Ae.breaks:V.inline=Ae.gfm),this.tokenizer.rules=V}W.lex=function(V,X){var ae=new W(X);return ae.lex(V)},W.lexInline=function(V,X){var ae=new W(X);return ae.inlineTokens(V)};var ie=W.prototype;return ie.lex=function(V){return V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens,!0),this.inline(this.tokens),this.tokens},ie.blockTokens=function(V,X,ae){X===void 0&&(X=[]),ae===void 0&&(ae=!0),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var he,ye,ze,Be;V;){if(he=this.tokenizer.space(V)){V=V.substring(he.raw.length),he.type&&X.push(he);continue}if(he=this.tokenizer.code(V)){V=V.substring(he.raw.length),Be=X[X.length-1],Be&&Be.type==="paragraph"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):X.push(he);continue}if(he=this.tokenizer.fences(V)){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.heading(V)){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.nptable(V)){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.hr(V)){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.blockquote(V)){V=V.substring(he.raw.length),he.tokens=this.blockTokens(he.text,[],ae),X.push(he);continue}if(he=this.tokenizer.list(V)){for(V=V.substring(he.raw.length),ze=he.items.length,ye=0;ye<ze;ye++)he.items[ye].tokens=this.blockTokens(he.items[ye].text,[],!1);X.push(he);continue}if(he=this.tokenizer.html(V)){V=V.substring(he.raw.length),X.push(he);continue}if(ae&&(he=this.tokenizer.def(V))){V=V.substring(he.raw.length),this.tokens.links[he.tag]||(this.tokens.links[he.tag]={href:he.href,title:he.title});continue}if(he=this.tokenizer.table(V)){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.lheading(V)){V=V.substring(he.raw.length),X.push(he);continue}if(ae&&(he=this.tokenizer.paragraph(V))){V=V.substring(he.raw.length),X.push(he);continue}if(he=this.tokenizer.text(V)){V=V.substring(he.raw.length),Be=X[X.length-1],Be&&Be.type==="text"?(Be.raw+=`
`+he.raw,Be.text+=`
`+he.text):X.push(he);continue}if(V){var Ne="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return X},ie.inline=function(V){var X,ae,he,ye,ze,Be,Ne=V.length;for(X=0;X<Ne;X++)switch(Be=V[X],Be.type){case"paragraph":case"text":case"heading":{Be.tokens=[],this.inlineTokens(Be.text,Be.tokens);break}case"table":{for(Be.tokens={header:[],cells:[]},ye=Be.header.length,ae=0;ae<ye;ae++)Be.tokens.header[ae]=[],this.inlineTokens(Be.header[ae],Be.tokens.header[ae]);for(ye=Be.cells.length,ae=0;ae<ye;ae++)for(ze=Be.cells[ae],Be.tokens.cells[ae]=[],he=0;he<ze.length;he++)Be.tokens.cells[ae][he]=[],this.inlineTokens(ze[he],Be.tokens.cells[ae][he]);break}case"blockquote":{this.inline(Be.tokens);break}case"list":{for(ye=Be.items.length,ae=0;ae<ye;ae++)this.inline(Be.items[ae].tokens);break}}return V},ie.inlineTokens=function(V,X,ae,he){X===void 0&&(X=[]),ae===void 0&&(ae=!1),he===void 0&&(he=!1);var ye,ze,Be=V,Ne,Ge,nt;if(this.tokens.links){var dt=Object.keys(this.tokens.links);if(dt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Be))!=null;)dt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"["+We("a",Ne[0].length-2)+"]"+Be.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Be))!=null;)Be=Be.slice(0,Ne.index)+"++"+Be.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;){if(Ge||(nt=""),Ge=!1,ye=this.tokenizer.escape(V)){V=V.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.tag(V,ae,he)){V=V.substring(ye.raw.length),ae=ye.inLink,he=ye.inRawBlock;var it=X[X.length-1];it&&ye.type==="text"&&it.type==="text"?(it.raw+=ye.raw,it.text+=ye.text):X.push(ye);continue}if(ye=this.tokenizer.link(V)){V=V.substring(ye.raw.length),ye.type==="link"&&(ye.tokens=this.inlineTokens(ye.text,[],!0,he)),X.push(ye);continue}if(ye=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(ye.raw.length);var Je=X[X.length-1];ye.type==="link"?(ye.tokens=this.inlineTokens(ye.text,[],!0,he),X.push(ye)):Je&&ye.type==="text"&&Je.type==="text"?(Je.raw+=ye.raw,Je.text+=ye.text):X.push(ye);continue}if(ye=this.tokenizer.emStrong(V,Be,nt)){V=V.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),X.push(ye);continue}if(ye=this.tokenizer.codespan(V)){V=V.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.br(V)){V=V.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.del(V)){V=V.substring(ye.raw.length),ye.tokens=this.inlineTokens(ye.text,[],ae,he),X.push(ye);continue}if(ye=this.tokenizer.autolink(V,q)){V=V.substring(ye.raw.length),X.push(ye);continue}if(!ae&&(ye=this.tokenizer.url(V,q))){V=V.substring(ye.raw.length),X.push(ye);continue}if(ye=this.tokenizer.inlineText(V,he,B)){V=V.substring(ye.raw.length),ye.raw.slice(-1)!=="_"&&(nt=ye.raw.slice(-1)),Ge=!0,ze=X[X.length-1],ze&&ze.type==="text"?(ze.raw+=ye.raw,ze.text+=ye.text):X.push(ye);continue}if(V){var mt="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return X},e(W,null,[{key:"rules",get:function(){return{block:xe,inline:Ae}}}]),W}(),le=S.defaults,fe=x.cleanUrl,Se=x.escape,Oe=function(){function W(ce){this.options=ce||le}var ie=W.prototype;return ie.code=function(V,X,ae){var he=(X||"").match(/\S*/)[0];if(this.options.highlight){var ye=this.options.highlight(V,he);ye!=null&&ye!==V&&(ae=!0,V=ye)}return V=V.replace(/\n$/,"")+`
`,he?'<pre><code class="'+this.options.langPrefix+Se(he,!0)+'">'+(ae?V:Se(V,!0))+`</code></pre>
`:"<pre><code>"+(ae?V:Se(V,!0))+`</code></pre>
`},ie.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},ie.html=function(V){return V},ie.heading=function(V,X,ae,he){return this.options.headerIds?"<h"+X+' id="'+this.options.headerPrefix+he.slug(ae)+'">'+V+"</h"+X+`>
`:"<h"+X+">"+V+"</h"+X+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(V,X,ae){var he=X?"ol":"ul",ye=X&&ae!==1?' start="'+ae+'"':"";return"<"+he+ye+`>
`+V+"</"+he+`>
`},ie.listitem=function(V){return"<li>"+V+`</li>
`},ie.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(V){return"<p>"+V+`</p>
`},ie.table=function(V,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+X+`</table>
`},ie.tablerow=function(V){return`<tr>
`+V+`</tr>
`},ie.tablecell=function(V,X){var ae=X.header?"th":"td",he=X.align?"<"+ae+' align="'+X.align+'">':"<"+ae+">";return he+V+"</"+ae+`>
`},ie.strong=function(V){return"<strong>"+V+"</strong>"},ie.em=function(V){return"<em>"+V+"</em>"},ie.codespan=function(V){return"<code>"+V+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(V){return"<del>"+V+"</del>"},ie.link=function(V,X,ae){if(V=fe(this.options.sanitize,this.options.baseUrl,V),V===null)return ae;var he='<a href="'+Se(V)+'"';return X&&(he+=' title="'+X+'"'),he+=">"+ae+"</a>",he},ie.image=function(V,X,ae){if(V=fe(this.options.sanitize,this.options.baseUrl,V),V===null)return ae;var he='<img src="'+V+'" alt="'+ae+'"';return X&&(he+=' title="'+X+'"'),he+=this.options.xhtml?"/>":">",he},ie.text=function(V){return V},W}(),ge=function(){function W(){}var ie=W.prototype;return ie.strong=function(V){return V},ie.em=function(V){return V},ie.codespan=function(V){return V},ie.del=function(V){return V},ie.html=function(V){return V},ie.text=function(V){return V},ie.link=function(V,X,ae){return""+ae},ie.image=function(V,X,ae){return""+ae},ie.br=function(){return""},W}(),Ce=function(){function W(){this.seen={}}var ie=W.prototype;return ie.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(V,X){var ae=V,he=0;if(this.seen.hasOwnProperty(ae)){he=this.seen[V];do he++,ae=V+"-"+he;while(this.seen.hasOwnProperty(ae))}return X||(this.seen[V]=he,this.seen[ae]=0),ae},ie.slug=function(V,X){X===void 0&&(X={});var ae=this.serialize(V);return this.getNextSafeSlug(ae,X.dryrun)},W}(),Pe=S.defaults,$e=x.unescape,Ee=function(){function W(ce){this.options=ce||Pe,this.options.renderer=this.options.renderer||new Oe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ce}W.parse=function(V,X){var ae=new W(X);return ae.parse(V)},W.parseInline=function(V,X){var ae=new W(X);return ae.parseInline(V)};var ie=W.prototype;return ie.parse=function(V,X){X===void 0&&(X=!0);var ae="",he,ye,ze,Be,Ne,Ge,nt,dt,it,Je,mt,bt,be,de,oe,K,Re,Ie,Qe=V.length;for(he=0;he<Qe;he++)switch(Je=V[he],Je.type){case"space":continue;case"hr":{ae+=this.renderer.hr();continue}case"heading":{ae+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,$e(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{ae+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(dt="",nt="",Be=Je.header.length,ye=0;ye<Be;ye++)nt+=this.renderer.tablecell(this.parseInline(Je.tokens.header[ye]),{header:!0,align:Je.align[ye]});for(dt+=this.renderer.tablerow(nt),it="",Be=Je.cells.length,ye=0;ye<Be;ye++){for(Ge=Je.tokens.cells[ye],nt="",Ne=Ge.length,ze=0;ze<Ne;ze++)nt+=this.renderer.tablecell(this.parseInline(Ge[ze]),{header:!1,align:Je.align[ze]});it+=this.renderer.tablerow(nt)}ae+=this.renderer.table(dt,it);continue}case"blockquote":{it=this.parse(Je.tokens),ae+=this.renderer.blockquote(it);continue}case"list":{for(mt=Je.ordered,bt=Je.start,be=Je.loose,Be=Je.items.length,it="",ye=0;ye<Be;ye++)oe=Je.items[ye],K=oe.checked,Re=oe.task,de="",oe.task&&(Ie=this.renderer.checkbox(K),be?oe.tokens.length>0&&oe.tokens[0].type==="text"?(oe.tokens[0].text=Ie+" "+oe.tokens[0].text,oe.tokens[0].tokens&&oe.tokens[0].tokens.length>0&&oe.tokens[0].tokens[0].type==="text"&&(oe.tokens[0].tokens[0].text=Ie+" "+oe.tokens[0].tokens[0].text)):oe.tokens.unshift({type:"text",text:Ie}):de+=Ie),de+=this.parse(oe.tokens,be),it+=this.renderer.listitem(de,Re,K);ae+=this.renderer.list(it,mt,bt);continue}case"html":{ae+=this.renderer.html(Je.text);continue}case"paragraph":{ae+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(it=Je.tokens?this.parseInline(Je.tokens):Je.text;he+1<Qe&&V[he+1].type==="text";)Je=V[++he],it+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);ae+=X?this.renderer.paragraph(it):it;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return ae},ie.parseInline=function(V,X){X=X||this.renderer;var ae="",he,ye,ze=V.length;for(he=0;he<ze;he++)switch(ye=V[he],ye.type){case"escape":{ae+=X.text(ye.text);break}case"html":{ae+=X.html(ye.text);break}case"link":{ae+=X.link(ye.href,ye.title,this.parseInline(ye.tokens,X));break}case"image":{ae+=X.image(ye.href,ye.title,ye.text);break}case"strong":{ae+=X.strong(this.parseInline(ye.tokens,X));break}case"em":{ae+=X.em(this.parseInline(ye.tokens,X));break}case"codespan":{ae+=X.codespan(ye.text);break}case"br":{ae+=X.br();break}case"del":{ae+=X.del(this.parseInline(ye.tokens,X));break}case"text":{ae+=X.text(ye.text);break}default:{var Be='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}return ae},W}(),je=x.merge,H=x.checkSanitizeDeprecation,ee=x.escape,ve=S.getDefaults,Le=S.changeDefaults,He=S.defaults;function Ue(W,ie,ce){if(typeof W=="undefined"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof ie=="function"&&(ce=ie,ie=null),ie=je({},Ue.defaults,ie||{}),H(ie),ce){var V=ie.highlight,X;try{X=ne.lex(W,ie)}catch(ze){return ce(ze)}var ae=function(Be){var Ne;if(!Be)try{Ne=Ee.parse(X,ie)}catch(Ge){Be=Ge}return ie.highlight=V,Be?ce(Be):ce(null,Ne)};if(!V||V.length<3||(delete ie.highlight,!X.length))return ae();var he=0;Ue.walkTokens(X,function(ze){ze.type==="code"&&(he++,setTimeout(function(){V(ze.text,ze.lang,function(Be,Ne){if(Be)return ae(Be);Ne!=null&&Ne!==ze.text&&(ze.text=Ne,ze.escaped=!0),he--,he===0&&ae()})},0))}),he===0&&ae();return}try{var ye=ne.lex(W,ie);return ie.walkTokens&&Ue.walkTokens(ye,ie.walkTokens),Ee.parse(ye,ie)}catch(ze){if(ze.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+ee(ze.message+"",!0)+"</pre>";throw ze}}Ue.options=Ue.setOptions=function(W){return je(Ue.defaults,W),Le(Ue.defaults),Ue},Ue.getDefaults=ve,Ue.defaults=He,Ue.use=function(W){var ie=je({},W);if(W.renderer&&function(){var V=Ue.defaults.renderer||new Oe,X=function(ye){var ze=V[ye];V[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.renderer[ye].apply(V,Ne);return nt===!1&&(nt=ze.apply(V,Ne)),nt}};for(var ae in W.renderer)X(ae);ie.renderer=V}(),W.tokenizer&&function(){var V=Ue.defaults.tokenizer||new L,X=function(ye){var ze=V[ye];V[ye]=function(){for(var Be=arguments.length,Ne=new Array(Be),Ge=0;Ge<Be;Ge++)Ne[Ge]=arguments[Ge];var nt=W.tokenizer[ye].apply(V,Ne);return nt===!1&&(nt=ze.apply(V,Ne)),nt}};for(var ae in W.tokenizer)X(ae);ie.tokenizer=V}(),W.walkTokens){var ce=Ue.defaults.walkTokens;ie.walkTokens=function(V){W.walkTokens(V),ce&&ce(V)}}Ue.setOptions(ie)},Ue.walkTokens=function(W,ie){for(var ce=A(W),V;!(V=ce()).done;){var X=V.value;switch(ie(X),X.type){case"table":{for(var ae=A(X.tokens.header),he;!(he=ae()).done;){var ye=he.value;Ue.walkTokens(ye,ie)}for(var ze=A(X.tokens.cells),Be;!(Be=ze()).done;)for(var Ne=Be.value,Ge=A(Ne),nt;!(nt=Ge()).done;){var dt=nt.value;Ue.walkTokens(dt,ie)}break}case"list":{Ue.walkTokens(X.items,ie);break}default:X.tokens&&Ue.walkTokens(X.tokens,ie)}}},Ue.parseInline=function(W,ie){if(typeof W=="undefined"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");ie=je({},Ue.defaults,ie||{}),H(ie);try{var ce=ne.lexInline(W,ie);return ie.walkTokens&&Ue.walkTokens(ce,ie.walkTokens),Ee.parseInline(ce,ie)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+ee(V.message+"",!0)+"</pre>";throw V}},Ue.Parser=Ee,Ue.parser=Ee.parse,Ue.Renderer=Oe,Ue.TextRenderer=ge,Ue.Lexer=ne,Ue.lexer=ne.lex,Ue.Tokenizer=L,Ue.Slugger=Ce,Ue.parse=Ue;var Xe=Ue;return Xe}),define(we[81],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function w(S,C,D){return Math.min(Math.max(S,C),D)}e.clamp=w;function P(S,C){return(C+S%C)%C}e.rot=P;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(C){return this._val=this._val+(C-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function Q(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function S(D){T.push(D,Date.now())}function C(){const D=[];for(let k=0;k<T.length;k+=2)D.push({name:T[k],startTime:T[k+1]});return D}return{mark:S,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const S of performance.getEntriesByType("mark"))T.push({name:S.name,startTime:Math.round(A+S.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function w(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=w(P))})(),define(we[21],_e([0,1]),function(Q,e){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let A=!1,T=!1,S=!1,C=!1,D=!1,k=!1,i=!1,I,d=P,h,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const g=typeof((w=o==null?void 0:o.versions)===null||w===void 0?void 0:w.electron)=="string"&&o.type==="renderer";if(e.isElectronSandboxed=g&&(o==null?void 0:o.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=o==null?void 0:o.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!g)r=navigator.userAgent,A=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=r.indexOf("Linux")>=0,k=!0,I=navigator.language,d=I;else if(typeof o=="object"){A=o.platform==="win32",T=o.platform==="darwin",S=o.platform==="linux",C=S&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,I=P,d=P;const a=o.env.VSCODE_NLS_CONFIG;if(a)try{const s=JSON.parse(a),c=s.availableLanguages["*"];I=s.locale,d=c||P,h=s._translationsConfigFile}catch(s){}D=!0}else console.error("Unable to resolve platform.");var m;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(m=e.Platform||(e.Platform={}));function E(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let f=0;T?f=1:A?f=3:S&&(f=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=S,e.isLinuxSnap=C,e.isNative=D,e.isWeb=k,e.isIOS=i,e.platform=f,e.userAgent=r,e.language=d;var u;(function(a){function s(){return e.language}a.value=s;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=c;function p(){return e.language==="en"}a.isDefault=p})(u=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let c=[];e.globals.addEventListener("message",y=>{if(y.data&&y.data.vscodeSetImmediateId)for(let v=0,_=c.length;v<_;v++){const F=c[v];if(F.id===y.data.vscodeSetImmediateId){c.splice(v,1),F.callback();return}}});let p=0;return y=>{const v=++p;c.push({id:v,callback:y}),e.globals.postMessage({vscodeSetImmediateId:v},"*")}}if(typeof(o==null?void 0:o.nextTick)=="function")return o.nextTick.bind(o);const s=Promise.resolve();return c=>s.then(c)}();var b;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(b=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:A?1:3;let t=!0,n=!1;function l(){if(!n){n=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=l}),define(we[46],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof w.globals.vscode!="undefined"){const A=w.globals.vscode.process;P={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,w.setImmediate)(T)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:P={get platform(){return w.isWindows?"win32":w.isMacintosh?"darwin":"linux"},nextTick(A){return(0,w.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(we[13],_e([0,1,46]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,A=97,T=90,S=122,C=46,D=47,k=92,i=58,I=63;class d extends Error{constructor(u,b,t){let n;typeof b=="string"&&b.indexOf("not ")===0?(n="must not be",b=b.replace(/^not /,"")):n="must be";const l=u.indexOf(".")!==-1?"property":"argument";let a=`The "${u}" ${l} ${n} of type ${b}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(f,u){if(typeof f!="string")throw new d(u,"string",f)}function r(f){return f===D||f===k}function o(f){return f===D}function g(f){return f>=P&&f<=T||f>=A&&f<=S}function m(f,u,b,t){let n="",l=0,a=-1,s=0,c=0;for(let p=0;p<=f.length;++p){if(p<f.length)c=f.charCodeAt(p);else{if(t(c))break;c=D}if(t(c)){if(!(a===p-1||s===1))if(s===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==C||n.charCodeAt(n.length-2)!==C){if(n.length>2){const y=n.lastIndexOf(b);y===-1?(n="",l=0):(n=n.slice(0,y),l=n.length-1-n.lastIndexOf(b)),a=p,s=0;continue}else if(n.length!==0){n="",l=0,a=p,s=0;continue}}u&&(n+=n.length>0?`${b}..`:"..",l=2)}else n.length>0?n+=`${b}${f.slice(a+1,p)}`:n=f.slice(a+1,p),l=p-a-1;a=p,s=0}else c===C&&s!==-1?++s:s=-1}return n}function E(f,u){if(u===null||typeof u!="object")throw new d("pathObject","Object",u);const b=u.dir||u.root,t=u.base||`${u.name||""}${u.ext||""}`;return b?b===u.root?`${b}${t}`:`${b}${f}${t}`:t}e.win32={resolve(...f){let u="",b="",t=!1;for(let n=f.length-1;n>=-1;n--){let l;if(n>=0){if(l=f[n],h(l,"path"),l.length===0)continue}else u.length===0?l=w.cwd():(l=w.env[`=${u}`]||w.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==u.toLowerCase()&&l.charCodeAt(2)===k)&&(l=`${u}\\`));const a=l.length;let s=0,c="",p=!1;const y=l.charCodeAt(0);if(a===1)r(y)&&(s=1,p=!0);else if(r(y))if(p=!0,r(l.charCodeAt(1))){let v=2,_=v;for(;v<a&&!r(l.charCodeAt(v));)v++;if(v<a&&v!==_){const F=l.slice(_,v);for(_=v;v<a&&r(l.charCodeAt(v));)v++;if(v<a&&v!==_){for(_=v;v<a&&!r(l.charCodeAt(v));)v++;(v===a||v!==_)&&(c=`\\\\${F}\\${l.slice(_,v)}`,s=v)}}}else s=1;else g(y)&&l.charCodeAt(1)===i&&(c=l.slice(0,2),s=2,a>2&&r(l.charCodeAt(2))&&(p=!0,s=3));if(c.length>0)if(u.length>0){if(c.toLowerCase()!==u.toLowerCase())continue}else u=c;if(t){if(u.length>0)break}else if(b=`${l.slice(s)}\\${b}`,t=p,p&&u.length>0)break}return b=m(b,!t,"\\",r),t?`${u}\\${b}`:`${u}${b}`||"."},normalize(f){h(f,"path");const u=f.length;if(u===0)return".";let b=0,t,n=!1;const l=f.charCodeAt(0);if(u===1)return o(l)?"\\":f;if(r(l))if(n=!0,r(f.charCodeAt(1))){let s=2,c=s;for(;s<u&&!r(f.charCodeAt(s));)s++;if(s<u&&s!==c){const p=f.slice(c,s);for(c=s;s<u&&r(f.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&!r(f.charCodeAt(s));)s++;if(s===u)return`\\\\${p}\\${f.slice(c)}\\`;s!==c&&(t=`\\\\${p}\\${f.slice(c,s)}`,b=s)}}}else b=1;else g(l)&&f.charCodeAt(1)===i&&(t=f.slice(0,2),b=2,u>2&&r(f.charCodeAt(2))&&(n=!0,b=3));let a=b<u?m(f.slice(b),!n,"\\",r):"";return a.length===0&&!n&&(a="."),a.length>0&&r(f.charCodeAt(u-1))&&(a+="\\"),t===void 0?n?`\\${a}`:a:n?`${t}\\${a}`:`${t}${a}`},isAbsolute(f){h(f,"path");const u=f.length;if(u===0)return!1;const b=f.charCodeAt(0);return r(b)||u>2&&g(b)&&f.charCodeAt(1)===i&&r(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let u,b;for(let l=0;l<f.length;++l){const a=f[l];h(a,"path"),a.length>0&&(u===void 0?u=b=a:u+=`\\${a}`)}if(u===void 0)return".";let t=!0,n=0;if(typeof b=="string"&&r(b.charCodeAt(0))){++n;const l=b.length;l>1&&r(b.charCodeAt(1))&&(++n,l>2&&(r(b.charCodeAt(2))?++n:t=!1))}if(t){for(;n<u.length&&r(u.charCodeAt(n));)n++;n>=2&&(u=`\\${u.slice(n)}`)}return e.win32.normalize(u)},relative(f,u){if(h(f,"from"),h(u,"to"),f===u)return"";const b=e.win32.resolve(f),t=e.win32.resolve(u);if(b===t||(f=b.toLowerCase(),u=t.toLowerCase(),f===u))return"";let n=0;for(;n<f.length&&f.charCodeAt(n)===k;)n++;let l=f.length;for(;l-1>n&&f.charCodeAt(l-1)===k;)l--;const a=l-n;let s=0;for(;s<u.length&&u.charCodeAt(s)===k;)s++;let c=u.length;for(;c-1>s&&u.charCodeAt(c-1)===k;)c--;const p=c-s,y=a<p?a:p;let v=-1,_=0;for(;_<y;_++){const x=f.charCodeAt(n+_);if(x!==u.charCodeAt(s+_))break;x===k&&(v=_)}if(_!==y){if(v===-1)return t}else{if(p>y){if(u.charCodeAt(s+_)===k)return t.slice(s+_+1);if(_===2)return t.slice(s+_)}a>y&&(f.charCodeAt(n+_)===k?v=_:_===2&&(v=3)),v===-1&&(v=0)}let F="";for(_=n+v+1;_<=l;++_)(_===l||f.charCodeAt(_)===k)&&(F+=F.length===0?"..":"\\..");return s+=v,F.length>0?`${F}${t.slice(s,c)}`:(t.charCodeAt(s)===k&&++s,t.slice(s,c))},toNamespacedPath(f){if(typeof f!="string")return f;if(f.length===0)return"";const u=e.win32.resolve(f);if(u.length<=2)return f;if(u.charCodeAt(0)===k){if(u.charCodeAt(1)===k){const b=u.charCodeAt(2);if(b!==I&&b!==C)return`\\\\?\\UNC\\${u.slice(2)}`}}else if(g(u.charCodeAt(0))&&u.charCodeAt(1)===i&&u.charCodeAt(2)===k)return`\\\\?\\${u}`;return f},dirname(f){h(f,"path");const u=f.length;if(u===0)return".";let b=-1,t=0;const n=f.charCodeAt(0);if(u===1)return r(n)?f:".";if(r(n)){if(b=t=1,r(f.charCodeAt(1))){let s=2,c=s;for(;s<u&&!r(f.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&r(f.charCodeAt(s));)s++;if(s<u&&s!==c){for(c=s;s<u&&!r(f.charCodeAt(s));)s++;if(s===u)return f;s!==c&&(b=t=s+1)}}}}else g(n)&&f.charCodeAt(1)===i&&(b=u>2&&r(f.charCodeAt(2))?3:2,t=b);let l=-1,a=!0;for(let s=u-1;s>=t;--s)if(r(f.charCodeAt(s))){if(!a){l=s;break}}else a=!1;if(l===-1){if(b===-1)return".";l=b}return f.slice(0,l)},basename(f,u){u!==void 0&&h(u,"ext"),h(f,"path");let b=0,t=-1,n=!0,l;if(f.length>=2&&g(f.charCodeAt(0))&&f.charCodeAt(1)===i&&(b=2),u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let a=u.length-1,s=-1;for(l=f.length-1;l>=b;--l){const c=f.charCodeAt(l);if(r(c)){if(!n){b=l+1;break}}else s===-1&&(n=!1,s=l+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=s))}return b===t?t=s:t===-1&&(t=f.length),f.slice(b,t)}for(l=f.length-1;l>=b;--l)if(r(f.charCodeAt(l))){if(!n){b=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":f.slice(b,t)},extname(f){h(f,"path");let u=0,b=-1,t=0,n=-1,l=!0,a=0;f.length>=2&&f.charCodeAt(1)===i&&g(f.charCodeAt(0))&&(u=t=2);for(let s=f.length-1;s>=u;--s){const c=f.charCodeAt(s);if(r(c)){if(!l){t=s+1;break}continue}n===-1&&(l=!1,n=s+1),c===C?b===-1?b=s:a!==1&&(a=1):b!==-1&&(a=-1)}return b===-1||n===-1||a===0||a===1&&b===n-1&&b===t+1?"":f.slice(b,n)},format:E.bind(null,"\\"),parse(f){h(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const b=f.length;let t=0,n=f.charCodeAt(0);if(b===1)return r(n)?(u.root=u.dir=f,u):(u.base=u.name=f,u);if(r(n)){if(t=1,r(f.charCodeAt(1))){let v=2,_=v;for(;v<b&&!r(f.charCodeAt(v));)v++;if(v<b&&v!==_){for(_=v;v<b&&r(f.charCodeAt(v));)v++;if(v<b&&v!==_){for(_=v;v<b&&!r(f.charCodeAt(v));)v++;v===b?t=v:v!==_&&(t=v+1)}}}}else if(g(n)&&f.charCodeAt(1)===i){if(b<=2)return u.root=u.dir=f,u;if(t=2,r(f.charCodeAt(2))){if(b===3)return u.root=u.dir=f,u;t=3}}t>0&&(u.root=f.slice(0,t));let l=-1,a=t,s=-1,c=!0,p=f.length-1,y=0;for(;p>=t;--p){if(n=f.charCodeAt(p),r(n)){if(!c){a=p+1;break}continue}s===-1&&(c=!1,s=p+1),n===C?l===-1?l=p:y!==1&&(y=1):l!==-1&&(y=-1)}return s!==-1&&(l===-1||y===0||y===1&&l===s-1&&l===a+1?u.base=u.name=f.slice(a,s):(u.name=f.slice(a,l),u.base=f.slice(a,s),u.ext=f.slice(l,s))),a>0&&a!==t?u.dir=f.slice(0,a-1):u.dir=u.root,u},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...f){let u="",b=!1;for(let t=f.length-1;t>=-1&&!b;t--){const n=t>=0?f[t]:w.cwd();h(n,"path"),n.length!==0&&(u=`${n}/${u}`,b=n.charCodeAt(0)===D)}return u=m(u,!b,"/",o),b?`/${u}`:u.length>0?u:"."},normalize(f){if(h(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===D,b=f.charCodeAt(f.length-1)===D;return f=m(f,!u,"/",o),f.length===0?u?"/":b?"./":".":(b&&(f+="/"),u?`/${f}`:f)},isAbsolute(f){return h(f,"path"),f.length>0&&f.charCodeAt(0)===D},join(...f){if(f.length===0)return".";let u;for(let b=0;b<f.length;++b){const t=f[b];h(t,"path"),t.length>0&&(u===void 0?u=t:u+=`/${t}`)}return u===void 0?".":e.posix.normalize(u)},relative(f,u){if(h(f,"from"),h(u,"to"),f===u||(f=e.posix.resolve(f),u=e.posix.resolve(u),f===u))return"";const b=1,t=f.length,n=t-b,l=1,a=u.length-l,s=n<a?n:a;let c=-1,p=0;for(;p<s;p++){const v=f.charCodeAt(b+p);if(v!==u.charCodeAt(l+p))break;v===D&&(c=p)}if(p===s)if(a>s){if(u.charCodeAt(l+p)===D)return u.slice(l+p+1);if(p===0)return u.slice(l+p)}else n>s&&(f.charCodeAt(b+p)===D?c=p:p===0&&(c=0));let y="";for(p=b+c+1;p<=t;++p)(p===t||f.charCodeAt(p)===D)&&(y+=y.length===0?"..":"/..");return`${y}${u.slice(l+c)}`},toNamespacedPath(f){return f},dirname(f){if(h(f,"path"),f.length===0)return".";const u=f.charCodeAt(0)===D;let b=-1,t=!0;for(let n=f.length-1;n>=1;--n)if(f.charCodeAt(n)===D){if(!t){b=n;break}}else t=!1;return b===-1?u?"/":".":u&&b===1?"//":f.slice(0,b)},basename(f,u){u!==void 0&&h(u,"ext"),h(f,"path");let b=0,t=-1,n=!0,l;if(u!==void 0&&u.length>0&&u.length<=f.length){if(u===f)return"";let a=u.length-1,s=-1;for(l=f.length-1;l>=0;--l){const c=f.charCodeAt(l);if(c===D){if(!n){b=l+1;break}}else s===-1&&(n=!1,s=l+1),a>=0&&(c===u.charCodeAt(a)?--a==-1&&(t=l):(a=-1,t=s))}return b===t?t=s:t===-1&&(t=f.length),f.slice(b,t)}for(l=f.length-1;l>=0;--l)if(f.charCodeAt(l)===D){if(!n){b=l+1;break}}else t===-1&&(n=!1,t=l+1);return t===-1?"":f.slice(b,t)},extname(f){h(f,"path");let u=-1,b=0,t=-1,n=!0,l=0;for(let a=f.length-1;a>=0;--a){const s=f.charCodeAt(a);if(s===D){if(!n){b=a+1;break}continue}t===-1&&(n=!1,t=a+1),s===C?u===-1?u=a:l!==1&&(l=1):u!==-1&&(l=-1)}return u===-1||t===-1||l===0||l===1&&u===t-1&&u===b+1?"":f.slice(u,t)},format:E.bind(null,"/"),parse(f){h(f,"path");const u={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return u;const b=f.charCodeAt(0)===D;let t;b?(u.root="/",t=1):t=0;let n=-1,l=0,a=-1,s=!0,c=f.length-1,p=0;for(;c>=t;--c){const y=f.charCodeAt(c);if(y===D){if(!s){l=c+1;break}continue}a===-1&&(s=!1,a=c+1),y===C?n===-1?n=c:p!==1&&(p=1):n!==-1&&(p=-1)}if(a!==-1){const y=l===0&&b?1:l;n===-1||p===0||p===1&&n===a-1&&n===l+1?u.base=u.name=f.slice(y,a):(u.name=f.slice(y,n),u.base=f.slice(y,a),u.ext=f.slice(n,a))}return l>0?u.dir=f.slice(0,l-1):b&&(u.dir="/"),u},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=w.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w.platform==="win32"?e.win32.join:e.posix.join,e.resolve=w.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=w.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=w.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=w.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=w.platform==="win32"?e.win32.extname:e.posix.extname,e.format=w.platform==="win32"?e.win32.format:e.posix.format,e.parse=w.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=w.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=w.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[55],_e([0,1,21]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=w.globals.performance&&typeof w.globals.performance.now=="function";class A{constructor(S){this._highResolution=P&&S,this._startTime=this._now(),this._stopTime=-1}static create(S=!0){return new A(S)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?w.globals.performance.now():Date.now()}}e.StopWatch=A}),define(we[3],_e([0,1,12,53,6,45,55]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var C;(function(m){m.None=()=>A.Disposable.None;function E(j){return(z,te=null,$)=>{let R=!1,L;return L=j(M=>{if(!R)return L?L.dispose():R=!0,z.call(te,M)},null,$),R&&L.dispose(),L}}m.once=E;function f(j,z){return a((te,$=null,R)=>j(L=>te.call($,z(L)),null,R))}m.map=f;function u(j,z){return a((te,$=null,R)=>j(L=>{z(L),te.call($,L)},null,R))}m.forEach=u;function b(j,z){return a((te,$=null,R)=>j(L=>z(L)&&te.call($,L),null,R))}m.filter=b;function t(j){return j}m.signal=t;function n(...j){return(z,te=null,$)=>(0,A.combinedDisposable)(...j.map(R=>R(L=>z.call(te,L),null,$)))}m.any=n;function l(j,z,te){let $=te;return f(j,R=>($=z($,R),$))}m.reduce=l;function a(j){let z;const te=new d({onFirstListenerAdd(){z=j(te.fire,te)},onLastListenerRemove(){z.dispose()}});return te.event}m.snapshot=a;function s(j,z,te=100,$=!1,R){let L,M,U,G=0;const J=new d({leakWarningThreshold:R,onFirstListenerAdd(){L=j(re=>{G++,M=z(M,re),$&&!U&&(J.fire(M),M=void 0),clearTimeout(U),U=setTimeout(()=>{const pe=M;M=void 0,U=void 0,(!$||G>1)&&J.fire(pe),G=0},te)})},onLastListenerRemove(){L.dispose()}});return J.event}m.debounce=s;function c(j){const z=new Date().getTime();return f(E(j),te=>new Date().getTime()-z)}m.stopwatch=c;function p(j){let z=!0,te;return b(j,$=>{const R=z||$!==te;return z=!1,te=$,R})}m.latch=p;function y(j,z=!1,te=[]){let $=te.slice(),R=j(U=>{$?$.push(U):M.fire(U)});const L=()=>{$&&$.forEach(U=>M.fire(U)),$=null},M=new d({onFirstListenerAdd(){R||(R=j(U=>M.fire(U)))},onFirstListenerDidAdd(){$&&(z?setTimeout(L):L())},onLastListenerRemove(){R&&R.dispose(),R=null}});return M.event}m.buffer=y;class v{constructor(z){this.event=z}map(z){return new v(f(this.event,z))}forEach(z){return new v(u(this.event,z))}filter(z){return new v(b(this.event,z))}reduce(z,te){return new v(l(this.event,z,te))}latch(){return new v(p(this.event))}debounce(z,te=100,$=!1,R){return new v(s(this.event,z,te,$,R))}on(z,te,$){return this.event(z,te,$)}once(z,te,$){return E(this.event)(z,te,$)}}function _(j){return new v(j)}m.chain=_;function F(j,z,te=$=>$){const $=(...U)=>M.fire(te(...U)),R=()=>j.on(z,$),L=()=>j.removeListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromNodeEventEmitter=F;function x(j,z,te=$=>$){const $=(...U)=>M.fire(te(...U)),R=()=>j.addEventListener(z,$),L=()=>j.removeEventListener(z,$),M=new d({onFirstListenerAdd:R,onLastListenerRemove:L});return M.event}m.fromDOMEventEmitter=x;function Y(j){const z=new d;let te=!1;return j.then(void 0,()=>null).then(()=>{te?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),te=!0,z.event}m.fromPromise=Y;function me(j){return new Promise(z=>E(j)(z))}m.toPromise=me})(C=e.Event||(e.Event={}));class D{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${D._idPool++}`}start(E){this._stopWatch=new S.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let k=-1;function i(m){const E=k;return k=m,{dispose(){k=E}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(E,f=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=f,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let f=k;if(typeof this.customThreshold=="number"&&(f=this.customThreshold),!(f<=0||E<f)){this._stacks||(this._stacks=new Map);const u=new Error().stack.split(`
`).slice(3).join(`
`),b=this._stacks.get(u)||0;if(this._stacks.set(u,b+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=f*.5;let t,n=0;for(const[l,a]of this._stacks)(!t||n<a)&&(t=l,n=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(u)||0;this._stacks.set(u,t-1)}}}}class d{constructor(E){var f;this._disposed=!1,this._options=E,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((f=this._options)===null||f===void 0?void 0:f._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(E,f,u)=>{var b;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(f?[E,f]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,f);const l=(b=this._leakageMon)===null||b===void 0?void 0:b.check(this._listeners.size);let a;return a={dispose:()=>{l&&l(),a.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},u instanceof A.DisposableStore?u.add(a):Array.isArray(u)&&u.push(a),a}),this._event}fire(E){var f,u;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let b of this._listeners)this._deliveryQueue.push([b,E]);for((f=this._perfMon)===null||f===void 0||f.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[b,t]=this._deliveryQueue.shift();try{typeof b=="function"?b.call(void 0,t):b[0].call(b[1],t)}catch(n){(0,w.onUnexpectedError)(n)}}(u=this._perfMon)===null||u===void 0||u.stop()}}dispose(){var E,f,u;(E=this._listeners)===null||E===void 0||E.clear(),(f=this._deliveryQueue)===null||f===void 0||f.clear(),(u=this._leakageMon)===null||u===void 0||u.dispose(),this._disposed=!0}}e.Emitter=d,d._noop=function(){};class h extends d{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=h;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const f={event:E,listener:null};this.events.push(f),this.hasListeners&&this.hook(f);const u=()=>{this.hasListeners&&this.unhook(f);const b=this.events.indexOf(f);this.events.splice(b,1)};return(0,A.toDisposable)((0,P.once)(u))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(f=>this.emitter.fire(f))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(E){return(f,u,b)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>f.call(u,t)):f.call(u,t)},void 0,b)}bufferEvents(E){const f=[];this.buffers.push(f);const u=E();return this.buffers.pop(),f.forEach(b=>b()),u}}e.EventBufferer=o;class g{constructor(){this.listening=!1,this.inputEvent=C.None,this.inputEventListener=A.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(we[20],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(C,D){const k=setTimeout(C.bind(D),0);return{dispose(){clearTimeout(k)}}});var A;(function(C){function D(k){return k===C.None||k===C.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}C.isCancellationToken=D,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new w.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class S{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=S}),define(we[36],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new w.Emitter}add(I){const d=this._icons.get(I.id);d?I.description?d.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new P;e.iconRegistry=A;function T(i,I){return new C(i,I)}e.registerCodicon=T;function S(i){return i?i.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=S;class C{constructor(I,d,h){this.id=I,this.definition=d,this.description=h,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=C;function D(i,I){const d=["codicon","codicon-"+i];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=D;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(o){if(o instanceof C)return["codicon","codicon-"+o.id];const g=I.exec(o.id);if(!g)return d(C.error);let[,m,E]=g;const f=["codicon","codicon-"+m];return E&&f.push("codicon-modifier-"+E.substr(1)),f}i.asClassNameArray=d;function h(o){return d(o).join(" ")}i.asClassName=h;function r(o){return"."+d(o).join(".")}i.asCSSSelector=r})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(C=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,12,6]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(f){const u=f;return u?[u.on,u.pause,u.resume,u.destroy].every(b=>typeof b=="function"):!1}e.isReadableStream=A;function T(f){const u=f;return u?A(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=T;function S(f,u){return new C(f,u)}e.newWriteableStream=S;class C{constructor(u,b){this.reducer=u,this.options=b,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){var b;if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof((b=this.options)===null||b===void 0?void 0:b.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(b=>b(u))}emitError(u){this.listeners.error.length===0?(0,w.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(b=>b(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,b){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(b),this.resume();break;case"end":this.listeners.end.push(b),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(b),this.state.flowing&&this.flowErrors();break}}removeListener(u,b){if(!this.state.destroyed){let t;switch(u){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(b);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const b=[...this.pendingWritePromises];this.pendingWritePromises.length=0,b.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(f,u){const b=[];let t;for(;(t=f.read())!==null;)b.push(t);return u(b)}e.consumeReadable=D;function k(f,u,b){const t=[];let n;for(;(n=f.read())!==null&&t.length<b;)t.push(n);return n===null&&t.length>0?u(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const l=n;return n=void 0,l}return f.read()}}}e.peekReadable=k;function i(f,u){return new Promise((b,t)=>{const n=[];I(f,{onData:l=>{u&&n.push(l)},onError:l=>{u?t(l):b(void 0)},onEnd:()=>{b(u?u(n):void 0)}})})}e.consumeStream=i;function I(f,u){f.on("error",b=>u.onError(b)),f.on("end",()=>u.onEnd()),f.on("data",b=>u.onData(b))}e.listenStream=I;function d(f,u){return new Promise((b,t)=>{const n=new P.DisposableStore,l=[],a=p=>{if(l.push(p),l.length>u)return n.dispose(),f.pause(),b({stream:f,buffer:l,ended:!1})},s=p=>t(p),c=()=>b({stream:f,buffer:l,ended:!0});n.add((0,P.toDisposable)(()=>f.removeListener("error",s))),f.on("error",s),n.add((0,P.toDisposable)(()=>f.removeListener("end",c))),f.on("end",c),n.add((0,P.toDisposable)(()=>f.removeListener("data",a))),f.on("data",a)})}e.peekStream=d;function h(f,u){const b=S(u);return b.end(f),b}e.toStream=h;function r(){const f=S(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=r;function o(f){let u=!1;return{read:()=>u?null:(u=!0,f)}}e.toReadable=o;function g(f,u,b){const t=S(b);return I(f,{onData:n=>t.write(u.data(n)),onError:n=>t.error(u.error?u.error(n):n),onEnd:()=>t.end()}),t}e.transform=g;function m(f,u,b){let t=!1;return{read:()=>{const n=u.read();return t?n:(t=!0,n!==null?b([f,n]):f)}}}e.prefixedReadable=m;function E(f,u,b){let t=!1;const n=S(b);return I(u,{onData:l=>t?n.write(l):(t=!0,n.write(b([f,l]))),onError:l=>n.error(l),onEnd:()=>{t||(t=!0,n.write(f)),n.end()}}),n}e.prefixedStream=E}),define(we[8],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function w(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=w;const P=/{(\d+)}/g;function A(W,...ie){return ie.length===0?W:W.replace(P,function(ce,V){const X=parseInt(V,10);return isNaN(X)||X<0||X>=ie.length?ce:ie[X]})}e.format=A;function T(W){return W.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=T;function S(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function C(W,ie){let ce=0;const V=ie.charCodeAt(0);for(let X=W.length-1;X>=0;X--)W.charCodeAt(X)===V&&ce++;return ce}e.count=C;function D(W,ie,ce="\u2026"){return W.length<=ie?W:`${W.substr(0,ie)}${ce}`}e.truncate=D;function k(W,ie=" "){const ce=i(W,ie);return I(ce,ie)}e.trim=k;function i(W,ie){if(!W||!ie)return W;const ce=ie.length;if(ce===0||W.length===0)return W;let V=0;for(;W.indexOf(ie,V)===V;)V=V+ce;return W.substring(V)}e.ltrim=i;function I(W,ie){if(!W||!ie)return W;const ce=ie.length,V=W.length;if(ce===0||V===0)return W;let X=V,ae=-1;for(;ae=W.lastIndexOf(ie,X-1),!(ae===-1||ae+ce!==X);){if(ae===0)return"";X=ae}return W.substring(0,X)}e.rtrim=I;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function r(W,ie,ce={}){if(!W)throw new Error("Cannot create regex from empty string");ie||(W=S(W)),ce.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let V="";return ce.global&&(V+="g"),ce.matchCase||(V+="i"),ce.multiline&&(V+="m"),ce.unicode&&(V+="u"),new RegExp(W,V)}e.createRegExp=r;function o(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function m(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=m;function E(W){return W.split(/\r\n|\r|\n/)}e.splitLines=E;function f(W){for(let ie=0,ce=W.length;ie<ce;ie++){const V=W.charCodeAt(ie);if(V!==32&&V!==9)return ie}return-1}e.firstNonWhitespaceIndex=f;function u(W,ie=0,ce=W.length){for(let V=ie;V<ce;V++){const X=W.charCodeAt(V);if(X!==32&&X!==9)return W.substring(ie,V)}return W.substring(ie,ce)}e.getLeadingWhitespace=u;function b(W,ie=W.length-1){for(let ce=ie;ce>=0;ce--){const V=W.charCodeAt(ce);if(V!==32&&V!==9)return ce}return-1}e.lastNonWhitespaceIndex=b;function t(W,ie){return W<ie?-1:W>ie?1:0}e.compare=t;function n(W,ie,ce=0,V=W.length,X=0,ae=ie.length){for(;ce<V&&X<ae;ce++,X++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(X);if(ze<Be)return-1;if(ze>Be)return 1}const he=V-ce,ye=ae-X;return he<ye?-1:he>ye?1:0}e.compareSubstring=n;function l(W,ie){return a(W,ie,0,W.length,0,ie.length)}e.compareIgnoreCase=l;function a(W,ie,ce=0,V=W.length,X=0,ae=ie.length){for(;ce<V&&X<ae;ce++,X++){let ze=W.charCodeAt(ce),Be=ie.charCodeAt(X);if(ze!==Be){const Ne=ze-Be;if(!(Ne===32&&c(Be))&&!(Ne===-32&&c(ze)))return s(ze)&&s(Be)?Ne:n(W.toLowerCase(),ie.toLowerCase(),ce,V,X,ae)}}const he=V-ce,ye=ae-X;return he<ye?-1:he>ye?1:0}e.compareSubstringIgnoreCase=a;function s(W){return W>=97&&W<=122}e.isLowerAsciiLetter=s;function c(W){return W>=65&&W<=90}e.isUpperAsciiLetter=c;function p(W){return s(W)||c(W)}function y(W,ie){return W.length===ie.length&&v(W,ie)}e.equalsIgnoreCase=y;function v(W,ie,ce=W.length){for(let V=0;V<ce;V++){const X=W.charCodeAt(V),ae=ie.charCodeAt(V);if(X!==ae){if(p(X)&&p(ae)){const he=Math.abs(X-ae);if(he!==0&&he!==32)return!1}else if(String.fromCharCode(X).toLowerCase()!==String.fromCharCode(ae).toLowerCase())return!1}}return!0}function _(W,ie){const ce=ie.length;return ie.length>W.length?!1:v(W,ie,ce)}e.startsWithIgnoreCase=_;function F(W,ie){let ce,V=Math.min(W.length,ie.length);for(ce=0;ce<V;ce++)if(W.charCodeAt(ce)!==ie.charCodeAt(ce))return ce;return V}e.commonPrefixLength=F;function x(W,ie){let ce,V=Math.min(W.length,ie.length);const X=W.length-1,ae=ie.length-1;for(ce=0;ce<V;ce++)if(W.charCodeAt(X-ce)!==ie.charCodeAt(ae-ce))return ce;return V}e.commonSuffixLength=x;function Y(W){return 55296<=W&&W<=56319}e.isHighSurrogate=Y;function me(W){return 56320<=W&&W<=57343}e.isLowSurrogate=me;function j(W,ie){return(W-55296<<10)+(ie-56320)+65536}e.computeCodePoint=j;function z(W,ie,ce){const V=W.charCodeAt(ce);if(Y(V)&&ce+1<ie){const X=W.charCodeAt(ce+1);if(me(X))return j(V,X)}return V}e.getNextCodePoint=z;function te(W,ie){const ce=W.charCodeAt(ie-1);if(me(ce)&&ie>1){const V=W.charCodeAt(ie-2);if(Y(V))return j(V,ce)}return ce}function $(W,ie){const ce=Ue.getInstance(),V=ie,X=W.length,ae=z(W,X,ie);ie+=ae>=65536?2:1;let he=ce.getGraphemeBreakType(ae);for(;ie<X;){const ye=z(W,X,ie),ze=ce.getGraphemeBreakType(ye);if(Le(he,ze))break;ie+=ye>=65536?2:1,he=ze}return ie-V}e.nextCharLength=$;function R(W,ie){const ce=Ue.getInstance(),V=ie,X=te(W,ie);ie-=X>=65536?2:1;let ae=ce.getGraphemeBreakType(X);for(;ie>0;){const he=te(W,ie),ye=ce.getGraphemeBreakType(he);if(Le(ye,ae))break;ie-=he>=65536?2:1,ae=ye}return V-ie}e.prevCharLength=R;function L(W,ie){const ce=Ue.getInstance(),V=W.length,X=ie,ae=z(W,V,ie),he=ce.getGraphemeBreakType(ae);ie+=ae>=65536?2:1;let ye=he;for(;ie<V;){const Be=z(W,V,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(ye,Ne))break;ie+=Be>=65536?2:1,ye=Ne}const ze=ie;for(ie=X,ye=he;ie>0;){const Be=te(W,ie),Ne=ce.getGraphemeBreakType(Be);if(Le(Ne,ye))break;ie-=Be>=65536?2:1,ye=Ne}return[ie,ze]}function M(W,ie){return ie>0&&me(W.charCodeAt(ie))?L(W,ie-1):L(W,ie)}e.getCharContainingOffset=M;function U(W){const ie=W.length;let ce=0,V=0;for(;V<ie;){const he=z(W,ie,V);V+=he>=65536?2:1,he<128?ce+=1:he<2048?ce+=2:he<65536?ce+=3:ce+=4}const X=new Uint8Array(ce);V=0;let ae=0;for(;V<ie;){const he=z(W,ie,V);V+=he>=65536?2:1,he<128?X[ae++]=he:he<2048?(X[ae++]=192|(he&1984)>>>6,X[ae++]=128|(he&63)>>>0):he<65536?(X[ae++]=224|(he&61440)>>>12,X[ae++]=128|(he&4032)>>>6,X[ae++]=128|(he&63)>>>0):(X[ae++]=240|(he&1835008)>>>18,X[ae++]=128|(he&258048)>>>12,X[ae++]=128|(he&4032)>>>6,X[ae++]=128|(he&63)>>>0)}return X}e.encodeUTF8=U;function G(W){const ie=W.byteLength,ce=[];let V=0;for(;V<ie;){const X=W[V];let ae;if(X>=240&&V+3<ie?ae=(W[V++]&7)<<18>>>0|(W[V++]&63)<<12>>>0|(W[V++]&63)<<6>>>0|(W[V++]&63)<<0>>>0:X>=224&&V+2<ie?ae=(W[V++]&15)<<12>>>0|(W[V++]&63)<<6>>>0|(W[V++]&63)<<0>>>0:X>=192&&V+1<ie?ae=(W[V++]&31)<<6>>>0|(W[V++]&63)<<0>>>0:ae=W[V++],ae>=0&&ae<=55295||ae>=57344&&ae<=65535)ce.push(String.fromCharCode(ae));else if(ae>=65536&&ae<=1114111){const he=ae-65536,ye=55296+((he&1047552)>>>10),ze=56320+((he&1023)>>>0);ce.push(String.fromCharCode(ye)),ce.push(String.fromCharCode(ze))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=G;const J=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function re(W){return J.test(W)}e.containsRTL=re;const pe=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Te(W){return pe.test(W)}e.containsEmoji=Te;const xe=/^[\t\n\r\x20-\x7E]*$/;function Ae(W){return xe.test(W)}e.isBasicASCII=Ae,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function We(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=We;function B(W){for(let ie=0,ce=W.length;ie<ce;ie++)if(q(W.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=B;function q(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=q;function ne(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=ne;function le(W,ie){if(W.length<ie)return W;const ce=/\b/g;let V=0;for(;ce.test(W)&&!(W.length-ce.lastIndex<ie);)V=ce.lastIndex,ce.lastIndex+=1;return W.substring(V).replace(/^\s/,"")}e.lcut=le;const fe=/\x1B\x5B[12]?K/g,Se=/\x1b\[\d+m/g,Oe=/\x1b\[0?m/g;function ge(W){return W&&(W=W.replace(fe,""),W=W.replace(Se,""),W=W.replace(Oe,"")),W}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Pe(W){return Ce(W)?W.substr(1):W}e.stripUTF8BOM=Pe;function $e(W,ie){if(!W||!ie||W.length<ie.length)return!1;const ce=ie.length,V=W.toLowerCase();let X=0,ae=-1;for(;X<ce;){const he=V.indexOf(ie[X],ae+1);if(he<0)return!1;ae=he,X++}return!0}e.fuzzyContains=$e;function Ee(W,ie=!1){return W?(ie&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ee;function je(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=je;function H(W,ie=1){if(ie===0)return"";let ce=-1;do ce=W.indexOf(`
`,ce+1),ie--;while(ie>0&&ce>=0);return ce===-1?W:(W[ce-1]==="\r"&&ce--,W.substr(0,ce))}e.getNLines=H;function ee(W){const ie=90-65+1;return W=W%(2*ie),W<ie?String.fromCharCode(97+W):String.fromCharCode(65+W-ie)}e.singleLetterHash=ee;function ve(W){return Ue.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=ve;function Le(W,ie){return W===0?ie!==5&&ie!==7:W===2&&ie===3?!1:W===4||W===2||W===3||ie===4||ie===2||ie===3?!0:!(W===8&&(ie===8||ie===9||ie===11||ie===12)||(W===11||W===9)&&(ie===9||ie===10)||(W===12||W===10)&&ie===10||ie===5||ie===13||ie===7||W===1||W===13&&ie===14||W===6&&ie===6)}e.breakBetweenGraphemeBreakType=Le;var He;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(He=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Xe()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ce=this._data,V=ce.length/3;let X=1;for(;X<=V;)if(ie<ce[3*X])X=2*X;else if(ie>ce[3*X+1])X=2*X+1;else return ce[3*X+2];return 0}}Ue._INSTANCE=null;function Xe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(we[24],_e([0,1,8,109]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",S=typeof TextDecoder!="undefined";let C,D;class k{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return A?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,y){return!((y==null?void 0:y.dontUseNodeBuffer)||!1)&&A?new k(Buffer.from(p)):T?(C||(C=new TextEncoder),new k(C.encode(p))):new k(w.encodeUTF8(p))}static concat(p,y){if(typeof y=="undefined"){y=0;for(let F=0,x=p.length;F<x;F++)y+=p[F].byteLength}const v=k.alloc(y);let _=0;for(let F=0,x=p.length;F<x;F++){const Y=p[F];v.set(Y,_),_+=Y.byteLength}return v}toString(){return A?this.buffer.toString():S?(D||(D=new TextDecoder),D.decode(this.buffer)):w.decodeUTF8(this.buffer)}slice(p,y){return new k(this.buffer.subarray(p,y))}set(p,y){p instanceof k?this.buffer.set(p.buffer,y):this.buffer.set(p,y)}readUInt32BE(p){return d(this.buffer,p)}writeUInt32BE(p,y){h(this.buffer,p,y)}readUInt32LE(p){return r(this.buffer,p)}writeUInt32LE(p,y){o(this.buffer,p,y)}readUInt8(p){return g(this.buffer,p)}writeUInt8(p,y){m(this.buffer,p,y)}}e.VSBuffer=k;function i(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0}e.readUInt16LE=i;function I(c,p,y){c[y+0]=p&255,p=p>>>8,c[y+1]=p&255}e.writeUInt16LE=I;function d(c,p){return c[p]*2**24+c[p+1]*2**16+c[p+2]*2**8+c[p+3]}e.readUInt32BE=d;function h(c,p,y){c[y+3]=p,p=p>>>8,c[y+2]=p,p=p>>>8,c[y+1]=p,p=p>>>8,c[y]=p}e.writeUInt32BE=h;function r(c,p){return c[p+0]<<0>>>0|c[p+1]<<8>>>0|c[p+2]<<16>>>0|c[p+3]<<24>>>0}e.readUInt32LE=r;function o(c,p,y){c[y+0]=p&255,p=p>>>8,c[y+1]=p&255,p=p>>>8,c[y+2]=p&255,p=p>>>8,c[y+3]=p&255}e.writeUInt32LE=o;function g(c,p){return c[p]}e.readUInt8=g;function m(c,p,y){c[y]=p}e.writeUInt8=m;function E(c){return P.consumeReadable(c,p=>k.concat(p))}e.readableToBuffer=E;function f(c){return P.toReadable(c)}e.bufferToReadable=f;function u(c){return P.consumeStream(c,p=>k.concat(p))}e.streamToBuffer=u;async function b(c){return c.ended?k.concat(c.buffer):k.concat([...c.buffer,await u(c.stream)])}e.bufferedStreamToBuffer=b;function t(c){return P.toStream(c,p=>k.concat(p))}e.bufferToStream=t;function n(c){return P.transform(c,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.streamToBufferReadableStream=n;function l(c){return P.newWriteableStream(p=>k.concat(p),c)}e.newWriteableBufferStream=l;function a(c,p){return P.prefixedReadable(c,p,y=>k.concat(y))}e.prefixedBufferReadable=a;function s(c,p){return P.prefixedStream(c,p,y=>k.concat(y))}e.prefixedBufferStream=s}),define(we[56],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(m){return A(m,0)}e.hash=P;function A(m,E){switch(typeof m){case"object":return m===null?T(349,E):Array.isArray(m)?D(m,E):k(m,E);case"string":return C(m,E);case"boolean":return S(m,E);case"number":return T(m,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=A;function T(m,E){return(E<<5)-E+m|0}function S(m,E){return T(m?433:863,E)}function C(m,E){E=T(149417,E);for(let f=0,u=m.length;f<u;f++)E=T(m.charCodeAt(f),E);return E}e.stringHash=C;function D(m,E){return E=T(104579,E),m.reduce((f,u)=>A(u,f),E)}function k(m,E){return E=T(181387,E),Object.keys(m).sort().reduce((f,u)=>(f=C(u,f),A(m[u],f)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=A(E,this._value),this._value}}e.Hasher=i;var I;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(m,E,f=32){const u=f-E,b=~((1<<u)-1);return(m<<E|(b&m)>>>u)>>>0}function h(m,E=0,f=m.byteLength,u=0){for(let b=0;b<f;b++)m[E+b]=u}function r(m,E,f="0"){for(;m.length<E;)m=f+m;return m}function o(m,E=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(f=>f.toString(16).padStart(2,"0")).join(""):r((m>>>0).toString(16),E/4)}e.toHexString=o;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const f=E.length;if(f!==0){const u=this._buff;let b=this._buffLen,t=this._leftoverHighSurrogate,n,l;for(t!==0?(n=t,l=-1,t=0):(n=E.charCodeAt(0),l=0);;){let a=n;if(w.isHighSurrogate(n))if(l+1<f){const s=E.charCodeAt(l+1);w.isLowSurrogate(s)?(l++,a=w.computeCodePoint(n,s)):a=65533}else{t=n;break}else w.isLowSurrogate(n)&&(a=65533);if(b=this._push(u,b,a),l++,l<f)n=E.charCodeAt(l);else break}this._buffLen=b,this._leftoverHighSurrogate=t}}_push(E,f,u){return u<128?E[f++]=u:u<2048?(E[f++]=192|(u&1984)>>>6,E[f++]=128|(u&63)>>>0):u<65536?(E[f++]=224|(u&61440)>>>12,E[f++]=128|(u&4032)>>>6,E[f++]=128|(u&63)>>>0):(E[f++]=240|(u&1835008)>>>18,E[f++]=128|(u&258048)>>>12,E[f++]=128|(u&4032)>>>6,E[f++]=128|(u&63)>>>0),f>=64&&(this._step(),f-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),f}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=g._bigBlock32,f=this._buffDV;for(let p=0;p<64;p+=4)E.setUint32(p,f.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)E.setUint32(p,d(E.getUint32(p-12,!1)^E.getUint32(p-32,!1)^E.getUint32(p-56,!1)^E.getUint32(p-64,!1),1),!1);let u=this._h0,b=this._h1,t=this._h2,n=this._h3,l=this._h4,a,s,c;for(let p=0;p<80;p++)p<20?(a=b&t|~b&n,s=1518500249):p<40?(a=b^t^n,s=1859775393):p<60?(a=b&t|b&n|t&n,s=2400959708):(a=b^t^n,s=3395469782),c=d(u,5)+a+l+s+E.getUint32(p*4,!1)&4294967295,l=n,n=t,t=d(b,30),b=u,u=c;this._h0=this._h0+u&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+l&4294967295}}e.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[47],_e([0,1,8]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(P||(P={})),function(A){const T="error",S="warning",C="warn",D="info",k="ignore";function i(d){return d?w.equalsIgnoreCase(T,d)?A.Error:w.equalsIgnoreCase(S,d)||w.equalsIgnoreCase(C,d)?A.Warning:w.equalsIgnoreCase(D,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=i;function I(d){switch(d){case A.Error:return T;case A.Warning:return S;case A.Info:return D;default:return k}}A.toString=I}(P||(P={})),e.default=P}),define(we[10],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function w(p){return Array.isArray(p)}e.isArray=w;function P(p){return typeof p=="string"}e.isString=P;function A(p){return Array.isArray(p)&&p.every(y=>P(y))}e.isStringArray=A;function T(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=T;function S(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=S;function C(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=C;function D(p){return p===!0||p===!1}e.isBoolean=D;function k(p){return typeof p=="undefined"}e.isUndefined=k;function i(p){return!I(p)}e.isDefined=i;function I(p){return k(p)||p===null}e.isUndefinedOrNull=I;function d(p,y){if(!p)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=d;function h(p){if(I(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=h;function r(...p){const y=[];for(let v=0;v<p.length;v++){const _=p[v];if(I(_))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);y.push(_)}return y}e.assertAllDefined=r;const o=Object.prototype.hasOwnProperty;function g(p){if(!T(p))return!1;for(let y in p)if(o.call(p,y))return!1;return!0}e.isEmptyObject=g;function m(p){return typeof p=="function"}e.isFunction=m;function E(...p){return p.length>0&&p.every(m)}e.areFunctions=E;function f(p,y){const v=Math.min(p.length,y.length);for(let _=0;_<v;_++)u(p[_],y[_])}e.validateConstraints=f;function u(p,y){if(P(y)){if(typeof p!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(m(y)){try{if(p instanceof y)return}catch(v){}if(!I(p)&&p.constructor===y||y.length===1&&y.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=u;function b(p){let y=[],v=Object.getPrototypeOf(p);for(;Object.prototype!==v;)y=y.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return y}e.getAllPropertyNames=b;function t(p){const y=[];for(const v of b(p))typeof p[v]=="function"&&y.push(v);return y}e.getAllMethodNames=t;function n(p,y){const v=F=>function(){const x=Array.prototype.slice.call(arguments,0);return y(F,x)};let _={};for(const F of p)_[F]=v(F);return _}e.createProxyObject=n;function l(p){return p===null?void 0:p}e.withNullAsUndefined=l;function a(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=a;function s(p){return class{constructor(){return new Proxy({},{get(y,v){if(y[v])return y[v];throw new Error(`Not Implemented: ${p}->${String(v)}`)}})}}}e.NotImplementedProxy=s;function c(p){throw new Error("Unreachable")}e.assertNever=c}),define(we[37],_e([0,1,21,8,13,10]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function S(n){return n===47||n===92}e.isPathSeparator=S;function C(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=C;function D(n,l=A.posix.sep){if(!n)return"";const a=n.length,s=n.charCodeAt(0);if(S(s)){if(S(n.charCodeAt(1))&&!S(n.charCodeAt(2))){let p=3;const y=p;for(;p<a&&!S(n.charCodeAt(p));p++);if(y!==p&&!S(n.charCodeAt(p+1))){for(p+=1;p<a;p++)if(S(n.charCodeAt(p)))return n.slice(0,p+1).replace(/[\\/]/g,l)}}return l}else if(g(s)&&n.charCodeAt(1)===58)return S(n.charCodeAt(2))?n.slice(0,2)+l:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<a;c++)if(S(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=D;function k(n){if(!w.isWindows||!n||n.length<5)return!1;let l=n.charCodeAt(0);if(l!==92||(l=n.charCodeAt(1),l!==92))return!1;let a=2;const s=a;for(;a<n.length&&(l=n.charCodeAt(a),l!==92);a++);return!(s===a||(l=n.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=k;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,l=w.isWindows){const a=l?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(a.lastIndex=0,a.test(n))||l&&d.test(n)||n==="."||n===".."||l&&n[n.length-1]==="."||l&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function r(n,l,a){const s=n===l;return!a||s?s:!n||!l?!1:(0,P.equalsIgnoreCase)(n,l)}e.isEqual=r;function o(n,l,a,s=A.sep){if(n===l)return!0;if(!n||!l||l.length>n.length)return!1;if(a){if(!(0,P.startsWithIgnoreCase)(n,l))return!1;if(l.length===n.length)return!0;let p=l.length;return l.charAt(l.length-1)===s&&p--,n.charAt(p)===s}return l.charAt(l.length-1)!==s&&(l+=s),n.indexOf(l)===0}e.isEqualOrParent=o;function g(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=g;function m(n,l){return w.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(l,n)),n=(0,A.normalize)(n),w.isWindows?(n=(0,P.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,P.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=m;function E(n){const l=(0,A.normalize)(n);return w.isWindows?n.length>3?!1:f(l)&&(n.length===2||l.charCodeAt(2)===92):l===A.posix.sep}e.isRootOrDriveLetter=E;function f(n){return w.isWindows?g(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function u(n){return f(n)?n[0]:void 0}e.getDriveLetter=u;function b(n,l,a){return l.length>n.length?-1:n===l?0:(a&&(n=n.toLowerCase(),l=l.toLowerCase()),n.indexOf(l))}e.indexOfPath=b;function t(n){const l=n.split(":");let a,s,c;if(l.forEach(p=>{const y=Number(p);(0,T.isNumber)(y)?s===void 0?s=y:c===void 0&&(c=y):a=a?[a,p].join(":"):p}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:c!==void 0?c:s!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(we[23],_e([0,1,10]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const g=Array.isArray(o)?[]:{};return Object.keys(o).forEach(m=>{o[m]&&typeof o[m]=="object"?g[m]=P(o[m]):g[m]=o[m]}),g}e.deepClone=P;function A(o){if(!o||typeof o!="object")return o;const g=[o];for(;g.length>0;){const m=g.shift();Object.freeze(m);for(const E in m)if(T.call(m,E)){const f=m[E];typeof f=="object"&&!Object.isFrozen(f)&&g.push(f)}}return o}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function S(o,g){return C(o,g,new Set)}e.cloneAndChange=S;function C(o,g,m){if((0,w.isUndefinedOrNull)(o))return o;const E=g(o);if(typeof E!="undefined")return E;if((0,w.isArray)(o)){const f=[];for(const u of o)f.push(C(u,g,m));return f}if((0,w.isObject)(o)){if(m.has(o))throw new Error("Cannot clone recursive data-structure");m.add(o);const f={};for(let u in o)T.call(o,u)&&(f[u]=C(o[u],g,m));return m.delete(o),f}return o}function D(o,g,m=!0){return(0,w.isObject)(o)?((0,w.isObject)(g)&&Object.keys(g).forEach(E=>{E in o?m&&((0,w.isObject)(o[E])&&(0,w.isObject)(g[E])?D(o[E],g[E],m):o[E]=g[E]):o[E]=g[E]}),o):g}e.mixin=D;function k(o,g){if(o===g)return!0;if(o==null||g===null||g===void 0||typeof o!=typeof g||typeof o!="object"||Array.isArray(o)!==Array.isArray(g))return!1;let m,E;if(Array.isArray(o)){if(o.length!==g.length)return!1;for(m=0;m<o.length;m++)if(!k(o[m],g[m]))return!1}else{const f=[];for(E in o)f.push(E);f.sort();const u=[];for(E in g)u.push(E);if(u.sort(),!k(f,u))return!1;for(m=0;m<f.length;m++)if(!k(o[f[m]],g[f[m]]))return!1}return!0}e.equals=k;function i(o){const g=new Set;return JSON.stringify(o,(m,E)=>{if((0,w.isObject)(E)||Array.isArray(E)){if(g.has(E))return"[Circular]";g.add(E)}return E})}e.safeStringify=i;function I(o,g,m){const E=g(o);return typeof E=="undefined"?m:E}e.getOrDefault=I;function d(o,g){const m=Object.create(null);return!o||!g||Object.keys(g).forEach(f=>{const u=o[f],b=g[f];k(u,b)||(m[f]=b)}),m}e.distinct=d;function h(o,g){const m=g.toLowerCase(),E=Object.keys(o).find(f=>f.toLowerCase()===m);return E?o[E]:o[g]}e.getCaseInsensitive=h;function r(o,g){const m=Object.create(null);for(const E of Object.keys(o))g(E,o[E])&&(m[E]=o[E]);return m}e.filter=r}),define(we[82],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var w;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(w=e.Constants||(e.Constants={}));function P(T){return T<0?0:T>255?255:T|0}e.toUint8=P;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(we[2],_e([0,1,21,13]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,S=/^\/\//;function C(l,a){if(!l.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${l.authority}", path: "${l.path}", query: "${l.query}", fragment: "${l.fragment}"}`);if(l.scheme&&!A.test(l.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(l.path){if(l.authority){if(!T.test(l.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(l.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(l,a){return!l&&!a?"file":l}function k(l,a){switch(l){case"https":case"http":case"file":a?a[0]!==I&&(a=I+a):a=I;break}return a}const i="",I="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(a,s,c,p,y,v=!1){typeof a=="object"?(this.scheme=a.scheme||i,this.authority=a.authority||i,this.path=a.path||i,this.query=a.query||i,this.fragment=a.fragment||i):(this.scheme=D(a,v),this.authority=s||i,this.path=k(this.scheme,c||i),this.query=p||i,this.fragment=y||i,C(this,v))}static isUri(a){return a instanceof h?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return f(this,!1)}with(a){if(!a)return this;let{scheme:s,authority:c,path:p,query:y,fragment:v}=a;return s===void 0?s=this.scheme:s===null&&(s=i),c===void 0?c=this.authority:c===null&&(c=i),p===void 0?p=this.path:p===null&&(p=i),y===void 0?y=this.query:y===null&&(y=i),v===void 0?v=this.fragment:v===null&&(v=i),s===this.scheme&&c===this.authority&&p===this.path&&y===this.query&&v===this.fragment?this:new o(s,c,p,y,v)}static parse(a,s=!1){const c=d.exec(a);return c?new o(c[2]||i,n(c[4]||i),n(c[5]||i),n(c[7]||i),n(c[9]||i),s):new o(i,i,i,i,i)}static file(a){let s=i;if(w.isWindows&&(a=a.replace(/\\/g,I)),a[0]===I&&a[1]===I){const c=a.indexOf(I,2);c===-1?(s=a.substring(2),a=I):(s=a.substring(2,c),a=a.substring(c)||I)}return new o("file",s,a,i,i)}static from(a){return new o(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...s){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return w.isWindows&&a.scheme==="file"?c=h.file(P.win32.join(f(a,!0),...s)).path:c=P.posix.join(a.path,...s),a.with({path:c})}toString(a=!1){return u(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof h)return a;{const s=new o(a);return s._formatted=a.external,s._fsPath=a._sep===r?a.fsPath:null,s}}else return a}}e.URI=h;const r=w.isWindows?1:void 0;class o extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(a=!1){return a?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=r),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(l,a){let s,c=-1;for(let p=0;p<l.length;p++){const y=l.charCodeAt(p);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||a&&y===47)c!==-1&&(s+=encodeURIComponent(l.substring(c,p)),c=-1),s!==void 0&&(s+=l.charAt(p));else{s===void 0&&(s=l.substr(0,p));const v=g[y];v!==void 0?(c!==-1&&(s+=encodeURIComponent(l.substring(c,p)),c=-1),s+=v):c===-1&&(c=p)}}return c!==-1&&(s+=encodeURIComponent(l.substring(c))),s!==void 0?s:l}function E(l){let a;for(let s=0;s<l.length;s++){const c=l.charCodeAt(s);c===35||c===63?(a===void 0&&(a=l.substr(0,s)),a+=g[c]):a!==void 0&&(a+=l[s])}return a!==void 0?a:l}function f(l,a){let s;return l.authority&&l.path.length>1&&l.scheme==="file"?s=`//${l.authority}${l.path}`:l.path.charCodeAt(0)===47&&(l.path.charCodeAt(1)>=65&&l.path.charCodeAt(1)<=90||l.path.charCodeAt(1)>=97&&l.path.charCodeAt(1)<=122)&&l.path.charCodeAt(2)===58?a?s=l.path.substr(1):s=l.path[1].toLowerCase()+l.path.substr(2):s=l.path,w.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=f;function u(l,a){const s=a?E:m;let c="",{scheme:p,authority:y,path:v,query:_,fragment:F}=l;if(p&&(c+=p,c+=":"),(y||p==="file")&&(c+=I,c+=I),y){let x=y.indexOf("@");if(x!==-1){const Y=y.substr(0,x);y=y.substr(x+1),x=Y.indexOf(":"),x===-1?c+=s(Y,!1):(c+=s(Y.substr(0,x),!1),c+=":",c+=s(Y.substr(x+1),!1)),c+="@"}y=y.toLowerCase(),x=y.indexOf(":"),x===-1?c+=s(y,!1):(c+=s(y.substr(0,x),!1),c+=y.substr(x))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const x=v.charCodeAt(1);x>=65&&x<=90&&(v=`/${String.fromCharCode(x+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const x=v.charCodeAt(0);x>=65&&x<=90&&(v=`${String.fromCharCode(x+32)}:${v.substr(2)}`)}c+=s(v,!0)}return _&&(c+="?",c+=s(_,!1)),F&&(c+="#",c+=a?F:m(F,!1)),c}function b(l){try{return decodeURIComponent(l)}catch(a){return l.length>3?l.substr(0,3)+b(l.substr(3)):l}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(l){return l.match(t)?l.replace(t,a=>b(a)):l}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[22],_e([0,1,2,8]),function(Q,e,w,P){"use strict";var A,T,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,n,l){let a=t.get(n);return a===void 0&&(a=l,t.set(n,a)),a}e.getOrSet=C;function D(t){const n=[];return t.forEach((l,a)=>{n.push(`${a} => ${l}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function k(t){const n=[];return t.forEach(l=>{n.push(l)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const l=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return l-a}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,P.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class d{constructor(n=!0,l=!0){this._splitOnBackslash=n,this._caseSensitive=l}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const l=this._value.charCodeAt(this._to);if(l===47||this._splitOnBackslash&&l===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,P.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,P.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,P.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,P.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,P.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,P.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class g{constructor(n){this._iter=n}static forUris(n=()=>!1){return new g(new r(n))}static forPaths(){return new g(new d)}static forStrings(){return new g(new i)}static forConfigKeys(){return new g(new I)}clear(){this._root=void 0}set(n,l){const a=this._iter.reset(n);let s;for(this._root||(this._root=new o,this._root.segment=a.value()),s=this._root;;){const p=a.cmp(s.segment);if(p>0)s.left||(s.left=new o,s.left.segment=a.value()),s=s.left;else if(p<0)s.right||(s.right=new o,s.right.segment=a.value()),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new o,s.mid.segment=a.value()),s=s.mid;else break}const c=s.value;return s.value=l,s.key=n,c}get(n){var l;return(l=this._getNode(n))===null||l===void 0?void 0:l.value}_getNode(n){const l=this._iter.reset(n);let a=this._root;for(;a;){const s=l.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(l.hasNext())l.next(),a=a.mid;else break}return a}has(n){const l=this._getNode(n);return!((l==null?void 0:l.value)===void 0&&(l==null?void 0:l.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,l){const a=this._iter.reset(n),s=[];let c=this._root;for(;c;){const p=a.cmp(c.segment);if(p>0)s.push([1,c]),c=c.left;else if(p<0)s.push([-1,c]),c=c.right;else if(a.hasNext())a.next(),s.push([0,c]),c=c.mid;else{for(l?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;s.length>0&&c.isEmpty();){let[y,v]=s.pop();switch(y){case 1:v.left=void 0;break;case 0:v.mid=void 0;break;case-1:v.right=void 0;break}c=v}break}}}findSubstr(n){const l=this._iter.reset(n);let a=this._root,s;for(;a;){const c=l.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(l.hasNext())l.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr(n){const l=this._iter.reset(n);let a=this._root;for(;a;){const s=l.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(l.hasNext())l.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[l,a]of this)n(a,l)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=g;class m{constructor(n,l){this[A]="ResourceMap",n instanceof m?(this.map=new Map(n.map),this.toKey=l!=null?l:m.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:m.defaultToKey)}set(n,l){return this.map.set(this.toKey(n),l),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,l){typeof l!="undefined"&&(n=n.bind(l));for(let[a,s]of this.map)n(s,w.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield w.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[w.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[w.URI.parse(n[0]),n[1]]}}e.ResourceMap=m,m.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class f{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,l=0){const a=this._map.get(n);if(!!a)return l!==0&&this.touch(a,l),a.value}set(n,l,a=0){let s=this._map.get(n);if(s)s.value=l,a!==0&&this.touch(s,a);else{switch(s={key:n,value:l,next:void 0,previous:void 0},a){case 0:this.addItemLast(s);break;case 1:this.addItemFirst(s);break;case 2:this.addItemLast(s);break;default:this.addItemLast(s);break}this._map.set(n,s),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const l=this._map.get(n);if(!!l)return this._map.delete(n),this.removeItem(l),this._size--,l.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,l){const a=this._state;let s=this._head;for(;s;){if(l?n.bind(l)(s.value,s.key,this):n(s.value,s.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.key,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}values(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:a.value,done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}entries(){const n=this,l=this._state;let a=this._head;const s={[Symbol.iterator](){return s},next(){if(n._state!==l)throw new Error("LinkedMap got modified during iteration.");if(a){const c={value:[a.key,a.value],done:!1};return a=a.next,c}else return{value:void 0,done:!0}}};return s}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let l=this._head,a=this.size;for(;l&&a>n;)this._map.delete(l.key),l=l.next,a--;this._head=l,this._size=a,l&&(l.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const l=n.next,a=n.previous;if(!l||!a)throw new Error("Invalid list");l.previous=a,a.next=l}n.next=void 0,n.previous=void 0,this._state++}touch(n,l){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(n===this._head)return;const a=n.next,s=n.previous;n===this._tail?(s.next=void 0,this._tail=s):(a.previous=s,s.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(l===2){if(n===this._tail)return;const a=n.next,s=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=s,s.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((l,a)=>{n.push([a,l])}),n}fromJSON(n){this.clear();for(const[l,a]of n)this.set(l,a)}}e.LinkedMap=f;class u extends f{constructor(n,l=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,l),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,l=2){return super.get(n,l)}peek(n){return super.get(n,0)}set(n,l){return super.set(n,l,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u;class b{constructor(n){S.set(this,void 0),tt(this,S,n,"f")}get size(){return Me(this,S,"f").size}forEach(n,l){Me(this,S,"f").forEach(n,l)}get(n){return Me(this,S,"f").get(n)}has(n){return Me(this,S,"f").has(n)}entries(){return Me(this,S,"f").entries()}keys(){return Me(this,S,"f").keys()}values(){return Me(this,S,"f").values()}[(S=new WeakMap,Symbol.iterator)](){return Me(this,S,"f").entries()}}e.ReadonlyMapView=b}),define(we[110],_e([0,1,22,8]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...ge){return function(Ce,Pe){for(let $e=0,Ee=ge.length;$e<Ee;$e++){const je=ge[$e](Ce,Pe);if(je)return je}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(ge,Ce,Pe){if(!Pe||Pe.length<Ce.length)return null;let $e;return ge?$e=P.startsWithIgnoreCase(Pe,Ce):$e=Pe.indexOf(Ce)===0,$e?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function S(ge,Ce){const Pe=Ce.toLowerCase().indexOf(ge.toLowerCase());return Pe===-1?null:[{start:Pe,end:Pe+ge.length}]}e.matchesContiguousSubString=S;function C(ge,Ce){return D(ge.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=C;function D(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]===Ce[$e]){let Ee=null;return(Ee=D(ge,Ce,Pe+1,$e+1))?m({start:$e,end:$e+1},Ee):null}return D(ge,Ce,Pe,$e+1)}function k(ge){return 97<=ge&&ge<=122}function i(ge){return 65<=ge&&ge<=90}e.isUpper=i;function I(ge){return 48<=ge&&ge<=57}function d(ge){return ge===32||ge===9||ge===10||ge===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>h.add(ge.charCodeAt(0)));function r(ge){return d(ge)||h.has(ge)}function o(ge,Ce){return ge===Ce||r(ge)&&r(Ce)}function g(ge){return k(ge)||i(ge)||I(ge)}function m(ge,Ce){return Ce.length===0?Ce=[ge]:ge.end===Ce[0].start?Ce[0].start=ge.start:Ce.unshift(ge),Ce}function E(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++){const $e=ge.charCodeAt(Pe);if(i($e)||I($e)||Pe>0&&!g(ge.charCodeAt(Pe-1)))return Pe}return ge.length}function f(ge,Ce,Pe,$e){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(ge[Pe]!==Ce[$e].toLowerCase())return null;{let Ee=null,je=$e+1;for(Ee=f(ge,Ce,Pe+1,$e+1);!Ee&&(je=E(Ce,je))<Ce.length;)Ee=f(ge,Ce,Pe+1,je),je++;return Ee===null?null:m({start:$e,end:$e+1},Ee)}}function u(ge){let Ce=0,Pe=0,$e=0,Ee=0,je=0;for(let He=0;He<ge.length;He++)je=ge.charCodeAt(He),i(je)&&Ce++,k(je)&&Pe++,g(je)&&$e++,I(je)&&Ee++;const H=Ce/ge.length,ee=Pe/ge.length,ve=$e/ge.length,Le=Ee/ge.length;return{upperPercent:H,lowerPercent:ee,alphaPercent:ve,numericPercent:Le}}function b(ge){const{upperPercent:Ce,lowerPercent:Pe}=ge;return Pe===0&&Ce>.6}function t(ge){const{upperPercent:Ce,lowerPercent:Pe,alphaPercent:$e,numericPercent:Ee}=ge;return Pe>.2&&Ce<.8&&$e>.6&&Ee<.2}function n(ge){let Ce=0,Pe=0,$e=0,Ee=0;for(let je=0;je<ge.length;je++)$e=ge.charCodeAt(je),i($e)&&Ce++,k($e)&&Pe++,d($e)&&Ee++;return(Ce===0||Pe===0)&&Ee===0?ge.length<=30:Ce<=5}function l(ge,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(ge)||Ce.length>60)return null;const Pe=u(Ce);if(!t(Pe)){if(!b(Pe))return null;Ce=Ce.toLowerCase()}let $e=null,Ee=0;for(ge=ge.toLowerCase();Ee<Ce.length&&($e=f(ge,Ce,0,Ee))===null;)Ee=E(Ce,Ee+1);return $e}e.matchesCamelCase=l;function a(ge,Ce,Pe=!1){if(!Ce||Ce.length===0)return null;let $e=null,Ee=0;for(ge=ge.toLowerCase(),Ce=Ce.toLowerCase();Ee<Ce.length&&($e=s(ge,Ce,0,Ee,Pe))===null;)Ee=c(Ce,Ee+1);return $e}e.matchesWords=a;function s(ge,Ce,Pe,$e,Ee){if(Pe===ge.length)return[];if($e===Ce.length)return null;if(o(ge.charCodeAt(Pe),Ce.charCodeAt($e))){let je=null,H=$e+1;if(je=s(ge,Ce,Pe+1,$e+1,Ee),!Ee)for(;!je&&(H=c(Ce,H))<Ce.length;)je=s(ge,Ce,Pe+1,H,Ee),H++;return je===null?null:m({start:$e,end:$e+1},je)}else return null}function c(ge,Ce){for(let Pe=Ce;Pe<ge.length;Pe++)if(r(ge.charCodeAt(Pe))||Pe>0&&r(ge.charCodeAt(Pe-1)))return Pe;return ge.length}const p=A(e.matchesPrefix,l,S),y=A(e.matchesPrefix,l,C),v=new w.LRUCache(1e4);function _(ge,Ce,Pe=!1){if(typeof ge!="string"||typeof Ce!="string")return null;let $e=v.get(ge);$e||($e=new RegExp(P.convertSimple2RegExpPattern(ge),"i"),v.set(ge,$e));const Ee=$e.exec(Ce);return Ee?[{start:Ee.index,end:Ee.index+Ee[0].length}]:Pe?y(ge,Ce):p(ge,Ce)}e.matchesFuzzy=_;function F(ge,Ce){const Pe=B(ge,ge.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Pe?Y(Pe):null}e.matchesFuzzy2=F;function x(ge,Ce,Pe,$e,Ee,je){const H=Math.min(13,ge.length);for(;Pe<H;Pe++){const ee=B(ge,Ce,Pe,$e,Ee,je,!1);if(ee)return ee}return[0,je]}e.anyScore=x;function Y(ge){if(typeof ge=="undefined")return[];const Ce=[],Pe=ge[1];for(let $e=ge.length-1;$e>1;$e--){const Ee=ge[$e]+Pe,je=Ce[Ce.length-1];je&&je.end===Ee?je.end=Ee+1:Ce.push({start:Ee,end:Ee+1})}return Ce}e.createMatches=Y;const me=128;function j(){const ge=[],Ce=[];for(let Pe=0;Pe<=me;Pe++)Ce[Pe]=0;for(let Pe=0;Pe<=me;Pe++)ge.push(Ce.slice(0));return ge}function z(ge){const Ce=[];for(let Pe=0;Pe<=ge;Pe++)Ce[Pe]=0;return Ce}const te=z(2*me),$=z(2*me),R=j(),L=j(),M=j(),U=!1;function G(ge,Ce,Pe,$e,Ee){function je(ee,ve,Le=" "){for(;ee.length<ve;)ee=Le+ee;return ee}let H=` |   |${$e.split("").map(ee=>je(ee,3)).join("|")}
`;for(let ee=0;ee<=Pe;ee++)ee===0?H+=" |":H+=`${Ce[ee-1]}|`,H+=ge[ee].slice(0,Ee+1).map(ve=>je(ve.toString(),3)).join("|")+`
`;return H}function J(ge,Ce,Pe,$e){ge=ge.substr(Ce),Pe=Pe.substr($e),console.log(G(L,ge,ge.length,Pe,Pe.length)),console.log(G(M,ge,ge.length,Pe,Pe.length)),console.log(G(R,ge,ge.length,Pe,Pe.length))}function re(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;const Pe=ge.codePointAt(Ce);switch(Pe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(Pe)}}function pe(ge,Ce){if(Ce<0||Ce>=ge.length)return!1;switch(ge.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function Te(ge,Ce,Pe){return Ce[ge]!==Pe[ge]}function xe(ge,Ce,Pe,$e,Ee,je,H=!1){for(;Ce<Pe&&Ee<je;)ge[Ce]===$e[Ee]&&(H&&(te[Ce]=Ee),Ce+=1),Ee+=1;return Ce===Pe}e.isPatternInWord=xe;var Ae;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(Ae||(Ae={}));var We;(function(ge){ge.Default=[-100,0];function Ce(Pe){return!Pe||Pe.length===2&&Pe[0]===-100&&Pe[1]===0}ge.isDefault=Ce})(We=e.FuzzyScore||(e.FuzzyScore={}));function B(ge,Ce,Pe,$e,Ee,je,H){const ee=ge.length>me?me:ge.length,ve=$e.length>me?me:$e.length;if(!(Pe>=ee||je>=ve||ee-Pe>ve-je)&&!!xe(Ce,Pe,ee,Ee,je,ve,!0)){q(ee,ve,Pe,je,Ce,Ee);let Le=1,He=1,Ue=Pe,Xe=je;const W=[!1];for(Le=1,Ue=Pe;Ue<ee;Le++,Ue++){const ae=te[Ue],he=$[Ue],ye=Ue+1<ee?$[Ue+1]:ve;for(He=ae-je+1,Xe=ae;Xe<ye;He++,Xe++){let ze=Number.MIN_SAFE_INTEGER,Be=!1;Xe<=he&&(ze=ne(ge,Ce,Ue,Pe,$e,Ee,Xe,ve,je,R[Le-1][He-1]===0,W));let Ne=0;ze!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ne=ze+L[Le-1][He-1]);const Ge=Xe>ae,nt=Ge?L[Le][He-1]+(R[Le][He-1]>0?-5:0):0,dt=Xe>ae+1&&R[Le][He-1]>0,it=dt?L[Le][He-2]+(R[Le][He-2]>0?-5:0):0;if(dt&&(!Ge||it>=nt)&&(!Be||it>=Ne))L[Le][He]=it,M[Le][He]=3,R[Le][He]=0;else if(Ge&&(!Be||nt>=Ne))L[Le][He]=nt,M[Le][He]=2,R[Le][He]=0;else if(Be)L[Le][He]=Ne,M[Le][He]=1,R[Le][He]=R[Le-1][He-1]+1;else throw new Error("not possible")}}if(U&&J(ge,Pe,$e,je),!(!W[0]&&!H)){Le--,He--;const ie=[L[Le][He],je];let ce=0,V=0;for(;Le>=1;){let ae=He;do{const he=M[Le][ae];if(he===3)ae=ae-2;else if(he===2)ae=ae-1;else break}while(ae>=1);ce>1&&Ce[Pe+Le-1]===Ee[je+He-1]&&!Te(ae+je-1,$e,Ee)&&ce+1>R[Le][ae]&&(ae=He),ae===He?ce++:ce=1,V||(V=ae),Le--,He=ae-1,ie.push(He)}ve===ee&&(ie[0]+=2);const X=V-ee;return ie[0]-=X,ie}}}e.fuzzyScore=B;function q(ge,Ce,Pe,$e,Ee,je){let H=ge-1,ee=Ce-1;for(;H>=Pe&&ee>=$e;)Ee[H]===je[ee]&&($[H]=ee,H--),ee--}function ne(ge,Ce,Pe,$e,Ee,je,H,ee,ve,Le,He){if(Ce[Pe]!==je[H])return Number.MIN_SAFE_INTEGER;let Ue=1,Xe=!1;return H===Pe-$e?Ue=ge[Pe]===Ee[H]?7:5:Te(H,Ee,je)&&(H===0||!Te(H-1,Ee,je))?(Ue=ge[Pe]===Ee[H]?7:5,Xe=!0):re(je,H)&&(H===0||!re(je,H-1))?Ue=5:(re(je,H-1)||pe(je,H-1))&&(Ue=5,Xe=!0),Ue>1&&Pe===$e&&(He[0]=!0),Xe||(Xe=Te(H,Ee,je)||re(je,H-1)||pe(je,H-1)),Pe===$e?H>ve&&(Ue-=Xe?3:5):Le?Ue+=Xe?2:0:Ue+=Xe?0:1,H+1===ee&&(Ue-=Xe?3:5),Ue}function le(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!0,H)}e.fuzzyScoreGracefulAggressive=le;function fe(ge,Ce,Pe,$e,Ee,je,H){return Se(ge,Ce,Pe,$e,Ee,je,!1,H)}e.fuzzyScoreGraceful=fe;function Se(ge,Ce,Pe,$e,Ee,je,H,ee){let ve=B(ge,Ce,Pe,$e,Ee,je,ee);if(ve&&!H)return ve;if(ge.length>=3){const Le=Math.min(7,ge.length-1);for(let He=Pe+1;He<Le;He++){const Ue=Oe(ge,He);if(Ue){const Xe=B(Ue,Ue.toLowerCase(),Pe,$e,Ee,je,ee);Xe&&(Xe[0]-=3,(!ve||Xe[0]>ve[0])&&(ve=Xe))}}}return ve}function Oe(ge,Ce){if(!(Ce+1>=ge.length)){const Pe=ge[Ce],$e=ge[Ce+1];if(Pe!==$e)return ge.slice(0,Ce)+$e+Pe+ge.slice(Ce+2)}}}),define(we[111],_e([0,1,36,110,8]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${w.CSSIcon.iconNameExpression}(?:${w.CSSIcon.iconModifierExpression})?\\)`,"g"),S=new RegExp(`(\\\\)?${T.source}`,"g");function C(o){return o.replace(S,(g,m)=>m?g:`\\${g}`)}e.escapeIcons=C;const D=new RegExp(`\\\\${T.source}`,"g");function k(o){return o.replace(D,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function I(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(i,(g,m,E,f)=>E?g:m||f||"")}e.stripIcons=I;function d(o){const g=o.indexOf(e.iconStartMarker);return g===-1?{text:o}:h(o,g)}e.parseLabelWithIcons=d;function h(o,g){const m=[];let E="";function f(c){if(c){E+=c;for(const p of c)m.push(t)}}let u=-1,b="",t=0,n,l,a=g;const s=o.length;for(f(o.substr(0,g));a<s;)n=o[a],l=o[a+1],n===e.iconStartMarker[0]&&l===e.iconStartMarker[1]?(u=a,f(b),b=e.iconStartMarker,a++):n===")"&&u!==-1?(t+=a-u+1,u=-1,b=""):u!==-1?/^[a-z0-9\-]$/i.test(n)?b+=n:(f(b),u=-1,b=""):f(n),a++;return f(b),{text:E,iconOffsets:m}}function r(o,g,m=!1){const{text:E,iconOffsets:f}=g;if(!f||f.length===0)return(0,P.matchesFuzzy)(o,E,m);const u=(0,A.ltrim)(E," "),b=E.length-u.length,t=(0,P.matchesFuzzy)(o,u,m);if(t)for(const n of t){const l=f[n.start+b]+b;n.start+=l,n.end+=l}return t}e.matchesFuzzyIconAware=r}),define(we[83],_e([0,1,15,111,12]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(o="",g=!1){var m,E;if(this.value=o,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1):(this.isTrusted=(m=g.isTrusted)!==null&&m!==void 0?m:void 0,this.supportThemeIcons=(E=g.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(o,g=0){return this.value+=I(this.supportThemeIcons?(0,P.escapeIcons)(o):o).replace(/([ \t]+)/g,(m,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,g){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}}e.MarkdownString=S;function C(r){return D(r)?!r.value:Array.isArray(r)?r.every(C):!0}e.isEmptyMarkdownString=C;function D(r){return r instanceof S?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function k(r,o){return!r&&!o?!0:!r||!o?!1:Array.isArray(r)&&Array.isArray(o)?(0,w.equals)(r,o,i):D(r)&&D(o)?i(r,o):!1}e.markedStringsEquals=k;function i(r,o){return r===o?!0:!r||!o?!1:r.value===o.value&&r.isTrusted===o.isTrusted&&r.supportThemeIcons===o.supportThemeIcons}function I(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function d(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function h(r){const o=[],g=r.split("|").map(E=>E.trim());r=g[0];const m=g[1];if(m){const E=/height=(\d+)/.exec(m),f=/width=(\d+)/.exec(m),u=E?E[1]:"",b=f?f[1]:"",t=isFinite(parseInt(b)),n=isFinite(parseInt(u));t&&o.push(`width="${b}"`),n&&o.push(`height="${u}"`)}return{href:r,dimensions:o}}e.parseHrefAndDimensions=h}),define(we[57],_e([0,1,24,8,2]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,C)}e.stringify=T;function S(k){let i=JSON.parse(k);return i=D(i),i}e.parse=S;function C(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,P.regExpFlags)(i)}:i}function D(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return A.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof w.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=D(k[I],i+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=D(k[I],i+1))}return k}e.revive=D}),define(we[19],_e([0,1,2,21]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.userData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,k,i){this._hosts[D]=k,this._ports[D]=i}setConnectionToken(D,k){this._connectionTokens[D]=k}rewrite(D){if(this._delegate)return this._delegate(D);const k=D.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[k],d=this._connectionTokens[k];let h=`path=${encodeURIComponent(D.path)}`;return typeof d=="string"&&(h+=`&tkn=${encodeURIComponent(d)}`),w.URI.from({scheme:P.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new T;class S{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,k,i){const I=this.toUri(D,k);return I.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(I):P.isNative&&(i||P.isPreferringBrowserCodeLoad)&&I.scheme===A.file?I.with({scheme:A.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(D,k){const i=this.toUri(D,k);return i.scheme===A.vscodeFileResource?i.with({scheme:A.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(D,k){return w.URI.isUri(D)?D:w.URI.parse(k.toUrl(D))}}e.FileAccess=new S}),define(we[25],_e([0,1,37,13,2,8,19,21]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(h){return(0,A.uriToFsPath)(h,!0)}e.originalFSPath=D;class k{constructor(r){this._ignorePathCasing=r}compare(r,o,g=!1){return r===o?0:(0,T.compare)(this.getComparisonKey(r,g),this.getComparisonKey(o,g))}isEqual(r,o,g=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,g)===this.getComparisonKey(o,g)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,g=!1){if(r.scheme===o.scheme){if(r.scheme===S.Schemas.file)return w.isEqualOrParent(D(r),D(o),this._ignorePathCasing(r))&&r.query===o.query&&(g||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return w.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(g||r.fragment===o.fragment)}return!1}joinPath(r,...o){return A.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return P.posix.basename(r.path)}extname(r){return P.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===S.Schemas.file?o=A.URI.file(P.dirname(D(r))).path:(o=P.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===S.Schemas.file?o=A.URI.file(P.normalize(D(r))).path:o=P.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(!(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))){if(r.scheme===S.Schemas.file){const E=P.relative(D(r),D(o));return C.isWindows?w.toSlashes(E):E}let g=r.path||"/",m=o.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const f=Math.min(g.length,m.length);E<f&&!(g.charCodeAt(E)!==m.charCodeAt(E)&&g.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);g=m.substr(0,E)+g.substr(E)}return P.posix.relative(g,m)}}resolvePath(r,o){if(r.scheme===S.Schemas.file){const g=A.URI.file(P.resolve(D(r),o));return r.with({authority:g.authority,path:g.path})}return o.indexOf("/")===-1&&(o=w.toSlashes(o),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o)),r.with({path:P.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||(0,T.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=P.sep){if(r.scheme===S.Schemas.file){const g=D(r);return g.length>w.getRoot(g).length&&g[g.length-1]===o}else{const g=r.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=P.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=P.sep){let g=!1;if(r.scheme===S.Schemas.file){const m=D(r);g=m!==void 0&&m.length===w.getRoot(m).length&&m[m.length-1]===o}else{o="/";const m=r.path;g=m.length===1&&m.charCodeAt(m.length-1)===47}return!g&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(h=>h.scheme===S.Schemas.file?!C.isLinux:!0),e.extUriIgnorePathCase=new k(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(h,r){const o=[];for(let g=0;g<h.length;g++){const m=r(h[g]);h.some((E,f)=>f===g?!1:(0,e.isEqualOrParent)(m,r(E)))||o.push(h[g])}return o}e.distinctParents=i;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(o){const g=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(f=>{const[u,b]=f.split(":");u&&b&&g.set(u,b)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&g.set(h.META_DATA_MIME,E),g}h.parseMetaData=r})(I=e.DataUri||(e.DataUri={}));function d(h,r,o){if(r){let g=h.path;return g&&g[0]!==P.posix.sep&&(g=P.posix.sep+g),h.with({scheme:o,authority:r,path:g})}return h.with({scheme:o})}e.toLocalResource=d}),define(we[11],_e([0,1,20,12,3,6,45,25]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(L){return!!L&&typeof L.then=="function"}e.isThenable=D;function k(L){const M=new w.CancellationTokenSource,U=L(M.token),G=new Promise((J,re)=>{M.token.onCancellationRequested(()=>{re((0,P.canceled)())}),Promise.resolve(U).then(pe=>{M.dispose(),J(pe)},pe=>{M.dispose(),re(pe)})});return new class{cancel(){M.cancel()}then(J,re){return G.then(J,re)}catch(J){return this.then(void 0,J)}finally(J){return G.finally(J)}}}e.createCancelablePromise=k;function i(L,M,U){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(U)))])}e.raceCancellation=i;async function I(L){let M=-1;const U=L.map((J,re)=>J.then(pe=>(M=re,pe))),G=await Promise.race(U);return L.forEach((J,re)=>{re!==M&&J.cancel()}),G}e.raceCancellablePromises=I;function d(L,M,U){let G;const J=setTimeout(()=>{G==null||G(void 0),U==null||U()},M);return Promise.race([L.finally(()=>clearTimeout(J)),new Promise(re=>G=re)])}e.raceTimeout=d;function h(L){return new Promise((M,U)=>{const G=L();D(G)?G.then(M,U):M(G)})}e.asPromise=h;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(U,U).then(G)})}return new Promise((U,G)=>{this.queuedPromise.then(U,G)})}return this.activePromise=M(),new Promise((U,G)=>{this.activePromise.then(J=>{this.activePromise=null,U(J)},J=>{this.activePromise=null,G(J)})})}}e.Throttler=r;class o{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=o;class g{constructor(){this.promiseMap=new Map}queue(M,U){var G;const re=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(M)===re&&this.promiseMap.delete(M)});return this.promiseMap.set(M,re),re}}e.SequencerByKey=g;class m{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,U=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,J)=>{this.doResolve=G,this.doReject=J}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,P.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=m;class E{constructor(M){this.delayer=new m(M),this.throttler=new r}trigger(M,U){return this.delayer.trigger(()=>this.throttler.queue(M),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class f{constructor(){this._isOpen=!1,this._promise=new Promise((M,U)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=f;class u extends f{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function b(L,M){return M?new Promise((U,G)=>{const J=setTimeout(U,L);M.onCancellationRequested(()=>{clearTimeout(J),G((0,P.canceled)())})}):k(U=>b(L,U))}e.timeout=b;function t(L,M=0){const U=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function l(L){const M=[];let U=0;const G=L.length;function J(){return U<G?L[U++]():null}function re(pe){pe!=null&&M.push(pe);const Te=J();return Te?Te.then(re):Promise.resolve(M)}return Promise.resolve(null).then(re)}e.sequence=l;function a(L,M=G=>!!G,U=null){let G=0;const J=L.length,re=()=>{if(G>=J)return Promise.resolve(U);const pe=L[G++];return Promise.resolve(pe()).then(xe=>M(xe)?Promise.resolve(xe):re())};return re()}e.first=a;function s(L,M=G=>!!G,U=null){if(L.length===0)return Promise.resolve(U);let G=L.length;const J=()=>{var re,pe;G=-1;for(const Te of L)(pe=(re=Te).cancel)===null||pe===void 0||pe.call(re)};return new Promise((re,pe)=>{for(const Te of L)Te.then(xe=>{--G>=0&&M(xe)?(J(),re(xe)):G===0&&re(U)}).catch(xe=>{--G>=0&&(J(),pe(xe))})})}e.firstParallel=s;class c{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((U,G)=>{this.outstandingPromises.push({factory:M,c:U,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const U=M.factory();U.then(M.c,M.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=c;class p extends c{constructor(){super(1)}}e.Queue=p;class y{constructor(){this.queues=new Map}queueFor(M,U=C.extUri){const G=U.getComparisonKey(M);let J=this.queues.get(G);return J||(J=new p,A.Event.once(J.onFinished)(()=>{J==null||J.dispose(),this.queues.delete(G)}),this.queues.set(G,J)),J}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=y;class v{constructor(M,U){this._token=-1,typeof M=="function"&&typeof U=="number"&&this.setIfNotSet(M,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},U)}setIfNotSet(M,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},U))}}e.TimeoutTimer=v;class _{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,U){this.cancel(),this._token=setInterval(()=>{M()},U)}}e.IntervalTimer=_;class F{constructor(M,U){this.timeoutToken=-1,this.runner=M,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class x extends F{constructor(M,U){super(M,U);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=x,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const U=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(U))}}}}else e.runWhenIdle=(L,M)=>{const U=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(U))}}}}();class Y{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Y;async function me(L,M,U){let G;for(let J=0;J<U;J++)try{return await L()}catch(re){G=re,await b(M)}throw G}e.retry=me;class j{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,U,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:U},U.then(()=>this.donePending(M),()=>this.donePending(M)),U}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let U,G;const J=new Promise((re,pe)=>{U=re,G=pe});this._next={run:M,promise:J,promiseResolve:U,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=j;class z{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class te{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,U)=>{this.completeCallback=M,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(U=>{this.completeCallback(M),this.resolved=!0,U()})}error(M){return new Promise(U=>{this.errorCallback(M),this.rejected=!0,U()})}cancel(){new Promise(M=>{this.errorCallback((0,P.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=te;class $ extends A.Emitter{async fireAsync(M,U,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new S.LinkedList);for(const J of this._listeners)this._asyncDeliveryQueue.push([J,M]);for(;this._asyncDeliveryQueue.size>0&&!U.isCancellationRequested;){const[J,re]=this._asyncDeliveryQueue.shift(),pe=[],Te=Object.assign(Object.assign({},re),{waitUntil:xe=>{if(Object.isFrozen(pe))throw new Error("waitUntil can NOT be called asynchronous");G&&(xe=G(xe,typeof J=="function"?J:J[0])),pe.push(xe)}});try{typeof J=="function"?J.call(void 0,Te):J[0].call(J[1],Te)}catch(xe){(0,P.onUnexpectedError)(xe);continue}Object.freeze(pe),await R.settled(pe).catch(xe=>(0,P.onUnexpectedError)(xe))}}}}e.AsyncEmitter=$;var R;(function(L){async function M(re){return typeof Promise.allSettled=="function"?U(re):G(re)}L.allSettled=M;async function U(re){return Promise.allSettled(re)}async function G(re){return Promise.all(re.map(pe=>pe.then(Te=>({status:"fulfilled",value:Te}),Te=>({status:"rejected",reason:Te}))))}async function J(re){let pe;const Te=await Promise.all(re.map(xe=>xe.then(Ae=>Ae,Ae=>{pe||(pe=Ae)})));if(typeof pe!="undefined")throw pe;return Te}L.settled=J})(R=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,13,11]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new P.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new P.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function C(u,b,t=!1){const n=u||"",l=b||"",a=A.value.collator.compare(n,l);return A.value.collatorIsNumeric&&a===0&&n!==l?n<l?-1:1:a}e.compareFileNames=C;function D(u,b){const t=T.value.collator;return u=u||"",b=b||"",o(t,u,b)}e.compareFileNamesDefault=D;function k(u,b,t=!1){t||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase());const[n,l]=h(u),[a,s]=h(b);return n!==a?n<a?-1:1:l===s?0:l<s?-1:1}e.noIntlCompareFileNames=k;function i(u,b){const[t,n]=h(u),[l,a]=h(b);let s=A.value.collator.compare(n,a);if(s===0){if(A.value.collatorIsNumeric&&n!==a)return n<a?-1:1;if(s=A.value.collator.compare(t,l),A.value.collatorIsNumeric&&s===0&&t!==l)return t<l?-1:1}return s}e.compareFileExtensions=i;function I(u,b){u=u||"",b=b||"";const t=r(u),n=r(b),l=T.value.collator,a=S.value.collator;let s;return s=o(a,t,n),s!==0?s:o(l,u,b)}e.compareFileExtensionsDefault=I;const d=/^(.*?)(\.([^.]*))?$/;function h(u,b=!1){const t=u?d.exec(u):[];let n=[t&&t[1]||"",t&&t[3]||""];return b&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function r(u){const b=u?d.exec(u):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function o(u,b,t){let n=u.compare(b,t);return n!==0?n:b.length!==t.length?b.length<t.length?-1:1:0}function g(u,b,t=!1){return t||(u=u&&u.toLowerCase(),b=b&&b.toLowerCase()),u===b?0:u<b?-1:1}function m(u,b,t=!1){const n=u.split(w.sep),l=b.split(w.sep),a=n.length-1,s=l.length-1;let c,p;for(let y=0;;y++){if(c=a===y,p=s===y,c&&p)return C(n[y],l[y],t);if(c)return-1;if(p)return 1;const v=g(n[y],l[y],t);if(v!==0)return v}}e.comparePaths=m;function E(u,b,t){const n=u.toLowerCase(),l=b.toLowerCase(),a=f(u,b,t);if(a)return a;const s=n.endsWith(t),c=l.endsWith(t);if(s!==c)return s?-1:1;const p=C(n,l);return p!==0?p:n.localeCompare(l)}e.compareAnything=E;function f(u,b,t){const n=u.toLowerCase(),l=b.toLowerCase(),a=n.startsWith(t),s=l.startsWith(t);if(a!==s)return a?-1:1;if(a&&s){if(n.length<l.length)return-1;if(n.length>l.length)return 1}return 0}e.compareByPrefix=f}),define(we[28],_e([0,1,8,37,13,22,11]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function C(){return Object.create(null)}e.getEmptyExpression=C;const D="**",k="/",i="[/\\\\]",I="[^/\\\\]",d=/\//g;function h(U){switch(U){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function r(U,G){if(!U)return[];const J=[];let re=!1,pe=!1,Te="";for(const xe of U){switch(xe){case G:if(!re&&!pe){J.push(Te),Te="";continue}break;case"{":re=!0;break;case"}":re=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}Te+=xe}return Te&&J.push(Te),J}e.splitGlobAware=r;function o(U){if(!U)return"";let G="";const J=r(U,k);if(J.every(re=>re===D))G=".*";else{let re=!1;J.forEach((pe,Te)=>{if(pe===D){re||(G+=h(2),re=!0);return}let xe=!1,Ae="",We=!1,B="";for(const q of pe){if(q!=="}"&&xe){Ae+=q;continue}if(We&&(q!=="]"||!B)){let ne;q==="-"?ne=q:(q==="^"||q==="!")&&!B?ne="^":q===k?ne="":ne=w.escapeRegExpCharacters(q),B+=ne;continue}switch(q){case"{":xe=!0;continue;case"[":We=!0;continue;case"}":G+=`(?:${r(Ae,",").map(fe=>o(fe)).join("|")})`,xe=!1,Ae="";break;case"]":G+="["+B+"]",We=!1,B="";break;case"?":G+=I;continue;case"*":G+=h(1);continue;default:G+=w.escapeRegExpCharacters(q)}}Te<J.length-1&&(J[Te+1]!==D||Te+2<J.length)&&(G+=i),re=!1})}return G}const g=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,u=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},l=function(){return null};function a(U,G){if(!U)return l;let J;typeof U!="string"?J=U.pattern:J=U,J=J.trim();const re=`${J}_${!!G.trimForExclusions}`;let pe=t.get(re);if(pe)return s(pe,U);let Te;if(g.test(J)){const xe=J.substr(4);pe=function(Ae,We){return typeof Ae=="string"&&Ae.endsWith(xe)?J:null}}else(Te=m.exec(c(J,G)))?pe=p(Te[1],J):(G.trimForExclusions?f:E).test(J)?pe=y(J,G):(Te=u.exec(c(J,G)))?pe=v(Te[1].substr(1),J,!0):(Te=b.exec(c(J,G)))?pe=v(Te[1],J,!1):pe=_(J);return t.set(re,pe),s(pe,U)}function s(U,G){return typeof G=="string"?U:function(J,re){return P.isEqualOrParent(J,G.base)?U(A.relative(G.base,J),re):null}}function c(U,G){return G.trimForExclusions&&U.endsWith("/**")?U.substr(0,U.length-2):U}function p(U,G){const J=`/${U}`,re=`\\${U}`,pe=function(xe,Ae){return typeof xe!="string"?null:Ae?Ae===U?G:null:xe===U||xe.endsWith(J)||xe.endsWith(re)?G:null},Te=[U];return pe.basenames=Te,pe.patterns=[G],pe.allBasenames=Te,pe}function y(U,G){const J=M(U.slice(1,-1).split(",").map(Ae=>a(Ae,G)).filter(Ae=>Ae!==l),U),re=J.length;if(!re)return l;if(re===1)return J[0];const pe=function(Ae,We){for(let B=0,q=J.length;B<q;B++)if(J[B](Ae,We))return U;return null},Te=J.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=J.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function v(U,G,J){const re=A.sep===A.posix.sep,pe=re?U:U.replace(d,A.sep),Te=A.sep+pe,xe=A.posix.sep+U,Ae=J?function(We,B){return typeof We=="string"&&(We===pe||We.endsWith(Te)||!re&&(We===U||We.endsWith(xe)))?G:null}:function(We,B){return typeof We=="string"&&(We===pe||!re&&We===U)?G:null};return Ae.allPaths=[(J?"*/":"./")+U],Ae}function _(U){try{const G=new RegExp(`^${o(U)}$`);return function(J){return G.lastIndex=0,typeof J=="string"&&G.test(J)?U:null}}catch(G){return l}}function F(U,G,J){return!U||typeof G!="string"?!1:x(U)(G,void 0,J)}e.match=F;function x(U,G={}){if(!U)return n;if(typeof U=="string"||z(U)){const J=a(U,G);if(J===l)return n;const re=function(pe,Te){return!!J(pe,Te)};return J.allBasenames&&(re.allBasenames=J.allBasenames),J.allPaths&&(re.allPaths=J.allPaths),re}return R(U,G)}e.parse=x;function Y(U){if(!!U){let G;return J=>(G||(G=(U()||Promise.resolve([])).then(re=>re?j(re):{})),G.then(re=>!!re[J]))}}e.hasSiblingPromiseFn=Y;function me(U){if(!!U){let G;return J=>{if(!G){const re=U();G=re?j(re):{}}return!!G[J]}}}e.hasSiblingFn=me;function j(U){const G={};for(const J of U)G[J]=!0;return G}function z(U){const G=U;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=z;function te(U){return U.allBasenames||[]}e.getBasenameTerms=te;function $(U){return U.allPaths||[]}e.getPathTerms=$;function R(U,G){const J=M(Object.getOwnPropertyNames(U).map(Ae=>L(Ae,U[Ae],G)).filter(Ae=>Ae!==l)),re=J.length;if(!re)return l;if(!J.some(Ae=>!!Ae.requiresSiblings)){if(re===1)return J[0];const Ae=function(q,ne){for(let le=0,fe=J.length;le<fe;le++){const Se=J[le](q,ne);if(Se)return Se}return null},We=J.find(q=>!!q.allBasenames);We&&(Ae.allBasenames=We.allBasenames);const B=J.reduce((q,ne)=>ne.allPaths?q.concat(ne.allPaths):q,[]);return B.length&&(Ae.allPaths=B),Ae}const pe=function(Ae,We,B){let q;for(let ne=0,le=J.length;ne<le;ne++){const fe=J[ne];fe.requiresSiblings&&B&&(We||(We=A.basename(Ae)),q||(q=We.substr(0,We.length-A.extname(Ae).length)));const Se=fe(Ae,We,q,B);if(Se)return Se}return null},Te=J.find(Ae=>!!Ae.allBasenames);Te&&(pe.allBasenames=Te.allBasenames);const xe=J.reduce((Ae,We)=>We.allPaths?Ae.concat(We.allPaths):Ae,[]);return xe.length&&(pe.allPaths=xe),pe}function L(U,G,J){if(G===!1)return l;const re=a(U,J);if(re===l)return l;if(typeof G=="boolean")return re;if(G){const pe=G.when;if(typeof pe=="string"){const Te=(xe,Ae,We,B)=>{if(!B||!re(xe,Ae))return null;const q=pe.replace("$(basename)",We),ne=B(q);return(0,S.isThenable)(ne)?ne.then(le=>le?U:null):ne?U:null};return Te.requiresSiblings=!0,Te}}return re}function M(U,G){const J=U.filter(Ae=>!!Ae.basenames);if(J.length<2)return U;const re=J.reduce((Ae,We)=>{const B=We.basenames;return B?Ae.concat(B):Ae},[]);let pe;if(G){pe=[];for(let Ae=0,We=re.length;Ae<We;Ae++)pe.push(G)}else pe=J.reduce((Ae,We)=>{const B=We.patterns;return B?Ae.concat(B):Ae},[]);const Te=function(Ae,We){if(typeof Ae!="string")return null;if(!We){let q;for(q=Ae.length;q>0;q--){const ne=Ae.charCodeAt(q-1);if(ne===47||ne===92)break}We=Ae.substr(q)}const B=re.indexOf(We);return B!==-1?pe[B]:null};Te.basenames=re,Te.patterns=pe,Te.allBasenames=re;const xe=U.filter(Ae=>!Ae.basenames);return xe.push(Te),xe}}),define(we[58],_e([0,1,2,13,8,19,21,25,37]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(a,s,c){if(typeof a=="string"&&(a=w.URI.file(a)),c){const y=c.getWorkspaceFolder(a);if(y){const v=c.getWorkspace().folders.length>1;let _;if((0,C.isEqual)(y.uri,a)?_="":_=(0,C.relativePath)(y.uri,a),v){const F=y.name?y.name:(0,C.basename)(y.uri);_=_?F+" \u2022 "+_:F}return _}}if(a.scheme!==T.Schemas.file&&a.scheme!==T.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(a.fsPath))return(0,P.normalize)(I(a.fsPath));let p=(0,P.normalize)(a.fsPath);return!S.isWindows&&(s==null?void 0:s.userHome)&&(p=h(p,s.userHome.fsPath)),p}e.getPathLabel=k;function i(a){if(!!a){typeof a=="string"&&(a=w.URI.file(a));const s=(0,C.basename)(a)||(a.scheme===T.Schemas.file?a.fsPath:a.path);return S.isWindows&&(0,D.isRootOrDriveLetter)(s)?I(s):s}}e.getBaseLabel=i;function I(a){return(0,D.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=I;let d=Object.create(null);function h(a,s){if(S.isWindows||!a||!s)return a;let c=d.original===s?d.normalized:void 0;return c||(c=`${(0,A.rtrim)(s,P.posix.sep)}${P.posix.sep}`,d={original:s,normalized:c}),(S.isLinux?a.startsWith(c):(0,A.startsWithIgnoreCase)(a,c))&&(a=`~/${a.substr(c.length)}`),a}e.tildify=h;function r(a,s){return a.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=r;const o="\u2026",g="\\\\",m="~";function E(a,s=P.sep){const c=new Array(a.length);let p=!1;for(let y=0;y<a.length;y++){let v=a[y];if(v===""){c[y]=`.${s}`;continue}if(!v){c[y]=v;continue}p=!0;let _="";v.indexOf(g)===0?(_=v.substr(0,v.indexOf(g)+g.length),v=v.substr(v.indexOf(g)+g.length)):v.indexOf(s)===0?(_=v.substr(0,v.indexOf(s)+s.length),v=v.substr(v.indexOf(s)+s.length)):v.indexOf(m)===0&&(_=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length));const F=v.split(s);for(let x=1;p&&x<=F.length;x++)for(let Y=F.length-x;p&&Y>=0;Y--){p=!1;let me=F.slice(Y,Y+x).join(s);for(let j=0;!p&&j<a.length;j++)if(j!==y&&a[j]&&a[j].indexOf(me)>-1){const z=Y+x===F.length,te=Y>0&&a[j].indexOf(s)>-1?s+me:me,$=a[j].endsWith(te);p=!z||$}if(!p){let j="";(F[0].endsWith(":")||_!=="")&&(Y===1&&(Y=0,x++,me=F[0]+s+me),Y>0&&(j=F[0]+s),j=_+j),Y>0&&(j=j+o+s),j=j+me,Y+x<F.length&&(j=j+s+o),c[y]=j}}p&&(c[y]=v)}return c}e.shorten=E;var f;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function u(a,s=Object.create(null)){const c=[];let p=!1,y="";for(const v of a)if(v==="$"||p&&v==="{")y&&c.push({value:y,type:f.TEXT}),y="",p=!0;else if(v==="}"&&p){const _=s[y];if(typeof _=="string")_.length&&c.push({value:_,type:f.VARIABLE});else if(_){const F=c[c.length-1];(!F||F.type!==f.SEPARATOR)&&c.push({value:_.label,type:f.SEPARATOR})}y="",p=!1}else y+=v;return y&&!p&&c.push({value:y,type:f.TEXT}),c.filter((v,_)=>{if(v.type===f.SEPARATOR){const F=c[_-1],x=c[_+1];return[F,x].every(Y=>Y&&(Y.type===f.VARIABLE||Y.type===f.TEXT)&&Y.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=u;function b(a,s){return S.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,S.isMacintosh?"&":"&&"):a.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=b;function t(a,s){return S.isMacintosh||s?a.replace(/\(&&\w\)|&&/g,""):S.isWindows?a.replace(/&&|&/g,c=>c==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=n;function l(a){const s=a.indexOf("/")!==-1?P.posix:P.win32,c=s.basename(a),p=s.dirname(a);return c.length?{name:c,parentPath:p}:{name:p,parentPath:""}}e.splitName=l}),define(we[113],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(i){return i.toJSON()}class A{constructor(I){this._uriTransformer=I}transformIncoming(I){const d=this._uriTransformer.transformIncoming(I);return d===I?I:P(w.URI.from(d))}transformOutgoing(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:P(w.URI.from(d))}transformOutgoingURI(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:w.URI.from(d)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,I,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof w.URI)return I.transformOutgoing(i);for(let h in i)if(Object.hasOwnProperty.call(i,h)){const r=T(i[h],I,d+1);r!==null&&(i[h]=r)}}return null}function S(i,I){const d=T(i,I,0);return d===null?i:d}e.transformOutgoingURIs=S;function C(i,I,d,h){if(!i||h>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?w.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const o=C(i[r],I,d,h+1);o!==null&&(i[r]=o)}}return null}function D(i,I){const d=C(i,I,!1,0);return d===null?i:d}e.transformIncomingURIs=D;function k(i,I){const d=C(i,I,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=k}),define(we[31],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(D){return w.test(D)}e.isUUID=P;const A=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(D){for(let k=0;k<D.length;k++)D[k]=Math.floor(Math.random()*256);return D};function C(){S(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,k="";return k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+="-",k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k+=T[A[D++]],k}e.generateUuid=C}),define(we[84],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class P{constructor(C){let D=(0,w.toUint8)(C);this._defaultValue=D,this._asciiMap=P._createAsciiMap(D),this._map=new Map}static _createAsciiMap(C){let D=new Uint8Array(256);for(let k=0;k<256;k++)D[k]=C;return D}set(C,D){let k=(0,w.toUint8)(D);C>=0&&C<256?this._asciiMap[C]=k:this._map.set(C,k)}get(C){return C>=0&&C<256?this._asciiMap[C]:this._map.get(C)||this._defaultValue}}e.CharacterClassifier=P;var A;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new P(0)}add(C){this._actual.set(C,1)}has(C){return this._actual.get(C)===1}}e.CharacterSet=T}),define(we[114],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var P;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(P=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends w.CharacterClassifier{constructor(C){super(0);for(let D=0,k=C.length;D<k;D++)this.set(C.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(S){let C={};return D=>(C.hasOwnProperty(D)||(C[D]=S(D)),C[D])}e.getMapForWordSeparators=T(S=>new A(S))}),define(we[38],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class w{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new w(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return w.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return w.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return w.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let S=A.lineNumber|0,C=T.lineNumber|0;if(S===C){let D=A.column|0,k=T.column|0;return D-k}return S-C}clone(){return new w(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new w(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=w}),define(we[32],_e([0,1,38]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(T,S,C,D){T>C||T===C&&S>D?(this.startLineNumber=C,this.startColumn=D,this.endLineNumber=T,this.endColumn=S):(this.startLineNumber=T,this.startColumn=S,this.endLineNumber=C,this.endColumn=D)}isEmpty(){return P.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return P.containsPosition(this,T)}static containsPosition(T,S){return!(S.lineNumber<T.startLineNumber||S.lineNumber>T.endLineNumber||S.lineNumber===T.startLineNumber&&S.column<T.startColumn||S.lineNumber===T.endLineNumber&&S.column>T.endColumn)}containsRange(T){return P.containsRange(this,T)}static containsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>T.endColumn)}strictContainsRange(T){return P.strictContainsRange(this,T)}static strictContainsRange(T,S){return!(S.startLineNumber<T.startLineNumber||S.endLineNumber<T.startLineNumber||S.startLineNumber>T.endLineNumber||S.endLineNumber>T.endLineNumber||S.startLineNumber===T.startLineNumber&&S.startColumn<=T.startColumn||S.endLineNumber===T.endLineNumber&&S.endColumn>=T.endColumn)}plusRange(T){return P.plusRange(this,T)}static plusRange(T,S){let C,D,k,i;return S.startLineNumber<T.startLineNumber?(C=S.startLineNumber,D=S.startColumn):S.startLineNumber===T.startLineNumber?(C=S.startLineNumber,D=Math.min(S.startColumn,T.startColumn)):(C=T.startLineNumber,D=T.startColumn),S.endLineNumber>T.endLineNumber?(k=S.endLineNumber,i=S.endColumn):S.endLineNumber===T.endLineNumber?(k=S.endLineNumber,i=Math.max(S.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new P(C,D,k,i)}intersectRanges(T){return P.intersectRanges(this,T)}static intersectRanges(T,S){let C=T.startLineNumber,D=T.startColumn,k=T.endLineNumber,i=T.endColumn,I=S.startLineNumber,d=S.startColumn,h=S.endLineNumber,r=S.endColumn;return C<I?(C=I,D=d):C===I&&(D=Math.max(D,d)),k>h?(k=h,i=r):k===h&&(i=Math.min(i,r)),C>k||C===k&&D>i?null:new P(C,D,k,i)}equalsRange(T){return P.equalsRange(this,T)}static equalsRange(T,S){return!!T&&!!S&&T.startLineNumber===S.startLineNumber&&T.startColumn===S.startColumn&&T.endLineNumber===S.endLineNumber&&T.endColumn===S.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(T){return new w.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(T){return new w.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,S){return new P(this.startLineNumber,this.startColumn,T,S)}setStartPosition(T,S){return new P(T,S,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(T){return new P(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,S=T){return new P(T.lineNumber,T.column,S.lineNumber,S.column)}static lift(T){return T?new P(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<T.startColumn)}static areIntersecting(T,S){return!(T.endLineNumber<S.startLineNumber||T.endLineNumber===S.startLineNumber&&T.endColumn<=S.startColumn||S.endLineNumber<T.startLineNumber||S.endLineNumber===T.startLineNumber&&S.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,S){if(T&&S){const k=T.startLineNumber|0,i=S.startLineNumber|0;if(k===i){const I=T.startColumn|0,d=S.startColumn|0;if(I===d){const h=T.endLineNumber|0,r=S.endLineNumber|0;if(h===r){const o=T.endColumn|0,g=S.endColumn|0;return o-g}return h-r}return I-d}return k-i}return(T?1:0)-(S?1:0)}static compareRangesUsingEnds(T,S){return T.endLineNumber===S.endLineNumber?T.endColumn===S.endColumn?T.startLineNumber===S.startLineNumber?T.startColumn-S.startColumn:T.startLineNumber-S.startLineNumber:T.endColumn-S.endColumn:T.endLineNumber-S.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=P}),define(we[115],_e([0,1,38,32]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends P.Range{constructor(C,D,k,i){super(C,D,k,i);this.selectionStartLineNumber=C,this.selectionStartColumn=D,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(C){return T.selectionsEqual(this,C)}static selectionsEqual(C,D){return C.selectionStartLineNumber===D.selectionStartLineNumber&&C.selectionStartColumn===D.selectionStartColumn&&C.positionLineNumber===D.positionLineNumber&&C.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(C,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,C,D):new T(C,D,this.startLineNumber,this.startColumn)}getPosition(){return new w.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(C,D){return this.getDirection()===0?new T(C,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,C,D)}static fromPositions(C,D=C){return new T(C.lineNumber,C.column,D.lineNumber,D.column)}static liftSelection(C){return new T(C.selectionStartLineNumber,C.selectionStartColumn,C.positionLineNumber,C.positionColumn)}static selectionsArrEqual(C,D){if(C&&!D||!C&&D)return!1;if(!C&&!D)return!0;if(C.length!==D.length)return!1;for(let k=0,i=C.length;k<i;k++)if(!this.selectionsEqual(C[k],D[k]))return!1;return!0}static isISelection(C){return C&&typeof C.selectionStartLineNumber=="number"&&typeof C.selectionStartColumn=="number"&&typeof C.positionLineNumber=="number"&&typeof C.positionColumn=="number"}static createWithDirection(C,D,k,i,I){return I===0?new T(C,D,k,i):new T(k,i,C,D)}}e.Selection=T}),define(we[85],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var w;(function(h){h[h.Left=1]="Left",h[h.Center=2]="Center",h[h.Right=4]="Right",h[h.Full=7]="Full"})(w=e.OverviewRulerLane||(e.OverviewRulerLane={}));var P;(function(h){h[h.Inline=1]="Inline",h[h.Gutter=2]="Gutter"})(P=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(h){h[h.TextDefined=0]="TextDefined",h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(h){h[h.LF=1]="LF",h[h.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var S;(function(h){h[h.LF=0]="LF",h[h.CRLF=1]="CRLF"})(S=e.EndOfLineSequence||(e.EndOfLineSequence={}));class C{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=C;class D{constructor(r,o){this.range=r,this.matches=o}}e.FindMatch=D;var k;(function(h){h[h.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",h[h.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",h[h.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",h[h.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(h){h[h.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class I{constructor(r,o,g,m,E,f){this.identifier=r,this.range=o,this.text=g,this.forceMoveMarkers=m,this.isAutoWhitespaceEdit=E,this._isTracked=f}}e.ValidAnnotatedEditOperation=I;class d{constructor(r,o,g){this.reverseEdits=r,this.changes=o,this.trimAutoWhitespaceLineNumbers=g}}e.ApplyEditsResult=d}),define(we[116],_e([0,1,8,114,38,32,85]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const C=999;class D{constructor(f,u,b,t){this.searchString=f,this.isRegex=u,this.matchCase=b,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let f;this.isRegex?f=k(this.searchString):f=this.searchString.indexOf(`
`)>=0;let u=null;try{u=w.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:f,global:!0,unicode:!0})}catch(t){return null}if(!u)return null;let b=!this.isRegex&&!f;return b&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(b=this.matchCase),new i(u,this.wordSeparators?(0,P.getMapForWordSeparators)(this.wordSeparators):null,b?this.searchString:null)}}e.SearchParams=D;function k(E){if(!E||E.length===0)return!1;for(let f=0,u=E.length;f<u;f++)if(E.charCodeAt(f)===92){if(f++,f>=u)break;const t=E.charCodeAt(f);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(f,u,b){this.regex=f,this.wordSeparators=u,this.simpleSearch=b}}e.SearchData=i;function I(E,f,u){if(!u)return new S.FindMatch(E,null);let b=[];for(let t=0,n=f.length;t<n;t++)b[t]=f[t];return new S.FindMatch(E,b)}e.createFindMatch=I;class d{constructor(f){let u=[],b=0;for(let t=0,n=f.length;t<n;t++)f.charCodeAt(t)===10&&(u[b++]=t);this._lineFeedsOffsets=u}findLineFeedCountBeforeOffset(f){const u=this._lineFeedsOffsets;let b=0,t=u.length-1;if(t===-1||f<=u[0])return 0;for(;b<t;){const n=b+((t-b)/2>>0);u[n]>=f?t=n-1:u[n+1]>=f?(b=n,t=n):b=n+1}return b+1}}class h{static findMatches(f,u,b,t,n){const l=u.parseSearchRequest();return l?l.regex.multiline?this._doFindMatchesMultiline(f,b,new m(l.wordSeparators,l.regex),t,n):this._doFindMatchesLineByLine(f,b,l,t,n):[]}static _getMultilineMatchRange(f,u,b,t,n,l){let a,s=0;t?(s=t.findLineFeedCountBeforeOffset(n),a=u+n+s):a=u+n;let c;if(t){let _=t.findLineFeedCountBeforeOffset(n+l.length)-s;c=a+l.length+_}else c=a+l.length;const p=f.getPositionAt(a),y=f.getPositionAt(c);return new T.Range(p.lineNumber,p.column,y.lineNumber,y.column)}static _doFindMatchesMultiline(f,u,b,t,n){const l=f.getOffsetAt(u.getStartPosition()),a=f.getValueInRange(u,1),s=f.getEOL()===`\r
`?new d(a):null,c=[];let p=0,y;for(b.reset(0);y=b.next(a);)if(c[p++]=I(this._getMultilineMatchRange(f,l,a,s,y.index,y[0]),y,t),p>=n)return c;return c}static _doFindMatchesLineByLine(f,u,b,t,n){const l=[];let a=0;if(u.startLineNumber===u.endLineNumber){const c=f.getLineContent(u.startLineNumber).substring(u.startColumn-1,u.endColumn-1);return a=this._findMatchesInLine(b,c,u.startLineNumber,u.startColumn-1,a,l,t,n),l}const s=f.getLineContent(u.startLineNumber).substring(u.startColumn-1);a=this._findMatchesInLine(b,s,u.startLineNumber,u.startColumn-1,a,l,t,n);for(let c=u.startLineNumber+1;c<u.endLineNumber&&a<n;c++)a=this._findMatchesInLine(b,f.getLineContent(c),c,0,a,l,t,n);if(a<n){const c=f.getLineContent(u.endLineNumber).substring(0,u.endColumn-1);a=this._findMatchesInLine(b,c,u.endLineNumber,0,a,l,t,n)}return l}static _findMatchesInLine(f,u,b,t,n,l,a,s){const c=f.wordSeparators;if(!a&&f.simpleSearch){const v=f.simpleSearch,_=v.length,F=u.length;let x=-_;for(;(x=u.indexOf(v,x+_))!==-1;)if((!c||g(c,u,F,x,_))&&(l[n++]=new S.FindMatch(new T.Range(b,x+1+t,b,x+1+_+t),null),n>=s))return n;return n}const p=new m(f.wordSeparators,f.regex);let y;p.reset(0);do if(y=p.next(u),y&&(l[n++]=I(new T.Range(b,y.index+1+t,b,y.index+1+y[0].length+t),y,a),n>=s))return n;while(y);return n}static findNextMatch(f,u,b,t){const n=u.parseSearchRequest();if(!n)return null;const l=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(f,b,l,t):this._doFindNextMatchLineByLine(f,b,l,t)}static _doFindNextMatchMultiline(f,u,b,t){const n=new A.Position(u.lineNumber,1),l=f.getOffsetAt(n),a=f.getLineCount(),s=f.getValueInRange(new T.Range(n.lineNumber,n.column,a,f.getLineMaxColumn(a)),1),c=f.getEOL()===`\r
`?new d(s):null;b.reset(u.column-1);let p=b.next(s);return p?I(this._getMultilineMatchRange(f,l,s,c,p.index,p[0]),p,t):u.lineNumber!==1||u.column!==1?this._doFindNextMatchMultiline(f,new A.Position(1,1),b,t):null}static _doFindNextMatchLineByLine(f,u,b,t){const n=f.getLineCount(),l=u.lineNumber,a=f.getLineContent(l),s=this._findFirstMatchInLine(b,a,l,u.column,t);if(s)return s;for(let c=1;c<=n;c++){const p=(l+c-1)%n,y=f.getLineContent(p+1),v=this._findFirstMatchInLine(b,y,p+1,1,t);if(v)return v}return null}static _findFirstMatchInLine(f,u,b,t,n){f.reset(t-1);const l=f.next(u);return l?I(new T.Range(b,l.index+1,b,l.index+1+l[0].length),l,n):null}static findPreviousMatch(f,u,b,t){const n=u.parseSearchRequest();if(!n)return null;const l=new m(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(f,b,l,t):this._doFindPreviousMatchLineByLine(f,b,l,t)}static _doFindPreviousMatchMultiline(f,u,b,t){const n=this._doFindMatchesMultiline(f,new T.Range(1,1,u.lineNumber,u.column),b,t,10*C);if(n.length>0)return n[n.length-1];const l=f.getLineCount();return u.lineNumber!==l||u.column!==f.getLineMaxColumn(l)?this._doFindPreviousMatchMultiline(f,new A.Position(l,f.getLineMaxColumn(l)),b,t):null}static _doFindPreviousMatchLineByLine(f,u,b,t){const n=f.getLineCount(),l=u.lineNumber,a=f.getLineContent(l).substring(0,u.column-1),s=this._findLastMatchInLine(b,a,l,t);if(s)return s;for(let c=1;c<=n;c++){const p=(n+l-c-1)%n,y=f.getLineContent(p+1),v=this._findLastMatchInLine(b,y,p+1,t);if(v)return v}return null}static _findLastMatchInLine(f,u,b,t){let n=null,l;for(f.reset(0);l=f.next(u);)n=I(new T.Range(b,l.index+1,b,l.index+1+l[0].length),l,t);return n}}e.TextModelSearch=h;function r(E,f,u,b,t){if(b===0)return!0;const n=f.charCodeAt(b-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=f.charCodeAt(b);if(E.get(l)!==0)return!0}return!1}function o(E,f,u,b,t){if(b+t===u)return!0;const n=f.charCodeAt(b+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const l=f.charCodeAt(b+t-1);if(E.get(l)!==0)return!0}return!1}function g(E,f,u,b,t){return r(E,f,u,b,t)&&o(E,f,u,b,t)}e.isValidMatch=g;class m{constructor(f,u){this._wordSeparators=f,this._searchRegex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(f){this._searchRegex.lastIndex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(f){const u=f.length;let b;do{if(this._prevMatchStartIndex+this._prevMatchLength===u||(b=this._searchRegex.exec(f),!b))return null;const t=b.index,n=b[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){w.getNextCodePoint(f,u,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||g(this._wordSeparators,f,u,t,n))return b}while(b);return null}}e.Searcher=m}),define(we[86],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function w(C=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)C.indexOf(k)>=0||(D+="\\"+k);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=w();function P(C){let D=e.DEFAULT_WORD_REGEXP;if(C&&C instanceof RegExp)if(C.global)D=C;else{let k="g";C.ignoreCase&&(k+="i"),C.multiline&&(k+="m"),C.unicode&&(k+="u"),D=new RegExp(C.source,k)}return D.lastIndex=0,D}e.ensureValidWordDefinition=P;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(C,D,k,i,I=A){if(k.length>I.maxLen){let g=C-I.maxLen/2;return g<0?g=0:i+=g,k=k.substring(g,C+I.maxLen/2),T(C,D,k,i,I)}const d=Date.now(),h=C-1-i;let r=-1,o=null;for(let g=1;!(Date.now()-d>=I.timeBudget);g++){const m=h-I.windowSize*g;D.lastIndex=Math.max(0,m);const E=S(D,k,h,r);if(!E&&o||(o=E,m<=0))break;r=m}if(o){let g={word:o[0],startColumn:i+1+o.index,endColumn:i+1+o.index+o[0].length};return D.lastIndex=0,g}return null}e.getWordAtText=T;function S(C,D,k,i){let I;for(;I=C.exec(D);){const d=I.index||0;if(d<=k&&C.lastIndex>=k)return I;if(i>0&&d>i)return null}return null}}),define(we[117],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var w;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(w=e.IndentAction||(e.IndentAction={}));class P{constructor(C){if(this.open=C.open,this.close=C.close,this._standardTokenMask=0,Array.isArray(C.notIn))for(let D=0,k=C.notIn.length;D<k;D++)switch(C.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(C){return(this._standardTokenMask&C)==0}}e.StandardAutoClosingPairConditional=P;class A{constructor(C){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of C)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function T(S,C,D){S.has(C)?S.get(C).push(D):S.set(C,[D])}}),define(we[59],_e([0,1,28,13]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,S,C,D){if(Array.isArray(T)){let k=0;for(const i of T){const I=A(i,S,C,D);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof T=="string")return D?T==="*"?5:T===C?10:0:0;if(T){const{language:k,pattern:i,scheme:I,hasAccessToAllModels:d}=T;if(!D&&!d)return 0;let h=0;if(I)if(I===S.scheme)h=10;else if(I==="*")h=5;else return 0;if(k)if(k===C)h=10;else if(k==="*")h=Math.max(h,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,P.normalize)(i.base)}),r===S.fsPath||(0,w.match)(r,S.fsPath))h=10;else return 0}return h}else return 0}}e.score=A}),define(we[118],_e([0,1,84]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var P;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(P=e.State||(e.State={}));class A{constructor(r,o,g){const m=new Uint8Array(r*o);for(let E=0,f=r*o;E<f;E++)m[E]=g;this._data=m,this.rows=r,this.cols=o}get(r,o){return this._data[r*this.cols+o]}set(r,o,g){this._data[r*this.cols+o]=g}}e.Uint8Matrix=A;class T{constructor(r){let o=0,g=0;for(let E=0,f=r.length;E<f;E++){let[u,b,t]=r[E];b>o&&(o=b),u>g&&(g=u),t>g&&(g=t)}o++,g++;let m=new A(g,o,0);for(let E=0,f=r.length;E<f;E++){let[u,b,t]=r[E];m.set(u,b,t)}this._states=m,this._maxCharCode=o}nextState(r,o){return o<0||o>=this._maxCharCode?0:this._states.get(r,o)}}e.StateMachine=T;let S=null;function C(){return S===null&&(S=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var D;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let k=null;function i(){if(k===null){k=new w.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<h.length;o++)k.set(h.charCodeAt(o),1);const r=".,;";for(let o=0;o<r.length;o++)k.set(r.charCodeAt(o),2)}return k}class I{static _createLink(r,o,g,m,E){let f=E-1;do{const u=o.charCodeAt(f);if(r.get(u)!==2)break;f--}while(f>m);if(m>0){const u=o.charCodeAt(m-1),b=o.charCodeAt(f);(u===40&&b===41||u===91&&b===93||u===123&&b===125)&&f--}return{range:{startLineNumber:g,startColumn:m+1,endLineNumber:g,endColumn:f+2},url:o.substring(m,f+1)}}static computeLinks(r,o=C()){const g=i();let m=[];for(let E=1,f=r.getLineCount();E<=f;E++){const u=r.getLineContent(E),b=u.length;let t=0,n=0,l=0,a=1,s=!1,c=!1,p=!1,y=!1;for(;t<b;){let v=!1;const _=u.charCodeAt(t);if(a===13){let F;switch(_){case 40:s=!0,F=0;break;case 41:F=s?0:1;break;case 91:p=!0,c=!0,F=0;break;case 93:p=!1,F=c?0:1;break;case 123:y=!0,F=0;break;case 125:F=y?0:1;break;case 39:F=l===34||l===96?0:1;break;case 34:F=l===39||l===96?0:1;break;case 96:F=l===39||l===34?0:1;break;case 42:F=l===42?1:0;break;case 124:F=l===124?1:0;break;case 32:F=p?0:1;break;default:F=g.get(_)}F===1&&(m.push(I._createLink(g,u,E,n,t)),v=!0)}else if(a===12){let F;_===91?(c=!0,F=0):F=g.get(_),F===1?v=!0:a=13}else a=o.nextState(a,_),a===0&&(v=!0);v&&(a=1,s=!1,c=!1,y=!1,n=t+1,l=_),t++}a===13&&m.push(I._createLink(g,u,E,n,b))}return m}}e.LinkComputer=I;function d(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=d}),define(we[119],_e([0,1,3,6]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new w.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(S){this._onDidChange.fire({changedLanguages:S,changedColorMap:!1})}register(S,C){return this._map.set(S,C),this.fire([S]),(0,P.toDisposable)(()=>{this._map.get(S)===C&&(this._map.delete(S),this.fire([S]))})}registerPromise(S,C){let D=null,k=!1;return this._promises.set(S,C.then(i=>{this._promises.delete(S),!(k||!i)&&(D=this.register(S,i))})),(0,P.toDisposable)(()=>{k=!0,D&&D.dispose()})}getPromise(S){const C=this.get(S);if(C)return Promise.resolve(C);const D=this._promises.get(S);return D?D.then(k=>this.get(S)):null}get(S){return this._map.get(S)||null}setColorMap(S){this._colorMap=S,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(we[87],_e([0,1,24,21]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(A||(A={}));function T(I){for(let d=0,h=I.length;d<h;d+=4){const r=I[d+0],o=I[d+1],g=I[d+2],m=I[d+3];I[d+0]=m,I[d+1]=g,I[d+2]=o,I[d+3]=r}}function S(I){const d=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return P.isLittleEndian()||T(d),w.VSBuffer.wrap(d)}function C(I){const d=I.buffer;if(P.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const h=new Uint8Array(d.byteLength);return h.set(d),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function D(I){const d=new Uint32Array(k(I));let h=0;if(d[h++]=I.id,I.type==="full")d[h++]=1,d[h++]=I.data.length,d.set(I.data,h),h+=I.data.length;else{d[h++]=2,d[h++]=I.deltas.length;for(const r of I.deltas)d[h++]=r.start,d[h++]=r.deleteCount,r.data?(d[h++]=r.data.length,d.set(r.data,h),h+=r.data.length):d[h++]=0}return S(d)}e.encodeSemanticTokensDto=D;function k(I){let d=0;if(d+=1+1,I.type==="full")d+=1+I.data.length;else{d+=1,d+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(d+=h.data.length)}return d}function i(I){const d=C(I);let h=0;const r=d[h++];if(d[h++]===1){const E=d[h++],f=d.subarray(h,h+E);return h+=E,{id:r,type:"full",data:f}}const g=d[h++];let m=[];for(let E=0;E<g;E++){const f=d[h++],u=d[h++],b=d[h++];let t;b>0&&(t=d.subarray(h,h+b),h+=b),m[E]={start:f,deleteCount:u,data:t}}return{id:r,type:"delta",deltas:m}}e.decodeSemanticTokensDto=i}),define(we[88],_e([0,1,82]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class P{constructor(S,C){this.index=S,this.remainder=C}}e.PrefixSumIndexOfResult=P;class A{constructor(S){this.values=S,this.prefixSum=new Uint32Array(S.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(S,C){S=(0,w.toUint32)(S);const D=this.values,k=this.prefixSum,i=C.length;return i===0?!1:(this.values=new Uint32Array(D.length+i),this.values.set(D.subarray(0,S),0),this.values.set(D.subarray(S),S+i),this.values.set(C,S),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(S,C){return S=(0,w.toUint32)(S),C=(0,w.toUint32)(C),this.values[S]===C?!1:(this.values[S]=C,S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),!0)}removeValues(S,C){S=(0,w.toUint32)(S),C=(0,w.toUint32)(C);const D=this.values,k=this.prefixSum;if(S>=D.length)return!1;let i=D.length-S;return C>=i&&(C=i),C===0?!1:(this.values=new Uint32Array(D.length-C),this.values.set(D.subarray(0,S),0),this.values.set(D.subarray(S+C),S),this.prefixSum=new Uint32Array(this.values.length),S-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=S-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(S){return S<0?0:(S=(0,w.toUint32)(S),this._getAccumulatedValue(S))}_getAccumulatedValue(S){if(S<=this.prefixSumValidIndex[0])return this.prefixSum[S];let C=this.prefixSumValidIndex[0]+1;C===0&&(this.prefixSum[0]=this.values[0],C++),S>=this.values.length&&(S=this.values.length-1);for(let D=C;D<=S;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],S),this.prefixSum[S]}getIndexOf(S){S=Math.floor(S),this.getTotalValue();let C=0,D=this.values.length-1,k=0,i=0,I=0;for(;C<=D;)if(k=C+(D-C)/2|0,i=this.prefixSum[k],I=i-this.values[k],S<I)D=k-1;else if(S>=i)C=k+1;else break;return new P(k,S-I)}}e.PrefixSumComputer=A}),define(we[120],_e([0,1,8,38,88]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(C,D,k,i){this._uri=C,this._lines=D,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(C){C.eol&&C.eol!==this._eol&&(this._eol=C.eol,this._lineStarts=null);const D=C.changes;for(const k of D)this._acceptDeleteRange(k.range),this._acceptInsertText(new P.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=C.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const C=this._eol.length,D=this._lines.length,k=new Uint32Array(D);for(let i=0;i<D;i++)k[i]=this._lines[i].length+C;this._lineStarts=new A.PrefixSumComputer(k)}}_setLineText(C,D){this._lines[C]=D,this._lineStarts&&this._lineStarts.changeValue(C,this._lines[C].length+this._eol.length)}_acceptDeleteRange(C){if(C.startLineNumber===C.endLineNumber){if(C.startColumn===C.endColumn)return;this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.startLineNumber-1].substring(C.endColumn-1));return}this._setLineText(C.startLineNumber-1,this._lines[C.startLineNumber-1].substring(0,C.startColumn-1)+this._lines[C.endLineNumber-1].substring(C.endColumn-1)),this._lines.splice(C.startLineNumber,C.endLineNumber-C.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(C.startLineNumber,C.endLineNumber-C.startLineNumber)}_acceptInsertText(C,D){if(D.length!==0){let k=(0,w.splitLines)(D);if(k.length===1){this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]+this._lines[C.lineNumber-1].substring(C.column-1));return}k[k.length-1]+=this._lines[C.lineNumber-1].substring(C.column-1),this._setLineText(C.lineNumber-1,this._lines[C.lineNumber-1].substring(0,C.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(C.lineNumber+I-1,0,k[I]),i[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(C.lineNumber,i)}}}e.MirrorTextModel=T}),define(we[121],_e([16,17]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(we[60],_e([0,1,121,10,15]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?w.localize(0,null,C(k),S(k.stack)||S(k.stacktrace)):C(k)}function S(k){return Array.isArray(k)?k.join(`
`):k}function C(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?w.localize(1,null,k.message):k.message||w.localize(2,null)}function D(k=null,i=!1){if(!k)return w.localize(3,null);if(Array.isArray(k)){const I=A.coalesce(k),d=D(I[0],i);return I.length>1?w.localize(4,null,d,I.length):d}if(P.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return T(I.error,i);if(I.exception)return T(I.exception,i)}return k.stack?T(k,i):k.message?k.message:w.localize(5,null)}e.toErrorMessage=D}),define(we[122],_e([16,17]),function(Q,e){return Q.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,86]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(H){H[H.None=0]="None",H[H.Keep=1]="Keep",H[H.Brackets=2]="Brackets",H[H.Advanced=3]="Advanced",H[H.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class S{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=S;class C{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ve){this._values[ee]=ve}}e.ValidatedEditorOptions=C;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class k{constructor(ee,ve,Le,He){this.id=ee,this.name=ve,this.defaultValue=Le,this.schema=He}compute(ee,ve,Le){return Le}}class i{constructor(ee,ve=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ve}validate(ee){return this.defaultValue}}class I{constructor(ee,ve,Le,He){this.id=ee,this.name=ve,this.defaultValue=Le,this.schema=He}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ve,Le){return Le}}function d(H,ee){return typeof H=="undefined"?ee:H==="false"?!1:Boolean(H)}e.boolean=d;class h extends I{constructor(ee,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="boolean",He.default=Le),super(ee,ve,Le,He)}validate(ee){return d(ee,this.defaultValue)}}class r extends I{constructor(ee,ve,Le,He,Ue,Xe=void 0){typeof Xe!="undefined"&&(Xe.type="integer",Xe.default=Le,Xe.minimum=He,Xe.maximum=Ue),super(ee,ve,Le,Xe),this.minimum=He,this.maximum=Ue}static clampedInt(ee,ve,Le,He){if(typeof ee=="undefined")return ve;let Ue=parseInt(ee,10);return isNaN(Ue)?ve:(Ue=Math.max(Le,Ue),Ue=Math.min(He,Ue),Ue|0)}validate(ee){return r.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class o extends I{constructor(ee,ve,Le,He,Ue){typeof Ue!="undefined"&&(Ue.type="number",Ue.default=Le),super(ee,ve,Le,Ue),this.validationFn=He}static clamp(ee,ve,Le){return ee<ve?ve:ee>Le?Le:ee}static float(ee,ve){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ve;const Le=parseFloat(ee);return isNaN(Le)?ve:Le}validate(ee){return this.validationFn(o.float(ee,this.defaultValue))}}class g extends I{static string(ee,ve){return typeof ee!="string"?ve:ee}constructor(ee,ve,Le,He=void 0){typeof He!="undefined"&&(He.type="string",He.default=Le),super(ee,ve,Le,He)}validate(ee){return g.string(ee,this.defaultValue)}}function m(H,ee,ve){return typeof H!="string"||ve.indexOf(H)===-1?ee:H}e.stringSet=m;class E extends I{constructor(ee,ve,Le,He,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.enum=He,Ue.default=Le),super(ee,ve,Le,Ue),this._allowedValues=He}validate(ee){return m(ee,this.defaultValue,this._allowedValues)}}class f extends k{constructor(ee,ve,Le,He,Ue,Xe,W=void 0){typeof W!="undefined"&&(W.type="string",W.enum=Ue,W.default=He),super(ee,ve,Le,W),this._allowedValues=Ue,this._convert=Xe}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function u(H){switch(H){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class b extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",description:w.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ve,Le){return Le===0?ee.accessibilitySupport:Le}}class t extends k{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:w.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertSpace:d(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(H){H[H.Hidden=0]="Hidden",H[H.Blink=1]="Blink",H[H.Smooth=2]="Smooth",H[H.Phase=3]="Phase",H[H.Expand=4]="Expand",H[H.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function l(H){switch(H){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var a;(function(H){H[H.Line=1]="Line",H[H.Block=2]="Block",H[H.Underline=3]="Underline",H[H.LineThin=4]="LineThin",H[H.BlockOutline=5]="BlockOutline",H[H.UnderlineThin=6]="UnderlineThin"})(a=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function s(H){switch(H){case a.Line:return"line";case a.Block:return"block";case a.Underline:return"underline";case a.LineThin:return"line-thin";case a.BlockOutline:return"block-outline";case a.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=s;function c(H){switch(H){case"line":return a.Line;case"block":return a.Block;case"underline":return a.Underline;case"line-thin":return a.LineThin;case"block-outline":return a.BlockOutline;case"underline-thin":return a.UnderlineThin}}class p extends i{constructor(){super(123,[62,31])}compute(ee,ve,Le){const He=["monaco-editor"];return ve.get(31)&&He.push(ve.get(31)),ee.extraEditorClassName&&He.push(ee.extraEditorClassName),ve.get(62)==="default"?He.push("mouse-default"):ve.get(62)==="copy"&&He.push("mouse-copy"),ve.get(97)&&He.push("showUnused"),ve.get(121)&&He.push("showDeprecated"),He.join(" ")}}class y extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(ee,ve,Le){return Le&&ee.emptySelectionClipboard}}class v extends k{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:w.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[w.localize(9,null),w.localize(10,null),w.localize(11,null)],description:w.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:w.localize(13,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:w.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:w.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{cursorMoveOnType:d(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":m(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(ve.loop,this.defaultValue.loop)}}}class _ extends k{constructor(){super(41,"fontLigatures",_.OFF,{anyOf:[{type:"boolean",description:w.localize(16,null)},{type:"string",description:w.localize(17,null)}],description:w.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?_.OFF:ee==="true"?_.ON:ee:Boolean(ee)?_.ON:_.OFF}}e.EditorFontLigatures=_,_.OFF='"liga" off, "calt" off',_.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(ee,ve,Le){return ee.fontInfo}}class x extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(19,null)})}validate(ee){let ve=o.float(ee,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ve,6,100)}compute(ee,ve,Le){return ee.fontInfo.fontSize}}class Y extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.MINIMUM_VALUE,maximum:Y.MAXIMUM_VALUE,errorMessage:w.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(r.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.MINIMUM_VALUE,Y.MAXIMUM_VALUE))}}Y.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],Y.MINIMUM_VALUE=1,Y.MAXIMUM_VALUE=1e3;class me extends k{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[w.localize(22,null),w.localize(23,null),w.localize(24,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:w.localize(26,null)},ve),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:w.localize(27,null)},ve),"editor.gotoLocation.multipleDeclarations":Object.assign({description:w.localize(28,null)},ve),"editor.gotoLocation.multipleImplementations":Object.assign({description:w.localize(29,null)},ve),"editor.gotoLocation.multipleReferences":Object.assign({description:w.localize(30,null)},ve),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Le,description:w.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Le,description:w.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Le,description:w.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Le,description:w.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Le,description:w.localize(35,null)}})}validate(ee){var ve,Le,He,Ue,Xe;if(!ee||typeof ee!="object")return this.defaultValue;const W=ee;return{multiple:m(W.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ve=W.multipleDefinitions)!==null&&ve!==void 0?ve:m(W.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Le=W.multipleTypeDefinitions)!==null&&Le!==void 0?Le:m(W.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(He=W.multipleDeclarations)!==null&&He!==void 0?He:m(W.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ue=W.multipleImplementations)!==null&&Ue!==void 0?Ue:m(W.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Xe=W.multipleReferences)!==null&&Xe!==void 0?Xe:m(W.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(W.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(W.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(W.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(W.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(W.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class j extends k{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:w.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:w.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:w.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),delay:r.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:d(ve.sticky,this.defaultValue.sticky)}}}var z;(function(H){H[H.None=0]="None",H[H.Text=1]="Text",H[H.Blocks=2]="Blocks"})(z=e.RenderMinimap||(e.RenderMinimap={}));class te extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ee,ve,Le){return te.computeLayout(ve,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ve=ee.height/ee.lineHeight,Le=ee.scrollBeyondLastLine?ve-1:0,He=(ee.viewLineCount+Le)/(ee.pixelRatio*ee.height),Ue=Math.floor(ee.viewLineCount/He);return{typicalViewportLineCount:ve,extraLinesBeyondLastLine:Le,desiredRatio:He,minimapLineCount:Ue}}static _computeMinimapLayout(ee,ve){const Le=ee.outerWidth,He=ee.outerHeight,Ue=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ue*He),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:He};const Xe=ve.stableMinimapLayoutInput,W=Xe&&ee.outerHeight===Xe.outerHeight&&ee.lineHeight===Xe.lineHeight&&ee.typicalHalfwidthCharacterWidth===Xe.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Xe.pixelRatio&&ee.scrollBeyondLastLine===Xe.scrollBeyondLastLine&&ee.minimap.enabled===Xe.minimap.enabled&&ee.minimap.side===Xe.minimap.side&&ee.minimap.size===Xe.minimap.size&&ee.minimap.showSlider===Xe.minimap.showSlider&&ee.minimap.renderCharacters===Xe.minimap.renderCharacters&&ee.minimap.maxColumn===Xe.minimap.maxColumn&&ee.minimap.scale===Xe.minimap.scale&&ee.verticalScrollbarWidth===Xe.verticalScrollbarWidth&&ee.isViewportWrapping===Xe.isViewportWrapping,ie=ee.lineHeight,ce=ee.typicalHalfwidthCharacterWidth,V=ee.scrollBeyondLastLine,X=ee.minimap.renderCharacters;let ae=Ue>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const he=ee.minimap.maxColumn,ye=ee.minimap.size,ze=ee.minimap.side,Be=ee.verticalScrollbarWidth,Ne=ee.viewLineCount,Ge=ee.remainingWidth,nt=ee.isViewportWrapping,dt=X?2:3;let it=Math.floor(Ue*He);const Je=it/Ue;let mt=!1,bt=!1,be=dt*ae,de=ae/Ue,oe=1;if(ye==="fill"||ye==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Ye,desiredRatio:ot,minimapLineCount:ft}=te.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:V,height:He,lineHeight:ie,pixelRatio:Ue});if(Ne/ft>1)mt=!0,bt=!0,ae=1,be=1,de=ae/Ue;else{let Et=!1,vt=ae+1;if(ye==="fit"){const kt=Math.ceil((Ne+Ye)*be);nt&&W&&Ge<=ve.stableFitRemainingWidth?(Et=!0,vt=ve.stableFitMaxMinimapScale):(Et=kt>it,nt&&Et?(ve.stableMinimapLayoutInput=ee,ve.stableFitRemainingWidth=Ge):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0))}if(ye==="fill"||Et){mt=!0;const kt=ae;be=Math.min(ie*Ue,Math.max(1,Math.floor(1/ot))),ae=Math.min(vt,Math.max(1,Math.floor(be/dt))),ae>kt&&(oe=Math.min(2,ae/kt)),de=ae/Ue/oe,it=Math.ceil(Math.max(ht,Ne+Ye)*be),nt&&Et&&(ve.stableFitMaxMinimapScale=ae)}}}const K=Math.floor(he*de),Re=Math.min(K,Math.max(0,Math.floor((Ge-Be-2)*de/(ce+de)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ue*Re);const Qe=Ie/Ue;Ie=Math.floor(Ie*oe);const Ze=X?1:2,ut=ze==="left"?0:Le-Re-Be;return{renderMinimap:Ze,minimapLeft:ut,minimapWidth:Re,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:ae,minimapLineHeight:be,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:it,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:Je}}static computeLayout(ee,ve){const Le=ve.outerWidth|0,He=ve.outerHeight|0,Ue=ve.lineHeight|0,Xe=ve.lineNumbersDigitCount|0,W=ve.typicalHalfwidthCharacterWidth,ie=ve.maxDigitWidth,ce=ve.pixelRatio,V=ve.viewLineCount,X=ee.get(118),ae=X==="inherit"?ee.get(117):X,he=ae==="inherit"?ee.get(113):ae,ye=ee.get(116),ze=ee.get(2),Be=ve.isDominatedByLongLines,Ne=ee.get(46),Ge=ee.get(56).renderType!==0,nt=ee.get(57),dt=ee.get(91),it=ee.get(61),Je=ee.get(89),mt=Je.verticalScrollbarSize,bt=Je.verticalHasArrows,be=Je.arrowSize,de=Je.horizontalScrollbarSize,oe=ee.get(54),K=ee.get(35);let Re;if(typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)){const _t=parseFloat(oe.substr(0,oe.length-2));Re=r.clampedInt(_t*W,0,0,1e3)}else Re=r.clampedInt(oe,0,0,1e3);K&&(Re+=16);let Ie=0;if(Ge){const _t=Math.max(Xe,nt);Ie=Math.round(_t*ie)}let Qe=0;Ne&&(Qe=Ue);let Ze=0,ut=Ze+Qe,ht=ut+Ie,Ye=ht+Re;const ot=Le-Qe-Ie-Re;let ft=!1,at=!1,Et=-1;ze!==2&&(ae==="inherit"&&Be?(ft=!0,at=!0):he==="on"||he==="bounded"?at=!0:he==="wordWrapColumn"&&(Et=ye));const vt=te._computeMinimapLayout({outerWidth:Le,outerHeight:He,lineHeight:Ue,typicalHalfwidthCharacterWidth:W,pixelRatio:ce,scrollBeyondLastLine:dt,minimap:it,verticalScrollbarWidth:mt,viewLineCount:V,remainingWidth:ot,isViewportWrapping:at},ve.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(Ze+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Ye+=vt.minimapWidth);const kt=ot-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/W)),Tt=bt?be:0;return at&&(Et=Math.max(1,At),he==="bounded"&&(Et=Math.min(Et,ye))),{width:Le,height:He,glyphMarginLeft:Ze,glyphMarginWidth:Qe,lineNumbersLeft:ut,lineNumbersWidth:Ie,decorationsLeft:ht,decorationsWidth:Re,contentLeft:Ye,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:at,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:de,overviewRuler:{top:Tt,width:mt,height:He-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=te;class $ extends k{constructor(){const ee={enabled:!0};super(53,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:w.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:d(ee.enabled,this.defaultValue.enabled)}}}class R extends k{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:w.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:w.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:w.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(ve.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:w.localize(43,null)})}compute(ee,ve,Le){return ee.fontInfo.lineHeight}}class M extends k{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:w.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(45,null),w.localize(46,null),w.localize(47,null)],default:ee.size,description:w.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:w.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:w.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:w.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:w.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),size:m(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(ve.side,this.defaultValue.side,["right","left"]),showSlider:m(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(ve.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ve.scale,1,1,3),maxColumn:r.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function U(H){return H==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{top:r.clampedInt(ve.top,0,0,1e3),bottom:r.clampedInt(ve.bottom,0,0,1e3)}}}class J extends k{constructor(){const ee={enabled:!0,cycle:!1};super(72,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:w.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:w.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{enabled:d(ve.enabled,this.defaultValue.enabled),cycle:d(ve.cycle,this.defaultValue.cycle)}}}class re extends i{constructor(){super(124)}compute(ee,ve,Le){return ee.pixelRatio}}class pe extends k{constructor(){const ee={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:w.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:w.localize(59,null)},other:{type:"boolean",default:ee.other,description:w.localize(60,null)}}}],default:ee,description:w.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ve=ee,Le={other:d(ve.other,this.defaultValue.other),comments:d(ve.comments,this.defaultValue.comments),strings:d(ve.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var Te;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative",H[H.Interval=3]="Interval",H[H.Custom=4]="Custom"})(Te=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(62,null),w.localize(63,null),w.localize(64,null),w.localize(65,null)],default:"on",description:w.localize(66,null)})}validate(ee){let ve=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ve=4,Le=ee):ee==="interval"?ve=3:ee==="relative"?ve=2:ee==="on"?ve=1:ve=0),{renderType:ve,renderFn:Le}}}function Ae(H){const ee=H.get(84);return ee==="editable"?H.get(77):ee!=="on"}e.filterValidationDecorations=Ae;class We extends k{constructor(){const ee=[],ve={type:"number",description:w.localize(67,null)};super(88,"rulers",ee,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:w.localize(68,null),format:"color-hex"}}}]},default:ee,description:w.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let ve=[];for(let Le of ee)if(typeof Le=="number")ve.push({column:r.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const He=Le;ve.push({column:r.clampedInt(He.column,0,0,1e4),color:He.color})}return ve.sort((Le,He)=>Le.column-He.column),ve}return this.defaultValue}}function B(H,ee){if(typeof H!="string")return ee;switch(H){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee,Le=r.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),He=r.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(ve.vertical,this.defaultValue.vertical),horizontal:B(ve.horizontal,this.defaultValue.horizontal),useShadows:d(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:r.clampedInt(ve.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:He,verticalSliderSize:r.clampedInt(ve.verticalSliderSize,He,0,1e3),scrollByPage:d(ve.scrollByPage,this.defaultValue.scrollByPage)}}}class ne extends k{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(70,null),w.localize(71,null)],default:ee.insertMode,description:w.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:w.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:w.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:w.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:w.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:w.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:w.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:w.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(109,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ve=ee;return{insertMode:m(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(ve.showIcons,this.defaultValue.showIcons),showStatusBar:d(ve.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:d(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(ve.showMethods,this.defaultValue.showMethods),showFunctions:d(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:d(ve.showConstructors,this.defaultValue.showConstructors),showFields:d(ve.showFields,this.defaultValue.showFields),showVariables:d(ve.showVariables,this.defaultValue.showVariables),showClasses:d(ve.showClasses,this.defaultValue.showClasses),showStructs:d(ve.showStructs,this.defaultValue.showStructs),showInterfaces:d(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:d(ve.showModules,this.defaultValue.showModules),showProperties:d(ve.showProperties,this.defaultValue.showProperties),showEvents:d(ve.showEvents,this.defaultValue.showEvents),showOperators:d(ve.showOperators,this.defaultValue.showOperators),showUnits:d(ve.showUnits,this.defaultValue.showUnits),showValues:d(ve.showValues,this.defaultValue.showValues),showConstants:d(ve.showConstants,this.defaultValue.showConstants),showEnums:d(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:d(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(ve.showKeywords,this.defaultValue.showKeywords),showWords:d(ve.showWords,this.defaultValue.showWords),showColors:d(ve.showColors,this.defaultValue.showColors),showFiles:d(ve.showFiles,this.defaultValue.showFiles),showReferences:d(ve.showReferences,this.defaultValue.showReferences),showFolders:d(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:d(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(ve.showSnippets,this.defaultValue.showSnippets),showUsers:d(ve.showUsers,this.defaultValue.showUsers),showIssues:d(ve.showIssues,this.defaultValue.showIssues)}}}class le extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(110,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends i{constructor(){super(125,[77])}compute(ee,ve,Le){return ve.get(77)?!0:ee.tabFocusMode}}var Se;(function(H){H[H.None=0]="None",H[H.Same=1]="Same",H[H.Indent=2]="Indent",H[H.DeepIndent=3]="DeepIndent"})(Se=e.WrappingIndent||(e.WrappingIndent={}));function Oe(H){switch(H){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends i{constructor(){super(127,[126])}compute(ee,ve,Le){const He=ve.get(126);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:He.isWordWrapMinified,isViewportWrapping:He.isViewportWrapping,wrappingColumn:He.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?Pe:P.isLinux?$e:Ce,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function Ee(H){return e.editorOptionsRegistry[H.id]=H,H}var je;(function(H){H[H.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",H[H.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",H[H.accessibilitySupport=2]="accessibilitySupport",H[H.accessibilityPageSize=3]="accessibilityPageSize",H[H.ariaLabel=4]="ariaLabel",H[H.autoClosingBrackets=5]="autoClosingBrackets",H[H.autoClosingDelete=6]="autoClosingDelete",H[H.autoClosingOvertype=7]="autoClosingOvertype",H[H.autoClosingQuotes=8]="autoClosingQuotes",H[H.autoIndent=9]="autoIndent",H[H.automaticLayout=10]="automaticLayout",H[H.autoSurround=11]="autoSurround",H[H.codeLens=12]="codeLens",H[H.codeLensFontFamily=13]="codeLensFontFamily",H[H.codeLensFontSize=14]="codeLensFontSize",H[H.colorDecorators=15]="colorDecorators",H[H.columnSelection=16]="columnSelection",H[H.comments=17]="comments",H[H.contextmenu=18]="contextmenu",H[H.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",H[H.cursorBlinking=20]="cursorBlinking",H[H.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",H[H.cursorStyle=22]="cursorStyle",H[H.cursorSurroundingLines=23]="cursorSurroundingLines",H[H.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",H[H.cursorWidth=25]="cursorWidth",H[H.disableLayerHinting=26]="disableLayerHinting",H[H.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",H[H.domReadOnly=28]="domReadOnly",H[H.dragAndDrop=29]="dragAndDrop",H[H.emptySelectionClipboard=30]="emptySelectionClipboard",H[H.extraEditorClassName=31]="extraEditorClassName",H[H.fastScrollSensitivity=32]="fastScrollSensitivity",H[H.find=33]="find",H[H.fixedOverflowWidgets=34]="fixedOverflowWidgets",H[H.folding=35]="folding",H[H.foldingStrategy=36]="foldingStrategy",H[H.foldingHighlight=37]="foldingHighlight",H[H.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",H[H.fontFamily=39]="fontFamily",H[H.fontInfo=40]="fontInfo",H[H.fontLigatures=41]="fontLigatures",H[H.fontSize=42]="fontSize",H[H.fontWeight=43]="fontWeight",H[H.formatOnPaste=44]="formatOnPaste",H[H.formatOnType=45]="formatOnType",H[H.glyphMargin=46]="glyphMargin",H[H.gotoLocation=47]="gotoLocation",H[H.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",H[H.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",H[H.hover=50]="hover",H[H.inDiffEditor=51]="inDiffEditor",H[H.letterSpacing=52]="letterSpacing",H[H.lightbulb=53]="lightbulb",H[H.lineDecorationsWidth=54]="lineDecorationsWidth",H[H.lineHeight=55]="lineHeight",H[H.lineNumbers=56]="lineNumbers",H[H.lineNumbersMinChars=57]="lineNumbersMinChars",H[H.linkedEditing=58]="linkedEditing",H[H.links=59]="links",H[H.matchBrackets=60]="matchBrackets",H[H.minimap=61]="minimap",H[H.mouseStyle=62]="mouseStyle",H[H.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",H[H.mouseWheelZoom=64]="mouseWheelZoom",H[H.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",H[H.multiCursorModifier=66]="multiCursorModifier",H[H.multiCursorPaste=67]="multiCursorPaste",H[H.occurrencesHighlight=68]="occurrencesHighlight",H[H.overviewRulerBorder=69]="overviewRulerBorder",H[H.overviewRulerLanes=70]="overviewRulerLanes",H[H.padding=71]="padding",H[H.parameterHints=72]="parameterHints",H[H.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",H[H.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",H[H.quickSuggestions=75]="quickSuggestions",H[H.quickSuggestionsDelay=76]="quickSuggestionsDelay",H[H.readOnly=77]="readOnly",H[H.renameOnType=78]="renameOnType",H[H.renderControlCharacters=79]="renderControlCharacters",H[H.renderIndentGuides=80]="renderIndentGuides",H[H.renderFinalNewline=81]="renderFinalNewline",H[H.renderLineHighlight=82]="renderLineHighlight",H[H.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",H[H.renderValidationDecorations=84]="renderValidationDecorations",H[H.renderWhitespace=85]="renderWhitespace",H[H.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",H[H.roundedSelection=87]="roundedSelection",H[H.rulers=88]="rulers",H[H.scrollbar=89]="scrollbar",H[H.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",H[H.scrollBeyondLastLine=91]="scrollBeyondLastLine",H[H.scrollPredominantAxis=92]="scrollPredominantAxis",H[H.selectionClipboard=93]="selectionClipboard",H[H.selectionHighlight=94]="selectionHighlight",H[H.selectOnLineNumbers=95]="selectOnLineNumbers",H[H.showFoldingControls=96]="showFoldingControls",H[H.showUnused=97]="showUnused",H[H.snippetSuggestions=98]="snippetSuggestions",H[H.smartSelect=99]="smartSelect",H[H.smoothScrolling=100]="smoothScrolling",H[H.stickyTabStops=101]="stickyTabStops",H[H.stopRenderingLineAfter=102]="stopRenderingLineAfter",H[H.suggest=103]="suggest",H[H.suggestFontSize=104]="suggestFontSize",H[H.suggestLineHeight=105]="suggestLineHeight",H[H.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",H[H.suggestSelection=107]="suggestSelection",H[H.tabCompletion=108]="tabCompletion",H[H.tabIndex=109]="tabIndex",H[H.unusualLineTerminators=110]="unusualLineTerminators",H[H.useTabStops=111]="useTabStops",H[H.wordSeparators=112]="wordSeparators",H[H.wordWrap=113]="wordWrap",H[H.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",H[H.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",H[H.wordWrapColumn=116]="wordWrapColumn",H[H.wordWrapOverride1=117]="wordWrapOverride1",H[H.wordWrapOverride2=118]="wordWrapOverride2",H[H.wrappingIndent=119]="wrappingIndent",H[H.wrappingStrategy=120]="wrappingStrategy",H[H.showDeprecated=121]="showDeprecated",H[H.inlayHints=122]="inlayHints",H[H.editorClassName=123]="editorClassName",H[H.pixelRatio=124]="pixelRatio",H[H.tabFocusMode=125]="tabFocusMode",H[H.layoutInfo=126]="layoutInfo",H[H.wrappingInfo=127]="wrappingInfo"})(je=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ee(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(111,null)})),acceptSuggestionOnEnter:Ee(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(112,null),""],markdownDescription:w.localize(113,null)})),accessibilitySupport:Ee(new b),accessibilityPageSize:Ee(new r(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(114,null)})),ariaLabel:Ee(new g(4,"ariaLabel",w.localize(115,null))),autoClosingBrackets:Ee(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(116,null),w.localize(117,null),""],description:w.localize(118,null)})),autoClosingDelete:Ee(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(119,null),""],description:w.localize(120,null)})),autoClosingOvertype:Ee(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(121,null),""],description:w.localize(122,null)})),autoClosingQuotes:Ee(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(123,null),w.localize(124,null),""],description:w.localize(125,null)})),autoIndent:Ee(new f(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[w.localize(126,null),w.localize(127,null),w.localize(128,null),w.localize(129,null),w.localize(130,null)],description:w.localize(131,null)})),automaticLayout:Ee(new h(10,"automaticLayout",!1)),autoSurround:Ee(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null),""],description:w.localize(135,null)})),stickyTabStops:Ee(new h(101,"stickyTabStops",!1,{description:w.localize(136,null)})),codeLens:Ee(new h(12,"codeLens",!0,{description:w.localize(137,null)})),codeLensFontFamily:Ee(new g(13,"codeLensFontFamily","",{description:w.localize(138,null)})),codeLensFontSize:Ee(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:w.localize(139,null)})),colorDecorators:Ee(new h(15,"colorDecorators",!0,{description:w.localize(140,null)})),columnSelection:Ee(new h(16,"columnSelection",!1,{description:w.localize(141,null)})),comments:Ee(new t),contextmenu:Ee(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:Ee(new h(19,"copyWithSyntaxHighlighting",!0,{description:w.localize(142,null)})),cursorBlinking:Ee(new f(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],l,{description:w.localize(143,null)})),cursorSmoothCaretAnimation:Ee(new h(21,"cursorSmoothCaretAnimation",!1,{description:w.localize(144,null)})),cursorStyle:Ee(new f(22,"cursorStyle",a.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],c,{description:w.localize(145,null)})),cursorSurroundingLines:Ee(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(146,null)})),cursorSurroundingLinesStyle:Ee(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(147,null),w.localize(148,null)],description:w.localize(149,null)})),cursorWidth:Ee(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(150,null)})),disableLayerHinting:Ee(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ee(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:Ee(new h(28,"domReadOnly",!1)),dragAndDrop:Ee(new h(29,"dragAndDrop",!0,{description:w.localize(151,null)})),emptySelectionClipboard:Ee(new y),extraEditorClassName:Ee(new g(31,"extraEditorClassName","")),fastScrollSensitivity:Ee(new o(32,"fastScrollSensitivity",5,H=>H<=0?5:H,{markdownDescription:w.localize(152,null)})),find:Ee(new v),fixedOverflowWidgets:Ee(new h(34,"fixedOverflowWidgets",!1)),folding:Ee(new h(35,"folding",!0,{description:w.localize(153,null)})),foldingStrategy:Ee(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(154,null),w.localize(155,null)],description:w.localize(156,null)})),foldingHighlight:Ee(new h(37,"foldingHighlight",!0,{description:w.localize(157,null)})),unfoldOnClickAfterEndOfLine:Ee(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(158,null)})),fontFamily:Ee(new g(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(159,null)})),fontInfo:Ee(new F),fontLigatures2:Ee(new _),fontSize:Ee(new x),fontWeight:Ee(new Y),formatOnPaste:Ee(new h(44,"formatOnPaste",!1,{description:w.localize(160,null)})),formatOnType:Ee(new h(45,"formatOnType",!1,{description:w.localize(161,null)})),glyphMargin:Ee(new h(46,"glyphMargin",!0,{description:w.localize(162,null)})),gotoLocation:Ee(new me),hideCursorInOverviewRuler:Ee(new h(48,"hideCursorInOverviewRuler",!1,{description:w.localize(163,null)})),highlightActiveIndentGuide:Ee(new h(49,"highlightActiveIndentGuide",!0,{description:w.localize(164,null)})),hover:Ee(new j),inDiffEditor:Ee(new h(51,"inDiffEditor",!1)),letterSpacing:Ee(new o(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,H=>o.clamp(H,-5,20),{description:w.localize(165,null)})),lightbulb:Ee(new $),lineDecorationsWidth:Ee(new I(54,"lineDecorationsWidth",10)),lineHeight:Ee(new L),lineNumbers:Ee(new xe),lineNumbersMinChars:Ee(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:Ee(new h(58,"linkedEditing",!1,{description:w.localize(166,null)})),links:Ee(new h(59,"links",!0,{description:w.localize(167,null)})),matchBrackets:Ee(new E(60,"matchBrackets","always",["always","near","never"],{description:w.localize(168,null)})),minimap:Ee(new M),mouseStyle:Ee(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ee(new o(63,"mouseWheelScrollSensitivity",1,H=>H===0?1:H,{markdownDescription:w.localize(169,null)})),mouseWheelZoom:Ee(new h(64,"mouseWheelZoom",!1,{markdownDescription:w.localize(170,null)})),multiCursorMergeOverlapping:Ee(new h(65,"multiCursorMergeOverlapping",!0,{description:w.localize(171,null)})),multiCursorModifier:Ee(new f(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],U,{markdownEnumDescriptions:[w.localize(172,null),w.localize(173,null)],markdownDescription:w.localize(174,null)})),multiCursorPaste:Ee(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(175,null),w.localize(176,null)],markdownDescription:w.localize(177,null)})),occurrencesHighlight:Ee(new h(68,"occurrencesHighlight",!0,{description:w.localize(178,null)})),overviewRulerBorder:Ee(new h(69,"overviewRulerBorder",!0,{description:w.localize(179,null)})),overviewRulerLanes:Ee(new r(70,"overviewRulerLanes",3,0,3)),padding:Ee(new G),parameterHints:Ee(new J),peekWidgetDefaultFocus:Ee(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(180,null),w.localize(181,null)],description:w.localize(182,null)})),definitionLinkOpensInPeek:Ee(new h(74,"definitionLinkOpensInPeek",!1,{description:w.localize(183,null)})),quickSuggestions:Ee(new pe),quickSuggestionsDelay:Ee(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(184,null)})),readOnly:Ee(new h(77,"readOnly",!1)),renameOnType:Ee(new h(78,"renameOnType",!1,{description:w.localize(185,null),markdownDeprecationMessage:w.localize(186,null)})),renderControlCharacters:Ee(new h(79,"renderControlCharacters",!1,{description:w.localize(187,null)})),renderIndentGuides:Ee(new h(80,"renderIndentGuides",!0,{description:w.localize(188,null)})),renderFinalNewline:Ee(new h(81,"renderFinalNewline",!0,{description:w.localize(189,null)})),renderLineHighlight:Ee(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(190,null)],description:w.localize(191,null)})),renderLineHighlightOnlyWhenFocus:Ee(new h(83,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(192,null)})),renderValidationDecorations:Ee(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ee(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(193,null),w.localize(194,null),w.localize(195,null),""],description:w.localize(196,null)})),revealHorizontalRightPadding:Ee(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:Ee(new h(87,"roundedSelection",!0,{description:w.localize(197,null)})),rulers:Ee(new We),scrollbar:Ee(new q),scrollBeyondLastColumn:Ee(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:w.localize(198,null)})),scrollBeyondLastLine:Ee(new h(91,"scrollBeyondLastLine",!0,{description:w.localize(199,null)})),scrollPredominantAxis:Ee(new h(92,"scrollPredominantAxis",!0,{description:w.localize(200,null)})),selectionClipboard:Ee(new h(93,"selectionClipboard",!0,{description:w.localize(201,null),included:P.isLinux})),selectionHighlight:Ee(new h(94,"selectionHighlight",!0,{description:w.localize(202,null)})),selectOnLineNumbers:Ee(new h(95,"selectOnLineNumbers",!0)),showFoldingControls:Ee(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[w.localize(203,null),w.localize(204,null)],description:w.localize(205,null)})),showUnused:Ee(new h(97,"showUnused",!0,{description:w.localize(206,null)})),showDeprecated:Ee(new h(121,"showDeprecated",!0,{description:w.localize(207,null)})),inlayHints:Ee(new R),snippetSuggestions:Ee(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(208,null),w.localize(209,null),w.localize(210,null),w.localize(211,null)],description:w.localize(212,null)})),smartSelect:Ee(new le),smoothScrolling:Ee(new h(100,"smoothScrolling",!1,{description:w.localize(213,null)})),stopRenderingLineAfter:Ee(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ee(new ne),suggestFontSize:Ee(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(214,null)})),suggestLineHeight:Ee(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(215,null)})),suggestOnTriggerCharacters:Ee(new h(106,"suggestOnTriggerCharacters",!0,{description:w.localize(216,null)})),suggestSelection:Ee(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(217,null),w.localize(218,null),w.localize(219,null)],description:w.localize(220,null)})),tabCompletion:Ee(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(221,null),w.localize(222,null),w.localize(223,null)],description:w.localize(224,null)})),tabIndex:Ee(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:Ee(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(225,null),w.localize(226,null),w.localize(227,null)],description:w.localize(228,null)})),useTabStops:Ee(new h(111,"useTabStops",!0,{description:w.localize(229,null)})),wordSeparators:Ee(new g(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:w.localize(230,null)})),wordWrap:Ee(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(231,null),w.localize(232,null),w.localize(233,null),w.localize(234,null)],description:w.localize(235,null)})),wordWrapBreakAfterCharacters:Ee(new g(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ee(new g(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ee(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(236,null)})),wordWrapOverride1:Ee(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ee(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:Ee(new f(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Oe,{enumDescriptions:[w.localize(237,null),w.localize(238,null),w.localize(239,null),w.localize(240,null)],description:w.localize(241,null)})),wrappingStrategy:Ee(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[w.localize(242,null),w.localize(243,null)],description:w.localize(244,null)})),editorClassName:Ee(new p),pixelRatio:Ee(new re),tabFocusMode:Ee(new fe),layoutInfo:Ee(new te),wrappingInfo:Ee(new ge)}}),define(we[124],_e([16,17]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([16,17]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([16,17]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(we[127],_e([16,17]),function(Q,e){return Q.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([16,17]),function(Q,e){return Q.create("vs/platform/theme/common/iconRegistry",e)}),define(we[129],_e([16,17]),function(Q,e){return Q.create("vs/platform/workspaces/common/workspaces",e)}),define(we[130],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHost.api.impl",e)}),define(we[131],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[132],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[133],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostProgress",e)}),define(we[134],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[135],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[136],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[137],_e([16,17]),function(Q,e){return Q.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[138],_e([16,17]),function(Q,e){return Q.create("vs/workbench/common/views",e)}),define(we[139],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[140],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[141],_e([16,17]),function(Q,e){return Q.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[142],_e([16,17]),function(Q,e){return Q.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[143],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var w;(function(S){S[S.ACTIVATE=0]="ACTIVATE",S[S.RESTORE=1]="RESTORE",S[S.PRESERVE=2]="PRESERVE"})(w=e.EditorActivation||(e.EditorActivation={}));var P;(function(S){S[S.PICK=1]="PICK",S[S.DISABLED=2]="DISABLED"})(P=e.EditorOverride||(e.EditorOverride={}));var A;(function(S){S[S.API=0]="API",S[S.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(S){S[S.Center=0]="Center",S[S.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",S[S.NearTop=2]="NearTop",S[S.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[144],_e([0,1,125]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(I){return I=I.trim(),I==="*"||P.test(I)}e.isValidVersionStr=A;function T(I){if(!A(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=I.match(P);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=T;function S(I){if(!I)return null;let d=I.majorBase,h=I.majorMustEqual,r=I.minorBase,o=I.minorMustEqual,g=I.patchBase,m=I.patchMustEqual;return I.hasCaret&&(d===0||(o=!1),m=!1),{majorBase:d,majorMustEqual:h,minorBase:r,minorMustEqual:o,patchBase:g,patchMustEqual:m,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=S;function C(I,d){let h;typeof I=="string"?h=S(T(I)):h=I;let r;if(typeof d=="string"?r=S(T(d)):r=d,!h||!r)return!1;let o=h.majorBase,g=h.minorBase,m=h.patchBase,E=r.majorBase,f=r.minorBase,u=r.patchBase,b=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?o>E?!0:o<E?!1:g>f?!0:g<f?!1:m>=u:(o===1&&E===0&&(!b||!t||!n)&&(E=1,f=0,u=0,b=!0,t=!1,n=!1),o<E?!1:o>E?!b:g<f?!1:g>f?!t:m<u?!1:m>u?!n:!0)}e.isValidVersion=C;function D(I,d,h){return d.isBuiltin||typeof d.main=="undefined"?!0:i(I,d.engines.vscode,h)}e.isValidExtensionVersion=D;function k(I,d){return I==="*"||i(d,I)}e.isEngineValid=k;function i(I,d,h=[]){let r=S(T(d));if(!r)return h.push(w.localize(0,null,d)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return h.push(w.localize(1,null,d)),!1}else if(!r.majorMustEqual)return h.push(w.localize(2,null,d)),!1;return C(I,r)?!0:(h.push(w.localize(3,null,I,d)),!1)}e.isVersionValid=i}),define(we[89],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class w{constructor(T,S=[],C=!1){this.ctor=T,this.staticArguments=S,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=w;const P=(A,...T)=>new w(A,T);e.createSyncDescriptor=P}),define(we[61],_e([0,1,89]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const P=[];function A(S,C,D){C instanceof w.SyncDescriptor||(C=new w.SyncDescriptor(C,[],D)),P.push([S,C])}e.registerSingleton=A;function T(){return P}e.getSingletonServiceDescriptors=T}),define(we[145],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class w{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=w;class P{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let S of this._nodes.values())S.outgoing.size===0&&T.push(S);return T}insertEdge(T,S){const C=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(S);C.outgoing.set(this._hashFn(S),D),D.incoming.set(this._hashFn(T),C)}removeNode(T){const S=this._hashFn(T);this._nodes.delete(S);for(let C of this._nodes.values())C.outgoing.delete(S),C.incoming.delete(S)}lookupOrInsertNode(T){const S=this._hashFn(T);let C=this._nodes.get(S);return C||(C=new w(T),this._nodes.set(S,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[S,C]of this._nodes)T.push(`${S}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,S]of this._nodes){const C=new Set([T]),D=this._findCycle(S,C);if(D)return D}}_findCycle(T,S){for(let[C,D]of T.outgoing){if(S.has(C))return[...S,C].join(" -> ");S.add(C);const k=this._findCycle(D,S);if(k)return k;S.delete(C)}}}e.Graph=P}),define(we[4],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var w;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function D(k){return k[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=D})(w=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function P(C,D,k,i){D[w.DI_TARGET]===D?D[w.DI_DEPENDENCIES].push({id:C,index:k,optional:i}):(D[w.DI_DEPENDENCIES]=[{id:C,index:k,optional:i}],D[w.DI_TARGET]=D)}function A(C){if(w.serviceIds.has(C))return w.serviceIds.get(C);const D=function(k,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(D,k,I,!1)};return D.toString=()=>C,w.serviceIds.set(C,D),D}e.createDecorator=A;function T(C){return C}e.refineServiceDecorator=T;function S(C){return function(D,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(C,D,i,!0)}}e.optional=S}),define(we[146],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,w.createDecorator)("modelService");function P(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(we[147],_e([0,1,3,56,6,22,81,59,146]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new w.Emitter}get onDidChange(){return this._onDidChange.event}register(h,r){let o={selector:h,provider:r,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(o){let g=this._entries.indexOf(o);g>=0&&(this._entries.splice(g,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const r=[];for(let o of this._entries)o._score>0&&r.push(o.provider);return r}ordered(h){const r=[];return this._orderedForEach(h,o=>r.push(o.provider)),r}orderedGroups(h){const r=[];let o,g;return this._orderedForEach(h,m=>{o&&g===m._score?o.push(m.provider):(g=m._score,o=[m.provider],r.push(o))}),r}_orderedForEach(h,r){if(!!h){this._updateScores(h);for(const o of this._entries)o._score>0&&r(o)}}_updateScores(h){let r={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let o of this._entries)if(o._score=(0,C.score)(o.selector,h.uri,h.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(h)),k(o.selector)&&o._score>0){for(let g of this._entries)g._score=0;o._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(h,r){return h._score<r._score?1:h._score>r._score?-1:h._time<r._time?1:h._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(h,r,o=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=r,this.max=o,this._cache=new T.LRUCache(50,.7)}_key(h){return h.id+(0,P.hash)(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const r=this._key(h),o=this._cache.get(r);return this._clamp(o==null?void 0:o.value)}update(h,r){const o=this._key(h);let g=this._cache.get(o);return g||(g=new S.MovingAverage,this._cache.set(o,g)),g.update(r),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(we[62],_e([0,1,2,32,147,119,36]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var C;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(C=e.LanguageId||(e.LanguageId={}));class D{constructor(_,F){this.language=_,this.id=F}}e.LanguageIdentifier=D;var k;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",v[v.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(_){return(_&255)>>>0}static getTokenType(_){return(_&1792)>>>8}static getFontStyle(_){return(_&14336)>>>11}static getForeground(_){return(_&8372224)>>>14}static getBackground(_){return(_&4286578688)>>>23}static getClassNameFromMetadata(_){let F=this.getForeground(_),x="mtk"+F,Y=this.getFontStyle(_);return Y&1&&(x+=" mtki"),Y&2&&(x+=" mtkb"),Y&4&&(x+=" mtku"),x}static getInlineStyleFromMetadata(_,F){const x=this.getForeground(_),Y=this.getFontStyle(_);let me=`color: ${F[x]};`;return Y&1&&(me+="font-style: italic;"),Y&2&&(me+="font-weight: bold;"),Y&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=h;var r;(function(v){v[v.Method=0]="Method",v[v.Function=1]="Function",v[v.Constructor=2]="Constructor",v[v.Field=3]="Field",v[v.Variable=4]="Variable",v[v.Class=5]="Class",v[v.Struct=6]="Struct",v[v.Interface=7]="Interface",v[v.Module=8]="Module",v[v.Property=9]="Property",v[v.Event=10]="Event",v[v.Operator=11]="Operator",v[v.Unit=12]="Unit",v[v.Value=13]="Value",v[v.Constant=14]="Constant",v[v.Enum=15]="Enum",v[v.EnumMember=16]="EnumMember",v[v.Keyword=17]="Keyword",v[v.Text=18]="Text",v[v.Color=19]="Color",v[v.File=20]="File",v[v.Reference=21]="Reference",v[v.Customcolor=22]="Customcolor",v[v.Folder=23]="Folder",v[v.TypeParameter=24]="TypeParameter",v[v.User=25]="User",v[v.Issue=26]="Issue",v[v.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let v=Object.create(null);return v[0]="symbol-method",v[1]="symbol-function",v[2]="symbol-constructor",v[3]="symbol-field",v[4]="symbol-variable",v[5]="symbol-class",v[6]="symbol-struct",v[7]="symbol-interface",v[8]="symbol-module",v[9]="symbol-property",v[10]="symbol-event",v[11]="symbol-operator",v[12]="symbol-unit",v[13]="symbol-value",v[14]="symbol-constant",v[15]="symbol-enum",v[16]="symbol-enum-member",v[17]="symbol-keyword",v[27]="symbol-snippet",v[18]="symbol-text",v[19]="symbol-color",v[20]="symbol-file",v[21]="symbol-reference",v[22]="symbol-customcolor",v[23]="symbol-folder",v[24]="symbol-type-parameter",v[25]="account",v[26]="issues",function(_){const F=v[_];let x=F&&S.iconRegistry.get(F);return x||(console.info("No codicon found for CompletionItemKind "+_),x=S.Codicon.symbolProperty),x.classNames}}(),e.completionKindFromString=function(){let v=Object.create(null);return v.method=0,v.function=1,v.constructor=2,v.field=3,v.variable=4,v.class=5,v.struct=6,v.interface=7,v.module=8,v.property=9,v.event=10,v.operator=11,v.unit=12,v.value=13,v.constant=14,v.enum=15,v["enum-member"]=16,v.enumMember=16,v.keyword=17,v.snippet=27,v.text=18,v.color=19,v.file=20,v.reference=21,v.customcolor=22,v.folder=23,v["type-parameter"]=24,v.typeParameter=24,v.account=25,v.issue=26,function(_,F){let x=v[_];return typeof x=="undefined"&&!F&&(x=9),x}}();var o;(function(v){v[v.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var g;(function(v){v[v.KeepWhitespace=1]="KeepWhitespace",v[v.InsertAsSnippet=4]="InsertAsSnippet"})(g=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var m;(function(v){v[v.Invoke=0]="Invoke",v[v.TriggerCharacter=1]="TriggerCharacter",v[v.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(m=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(v){v[v.Invoke=1]="Invoke",v[v.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(v){v[v.Invoke=1]="Invoke",v[v.TriggerCharacter=2]="TriggerCharacter",v[v.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var u;(function(v){v[v.Text=0]="Text",v[v.Read=1]="Read",v[v.Write=2]="Write"})(u=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function b(v){return v&&w.URI.isUri(v.uri)&&P.Range.isIRange(v.range)&&(P.Range.isIRange(v.originSelectionRange)||P.Range.isIRange(v.targetSelectionRange))}e.isLocationLink=b;var t;(function(v){v[v.File=0]="File",v[v.Module=1]="Module",v[v.Namespace=2]="Namespace",v[v.Package=3]="Package",v[v.Class=4]="Class",v[v.Method=5]="Method",v[v.Property=6]="Property",v[v.Field=7]="Field",v[v.Constructor=8]="Constructor",v[v.Enum=9]="Enum",v[v.Interface=10]="Interface",v[v.Function=11]="Function",v[v.Variable=12]="Variable",v[v.Constant=13]="Constant",v[v.String=14]="String",v[v.Number=15]="Number",v[v.Boolean=16]="Boolean",v[v.Array=17]="Array",v[v.Object=18]="Object",v[v.Key=19]="Key",v[v.Null=20]="Null",v[v.EnumMember=21]="EnumMember",v[v.Struct=22]="Struct",v[v.Event=23]="Event",v[v.Operator=24]="Operator",v[v.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(v){v[v.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var l;(function(v){const _=new Map;_.set("file",0),_.set("module",1),_.set("namespace",2),_.set("package",3),_.set("class",4),_.set("method",5),_.set("property",6),_.set("field",7),_.set("constructor",8),_.set("enum",9),_.set("interface",10),_.set("function",11),_.set("variable",12),_.set("constant",13),_.set("string",14),_.set("number",15),_.set("boolean",16),_.set("array",17),_.set("object",18),_.set("key",19),_.set("null",20),_.set("enum-member",21),_.set("struct",22),_.set("event",23),_.set("operator",24),_.set("type-parameter",25);const F=new Map;F.set(0,"file"),F.set(1,"module"),F.set(2,"namespace"),F.set(3,"package"),F.set(4,"class"),F.set(5,"method"),F.set(6,"property"),F.set(7,"field"),F.set(8,"constructor"),F.set(9,"enum"),F.set(10,"interface"),F.set(11,"function"),F.set(12,"variable"),F.set(13,"constant"),F.set(14,"string"),F.set(15,"number"),F.set(16,"boolean"),F.set(17,"array"),F.set(18,"object"),F.set(19,"key"),F.set(20,"null"),F.set(21,"enum-member"),F.set(22,"struct"),F.set(23,"event"),F.set(24,"operator"),F.set(25,"type-parameter");function x(j){return _.get(j)}v.fromString=x;function Y(j){return F.get(j)}v.toString=Y;function me(j,z){const te=F.get(j);let $=te&&S.iconRegistry.get("symbol-"+te);return $||(console.info("No codicon found for SymbolKind "+j),$=S.Codicon.symbolProperty),`${z?"inline":"block"} ${$.classNames}`}v.toCssClassName=me})(l=e.SymbolKinds||(e.SymbolKinds={}));class a{constructor(_){this.value=_}}e.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region");var s;(function(v){v[v.Collapsed=0]="Collapsed",v[v.Expanded=1]="Expanded"})(s=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var c;(function(v){v[v.Editing=0]="Editing",v[v.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var p;(function(v){v[v.Other=0]="Other",v[v.Type=1]="Type",v[v.Parameter=2]="Parameter"})(p=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var y;(function(v){v[v.None=0]="None",v[v.Option=1]="Option",v[v.Default=2]="Default",v[v.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[148],_e([0,1,6,10,4,3,45,43]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,k){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:D,handler:k})}if(D.description){const r=[];for(let g of D.description.args)r.push(g.constraint);const o=D.handler;D.handler=function(g,...m){return(0,P.validateConstraints)(m,r),o(g,...m)}}const{id:i}=D;let I=this._commands.get(i);I||(I=new S.LinkedList,this._commands.set(i,I));let d=I.unshift(D),h=(0,w.toDisposable)(()=>{d();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),h}registerCommandAlias(D,k){return e.CommandsRegistry.registerCommand(D,(i,...I)=>i.get(e.ICommandService).executeCommand(k,...I))}getCommand(D){const k=this._commands.get(D);if(!(!k||k.isEmpty()))return C.Iterable.first(k)}getCommands(){const D=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&D.set(k,i)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>w.Disposable.None,onDidExecuteCommand:()=>w.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(we[63],_e([0,1,8,4,21]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",A.isMacintosh),S.set("isLinux",A.isLinux),S.set("isWindows",A.isWindows),S.set("isWeb",A.isWeb),S.set("isMacNative",A.isMacintosh&&!A.isWeb),S.set("isEdge",T.indexOf("Edg/")>=0),S.set("isFirefox",T.indexOf("Firefox")>=0),S.set("isChrome",T.indexOf("Chrome")>=0),S.set("isSafari",T.indexOf("Safari")>=0),S.set("isIPad",T.indexOf("iPad")>=0);const C=Object.prototype.hasOwnProperty;var D;(function(v){v[v.False=0]="False",v[v.True=1]="True",v[v.Defined=2]="Defined",v[v.Not=3]="Not",v[v.Equals=4]="Equals",v[v.NotEquals=5]="NotEquals",v[v.And=6]="And",v[v.Regex=7]="Regex",v[v.NotRegex=8]="NotRegex",v[v.Or=9]="Or",v[v.In=10]="In",v[v.NotIn=11]="NotIn",v[v.Greater=12]="Greater",v[v.GreaterEquals=13]="GreaterEquals",v[v.Smaller=14]="Smaller",v[v.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return d.INSTANCE}static has(_){return h.create(_)}static equals(_,F){return r.create(_,F)}static notEquals(_,F){return m.create(_,F)}static regex(_,F){return n.create(_,F)}static in(_,F){return o.create(_,F)}static not(_){return E.create(_)}static and(..._){return a.create(_)}static or(..._){return s.create(_)}static greater(_,F){return f.create(_,F)}static less(_,F){return b.create(_,F)}static deserialize(_,F=!1){if(!!_)return this._deserializeOrExpression(_,F)}static _deserializeOrExpression(_,F){let x=_.split("||");return s.create(x.map(Y=>this._deserializeAndExpression(Y,F)))}static _deserializeAndExpression(_,F){let x=_.split("&&");return a.create(x.map(Y=>this._deserializeOne(Y,F)))}static _deserializeOne(_,F){if(_=_.trim(),_.indexOf("!=")>=0){let x=_.split("!=");return m.create(x[0].trim(),this._deserializeValue(x[1],F))}if(_.indexOf("==")>=0){let x=_.split("==");return r.create(x[0].trim(),this._deserializeValue(x[1],F))}if(_.indexOf("=~")>=0){let x=_.split("=~");return n.create(x[0].trim(),this._deserializeRegexValue(x[1],F))}if(_.indexOf(" in ")>=0){let x=_.split(" in ");return o.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(_)){const x=_.split(">=");return u.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(_)){const x=_.split(">");return f.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(_)){const x=_.split("<=");return t.create(x[0].trim(),x[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(_)){const x=_.split("<");return b.create(x[0].trim(),x[1].trim())}return/^\!\s*/.test(_)?E.create(_.substr(1).trim()):h.create(_)}static _deserializeValue(_,F){if(_=_.trim(),_==="true")return!0;if(_==="false")return!1;let x=/^'([^']*)'$/.exec(_);return x?x[1].trim():_}static _deserializeRegexValue(_,F){if((0,w.isFalsyOrWhitespace)(_)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let x=_.indexOf("/"),Y=_.lastIndexOf("/");if(x===Y||x<0){if(F)throw new Error(`bad regexp-value '${_}', missing /-enclosure`);return console.warn(`bad regexp-value '${_}', missing /-enclosure`),null}let me=_.slice(x+1,Y),j=_[Y+1]==="i"?"i":"";try{return new RegExp(me,j)}catch(z){if(F)throw new Error(`bad regexp-value '${_}', parse error: ${z}`);return console.warn(`bad regexp-value '${_}', parse error: ${z}`),null}}}e.ContextKeyExpr=k;function i(v,_){return v.cmp(_)}class I{constructor(){this.type=0}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!1}serialize(){return"false"}keys(){return[]}map(_){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class d{constructor(){this.type=1}cmp(_){return this.type-_.type}equals(_){return _.type===this.type}evaluate(_){return!0}serialize(){return"true"}keys(){return[]}map(_){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class h{constructor(_){this.key=_,this.type=2}static create(_){const F=S.get(_);return typeof F=="boolean"?F?d.INSTANCE:I.INSTANCE:new h(_)}cmp(_){return _.type!==this.type?this.type-_.type:p(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!!_.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(_){return _.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=h;class r{constructor(_,F){this.key=_,this.value=F,this.type=4}static create(_,F){if(typeof F=="boolean")return F?h.create(_):E.create(_);const x=S.get(_);return typeof x=="boolean"?F===(x?"true":"false")?d.INSTANCE:I.INSTANCE:new r(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(_){return _.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class o{constructor(_,F){this.key=_,this.valueKey=F,this.type=10}static create(_,F){return new o(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.valueKey,_.key,_.valueKey)}equals(_){return _.type===this.type?this.key===_.key&&this.valueKey===_.valueKey:!1}evaluate(_){const F=_.getValue(this.valueKey),x=_.getValue(this.key);return Array.isArray(F)?F.indexOf(x)>=0:typeof x=="string"&&typeof F=="object"&&F!==null?C.call(F,x):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(_){return _.mapIn(this.key,this.valueKey)}negate(){return g.create(this)}}e.ContextKeyInExpr=o;class g{constructor(_){this._actual=_,this.type=11}static create(_){return new g(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new g(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotInExpr=g;class m{constructor(_,F){this.key=_,this.value=F,this.type=5}static create(_,F){if(typeof F=="boolean")return F?E.create(_):h.create(_);const x=S.get(_);return typeof x=="boolean"?F===(x?"true":"false")?I.INSTANCE:d.INSTANCE:new m(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return _.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(_){return _.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=m;class E{constructor(_){this.key=_,this.type=3}static create(_){const F=S.get(_);return typeof F=="boolean"?F?I.INSTANCE:d.INSTANCE:new E(_)}cmp(_){return _.type!==this.type?this.type-_.type:p(this.key,_.key)}equals(_){return _.type===this.type?this.key===_.key:!1}evaluate(_){return!_.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(_){return _.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=E;class f{constructor(_,F){this.key=_,this.value=F,this.type=12}static create(_,F){return new f(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=f;class u{constructor(_,F){this.key=_,this.value=F,this.type=13}static create(_,F){return new u(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(_){return _.mapGreaterEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=u;class b{constructor(_,F){this.key=_,this.value=F,this.type=14}static create(_,F){return new b(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmaller(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerExpr=b;class t{constructor(_,F){this.key=_,this.value=F,this.type=15}static create(_,F){return new t(_,F)}cmp(_){return _.type!==this.type?this.type-_.type:y(this.key,this.value,_.key,_.value)}equals(_){return _.type===this.type?this.key===_.key&&this.value===_.value:!1}evaluate(_){return parseFloat(_.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(_){return _.mapSmallerEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(_,F){this.key=_,this.regexp=F,this.type=7}static create(_,F){return new n(_,F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.key<_.key)return-1;if(this.key>_.key)return 1;const F=this.regexp?this.regexp.source:"",x=_.regexp?_.regexp.source:"";return F<x?-1:F>x?1:0}equals(_){if(_.type===this.type){const F=this.regexp?this.regexp.source:"",x=_.regexp?_.regexp.source:"";return this.key===_.key&&F===x}return!1}evaluate(_){let F=_.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const _=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${_}`}keys(){return[this.key]}map(_){return _.mapRegex(this.key,this.regexp)}negate(){return l.create(this)}}e.ContextKeyRegexExpr=n;class l{constructor(_){this._actual=_,this.type=8}static create(_){return new l(_)}cmp(_){return _.type!==this.type?this.type-_.type:this._actual.cmp(_._actual)}equals(_){return _.type===this.type?this._actual.equals(_._actual):!1}evaluate(_){return!this._actual.evaluate(_)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(_){return new l(this._actual.map(_))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=l;class a{constructor(_){this.expr=_,this.type=6}static create(_){return a._normalizeArr(_)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const Y=i(this.expr[F],_.expr[F]);if(Y!==0)return Y}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].evaluate(_))return!1;return!0}static _normalizeArr(_){const F=[];let x=!1;for(const Y of _)if(!!Y){if(Y.type===1){x=!0;continue}if(Y.type===0)return I.INSTANCE;if(Y.type===6){F.push(...Y.expr);continue}F.push(Y)}if(F.length===0&&x)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const Y=F[F.length-1];if(Y.type!==9)break;F.pop();const me=F.pop(),j=s.create(Y.expr.map(z=>a.create([z,me])));j&&(F.push(j),F.sort(i))}return F.length===1?F[0]:new a(F)}}serialize(){return this.expr.map(_=>_.serialize()).join(" && ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new a(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let F of this.expr)_.push(F.negate());return s.create(_)}}e.ContextKeyAndExpr=a;class s{constructor(_){this.expr=_,this.type=9}static create(_){const F=s._normalizeArr(_);if(F.length!==0)return F.length===1?F[0]:new s(F)}cmp(_){if(_.type!==this.type)return this.type-_.type;if(this.expr.length<_.expr.length)return-1;if(this.expr.length>_.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const Y=i(this.expr[F],_.expr[F]);if(Y!==0)return Y}return 0}equals(_){if(_.type===this.type){if(this.expr.length!==_.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(_.expr[F]))return!1;return!0}return!1}evaluate(_){for(let F=0,x=this.expr.length;F<x;F++)if(this.expr[F].evaluate(_))return!0;return!1}static _normalizeArr(_){let F=[],x=!1;if(_){for(let Y=0,me=_.length;Y<me;Y++){const j=_[Y];if(!!j){if(j.type===0){x=!0;continue}if(j.type===1)return[d.INSTANCE];if(j.type===9){F=F.concat(j.expr);continue}F.push(j)}}if(F.length===0&&x)return[I.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(_=>_.serialize()).join(" || ")}keys(){const _=[];for(let F of this.expr)_.push(...F.keys());return _}map(_){return new s(this.expr.map(F=>F.map(_)))}negate(){let _=[];for(let x of this.expr)_.push(x.negate());const F=x=>x.type===9?x.expr:[x];for(;_.length>1;){const x=_.shift(),Y=_.shift(),me=[];for(const j of F(x))for(const z of F(Y))me.push(k.and(j,z));_.unshift(k.or(...me))}return _[0]}}e.ContextKeyOrExpr=s;class c extends h{constructor(_,F,x){super(_);this._defaultValue=F,typeof x=="object"?c._info.push(Object.assign(Object.assign({},x),{key:_})):x!==!0&&c._info.push({key:_,description:x,type:F!=null?typeof F:void 0})}static all(){return c._info.values()}bindTo(_){return _.createKey(this.key,this._defaultValue)}getValue(_){return _.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(_){return k.equals(this.key,_)}notEqualsTo(_){return k.notEquals(this.key,_)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=(0,P.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(v,_){return v<_?-1:v>_?1:0}function y(v,_,F,x){return v<F?-1:v>F?1:_<x?-1:_>x?1:0}}),define(we[149],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,w.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,w.refineServiceDecorator)(e.IEnvironmentService)}),define(we[26],_e([0,1,8,4]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class S{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let d=typeof i=="string"?i:i.value,h=typeof I=="string"?I:I.value;return w.equalsIgnoreCase(d,h)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=S;function C(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function D(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[150],_e([0,1,8,26]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(h,r){return h.uuid&&r.uuid?h.uuid===r.uuid:h.id===r.id?!0:(0,w.compareIgnoreCase)(h.id,r.id)===0}e.areSameExtensions=A;class T{constructor(r,o){this.version=o,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?A(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function S(h,r){return`${h}.${r}`}e.getExtensionId=S;function C(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=C;function D(h,r){return C(S(h,r))}e.getGalleryExtensionId=D;function k(h,r){const o=[],g=m=>{for(const E of o)if(E.some(f=>A(r(f),r(m))))return E;return null};for(const m of h){const E=g(m);E?E.push(m):o.push([m])}return o}e.groupByExtension=k;function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(h){const r=new Set;for(const o of h)o.malicious&&r.add(o.id.id);return r}e.getMaliciousExtensionsSet=d}),define(we[64],_e([0,1,126,13,2,4,8,10,22]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(j){return j.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(j){j[j.Unknown=0]="Unknown",j[j.File=1]="File",j[j.Directory=2]="Directory",j[j.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(j){j[j.FileReadWrite=2]="FileReadWrite",j[j.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",j[j.FileReadStream=16]="FileReadStream",j[j.FileFolderCopy=8]="FileFolderCopy",j[j.PathCaseSensitive=1024]="PathCaseSensitive",j[j.Readonly=2048]="Readonly",j[j.Trash=4096]="Trash",j[j.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(j){return!!(j.capabilities&2)}e.hasReadWriteCapability=d;function h(j){return!!(j.capabilities&8)}e.hasFileFolderCopyCapability=h;function r(j){return!!(j.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function o(j){return!!(j.capabilities&16)}e.hasFileReadStreamCapability=o;var g;(function(j){j.FileExists="EntryExists",j.FileNotFound="EntryNotFound",j.FileNotADirectory="EntryNotADirectory",j.FileIsADirectory="EntryIsADirectory",j.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",j.FileTooLarge="EntryTooLarge",j.FileWriteLocked="EntryWriteLocked",j.NoPermissions="NoPermissions",j.Unavailable="Unavailable",j.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class m extends Error{constructor(z,te){super(z);this.code=te}}e.FileSystemProviderError=m;function E(j,z){const te=new m(j.toString(),z);return u(te,z),te}e.createFileSystemProviderError=E;function f(j){return j||E((0,w.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=f;function u(j,z){return j.name=z?`${z} (FileSystemError)`:"FileSystemError",j}e.markAsFileSystemProviderError=u;function b(j){if(!j)return g.Unknown;if(j instanceof m)return j.code;const z=/^(.+) \(FileSystemError\)$/.exec(j.name);if(!z)return g.Unknown;switch(z[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=b;function t(j){if(j instanceof p)return j.fileOperationResult;switch(b(j)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(j){j[j.CREATE=0]="CREATE",j[j.DELETE=1]="DELETE",j[j.MOVE=2]="MOVE",j[j.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class l{constructor(z,te,$){this.resource=z,this.operation=te,this.target=$}isOperation(z){return this.operation===z}}e.FileOperationEvent=l;var a;(function(j){j[j.UPDATED=0]="UPDATED",j[j.ADDED=1]="ADDED",j[j.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class s{constructor(z,te){this.ignorePathCasing=te,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=z;for(const $ of z)switch($.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set($.resource,$);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set($.resource,$);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set($.resource,$);break}}contains(z,...te){return this.doContains(z,{includeChildren:!1},...te)}affects(z,...te){return this.doContains(z,{includeChildren:!0},...te)}doContains(z,te,...$){var R,L,M,U,G,J;if(!z)return!1;const re=$.length>0;return!!((!re||$.includes(1))&&(((R=this.added)===null||R===void 0?void 0:R.get(z))||te.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(z)))||(!re||$.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(z))||te.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(z)))||(!re||$.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(z))||te.includeChildren&&((J=this.deleted)===null||J===void 0?void 0:J.findSuperstr(z))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(z){const te=[],$=z===1?this.added:z===0?this.updated:this.deleted;if($)for(const[,R]of $)te.push(R);return te}filter(z){return new s(this.changes.filter(te=>z(te)),this.ignorePathCasing)}}e.FileChangesEvent=s;function c(j,z,te){return!j||!z||j===z||z.length>j.length?!1:(z.charAt(z.length-1)!==P.sep&&(z+=P.sep),te?(0,S.startsWithIgnoreCase)(j,z):j.indexOf(z)===0)}e.isParent=c;class p extends Error{constructor(z,te,$){super(z);this.fileOperationResult=te,this.options=$}static isFileOperationError(z){return z instanceof Error&&!(0,C.isUndefinedOrNull)(z.fileOperationResult)}}e.FileOperationError=p;var y;(function(j){j[j.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",j[j.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",j[j.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",j[j.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",j[j.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",j[j.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",j[j.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",j[j.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",j[j.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",j[j.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",j[j.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",j[j.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(y=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var v;(function(j){j[j.FILE=0]="FILE",j[j.FOLDER=1]="FOLDER",j[j.ROOT_FOLDER=2]="ROOT_FOLDER"})(v=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(j){if(!(typeof j.size!="number"||typeof j.mtime!="number"))return j.mtime.toString(29)+j.size.toString(31)}e.etag=_;async function F(j,z){if(!z.canHandleResource(A.URI.from({scheme:j.scheme})))return new Promise(te=>{const $=z.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===j.scheme&&R.added&&($.dispose(),te())})})}e.whenProviderRegistered=F,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class x{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<x.KB?(0,w.localize)(1,null,z.toFixed(0)):z<x.MB?(0,w.localize)(2,null,(z/x.KB).toFixed(2)):z<x.GB?(0,w.localize)(3,null,(z/x.MB).toFixed(2)):z<x.TB?(0,w.localize)(4,null,(z/x.GB).toFixed(2)):(0,w.localize)(5,null,(z/x.TB).toFixed(2))}}e.ByteSize=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;var Y;(function(j){j[j.IA32=0]="IA32",j[j.OTHER=1]="OTHER"})(Y=e.Arch||(e.Arch={}));function me(j){return{maxFileSize:j===0?300*x.MB:16*x.GB,maxHeapSize:j===0?700*x.MB:2*700*x.MB}}e.getPlatformLimits=me}),define(we[65],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class w{constructor(...A){this._entries=new Map;for(let[T,S]of A)this.set(T,S)}set(A,T){const S=this._entries.get(A);return this._entries.set(A,T),S}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=w}),define(we[151],_e([0,1,12,145,89,4,65,11]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class k extends Error{constructor(r){var o;super("cyclic dependency between services");this.message=(o=r.findCycleSlow())!==null&&o!==void 0?o:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new S.ServiceCollection,o=!1,g){this._activeInstantiations=new Set,this._services=r,this._strict=o,this._parent=g,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...o){let g=d.traceInvocation(r),m=!1;try{return r({get:(f,u)=>{if(m)throw(0,w.illegalState)("service accessor is only valid during the invocation of its target method");const b=this._getOrCreateServiceInstance(f,g);if(!b&&u!==T.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return b}},...o)}finally{m=!0,g.stop()}}createInstance(r,...o){let g,m;return r instanceof A.SyncDescriptor?(g=d.traceCreation(r.ctor),m=this._createInstance(r.ctor,r.staticArguments.concat(o),g)):(g=d.traceCreation(r),m=this._createInstance(r,o,g)),g.stop(),m}_createInstance(r,o=[],g){let m=T._util.getServiceDependencies(r).sort((u,b)=>u.index-b.index),E=[];for(const u of m){let b=this._getOrCreateServiceInstance(u.id,g);if(!b&&this._strict&&!u.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${u.id}.`);E.push(b)}let f=m.length>0?m[0].index:o.length;if(o.length!==f){console.warn(`[createInstance] First service dependency of ${r.name} at position ${f+1} conflicts with ${o.length} static arguments`);let u=f-o.length;u>0?o=o.concat(new Array(u)):o=o.slice(0,f)}return new r(...[...o,...E])}_setServiceInstance(r,o){if(this._services.get(r)instanceof A.SyncDescriptor)this._services.set(r,o);else if(this._parent)this._parent._setServiceInstance(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let o=this._services.get(r);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):o}_getOrCreateServiceInstance(r,o){let g=this._getServiceInstanceOrDescriptor(r);return g instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,g,o.branch(r,!0)):(o.branch(r,!1),g)}_safeCreateAndCacheServiceInstance(r,o,g){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,o,g)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,o,g){const m=new P.Graph(u=>u.id.toString());let E=0;const f=[{id:r,desc:o,_trace:g}];for(;f.length;){const u=f.pop();if(m.lookupOrInsertNode(u),E++>1e3)throw new k(m);for(let b of T._util.getServiceDependencies(u.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(b.id);if(!t&&!b.optional&&console.warn(`[createInstance] ${r} depends on ${b.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:b.id,desc:t,_trace:u._trace.branch(b.id,!0)};m.insertEdge(u,n),f.push(n)}}}for(;;){const u=m.roots();if(u.length===0){if(!m.isEmpty())throw new k(m);break}for(const{data:b}of u){if(this._getServiceInstanceOrDescriptor(b.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this._setServiceInstance(b.id,n)}m.removeNode(b)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,o,g=[],m,E){if(this._services.get(r)instanceof A.SyncDescriptor)return this._createServiceInstance(o,g,m,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,o,g,m,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(r,o=[],g,m){if(g){const E=new C.IdleValue(()=>this._createInstance(r,o,m));return new Proxy(Object.create(null),{get(f,u){if(u in f)return f[u];let b=E.value,t=b[u];return typeof t!="function"||(t=t.bind(b),f[u]=t),t},set(f,u,b){return E.value[u]=b,!0}})}else return this._createInstance(r,o,m)}}e.InstantiationService=i;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class d{constructor(r,o){this.type=r,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return D?new d(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(r){return D?new d(0,r.name):d._None}branch(r,o){let g=new d(2,r.toString());return this._dep.push([r,o,g]),g}stop(){let r=Date.now()-this._start;d._totals+=r;let o=!1;function g(E,f){let u=[],b=new Array(E+1).join("	");for(const[t,n,l]of f._dep)if(n&&l){o=!0,u.push(`${b}CREATES -> ${t}`);let a=g(E+1,l);a&&u.push(a)}else u.push(`${b}uses -> ${t}`);return u.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(r>2||o)&&console.log(m.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(we[18],_e([0,1,4,6,21,3,60]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,w.createDecorator)("logService"),e.ILoggerService=(0,w.createDecorator)("loggerService");function C(){return new Date().toISOString()}var D;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class k extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const l=Array.prototype.slice.call(arguments);l[0]=t.stack,this.log(D.Error,this.format(l))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let l=0;l<t.length;l++){let a=t[l];if(typeof a=="object")try{a=JSON.stringify(a)}catch(s){}n+=(l>0?" ":"")+a}return n}}e.AbstractMessageLogger=i;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...n):console.log(`[main ${C()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...n):console.warn(`[main ${C()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...n):console.error(`[main ${C()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class h extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,S.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class r extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const l of this.logServices)l.trace(t,...n)}debug(t,...n){for(const l of this.logServices)l.debug(t,...n)}info(t,...n){for(const l of this.logServices)l.info(t,...n)}warn(t,...n){for(const l of this.logServices)l.warn(t,...n)}error(t,...n){for(const l of this.logServices)l.error(t,...n)}critical(t,...n){for(const l of this.logServices)l.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class o extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=o;class g extends P.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(l=>{this.logLevel=l,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(l))}))}createLogger(t,n){let l=this.loggers.get(t.toString());return l||(l=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),l),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(l)),l}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class m{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=m;function E(b){if(b.verbose)return D.Trace;if(typeof b.logLevel=="string"){const t=f(b.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function f(b){switch(b){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=f;function u(b){switch(b){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=u}),define(we[90],_e([0,1,4,127,47]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var S;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function k(r,o){return o-r}D.compare=k;const i=Object.create(null);i[D.Error]=(0,P.localize)(0,null),i[D.Warning]=(0,P.localize)(1,null),i[D.Info]=(0,P.localize)(2,null);function I(r){return i[r]||""}D.toString=I;function d(r){switch(r){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=d;function h(r){switch(r){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=h}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var C;(function(D){const k="";function i(d){return I(d,!0)}D.makeKey=i;function I(d,h){let r=[k];return d.source?r.push(d.source.replace("\xA6","\\\xA6")):r.push(k),d.code?typeof d.code=="string"?r.push(d.code.replace("\xA6","\\\xA6")):r.push(d.code.value.replace("\xA6","\\\xA6")):r.push(k),d.severity!==void 0&&d.severity!==null?r.push(S.toString(d.severity)):r.push(k),d.message&&h?r.push(d.message.replace("\xA6","\\\xA6")):r.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?r.push(d.startLineNumber.toString()):r.push(k),d.startColumn!==void 0&&d.startColumn!==null?r.push(d.startColumn.toString()):r.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?r.push(d.endLineNumber.toString()):r.push(k),d.endColumn!==void 0&&d.endColumn!==null?r.push(d.endColumn.toString()):r.push(k),r.push(k),r.join("\xA6")}D.makeKeyOptionalMessage=I})(C=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[152],_e([0,1,47,4,3]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=w.default,e.INotificationService=(0,P.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class C{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=C;class D{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=D});var Ve=this&&this.__decorate||function(Q,e,w,P){var A=arguments.length,T=A<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,w):P,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(Q,e,w,P);else for(var C=Q.length-1;C>=0;C--)(S=Q[C])&&(T=(A<3?S(T):A>3?S(e,w,T):S(e,w))||T);return A>3&&T&&Object.defineProperty(e,w,T),T},qe=this&&this.__param||function(Q,e){return function(w,P){e(w,P,Q)}};define(we[153],_e([0,1,4,20,6,11]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,w.createDecorator)("progressService");var S;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class C{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=C,C.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(I,d){super();this.deferred=new T.DeferredPromise,d.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};D=Ve([qe(1,e.IProgressService)],D),e.UnmanagedProgress=D;class k extends A.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(I){this.stop();const d=++this.currentOperationId,h=new P.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>h.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:h.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,w.createDecorator)("editorProgressService")}),define(we[29],_e([0,1,10,42]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(S,C){P.ok(w.isString(S)),P.ok(w.isObject(C)),P.ok(!this.data.has(S),"There is already an extension with this id"),this.data.set(S,C)}knows(S){return this.data.has(S)}as(S){return this.data.get(S)||null}}e.Registry=new A}),define(we[91],_e([0,1,29,3]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,k){this.schemasById[A(D)]=k,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const S=new T;w.Registry.add(e.Extensions.JSONContribution,S)}),define(we[66],_e([0,1,124,3,29,10,91]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(S.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(m,E=!0){this.registerConfigurations([m],E)}registerConfigurations(m,E=!0){const f=[];m.forEach(u=>{f.push(...this.validateAndRegisterProperties(u,E,u.extensionInfo)),this.configurationContributors.push(u),this.registerJSONConfiguration(u)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterConfigurations(m){const E=[],f=u=>{if(u.properties)for(const b in u.properties)E.push(b),delete this.configurationProperties[b],this.removeFromSchema(b,u.properties[b]);u.allOf&&u.allOf.forEach(b=>f(b))};for(const u of m){f(u);const b=this.configurationContributors.indexOf(u);b!==-1&&this.configurationContributors.splice(b,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(m){const E=[],f=[];for(const u of m)for(const b in u)if(E.push(b),e.OVERRIDE_PROPERTY_PATTERN.test(b)){this.defaultValues[b]=Object.assign(Object.assign({},this.defaultValues[b]||{}),u[b]);const t={type:"object",default:this.defaultValues[b],description:w.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId};f.push(I(b)),this.configurationProperties[b]=t,this.defaultLanguageConfigurationOverridesNode.properties[b]=t}else{this.defaultValues[b]=u[b];const t=this.configurationProperties[b];t&&(this.updatePropertyDefaultValue(b,t),this.updateSchema(b,t))}this.registerOverrideIdentifiers(f),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(m){const E=[];for(const f of m)for(const u in f)if(E.push(u),delete this.defaultValues[u],e.OVERRIDE_PROPERTY_PATTERN.test(u))delete this.configurationProperties[u],delete this.defaultLanguageConfigurationOverridesNode.properties[u];else{const b=this.configurationProperties[u];b&&(this.updatePropertyDefaultValue(u,b),this.updateSchema(u,b))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...m){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(m){for(const E of m)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(m,E=!0,f,u=3){var b;u=T.isUndefinedOrNull(m.scope)?u:m.scope;let t=[],n=m.properties;if(n)for(let a in n){if(E&&r(a)){delete n[a];continue}const s=n[a];if(this.updatePropertyDefaultValue(a,s),e.OVERRIDE_PROPERTY_PATTERN.test(a)?s.scope=void 0:(s.scope=T.isUndefinedOrNull(s.scope)?u:s.scope,s.restricted=T.isUndefinedOrNull(s.restricted)?!!((b=f==null?void 0:f.restrictedConfigurations)===null||b===void 0?void 0:b.includes(a)):s.restricted),n[a].hasOwnProperty("included")&&!n[a].included){this.excludedConfigurationProperties[a]=n[a],delete n[a];continue}else this.configurationProperties[a]=n[a];!n[a].deprecationMessage&&n[a].markdownDeprecationMessage&&(n[a].deprecationMessage=n[a].markdownDeprecationMessage),t.push(a)}let l=m.allOf;if(l)for(let a of l)t.push(...this.validateAndRegisterProperties(a,E,f,u));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(m){const E=f=>{let u=f.properties;if(u)for(const t in u)this.updateSchema(t,u[t]);let b=f.allOf;b&&b.forEach(E)};E(m)}updateSchema(m,E){switch(e.allSettings.properties[m]=E,E.scope){case 1:e.applicationSettings.properties[m]=E;break;case 2:e.machineSettings.properties[m]=E;break;case 6:e.machineOverridableSettings.properties[m]=E;break;case 3:e.windowSettings.properties[m]=E;break;case 4:e.resourceSettings.properties[m]=E;break;case 5:e.resourceSettings.properties[m]=E,this.resourceLanguageSettingsSchema.properties[m]=E;break}}removeFromSchema(m,E){switch(delete e.allSettings.properties[m],E.scope){case 1:delete e.applicationSettings.properties[m];break;case 2:delete e.machineSettings.properties[m];break;case 6:delete e.machineOverridableSettings.properties[m];break;case 3:delete e.windowSettings.properties[m];break;case 4:case 5:delete e.resourceSettings.properties[m];break}}updateOverridePropertyPatternKey(){for(const m of this.overrideIdentifiers.values()){const E=`[${m}]`,f={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,f),e.allSettings.properties[E]=f,e.applicationSettings.properties[E]=f,e.machineSettings.properties[E]=f,e.machineOverridableSettings.properties[E]=f,e.windowSettings.properties[E]=f,e.resourceSettings.properties[E]=f}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(m,E){let f=this.defaultValues[m];T.isUndefined(f)&&(f=E.default),T.isUndefined(f)&&(f=d(E.type)),E.default=f}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(g){return g.substring(1,g.length-1)}e.overrideIdentifierFromKey=I;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new k;A.Registry.add(e.Extensions.Configuration,h);function r(g){return g.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(g)?w.localize(5,null,g):h.getConfigurationProperties()[g]!==void 0?w.localize(6,null,g):null:w.localize(4,null)}e.validateProperty=r;function o(){const g=[],m=h.getConfigurationProperties();for(const E of Object.keys(m))g.push([E,m[E].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=o}),define(we[92],_e([0,1,23,10,2,29,4,66]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,S.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=D;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,l){const a=l?n?l.keys.filter(F=>n.keys.indexOf(F)===-1):[...l.keys]:[],s=n?l?n.keys.filter(F=>l.keys.indexOf(F)===-1):[...n.keys]:[],c=[];if(l&&n){for(const F of n.keys)if(l.keys.indexOf(F)!==-1){const x=m(n.contents,F),Y=m(l.contents,F);w.equals(x,Y)||c.push(F)}}const p=[],y=F=>{const x={};for(const Y of F)for(const me of Y.identifiers)x[b(me)]=Y;return x},v=l?y(l.overrides):{},_=n?y(n.overrides):{};if(Object.keys(v).length)for(const F of a){const x=v[F];x&&p.push([(0,C.overrideIdentifierFromKey)(F),x.keys])}if(Object.keys(_).length)for(const F of s){const x=_[F];x&&p.push([(0,C.overrideIdentifierFromKey)(F),x.keys])}if(Object.keys(v).length&&Object.keys(_).length)for(const F of c){const x=_[F],Y=v[F];if(x&&Y){const me=I({contents:x.contents,keys:x.keys,overrides:[]},{contents:Y.contents,keys:Y.keys,overrides:[]});p.push([(0,C.overrideIdentifierFromKey)(F),[...me.added,...me.removed,...me.updated]])}}return{added:a,removed:s,updated:c,overrides:p}}e.compare=I;function d(n,l){const a=[];for(const s of Object.keys(n))if(C.OVERRIDE_PROPERTY_PATTERN.test(s)){const c={};for(const p in n[s])c[p]=n[s][p];a.push({identifiers:[(0,C.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(c),contents:h(c,l)})}return a}e.toOverrides=d;function h(n,l){const a=Object.create(null);for(let s in n)r(a,s,n[s],l);return a}e.toValuesTree=h;function r(n,l,a,s){const c=l.split("."),p=c.pop();let y=n;for(let v=0;v<c.length;v++){let _=c[v],F=y[_];switch(typeof F){case"undefined":F=y[_]=Object.create(null);break;case"object":break;default:s(`Ignoring ${l} as ${c.slice(0,v+1).join(".")} is ${JSON.stringify(F)}`);return}y=F}if(typeof y=="object"&&y!==null)try{y[p]=a}catch(v){s(`Ignoring ${l} as ${c.join(".")} is ${JSON.stringify(y)}`)}else s(`Ignoring ${l} as ${c.join(".")} is ${JSON.stringify(y)}`)}e.addToValueTree=r;function o(n,l){const a=l.split(".");g(n,a)}e.removeFromValueTree=o;function g(n,l){const a=l.shift();if(l.length===0){delete n[a];return}if(Object.keys(n).indexOf(a)!==-1){const s=n[a];typeof s=="object"&&!Array.isArray(s)&&(g(s,l),Object.keys(s).length===0&&delete n[a])}}function m(n,l,a){function s(y,v){let _=y;for(const F of v){if(typeof _!="object"||_===null)return;_=_[F]}return _}const c=l.split("."),p=s(n,c);return typeof p=="undefined"?a:p}e.getConfigurationValue=m;function E(n,l,a){Object.keys(l).forEach(s=>{s!=="__proto__"&&(s in n?P.isObject(n[s])&&P.isObject(l[s])?E(n[s],l[s],a):a&&(n[s]=l[s]):n[s]=l[s])})}e.merge=E;function f(){const n=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=f;function u(){const n=Object.create(null),l=T.Registry.as(C.Extensions.Configuration).getConfigurationProperties();for(let a in l){let s=l[a].default;r(n,a,s,c=>console.error(`Conflict in default settings: ${c}`))}return n}e.getDefaultValues=u;function b(n){return`[${n}]`}e.keyFromOverrideIdentifier=b;function t(n,l,a){const s=n.inspect(l),c=n.inspect(a);return typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:s.defaultValue}e.getMigratedSettingValue=t}),define(we[154],_e([0,1,44,22,15,10,23,2,66,92,29,6,3]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},n=[],l=[]){this._contents=t,this._keys=n,this._overrides=l,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const l=this.getContentsForOverrideIdentifer(n);return l?t?(0,k.getConfigurationValue)(l,t):l:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let l={};for(const a of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let s=this.contents[a],c=n[a];c&&(typeof s=="object"&&typeof c=="object"?(s=S.deepClone(s),this.mergeContents(s,c)):s=c),l[a]=s}return new h(l,this.keys,this.overrides)}merge(...t){const n=S.deepClone(this.contents),l=S.deepClone(this.overrides),a=[...this.keys];for(const s of t){this.mergeContents(n,s.contents);for(const c of s.overrides){const[p]=l.filter(y=>A.equals(y.identifiers,c.identifiers));p?this.mergeContents(p.contents,c.contents):l.push(S.deepClone(c))}for(const c of s.keys)a.indexOf(c)===-1&&a.push(c)}return new h(n,a,l)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const l of Object.keys(n)){if(l in t&&T.isObject(t[l])&&T.isObject(n[l])){this.mergeContents(t[l],n[l]);continue}t[l]=S.deepClone(n[l])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?S.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,l=>{throw new Error(l)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let l=0;l<n;l++)t.indexOf(this.keys[l])===0&&(n=l);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=h;class r extends h{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),l=[];for(const a of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(a)&&l.push({identifiers:[(0,D.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,k.toValuesTree)(t[a],s=>console.error(`Conflict in default settings file: ${s}`))});super(t,n,l)}}e.DefaultConfigurationModel=r;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const l=this.doParseContent(t);this.parseRaw(l,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:l,keys:a,overrides:s,restricted:c}=this.doParseRaw(t,n);this._configurationModel=new h(l,a,s),this._restrictedConfigurations=c||[]}doParseContent(t){let n={},l=null,a=[],s=[],c=[];function p(v){Array.isArray(a)?a.push(v):l&&(a[l]=v)}let y={onObjectBegin:()=>{let v={};p(v),s.push(a),a=v,l=null},onObjectProperty:v=>{l=v},onObjectEnd:()=>{a=s.pop()},onArrayBegin:()=>{let v=[];p(v),s.push(a),a=v,l=null},onArrayEnd:()=>{a=s.pop()},onLiteralValue:p,onError:(v,_,F)=>{c.push({error:v,offset:_,length:F})}};if(t)try{w.visit(t,y),n=a[0]||{}}catch(v){console.error(`Error while parsing settings file ${this._name}: ${v}`),this._parseErrors=[v]}return n}doParseRaw(t,n){const l=i.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,l,!0,n);t=a.raw;const s=(0,k.toValuesTree)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),c=Object.keys(t),p=(0,k.toOverrides)(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:s,keys:c,overrides:p,restricted:a.restricted}}filter(t,n,l,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const s={},c=[];for(let p in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(p)&&l){const y=this.filter(t[p],n,!1,a);s[p]=y.raw,c.push(...y.restricted)}else{const y=n[p],v=y?typeof y.scope!="undefined"?y.scope:3:void 0;(y==null?void 0:y.restricted)&&c.push(p),(v===void 0||a.scopes===void 0||a.scopes.includes(v))&&(a.skipRestricted&&(y==null?void 0:y.restricted)||(s[p]=t[p]))}return{raw:s,restricted:c}}}e.ConfigurationModelParser=o;class g extends I.Disposable{constructor(t,n,l,a){super();this.userSettingsResource=t,this.scopes=n,this.fileService=a,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(l.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,s=>s.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=g;class m{constructor(t,n,l=new h,a=new h,s=new P.ResourceMap,c=new h,p=new P.ResourceMap,y=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=s,this._memoryConfiguration=c,this._memoryConfigurationByResource=p,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,n,l){return this.getConsolidateConfigurationModel(n,l).getValue(t)}updateValue(t,n,l={}){let a;l.resource?(a=this._memoryConfigurationByResource.get(l.resource),a||(a=new h,this._memoryConfigurationByResource.set(l.resource,a))):a=this._memoryConfiguration,n===void 0?a.removeValue(t):a.setValue(t,n),l.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,l){const a=this.getConsolidateConfigurationModel(n,l),s=this.getFolderConfigurationModelForResource(n.resource,l),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),y=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),_=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=l?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,x=s?n.overrideIdentifier?s.freeze().override(n.overrideIdentifier).getValue(t):s.freeze().getValue(t):void 0,Y=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(t):c.getValue(t),me=a.getValue(t),j=A.distinct(A.flatten(a.overrides.map(z=>z.identifiers))).filter(z=>a.getOverrideValue(t,z)!==void 0);return{defaultValue:p,userValue:y,userLocalValue:v,userRemoteValue:_,workspaceValue:F,workspaceFolderValue:x,memoryValue:Y,value:me,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:v!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:x!==void 0?{value:s==null?void 0:s.freeze().getValue(t),override:n.overrideIdentifier?s==null?void 0:s.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:Y!==void 0?{value:c.getValue(t),override:n.overrideIdentifier?c.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:j.length?j:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const l=n.filter(a=>D.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const s=(0,D.overrideIdentifierFromKey)(a),c=this._defaultConfiguration.getKeysForOverrideIdentifier(s),p=t.getKeysForOverrideIdentifier(s),y=[...p.filter(v=>c.indexOf(v)===-1),...c.filter(v=>p.indexOf(v)===-1),...c.filter(v=>!S.equals(this._defaultConfiguration.override(s).getValue(v),t.override(s).getValue(v)))];return[s,y]});return this.updateDefaultConfiguration(t),{keys:n,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,k.compare)(this.localUserConfiguration,t),c=[...n,...l,...a];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,k.compare)(this.remoteUserConfiguration,t);let c=[...n,...l,...a];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:s}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:l,removed:a,overrides:s}=(0,k.compare)(this.workspaceConfiguration,t);let c=[...n,...l,...a];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:s}}compareAndUpdateFolderConfiguration(t,n){const l=this.folderConfigurations.get(t),{added:a,updated:s,removed:c,overrides:p}=(0,k.compare)(l,n);let y=[...a,...s,...c];return(y.length||!l)&&this.updateFolderConfiguration(t,n),{keys:y,overrides:p}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:l,updated:a,removed:s,overrides:c}=(0,k.compare)(n,void 0);return{keys:[...l,...a,...s],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let l=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?l.override(t.overrideIdentifier):l}getConsolidatedConfigurationModelForResource({resource:t},n){let l=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const a=n.getFolder(t);a&&(l=this.getFolderConsolidatedConfiguration(a.uri)||l);const s=this._memoryConfigurationByResource.get(t);s&&(l=l.merge(s))}return l}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const l=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(n=l.merge(a),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=l}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const l=n.getFolder(t);if(l)return this._folderConfigurations.get(l.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:l,overrides:a,keys:s}=this._folderConfigurations.get(n);return t.push([n,{contents:l,overrides:a,keys:s}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(l=>t.add(l))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(l=>n.add(l)),this._folderConfigurations.forEach(l=>l.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),l=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),s=t.folders.reduce((c,p)=>(c.set(C.URI.revive(p[0]),this.parseConfigurationModel(p[1])),c),new P.ResourceMap);return new m(n,l,new h,a,s,new h,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=m;function E(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const t=new Set,n=new Map;for(const a of b)a.keys.forEach(s=>t.add(s)),a.overrides.forEach(([s,c])=>{const p=(0,P.getOrSet)(n,s,new Set);c.forEach(y=>p.add(y))});const l=[];return n.forEach((a,s)=>l.push([s,[...a.values()]])),{keys:[...t.values()],overrides:l}}e.mergeChanges=E;class f{constructor(t,n,l,a){this.change=t,this.previous=n,this.currentConfiguraiton=l,this.currentWorkspace=a,this._previousConfiguration=void 0;const s=new Set;t.keys.forEach(p=>s.add(p)),t.overrides.forEach(([,p])=>p.forEach(y=>s.add(y))),this.affectedKeys=[...s.values()];const c=new h;this.affectedKeys.forEach(p=>c.setValue(p,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var l;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(l=this.previous)===null||l===void 0?void 0:l.workspace):void 0,s=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!S.equals(a,s)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let l=(0,k.toValuesTree)({[n]:!0},()=>{}),a;for(;typeof l=="object"&&(a=Object.keys(l)[0]);){if(t=t[a],!t)return!1;l=l[a]}return!0}}e.ConfigurationChangeEvent=f;class u extends f{constructor(t,n,l,a){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=l,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=u}),define(we[67],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,w.createDecorator)("remoteAuthorityResolverService");var P;(function(S){S[S.Unknown=0]="Unknown",S[S.DisableTrust=1]="DisableTrust",S[S.MachineTrusted=2]="MachineTrusted"})(P=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(C,D=A.Unknown,k){super(C);this._message=C,this._code=D,this._detail=k,this.isHandled=D===A.NotAvailable&&k===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===A.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===A.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(we[93],_e([0,1,19]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function P(D){return D.scheme===w.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=P;function A(D){if(!!D){const k=D.indexOf("+");return k<0?D:D.substr(0,k)}}e.getRemoteName=A;function T(D){return D.scheme!==w.Schemas.file&&D.scheme!==w.Schemas.vscodeRemote}function S(D){if(D.folders.length)return D.folders.every(k=>T(k.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=S;function C(D){var k;return(k=S(D))===null||k===void 0?void 0:k.scheme}e.getVirtualWorkspaceScheme=C}),define(we[155],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class w{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,S=5){let C;return C=T(D=>{const k=typeof D=="string"?D:D.data;let i=this._terminalBufferMap.get(A);if(i){i.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(A),S);i={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(A),C.dispose()}},this._terminalBufferMap.set(A,i)}),C}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=w}),define(we[156],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var w;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(w=e.ColorScheme||(e.ColorScheme={}))}),define(we[157],_e([0,1,4,6,29,3,156,36]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,w.createDecorator)("themeService");var D;(function(g){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}g.isThemeColor=m})(D=e.ThemeColor||(e.ThemeColor={}));function k(g){return{id:g}}e.themeColorFromId=k;var i;(function(g){function m(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}g.isThemeIcon=m;const E=new RegExp(`^\\$\\((${C.CSSIcon.iconNameExpression}(?:${C.CSSIcon.iconModifierExpression})?)\\)$`);function f(t){const n=E.exec(t);if(!!n){let[,l]=n;return{id:l}}}g.fromString=f;function u(t,n){let l=t.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),n&&(l=`${l}~${n}`),{id:l}}g.modify=u;function b(t,n){var l,a;return t.id===n.id&&((l=t.color)===null||l===void 0?void 0:l.id)===((a=n.color)===null||a===void 0?void 0:a.id)}g.isEqual=b,g.asClassNameArray=C.CSSIcon.asClassNameArray,g.asClassName=C.CSSIcon.asClassName,g.asCSSSelector=C.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=C.Codicon.file,e.FolderThemeIcon=C.Codicon.folder;function I(g){switch(g){case S.ColorScheme.DARK:return"vs-dark";case S.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,P.toDisposable)(()=>{const E=this.themingParticipants.indexOf(m);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let h=new d;A.Registry.add(e.Extensions.ThemingContribution,h);function r(g){return h.onColorThemeChange(g)}e.registerThemingParticipant=r;class o extends P.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,E){let f=this.theme.getColor(m);return f&&E&&(f=E(f,this.theme)),f?f.toString():null}}e.Themable=o}),define(we[158],_e([0,1,29,157,3,128,91,11,36]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(m,E,f,u){const b=this.iconsById[m];if(b){if(f&&!b.description){b.description=f,this.iconSchema.properties[m].markdownDescription=`${f} $(${m})`;const l=this.iconReferenceSchema.enum.indexOf(m);l!==-1&&(this.iconReferenceSchema.enumDescriptions[l]=f),this._onDidChange.fire()}return b}let t={id:m,description:f,defaults:E,deprecationMessage:u};this.iconsById[m]=t;let n={$ref:"#/definitions/icons"};return u&&(n.deprecationMessage=u),f&&(n.markdownDescription=`${f}: $(${m})`),this.iconSchema.properties[m]=n,this.iconReferenceSchema.enum.push(m),this.iconReferenceSchema.enumDescriptions.push(f||""),this._onDidChange.fire(),{id:m}}deregisterIcon(m){delete this.iconsById[m],delete this.iconSchema.properties[m];const E=this.iconReferenceSchema.enum.indexOf(m);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(m=>this.iconsById[m])}getIcon(m){return this.iconsById[m]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(m,E){const f=this.iconFontsById[m];if(f)return f;let u={id:m,definition:E};return this.iconFontsById[m]=u,this._onDidChange.fire(),u}deregisterIconFont(m){delete this.iconFontsById[m]}getIconFonts(){return Object.keys(this.iconFontsById).map(m=>this.iconFontsById[m])}getIconFont(m){return this.iconFontsById[m]}toString(){const m=(b,t)=>b.id.localeCompare(t.id),E=b=>{for(;P.ThemeIcon.isThemeIcon(b.defaults);)b=this.iconsById[b.defaults.id];return`codicon codicon-${b?b.id:""}`};let f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.iconsById).map(b=>this.iconsById[b]);for(const b of u.filter(t=>!!t.description).sort(m))f.push(`|<i class="${E(b)}"></i>|${b.id}|${P.ThemeIcon.isThemeIcon(b.defaults)?b.defaults.id:b.id}|${b.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const b of u.filter(t=>!P.ThemeIcon.isThemeIcon(t.defaults)).sort(m))f.push(`|<i class="${E(b)}"></i>|${b.id}|`);return f.join(`
`)}}const i=new k;w.Registry.add(e.Extensions.IconContribution,i);function I(g,m,E,f){return i.registerIcon(g,m,E,f)}e.registerIcon=I;function d(){return i}e.getIconRegistry=d;function h(){for(const g of D.iconRegistry.all)i.registerIcon(g.id,g.definition,g.description);D.iconRegistry.onDidRegister(g=>i.registerIcon(g.id,g.definition,g.description))}h(),e.iconsSchemaId="vscode://schemas/icons";let r=w.Registry.as(S.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const o=new C.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=I("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=P.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(we[48],_e([0,1,2,25,4,22]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S=e.WorkbenchState||(e.WorkbenchState={}));function C(d){const h=d;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=C;function D(d){const h=d;return!!(h&&typeof h=="object"&&w.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=D;class k{constructor(h,r,o,g){this._id=h,this._configuration=o,this._ignorePathCasing=g,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(h,r){this.raw=r,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,P.joinPath)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(d){return new i({uri:d,index:0,name:(0,P.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=I}),define(we[159],_e([0,1,4,129,48,2,21,13,25,107,44,19,58,37,93]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,P.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function g(te){return(typeof te=="string"?(0,C.extname)(te):(0,D.extname)(te))===o}e.hasWorkspaceFileExtension=g,e.IWorkspacesService=(0,w.createDecorator)("workspacesService");function m(te){return te.hasOwnProperty("workspace")}e.isRecentWorkspace=m;function E(te){return te.hasOwnProperty("folderUri")}e.isRecentFolder=E;function f(te){return te.hasOwnProperty("fileUri")}e.isRecentFile=f;function u(te){const $=te;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.uri)}e.isSingleFolderWorkspaceIdentifier=u;function b(te){if(te.configuration)return{id:te.id,configPath:te.configuration};if(te.folders.length===1)return{id:te.id,uri:te.folders[0].uri}}e.toWorkspaceIdentifier=b;function t(te){const $=te;return typeof($==null?void 0:$.id)=="string"&&T.URI.isUri($.configPath)}e.isWorkspaceIdentifier=t;function n(te){const $=te;if($==null?void 0:$.uri)return{id:$.id,uri:T.URI.revive($.uri)};const R=te;if(R==null?void 0:R.configPath)return{id:R.id,configPath:T.URI.revive(R.configPath)};if(te==null?void 0:te.id)return{id:te.id}}e.reviveIdentifier=n;function l(te,$){return D.extUriBiasedIgnorePathCase.isEqualOrParent(te,$.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function a(te){return s(te)||c(te)}e.isStoredWorkspaceFolder=a;function s(te){const $=te;return typeof($==null?void 0:$.path)=="string"&&(!$.name||typeof $.name=="string")}e.isRawFileWorkspaceFolder=s;function c(te){const $=te;return typeof($==null?void 0:$.uri)=="string"&&(!$.name||typeof $.name=="string")}e.isRawUriWorkspaceFolder=c;function p(te,$,R,L,M=!S.isWindows,U){if(te.scheme!==L.scheme)return{name:R,uri:te.toString(!0)};let G=$?void 0:U.relativePath(L,te);if(G!==void 0)G.length===0?G=".":S.isWindows&&te.scheme===I.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(te.scheme===I.Schemas.file)G=te.fsPath,S.isWindows&&(G=(0,d.normalizeDriveLetter)(G),M&&(G=(0,h.toSlashes)(G)));else{if(!U.isEqualAuthority(te.authority,L.authority))return{name:R,uri:te.toString(!0)};G=te.path}return{name:R,path:G}}e.getStoredWorkspaceFolder=p;function y(te,$,R){let L=[],M=new Set;const U=R.dirname($);for(let G of te){let J;if(s(G))G.path&&(J=R.resolvePath(U,G.path));else if(c(G))try{J=T.URI.parse(G.uri),J.path[0]!=="/"&&(J=J.with({path:"/"+J.path}))}catch(re){console.warn(re)}if(J){let re=R.getComparisonKey(J);if(!M.has(re)){M.add(re);const pe=G.name||R.basenameOrAuthority(J);L.push(new A.WorkspaceFolder({uri:J,name:pe,index:L.length},G))}}}return L}e.toWorkspaceFolders=y;function v(te,$,R,L,M){let U=_($,te);const G=M.dirname($),J=M.dirname(L),re=[],pe=F(U.folders);for(const We of U.folders){const B=s(We)?M.resolvePath(G,We.path):T.URI.parse(We.uri);let q;R?q=!1:q=!s(We)||(0,C.isAbsolute)(We.path),re.push(p(B,q,We.name,J,pe,M))}const Te={insertSpaces:!1,tabSize:4,eol:S.isLinux||S.isMacintosh?`
`:`\r
`},xe=k.setProperty(te,["folders"],re,Te);let Ae=k.applyEdits(te,xe);return U.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Ae=k.applyEdits(Ae,k.removeProperty(Ae,["remoteAuthority"],Te))),Ae}e.rewriteWorkspaceFileForNewLocation=v;function _(te,$){let R=i.parse($);if(R&&Array.isArray(R.folders))R.folders=R.folders.filter(L=>a(L));else throw new Error(`${te} looks like an invalid workspace file.`);return R}function F(te){return S.isWindows?te.some($=>s($)&&$.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function x(te){return te.workspace&&typeof te.workspace=="object"&&typeof te.workspace.id=="string"&&typeof te.workspace.configPath=="string"}function Y(te){return typeof te.folderUri=="string"}function me(te){return typeof te.fileUri=="string"}function j(te,$){const R={workspaces:[],files:[]};if(te){const L=function(U,G){for(let J=0;J<U.length;J++)try{G(U[J],J)}catch(re){$.warn(`Error restoring recent entry ${JSON.stringify(U[J])}: ${re.toString()}. Skip entry.`)}},M=te;if(Array.isArray(M.entries))L(M.entries,U=>{const G=U.label,J=U.remoteAuthority;x(U)?R.workspaces.push({label:G,remoteAuthority:J,workspace:{id:U.workspace.id,configPath:T.URI.parse(U.workspace.configPath)}}):Y(U)?R.workspaces.push({label:G,remoteAuthority:J,folderUri:T.URI.parse(U.folderUri)}):me(U)&&R.files.push({label:G,remoteAuthority:J,fileUri:T.URI.parse(U.fileUri)})});else{const U=te;Array.isArray(U.workspaces3)&&L(U.workspaces3,(G,J)=>{const re=Array.isArray(U.workspaceLabels)&&U.workspaceLabels[J]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?R.workspaces.push({label:re,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&R.workspaces.push({label:re,folderUri:T.URI.parse(G)})}),Array.isArray(U.files2)&&L(U.files2,(G,J)=>{const re=Array.isArray(U.fileLabels)&&U.fileLabels[J]||void 0;typeof G=="string"&&R.files.push({label:re,fileUri:T.URI.parse(G)})})}}return R}e.restoreRecentlyOpened=j;function z(te){const $={entries:[]};for(const R of te.workspaces)E(R)?$.entries.push({folderUri:R.folderUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority}):$.entries.push({workspace:{id:R.workspace.id,configPath:R.workspace.configPath.toString()},label:R.label,remoteAuthority:R.remoteAuthority});for(const R of te.files)$.entries.push({fileUri:R.fileUri.toString(),label:R.label,remoteAuthority:R.remoteAuthority});return $}e.toStoreData=z}),define(we[68],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class w{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!w.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=w,w.enableDebugLogging=!1}),define(we[160],_e([0,1,2,3]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new P.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(C=>({name:C.name,group:C.group,resource:w.URI.revive(C.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(we[49],_e([0,1,19,4]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(w.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(S,C){C===null?this._providerInfo.delete(S):this._providerInfo.set(S,C)}isFreeScheme(S){return!this._providerInfo.has(S)&&!this._systemSchemes.has(S)}getCapabilities(S){return this._providerInfo.get(S)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,P.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,w.createDecorator)("IExtHostInitDataService")}),define(we[161],_e([0,1,11]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(S,C,D){this._deferredPromises=new Map,this._id=S,this._shared=C,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new w.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const I of k.values())I.error(i)}})()},0)}get whenReady(){return this._init}get(S,C){let D=this._value[S];return typeof D=="undefined"&&(D=C),D}update(S,C){this._value[S]=C;let D=this._deferredPromises.get(S);if(D!==void 0)return D.p;const k=new w.DeferredPromise;return this._deferredPromises.set(S,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=P;class A extends P{constructor(S,C){super(S.identifier.value,!0,C);this._extension=S}setKeysForSync(S){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},S)}}e.ExtensionGlobalMemento=A}),define(we[14],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,w.createDecorator)("IExtHostRpcService");class P{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=P});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[162],_e([0,1,26,3]),function(Q,e,w,P){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(C,D){A.set(this,void 0),this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._id=w.ExtensionIdentifier.toKey(C.identifier),tt(this,A,D,"f"),Me(this,A,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(C){return Me(this,A,"f").get(this._id,C)}store(C,D){return Me(this,A,"f").store(this._id,C,D)}delete(C){return Me(this,A,"f").delete(this._id,C)}}e.ExtensionSecrets=T,A=new WeakMap}),define(we[94],_e([0,1,4,3]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new P.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(S){this._enabled=S}$onDidChangeTelemetryEnabled(S){this._enabled=S,this._onDidChangeTelemetryEnabled.fire(S)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,w.createDecorator)("IExtHostTelemetry")}),define(we[69],_e([0,1,3]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var P;(function(S){S[S.NewChild=0]="NewChild",S[S.Disposed=1]="Disposed",S[S.Invalidated=2]="Invalidated",S[S.SetProp=3]="SetProp"})(P=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=S=>{let C=A.get(S);return C||(C={children:new Map,bus:new w.Emitter},A.set(S,C)),C};e.getPrivateApiFor=T}),define(we[70],_e([0,1,4,3,14]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(C){function D(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}C.fromApiTunnel=D;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}C.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,w.createDecorator)("IExtHostTunnelService");let S=class{constructor(D){this.onDidChangeTunnels=new P.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,k){return{dispose:()=>{}}}async $providePortAttributes(D,k,i,I,d){return[]}async $forwardPort(D,k){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};S=Ve([qe(0,A.IExtHostRpcService)],S),e.ExtHostTunnelService=S});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var w={};for(var P in Q)Object.prototype.hasOwnProperty.call(Q,P)&&e.indexOf(P)<0&&(w[P]=Q[P]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(Q);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,P[A])&&(w[P[A]]=Q[P[A]]);return w};define(we[7],_e([0,1,15,12,83,22,8,10,2,31,64,67,69]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d){"use strict";var h,r,o,g,m,E,f,u,b,t,n,l,a,s,c,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function y(N){function O(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(O,N),Object.setPrototypeOf(O.prototype,N.prototype),O}let v=o=class{constructor(O){h.set(this,void 0),tt(this,h,O,"f")}static from(...O){let se=O;return new o(function(){if(se){for(const De of se)De&&typeof De.dispose=="function"&&De.dispose();se=void 0}})}dispose(){typeof Me(this,h,"f")=="function"&&(Me(this,h,"f").call(this),tt(this,h,void 0,"f"))}};h=new WeakMap,v=o=Ve([y],v),e.Disposable=v;let _=g=class{constructor(O,se){if(O<0)throw(0,P.illegalArgument)("line must be non-negative");if(se<0)throw(0,P.illegalArgument)("character must be non-negative");this._line=O,this._character=se}static Min(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let De=1;De<O.length;De++){const Ke=O[De];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(O){if(!O)return!1;if(O instanceof g)return!0;let{line:se,character:De}=O;return typeof se=="number"&&typeof De=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,se=0){if(O===null||se===null)throw(0,P.illegalArgument)();let De;return typeof O=="undefined"?De=0:typeof O=="number"?De=O:(De=typeof O.lineDelta=="number"?O.lineDelta:0,se=typeof O.characterDelta=="number"?O.characterDelta:0),De===0&&se===0?this:new g(this.line+De,this.character+se)}with(O,se=this.character){if(O===null||se===null)throw(0,P.illegalArgument)();let De;return typeof O=="undefined"?De=this.line:typeof O=="number"?De=O:(De=typeof O.line=="number"?O.line:this.line,se=typeof O.character=="number"?O.character:this.character),De===this.line&&se===this.character?this:new g(De,se)}toJSON(){return{line:this.line,character:this.character}}};_=g=Ve([y],_),e.Position=_;let F=m=class{constructor(O,se,De,Ke){let et,st;if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new _(O,se),st=new _(De,Ke)):O instanceof _&&se instanceof _&&(et=O,st=se),!et||!st)throw new Error("Invalid arguments");et.isBefore(st)?(this._start=et,this._end=st):(this._start=st,this._end=et)}static isRange(O){return O instanceof m?!0:O?_.isPosition(O.start)&&_.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof m?this.contains(O._start)&&this.contains(O._end):O instanceof _?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const se=_.Max(O.start,this._start),De=_.Min(O.end,this._end);if(!se.isAfter(De))return new m(se,De)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const se=_.Min(O.start,this._start),De=_.Max(O.end,this.end);return new m(se,De)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,se=this.end){if(O===null||se===null)throw(0,P.illegalArgument)();let De;return O?_.isPosition(O)?De=O:(De=O.start||this.start,se=O.end||this.end):De=this.start,De.isEqual(this._start)&&se.isEqual(this.end)?this:new m(De,se)}toJSON(){return[this.start,this.end]}};F=m=Ve([y],F),e.Range=F;let x=E=class extends F{constructor(O,se,De,Ke){let et,st;if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"?(et=new _(O,se),st=new _(De,Ke)):O instanceof _&&se instanceof _&&(et=O,st=se),!et||!st)throw new Error("Invalid arguments");super(et,st);this._anchor=et,this._active=st}static isSelection(O){return O instanceof E?!0:O?F.isRange(O)&&_.isPosition(O.anchor)&&_.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};x=E=Ve([y],x),e.Selection=x;class Y{constructor(O,se,De){if(typeof O!="string"||O.length===0)throw(0,P.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,P.illegalArgument)("port");if(typeof De!="undefined"&&(typeof De!="string"||De.length===0||!/^[0-9A-Za-z\-]+$/.test(De)))throw(0,P.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(se),this.connectionToken=De}}e.ResolvedAuthority=Y;class me extends Error{constructor(O,se=I.RemoteAuthorityResolverErrorCode.Unknown,De){super(O);this._message=O,this._code=se,this._detail=De,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,me.prototype)}static NotAvailable(O,se){return new me(O,I.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(O){return new me(O,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=me;var j;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(j=e.EndOfLine||(e.EndOfLine={}));var z;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let te=f=class{constructor(O,se){this._range=O,this._newText=se}static isTextEdit(O){return O instanceof f?!0:O?F.isRange(O)&&typeof O.newText=="string":!1}static replace(O,se){return new f(O,se)}static insert(O,se){return f.replace(new F(O,O),se)}static delete(O){return f.replace(O,"")}static setEndOfLine(O){const se=new f(new F(new _(0,0),new _(0,0)),"");return se.newEol=O,se}get range(){return this._range}set range(O){if(O&&!F.isRange(O))throw(0,P.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,P.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,P.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};te=f=Ve([y],te),e.TextEdit=te;var $;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellOutput=4]="CellOutput",N[N.CellReplace=5]="CellReplace",N[N.CellOutputItem=6]="CellOutputItem"})($=e.FileEditType||(e.FileEditType={}));let R=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,se,De,Ke){this._edits.push({_type:1,from:O,to:se,options:De,metadata:Ke})}createFile(O,se,De){this._edits.push({_type:1,from:void 0,to:O,options:se,metadata:De})}deleteFile(O,se,De){this._edits.push({_type:1,from:O,to:void 0,options:se,metadata:De})}replaceNotebookMetadata(O,se,De){this._edits.push({_type:3,metadata:De,uri:O,edit:{editType:5,metadata:se},notebookMetadata:se})}replaceNotebookCells(O,se,De,Ke,et){let st,ct,yt=[],Ct;if($t.isNotebookRange(se)&&Lt.isNotebookCellDataArray(De)&&!Lt.isNotebookCellDataArray(Ke)?(st=se.start,ct=se.end,yt=De,Ct=Ke):typeof se=="number"&&typeof De=="number"&&Lt.isNotebookCellDataArray(Ke)&&(st=se,ct=De,yt=Ke,Ct=et),st===void 0||ct===void 0)throw new Error("Invalid arguments");(st!==ct||yt.length>0)&&this._edits.push({_type:5,uri:O,index:st,count:ct-st,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(O,se,De,Ke){this._edits.push({_type:3,metadata:Ke,uri:O,edit:{editType:8,index:se,metadata:De}})}replace(O,se,De,Ke){this._edits.push({_type:2,uri:O,edit:new te(se,De),metadata:Ke})}insert(O,se,De,Ke){this.replace(O,new F(se,se),De,Ke)}delete(O,se,De){this.replace(O,se,"",De)}has(O){return this._edits.some(se=>se._type===2&&se.uri.toString()===O.toString())}set(O,se){if(se)for(const De of se)De&&this._edits.push({_type:2,uri:O,edit:De});else{for(let De=0;De<this._edits.length;De++){const Ke=this._edits[De];Ke._type===2&&Ke.uri.toString()===O.toString()&&(this._edits[De]=void 0)}(0,w.coalesceInPlace)(this._edits)}}get(O){const se=[];for(let De of this._edits)De._type===2&&De.uri.toString()===O.toString()&&se.push(De.edit);return se}entries(){const O=new T.ResourceMap;for(let se of this._edits)if(se._type===2){let De=O.get(se.uri);De||(De=[se.uri,[]],O.set(se.uri,De)),De[1].push(se.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};R=Ve([y],R),e.WorkspaceEdit=R;let L=u=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof u?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=u._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,se=this._tabstop++){if(typeof O=="function"){const De=new u;De._tabstop=this._tabstop,O(De),this._tabstop=De._tabstop,O=De.value}else O=u._escape(O);return this.value+="${",this.value+=se,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,se=this._tabstop++){const De=O.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(O,se){if(typeof se=="function"){const De=new u;De._tabstop=this._tabstop,se(De),this._tabstop=De._tabstop,se=De.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,se&&(this.value+=":",this.value+=se),this.value+="}",this}};L=u=Ve([y],L),e.SnippetString=L;var M;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=b=class{constructor(O,se){if(this.uri=O,se)if(se instanceof F)this.range=se;else if(se instanceof _)this.range=new F(se,se);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof b?!0:O?F.isRange(O.range)&&D.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=b=Ve([y],G),e.Location=G;let J=class{constructor(O,se){this.location=O,this.message=se}static is(O){return O?typeof O.message=="string"&&O.location&&F.isRange(O.location.range)&&D.URI.isUri(O.location.uri):!1}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.location.range.isEqual(se.location.range)&&O.location.uri.toString()===se.location.uri.toString()}};J=Ve([y],J),e.DiagnosticRelatedInformation=J;let re=class{constructor(O,se,De=U.Error){if(!F.isRange(O))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=O,this.message=se,this.severity=De}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.severity===se.severity&&O.code===se.code&&O.severity===se.severity&&O.source===se.source&&O.range.isEqual(se.range)&&(0,w.equals)(O.tags,se.tags)&&(0,w.equals)(O.relatedInformation,se.relatedInformation,J.isEqual)}};re=Ve([y],re),e.Diagnostic=re;let pe=class{constructor(O,se){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,A.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=se}};pe=Ve([y],pe),e.Hover=pe;var Te;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Te=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let xe=class{constructor(O,se=Te.Text){this.range=O,this.kind=se}toJSON(){return{range:this.range,kind:Te[this.kind]}}};xe=Ve([y],xe),e.DocumentHighlight=xe;var Ae;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(Ae=e.SymbolKind||(e.SymbolKind={}));var We;(function(N){N[N.Deprecated=1]="Deprecated"})(We=e.SymbolTag||(e.SymbolTag={}));let B=t=class{constructor(O,se,De,Ke,et){this.name=O,this.kind=se,this.containerName=et,typeof De=="string"&&(this.containerName=De),Ke instanceof G?this.location=Ke:De instanceof F&&(this.location=new G(Ke,De)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};B=t=Ve([y],B),e.SymbolInformation=B;let q=n=class{constructor(O,se,De,Ke,et){this.name=O,this.detail=se,this.kind=De,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};q=n=Ve([y],q),e.DocumentSymbol=q;var ne;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(ne=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let le=class{constructor(O,se){this.title=O,this.kind=se}};le=Ve([y],le),e.CodeAction=le;let fe=l=class{constructor(O){this.value=O}append(O){return new l(this.value?this.value+l.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+l.sep)}};fe.sep=".",fe=l=Ve([y],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Se=class{constructor(O,se){if(this.range=O,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Se=Ve([y],Se),e.SelectionRange=Se;class Oe{constructor(O,se,De,Ke,et,st){this.kind=O,this.name=se,this.detail=De,this.uri=Ke,this.range=et,this.selectionRange=st}}e.CallHierarchyItem=Oe;class ge{constructor(O,se){this.fromRanges=se,this.from=O}}e.CallHierarchyIncomingCall=ge;class Ce{constructor(O,se){this.fromRanges=se,this.to=O}}e.CallHierarchyOutgoingCall=Ce;let Pe=class{constructor(O,se){this.range=O,this.command=se}get isResolved(){return!!this.command}};Pe=Ve([y],Pe),e.CodeLens=Pe;let $e=a=class{constructor(O,se=!1){r.set(this,void 0),tt(this,r,new A.MarkdownString(O,{supportThemeIcons:se}),"f")}static isMarkdownString(O){return O instanceof a?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Me(this,r,"f").value}set value(O){Me(this,r,"f").value=O}get isTrusted(){return Me(this,r,"f").isTrusted}set isTrusted(O){Me(this,r,"f").isTrusted=O}get supportThemeIcons(){return Me(this,r,"f").supportThemeIcons}appendText(O){return Me(this,r,"f").appendText(O),this}appendMarkdown(O){return Me(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,se){return Me(this,r,"f").appendCodeblock(se!=null?se:"",O),this}};r=new WeakMap,$e=a=Ve([y],$e),e.MarkdownString=$e;let Ee=class{constructor(O,se){this.label=O,this.documentation=se}};Ee=Ve([y],Ee),e.ParameterInformation=Ee;let je=class{constructor(O,se){this.label=O,this.documentation=se,this.parameters=[]}};je=Ve([y],je),e.SignatureInformation=je;let H=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};H=Ve([y],H),e.SignatureHelp=H;var ee;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(O,se,De){this.text=O,this.position=se,this.kind=De}};Le=Ve([y],Le),e.InlayHint=Le;var He;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(N){N[N.Deprecated=1]="Deprecated"})(Xe=e.CompletionItemTag||(e.CompletionItemTag={}));let W=class{constructor(O,se){this.label=O,this.kind=se}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};W=Ve([y],W),e.CompletionItem=W;let ie=class{constructor(O=[],se=!1){this.items=O,this.isIncomplete=se}};ie=Ve([y],ie),e.CompletionList=ie;var ce;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(ce=e.ViewColumn||(e.ViewColumn={}));var V;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(V=e.StatusBarAlignment||(e.StatusBarAlignment={}));var X;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ae;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var he;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(he=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ye;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ze;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function O(se){switch(se){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=O}(ye=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Be=class{constructor(O,se){if(se&&!D.URI.isUri(se))throw(0,P.illegalArgument)("target");if(!F.isRange(O)||O.isEmpty)throw(0,P.illegalArgument)("range");this.range=O,this.target=se}};Be=Ve([y],Be),e.DocumentLink=Be;let Ne=class{constructor(O,se,De,Ke){this.red=O,this.green=se,this.blue=De,this.alpha=Ke}};Ne=Ve([y],Ne),e.Color=Ne;let Ge=class{constructor(O,se){if(se&&!(se instanceof Ne))throw(0,P.illegalArgument)("color");if(!F.isRange(O)||O.isEmpty)throw(0,P.illegalArgument)("range");this.range=O,this.color=se}};Ge=Ve([y],Ge),e.ColorInformation=Ge;let nt=class{constructor(O){if(!O||typeof O!="string")throw(0,P.illegalArgument)("label");this.label=O}};nt=Ve([y],nt),e.ColorPresentation=nt;var dt;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var it;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(it=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Je;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(Je=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=s=class{constructor(O,se){if(typeof O!="string"||typeof se!="string")throw(0,P.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return s.Clean;case"build":return s.Build;case"rebuild":return s.Rebuild;case"test":return s.Test;default:return}}get id(){return this._id}};bt.Clean=new s("clean","Clean"),bt.Build=new s("build","Build"),bt.Rebuild=new s("rebuild","Rebuild"),bt.Test=new s("test","Test"),bt=s=Ve([y],bt),e.TaskGroup=bt;function be(N){let O="";for(let se=0;se<N.length;se++)O+=N[se].replace(/,/g,",,")+",";return O}let de=class{constructor(O,se,De){if(typeof O!="string")throw(0,P.illegalArgument)("process");this._args=[],this._process=O,se!==void 0&&(Array.isArray(se)?(this._args=se,this._options=De):this._options=se)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,P.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let se of this._args)O.push(se);return be(O)}};de=Ve([y],de),e.ProcessExecution=de;let oe=class{constructor(O,se,De){if(this._args=[],Array.isArray(se)){if(!O)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,P.illegalArgument)("command");this._command=O,this._args=se,this._options=De}else{if(typeof O!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=O,this._options=se}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,P.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,P.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let se of this._args)O.push(typeof se=="string"?se:se.value);return be(O)}};oe=Ve([y],oe),e.ShellExecution=oe;var K;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(K=e.ShellQuoting||(e.ShellQuoting={}));var Re;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(Re=e.TaskScope||(e.TaskScope={}));class Ie{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ie;let Qe=c=class{constructor(O,se,De,Ke,et,st){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof se=="string"?(this._name=this.name=se,this._source=this.source=De,this.execution=Ke,ct=et,this.__deprecated=!0):se===Re.Global||se===Re.Workspace?(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st):(this.target=se,this._name=this.name=De,this._source=this.source=Ke,this.execution=et,ct=st),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof de?this._definition={type:c.ProcessType,id:this._execution.computeId()}:this._execution instanceof oe?this._definition={type:c.ShellType,id:this._execution.computeId()}:this._execution instanceof Ie?this._definition={type:c.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:c.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,P.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const se=this._definition.type;(c.EmptyType===se||c.ProcessType===se||c.ShellType===se||c.ExtensionCallbackType===se)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Qe.ExtensionCallbackType="customExecution",Qe.ProcessType="process",Qe.ShellType="shell",Qe.EmptyType="$empty",Qe=c=Ve([y],Qe),e.Task=Qe;var Ze;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(Ze=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,se=ht.None){this.collapsibleState=se,D.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=Ve([y],ut),e.TreeItem=ut;var ht;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Ye=class{constructor(O,se){this.id=O,this.color=se}};Ye=Ve([y],Ye),e.ThemeIcon=Ye,Ye.File=new Ye("file"),Ye.Folder=new Ye("folder");let ot=class{constructor(O){this.id=O}};ot=Ve([y],ot),e.ThemeColor=ot;var ft;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let at=class{constructor(O,se){if(typeof O!="string"&&(!O||!D.URI.isUri(O)&&!D.URI.isUri(O.uri)))throw(0,P.illegalArgument)("base");if(typeof se!="string")throw(0,P.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=D.URI.file(O),this.base=O):D.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=se}};at=Ve([y],at),e.RelativePattern=at;let Et=class{constructor(O,se,De,Ke){this.enabled=typeof O=="boolean"?O:!0,typeof se=="string"&&(this.condition=se),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};Et=Ve([y],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,se,De,Ke,et){super(se,De,Ke,et);if(O===null)throw(0,P.illegalArgument)("location");this.location=O}};vt=Ve([y],vt),e.SourceBreakpoint=vt;let kt=class extends Et{constructor(O,se,De,Ke,et){super(se,De,Ke,et);this.functionName=O}};kt=Ve([y],kt),e.FunctionBreakpoint=kt;let At=class extends Et{constructor(O,se,De,Ke,et,st,ct){super(Ke,et,st,ct);if(!se)throw(0,P.illegalArgument)("dataId");this.label=O,this.dataId=se,this.canPersist=De}};At=Ve([y],At),e.DataBreakpoint=At;let Tt=class{constructor(O,se,De){this.command=O,this.args=se||[],this.options=De}};Tt=Ve([y],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,se){this.port=O,this.host=se}};_t=Ve([y],_t),e.DebugAdapterServer=_t;let Yt=class{constructor(O){this.path=O}};Yt=Ve([y],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(O){this.implementation=O}};Jt=Ve([y],Jt),e.DebugAdapterInlineImplementation=Jt;let gt=class{constructor(O,se){this.range=O,this.expression=se}};gt=Ve([y],gt),e.EvaluatableExpression=gt;let Xt=class{constructor(O,se){this.range=O,this.text=se}};Xt=Ve([y],Xt),e.InlineValueText=Xt;let St=class{constructor(O,se,De=!0){this.range=O,this.variableName=se,this.caseSensitiveLookup=De}};St=Ve([y],St),e.InlineValueVariableLookup=St;let jt=class{constructor(O,se){this.range=O,this.expression=se}};jt=Ve([y],jt),e.InlineValueEvaluatableExpression=jt;let Zt=class{constructor(O,se){this.frameId=O,this.stoppedLocation=se}};Zt=Ve([y],Zt),e.InlineValueContext=Zt;var qt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let lt=p=class extends Error{constructor(O,se=i.FileSystemProviderErrorCode.Unknown,De){var Ke;super(D.URI.isUri(O)?O.toString(!0):O);this.code=(Ke=De==null?void 0:De.name)!==null&&Ke!==void 0?Ke:"Unknown",(0,i.markAsFileSystemProviderError)(this,se),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}static FileExists(O){return new p(O,i.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(O){return new p(O,i.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(O){return new p(O,i.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(O){return new p(O,i.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(O){return new p(O,i.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(O){return new p(O,i.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};lt=p=Ve([y],lt),e.FileSystemError=lt;let en=class{constructor(O,se,De){this.start=O,this.end=se,this.kind=De}};en=Ve([y],en),e.FoldingRange=en;var Rt;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xt;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class _n{constructor(O,se=[]){this.tokenTypes=O,this.tokenModifiers=se}}e.SemanticTokensLegend=_n;function hn(N){return typeof N=="undefined"||(0,C.isStringArray)(N)}class tn{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let se=0,De=O.tokenTypes.length;se<De;se++)this._tokenTypeStrToInt.set(O.tokenTypes[se],se);for(let se=0,De=O.tokenModifiers.length;se<De;se++)this._tokenModifierStrToInt.set(O.tokenModifiers[se],se)}}push(O,se,De,Ke,et){if(typeof O=="number"&&typeof se=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(O,se,De,Ke,et);if(F.isRange(O)&&typeof se=="string"&&hn(De))return this._push(O,se,De);throw(0,P.illegalArgument)()}_push(O,se,De){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=O.start.line,et=O.start.character,st=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(se);let yt=0;if(De)for(const Ct of De){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);yt|=1<<It>>>0}this._pushEncoded(Ke,et,st,ct,yt)}_pushEncoded(O,se,De,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&se<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<yt;Pt++){let Mt=this._data[5*Pt],un=this._data[5*Pt+1];Mt===0?(Mt=Ct,un+=It):Mt+=Ct,this._data[5*Pt]=Mt,this._data[5*Pt+1]=un,Ct=Mt,It=un}}let st=O,ct=se;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(st-=this._prevLine,st===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=st,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=De,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=O,this._prevChar=se}static _sortAndDeltaEncode(O){let se=[];const De=O.length/5|0;for(let ct=0;ct<De;ct++)se[ct]=ct;se.sort((ct,yt)=>{const Ct=O[5*ct],It=O[5*yt];if(Ct===It){const Pt=O[5*ct+1],Mt=O[5*yt+1];return Pt-Mt}return Ct-It});const Ke=new Uint32Array(O.length);let et=0,st=0;for(let ct=0;ct<De;ct++){const yt=5*se[ct],Ct=O[yt+0],It=O[yt+1],Pt=O[yt+2],Mt=O[yt+3],un=O[yt+4],Tn=Ct-et,Mn=Tn===0?It-st:It,cn=5*ct;Ke[cn+0]=Tn,Ke[cn+1]=Mn,Ke[cn+2]=Pt,Ke[cn+3]=Mt,Ke[cn+4]=un,et=Ct,st=It}return Ke}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(tn._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=tn;class Kt{constructor(O,se){this.resultId=se,this.data=O}}e.SemanticTokens=Kt;class Nt{constructor(O,se,De){this.start=O,this.deleteCount=se,this.data=De}}e.SemanticTokensEdit=Nt;class En{constructor(O,se){this.resultId=se,this.edits=O}}e.SemanticTokensEdits=En;var nn;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Ye("arrow-left")},Gt=Ve([y],Gt),e.QuickInputButtons=Gt;var yn;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,se,De){this.badge=O,this.tooltip=se,this.color=De}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let sn=class{constructor(O){this.kind=O}};sn=Ve([y],sn),e.ColorTheme=sn;var Sn;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(O,se){if(O<0)throw(0,P.illegalArgument)("start must be positive");if(se<0)throw(0,P.illegalArgument)("end must be positive");O<=se?(this._start=O,this._end=se):(this._start=se,this._end=O)}static isNotebookRange(O){return O instanceof $t?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let se=this._start,De=this._end;return O.start!==void 0&&(se=O.start),O.end!==void 0&&(De=O.end),se===this._start&&De===this._end?this:new $t(se,De)}}e.NotebookRange=$t;class on{constructor(O,se){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=se)}with(O){let{inputCollapsed:se,outputCollapsed:De}=O,Ke=Qt(O,["inputCollapsed","outputCollapsed"]);return se===void 0?se=this.inputCollapsed:se===null&&(se=void 0),De===void 0?De=this.outputCollapsed:De===null&&(De=void 0),se===this.inputCollapsed&&De===this.outputCollapsed&&Object.keys(Ke).length===0?this:new on(Object.assign({inputCollapsed:se,outputCollapsed:De},Ke))}}e.NotebookCellMetadata=on;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Lt{constructor(O,se,De,Ke,et,st){this.kind=O,this.source=se,this.language=De,this.outputs=Ke!=null?Ke:[],this.metadata=et,this.latestExecutionSummary=st}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(se=>Lt.isNotebookCellData(se))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class fn{constructor(O,se){this.cells=O,this.metadata=se!=null?se:new Ut}}e.NotebookData=fn;class Wt{constructor(O,se,De){if(this.mime=O,this.value=se,this.metadata=De,(0,S.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Wt}}e.NotebookCellOutputItem=Wt;class Fe{constructor(O,se,De){this.outputs=O,typeof se=="string"?(this.id=se,this.metadata=De):(this.id=(0,k.generateUuid)(),this.metadata=se!=null?se:De)}}e.NotebookCellOutput=Fe;var an;(function(N){N[N.Markdown=1]="Markdown",N[N.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(O,se,De,Ke,et,st){this.text=O,this.alignment=se,this.command=De,this.tooltip=Ke,this.priority=et,this.accessibilityInformation=st}}e.NotebookCellStatusBarItem=Cn;var mn;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(mn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class gn{constructor(O,se=[]){this.uri=O,this.provides=typeof se=="string"?[se]:se}}e.NotebookKernelPreload=gn;let Ht=class{constructor(O,se){this.label=O,this.timestamp=se}};Ht=Ve([y],Ht),e.TimelineItem=Ht;var kn;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(O,se){this.ranges=O,this.wordPattern=se}}e.LinkedEditingRanges=pn;var An;(function(N){N[N.Unset=0]="Unset",N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var vn;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information",N[N.Hint=3]="Hint"})(vn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(N){N[N.Pending=0]="Pending",N[N.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(N,O,se,De)=>{let Ke=se;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){De(Ke,et)||(Ke=et,N.bus.fire([3,O,et]))}}},zt=(N,O)=>N===O,Z=(N,O)=>N===O?!0:!N||!O?!1:N.isEqual(O);class ue{constructor(O,se,De,Ke){this.label=se,this.data=Ke;const et=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:De,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new T.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Bt(et,"range",void 0,Z),description:Bt(et,"description",void 0,zt),runnable:Bt(et,"runnable",!0,zt),debuggable:Bt(et,"debuggable",!0,zt),status:Bt(et,"status",bn.Resolved,zt),error:Bt(et,"error",void 0,zt)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,d.getPrivateApiFor)(this);O.parent&&(0,d.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof ue))throw new Error("Test child must be created through vscode.test.createTestItem()");const se=(0,d.getPrivateApiFor)(this);if(se.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);se.children.set(O.id,O),se.bus.fire([0,O])}}e.TestItemImpl=ue;class ke{constructor(O){this.message=O,this.severity=vn.Error}static diff(O,se,De){const Ke=new ke(O);return Ke.expectedOutput=se,Ke.actualOutput=De,Ke}}e.TestMessage=ke;var rt;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(rt=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wt;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(wt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,42,19,8,120,86,7,15]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(r,o){o?k.set(r,o):k.delete(r)}e.setWordDefinitionFor=i;function I(r){return k.get(r)}e.getWordDefinitionFor=I;class d extends T.MirrorTextModel{constructor(o,g,m,E,f,u,b,t){super(g,m,E,f);this._proxy=o,this._languageId=u,this._isDirty=b,this._notebook=t,this._isDisposed=!1}dispose(){(0,w.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,D.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===P.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(g){return g?o._getTextInRange(g):o.getText()},get eol(){return o._eol===`
`?C.EndOfLine.LF:C.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(g){return o._lineAt(g)},offsetAt(g){return o._offsetAt(g)},positionAt(g){return o._positionAt(g)},validateRange(g){return o._validateRange(g)},validatePosition(g){return o._validatePosition(g)},getWordRangeAtPosition(g,m){return o._getWordRangeAtPosition(g,m)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,w.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,w.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const g=this._validateRange(o);if(g.isEmpty)return"";if(g.isSingleLine)return this._lines[g.start.line].substring(g.start.character,g.end.character);const m=this._eol,E=g.start.line,f=g.end.line,u=[];u.push(this._lines[E].substring(g.start.character));for(let b=E+1;b<f;b++)u.push(this._lines[b]);return u.push(this._lines[f].substring(0,g.end.character)),u.join(m)}_lineAt(o){let g;if(o instanceof C.Position?g=o.line:typeof o=="number"&&(g=o),typeof g!="number"||g<0||g>=this._lines.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new h(g,this._lines[g],g===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const g=this._lineStarts.getIndexOf(o),m=this._lines[g.index].length;return new C.Position(g.index,Math.min(g.remainder,m))}_validateRange(o){if(!(o instanceof C.Range))throw new Error("Invalid argument");const g=this._validatePosition(o.start),m=this._validatePosition(o.end);return g===o.start&&m===o.end?o:new C.Range(g.line,g.character,m.line,m.character)}_validatePosition(o){if(!(o instanceof C.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:g,character:m}=o,E=!1;if(g<0)g=0,m=0,E=!0;else if(g>=this._lines.length)g=this._lines.length-1,m=this._lines[g].length,E=!0;else{const f=this._lines[g].length;m<0?(m=0,E=!0):m>f&&(m=f,E=!0)}return E?new C.Position(g,m):o}_getWordRangeAtPosition(o,g){const m=this._validatePosition(o);if(!g)g=I(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const E=(0,S.getWordAtText)(m.character+1,(0,S.ensureValidWordDefinition)(g),this._lines[m.line],0);if(E)return new C.Range(m.line,E.startColumn-1,m.line,E.endColumn-1)}}e.ExtHostDocumentData=d;class h{constructor(o,g,m){this._line=o,this._text=g,this._isLastLine=m}get lineNumber(){return this._line}get text(){return this._text}get range(){return new C.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new C.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[163],_e([0,1,7,3,88,6,59,22,2,31]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,h,r,o){this._notebook=r,this._selector=o,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(h.onDidChangeDocument(m=>{const E=this._cellUris.get(m.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const g=m=>{m===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(m=>g(m.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new C.ResourceMap;const d=[],h=[];for(const r of this._notebook.getCells())r.kind===w.NotebookCellKind.Code&&(!this._selector||(0,S.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),d.push(r.document.getText().length+1),h.push(r.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(d){var h,r;if(!d){let f="";for(const u of this._cells)f+=u.document.getText()+`
`;return f=f.slice(0,-1),f}if(d.isEmpty)return"";const o=this.locationAt(d.start),g=this.locationAt(d.end),m=this._cells[(h=this._cellUris.get(o.uri))!==null&&h!==void 0?h:-1],E=this._cells[(r=this._cellUris.get(g.uri))!==null&&r!==void 0?r:-1];if(!m||!E)return"";if(m===E)return m.document.getText(new w.Range(o.range.start,g.range.end));{const f=m.document.getText(new w.Range(o.range.start,new w.Position(m.document.lineCount,0))),u=E.document.getText(new w.Range(new w.Position(0,0),g.range.end));return f+`
`+u}}offsetAt(d){const h=this._cellLines.getIndexOf(d.line),r=this._cellLengths.getAccumulatedValue(h.index-1),o=this._cells[h.index].document.offsetAt(d.with(h.remainder));return r+o}positionAt(d){if(typeof d=="number"){const r=this._cellLengths.getIndexOf(d),o=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(o)}const h=this._cellUris.get(d.uri);if(h!==void 0){const r=this._cellLines.getAccumulatedValue(h-1);return new w.Position(r+d.range.start.line,d.range.start.character)}return new w.Position(0,0)}locationAt(d){w.Range.isRange(d)||(d=new w.Range(d,d));const h=this._cellLines.getIndexOf(d.start.line);let r=h;d.isEmpty||(r=this._cellLines.getIndexOf(d.end.line));const o=new w.Position(h.remainder,d.start.character),g=new w.Position(r.remainder,d.end.character),m=new w.Range(o,g),E=this._cells[h.index];return new w.Location(E.document.uri,E.document.validateRange(m))}contains(d){return this._cellUris.has(d)}validateRange(d){const h=this.validatePosition(d.start),r=this.validatePosition(d.end);return d.with(h,r)}validatePosition(d){const h=this._cellLines.getIndexOf(d.line),r=new w.Position(h.remainder,d.character),o=this._cells[h.index].document.validatePosition(r),g=this._cellLines.getAccumulatedValue(h.index-1);return new w.Position(g+o.line,o.character)}}e.ExtHostNotebookConcatDocument=i}),define(we[164],_e([0,1,7,14,3]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(C){this._actual=new w.ColorTheme(w.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(C){let D=C==="light"?w.ColorThemeKind.Light:C==="dark"?w.ColorThemeKind.Dark:w.ColorThemeKind.HighContrast;this._actual=new w.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=Ve([qe(0,P.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(we[71],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,w.createDecorator)("IURITransformerService");class P{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=P}),define(we[165],_e([0,1,24]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(D){let k=this.buffers.indexOf(D);return k<0&&(k=this.buffers.length,this.buffers.push(D)),k}}function A(C,D){if(D.serializeBuffersForPostMessage){const k=new P,i=(h,r)=>{if(r instanceof ArrayBuffer){const o=k.add(r);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(r)){const o=T(r);if(o){const g=k.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:g,view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},I=JSON.stringify(C,i),d=k.buffers.map(h=>{const r=new Uint8Array(h);return w.VSBuffer.wrap(r)});return{message:I,buffers:d}}else return{message:JSON.stringify(C),buffers:[]}}e.serializeWebviewMessage=A;function T(C){switch(C.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(C,D){const k=D.map(d=>{const h=new ArrayBuffer(d.byteLength);return new Uint8Array(h).set(d.buffer),h}),i=D.length?(d,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:o}=r,g=k[o];if(r.view)switch(r.view.type){case 1:return new Int8Array(g,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return h}:void 0;return{message:JSON.parse(C,i),arrayBuffers:k}}e.deserializeWebviewMessage=S}),define(we[72],_e([0,1,2]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function P(T,S,C){const D=T.webviewResourceRoot.replace("{{resource}}",C.scheme+A(C)).replace("{{uuid}}",S);return w.URI.parse(D)}e.asWebviewUri=P;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(we[166],_e([0,1,3,6,72,31]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(D,k,i){this._proxy=D,this._editors=k,this._initData=i,this._handlePool=0,this._disposables=new P.DisposableStore,this._insets=new Map,this._disposables.add(k.onDidChangeVisibleTextEditors(()=>{const I=k.getVisibleTextEditors();for(const d of this._insets.values())I.indexOf(d.editor)<0&&d.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,k,i,I,d){let h;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===D){h=u;break}if(!h)throw new Error("not a visible editor");const r=this,o=this._handlePool++,g=new w.Emitter,m=new w.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(u){return(0,A.asWebviewUri)(r._initData,this._uuid,u)}get cspSource(){return r._initData.webviewCspSource}set options(u){this._options=u,r._proxy.$setOptions(o,u)}get options(){return this._options}set html(u){this._html=u,r._proxy.$setHtml(o,u)}get html(){return this._html}get onDidReceiveMessage(){return g.event}postMessage(u){return r._proxy.$postMessage(o,u)}},f=new class{constructor(){this.editor=D,this.line=k,this.height=i,this.webview=E,this.onDidDispose=m.event}dispose(){r._insets.has(o)&&(r._insets.delete(o),r._proxy.$disposeEditorInset(o),m.fire(),m.dispose(),g.dispose())}};return this._proxy.$createEditorInset(o,h.id,h.value.document.uri,k+1,i,I||{},d.identifier,d.extensionLocation),this._insets.set(o,{editor:D,inset:f,onDidReceiveMessage:g}),f}$onDidDispose(D){const k=this._insets.get(D);k&&k.inset.dispose()}$onDidReceiveMessage(D,k){const i=this._insets.get(D);i&&i.onDidReceiveMessage.fire(k)}}e.ExtHostEditorInsets=S}),define(we[167],_e([0,1,3,63,138,4,6,22,29,15,51,23,36,158]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,h.registerIcon)("default-view-icon",d.Codicon.window,(0,A.localize)(0,null));var r;(function(s){s.ViewContainersRegistry="workbench.registry.view.containers",s.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var o;(function(s){s[s.Sidebar=0]="Sidebar",s[s.Panel=1]="Panel"})(o=e.ViewContainerLocation||(e.ViewContainerLocation={}));function g(s){switch(s){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=g;function m(s){return`viewContainer.${s}.enabled`}e.getEnabledViewContainerContextKey=m;class E extends S.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new w.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new w.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(c,p,y){var v;const _=this.get(c.id);if(_)return _;const F=c;return F.openCommandActionDescriptor=(y==null?void 0:y.donotRegisterOpenCommand)?void 0:(v=F.openCommandActionDescriptor)!==null&&v!==void 0?v:{id:F.id},(0,C.getOrSet)(this.viewContainers,p,[]).push(F),(y==null?void 0:y.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:p}),F}deregisterViewContainer(c){for(const p of this.viewContainers.keys()){const y=this.viewContainers.get(p),v=y==null?void 0:y.indexOf(c);if(v!==-1){y==null||y.splice(v,1),y.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:c,viewContainerLocation:p});return}}}get(c){return this.all.filter(p=>p.id===c)[0]}getViewContainers(c){return[...this.viewContainers.get(c)||[]]}getViewContainerLocation(c){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(y=>(y==null?void 0:y.id)===c.id).length>0)[0]}getDefaultViewContainer(c){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===c)}}D.Registry.add(r.ViewContainersRegistry,new E);var f;(function(s){s.Open="2_open",s.Debug="4_debug",s.SCM="5_scm",s.More="9_more"})(f=e.ViewContentGroups||(e.ViewContentGroups={}));function u(s,c){var p,y,v,_;const F=(p=s.group)!==null&&p!==void 0?p:f.More,x=(y=c.group)!==null&&y!==void 0?y:f.More;return F!==x?F.localeCompare(x):((v=s.order)!==null&&v!==void 0?v:5)-((_=c.order)!==null&&_!==void 0?_:5)}class b extends S.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new w.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new w.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new w.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new w.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(c,p){this.registerViews2([{views:c,viewContainer:p}])}registerViews2(c){c.forEach(({views:p,viewContainer:y})=>this.addViews(p,y)),this._onViewsRegistered.fire(c)}deregisterViews(c,p){const y=this.removeViews(c,p);y.length&&this._onViewsDeregistered.fire({views:y,viewContainer:p})}moveViews(c,p){for(const y of this._views.keys())if(y!==p){const v=this.removeViews(c,y);v.length&&(this.addViews(v,p),this._onDidChangeContainer.fire({views:v,from:y,to:p}))}}getViews(c){return this._views.get(c)||[]}getView(c){for(const p of this._viewContainers){const y=(this._views.get(p)||[]).filter(v=>v.id===c)[0];if(y)return y}return null}getViewContainer(c){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(v=>v.id===c)[0])return p;return null}registerViewWelcomeContent(c,p){return this._viewWelcomeContents.add(c,p),this._onDidChangeViewWelcomeContent.fire(c),(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(c,p),this._onDidChangeViewWelcomeContent.fire(c)})}registerViewWelcomeContent2(c,p){const y=new Map;for(const[v,_]of p)this._viewWelcomeContents.add(c,_),y.set(v,(0,S.toDisposable)(()=>{this._viewWelcomeContents.delete(c,_),this._onDidChangeViewWelcomeContent.fire(c)}));return this._onDidChangeViewWelcomeContent.fire(c),y}getViewWelcomeContent(c){const p=[];return this._viewWelcomeContents.forEach(c,y=>p.push(y)),p.sort(u)}addViews(c,p){let y=this._views.get(p);y||(y=[],this._views.set(p,y),this._viewContainers.push(p));for(const v of c){if(this.getView(v.id)!==null)throw new Error((0,A.localize)(1,null,v.id));y.push(v)}}removeViews(c,p){const y=this._views.get(p);if(!y)return[];const v=[],_=[];for(const F of y)c.includes(F)?v.push(F):_.push(F);return v.length&&(_.length?this._views.set(p,_):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),v}}D.Registry.add(r.ViewsRegistry,new b),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new P.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(s){return`view.${s}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(s){s[s.Default=0]="Default",s[s.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var l;(function(s){s[s.None=0]="None",s[s.Collapsed=1]="Collapsed",s[s.Expanded=2]="Expanded"})(l=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class a{constructor(c,p){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,c),this._hasResolve=!!p,this.resolve=async y=>{var v,_;if(p&&!this.resolved){const F=await p(y);F&&(this.tooltip=(v=this.tooltip)!==null&&v!==void 0?v:F.tooltip,this.command=(_=this.command)!==null&&_!==void 0?_:F.command)}y.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=a}),define(we[168],_e([0,1,2,148,159,18,149,167]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(o){return(g,...m)=>o(g.get(P.ICommandService),...m)}class k{static execute(g,m){const E={forceReuseWindow:m&&m.reuseWindow,remoteAuthority:m&&m.remoteAuthority};return g.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",P.CommandsRegistry.registerCommand({id:k.ID,handler:D(k.execute),description:{description:"Opens an new window",args:[]}}),P.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,g){return o.get(A.IWorkspacesService).removeRecentlyOpened([g])});class i{static execute(g,m){return typeof m=="string"?m=m.match(/^[^:/?#]+:\/\//)?w.URI.parse(m):w.URI.file(m):m=w.URI.revive(m),g.executeCommand("_workbench.removeFromRecentlyOpened",m)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",P.CommandsRegistry.registerCommand(i.ID,D(i.execute));class I{static execute(g,m){const E=typeof m=="string"?{extensionId:m}:m;return g.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",P.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,g){const m=o.get(A.IWorkspacesService);let E;const f=g.uri,u=g.label,b=g.remoteAuthority;return g.type==="workspace"?E={workspace:await m.getWorkspaceIdentifier(f),label:u,remoteAuthority:b}:g.type==="folder"?E={folderUri:f,label:u,remoteAuthority:b}:E={fileUri:f,label:u,remoteAuthority:b},m.addRecentlyOpened([E])}),P.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(A.IWorkspacesService).getRecentlyOpened()}),P.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,g){const m=o.get(T.ILogService),E=o.get(S.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&m.setLevel(g)}),P.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),P.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,g){const m=o.get(C.IViewDescriptorService),E=m.getViewContainerById(g.destinationId);if(!!E){for(const f of g.viewIds){const u=m.getViewDescriptorById(f);(u==null?void 0:u.canMoveView)&&m.moveViewsToContainer([u],E,C.ViewVisibilityState.Default)}await o.get(C.IViewsService).openViewContainer(E.id,!0)}});class d{static execute(g,m){return!Array.isArray(m==null?void 0:m.viewIds)||typeof(m==null?void 0:m.destinationId)!="string"?Promise.reject("Invalid arguments"):g.executeCommand("_workbench.action.moveViews",m)}}e.MoveViewsAPICommand=d,d.ID="vscode.moveViews",P.CommandsRegistry.registerCommand({id:d.ID,handler:D(d.execute),description:{description:"Move Views",args:[]}});class h{static execute(g,m){return g.executeCommand("_workbench.open",m)}}h.ID="vscode.open",P.CommandsRegistry.registerCommand(h.ID,D(h.execute));class r{static execute(g,m,E,f,u){return g.executeCommand("_workbench.diff",[m,E,f])}}r.ID="vscode.diff",P.CommandsRegistry.registerCommand(r.ID,D(r.execute))}),define(we[169],_e([0,1,3,11,139]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new w.Emitter,this._onExit=new w.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(C){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=C}onEvent(C){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=C}onRequest(C){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=C}sendResponse(C){C.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${C.command}`)):this.internalSend("response",C)}sendRequest(C,D,k,i){const I={command:C};if(D&&Object.keys(D).length>0&&(I.arguments=D),this.internalSend("request",I),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const r={type:"response",seq:0,request_seq:I.seq,success:!1,command:C,message:(0,A.localize)(0,null,i,C)};h(r)}},i)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(C){this.messageCallback?this.messageCallback(C):(this.queue.push(C),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(C,D){return C.type!=="event"||D.type!=="event"}async processQueue(){let C;for(;this.queue.length;){if((!C||this.needsTaskBoundaryBetween(this.queue[0],C))&&await(0,P.timeout)(0),C=this.queue.shift(),!C)return;switch(C.type){case"event":this.eventCallback&&this.eventCallback(C);break;case"request":this.requestCallback&&this.requestCallback(C);break;case"response":const D=C,k=this.pendingRequests.get(D.request_seq);k&&(this.pendingRequests.delete(D.request_seq),k(D));break}}}internalSend(C,D){D.type=C,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const C=new Map;this.pendingRequests.forEach((D,k)=>C.set(k,D)),await(0,P.timeout)(500),C.forEach((D,k)=>{D({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(we[170],_e([0,1,8,2,13,23,19]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const C=/{([^}]+)}/g;function D(n,l,a){return n.replace(C,function(s,c){return l&&c.length>0&&c[0]!=="_"?s:a&&a.hasOwnProperty(c)?a[c]:s})}e.formatPII=D;function k(n){const l={};for(const a of Object.keys(n))a.startsWith("!")||(l[a]=n[a]);return l}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let l=n.configuration.type;if(!!l)return l==="vslsShare"&&(l=n.configuration.adapterProxy.configuration.type),(0,w.equalsIgnoreCase)(l,"extensionhost")||(0,w.equalsIgnoreCase)(l,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function h(n,l,a){let s,c=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,y=null;for(;y=p.exec(n);){let v=y.index+1,_=v+y[0].length;if(v<=l&&_>=a){s=y[0],c=v;break}}if(s){let v=/\w+/g,_=null;for(;(_=v.exec(s))&&!(_.index+1+c+_[0].length>=a););_&&(s=s.substring(0,v.lastIndex))}return s?{start:c,end:c+s.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(r))}e.isUri=o;function g(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return P.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return P.URI.file(n.path)}return n.path}function m(n){if(typeof n.path=="object"){const l=P.URI.revive(n.path);if(l)return l.scheme===S.Schemas.file?l.fsPath:l.toString()}return n.path}function E(n,l){const a=l?g:m,s=(0,T.deepClone)(n);return u(s,(c,p)=>{c&&p&&(p.path=a(p))}),s}e.convertToDAPaths=E;function f(n,l){const a=l?g:m,s=(0,T.deepClone)(n);return u(s,(c,p)=>{!c&&p&&(p.path=a(p))}),s}e.convertToVSCPaths=f;function u(n,l){switch(n.type){case"event":const a=n;switch(a.event){case"output":l(!1,a.body.source);break;case"loadedSource":l(!1,a.body.source);break;case"breakpoint":l(!1,a.body.breakpoint.source);break;default:break}break;case"request":const s=n;switch(s.command){case"setBreakpoints":l(!0,s.arguments.source);break;case"breakpointLocations":l(!0,s.arguments.source);break;case"source":l(!0,s.arguments.source);break;case"gotoTargets":l(!0,s.arguments.source);break;case"launchVSCode":s.arguments.args.forEach(p=>l(!1,p));break;default:break}break;case"response":const c=n;if(c.success&&c.body)switch(c.command){case"stackTrace":c.body.stackFrames.forEach(p=>l(!1,p.source));break;case"loadedSources":c.body.sources.forEach(p=>l(!1,p));break;case"scopes":c.body.scopes.forEach(p=>l(!1,p.source));break;case"setFunctionBreakpoints":c.body.breakpoints.forEach(p=>l(!1,p.source));break;case"setBreakpoints":c.body.breakpoints.forEach(p=>l(!1,p.source));break;default:break}break}}function b(n){return n.filter(l=>{var a;return!((a=l.presentation)===null||a===void 0?void 0:a.hidden)}).sort((l,a)=>l.presentation?a.presentation?l.presentation.group?a.presentation.group?l.presentation.group!==a.presentation.group?l.presentation.group.localeCompare(a.presentation.group):t(l.presentation.order,a.presentation.order):-1:a.presentation.group?1:t(l.presentation.order,a.presentation.order):-1:a.presentation?1:0)}e.getVisibleAndSorted=b;function t(n,l){return typeof n!="number"?typeof l!="number"?0:1:typeof l!="number"?-1:n-l}}),define(we[73],_e([0,1,28,19,13,21,63]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var C;(function(y){y[y.Markdown=1]="Markdown",y[y.Code=2]="Code"})(C=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(y){y[y.Running=1]="Running",y[y.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(y){y[y.Idle=1]="Idle",y[y.Pending=2]="Pending",y[y.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(y){y[y.WithHardKernelDependency=0]="WithHardKernelDependency",y[y.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",y[y.Pure=2]="Pure",y[y.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(y){y[y.ModelChange=1]="ModelChange",y[y.Move=2]="Move",y[y.CellClearOutput=3]="CellClearOutput",y[y.CellsClearOutput=4]="CellsClearOutput",y[y.ChangeLanguage=5]="ChangeLanguage",y[y.Initialize=6]="Initialize",y[y.ChangeCellMetadata=7]="ChangeCellMetadata",y[y.Output=8]="Output",y[y.OutputItem=9]="OutputItem",y[y.ChangeCellContent=10]="ChangeCellContent",y[y.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",y[y.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(y){y[y.Handle=0]="Handle",y[y.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(y){y[y.Replace=1]="Replace",y[y.Output=2]="Output",y[y.Metadata=3]="Metadata",y[y.CellLanguage=4]="CellLanguage",y[y.DocumentMetadata=5]="DocumentMetadata",y[y.Move=6]="Move",y[y.OutputItems=7]="OutputItems",y[y.PartialMetadata=8]="PartialMetadata"})(h=e.CellEditType||(e.CellEditType={}));function r(y){const v=o.parse(y);return v?v.notebook.toString():y.toString()}e.getCellUndoRedoComparisonKey=r;var o;(function(y){y.scheme=P.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function _(me,j){return me.with({scheme:y.scheme,fragment:`ch${j.toString().padStart(7,"0")}${me.scheme!==P.Schemas.file?me.scheme:""}`})}y.generate=_;function F(me){if(me.scheme===y.scheme){const j=v.exec(me.fragment);if(!!j)return{handle:Number(j[1]),notebook:me.with({scheme:me.fragment.substr(j[0].length)||P.Schemas.file,fragment:null})}}}y.parse=F;function x(me,j){return me.with({scheme:P.Schemas.vscodeNotebookCellMetadata,fragment:`ch${j.toString().padStart(7,"0")}${me.scheme!==P.Schemas.file?me.scheme:""}`})}y.generateCellMetadataUri=x;function Y(me){if(me.scheme===P.Schemas.vscodeNotebookCellMetadata){const j=v.exec(me.fragment);if(!!j)return{handle:Number(j[1]),notebook:me.with({scheme:me.fragment.substr(j[0].length)||P.Schemas.file,fragment:null})}}}y.parseCellMetadataUri=Y})(o=e.CellUri||(e.CellUri={}));const g=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function m(y){var v,_;return(_=(v=g.get(y))===null||v===void 0?void 0:v.alwaysSecure)!==null&&_!==void 0?_:!1}e.mimeTypeIsAlwaysSecure=m;function E(y){var v,_;return(_=(v=g.get(y))===null||v===void 0?void 0:v.supportedByCore)!==null&&_!==void 0?_:!1}e.mimeTypeSupportedByCore=E;function f(y){var v,_;return(_=(v=g.get(y))===null||v===void 0?void 0:v.mergeable)!==null&&_!==void 0?_:!1}e.mimeTypeIsMergeable=f;function u(y,v){return T.isWindows&&(y=y.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),w.match(y,v)}function b(y,v,_){let F=0;for(let x=0;x<v.length;x++){if(u(v[x],y))return F;F++}for(let x=0;x<_.length;x++){if(u(_[x],y))return F;F++}return F}function t(y,v,_){return y.sort((F,x)=>b(F,v,_)-b(x,v,_))}e.sortMimeTypes=t;function n(y,v,_,F=(x,Y)=>x===Y){const x=[];function Y(z,te,$){if(!(te===0&&$.length===0)){const R=x[x.length-1];R&&R.start+R.deleteCount===z?(R.deleteCount+=te,R.toInsert.push(...$)):x.push({start:z,deleteCount:te,toInsert:$})}}let me=0,j=0;for(;;){if(me===y.length){Y(me,0,v.slice(j));break}if(j===v.length){Y(me,y.length-me,[]);break}const z=y[me],te=v[j];if(F(z,te)){me+=1,j+=1;continue}_(te)?(Y(me,1,[]),me+=1):(Y(me,0,[te]),j+=1)}return x}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new S.RawContextKey("notebookEditorCursorAtBoundary","none");var l;(function(y){y.default="default",y.option="option"})(l=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(y){const v=y;return!!((typeof v.include=="string"||w.isRelativePattern(v.include))&&(typeof v.exclude=="string"||w.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=a;function s(y,v,_){if(Array.isArray(y.viewType)&&y.viewType.indexOf(v)>=0||y.viewType===v)return!0;if(y.filenamePattern){let F=a(y.filenamePattern)?y.filenamePattern.include:y.filenamePattern,x=a(y.filenamePattern)?y.filenamePattern.exclude:void 0;if(w.match(F,(0,A.basename)(_.fsPath).toLowerCase()))return!(x&&w.match(x,(0,A.basename)(_.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s;class c{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let _=0;_<this.textModel.cells.length;_++)v[_]=this.textModel.cells[_].getHashValue();return v}}e.CellSequence=c,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var p;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={})),e.NOTEBOOK_WORKING_COPY_TYPE_PREFIX="notebook/"}),define(we[171],_e([0,1,141,4,63]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,w.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,w.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,w.localize(2,null)),e.ITaskService=(0,P.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[172],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function w(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=w;function P(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=P}),define(we[96],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var w;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(w=e.TestItemExpandState||(e.TestItemExpandState={}));const P=(D,k)=>{k.expand!==void 0&&(D.expand=k.expand),k.item!==void 0&&(D.item=D.item?Object.assign(D.item,k.item):k.item)};e.applyTestItemUpdate=P;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,k)=>`${D}:${k.toString()}`;e.getTestSubscriptionKey=T;class S{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=S;class C{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const I of k)switch(I[0]){case 0:{const d=I[1];if(d.parent){if(this.items.has(d.parent)){const h=this.items.get(d.parent);h.children.add(d.item.extId);const r=this.createItem(d,h);this.items.set(d.item.extId,r),i.add(r)}}else{this.roots.add(d.item.extId);const h=this.createItem(d);this.items.set(d.item.extId,h),i.add(h)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=I[1],h=this.items.get(d.extId);if(!h)break;d.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(h,d),i.update(h);break}case 2:{const d=this.items.get(I[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const h=[[I[1]]];for(;h.length;)for(const r of h.pop()){const o=this.items.get(r);o&&(h.push(o.children),this.items.delete(r),i.remove(o,o!==d),o.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new S}}e.AbstractIncrementalTestCollection=C}),define(we[173],_e([0,1,13,46,10,23,21,58,142]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,d,h){this._contributedVariables=new Map,this._context=I,this._labelService=d,h&&(this._envVariablesPromise=h.then(r=>this.prepareEnv(r)))}prepareEnv(I){if(S.isWindows){const d=Object.create(null);return Object.keys(I).forEach(h=>{d[h.toLowerCase()]=I[h]}),d}return I}resolveWithEnvironment(I,d,h){return this.recursiveResolve(this.prepareEnv(I),d?d.uri:void 0,h)}async resolveAsync(I,d){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d)}async resolveAnyBase(I,d,h,r){const o=T.deepClone(d);return S.isWindows&&o.windows?Object.keys(o.windows).forEach(g=>o[g]=o.windows[g]):S.isMacintosh&&o.osx?Object.keys(o.osx).forEach(g=>o[g]=o.osx[g]):S.isLinux&&o.linux&&Object.keys(o.linux).forEach(g=>o[g]=o.linux[g]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o,h,r)}async resolveAnyAsync(I,d,h){return this.resolveAnyBase(I,d,h)}async resolveAnyMap(I,d,h){const r=new Map;return{newConfig:await this.resolveAnyBase(I,d,h,r),resolvedVariables:r}}resolveWithInteractionReplace(I,d,h,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,d,h,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,d){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,d)}recursiveResolve(I,d,h,r,o){if(A.isString(h))return this.resolveString(I,d,h,r,o);if(A.isArray(h))return h.map(g=>this.recursiveResolve(I,d,g,r,o));if(A.isObject(h)){let g=Object.create(null);return Object.keys(h).forEach(m=>{const E=this.resolveString(I,d,m,r,o);g[E]=this.recursiveResolve(I,d,h[m],r,o)}),g}return h}resolveString(I,d,h,r,o){return h.replace(k.VARIABLE_REGEXP,(m,E)=>{if(E.includes(k.VARIABLE_LHS))return m;let f=this.evaluateSingleVariable(I,m,E,d,r);return o&&o.set(E,f),f})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,d,h,r,o){let g;const m=h.split(":");m.length>1&&(h=m[0],g=m[1]);const E=()=>{const b=this._context.getFilePath();if(b)return b;throw new Error((0,D.localize)(0,null,d))},f=()=>{const b=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,d,w.basename(b)))},u=()=>{if(g){const b=this._context.getFolderUri(g);if(b)return b;throw new Error((0,D.localize)(2,null,d,g))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,d)):new Error((0,D.localize)(4,null,d))};switch(h){case"env":if(g){if(I){const b=I[S.isWindows?g.toLowerCase():g];if(A.isString(b))return b}return""}throw new Error((0,D.localize)(5,null,d));case"config":if(g){const b=this._context.getConfigurationValue(r,g);if(A.isUndefinedOrNull(b))throw new Error((0,D.localize)(6,null,d,g));if(A.isObject(b))throw new Error((0,D.localize)(7,null,d,g));return b}throw new Error((0,D.localize)(8,null,d));case"command":return this.resolveFromMap(d,g,o,"command");case"input":return this.resolveFromMap(d,g,o,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return(0,C.normalizeDriveLetter)(this.fsPath(u()));case"cwd":return r||g?(0,C.normalizeDriveLetter)(this.fsPath(u())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return w.basename(this.fsPath(u()));case"lineNumber":const b=this._context.getLineNumber();if(b)return b;throw new Error((0,D.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,d));case"file":return E();case"fileWorkspaceFolder":return f();case"relativeFile":return r||g?w.relative(this.fsPath(u()),E()):E();case"relativeFileDirname":const n=w.dirname(E());if(r||g){const c=w.relative(this.fsPath(u()),n);return c.length===0?".":c}return n;case"fileDirname":return w.dirname(E());case"fileExtname":return w.extname(E());case"fileBasename":return w.basename(E());case"fileBasenameNoExtension":const l=w.basename(E());return l.slice(0,l.length-w.extname(l).length);case"fileDirnameBasename":return w.basename(w.dirname(E()));case"execPath":const a=this._context.getExecPath();return a||d;case"execInstallFolder":const s=this._context.getAppRoot();return s||d;case"pathSeparator":return w.sep;default:try{const c=g?`${h}:${g}`:h;return this.resolveFromMap(d,c,o,void 0)}catch(c){return d}}}}resolveFromMap(I,d,h,r){if(d&&h){const o=r===void 0?h[d]:h[r+":"+d];if(typeof o=="string")return o;throw new Error((0,D.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[174],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,w.createDecorator)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P=e.GroupDirection||(e.GroupDirection={}));var A;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var S;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(S=e.GroupsArrangement||(e.GroupsArrangement={}));var C;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(C=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_PIN=7]="EDITOR_PIN",d[d.EDITOR_STICKY=8]="EDITOR_STICKY",d[d.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[175],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,w.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,15,83,229,57,23,10,2,32,62,143,90,73,175,7]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var g;(function(be){function de(K){const{selectionStartLineNumber:Re,selectionStartColumn:Ie,positionLineNumber:Qe,positionColumn:Ze}=K,ut=new o.Position(Re-1,Ie-1),ht=new o.Position(Qe-1,Ze-1);return new o.Selection(ut,ht)}be.to=de;function oe(K){const{anchor:Re,active:Ie}=K;return{selectionStartLineNumber:Re.line+1,selectionStartColumn:Re.character+1,positionLineNumber:Ie.line+1,positionColumn:Ie.character+1}}be.from=oe})(g=e.Selection||(e.Selection={}));var m;(function(be){function de(K){if(!!K){const{start:Re,end:Ie}=K;return{startLineNumber:Re.line+1,startColumn:Re.character+1,endLineNumber:Ie.line+1,endColumn:Ie.character+1}}}be.from=de;function oe(K){if(!!K){const{startLineNumber:Re,startColumn:Ie,endLineNumber:Qe,endColumn:Ze}=K;return new o.Range(Re-1,Ie-1,Qe-1,Ze-1)}}be.to=oe})(m=e.Range||(e.Range={}));var E;(function(be){function de(oe){switch(oe){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}be.to=de})(E=e.TokenType||(e.TokenType={}));var f;(function(be){function de(K){return new o.Position(K.lineNumber-1,K.column-1)}be.to=de;function oe(K){return{lineNumber:K.line+1,column:K.character+1}}be.from=oe})(f=e.Position||(e.Position={}));var u;(function(be){function de(K){switch(K){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}be.from=de;function oe(K){switch(K){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}be.to=oe})(u=e.DiagnosticTag||(e.DiagnosticTag={}));var b;(function(be){function de(K){let Re;return K.code&&((0,C.isString)(K.code)||(0,C.isNumber)(K.code)?Re=String(K.code):Re={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},m.from(K.range)),{message:K.message,source:K.source,code:Re,severity:n.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?(0,w.coalesce)(K.tags.map(u.from)):void 0})}be.from=de;function oe(K){var Re;const Ie=new o.Diagnostic(m.to(K),K.message,n.to(K.severity));return Ie.source=K.source,Ie.code=(0,C.isString)(K.code)?K.code:(Re=K.code)===null||Re===void 0?void 0:Re.value,Ie.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Ie.tags=K.tags&&(0,w.coalesce)(K.tags.map(u.to)),Ie}be.to=oe})(b=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function de(K){return Object.assign(Object.assign({},m.from(K.location.range)),{message:K.message,resource:K.location.uri})}be.from=de;function oe(K){return new o.DiagnosticRelatedInformation(new o.Location(K.resource,m.to(K)),K.message)}be.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function de(K){switch(K){case o.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}be.from=de;function oe(K){switch(K){case d.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}be.to=oe})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var l;(function(be){function de(K){return typeof K=="number"&&K>=o.ViewColumn.One?K-1:K===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}be.from=de;function oe(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(l=e.ViewColumn||(e.ViewColumn={}));function a(be){return typeof be.range!="undefined"}function s(be){return be.length===0?!0:!!a(be[0])}e.isDecorationOptionsArr=s;var c;(function(be){function de(Ze){return Ze.map(be.from)}be.fromMany=de;function oe(Ze){return Ze&&typeof Ze=="object"&&typeof Ze.language=="string"&&typeof Ze.value=="string"}function K(Ze){let ut;if(oe(Ze)){const{language:ft,value:at}=Ze;ut={value:"```"+ft+`
`+at+"\n```\n"}}else o.MarkdownString.isMarkdownString(Ze)?ut={value:Ze.value,isTrusted:Ze.isTrusted,supportThemeIcons:Ze.supportThemeIcons}:typeof Ze=="string"?ut={value:Ze}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Ye=ft=>{try{let at=D.URI.parse(ft,!0);at=at.with({query:Re(at.query,ht)}),ht[ft]=at}catch(at){}return""},ot=new A.Renderer;return ot.link=Ye,ot.image=ft=>Ye(P.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:ot}),ut}be.from=K;function Re(Ze,ut){if(!Ze)return Ze;let ht;try{ht=(0,T.parse)(Ze)}catch(ot){}if(!ht)return Ze;let Ye=!1;return ht=(0,S.cloneAndChange)(ht,ot=>{if(D.URI.isUri(ot)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=ot,Ye=!0,ft}else return}),Ye?JSON.stringify(ht):Ze}function Ie(Ze){const ut=new o.MarkdownString(Ze.value,Ze.supportThemeIcons);return ut.isTrusted=Ze.isTrusted,ut}be.to=Ie;function Qe(Ze){if(!!Ze)return typeof Ze=="string"?Ze:be.from(Ze)}be.fromStrict=Qe})(c=e.MarkdownString||(e.MarkdownString={}));function p(be){return s(be)?be.map(de=>({range:m.from(de.range),hoverMessage:Array.isArray(de.hoverMessage)?c.fromMany(de.hoverMessage):de.hoverMessage?c.from(de.hoverMessage):void 0,renderOptions:de.renderOptions})):be.map(de=>({range:m.from(de)}))}e.fromRangeOrRangeWithMessage=p;function y(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=y;var v;(function(be){function de(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?y(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=de})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var _;(function(be){function de(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?y(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}be.from=de})(_=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(be){function de(oe){if(typeof oe=="undefined")return oe;switch(oe){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=de})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var x;(function(be){function de(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?F.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?_.from(oe.light):void 0,dark:oe.dark?_.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?y(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}be.from=de})(x=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Y;(function(be){function de(K){return{text:K.newText,eol:K.newEol&&ee.from(K.newEol),range:m.from(K.range)}}be.from=de;function oe(K){const Re=new o.TextEdit(m.to(K.range),K.text);return Re.newEol=typeof K.eol=="undefined"?void 0:ee.to(K.eol),Re}be.to=oe})(Y=e.TextEdit||(e.TextEdit={}));var me;(function(be){function de(K,Re,Ie){var Qe,Ze,ut;const ht={edits:[]};if(K instanceof o.WorkspaceEdit)for(let Ye of K._allEntries())if(Ye._type===1)ht.edits.push({_type:1,oldUri:Ye.from,newUri:Ye.to,options:Ye.options,metadata:Ye.metadata});else if(Ye._type===2){const ot=Re==null?void 0:Re.getDocument(Ye.uri);ht.edits.push({_type:2,resource:Ye.uri,edit:Y.from(Ye.edit),modelVersionId:ot==null?void 0:ot.version,metadata:Ye.metadata})}else Ye._type===3?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:Ye.edit,notebookMetadata:Ye.notebookMetadata,notebookVersionId:(Qe=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Qe===void 0?void 0:Qe.apiNotebook.version}):Ye._type===4?(Ye.newOutputs&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:2,index:Ye.index,append:Ye.append,outputs:Ye.newOutputs.map(ze.from)}}),Ye.newMetadata&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:8,index:Ye.index,metadata:Ye.newMetadata}})):Ye._type===5?ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,notebookVersionId:(Ze=Ie==null?void 0:Ie.lookupNotebookDocument(Ye.uri))===null||Ze===void 0?void 0:Ze.apiNotebook.version,edit:{editType:1,index:Ye.index,count:Ye.count,cells:Ye.cells.map(he.from)}}):Ye._type===6&&ht.edits.push({_type:3,metadata:Ye.metadata,resource:Ye.uri,edit:{editType:7,outputId:Ye.outputId,items:((ut=Ye.newOutputItems)===null||ut===void 0?void 0:ut.map(ye.from))||[],append:Ye.append}});return ht}be.from=de;function oe(K){const Re=new o.WorkspaceEdit;for(const Ie of K.edits)Ie.edit?Re.replace(D.URI.revive(Ie.resource),m.to(Ie.edit.range),Ie.edit.text):Re.renameFile(D.URI.revive(Ie.oldUri),D.URI.revive(Ie.newUri),Ie.options);return Re}be.to=oe})(me=e.WorkspaceEdit||(e.WorkspaceEdit={}));var j;(function(be){const de=Object.create(null);de[o.SymbolKind.File]=0,de[o.SymbolKind.Module]=1,de[o.SymbolKind.Namespace]=2,de[o.SymbolKind.Package]=3,de[o.SymbolKind.Class]=4,de[o.SymbolKind.Method]=5,de[o.SymbolKind.Property]=6,de[o.SymbolKind.Field]=7,de[o.SymbolKind.Constructor]=8,de[o.SymbolKind.Enum]=9,de[o.SymbolKind.Interface]=10,de[o.SymbolKind.Function]=11,de[o.SymbolKind.Variable]=12,de[o.SymbolKind.Constant]=13,de[o.SymbolKind.String]=14,de[o.SymbolKind.Number]=15,de[o.SymbolKind.Boolean]=16,de[o.SymbolKind.Array]=17,de[o.SymbolKind.Object]=18,de[o.SymbolKind.Key]=19,de[o.SymbolKind.Null]=20,de[o.SymbolKind.EnumMember]=21,de[o.SymbolKind.Struct]=22,de[o.SymbolKind.Event]=23,de[o.SymbolKind.Operator]=24,de[o.SymbolKind.TypeParameter]=25;function oe(Re){return typeof de[Re]=="number"?de[Re]:6}be.from=oe;function K(Re){for(const Ie in de)if(de[Ie]===Re)return Number(Ie);return o.SymbolKind.Property}be.to=K})(j=e.SymbolKind||(e.SymbolKind={}));var z;(function(be){function de(K){switch(K){case o.SymbolTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return o.SymbolTag.Deprecated}}be.to=oe})(z=e.SymbolTag||(e.SymbolTag={}));var te;(function(be){function de(K){return{name:K.name,kind:j.from(K.kind),tags:K.tags&&K.tags.map(z.from),containerName:K.containerName,location:U.from(K.location)}}be.from=de;function oe(K){const Re=new o.SymbolInformation(K.name,j.to(K.kind),K.containerName,U.to(K.location));return Re.tags=K.tags&&K.tags.map(z.to),Re}be.to=oe})(te=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var $;(function(be){function de(K){var Re,Ie;const Qe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:m.from(K.range),selectionRange:m.from(K.selectionRange),kind:j.from(K.kind),tags:(Ie=(Re=K.tags)===null||Re===void 0?void 0:Re.map(z.from))!==null&&Ie!==void 0?Ie:[]};return K.children&&(Qe.children=K.children.map(de)),Qe}be.from=de;function oe(K){const Re=new o.DocumentSymbol(K.name,K.detail,j.to(K.kind),m.to(K.range),m.to(K.selectionRange));return(0,w.isNonEmptyArray)(K.tags)&&(Re.tags=K.tags.map(z.to)),K.children&&(Re.children=K.children.map(oe)),Re}be.to=oe})($=e.DocumentSymbol||(e.DocumentSymbol={}));var R;(function(be){function de(oe){const K=new o.CallHierarchyItem(j.to(oe.kind),oe.name,oe.detail||"",D.URI.revive(oe.uri),m.to(oe.range),m.to(oe.selectionRange));return K._sessionId=oe._sessionId,K._itemId=oe._itemId,K}be.to=de})(R=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(be){function de(oe){return new o.CallHierarchyIncomingCall(R.to(oe.from),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function de(oe){return new o.CallHierarchyOutgoingCall(R.to(oe.to),oe.fromRanges.map(K=>m.to(K)))}be.to=de})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var U;(function(be){function de(K){return{range:K.range&&m.from(K.range),uri:K.uri}}be.from=de;function oe(K){return new o.Location(D.URI.revive(K.uri),m.to(K.range))}be.to=oe})(U=e.location||(e.location={}));var G;(function(be){function de(K){const Re=K,Ie=K;return{originSelectionRange:Re.originSelectionRange?m.from(Re.originSelectionRange):void 0,uri:Re.targetUri?Re.targetUri:Ie.uri,range:m.from(Re.targetRange?Re.targetRange:Ie.range),targetSelectionRange:Re.targetSelectionRange?m.from(Re.targetSelectionRange):void 0}}be.from=de;function oe(K){return{targetUri:D.URI.revive(K.uri),targetRange:m.to(K.range),targetSelectionRange:K.targetSelectionRange?m.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?m.to(K.originSelectionRange):void 0}}be.to=oe})(G=e.DefinitionLink||(e.DefinitionLink={}));var J;(function(be){function de(K){return{range:m.from(K.range),contents:c.fromMany(K.contents)}}be.from=de;function oe(K){return new o.Hover(K.contents.map(c.to),m.to(K.range))}be.to=oe})(J=e.Hover||(e.Hover={}));var re;(function(be){function de(K){return{range:m.from(K.range),expression:K.expression}}be.from=de;function oe(K){return new o.EvaluatableExpression(m.to(K.range),K.expression)}be.to=oe})(re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var pe;(function(be){function de(K){if(K instanceof o.InlineValueText)return{type:"text",range:m.from(K.range),text:K.text};if(K instanceof o.InlineValueVariableLookup)return{type:"variable",range:m.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:m.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}be.from=de;function oe(K){switch(K.type){case"text":return{range:m.to(K.range),text:K.text};case"variable":return{range:m.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:m.to(K.range),expression:K.expression}}}be.to=oe})(pe=e.InlineValue||(e.InlineValue={}));var Te;(function(be){function de(K){return{frameId:K.frameId,stoppedLocation:m.from(K.stoppedLocation)}}be.from=de;function oe(K){return new o.InlineValueContext(K.frameId,m.to(K.stoppedLocation))}be.to=oe})(Te=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(be){function de(K){return{range:m.from(K.range),kind:K.kind}}be.from=de;function oe(K){return new o.DocumentHighlight(m.to(K.range),K.kind)}be.to=oe})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Ae;(function(be){function de(oe){switch(oe){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}be.to=de})(Ae=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function(be){function de(oe){return{triggerKind:Ae.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=de})(We=e.CompletionContext||(e.CompletionContext={}));var B;(function(be){function de(K){switch(K){case o.CompletionItemTag.Deprecated:return 1}}be.from=de;function oe(K){switch(K){case 1:return o.CompletionItemTag.Deprecated}}be.to=oe})(B=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(be){const de=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function oe(Ie){var Qe;return(Qe=de.get(Ie))!==null&&Qe!==void 0?Qe:9}be.from=oe;const K=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Re(Ie){var Qe;return(Qe=K.get(Ie))!==null&&Qe!==void 0?Qe:o.CompletionItemKind.Property}be.to=Re})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var ne;(function(be){function de(oe,K){var Re;const Ie=new o.CompletionItem(typeof oe.label=="string"?oe.label:oe.label.name);return typeof oe.label!="string"&&(Ie.label2=oe.label),Ie.insertText=oe.insertText,Ie.kind=q.to(oe.kind),Ie.tags=(Re=oe.tags)===null||Re===void 0?void 0:Re.map(B.to),Ie.detail=oe.detail,Ie.documentation=P.isMarkdownString(oe.documentation)?c.to(oe.documentation):oe.documentation,Ie.sortText=oe.sortText,Ie.filterText=oe.filterText,Ie.preselect=oe.preselect,Ie.commitCharacters=oe.commitCharacters,k.Range.isIRange(oe.range)?Ie.range=m.to(oe.range):typeof oe.range=="object"&&(Ie.range={inserting:m.to(oe.range.insert),replacing:m.to(oe.range.replace)}),Ie.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Ie.insertText=new o.SnippetString(oe.insertText):(Ie.insertText=oe.insertText,Ie.textEdit=Ie.range instanceof o.Range?new o.TextEdit(Ie.range,Ie.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Ie.additionalTextEdits=oe.additionalTextEdits.map(Qe=>Y.to(Qe))),Ie.command=K&&oe.command?K.fromInternal(oe.command):void 0,Ie}be.to=de})(ne=e.CompletionItem||(e.CompletionItem={}));var le;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0}}be.from=de;function oe(K){return{label:K.label,documentation:P.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation}}be.to=oe})(le=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function de(K){return{label:K.label,documentation:K.documentation?c.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(le.from):[],activeParameter:K.activeParameter}}be.from=de;function oe(K){return{label:K.label,documentation:P.isMarkdownString(K.documentation)?c.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(le.to):[],activeParameter:K.activeParameter}}be.to=oe})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Se;(function(be){function de(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(fe.from):[]}}be.from=de;function oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(fe.to):[]}}be.to=oe})(Se=e.SignatureHelp||(e.SignatureHelp={}));var Oe;(function(be){function de(K){var Re;return{text:K.text,position:f.from(K.position),kind:ge.from((Re=K.kind)!==null&&Re!==void 0?Re:o.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}be.from=de;function oe(K){const Re=new o.InlayHint(K.text,f.to(K.position),ge.to(K.kind));return Re.whitespaceAfter=K.whitespaceAfter,Re.whitespaceBefore=K.whitespaceBefore,Re}be.to=oe})(Oe=e.InlayHint||(e.InlayHint={}));var ge;(function(be){function de(K){return K}be.from=de;function oe(K){return K}be.to=oe})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function de(K){return{range:m.from(K.range),url:K.target,tooltip:K.tooltip}}be.from=de;function oe(K){let Re;if(K.url)try{Re=typeof K.url=="string"?D.URI.parse(K.url,!0):D.URI.revive(K.url)}catch(Ie){}return new o.DocumentLink(m.to(K.range),Re)}be.to=oe})(Ce=e.DocumentLink||(e.DocumentLink={}));var Pe;(function(be){function de(K){const Re=new o.ColorPresentation(K.label);return K.textEdit&&(Re.textEdit=Y.to(K.textEdit)),K.additionalTextEdits&&(Re.additionalTextEdits=K.additionalTextEdits.map(Ie=>Y.to(Ie))),Re}be.to=de;function oe(K){return{label:K.label,textEdit:K.textEdit?Y.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Re=>Y.from(Re)):void 0}}be.from=oe})(Pe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(be){function de(K){return new o.Color(K[0],K[1],K[2],K[3])}be.to=de;function oe(K){return[K.red,K.green,K.blue,K.alpha]}be.from=oe})($e=e.Color||(e.Color={}));var Ee;(function(be){function de(K){return{range:m.from(K.range)}}be.from=de;function oe(K){return new o.SelectionRange(m.to(K.range))}be.to=oe})(Ee=e.SelectionRange||(e.SelectionRange={}));var je;(function(be){function de(oe){switch(oe){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}be.to=de})(je=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var H;(function(be){function de(K){switch(K){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}be.from=de;function oe(K){switch(K){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}be.to=oe})(H=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(be){function de(K){if(K===o.EndOfLine.CRLF)return 1;if(K===o.EndOfLine.LF)return 0}be.from=de;function oe(K){if(K===1)return o.EndOfLine.CRLF;if(K===0)return o.EndOfLine.LF}be.to=oe})(ee=e.EndOfLine||(e.EndOfLine={}));var ve;(function(be){function de(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=de})(ve=e.ProgressLocation||(e.ProgressLocation={}));var Le;(function(be){function de(oe){const K={start:oe.start+1,end:oe.end+1};return oe.kind&&(K.kind=He.from(oe.kind)),K}be.from=de})(Le=e.FoldingRange||(e.FoldingRange={}));var He;(function(be){function de(oe){if(oe)switch(oe){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}be.from=de})(He=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(be){function de(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?m.from(oe.selection):void 0,override:typeof oe.override=="boolean"?I.EditorOverride.DISABLED:void 0}}be.from=de})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Xe;(function(be){function de(K){return K instanceof o.RelativePattern||typeof K=="string"?K:oe(K)?new o.RelativePattern(K.base,K.pattern):K}be.from=de;function oe(K){const Re=K;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(Xe=e.GlobPattern||(e.GlobPattern={}));var W;(function(be){function de(oe){if(oe){if(Array.isArray(oe))return oe.map(de);if(typeof oe=="string")return oe;{const K=oe;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Xe.from(K.pattern),exclusive:K.exclusive}}}else return}be.from=de})(W=e.LanguageSelector||(e.LanguageSelector={}));var ie;(function(be){function de(K){return{start:K.start,end:K.end}}be.from=de;function oe(K){return new o.NotebookRange(K.start,K.end)}be.to=oe})(ie=e.NotebookRange||(e.NotebookRange={}));var ce;(function(be){function de(oe){return new o.NotebookCellMetadata().with(Object.assign(Object.assign({},oe),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=de})(ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var V;(function(be){function de(K){return K}be.from=de;function oe(K){return new o.NotebookDocumentMetadata().with(K)}be.to=oe})(V=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var X;(function(be){function de(K){return{startTime:K.runStartTime,endTime:K.runEndTime,executionOrder:K.executionOrder,success:K.lastRunSuccess}}be.to=de;function oe(K){return{lastRunSuccess:K.success,runStartTime:K.startTime,runEndTime:K.endTime,executionOrder:K.executionOrder}}be.from=oe})(X=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var ae;(function(be){function de(K){switch(K){case o.NotebookCellKind.Markdown:return h.CellKind.Markdown;case o.NotebookCellKind.Code:default:return h.CellKind.Code}}be.from=de;function oe(K){switch(K){case h.CellKind.Markdown:return o.NotebookCellKind.Markdown;case h.CellKind.Code:default:return o.NotebookCellKind.Code}}be.to=oe})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var he;(function(be){function de(K){var Re;return{cellKind:ae.from(K.kind),language:K.language,source:K.source,metadata:Object.assign(Object.assign({},K.metadata),X.from((Re=K.latestExecutionSummary)!==null&&Re!==void 0?Re:{})),outputs:K.outputs?K.outputs.map(ze.from):[]}}be.from=de;function oe(K){return new o.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.outputs?K.outputs.map(ze.to):void 0,K.metadata?ce.to(K.metadata):void 0)}be.to=oe})(he=e.NotebookCellData||(e.NotebookCellData={}));var ye;(function(be){function de(K){return{mime:K.mime,value:K.value,metadata:K.metadata}}be.from=de;function oe(K){return new o.NotebookCellOutputItem(K.mime,K.value,K.metadata)}be.to=oe})(ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ze;(function(be){function de(K){return{outputId:K.id,outputs:K.outputs.map(ye.from),metadata:K.metadata}}be.from=de;function oe(K){const Re=K.outputs.map(ye.to);return new o.NotebookCellOutput(Re,K.outputId,K.metadata)}be.to=oe})(ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Be;(function(be){function de(Ie){if(Ie!=null){if(Ie instanceof o.RelativePattern||typeof Ie=="string")return Ie;if(Re(Ie))return new o.RelativePattern(Ie.base,Ie.pattern);if(K(Ie))return{include:Xe.from(Ie.include)||void 0,exclude:Xe.from(Ie.exclude)||void 0}}}be.from=de;function oe(Ie){return typeof Ie=="string"?Ie:Re(Ie)?{base:Ie.base,pattern:Ie.pattern}:{include:Ie.include,exclude:Ie.exclude}}be.to=oe;function K(Ie){const Qe=Ie,Ze=Xe.from(Qe.include);if(!(Ze&&Ze instanceof o.RelativePattern||typeof Ze=="string"))return!1;const ut=Xe.from(Qe.exclude);return!!(ut&&ut instanceof o.RelativePattern||typeof ut=="string")}function Re(Ie){const Qe=Ie;return Qe&&typeof Qe.base=="string"&&typeof Qe.pattern=="string"}})(Be=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ne;(function(be){function de(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?v.from(oe.top):void 0}}be.from=de})(Ne=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ge;(function(be){function de(oe,K,Re){const Ie=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Ie,Re),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=de})(Ge=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var nt;(function(be){function de(oe){var K,Re;return{transientOutputs:(K=oe==null?void 0:oe.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:Object.assign(Object.assign({},oe==null?void 0:oe.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Re=oe==null?void 0:oe.transientDocumentMetadata)!==null&&Re!==void 0?Re:{}}}be.from=de})(nt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var dt;(function(be){function de(K){var Re;return{uri:K.uri,provides:typeof K.provides=="string"?[K.provides]:(Re=K.provides)!==null&&Re!==void 0?Re:[]}}be.from=de;function oe(K){return new o.NotebookKernelPreload(D.URI.revive(K.uri),K.provides)}be.to=oe})(dt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var it;(function(be){function de(K){return{message:c.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?U.from(K.location):void 0}}be.from=de;function oe(K){const Re=new o.TestMessage(typeof K.message=="string"?K.message:c.to(K.message));return Re.severity=K.severity,Re.actualOutput=K.actualOutput,Re.expectedOutput=K.expectedOutput,Re}be.to=oe})(it=e.TestMessage||(e.TestMessage={}));var Je;(function(be){function de(Ie){var Qe,Ze;return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:(Qe=Ie.debuggable)!==null&&Qe!==void 0?Qe:!1,description:Ie.description||null,runnable:(Ze=Ie.runnable)!==null&&Ze!==void 0?Ze:!0,error:Ie.error&&c.fromStrict(Ie.error)||null}}be.from=de;function oe(Ie){return{extId:Ie.id,label:Ie.label,uri:Ie.uri,range:m.from(Ie.range)||null,debuggable:!1,description:Ie.description||null,error:null,runnable:!0}}be.fromResultSnapshot=oe;function K(Ie){return{id:Ie.extId,label:Ie.label,uri:D.URI.revive(Ie.uri),range:m.to(Ie.range||void 0),addChild:()=>{},dispose:()=>{},status:o.TestItemStatus.Pending,data:void 0,debuggable:Ie.debuggable,description:Ie.description||void 0,runnable:Ie.runnable}}be.toPlain=K;function Re(Ie){const Qe=new o.TestItemImpl(Ie.extId,Ie.label,D.URI.revive(Ie.uri),void 0);return Qe.range=m.to(Ie.range||void 0),Qe.debuggable=Ie.debuggable,Qe.description=Ie.description||void 0,Qe.runnable=Ie.runnable,Qe}be.to=Re})(Je=e.TestItem||(e.TestItem={}));var mt;(function(be){const de=(K,Re)=>Object.assign(Object.assign({},Je.toPlain(K.item)),{taskStates:K.tasks.map(Ie=>({state:Ie.state,duration:Ie.duration,messages:Ie.messages.map(it.to)})),children:K.children.map(Ie=>Re.get(Ie)).filter(C.isDefined).map(Ie=>de(Ie,Re))});function oe(K){const Re=[],Ie=new Map;for(const Qe of K.items)Ie.set(Qe.item.extId,Qe),Qe.direct&&Re.push(Qe);return{completedAt:K.completedAt,results:Re.map(Qe=>de(Qe,Ie))}}be.to=oe})(mt=e.TestResults||(e.TestResults={}));var bt;(function(be){function de(oe){switch(oe){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}be.to=de})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[176],_e([0,1,2,12,7,9,45]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class C{constructor(k,i,I,d={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=d,this._callbacks=new S.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,I,d)=>{const r={dispose:this._callbacks.push([i,I,k])};return Array.isArray(d)&&d.push(r),r}}async $participateInSave(k,i){const I=w.URI.revive(k);let d=!1;const h=setTimeout(()=>d=!0,this._thresholds.timeout),r=[];try{for(let o of[...this._callbacks]){if(d)break;const g=this._documents.getDocument(I),m=await this._deliverEventAsyncAndBlameBadListeners(o,{document:g,reason:T.TextDocumentSaveReason.to(i)});r.push(m)}}finally{clearTimeout(h)}return r}_deliverEventAsyncAndBlameBadListeners([k,i,I],d){const h=this._badListeners.get(k);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,i,d).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(k);this._badListeners.set(k,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,I,d){const h=[],r=Date.now(),{document:o,reason:g}=d,{version:m}=o,E=Object.freeze({document:o,reason:g,waitUntil(f){if(Object.isFrozen(h))throw(0,P.illegalState)("waitUntil can not be called async");h.push(Promise.resolve(f))}});try{i.apply(I,[E])}catch(f){return Promise.reject(f)}return Object.freeze(h),new Promise((f,u)=>{const b=setTimeout(()=>u(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(b),f(t)}).catch(t=>{clearTimeout(b),u(t)})}).then(f=>{const u={edits:[]};for(const b of f)if(Array.isArray(b)&&b.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:l}of b)u.edits.push({_type:2,resource:o.uri,edit:{range:l&&T.Range.from(l),text:t,eol:n&&T.EndOfLine.from(n)}});if(u.edits.length!==0)return m===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(u):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=C}),define(we[177],_e([0,1,3,11,28,2,9,7]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(I,d,h,r,o){this._onDidCreate=new w.Emitter,this._onDidChange=new w.Emitter,this._onDidDelete=new w.Emitter,this._config=0,h&&(this._config+=1),r&&(this._config+=2),o&&(this._config+=4);const g=(0,A.parse)(d),m=I(E=>{if(!h)for(let f of E.created){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidCreate.fire(u)}if(!r)for(let f of E.changed){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidChange.fire(u)}if(!o)for(let f of E.deleted){const u=T.URI.revive(f);g(u.fsPath)&&this._onDidDelete.fire(u)}});this._disposable=C.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,m)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,d,h){this._logService=d,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new w.Emitter,this._onDidRenameFile=new w.Emitter,this._onDidCreateFile=new w.Emitter,this._onDidDeleteFile=new w.Emitter,this._onWillRenameFile=new P.AsyncEmitter,this._onWillCreateFile=new P.AsyncEmitter,this._onWillDeleteFile=new P.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,d,h,r){return new D(this._onFileSystemEvent.event,I,d,h,r)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,d){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(h=>({oldUri:T.URI.revive(h.source),newUri:T.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(h=>T.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,d){return(h,r,o)=>{const g=function(E){h.call(r,E)};return g.extension=I,d.event(g,void 0,o)}}async $onWillRunFileOperation(I,d,h,r){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(o=>({oldUri:T.URI.revive(o.source),newUri:T.URI.revive(o.target)}))},h,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(o=>T.URI.revive(o.target))},h,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(o=>T.URI.revive(o.target))},h,r)}}async _fireWillEvent(I,d,h,r){const o=new Set,g=[];if(await I.fireAsync(d,r,async(E,f)=>{var u;const b=Date.now(),t=await Promise.resolve(E);t instanceof C.WorkspaceEdit&&(g.push(t),o.add((u=f.extension.displayName)!==null&&u!==void 0?u:f.extension.identifier.value)),Date.now()-b>h&&this._logService.warn("SLOW file-participant",f.extension.identifier)}),!r.isCancellationRequested&&g.length!==0){const m={edits:[]};for(let E of g){let{edits:f}=S.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);m.edits=m.edits.concat(f)}return{edit:m,extensionNames:Array.from(o)}}}}e.ExtHostFileSystemEventService=k}),define(we[178],_e([0,1,19,23,2,9,7,73]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(d,h,r,o){this.start=d,this.deletedCount=h,this.deletedItems=r,this.items=o}static asApiEvents(d){return d.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(r=>r.apiCell)}))}}class k{constructor(d,h,r){var o;this._notebook=d,this._extHostDocument=h,this._cellData=r,this.handle=r.handle,this.uri=A.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(o=r.metadata)!==null&&o!==void 0?o:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(d,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._cell){const d=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._cell=Object.freeze({get index(){return d._notebook.getCellIndex(d)},notebook:d._notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get latestExecutionSummary(){return d._previousResult}})}return this._cell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,h,r){const o=r.map(T.NotebookCellOutputItem.to),g=this._outputs.find(m=>m.id===d);g&&(h||(g.outputs.length=0),g.outputs.push(...o))}setMetadata(d){this._internalMetadata=d,this._metadata=T.NotebookCellMetadata.to(d),this._previousResult=T.NotebookCellPreviousExecutionResult.to(d)}}e.ExtHostCell=k;class i{constructor(d,h,r,o,g,m,E){this._proxy=d,this._textDocumentsAndEditors=h,this._textDocuments=r,this._emitter=o,this._viewType=g,this._metadata=m,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===w.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(h){return h=d._validateIndex(h),d._cells[h].apiCell},getCells(h){return(h?d._getCells(h):d._cells).map(o=>o.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,h){this._versionId=d.versionId,this._isDirty=h;for(const r of d.rawEvents)r.kind===C.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===C.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===C.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===C.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===C.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===C.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===C.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(d){return d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){return d.start<0&&(d=d.with({start:0})),d.end>this._cells.length&&(d=d.with({end:this._cells.length})),d}_getCells(d){d=this._validateRange(d);const h=[];for(let r=d.start;r<d.end;r++)h.push(this._cells[r]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(d,h){if(!this._disposed){const r=[],o=[],g=[];d.reverse().forEach(m=>{const f=m[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return h||o.push(k.asModelAddData(this.apiNotebook,t)),n}),u=new D(m[0],m[1],[],f),b=this._cells.splice(m[0],m[1],...f);for(let t of b)g.push(t.uri),u.deletedItems.push(t.apiCell);r.push(u)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:g}),h||this._emitter.emitModelChange((0,P.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(r)}))}}_moveCell(d,h){const r=this._cells.splice(d,1);this._cells.splice(h,0,...r);const o=[new D(d,1,r.map(g=>g.apiCell),[]),new D(h,0,[],r)];this._emitter.emitModelChange((0,P.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(o)}))}_setCellOutputs(d,h){const r=this._cells[d];r.setOutputs(h),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(d,h,r,o){const g=this._cells[d];g.setOutputItems(h,r,o),this._emitter.emitCellOutputsChange((0,P.deepFreeze)({document:this.apiNotebook,cells:[g.apiCell]}))}_changeCellLanguage(d,h){const r=this._cells[d];r.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(r.uri,h)}_changeCellMetadata(d,h){var r;const o=this._cells[d],g=o.internalMetadata,m=o.apiCell.metadata;o.setMetadata(h);const E=o.apiCell.metadata;if((0,P.equals)(m,E)||this._emitter.emitCellMetadataChange((0,P.deepFreeze)({document:this.apiNotebook,cell:o.apiCell})),g.runState!==h.runState){const f=(r=h.runState)!==null&&r!==void 0?r:S.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,P.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,executionState:f}))}}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(h=>h.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(we[179],_e([0,1,7,9]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(C){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=C}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(C){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:C})}replaceCellMetadata(C,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:C,metadata:D})}replaceCells(C,D,k){this._throwIfFinalized(),!(C===D&&k.length===0)&&this._collectedEdits.push({editType:1,index:C,count:D-C,cells:k.map(P.NotebookCellData.from)})}}class T{constructor(C,D,k,i,I,d){this.id=C,this._proxy=D,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const C=this;this._editor={get document(){return C.notebookData.apiNotebook},get selections(){return C._selections},get visibleRanges(){return C._visibleRanges},revealRange(D,k){C._proxy.$tryRevealRange(C.id,P.NotebookRange.from(D),k!=null?k:w.NotebookEditorRevealType.Default)},get viewColumn(){return C._viewColumn},edit(D){const k=new A(this.document.version);return D(k),C._applyEdit(k.finalize())},setDecorations(D,k){return C.setDecorations(D,k)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(C){this._visible=C}_acceptVisibleRanges(C){this._visibleRanges=C}_acceptSelections(C){this._selections=C}_acceptViewColumn(C){this._viewColumn=C}_applyEdit(C){if(C.cellEdits.length===0)return Promise.resolve(!0);const D=[];let k=-1;for(let i=0;i<C.cellEdits.length;i++){if(k<0){D.push(C.cellEdits[i]),k++;continue}const d=D[k],h=C.cellEdits[i];if(d.editType===1&&h.editType===1&&d.index===h.index){d.cells.push(...C.cellEdits[i].cells),d.count+=C.cellEdits[i].count;continue}D.push(C.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,C.documentVersionId,D)}setDecorations(C,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(C.key)))return D.isEmpty?this._hasDecorationsForKey.delete(C.key):this._hasDecorationsForKey.add(C.key),this._proxy.$trySetDecorations(this.id,P.NotebookRange.from(D),C.key)}}e.ExtHostNotebookEditor=T}),define(we[180],_e([0,1,9,153,133,20,52]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class C{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,d,h){const r=this._handles++,{title:o,location:g,cancellable:m}=d,E={label:(0,A.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(r,{location:w.ProgressLocation.from(g),title:o,source:E,cancellable:m},I),this._withProgress(r,h,!!m)}_withProgress(I,d,h){let r;h&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,r));const o=m=>{this._proxy.$progressEnd(m),this._mapHandleToCancellationSource.delete(m),r&&r.dispose()};let g;try{g=d(new k(this._proxy,I),h&&r?r.token:T.CancellationToken.None)}catch(m){throw o(I),m}return g.then(m=>o(I),m=>o(I)),g}$acceptProgressCanceled(I){const d=this._mapHandleToCancellationSource.get(I);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=C;function D(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class k extends P.Progress{constructor(I,d){super(h=>this.throttledReport(h));this._proxy=I,this._handle=d}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([(0,S.throttle)(100,(i,I)=>D(i,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(we[97],_e([0,1,42,12,54,9,7]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class C{constructor(d,h){const r=C._Keys.nextId();d.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){d.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=C,C._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(d,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,h){this._throwIfFinalized();let r=null;if(d instanceof S.Position)r=new S.Range(d,d);else if(d instanceof S.Range)r=d;else throw new Error("Unrecognized location");this._pushEdit(r,h,!1)}insert(d,h){this._throwIfFinalized(),this._pushEdit(new S.Range(d,d),h,!0)}delete(d){this._throwIfFinalized();let h=null;if(d instanceof S.Range)h=d;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(d,h,r){const o=this._document.validateRange(d);this._collectedEdits.push({range:o,text:h,forceMoveMarkers:r})}setEndOfLine(d){if(this._throwIfFinalized(),d!==S.EndOfLine.LF&&d!==S.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=D;class k{constructor(d,h,r,o){this._proxy=d,this._id=h,this._accept(r),this._logService=o;const g=this;this.value={get tabSize(){return g._tabSize},set tabSize(m){g._setTabSize(m)},get insertSpaces(){return g._insertSpaces},set insertSpaces(m){g._setInsertSpaces(m)},get cursorStyle(){return g._cursorStyle},set cursorStyle(m){g._setCursorStyle(m)},get lineNumbers(){return g._lineNumbers},set lineNumbers(m){g._setLineNumbers(m)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const h=Math.floor(d);return h>0?h:null}if(typeof d=="string"){const h=parseInt(d,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(d){const h=this._validateTabSize(d);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const h=this._validateInsertSpaces(d);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const h={};let r=!1;if(typeof d.tabSize!="undefined"){const o=this._validateTabSize(d.tabSize);o==="auto"?(r=!0,h.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,r=!0,h.tabSize=o)}if(typeof d.insertSpaces!="undefined"){const o=this._validateInsertSpaces(d.insertSpaces);o==="auto"?(r=!0,h.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,r=!0,h.insertSpaces=o)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,r=!0,h.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,r=!0,h.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(d){d.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=k;class i{constructor(d,h,r,o,g,m,E,f){this.id=d,this._proxy=h,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=g,this._options=new k(this._proxy,this.id,m,r),this._visibleRanges=E,this._viewColumn=f;const u=this;this.value=Object.freeze({get document(){return o.getValue()},set document(b){throw(0,P.readonly)("document")},get selection(){return u._selections&&u._selections[0]},set selection(b){if(!(b instanceof S.Selection))throw(0,P.illegalArgument)("selection");u._selections=[b],u._trySetSelection()},get selections(){return u._selections},set selections(b){if(!Array.isArray(b)||b.some(t=>!(t instanceof S.Selection)))throw(0,P.illegalArgument)("selections");u._selections=b,u._trySetSelection()},get visibleRanges(){return u._visibleRanges},set visibleRanges(b){throw(0,P.readonly)("visibleRanges")},get options(){return u._options.value},set options(b){u._disposed||u._options.assign(b)},get viewColumn(){return u._viewColumn},set viewColumn(b){throw(0,P.readonly)("viewColumn")},edit(b,t={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(o.getValue(),t);return b(n),u._applyEdit(n)},insertSnippet(b,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(u._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let l;if(!t||Array.isArray(t)&&t.length===0)l=u._selections.map(a=>T.Range.from(a));else if(t instanceof S.Position){const{lineNumber:a,column:s}=T.Position.from(t);l=[{startLineNumber:a,startColumn:s,endLineNumber:a,endColumn:s}]}else if(t instanceof S.Range)l=[T.Range.from(t)];else{l=[];for(const a of t)if(a instanceof S.Range)l.push(T.Range.from(a));else{const{lineNumber:s,column:c}=T.Position.from(a);l.push({startLineNumber:s,startColumn:c,endLineNumber:s,endColumn:c})}}return h.$tryInsertSnippet(d,b.value,l,n)},setDecorations(b,t){const n=t.length===0;n&&!u._hasDecorationsForKey.has(b.key)||(n?u._hasDecorationsForKey.delete(b.key):u._hasDecorationsForKey.add(b.key),u._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return h.$trySetDecorations(d,b.key,T.fromRangeOrRangeWithMessage(t));{const l=new Array(4*t.length);for(let a=0,s=t.length;a<s;a++){const c=t[a];l[4*a]=c.start.line+1,l[4*a+1]=c.start.character+1,l[4*a+2]=c.end.line+1,l[4*a+3]=c.end.character+1}return h.$trySetDecorationsFast(d,b.key,l)}}))},revealRange(b,t){u._runOnProxy(()=>h.$tryRevealRange(d,T.Range.from(b),t||S.TextEditorRevealType.Default))},show(b){h.$tryShowEditor(d,T.ViewColumn.from(b))},hide(){h.$tryHideEditor(d)}})}dispose(){(0,w.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,w.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,w.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,w.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,w.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const h=d.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const r=h.edits.map(g=>g.range);r.sort((g,m)=>g.end.line===m.end.line?g.end.character===m.end.character?g.start.line===m.start.line?g.start.character-m.start.character:g.start.line-m.start.line:g.end.character-m.end.character:g.end.line-m.end.line);for(let g=0,m=r.length-1;g<m;g++){const E=r[g].end;if(r[g+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=h.edits.map(g=>({range:T.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,o,{setEndOfLine:typeof h.setEndOfLine=="number"?T.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=i}),define(we[181],_e([0,1,136,25,2,3,6,11,7,10,15,9,20]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(g,m){if((0,k.isString)(g))return{label:g};if(g&&typeof g=="object"&&typeof g.label=="string"){let E;return Array.isArray(g.highlights)&&(E=g.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),E=E.length?E:void 0),{label:g.label,highlights:E}}}class r{constructor(m,E,f){this._proxy=m,this.commands=E,this.logService=f,this.treeViews=new Map;function u(b){return b&&b.$treeViewId&&b.$treeItemHandle}E.registerArgumentProcessor({processArgument:b=>u(b)?this.convertArgument(b):Array.isArray(b)&&b.length>0?b.map(t=>u(t)?this.convertArgument(t):t):b})}registerTreeDataProvider(m,E,f){const u=this.createTreeView(m,{treeDataProvider:E},f);return{dispose:()=>u.dispose()}}createTreeView(m,E,f){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=this._proxy.$registerTreeViewDataProvider(m,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),b=this.createExtHostTreeView(m,E,f);return{get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get message(){return b.message},set message(t){b.message=t},get title(){return b.title},set title(t){b.title=t},get description(){return b.description},set description(t){b.description=t},reveal:(t,n)=>b.reveal(t,n),dispose:async()=>{await u,this.treeViews.delete(m),b.dispose()}}}$getChildren(m,E){const f=this.treeViews.get(m);return f?f.getChildren(E):Promise.reject(new Error((0,w.localize)(0,null,m)))}$setParent(m,E,f){const u=this.treeViews.get(m);return u?u.setParent(E,f):Promise.reject(new Error((0,w.localize)(1,null,m)))}async $hasResolve(m){const E=this.treeViews.get(m);if(!E)throw new Error((0,w.localize)(2,null,m));return E.hasResolve}$resolve(m,E,f){const u=this.treeViews.get(m);if(!u)throw new Error((0,w.localize)(3,null,m));return u.resolveTreeItem(E,f)}$setExpanded(m,E,f){const u=this.treeViews.get(m);if(!u)throw new Error((0,w.localize)(4,null,m));u.setExpanded(E,f)}$setSelection(m,E){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(5,null,m));f.setSelection(E)}$setVisible(m,E){const f=this.treeViews.get(m);if(!f)throw new Error((0,w.localize)(6,null,m));f.setVisible(E)}createExtHostTreeView(m,E,f){const u=new o(m,E,this._proxy,this.commands.converter,this.logService,f);return this.treeViews.set(m,u),u}convertArgument(m){const E=this.treeViews.get(m.$treeViewId);return E?E.getExtensionElement(m.$treeItemHandle):null}}e.ExtHostTreeViews=r;class o extends S.Disposable{constructor(m,E,f,u,b,t){super();if(this.viewId=m,this.proxy=f,this.commands=u,this.logService=b,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const a in t.contributes.views)for(const s of t.contributes.views[a])s.id===m&&(this._title=s.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(a=>this._onDidChangeData.fire({message:!1,element:a})));let n,l;this._register(T.Event.debounce(this._onDidChangeData.event,(a,s)=>(a||(a={message:!1,elements:[]}),s.element!==!1&&(n||(n=new Promise(c=>l=c),this.refreshPromise=this.refreshPromise.then(()=>n)),a.elements.push(s.element)),s.message&&(a.message=!0),a),200,!0)(({message:a,elements:s})=>{s.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const c=l;return n=null,this.refresh(s).then(()=>c())})),a&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(m=>this.getExtensionElement(m)).filter(m=>!(0,k.isUndefinedOrNull)(m))}getChildren(m){const E=m?this.getExtensionElement(m):void 0;if(m&&!E)return this.logService.error(`No tree item with id '${m}' found.`),Promise.resolve([]);const f=this.getChildrenNodes(m);return(f?Promise.resolve(f):this.fetchChildrenNodes(E)).then(u=>u.map(b=>b.item))}getExtensionElement(m){return this.elements.get(m)}reveal(m,E){E=E||{select:!0,focus:!1};const f=(0,k.isUndefinedOrNull)(E.select)?!0:E.select,u=(0,k.isUndefinedOrNull)(E.focus)?!1:E.focus,b=(0,k.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):m?this.refreshPromise.then(()=>this.resolveUnknownParentChain(m)).then(t=>this.resolveTreeNode(m,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(l=>l.item)},{select:f,focus:u,expand:b})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:f,focus:u,expand:b})}get message(){return this._message}set message(m){this._message=m,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(m){this._title=m,this.proxy.$setTitle(this.viewId,m,this._description)}get description(){return this._description}set description(m){this._description=m,this.proxy.$setTitle(this.viewId,this._title,m)}setExpanded(m,E){const f=this.getExtensionElement(m);f&&(E?this._onDidExpandElement.fire(Object.freeze({element:f})):this._onDidCollapseElement.fire(Object.freeze({element:f})))}setSelection(m){(0,i.equals)(this._selectedHandles,m)||(this._selectedHandles=m,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(m){m!==this._visible&&(this._visible=m,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(m,E){const f=m.map(b=>this.getExtensionElement(b)).filter(b=>!(0,k.isUndefinedOrNull)(b)),u=this.getExtensionElement(E);return this.dataProvider.setParent&&f&&u?(0,C.asPromise)(()=>this.dataProvider.setParent(f,u)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(m,E){var f;if(!!this.dataProvider.resolveTreeItem){const u=this.elements.get(m);if(u){const b=this.nodes.get(u);if(b){const t=(f=await this.dataProvider.resolveTreeItem(b.extensionItem,u,E))!==null&&f!==void 0?f:b.extensionItem;return b.item.tooltip=this.getTooltip(t.tooltip),b.item.command=this.getCommand(b.disposableStore,t.command),b.item}}}}resolveUnknownParentChain(m){return this.resolveParent(m).then(E=>E?this.resolveUnknownParentChain(E).then(f=>this.resolveTreeNode(E,f[f.length-1]).then(u=>(f.push(u),f))):Promise.resolve([]))}resolveParent(m){const E=this.nodes.get(m);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,C.asPromise)(()=>this.dataProvider.getParent(m))}resolveTreeNode(m,E){const f=this.nodes.get(m);return f?Promise.resolve(f):(0,C.asPromise)(()=>this.dataProvider.getTreeItem(m)).then(u=>this.createHandle(m,u,E,!0)).then(u=>this.getChildren(E?E.item.handle:void 0).then(()=>{const b=this.getExtensionElement(u);if(b){const t=this.nodes.get(b);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(m){if(m){let E;if(typeof m=="string"){const f=this.getExtensionElement(m);E=f?this.nodes.get(f):void 0}else E=m;return E&&E.children||null}return this.roots}async fetchChildrenNodes(m){this.clearChildren(m);const E=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const f=m?this.nodes.get(m):void 0,u=await this.dataProvider.getChildren(m);if(E.token.isCancellationRequested)return[];const b=await Promise.all((0,i.coalesce)(u||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,f):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(b)}finally{E.dispose()}}refresh(m){if(m.some(f=>!f))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const f=this.getHandlesToRefresh(m);if(f.length)return this.refreshHandles(f)}return Promise.resolve(void 0)}getHandlesToRefresh(m){const E=new Set,f=m.map(b=>this.nodes.get(b));for(const b of f)if(b&&!E.has(b.item.handle)){let t=b;for(;t&&t.parent&&f.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(b.item.handle)}const u=[];return E.forEach(b=>{const t=this.elements.get(b);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&u.push(b)}}),u}refreshHandles(m){const E={};return Promise.all(m.map(f=>this.refreshNode(f).then(u=>{u&&(E[f]=u.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(m){const E=this.getExtensionElement(m);if(E){const f=this.nodes.get(E);if(f)return this.clearChildren(E),(0,C.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(u=>{if(u){const b=this.createTreeNode(E,u,f.parent);return this.updateNodeCache(E,b,f,f.parent),f.dispose(),b}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(m,E,f){const u=this.createTreeNode(m,E,f);if(E.id&&this.elements.has(u.item.handle))throw new Error((0,w.localize)(7,null,E.id));return this.addNodeToCache(m,u),this.addNodeToParentCache(u,f),u}getTooltip(m){return D.MarkdownString.isMarkdownString(m)?I.MarkdownString.from(m):m}getCommand(m,E){return E?this.commands.toInternal(E,m):void 0}createTreeNode(m,E,f){const u=new S.DisposableStore,b=this.createHandle(m,E,f),t=this.getLightIconPath(E);return{item:{handle:b,parentHandle:f?f.item.handle:void 0,label:h(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(u,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,k.isUndefinedOrNull)(E.collapsibleState)?D.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:f,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(m){return m.iconPath instanceof D.ThemeIcon?m.iconPath:void 0}createHandle(m,{id:E,label:f,resourceUri:u},b,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const n=h(f,this.extension),l=b?b.item.handle:o.LABEL_HANDLE_PREFIX;let a=n?n.label:u?(0,P.basename)(u):"";a=a.indexOf("/")!==-1?a.replace("/","//"):a;const s=this.nodes.has(m)?this.nodes.get(m).item.handle:void 0,c=this.getChildrenNodes(b)||[];let p,y=0;do{if(p=`${l}/${y}:${a}`,t||!this.elements.has(p)||s===p)break;y++}while(y<=c.length);return p}getLightIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon))return typeof m.iconPath=="string"||A.URI.isUri(m.iconPath)?this.getIconPath(m.iconPath):this.getIconPath(m.iconPath.light)}getDarkIconPath(m){if(m.iconPath&&!(m.iconPath instanceof D.ThemeIcon)&&m.iconPath.dark)return this.getIconPath(m.iconPath.dark)}getIconPath(m){return A.URI.isUri(m)?m:A.URI.file(m)}addNodeToCache(m,E){this.elements.set(E.item.handle,m),this.nodes.set(m,E)}updateNodeCache(m,E,f,u){this.elements.delete(E.item.handle),this.nodes.delete(m),E.item.handle!==f.item.handle&&this.elements.delete(f.item.handle),this.addNodeToCache(m,E);const b=this.getChildrenNodes(u)||[],t=b.filter(n=>n.item.handle===f.item.handle)[0];t&&b.splice(b.indexOf(t),1,E)}addNodeToParentCache(m,E){E?(E.children||(E.children=[]),E.children.push(m)):(this.roots||(this.roots=[]),this.roots.push(m))}clearChildren(m){if(m){const E=this.nodes.get(m);if(E){if(E.children)for(const f of E.children){const u=this.elements.get(f.item.handle);u&&this.clear(u)}E.children=void 0}}else this.clearAll()}clear(m){const E=this.nodes.get(m);if(E){if(E.children)for(const f of E.children){const u=this.elements.get(f.item.handle);u&&this.clear(u)}this.nodes.delete(m),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(m=>m.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(we[182],_e([0,1,15,11,20,10,69,9,7,96]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(g,m){if(m!==void 0){const E=this.testIdsToInternal.get(m),f=E==null?void 0:E.get(g);if(f)return[E,f]}return(0,w.mapFind)(this.testIdsToInternal.values(),E=>{const f=E.get(g);return f&&[E,f]})}createForHierarchy(g=()=>{}){return new r(this.createIdMap(d++),g)}createIdMap(g){const m=new h(g);return this.testIdsToInternal.set(m.id,m),{object:m,dispose:()=>this.testIdsToInternal.delete(m.id)}}}e.OwnedTestCollection=i;var I;(function(o){o[o.Disconnected=0]="Disconnected",o[o.IsChild=1]="IsChild",o[o.IsParent=2]="IsParent",o[o.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let d=0;class h{constructor(g){this.id=g,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(g){if(this.map.has(g.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${g.item.extId}`);this.map.set(g.item.extId,g),g.parent||this._roots.add(g)}has(g){return this.map.has(g)}delete(g){const m=this.map.get(g);return m?(this.map.delete(g),this._roots.delete(m),!0):!1}get(g){return this.map.get(g)}comparePositions(g,m){const E=typeof g=="string"?this.map.get(g):g,f=typeof m=="string"?this.map.get(m):m;if(!E||!f)return 0;if(E===f)return 3;for(let u=this.map.get(f.parent);u;u=this.map.get(u.parent))if(u===E)return 1;for(let u=this.map.get(E.parent);u;u=this.map.get(u.parent))if(u===f)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=h;class r{constructor(g,m){this.testIdToInternal=g,this.publishDiff=m,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new P.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(g,m){this.addItem(g,m,null)}getTestByReference(g){return this.testItemToInternal.get(g)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const m=this.diff[this.diff.length-1];if(m&&g[0]===1){if(m[0]===1&&m[1].extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}if(m[0]===0&&m[1].item.extId===g[1].extId){(0,k.applyTestItemUpdate)(m[1],g[1]);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,m){var E;const f=this.testIdToInternal.object.get(g);if(!!f){if((f.expandLevels===void 0||m>f.expandLevels)&&(f.expandLevels=m),f.expand===1){const u=this.refreshChildren(f);return u.isSettled?this.expandChildren(f,m-1):u.p.then(()=>this.expandChildren(f,m-1))}else if(f.expand===3)return((E=f.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?f.initialExpand.p.then(()=>this.expandChildren(f,m-1)):this.expandChildren(f,m-1)}}dispose(){var g;for(const m of this.testItemToInternal.values())(g=m.discoverCts)===null||g===void 0||g.dispose(!0),(0,S.getPrivateApiFor)(m.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(g,m){const E=g==null?void 0:g.actual.id;switch(m[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(g);break;case 0:this.addItem(m[1],g.src.controller,g);break;case 3:const[f,u,b]=m;switch(u){case"status":this.updateExpandability(g);break;case"range":this.pushDiff([1,{extId:E,item:{range:C.Range.from(b)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:C.MarkdownString.fromStrict(b)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[u]:b!=null?b:null}}]);break}break;default:(0,T.assertNever)(m[0])}}addItem(g,m,E){if(!(g instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);if(this.testItemToInternal.has(g))throw new Error(`Attempted to add a single TestItem ${g.id} multiple times to the tree`);if(this.testIdToInternal.object.has(g.id))throw new Error(`Attempted to insert a duplicate test item ID ${g.id}`);const f=E?E.item.extId:null,u=g.resolveHandler?1:0,b=E?E.expandLevels:1,t={controller:m,tree:this.testIdToInternal.object.id},n={actual:g,parent:f,item:C.TestItem.from(g),expandLevels:b?b-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(g,n),this.pushDiff([0,{parent:f,src:t,expand:u,item:n.item}]);const l=(0,S.getPrivateApiFor)(g);l.parent=E==null?void 0:E.actual,l.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const a of l.children.values())this.testItemToInternal.has(a)||this.addItem(a,m,n)}updateExpandability(g){var m;let E;g.actual.resolveHandler?g.actual.status===D.TestItemStatus.Pending?E=g.discoverCts?2:1:((m=g.initialExpand)===null||m===void 0||m.complete(),E=3):E=0,E!==g.expand&&(g.expand=E,this.pushDiff([1,{extId:g.actual.id,expand:E}]),E===1&&g.expandLevels!==void 0&&this.refreshChildren(g))}expandChildren(g,m){if(!(m<0)){const E=[...g.actual.children.values()].map(f=>this.expand(f.id,m)).filter(P.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(g){if(g.discoverCts&&g.discoverCts.dispose(!0),!g.actual.resolveHandler){const m=new P.DeferredPromise;return m.complete(),m}return g.expand=2,g.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(g),g.initialExpand=new P.DeferredPromise,g.actual.resolveHandler(g.discoverCts.token),g.initialExpand}pushExpandStateUpdate(g){this.pushDiff([1,{extId:g.actual.id,expand:g.expand}])}removeItem(g){var m;this.pushDiff([2,g.actual.id]);const E=[g];for(;E.length;){const f=E.pop();if(!!f){(m=f.discoverCts)===null||m===void 0||m.dispose(!0),this.testIdToInternal.object.delete(f.item.extId),this.testItemToInternal.delete(f.actual);for(const u of f.actual.children.values())E.push(this.testIdToInternal.object.get(u.id))}}}flushDiff(){const g=this.collectDiff();g.length&&this.publishDiff(g)}}e.SingleUseTestCollection=r}),define(we[183],_e([0,1,26,3,13]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class S{constructor(i){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(w.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(w.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${w.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(d=>I.add(w.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>I.has(w.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=S._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(d.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(r=>h.add(w.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!h.has(w.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(g){this._nodesSet.has(g)||(this._nodesSet.add(g),this._nodesArr.push(g))}addArc(g,m){this.addNode(g),this.addNode(m),this._arcs.has(g)?this._arcs.get(g).push(m):this._arcs.set(g,[m])}getArcs(g){return this._arcs.has(g)?this._arcs.get(g):[]}hasOnlyGoodArcs(g,m){const E=I.getArcs(g);for(let f=0;f<E.length;f++)if(!m.has(E[f]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let g of i){const m=w.ExtensionIdentifier.toKey(g.identifier);if(d.set(m,g),g.extensionDependencies)for(let E of g.extensionDependencies){const f=w.ExtensionIdentifier.toKey(E);I.addArc(m,f)}}let h=new Set;I.getNodes().filter(g=>I.getArcs(g).length===0).forEach(g=>h.add(g));let r=I.getNodes().filter(g=>!h.has(g)),o;do{o=!1;for(let g=0;g<r.length;g++){const m=r[g];I.hasOnlyGoodArcs(m,h)&&(r.splice(g,1),g--,h.add(m),o=!0)}}while(o);return r.map(g=>d.get(g))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(w.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(w.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=S;var C;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(C||(C={}));function D(k,i){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==d)return I-d;const h=A.posix.basename(k.extensionLocation.path),r=A.posix.basename(i.extensionLocation.path);return h<r?-1:h>r?1:0}}),define(we[184],_e([0,1,24]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var P;(function(C){C[C.VersionMismatch=55]="VersionMismatch",C[C.UnexpectedError=81]="UnexpectedError"})(P=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(C){C[C.Initialized=0]="Initialized",C[C.Ready=1]="Ready",C[C.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(C){const D=w.VSBuffer.alloc(1);switch(C){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function S(C,D){if(C.byteLength!==1)return!1;switch(C.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=S}),define(we[33],_e([0,1,3,2,4,26,150]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class C{constructor(E){this.dependency=E}}e.MissingExtensionDependency=C;var D;(function(m){m[m.LocalProcess=0]="LocalProcess",m[m.LocalWebWorker=1]="LocalWebWorker",m[m.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(E,f,u,b){this.codeLoadingTime=E,this.activateCallTime=f,this.activateResolvedTime=u,this.activationReason=b}}e.ActivationTimes=k;class i{constructor(E,f){this.description=E,this.value=f}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(m){m[m.Normal=0]="Normal",m[m.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function d(m){m.enableProposedApi||h(m)}e.checkProposedApiEnabled=d;function h(m){throw new Error(`[${m.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${m.identifier.value}`)}e.throwProposedApiError=h;function r(m){return{type:m.isBuiltin?0:1,isBuiltin:m.isBuiltin||m.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(m.publisher,m.name),uuid:m.uuid},manifest:m,location:m.extensionLocation}}e.toExtension=r;function o(m){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(m.identifier.id),isBuiltin:m.type===0,isUserBuiltin:m.type===1&&m.isBuiltin,isUnderDevelopment:!1,extensionLocation:m.location},m.manifest),{uuid:m.identifier.uuid})}e.toExtensionDescription=o;class g{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,f){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,f,u,b,t){}_onDidActivateExtensionError(E,f){}_onExtensionRuntimeError(E,f){}_onExtensionHostExit(E){}}e.NullExtensionService=g}),define(we[185],_e([0,1,26,33,18]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class S{constructor(r,o,g,m){this.startup=r,this.codeLoadingTime=o,this.activateCallTime=g,this.activateResolvedTime=m}}e.ExtensionActivationTimes=S,S.NONE=new S(!1,-1,-1,-1);class C{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,o){return r===-1||o===-1?-1:o-r}build(){return new S(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=C;class D{constructor(r,o,g,m,E,f){this.activationFailed=r,this.activationFailedError=o,this.activationTimes=g,this.module=m,this.exports=E,this.subscriptions=f}}e.ActivatedExtension=D;class k extends D{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends D{constructor(){super(!1,null,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends D{constructor(r){super(!0,r,S.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let d=class{constructor(r,o,g,m,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,o.forEach(f=>this._resolvedExtensionsSet.add(w.ExtensionIdentifier.toKey(f))),this._hostExtensionsMap=new Map,g.forEach(f=>this._hostExtensionsMap.set(w.ExtensionIdentifier.toKey(f),f)),this._host=m,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const o=w.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(o)}getActivatedExtension(r){const o=w.ExtensionIdentifier.toKey(r),g=this._activatedExtensions.get(o);if(!g)throw new Error("Extension `"+r.value+"` is not known or not activated");return g}activateByEvent(r,o){if(this._alreadyActivatedEvents[r])return T;const g=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(g.map(m=>({id:m.identifier,reason:{startup:o,extensionId:m.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,o){const g=this._registry.getExtensionDescription(r);if(!g)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:g.identifier,reason:o}])}_handleActivateRequest(r,o,g){if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(r.id))){o[w.ExtensionIdentifier.toKey(r.id)]=r;return}const m=this._registry.getExtensionDescription(r.id);if(!m){const u=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,u,new P.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(r.id),new I(u));return}const E=typeof m.extensionDependencies=="undefined"?[]:m.extensionDependencies;let f=!0;for(let u=0,b=E.length;u<b;u++){const t=E[u];if(!this._resolvedExtensionsSet.has(w.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(w.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const c=m.displayName||m.identifier.value,p=this._registry.getExtensionDescription(t),y=p&&p.displayName||t,v=new Error(`Cannot activate the '${c}' extension because its dependency '${y}' failed to activate`);v.detail=n.activationFailedError,this._host.onExtensionActivationError(m.identifier,v,null),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(m.identifier),new I(v));return}if(this._hostExtensionsMap.has(w.ExtensionIdentifier.toKey(t))){f=!1,o[w.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(w.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const l=this._registry.getExtensionDescription(t);if(l){f=!1,o[w.ExtensionIdentifier.toKey(t)]={id:l.identifier,reason:r.reason};continue}const a=m.displayName||m.identifier.value,s=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(m.identifier,s,new P.MissingExtensionDependency(t)),this._activatedExtensions.set(w.ExtensionIdentifier.toKey(m.identifier),new I(s));return}}}f?o[w.ExtensionIdentifier.toKey(m.identifier)]=r:g.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(w.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const o=Object.create(null),g=[];for(let E=0,f=r.length;E<f;E++)this._handleActivateRequest(r[E],o,g);for(let E=0,f=g.length;E<f;E++){const u=w.ExtensionIdentifier.toKey(g[E].id);o[u]&&delete o[u]}const m=Object.keys(o).map(E=>o[E]);return g.length===0?Promise.all(m.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(m).then(E=>this._activateExtensions(g))}_activateExtension(r,o){const g=w.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(g))return Promise.resolve(void 0);const m=this._activatingExtensions.get(g);if(m)return m;const E=this._host.actualActivateExtension(r,o).then(void 0,f=>{const u=new Error;return f&&f.name&&(u.name=f.name),f&&f.message?u.message=`Activating extension '${r.value}' failed: ${f.message}.`:u.message=`Activating extension '${r.value}' failed: ${f}.`,f&&f.stack&&(u.stack=f.stack),this._host.onExtensionActivationError(r,u,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(f),new I(f)}).then(f=>{this._activatedExtensions.set(g,f),this._activatingExtensions.delete(g)});return this._activatingExtensions.set(g,E),E}};d=Ve([qe(4,A.ILogService)],d),e.ExtensionsActivator=d}),define(we[186],_e([0,1,12]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class P{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,S)=>{this._actualOk=T,this._actualErr=S,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,w.onUnexpectedError)(T))}then(T,S){return this._ensureActual().then(T,S)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=P}),define(we[98],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class w{constructor(D,k){this.isMain=D,this.sid=k,this.nid=++w.count}}e.ProxyIdentifier=w,w.count=0;const P=[];function A(C){const D=new w(!0,C);return P[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function T(C){const D=new w(!1,C);return P[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function S(C){return P[C].sid}e.getStringIdentifierForProxy=S}),define(we[5],_e([0,1,2,98,57]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var S;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(S=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(k=e.CellKind||(e.CellKind={}));var i;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var d;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(d=e.CandidatePortSource||(e.CandidatePortSource={}));var h;(function(u){u.name="$ident";function b(n,l){return Object.defineProperty(n,u.name,{value:l,enumerable:!0}),n}u.mixin=b;function t(n){return n[u.name]}u.of=t})(h=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(b){return b._id=r._n++,b}}e.IdObject=r,r._n=0;var o;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(m=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(u){if(u&&u.edits)for(const b of u.edits)typeof b.resource=="object"?b.resource=w.URI.revive(b.resource):(b.newUri=w.URI.revive(b.newUri),b.oldUri=w.URI.revive(b.oldUri)),b.metadata&&b.metadata.iconPath&&(b.metadata=(0,A.revive)(b.metadata));return u}e.reviveWorkspaceEditDto=E;var f;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,P.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,P.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,P.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,P.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,P.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,P.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,P.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,P.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,P.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,P.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,P.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,P.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,P.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,P.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,P.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,P.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,P.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,P.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,P.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,P.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,P.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,P.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,P.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,P.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,P.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,P.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,P.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,P.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,P.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,P.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,P.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,P.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,P.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,P.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,P.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,P.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,P.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,P.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,P.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,P.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,P.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,P.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,P.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,P.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,P.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,P.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,P.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,P.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,P.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,P.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,P.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,P.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,P.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,P.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,P.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,P.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,P.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,P.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,P.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,P.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,P.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,P.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,P.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,P.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,P.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,P.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,P.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,P.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,P.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,P.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,P.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,P.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,P.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,P.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,P.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,P.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,P.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,P.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,P.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,P.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,P.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,P.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,P.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,P.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,P.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(we[74],_e([0,1,5,3,4]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(C){this._onDidChangePassword=new P.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=C.getProxy(w.MainContext.MainThreadSecretState)}async $onDidChangePassword(C){this._onDidChangePassword.fire(C)}get(C,D){return this._proxy.$getPassword(C,D)}store(C,D,k){return this._proxy.$setPassword(C,D,k)}delete(C,D){return this._proxy.$deletePassword(C,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(we[75],_e([0,1,4,18,5,14]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,w.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(D,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,k,i){const I=this.getUsageKey(D,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:D}))}getUsageKey(D,k){return`${D}-${k.identifier.value}`}};S=Ve([qe(0,T.IExtHostRpcService),qe(1,P.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(C,D,k){}})}),define(we[187],_e([0,1,3,5,7,26]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new w.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new w.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,k,i,I={}){const d=T.ExtensionIdentifier.toKey(D.identifier),h=this._inFlightRequests.get(d)||[],r=i.sort().join(" ");let o=h.find(g=>g.scopes===r);if(o)return o.result;{const g=this._getSession(D,d,k,i,I);o={scopes:r,result:g},h.push(o),this._inFlightRequests.set(d,h);try{await g}finally{const m=h.findIndex(E=>E.scopes===r);m>-1&&(h.splice(m),this._inFlightRequests.set(d,h))}return g}}async _getSession(D,k,i,I,d={}){await this._proxy.$ensureProvider(i);const h=D.displayName||D.name;return this._proxy.$getSession(i,I,k,h,d)}async removeSession(D,k){const i=this._authenticationProviders.get(D);return i?i.provider.removeSession(k):this._proxy.$removeSession(D,k)}registerAuthenticationProvider(D,k,i,I){var d;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:k,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===D)||this._providers.push({id:D,label:k});const h=i.onDidChangeSessions(r=>{var o,g,m;this._proxy.$sendDidChangeSessions(D,{added:(o=r.added)!==null&&o!==void 0?o:[],changed:(g=r.changed)!==null&&g!==void 0?g:[],removed:(m=r.removed)!==null&&m!==void 0?m:[]})});return this._proxy.$registerAuthenticationProvider(D,k,(d=I==null?void 0:I.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new A.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(D);const r=this._providers.findIndex(o=>o.id===D);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,k){const i=this._authenticationProviders.get(D);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,k){return this._onDidChangeSessions.fire({provider:{id:D,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,k){return D.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const I=this._providers.findIndex(d=>d.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(we[188],_e([0,1,5,14,9]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(C,D){this._extHostDocumentsAndEditors=D,this._proxy=C.getProxy(w.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(C){const D=A.WorkspaceEdit.from(C,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=Ve([qe(0,P.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(we[189],_e([0,1,5]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(T){const S=T.getProxy(w.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(C){return S.$writeText(C)}})}}e.ExtHostClipboard=P}),define(we[76],_e([0,1,10,7,9,23,5,15,18,57,32,38,2,6,4,14]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let g=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(S.MainContext.MainThreadCommands),this._logService=n,this.converter=new m(this,l=>{const a=this._apiCommands.get(l);return(a==null?void 0:a.result)===f.Void?a:void 0},n),this._argumentProcessors=[{processArgument(l){return(0,k.revive)(l)}},{processArgument(l){return(0,T.cloneAndChange)(l,function(a){if(i.Range.isIRange(a))return A.Range.to(a);if(I.Position.isIPosition(a))return A.Position.to(a);if(i.Range.isIRange(a.range)&&d.URI.isUri(a.uri))return A.location.to(a);if(!Array.isArray(a))return a})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...l)=>{const a=t.args.map((c,p)=>{if(!c.validate(l[p]))throw new Error(`Invalid argument '${c.name}' when running '${t.id}', received: ${l[p]}`);return c.convert(l[p])}),s=await this.executeCommand(t.internalId,...a);return t.result.convert(s,l,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,l,a,s){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:l,thisArg:a,description:s}),t&&this._proxy.$registerCommand(n),new P.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,l){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const a=(0,T.cloneAndChange)(n,function(s){if(s instanceof P.Position)return A.Position.from(s);if(s instanceof P.Range)return A.Range.from(s);if(s instanceof P.Location)return A.location.from(s);if(!Array.isArray(s))return s});try{const s=await this._proxy.$executeCommand(t,a,l);return(0,k.revive)(s)}catch(s){if(s instanceof Error&&s.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw s}}}async _executeContributedCommand(t,n){const l=this._commands.get(t);if(!l)throw new Error("Unknown command");let{callback:a,thisArg:s,description:c}=l;if(c)for(let p=0;p<c.args.length;p++)try{(0,w.validateConstraint)(n[p],c.args[p].constraint)}catch(y){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${c.args[p].name}' - ${c.args[p].description}`)}try{return await a.apply(s,n)}catch(p){if(t===this.converter.delegatingCommandId){const y=this.converter.getActualCommand(...n);y&&(t=y.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(l=>this._argumentProcessors.reduce((a,s)=>s.processArgument(a),l)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(l=>l[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,l]of this._commands){let{description:a}=l;a&&(t[n]=a)}return Promise.resolve(t)}};g=Ve([qe(0,o.IExtHostRpcService),qe(1,D.ILogService)],g),e.ExtHostCommands=g,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class m{constructor(t,n,l){this._commands=t,this._lookupApiCommand=n,this._logService=l,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const l={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return l;const a=this._lookupApiCommand(t.command);if(a)l.id=a.internalId,l.arguments=a.args.map((s,c)=>s.convert(t.arguments&&t.arguments[c]));else if((0,C.isNonEmptyArray)(t.arguments)){const s=++this._cachIdPool;this._cache.set(s,t),n.add((0,h.toDisposable)(()=>{this._cache.delete(s),this._logService.trace("CommandsConverter#DISPOSE",s)})),l.$ident=s,l.id=this.delegatingCommandId,l.arguments=[s],this._logService.trace("CommandsConverter#CREATE",t.command,s)}return l}}fromInternal(t){const n=S.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=m;class E{constructor(t,n,l,a){this.name=t,this.description=n,this.validate=l,this.convert=a}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",b=>d.URI.isUri(b),b=>b),E.Position=new E("position","A position in a text document",b=>P.Position.isPosition(b),A.Position.from),E.Range=new E("range","A range in a text document",b=>P.Range.isRange(b),A.Range.from),E.Selection=new E("selection","A selection in a text document",b=>P.Selection.isSelection(b),A.Selection.from),E.Number=new E("number","",b=>typeof b=="number",b=>b),E.String=new E("string","",b=>typeof b=="string",b=>b),E.CallHierarchyItem=new E("item","A call hierarchy item",b=>b instanceof P.CallHierarchyItem,A.CallHierarchyItem.to);class f{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=f,f.Void=new f("no result",b=>b);class u{constructor(t,n,l,a,s){this.id=t,this.internalId=n,this.description=l,this.args=a,this.result=s}}e.ApiCommand=u}),define(we[190],_e([0,1,6,9,7,62,76,168,15,87]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(P.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if(!(0,D.isFalsyOrEmpty)(r)){class g extends A.SymbolInformation{static to(E){const f=new g(E.name,P.SymbolKind.to(E.kind),E.containerName||"",new A.Location(o[0],P.Range.to(E.range)));return f.detail=E.detail,f.range=f.location.range,f.selectionRange=P.Range.to(E.selectionRange),f.children=E.children?E.children.map(g.to):[],f}}return r.map(g.to)}})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(P.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(P.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new S.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(P.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",h)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(P.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(P.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>A.Position.isPosition(o)),r=>r.map(P.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let g;for(const m of o.reverse())g=new A.SelectionRange(P.Range.to(m),g);return g}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const o=[];if(Array.isArray(r))for(let g of r)o.push(...g[1].map(P.WorkspaceSymbol.to));return o})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(P.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(P.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(P.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return P.WorkspaceEdit.to(r)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(P.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,k.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new A.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,k.decodeSemanticTokensDto)(r);if(o.type==="full")return new A.SemanticTokens(o.data,void 0)}})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,g)=>{if(!r)return new A.CompletionList([]);const m=r.suggestions.map(E=>P.CompletionItem.to(E,g));return new A.CompletionList(m,r.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return P.SignatureHelp.to(r)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,g)=>d(m=>new A.CodeLens(P.Range.to(m.range),m.command&&g.fromInternal(m.command)))(r))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.Range.isRange(r),r=>A.Selection.isSelection(r)?P.Selection.from(r):P.Range.from(r)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,g)=>d(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal(m.command)}else{const E=new A.CodeAction(m.title,m.kind?new A.CodeActionKind(m.kind):void 0);return m.edit&&(E.edit=P.WorkspaceEdit.to(m.edit)),m.command&&(E.command=g.fromInternal(m.command)),E.isPreferred=m.isPreferred,E}})(r))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new A.ColorInformation(P.Range.to(o.range),P.Color.to(o.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",r=>r instanceof A.Color,P.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:P.Range.from(r.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(P.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(P.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>P.NotebookExclusiveDocumentPattern.to(o))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(P.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[P.ViewColumn.from(r.viewColumn),P.TextEditorOpenOptions.from(r)]).optional()],S.ApiCommandResult.Void)];class I{constructor(o){this._disposables=new w.DisposableStore,this._commands=o}static register(o){return i.forEach(o.registerApiCommand,o),new I(o).registerCommands()}registerCommands(){const o=g=>(...m)=>g(this._commands,...m);this._register(C.RemoveFromRecentlyOpenedAPICommand.ID,o(C.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:g=>typeof g=="string"}]}),this._register(C.OpenIssueReporter.ID,o(C.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:g=>typeof g=="string"||typeof g=="object"&&typeof g.extensionId=="string"}]})}_register(o,g,m){const E=this._commands.registerCommand(!1,o,g,this,m);this._disposables.add(E)}}e.ExtHostApiCommands=I;function d(r){return o=>{if(Array.isArray(o))return o.map(r)}}function h(r){if(!!Array.isArray(r)){const o=[];for(const g of r)T.isLocationLink(g)?o.push(P.DefinitionLink.to(g)):o.push(P.location.to(g));return o}}}),define(we[191],_e([0,1,11,52,3,6,2,62,26,9,7,5]),function(Q,e,w,P,A,T,S,C,D,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(u,b,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=u.getProxy(I.MainContext.MainThreadComments),b.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const l=this._commentControllers.get(n.handle);return l||n}else if(n&&n.$mid===7){const l=this._commentControllers.get(n.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.commentThreadHandle);return a||n}else if(n&&n.$mid===8){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);return a?{thread:a,text:n.text}:n}else if(n&&n.$mid===9){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let s=n.commentUniqueId,c=a.getCommentByUniqueId(s);return c||n}else if(n&&n.$mid===10){const l=this._commentControllers.get(n.thread.commentControlHandle);if(!l)return n;const a=l.getCommentThread(n.thread.commentThreadHandle);if(!a)return n;let s=n.text,c=n.commentUniqueId,p=a.getCommentByUniqueId(c);return p?(p.body=s,p):n}return n}})}createCommentController(u,b,t){const n=d.handlePool++,l=new r(u,n,this._proxy,b,t);this._commentControllers.set(l.handle,l);const a=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(u.identifier))||[];return a.push(l),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(u.identifier),a),l}$createCommentThreadTemplate(u,b,t){const n=this._commentControllers.get(u);!n||n.$createCommentThreadTemplate(b,t)}async $updateCommentThreadTemplate(u,b,t){const n=this._commentControllers.get(u);!n||n.$updateCommentThreadTemplate(b,t)}$deleteCommentThread(u,b){const t=this._commentControllers.get(u);t&&t.$deleteCommentThread(b)}$provideCommentingRanges(u,b,t){const n=this._commentControllers.get(u);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const l=this._documents.getDocument(S.URI.revive(b));return(0,w.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(l,t)).then(a=>a?a.map(s=>k.Range.from(s)):void 0)}$toggleReaction(u,b,t,n,l){const a=this._commentControllers.get(u);return!a||!a.reactionHandler?Promise.resolve(void 0):(0,w.asPromise)(()=>{const s=a.getCommentThread(b);if(s){const c=s.getCommentByUniqueId(n.uniqueIdInThread);if(a!==void 0&&c&&a.reactionHandler)return a.reactionHandler(c,m(l))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class h{constructor(u,b,t,n,l,a,s){this._proxy=u,this._commentController=b,this._id=t,this._uri=n,this._range=l,this._comments=a,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${b.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),s),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=a}set threadId(u){this._id=u}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(u){u.isEqual(this._range)||(this._range=u,this.modifications.range=u,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(u){this._canReply!==u&&(this._canReply=u,this.modifications.canReply=u,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(u){this._label=u,this.modifications.label=u,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(u){this._contextValue=u,this.modifications.contextValue=u,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(u){this._comments=u,this.modifications.comments=u,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(u){this._collapseState=u,this.modifications.collapsibleState=u,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const u=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),b={};u("range")&&(b.range=k.Range.from(this._range)),u("label")&&(b.label=this.label),u("contextValue")&&(b.contextValue=this.contextValue),u("comments")&&(b.comments=this._comments.map(t=>o(this,this._commentController,t,this._commentsMap))),u("collapsibleState")&&(b.collapseState=E(this._collapseState)),u("canReply")&&(b.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,b)}}getCommentByUniqueId(u){for(let b of this._commentsMap){let t=b[0],n=b[1];if(u===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(u=>u.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([(0,P.debounce)(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class r{constructor(u,b,t,n,l){this._extension=u,this._handle=b,this._proxy=t,this._id=n,this._label=l,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,l)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(u){this._reactionHandler=u,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this._options}set options(u){this._options=u,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(u,b,t,n){if(typeof u=="string"){const l=new h(this._proxy,this,u,b,t,n,this._extension.identifier);return this._threads.set(l.handle,l),l}else{const l=new h(this._proxy,this,void 0,u,b,t,this._extension.identifier);return this._threads.set(l.handle,l),l}}$createCommentThreadTemplate(u,b){const t=new h(this._proxy,this,void 0,S.URI.revive(u),k.Range.to(b),[],this._extension.identifier);return t.collapsibleState=C.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(u,b){let t=this._threads.get(u);t&&(t.range=k.Range.to(b))}$deleteCommentThread(u){let b=this._threads.get(u);b&&b.dispose(),this._threads.delete(u)}getCommentThread(u){return this._threads.get(u)}dispose(){this._threads.forEach(u=>{u.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function o(f,u,b,t){let n=t.get(b);n||(n=++f.commentHandle,t.set(b,n));const l=b.author&&b.author.iconPath?b.author.iconPath.toString():void 0;return{mode:b.mode,contextValue:b.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(b.body),userName:b.author.name,userIconPath:l,label:b.label,commentReactions:b.reactions?b.reactions.map(a=>g(a)):void 0}}function g(f){return{label:f.label,iconPath:f.iconPath?k.pathOrURIToURI(f.iconPath):void 0,count:f.count,hasReacted:f.authorHasReacted}}function m(f){return{label:f.label||"",count:f.count||0,iconPath:f.iconPath?S.URI.revive(f.iconPath):"",authorHasReacted:f.hasReacted||!1}}function E(f){if(f!==void 0)switch(f){case i.CommentThreadCollapsibleState.Expanded:return C.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return C.CommentThreadCollapsibleState.Collapsed}return C.CommentThreadCollapsibleState.Collapsed}}),define(we[99],_e([0,1,2,5,7,4,14,18,15,8,13]),function(Q,e,w,P,A,T,S,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(h,r){this._logService=r,this._provider=new Map,this._proxy=h.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,r){const o=wn._handlePool++;this._provider.set(o,{provider:h,extensionId:r}),this._proxy.$registerDecorationProvider(o,r.value);const g=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(m=>{if(!m){this._proxy.$onDidChange(o,null);return}let E=(0,D.asArray)(m);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const f=E.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),u=(0,D.groupBy)(f,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let b=[];e:for(let t of u){let n;for(let l of t){let a=(0,i.dirname)(l.uri.path);if(n!==a&&(n=a,b.push(l.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(o,b)});return new A.Disposable(()=>{g==null||g.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(h,r,o){if(!this._provider.has(h))return Object.create(null);const g=Object.create(null),{provider:m,extensionId:E}=this._provider.get(h);return await Promise.all(r.map(async f=>{try{const{uri:u,id:b}=f,t=await Promise.resolve(m.provideFileDecoration(w.URI.revive(u),o));if(!t)return;try{A.FileDecoration.validate(t),g[b]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(u){this._logService.error(u)}})),g}};I._handlePool=0,I._maxEventSize=250,I=Ve([qe(0,S.IExtHostRpcService),qe(1,C.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(we[192],_e([0,1,131,90,2,5,7,9,3,18,22]),function(Q,e,w,P,A,T,S,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(r,o,g,m,E){this._name=r,this._owner=o,this._maxDiagnosticsPerFile=g,this._proxy=m,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,o){if(!r){this.clear();return}this._checkDisposed();let g=[];if(A.URI.isUri(r)){if(!o){this.delete(r);return}this._data.set(r,o.slice()),g=[r]}else if(Array.isArray(r)){g=[];let E;r=[...r].sort(I._compareIndexedTuplesByUri);for(const f of r){const[u,b]=f;if((!E||u.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=u,g.push(u),this._data.set(u,[])),b){const t=this._data.get(u);t&&t.push(...b)}else{const t=this._data.get(u);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(g),!!this._proxy){const m=[];for(let E of g){let f=[];const u=this._data.get(E);if(u)if(u.length>this._maxDiagnosticsPerFile){f=[];const b=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of u)if(n.severity===b[t]&&f.push(C.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;f.push({severity:P.MarkerSeverity.Info,message:(0,w.localize)(0,null,u.length-this._maxDiagnosticsPerFile),startLineNumber:f[f.length-1].startLineNumber,startColumn:f[f.length-1].startColumn,endLineNumber:f[f.length-1].endLineNumber,endColumn:f[f.length-1].endColumn})}else f=u.map(b=>C.Diagnostic.from(b));m.push([E,f])}this._proxy.$changeMany(this._owner,m)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,o){this._checkDisposed();for(let g of this._data.keys())r.apply(o,[g,this.get(g),this])}get(r){this._checkDisposed();const o=this._data.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=I;let d=class Vt{constructor(r,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,o){return r?r.concat(o):o}static _mapper(r){const o=[],g=new Set;for(const m of r)typeof m=="string"?g.has(m)||(g.add(m),o.push(A.URI.parse(m))):g.has(m.toString())||(g.add(m.toString()),o.push(m));return Object.freeze(o),{uris:o}}createDiagnosticCollection(r,o){const{_collections:g,_proxy:m,_onDidChangeDiagnostics:E,_logService:f}=this,u=new class{$changeMany(n,l){m.$changeMany(n,l),f.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,l.length===0?"CLEARING":l)}$clear(n){m.$clear(n),f.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){m.dispose()}};let b;if(!o)o="_generated_diagnostic_collection_name_#"+Vt._idPool++,b=o;else if(!g.has(o))b=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do b=o+Vt._idPool++;while(g.has(b))}return new class extends I{constructor(){super(o,b,Vt._maxDiagnosticsPerFile,u,E);g.set(b,this)}dispose(){super.dispose(),g.delete(b)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const o=new Map,g=[];for(const m of this._collections.values())m.forEach((E,f)=>{let u=o.get(E.toString());typeof u=="undefined"&&(u=g.length,o.set(E.toString(),u),g.push([E,[]])),g[u][1]=g[u][1].concat(...f)});return g}}_getDiagnostics(r){let o=[];for(let g of this._collections.values())g.has(r)&&(o=o.concat(g.get(r)));return o}$acceptMarkersChange(r){if(!this._mirrorCollection){const o="_generated_mirror",g=new I(o,o,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,g),this._mirrorCollection=g}for(const[o,g]of r)this._mirrorCollection.set(A.URI.revive(o),g.map(C.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=Ve([qe(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(we[193],_e([0,1,2,5]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(S){this._proxy=S.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(S){return this._proxy.$showOpenDialog(S).then(C=>C?C.map(D=>w.URI.revive(D)):void 0)}showSaveDialog(S){return this._proxy.$showSaveDialog(S).then(C=>C?w.URI.revive(C):void 0)}}e.ExtHostDialogs=A}),define(we[194],_e([0,1,12,2,7,5,19,20,8]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,d,h){this._documentsAndEditors=d,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,d){if(Object.keys(S.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=k._handlePool++;this._documentContentProviders.set(h,d),this._proxy.$registerTextContentProvider(h,I);let r;return typeof d.onDidChange=="function"&&(r=d.onDidChange(o=>{if(o.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(h,o).then(g=>{if(!(!g&&typeof g!="string")){const m=this._documentsAndEditors.getDocument(o);if(!!m){const E=(0,D.splitLines)(g);if(!m.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,g)}}},w.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(I,d){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(P.URI.revive(d),C.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(we[195],_e([0,1,3,6,2,5,95,9,10,23]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,h){this._onDidAddDocument=new w.Emitter,this._onDidRemoveDocument=new w.Emitter,this._onDidChangeDocument=new w.Emitter,this._onDidSaveDocument=new w.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new P.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!!d){const h=this._documentsAndEditors.getDocument(d);if(h)return h}}getDocument(d){const h=this.getDocumentData(d);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return h.document}ensureDocumentData(d){const h=this._documentsAndEditors.getDocument(d);if(h)return Promise.resolve(h);let r=this._documentLoader.get(d.toString());return r||(r=this._proxy.$tryOpenDocument(d).then(o=>{this._documentLoader.delete(d.toString());const g=A.URI.revive(o);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(g))},o=>(this._documentLoader.delete(d.toString()),Promise.reject(o))),this._documentLoader.set(d.toString(),r)),r}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(h=>A.URI.revive(h))}$acceptModelModeChanged(d,h){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(h),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(d){const h=A.URI.revive(d),r=this._documentsAndEditors.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(d,h){const r=A.URI.revive(d),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this._onDidChangeDocument.fire({document:o.document,contentChanges:[]})}$acceptModelChanged(d,h,r){const o=A.URI.revive(d),g=this._documentsAndEditors.getDocument(o);if(!g)throw new Error("unknown document");g._acceptIsDirty(r),g.onEvents(h),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:g.document,contentChanges:h.changes.map(m=>({range:C.Range.to(m.range),rangeOffset:m.rangeOffset,rangeLength:m.rangeLength,text:m.text}))}))}setWordDefinitionFor(d,h){(0,S.setWordDefinitionFor)(d,h)}}e.ExtHostDocuments=i}),define(we[39],_e([0,1,42,3,6,2,4,5,95,14,97,9,18,22,19,43,108]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class m{constructor(u){this.value=u,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(u,b){this._extHostRpc=u,this._logService=b,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new P.Emitter,this._onDidRemoveDocuments=new P.Emitter,this._onDidChangeVisibleTextEditors=new P.Emitter,this._onDidChangeActiveTextEditor=new P.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(u){this.acceptDocumentsAndEditorsDelta(u)}acceptDocumentsAndEditorsDelta(u){const b=[],t=[],n=[];if(u.removedDocuments)for(const l of u.removedDocuments){const a=T.URI.revive(l),s=this._documents.get(a);(s==null?void 0:s.unref())&&(this._documents.delete(a),b.push(s.value))}if(u.addedDocuments)for(const l of u.addedDocuments){const a=T.URI.revive(l.uri);let s=this._documents.get(a);if(s&&a.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${a} already exists!'`);s||(s=new m(new D.ExtHostDocumentData(this._extHostRpc.getProxy(C.MainContext.MainThreadDocuments),a,l.lines,l.EOL,l.versionId,l.modeId,l.isDirty,l.notebook)),this._documents.set(a,s),t.push(s.value)),s.ref()}if(u.removedEditors)for(const l of u.removedEditors){const a=this._editors.get(l);this._editors.delete(l),a&&n.push(a)}if(u.addedEditors)for(const l of u.addedEditors){const a=T.URI.revive(l.documentUri);w.ok(this._documents.has(a),`document '${a}' does not exist`),w.ok(!this._editors.has(l.id),`editor '${l.id}' already exists!`);const s=this._documents.get(a).value,c=new i.ExtHostTextEditor(l.id,this._extHostRpc.getProxy(C.MainContext.MainThreadTextEditors),this._logService,new g.Lazy(()=>s.document),l.selections.map(I.Selection.to),l.options,l.visibleRanges.map(p=>I.Range.to(p)),typeof l.editorPosition=="number"?I.ViewColumn.to(l.editorPosition):void 0);this._editors.set(l.id,c)}u.newActiveEditor!==void 0&&(w.ok(u.newActiveEditor===null||this._editors.has(u.newActiveEditor),`active editor '${u.newActiveEditor}' does not exist`),this._activeEditorId=u.newActiveEditor),(0,A.dispose)(b),(0,A.dispose)(n),u.removedDocuments&&this._onDidRemoveDocuments.fire(b),u.addedDocuments&&this._onDidAddDocuments.fire(t),(u.removedEditors||u.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(l=>l.value)),u.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(u){var b;return(b=this._documents.get(u))===null||b===void 0?void 0:b.value}allDocuments(){return o.Iterable.map(this._documents.values(),u=>u.value)}getEditor(u){return this._editors.get(u)}activeEditor(u){if(!!this._activeEditorId){const b=this._editors.get(this._activeEditorId);return u?b:b==null?void 0:b.value}}allEditors(){return[...this._editors.values()]}};E=Ve([qe(0,k.IExtHostRpcService),qe(1,d.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[196],_e([0,1,2,5,6,7,9,118,8,24]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const r=this._schemes.indexOf(h);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),r=[];let o,g,m=14,E=14;for(const f of h){let u=o?(0,D.commonPrefixLength)(o,f):0;for(u===0?g=1:g=E;u<f.length;u++)u+1===f.length?(m=E,E=9):E+=1,r.push([g,f.toUpperCase().charCodeAt(u),E]),r.push([g,f.toLowerCase().charCodeAt(u),E]),g=E;o=f,E=m}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new C.StateMachine(r)}}provideDocumentLinks(h){this._initStateMachine();const r=[],o=C.LinkComputer.computeLinks({getLineContent(g){return h.lineAt(g-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const g of o){const m=S.DocumentLink.to(g);m.target&&r.push(m)}return r}}class I{constructor(h,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=h.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,r,o,g={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const m=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(m,o);let E=2;g.isCaseSensitive&&(E+=1024),g.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(m,r,E).catch(u=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${r}`),console.error(u)});const f=o.onDidChangeFile(u=>{const b=[];for(const t of u){let{uri:n,type:l}=t;if(n.scheme===r){let a;switch(l){case T.FileChangeType.Changed:a=0;break;case T.FileChangeType.Created:a=1;break;case T.FileChangeType.Deleted:a=2;break;default:throw new Error("Unknown FileChangeType")}b.push({resource:n,type:a})}}this._proxy.$onFileSystemChange(m,b)});return(0,A.toDisposable)(()=>{f.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(m),this._proxy.$unregisterProvider(m)})}static _asIStat(h){const{type:r,ctime:o,mtime:g,size:m}=h;return{type:r,ctime:o,mtime:g,size:m}}$stat(h,r){return Promise.resolve(this._getFsProvider(h).stat(w.URI.revive(r))).then(I._asIStat)}$readdir(h,r){return Promise.resolve(this._getFsProvider(h).readDirectory(w.URI.revive(r)))}$readFile(h,r){return Promise.resolve(this._getFsProvider(h).readFile(w.URI.revive(r))).then(o=>k.VSBuffer.wrap(o))}$writeFile(h,r,o,g){return Promise.resolve(this._getFsProvider(h).writeFile(w.URI.revive(r),o.buffer,g))}$delete(h,r,o){return Promise.resolve(this._getFsProvider(h).delete(w.URI.revive(r),o))}$rename(h,r,o,g){return Promise.resolve(this._getFsProvider(h).rename(w.URI.revive(r),w.URI.revive(o),g))}$copy(h,r,o,g){const m=this._getFsProvider(h);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(r),w.URI.revive(o),g))}$mkdir(h,r){return Promise.resolve(this._getFsProvider(h).createDirectory(w.URI.revive(r)))}$watch(h,r,o,g){const m=this._getFsProvider(h).watch(w.URI.revive(o),g);this._watches.set(r,m)}$unwatch(h,r){const o=this._watches.get(r);o&&(o.dispose(),this._watches.delete(r))}$open(h,r,o){const g=this._getFsProvider(h);if(!g.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(g.open(w.URI.revive(r),o))}$close(h,r){const o=this._getFsProvider(h);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(h,r,o,g){const m=this._getFsProvider(h);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const E=k.VSBuffer.alloc(g);return Promise.resolve(m.read(r,o,E.buffer,0,g)).then(f=>E.slice(0,f))}$write(h,r,o,g){const m=this._getFsProvider(h);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(r,o,g.buffer,0,g.byteLength))}_getFsProvider(h){const r=this._fsProvider.get(h);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=I}),define(we[77],_e([0,1,5,64,7,24,4,14,49]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ot{constructor(I,d){const h=I.getProxy(w.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return h.$stat(r).catch(Ot._handleError)},readDirectory(r){return h.$readdir(r).catch(Ot._handleError)},createDirectory(r){return h.$mkdir(r).catch(Ot._handleError)},async readFile(r){return h.$readFile(r).then(o=>o.buffer).catch(Ot._handleError)},writeFile(r,o){return h.$writeFile(r,T.VSBuffer.wrap(o)).catch(Ot._handleError)},delete(r,o){return h.$delete(r,Object.assign({recursive:!1,useTrash:!1},o)).catch(Ot._handleError)},rename(r,o,g){return h.$rename(r,o,Object.assign({overwrite:!1},g)).catch(Ot._handleError)},copy(r,o,g){return h.$copy(r,o,Object.assign({overwrite:!1},g)).catch(Ot._handleError)},isWritableFileSystem(r){const o=d.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new A.FileSystemError(String(I));if(I.name==="ENOPRO")throw A.FileSystemError.Unavailable(I.message);switch(I.name){case P.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(I.message);case P.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(I.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(I.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(I.message);case P.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(I.message);case P.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(I.message);default:throw new A.FileSystemError(I.message,I.name)}}};k=Ve([qe(0,C.IExtHostRpcService),qe(1,D.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(we[197],_e([0,1,6,5]),function(Q,e,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(S){this._handlePool=0,this._proxy=S.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const C=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(C,S),(0,w.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(C)})}}e.ExtHostLabelService=A}),define(we[198],_e([0,1,2,23,9,7,11,5,8,32,15,10,115,6,87,54,68,55,12]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor(B,q){this._documents=B,this._provider=q}provideDocumentSymbols(B,q){const ne=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideDocumentSymbols(ne,q)).then(le=>{if(!(0,i.isFalsyOrEmpty)(le))return le[0]instanceof T.DocumentSymbol?le.map(A.DocumentSymbol.from):f._asDocumentSymbolTree(le)})}static _asDocumentSymbolTree(B){var q;B=B.slice(0).sort((fe,Se)=>{let Oe=fe.location.range.start.compareTo(Se.location.range.start);return Oe===0&&(Oe=Se.location.range.end.compareTo(fe.location.range.end)),Oe});const ne=[],le=[];for(const fe of B){const Se={name:fe.name||"!!MISSING: name!!",kind:A.SymbolKind.from(fe.kind),tags:((q=fe.tags)===null||q===void 0?void 0:q.map(A.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:A.Range.from(fe.location.range),selectionRange:A.Range.from(fe.location.range),children:[]};for(;;){if(le.length===0){le.push(Se),ne.push(Se);break}const Oe=le[le.length-1];if(k.Range.containsRange(Oe.range,Se.range)&&!k.Range.equalsRange(Oe.range,Se.range)){Oe.children&&Oe.children.push(Se),le.push(Se);break}le.pop()}}return ne}}class u{constructor(B,q,ne){this._documents=B,this._commands=q,this._provider=ne,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(B,q){const ne=this._documents.getDocument(B),le=await this._provider.provideCodeLenses(ne,q);if(!(!le||q.isCancellationRequested)){const fe=this._cache.add(le),Se=new h.DisposableStore;this._disposables.set(fe,Se);const Oe={cacheId:fe,lenses:[]};for(let ge=0;ge<le.length;ge++)Oe.lenses.push({cacheId:[fe,ge],range:A.Range.from(le[ge].range),command:this._commands.toInternal(le[ge].command,Se)});return Oe}}async resolveCodeLens(B,q){var ne;const le=B.cacheId&&this._cache.get(...B.cacheId);if(!!le){let fe;if(typeof this._provider.resolveCodeLens!="function"||le.isResolved?fe=le:fe=await this._provider.resolveCodeLens(le,q),fe||(fe=le),!q.isCancellationRequested){const Se=B.cacheId&&this._disposables.get(B.cacheId[0]);if(!!Se)return B.command=this._commands.toInternal((ne=fe.command)!==null&&ne!==void 0?ne:u._badCmd,Se),B}}}releaseCodeLenses(B){var q;(q=this._disposables.get(B))===null||q===void 0||q.dispose(),this._disposables.delete(B),this._cache.delete(B)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function b(We){return Array.isArray(We)?We.map(A.DefinitionLink.from):We?[A.DefinitionLink.from(We)]:[]}class t{constructor(B,q){this._documents=B,this._provider=q}provideDefinition(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideDefinition(le,fe,ne)).then(b)}}class n{constructor(B,q){this._documents=B,this._provider=q}provideDeclaration(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideDeclaration(le,fe,ne)).then(b)}}class l{constructor(B,q){this._documents=B,this._provider=q}provideImplementation(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideImplementation(le,fe,ne)).then(b)}}class a{constructor(B,q){this._documents=B,this._provider=q}provideTypeDefinition(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideTypeDefinition(le,fe,ne)).then(b)}}class s{constructor(B,q){this._documents=B,this._provider=q}provideHover(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideHover(le,fe,ne)).then(Se=>{if(!(!Se||(0,i.isFalsyOrEmpty)(Se.contents)))return Se.range||(Se.range=le.getWordRangeAtPosition(fe)),Se.range||(Se.range=new T.Range(fe,fe)),A.Hover.from(Se)})}}class c{constructor(B,q){this._documents=B,this._provider=q}provideEvaluatableExpression(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideEvaluatableExpression(le,fe,ne)).then(Se=>{if(Se)return A.EvaluatableExpression.from(Se)})}}class p{constructor(B,q){this._documents=B,this._provider=q}provideInlineValues(B,q,ne,le){const fe=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideInlineValues(fe,A.Range.to(q),A.InlineValueContext.to(ne),le)).then(Se=>{if(Array.isArray(Se))return Se.map(Oe=>A.InlineValue.from(Oe))})}}class y{constructor(B,q){this._documents=B,this._provider=q}provideDocumentHighlights(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideDocumentHighlights(le,fe,ne)).then(Se=>{if(Array.isArray(Se))return Se.map(A.DocumentHighlight.from)})}}class v{constructor(B,q){this._documents=B,this._provider=q}provideLinkedEditingRanges(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideLinkedEditingRanges(le,fe,ne)).then(Se=>{if(Se&&Array.isArray(Se.ranges))return{ranges:(0,i.coalesce)(Se.ranges.map(A.Range.from)),wordPattern:Se.wordPattern}})}}class _{constructor(B,q){this._documents=B,this._provider=q}provideReferences(B,q,ne,le){const fe=this._documents.getDocument(B),Se=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideReferences(fe,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.location.from)})}}class F{constructor(B,q,ne,le,fe,Se,Oe){this._documents=B,this._commands=q,this._diagnostics=ne,this._provider=le,this._logService=fe,this._extension=Se,this._apiDeprecation=Oe,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(B,q,ne,le){const fe=this._documents.getDocument(B),Se=d.Selection.isISelection(q)?A.Selection.to(q):A.Range.to(q),Oe=[];for(const Ce of this._diagnostics.getDiagnostics(B))if(Se.intersection(Ce.range)&&Oe.push(Ce)>F._maxCodeActionsPerFile)break;const ge={diagnostics:Oe,only:ne.only?new T.CodeActionKind(ne.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ne.trigger)};return(0,S.asPromise)(()=>this._provider.provideCodeActions(fe,Se,ge,le)).then(Ce=>{var Pe;if(!(!(0,i.isNonEmptyArray)(Ce)||le.isCancellationRequested)){const $e=this._cache.add(Ce),Ee=new h.DisposableStore;this._disposables.set($e,Ee);const je=[];for(let H=0;H<Ce.length;H++){const ee=Ce[H];!ee||(F._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),je.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,Ee)})):(ge.only&&(ee.kind?ge.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${ge.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),je.push({cacheId:[$e,H],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,Ee),diagnostics:ee.diagnostics&&ee.diagnostics.map(A.Diagnostic.from),edit:ee.edit&&A.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:(Pe=ee.disabled)===null||Pe===void 0?void 0:Pe.reason})))}return{cacheId:$e,actions:je}}})}async resolveCodeAction(B,q){var ne;const[le,fe]=B,Se=this._cache.get(le,fe);if(!(!Se||F._isCommand(Se))&&!!this._provider.resolveCodeAction){const Oe=(ne=await this._provider.resolveCodeAction(Se,q))!==null&&ne!==void 0?ne:Se;return(Oe==null?void 0:Oe.edit)?A.WorkspaceEdit.from(Oe.edit):void 0}}releaseCodeActions(B){var q;(q=this._disposables.get(B))===null||q===void 0||q.dispose(),this._disposables.delete(B),this._cache.delete(B)}static _isCommand(B){return typeof B.command=="string"&&typeof B.title=="string"}}F._maxCodeActionsPerFile=1e3;class x{constructor(B,q){this._documents=B,this._provider=q}provideDocumentFormattingEdits(B,q,ne){const le=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideDocumentFormattingEdits(le,q,ne)).then(fe=>{if(Array.isArray(fe))return fe.map(A.TextEdit.from)})}}class Y{constructor(B,q){this._documents=B,this._provider=q}provideDocumentRangeFormattingEdits(B,q,ne,le){const fe=this._documents.getDocument(B),Se=A.Range.to(q);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Se,ne,le)).then(Oe=>{if(Array.isArray(Oe))return Oe.map(A.TextEdit.from)})}}class me{constructor(B,q){this._documents=B,this._provider=q,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(B,q,ne,le,fe){const Se=this._documents.getDocument(B),Oe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Se,Oe,ne,le,fe)).then(ge=>{if(Array.isArray(ge))return ge.map(A.TextEdit.from)})}}class j{constructor(B,q){this._provider=B,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(B,q){const ne=C.IdObject.mixin({symbols:[]});return(0,S.asPromise)(()=>this._provider.provideWorkspaceSymbols(B,q)).then(le=>{if((0,i.isNonEmptyArray)(le)){for(const fe of le)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Se=C.IdObject.mixin(A.WorkspaceSymbol.from(fe));this._symbolCache.set(Se._id,fe),ne.symbols.push(Se)}}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(B,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return B;const ne=this._symbolCache.get(B._id);if(ne){const le=await(0,S.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,q));return le&&(0,P.mixin)(B,A.WorkspaceSymbol.from(le),!0)}}releaseWorkspaceSymbols(B){const q=this._resultCache.get(B);if(q){for(let[ne,le]=q;ne<=le;ne++)this._symbolCache.delete(ne);this._resultCache.delete(B)}}}class z{constructor(B,q,ne){this._documents=B,this._provider=q,this._logService=ne}static supportsResolving(B){return typeof B.prepareRename=="function"}provideRenameEdits(B,q,ne,le){const fe=this._documents.getDocument(B),Se=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.provideRenameEdits(fe,Se,ne,le)).then(Oe=>{if(!!Oe)return A.WorkspaceEdit.from(Oe)},Oe=>{const ge=z._asMessage(Oe);return ge?{rejectReason:ge,edits:void 0}:Promise.reject(Oe)})}resolveRenameLocation(B,q,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const le=this._documents.getDocument(B),fe=A.Position.to(q);return(0,S.asPromise)(()=>this._provider.prepareRename(le,fe,ne)).then(Se=>{let Oe,ge;if(T.Range.isRange(Se)?(Oe=Se,ge=le.getText(Se)):(0,I.isObject)(Se)&&(Oe=Se.range,ge=Se.placeholder),!!Oe){if(Oe.start.line>fe.line||Oe.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Oe),text:ge}}},Se=>{const Oe=z._asMessage(Se);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(Se)})}static _asMessage(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class te{constructor(B,q){this.resultId=B,this.tokens=q}}class ${constructor(B,q){this._documents=B,this._provider=q,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(B,q,ne){const le=this._documents.getDocument(B),fe=q!==0?this._previousResults.get(q):null;return(0,S.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(le,fe.resultId,ne):this._provider.provideDocumentSemanticTokens(le,ne)).then(Se=>(fe&&this._previousResults.delete(q),Se?(Se=$._fixProvidedSemanticTokens(Se),this._send($._convertToEdits(fe,Se),Se)):null))}async releaseDocumentSemanticColoring(B){this._previousResults.delete(B)}static _fixProvidedSemanticTokens(B){return $._isSemanticTokens(B)?$._isCorrectSemanticTokens(B)?B:new T.SemanticTokens(new Uint32Array(B.data),B.resultId):$._isSemanticTokensEdits(B)?$._isCorrectSemanticTokensEdits(B)?B:new T.SemanticTokensEdits(B.edits.map(q=>new T.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),B.resultId):B}static _isSemanticTokens(B){return B&&!!B.data}static _isCorrectSemanticTokens(B){return B.data instanceof Uint32Array}static _isSemanticTokensEdits(B){return B&&Array.isArray(B.edits)}static _isCorrectSemanticTokensEdits(B){for(const q of B.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(B,q){if(!$._isSemanticTokens(q)||!B||!B.tokens)return q;const ne=B.tokens,le=ne.length,fe=q.data,Se=fe.length;let Oe=0;const ge=Math.min(le,Se);for(;Oe<ge&&ne[Oe]===fe[Oe];)Oe++;if(Oe===le&&Oe===Se)return new T.SemanticTokensEdits([],q.resultId);let Ce=0;const Pe=ge-Oe;for(;Ce<Pe&&ne[le-Ce-1]===fe[Se-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Oe,deleteCount:le-Oe-Ce,data:fe.subarray(Oe,Se-Ce)}],q.resultId)}_send(B,q){if($._isSemanticTokens(B)){const ne=this._nextResultId++;return this._previousResults.set(ne,new te(B.resultId,B.data)),(0,r.encodeSemanticTokensDto)({id:ne,type:"full",data:B.data})}if($._isSemanticTokensEdits(B)){const ne=this._nextResultId++;return $._isSemanticTokens(q)?this._previousResults.set(ne,new te(q.resultId,q.data)):this._previousResults.set(ne,new te(B.resultId)),(0,r.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(B.edits||[]).map(le=>({start:le.start,deleteCount:le.deleteCount,data:le.data}))})}return null}}e.DocumentSemanticTokensAdapter=$;class R{constructor(B,q){this._documents=B,this._provider=q}provideDocumentRangeSemanticTokens(B,q,ne){const le=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(le,A.Range.to(q),ne)).then(fe=>fe?this._send(fe):null)}_send(B){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:B.data})}}e.DocumentRangeSemanticTokensAdapter=R;class L{constructor(B,q,ne,le,fe){this._documents=B,this._commands=q,this._provider=ne,this._apiDeprecation=le,this._extension=fe,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}async provideCompletionItems(B,q,ne,le){const fe=this._documents.getDocument(B),Se=A.Position.to(q),Oe=fe.getWordRangeAtPosition(Se)||new T.Range(Se,Se),ge=Oe.with({end:Se}),Ce=new m.StopWatch(!0),Pe=await(0,S.asPromise)(()=>this._provider.provideCompletionItems(fe,Se,le,A.CompletionContext.to(ne)));if(!!Pe&&!le.isCancellationRequested){const $e=Array.isArray(Pe)?new T.CompletionList(Pe):Pe,Ee=L.supportsResolving(this._provider)?this._cache.add($e.items):this._cache.add([]),je=new h.DisposableStore;this._disposables.set(Ee,je);const H=[],ee={x:Ee,b:H,a:{replace:A.Range.from(Oe),insert:A.Range.from(ge)},c:$e.isIncomplete||void 0,d:Ce.elapsed()};for(let ve=0;ve<$e.items.length;ve++){const Le=$e.items[ve],He=this._convertCompletionItem(Le,[Ee,ve],ge,Oe);H.push(He)}return ee}}async resolveCompletionItem(B,q){if(typeof this._provider.resolveCompletionItem=="function"){const ne=this._cache.get(...B);if(!!ne){const le=await(0,S.asPromise)(()=>this._provider.resolveCompletionItem(ne,q));if(!!le)return this._convertCompletionItem(le,B)}}}releaseCompletionItems(B){var q;(q=this._disposables.get(B))===null||q===void 0||q.dispose(),this._disposables.delete(B),this._cache.delete(B)}_convertCompletionItem(B,q,ne,le){var fe;const Se=this._disposables.get(q[0]);if(!Se)throw Error("DisposableStore is missing...");const Oe={x:q,a:(fe=B.label)!==null&&fe!==void 0?fe:"",o:B.label2,b:B.kind!==void 0?A.CompletionItemKind.from(B.kind):void 0,n:B.tags&&B.tags.map(A.CompletionItemTag.from),c:B.detail,d:typeof B.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters,l:B.additionalTextEdits&&B.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(B.command,Se)};B.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=B.textEdit.newText):typeof B.insertText=="string"?Oe.h=B.insertText:B.insertText instanceof T.SnippetString&&(Oe.h=B.insertText.value,Oe.i|=4);let ge;return B.textEdit?ge=B.textEdit.range:B.range&&(ge=B.range),T.Range.isRange(ge)?Oe.j=A.Range.from(ge):ge&&(!(ne==null?void 0:ne.isEqual(ge.inserting))||!(le==null?void 0:le.isEqual(ge.replacing)))&&(Oe.j={insert:A.Range.from(ge.inserting),replace:A.Range.from(ge.replacing)}),Oe}}class M{constructor(B,q){this._documents=B,this._provider=q,this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(B,q,ne,le){const fe=this._documents.getDocument(B),Se=A.Position.to(q),Oe=this.reviveContext(ne);return(0,S.asPromise)(()=>this._provider.provideSignatureHelp(fe,Se,le,Oe)).then(ge=>{if(ge){const Ce=this._cache.add([ge]);return Object.assign(Object.assign({},A.SignatureHelp.from(ge)),{id:Ce})}})}reviveContext(B){let q;if(B.activeSignatureHelp){const ne=A.SignatureHelp.to(B.activeSignatureHelp),le=this._cache.get(B.activeSignatureHelp.id,0);le?(q=le,q.activeSignature=ne.activeSignature,q.activeParameter=ne.activeParameter):q=ne}return Object.assign(Object.assign({},B),{activeSignatureHelp:q})}releaseSignatureHelp(B){this._cache.delete(B)}}class U{constructor(B,q){this._documents=B,this._provider=q}provideInlayHints(B,q,ne){const le=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideInlayHints(le,A.Range.to(q),ne)).then(fe=>fe?{hints:fe.map(A.InlayHint.from)}:void 0)}}class G{constructor(B,q){this._documents=B,this._provider=q,this._cache=new g.Cache("DocumentLink")}provideLinks(B,q){const ne=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideDocumentLinks(ne,q)).then(le=>{if(!(!Array.isArray(le)||le.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:le.map(A.DocumentLink.from)};{const fe=this._cache.add(le),Se={links:[],id:fe};for(let Oe=0;Oe<le.length;Oe++){const ge=A.DocumentLink.from(le[Oe]);ge.cacheId=[fe,Oe],Se.links.push(ge)}return Se}}})}resolveLink(B,q){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...B);return ne?(0,S.asPromise)(()=>this._provider.resolveDocumentLink(ne,q)).then(le=>le&&A.DocumentLink.from(le)||void 0):Promise.resolve(void 0)}releaseLinks(B){this._cache.delete(B)}}class J{constructor(B,q){this._documents=B,this._provider=q}provideColors(B,q){const ne=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideDocumentColors(ne,q)).then(le=>Array.isArray(le)?le.map(Se=>({color:A.Color.from(Se.color),range:A.Range.from(Se.range)})):[])}provideColorPresentations(B,q,ne){const le=this._documents.getDocument(B),fe=A.Range.to(q.range),Se=A.Color.to(q.color);return(0,S.asPromise)(()=>this._provider.provideColorPresentations(Se,{document:le,range:fe},ne)).then(Oe=>{if(!!Array.isArray(Oe))return Oe.map(A.ColorPresentation.from)})}}class re{constructor(B,q){this._documents=B,this._provider=q}provideFoldingRanges(B,q,ne){const le=this._documents.getDocument(B);return(0,S.asPromise)(()=>this._provider.provideFoldingRanges(le,q,ne)).then(fe=>{if(!!Array.isArray(fe))return fe.map(A.FoldingRange.from)})}}class pe{constructor(B,q,ne){this._documents=B,this._provider=q,this._logService=ne}provideSelectionRanges(B,q,ne){const le=this._documents.getDocument(B),fe=q.map(A.Position.to);return(0,S.asPromise)(()=>this._provider.provideSelectionRanges(le,fe,ne)).then(Se=>{if(!(0,i.isNonEmptyArray)(Se))return[];if(Se.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let ge=0;ge<fe.length;ge++){const Ce=[];Oe.push(Ce);let Pe=fe[ge],$e=Se[ge];for(;;){if(!$e.range.contains(Pe))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from($e)),!$e.parent)break;Pe=$e.range,$e=$e.parent}}return Oe})}}class Te{constructor(B,q){this._documents=B,this._provider=q,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(B,q,ne){const le=this._documents.getDocument(B),fe=A.Position.to(q),Se=await this._provider.prepareCallHierarchy(le,fe,ne);if(!!Se){const Oe=this._idPool.nextId();return this._cache.set(Oe,new Map),Array.isArray(Se)?Se.map(ge=>this._cacheAndConvertItem(Oe,ge)):[this._cacheAndConvertItem(Oe,Se)]}}async provideCallsTo(B,q,ne){const le=this._itemFromCache(B,q);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(le,ne);if(!!fe)return fe.map(Se=>({from:this._cacheAndConvertItem(B,Se.from),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}async provideCallsFrom(B,q,ne){const le=this._itemFromCache(B,q);if(!le)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(le,ne);if(!!fe)return fe.map(Se=>({to:this._cacheAndConvertItem(B,Se.to),fromRanges:Se.fromRanges.map(Oe=>A.Range.from(Oe))}))}releaseSession(B){this._cache.delete(B)}_cacheAndConvertItem(B,q){var ne;const le=this._cache.get(B),fe={_sessionId:B,_itemId:le.size.toString(36),name:q.name,detail:q.detail,kind:A.SymbolKind.from(q.kind),uri:q.uri,range:A.Range.from(q.range),selectionRange:A.Range.from(q.selectionRange),tags:(ne=q.tags)===null||ne===void 0?void 0:ne.map(A.SymbolTag.from)};return le.set(fe._itemId,q),fe}_itemFromCache(B,q){const ne=this._cache.get(B);return ne==null?void 0:ne.get(q)}}class xe{constructor(B,q){this.adapter=B,this.extension=q}}class Ae{constructor(B,q,ne,le,fe,Se,Oe){this._adapter=new Map,this._uriTransformer=q,this._proxy=B.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=le,this._diagnostics=fe,this._logService=Se,this._apiDeprecation=Oe}_transformDocumentSelector(B){return(0,i.coalesce)((0,i.asArray)(B).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(B){if(typeof B=="string")return{$serialized:!0,language:B};if(B)return{$serialized:!0,language:B.language,scheme:this._transformScheme(B.scheme),pattern:typeof B.pattern=="undefined"?void 0:A.GlobPattern.from(B.pattern),exclusive:B.exclusive}}_transformScheme(B){return this._uriTransformer&&typeof B=="string"?this._uriTransformer.transformOutgoingScheme(B):B}_createDisposable(B){return new T.Disposable(()=>{this._adapter.delete(B),this._proxy.$unregister(B)})}_nextHandle(){return Ae._handlePool++}_withAdapter(B,q,ne,le,fe=!1){const Se=this._adapter.get(B);if(!Se)return Promise.resolve(le);if(Se.adapter instanceof q){let Oe;Se.extension&&(Oe=Date.now(),this._logService.trace(`[${Se.extension.identifier.value}] INVOKE provider '${q.name}'`));const ge=ne(Se.adapter,Se.extension),Ce=Se.extension;return Ce&&Promise.resolve(ge).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Oe}ms`),Pe=>{fe&&Pe instanceof E.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Pe))}),ge}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(B,q){const ne=this._nextHandle();return this._adapter.set(ne,new xe(B,q)),ne}static _extLabel(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,q,ne,le){const fe=this._addNewAdapter(new f(this._documents,ne),B),Se=le&&le.label||Ae._extLabel(B);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(q),Se),this._createDisposable(fe)}$provideDocumentSymbols(B,q,ne){return this._withAdapter(B,f,le=>le.provideDocumentSymbols(w.URI.revive(q),ne),void 0)}registerCodeLensProvider(B,q,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new u(this._documents,this._commands.converter,ne),B)),this._proxy.$registerCodeLensSupport(le,this._transformDocumentSelector(q),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeCodeLenses(ge=>this._proxy.$emitCodeLensEvent(fe));Se=T.Disposable.from(Se,Oe)}return Se}$provideCodeLenses(B,q,ne){return this._withAdapter(B,u,le=>le.provideCodeLenses(w.URI.revive(q),ne),void 0)}$resolveCodeLens(B,q,ne){return this._withAdapter(B,u,le=>le.resolveCodeLens(q,ne),void 0)}$releaseCodeLenses(B,q){this._withAdapter(B,u,ne=>Promise.resolve(ne.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(B,q,ne){const le=this._addNewAdapter(new t(this._documents,ne),B);return this._proxy.$registerDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDefinition(B,q,ne,le){return this._withAdapter(B,t,fe=>fe.provideDefinition(w.URI.revive(q),ne,le),[])}registerDeclarationProvider(B,q,ne){const le=this._addNewAdapter(new n(this._documents,ne),B);return this._proxy.$registerDeclarationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDeclaration(B,q,ne,le){return this._withAdapter(B,n,fe=>fe.provideDeclaration(w.URI.revive(q),ne,le),[])}registerImplementationProvider(B,q,ne){const le=this._addNewAdapter(new l(this._documents,ne),B);return this._proxy.$registerImplementationSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideImplementation(B,q,ne,le){return this._withAdapter(B,l,fe=>fe.provideImplementation(w.URI.revive(q),ne,le),[])}registerTypeDefinitionProvider(B,q,ne){const le=this._addNewAdapter(new a(this._documents,ne),B);return this._proxy.$registerTypeDefinitionSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideTypeDefinition(B,q,ne,le){return this._withAdapter(B,a,fe=>fe.provideTypeDefinition(w.URI.revive(q),ne,le),[])}registerHoverProvider(B,q,ne,le){const fe=this._addNewAdapter(new s(this._documents,ne),B);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(q)),this._createDisposable(fe)}$provideHover(B,q,ne,le){return this._withAdapter(B,s,fe=>fe.provideHover(w.URI.revive(q),ne,le),void 0)}registerEvaluatableExpressionProvider(B,q,ne,le){const fe=this._addNewAdapter(new c(this._documents,ne),B);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(q)),this._createDisposable(fe)}$provideEvaluatableExpression(B,q,ne,le){return this._withAdapter(B,c,fe=>fe.provideEvaluatableExpression(w.URI.revive(q),ne,le),void 0)}registerInlineValuesProvider(B,q,ne,le){const fe=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Se=this._addNewAdapter(new p(this._documents,ne),B);this._proxy.$registerInlineValuesProvider(Se,this._transformDocumentSelector(q),fe);let Oe=this._createDisposable(Se);if(fe!==void 0){const ge=ne.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideInlineValues(B,q,ne,le,fe){return this._withAdapter(B,p,Se=>Se.provideInlineValues(w.URI.revive(q),ne,le,fe),void 0)}registerDocumentHighlightProvider(B,q,ne){const le=this._addNewAdapter(new y(this._documents,ne),B);return this._proxy.$registerDocumentHighlightProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentHighlights(B,q,ne,le){return this._withAdapter(B,y,fe=>fe.provideDocumentHighlights(w.URI.revive(q),ne,le),void 0)}registerLinkedEditingRangeProvider(B,q,ne){const le=this._addNewAdapter(new v(this._documents,ne),B);return this._proxy.$registerLinkedEditingRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideLinkedEditingRanges(B,q,ne,le){return this._withAdapter(B,v,async fe=>{const Se=await fe.provideLinkedEditingRanges(w.URI.revive(q),ne,le);if(Se)return{ranges:Se.ranges,wordPattern:Se.wordPattern?Ae._serializeRegExp(Se.wordPattern):void 0}},void 0)}registerReferenceProvider(B,q,ne){const le=this._addNewAdapter(new _(this._documents,ne),B);return this._proxy.$registerReferenceSupport(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideReferences(B,q,ne,le,fe){return this._withAdapter(B,_,Se=>Se.provideReferences(w.URI.revive(q),ne,le,fe),void 0)}registerCodeActionProvider(B,q,ne,le){var fe,Se;const Oe=new h.DisposableStore,ge=this._addNewAdapter(new F(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,B,this._apiDeprecation),B);return this._proxy.$registerQuickFixSupport(ge,this._transformDocumentSelector(q),{providedKinds:(fe=le==null?void 0:le.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Se=le==null?void 0:le.documentation)===null||Se===void 0?void 0:Se.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Oe)}))},Ae._extLabel(B),Boolean(ne.resolveCodeAction)),Oe.add(this._createDisposable(ge)),Oe}$provideCodeActions(B,q,ne,le,fe){return this._withAdapter(B,F,Se=>Se.provideCodeActions(w.URI.revive(q),ne,le,fe),void 0)}$resolveCodeAction(B,q,ne){return this._withAdapter(B,F,le=>le.resolveCodeAction(q,ne),void 0)}$releaseCodeActions(B,q){this._withAdapter(B,F,ne=>Promise.resolve(ne.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(B,q,ne){const le=this._addNewAdapter(new x(this._documents,ne),B);return this._proxy.$registerDocumentFormattingSupport(le,this._transformDocumentSelector(q),B.identifier,B.displayName||B.name),this._createDisposable(le)}$provideDocumentFormattingEdits(B,q,ne,le){return this._withAdapter(B,x,fe=>fe.provideDocumentFormattingEdits(w.URI.revive(q),ne,le),void 0)}registerDocumentRangeFormattingEditProvider(B,q,ne){const le=this._addNewAdapter(new Y(this._documents,ne),B);return this._proxy.$registerRangeFormattingSupport(le,this._transformDocumentSelector(q),B.identifier,B.displayName||B.name),this._createDisposable(le)}$provideDocumentRangeFormattingEdits(B,q,ne,le,fe){return this._withAdapter(B,Y,Se=>Se.provideDocumentRangeFormattingEdits(w.URI.revive(q),ne,le,fe),void 0)}registerOnTypeFormattingEditProvider(B,q,ne,le){const fe=this._addNewAdapter(new me(this._documents,ne),B);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(q),le,B.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(B,q,ne,le,fe,Se){return this._withAdapter(B,me,Oe=>Oe.provideOnTypeFormattingEdits(w.URI.revive(q),ne,le,fe,Se),void 0)}registerWorkspaceSymbolProvider(B,q){const ne=this._addNewAdapter(new j(q,this._logService),B);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(B,q,ne){return this._withAdapter(B,j,le=>le.provideWorkspaceSymbols(q,ne),{symbols:[]})}$resolveWorkspaceSymbol(B,q,ne){return this._withAdapter(B,j,le=>le.resolveWorkspaceSymbol(q,ne),void 0)}$releaseWorkspaceSymbols(B,q){this._withAdapter(B,j,ne=>ne.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(B,q,ne){const le=this._addNewAdapter(new z(this._documents,ne,this._logService),B);return this._proxy.$registerRenameSupport(le,this._transformDocumentSelector(q),z.supportsResolving(ne)),this._createDisposable(le)}$provideRenameEdits(B,q,ne,le,fe){return this._withAdapter(B,z,Se=>Se.provideRenameEdits(w.URI.revive(q),ne,le,fe),void 0)}$resolveRenameLocation(B,q,ne,le){return this._withAdapter(B,z,fe=>fe.resolveRenameLocation(w.URI.revive(q),ne,le),void 0)}registerDocumentSemanticTokensProvider(B,q,ne,le){const fe=this._nextHandle(),Se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new xe(new $(this._documents,ne),B)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(q),le,Se);let Oe=this._createDisposable(fe);if(Se){const ge=ne.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Se));Oe=T.Disposable.from(Oe,ge)}return Oe}$provideDocumentSemanticTokens(B,q,ne,le){return this._withAdapter(B,$,fe=>fe.provideDocumentSemanticTokens(w.URI.revive(q),ne,le),null,!0)}$releaseDocumentSemanticTokens(B,q){this._withAdapter(B,$,ne=>ne.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(B,q,ne,le){const fe=this._addNewAdapter(new R(this._documents,ne),B);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(q),le),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(B,q,ne,le){return this._withAdapter(B,R,fe=>fe.provideDocumentRangeSemanticTokens(w.URI.revive(q),ne,le),null,!0)}registerCompletionItemProvider(B,q,ne,le){const fe=this._addNewAdapter(new L(this._documents,this._commands.converter,ne,this._apiDeprecation,B),B);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(q),le,L.supportsResolving(ne),`${B.identifier.value}(${le.join("")})`),this._createDisposable(fe)}$provideCompletionItems(B,q,ne,le,fe){return this._withAdapter(B,L,Se=>Se.provideCompletionItems(w.URI.revive(q),ne,le,fe),void 0)}$resolveCompletionItem(B,q,ne){return this._withAdapter(B,L,le=>le.resolveCompletionItem(q,ne),void 0)}$releaseCompletionItems(B,q){this._withAdapter(B,L,ne=>ne.releaseCompletionItems(q),void 0)}registerSignatureHelpProvider(B,q,ne,le){const fe=Array.isArray(le)?{triggerCharacters:le,retriggerCharacters:[]}:le,Se=this._addNewAdapter(new M(this._documents,ne),B);return this._proxy.$registerSignatureHelpProvider(Se,this._transformDocumentSelector(q),fe),this._createDisposable(Se)}$provideSignatureHelp(B,q,ne,le,fe){return this._withAdapter(B,M,Se=>Se.provideSignatureHelp(w.URI.revive(q),ne,le,fe),void 0)}$releaseSignatureHelp(B,q){this._withAdapter(B,M,ne=>ne.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(B,q,ne){const le=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new U(this._documents,ne),B);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(q),le);let Se=this._createDisposable(fe);if(le!==void 0){const Oe=ne.onDidChangeInlayHints(ge=>this._proxy.$emitInlayHintsEvent(le));Se=T.Disposable.from(Se,Oe)}return Se}$provideInlayHints(B,q,ne,le){return this._withAdapter(B,U,fe=>fe.provideInlayHints(w.URI.revive(q),ne,le),void 0)}registerDocumentLinkProvider(B,q,ne){const le=this._addNewAdapter(new G(this._documents,ne),B);return this._proxy.$registerDocumentLinkProvider(le,this._transformDocumentSelector(q),typeof ne.resolveDocumentLink=="function"),this._createDisposable(le)}$provideDocumentLinks(B,q,ne){return this._withAdapter(B,G,le=>le.provideLinks(w.URI.revive(q),ne),void 0)}$resolveDocumentLink(B,q,ne){return this._withAdapter(B,G,le=>le.resolveLink(q,ne),void 0)}$releaseDocumentLinks(B,q){this._withAdapter(B,G,ne=>ne.releaseLinks(q),void 0)}registerColorProvider(B,q,ne){const le=this._addNewAdapter(new J(this._documents,ne),B);return this._proxy.$registerDocumentColorProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideDocumentColors(B,q,ne){return this._withAdapter(B,J,le=>le.provideColors(w.URI.revive(q),ne),[])}$provideColorPresentations(B,q,ne,le){return this._withAdapter(B,J,fe=>fe.provideColorPresentations(w.URI.revive(q),ne,le),void 0)}registerFoldingRangeProvider(B,q,ne){const le=this._nextHandle(),fe=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(le,new xe(new re(this._documents,ne),B)),this._proxy.$registerFoldingRangeProvider(le,this._transformDocumentSelector(q),fe);let Se=this._createDisposable(le);if(fe!==void 0){const Oe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Se=T.Disposable.from(Se,Oe)}return Se}$provideFoldingRanges(B,q,ne,le){return this._withAdapter(B,re,fe=>fe.provideFoldingRanges(w.URI.revive(q),ne,le),void 0)}registerSelectionRangeProvider(B,q,ne){const le=this._addNewAdapter(new pe(this._documents,ne,this._logService),B);return this._proxy.$registerSelectionRangeProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$provideSelectionRanges(B,q,ne,le){return this._withAdapter(B,pe,fe=>fe.provideSelectionRanges(w.URI.revive(q),ne,le),[])}registerCallHierarchyProvider(B,q,ne){const le=this._addNewAdapter(new Te(this._documents,ne),B);return this._proxy.$registerCallHierarchyProvider(le,this._transformDocumentSelector(q)),this._createDisposable(le)}$prepareCallHierarchy(B,q,ne,le){return this._withAdapter(B,Te,fe=>Promise.resolve(fe.prepareSession(w.URI.revive(q),ne,le)),void 0)}$provideCallHierarchyIncomingCalls(B,q,ne,le){return this._withAdapter(B,Te,fe=>fe.provideCallsTo(q,ne,le),void 0)}$provideCallHierarchyOutgoingCalls(B,q,ne,le){return this._withAdapter(B,Te,fe=>fe.provideCallsFrom(q,ne,le),void 0)}$releaseCallHierarchy(B,q){this._withAdapter(B,Te,ne=>Promise.resolve(ne.releaseSession(q)),void 0)}static _serializeRegExp(B){return{pattern:B.source,flags:(0,D.regExpFlags)(B)}}static _serializeIndentationRule(B){return{decreaseIndentPattern:Ae._serializeRegExp(B.decreaseIndentPattern),increaseIndentPattern:Ae._serializeRegExp(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ae._serializeRegExp(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ae._serializeRegExp(B.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(B){return{beforeText:Ae._serializeRegExp(B.beforeText),afterText:B.afterText?Ae._serializeRegExp(B.afterText):void 0,previousLineText:B.previousLineText?Ae._serializeRegExp(B.previousLineText):void 0,action:B.action}}static _serializeOnEnterRules(B){return B.map(Ae._serializeOnEnterRule)}setLanguageConfiguration(B,q,ne){let{wordPattern:le}=ne;if(le&&(0,D.regExpLeadsToEndlessLoop)(le))throw new Error(`Invalid language configuration: wordPattern '${le}' is not allowed to match the empty string.`);le?this._documents.setWordDefinitionFor(q,le):this._documents.setWordDefinitionFor(q,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const fe=this._nextHandle(),Se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ae._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ae._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ae._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,q,Se),this._createDisposable(fe)}$setWordDefinitions(B){for(const q of B)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=Ae,Ae._handlePool=0}),define(we[199],_e([0,1,5,9,7]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(C,D){this._proxy=C.getProxy(w.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(C,D){await this._proxy.$changeLanguage(C,D);const k=this._documents.getDocumentData(C);if(!k)throw new Error(`document '${C.toString}' NOT found`);return k.document}async tokenAtPosition(C,D){var k;const i=C.version,I=P.Position.from(D),d=await this._proxy.$tokensAtPosition(C.uri,I),h={type:A.StandardTokenType.Other,range:(k=C.getWordRangeAtPosition(D))!==null&&k!==void 0?k:new A.Range(D.line,D.character,D.line,D.character)};if(!d)return h;const r={range:P.Range.to(d.range),type:P.TokenType.to(d.type)};return!r.range.contains(D)||i!==C.version?h:r}}e.ExtHostLanguages=T}),define(we[200],_e([0,1,5,18,33]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(C){return C&&C.title}let S=class{constructor(D,k){this._logService=k,this._proxy=D.getProxy(w.MainContext.MainThreadMessageService)}showMessage(D,k,i,I,d){const h={extension:D};let r;typeof I=="string"||T(I)?r=[I,...d]:(h.modal=I&&I.modal,h.useCustom=I&&I.useCustom,r=d),h.useCustom&&(0,A.checkProposedApiEnabled)(D);const o=[];for(let g=0;g<r.length;g++){const m=r[g];if(typeof m=="string")o.push({title:m,handle:g,isCloseAffordance:!1});else if(typeof m=="object"){let{title:E,isCloseAffordance:f}=m;o.push({title:E,isCloseAffordance:!!f,handle:g})}else this._logService.warn("Invalid message item:",m)}return this._proxy.$showMessage(k,i,h,o).then(g=>{if(typeof g=="number")return r[g]})}};S=Ve([qe(1,P.ILogService)],S),e.ExtHostMessageService=S}),define(we[201],_e([0,1,11,24,20,3,56,54,6,22,8,10,2,68,5,9,7,73,178,179]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class u{constructor(s,c){const p=u._Keys.nextId();s.$registerNotebookEditorDecorationType(p,o.NotebookDecorationRenderOptions.from(c)),this.value={key:p,dispose(){s.$removeNotebookEditorDecorationType(p)}}}}e.NotebookEditorDecorationType=u,u._Keys=new C.IdGenerator("NotebookEditorDecorationType");class b{constructor(s,c,p,y,v,_){this._textDocumentsAndEditors=p,this._textDocuments=y,this.logService=v,this._extensionStoragePaths=_,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new T.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new T.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new T.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new T.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._activeExecutions=new k.ResourceMap,this._statusBarCache=new h.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=s.getProxy(r.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=s.getProxy(r.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=s.getProxy(r.MainContext.MainThreadNotebookEditors),this._commandsConverter=c.converter,c.registerArgumentProcessor({processArgument:F=>{var x;if(F&&F.$mid===12){const Y=(x=F.notebookEditor)===null||x===void 0?void 0:x.notebookUri,me=F.cell.handle,j=this._documents.get(Y),z=j==null?void 0:j.getCell(me);if(z)return z.apiCell}return F}})}get activeNotebookEditor(){var s;return(s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(s=>s.apiEditor)}getEditorById(s){return this._editors.get(s)}getIdByEditor(s){for(const[c,p]of this._editors)if(p.apiEditor===s)return c}get notebookDocuments(){return[...this._documents.values()]}lookupNotebookDocument(s){return this._documents.get(s)}_getNotebookDocument(s){const c=this._documents.get(s);if(!c)throw new Error(`NO notebook document for '${s}'`);return c}_getProviderData(s){const c=this._notebookContentProviders.get(s);if(!c)throw new Error(`NO provider for '${s}'`);return c}registerNotebookContentProvider(s,c,p,y){var v,_,F;if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(c))throw new Error(`Notebook provider for '${c}' already registered`);this._notebookContentProviders.set(c,{extension:s,provider:p});let x;p.onDidChangeNotebookContentOptions&&(x=p.onDidChangeNotebookContentOptions(()=>{const j=o.NotebookDocumentContentOptions.from(p.options);this._notebookProxy.$updateNotebookProviderOptions(c,j)}));const Y=(v=y==null?void 0:y.viewOptions)===null||v===void 0?void 0:v.filenamePattern.map(j=>o.NotebookExclusiveDocumentPattern.from(j)).filter(j=>j!==void 0);((_=y==null?void 0:y.viewOptions)===null||_===void 0?void 0:_.filenamePattern)&&!Y&&console.warn(`Notebook content provider view options file name pattern is invalid ${(F=y==null?void 0:y.viewOptions)===null||F===void 0?void 0:F.filenamePattern}`);const me=o.NotebookDocumentContentOptions.from(y);return this._notebookProxy.$registerNotebookProvider({id:s.identifier,location:s.extensionLocation,description:s.description},c,{transientOutputs:me.transientOutputs,transientCellMetadata:me.transientCellMetadata,transientDocumentMetadata:me.transientDocumentMetadata,viewOptions:(y==null?void 0:y.viewOptions)&&Y?{displayName:y.viewOptions.displayName,filenamePattern:Y,exclusive:y.viewOptions.exclusive||!1}:void 0}),new g.Disposable(()=>{x==null||x.dispose(),this._notebookContentProviders.delete(c),this._notebookProxy.$unregisterNotebookProvider(c)})}registerNotebookCellStatusBarItemProvider(s,c,p){const y=b._notebookStatusBarItemProviderHandlePool++,v=typeof p.onDidChangeCellStatusBarItems=="function"?b._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(y,p),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(y,v,c);let _;return v!==void 0&&(_=p.onDidChangeCellStatusBarItems(F=>this._notebookProxy.$emitCellStatusBarEvent(v))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(y),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(y,v),_&&_.dispose()})}createNotebookEditorDecorationType(s){return new u(this._notebookEditorsProxy,s).value}async openNotebookDocument(s){const c=this._documents.get(s);if(c)return c.apiNotebook;const p=await this._notebookDocumentsProxy.$tryOpenDocument(s),y=this._documents.get(d.URI.revive(p));return(0,I.assertIsDefined)(y==null?void 0:y.apiNotebook)}async showNotebookDocument(s,c){var p;d.URI.isUri(s)&&(s=await this.openNotebookDocument(s));let y;typeof c=="object"?y={position:o.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selections:c.selections&&c.selections.map(o.NotebookRange.from),pinned:typeof c.preview=="boolean"?!c.preview:void 0}:y={preserveFocus:!1};const v=await this._notebookEditorsProxy.$tryShowNotebookDocument(s.uri,s.viewType,y),_=v&&((p=this._editors.get(v))===null||p===void 0?void 0:p.apiEditor);if(_)return _;throw v?new Error(`Could NOT open editor for "${s.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${s.toString()}".`)}async $provideNotebookCellStatusBarItems(s,c,p,y){var v;const _=this._notebookStatusBarItemProviders.get(s),F=d.URI.revive(c),x=this._documents.get(F);if(!(!x||!_)){const Y=x.getCellFromIndex(p);if(!!Y){const me=await _.provideCellStatusBarItems(Y.apiCell,y);if(!!me){const j=new D.DisposableStore,z=this._statusBarCache.add([j]),te=(v=me&&me.map($=>o.NotebookStatusBarItem.from($,this._commandsConverter,j)))!==null&&v!==void 0?v:void 0;return{cacheId:z,items:te}}}}}$releaseNotebookCellStatusBarItems(s){this._statusBarCache.delete(s)}registerNotebookSerializer(s,c,p,y){if((0,i.isFalsyOrWhitespace)(c))throw new Error("viewType cannot be empty or just whitespace");const v=this._handlePool++;this._notebookSerializer.set(v,p);const _=o.NotebookDocumentContentOptions.from(y);return this._notebookProxy.$registerNotebookSerializer(v,{id:s.identifier,location:s.extensionLocation,description:s.description},c,_),(0,D.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(v)})}async $dataToNotebook(s,c,p){const y=this._notebookSerializer.get(s);if(!y)throw new Error("NO serializer found");const v=await y.deserializeNotebook(c.buffer,p);return{metadata:o.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(o.NotebookCellData.from)}}async $notebookToData(s,c,p){const y=this._notebookSerializer.get(s);if(!y)throw new Error("NO serializer found");const v=await y.serializeNotebook({metadata:o.NotebookDocumentMetadata.to(c.metadata),cells:c.cells.map(o.NotebookCellData.to)},p);return P.VSBuffer.wrap(v)}cancelOneNotebookCellExecution(s){const c=this._activeExecutions.get(s.uri);c==null||c.cancel()}async $openNotebook(s,c,p,y,v){const{provider:_}=this._getProviderData(s),F=await _.openNotebook(d.URI.revive(c),{backupId:p,untitledDocumentData:y==null?void 0:y.buffer},v);return{metadata:o.NotebookDocumentMetadata.from(F.metadata),cells:F.cells.map(o.NotebookCellData.from)}}async $saveNotebook(s,c,p){const y=this._getNotebookDocument(d.URI.revive(c)),{provider:v}=this._getProviderData(s);return await v.saveNotebook(y.apiNotebook,p),!0}async $saveNotebookAs(s,c,p,y){const v=this._getNotebookDocument(d.URI.revive(c)),{provider:_}=this._getProviderData(s);return await _.saveNotebookAs(d.URI.revive(p),v.apiNotebook,y),!0}async $backupNotebook(s,c,p){var y;const v=this._getNotebookDocument(d.URI.revive(c)),_=this._getProviderData(s),F=(y=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&y!==void 0?y:this._extensionStoragePaths.globalValue(_.extension),x=String((0,S.hash)([v.uri.toString(),this._backupIdPool++])),Y=d.URI.joinPath(F,x),me=await _.provider.backupNotebook(v.apiNotebook,{destination:Y},p);return v.updateBackup(me),me.id}$acceptModelChanged(s,c,p){this._getNotebookDocument(d.URI.revive(s)).acceptModelChanged(c,p)}$acceptDirtyStateChanged(s,c){const p=this._getNotebookDocument(d.URI.revive(s));p.acceptModelChanged({rawEvents:[],versionId:p.apiNotebook.version},c)}$acceptModelSaved(s){const c=this._getNotebookDocument(d.URI.revive(s));this._onDidSaveNotebookDocument.fire(c.apiNotebook)}$acceptEditorPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",s,c);const p=this._editors.get(s);if(!p)throw new Error(`unknown text editor: ${s}. known editors: ${[...this._editors.keys()]} `);c.visibleRanges&&p._acceptVisibleRanges(c.visibleRanges.ranges.map(o.NotebookRange.to)),c.selections&&p._acceptSelections(c.selections.selections.map(o.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:p.apiEditor,visibleRanges:p.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:p.apiEditor,selections:p.apiEditor.selections}))}$acceptEditorViewColumns(s){for(const c in s){const p=this._editors.get(c);if(!p)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);p._acceptViewColumn(o.ViewColumn.to(s[c]))}}$acceptDocumentPropertiesChanged(s,c){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",s.path,c);const p=this._getNotebookDocument(d.URI.revive(s));p.acceptDocumentPropertiesChanged(c),c.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:p.apiNotebook})}_createExtHostEditor(s,c,p){if(this._editors.has(c))throw new Error(`editor with id ALREADY EXSIST: ${c}`);const y=new f.ExtHostNotebookEditor(c,this._notebookEditorsProxy,s,p.visibleRanges.map(o.NotebookRange.to),p.selections.map(o.NotebookRange.to),typeof p.viewColumn=="number"?o.ViewColumn.to(p.viewColumn):void 0);this._editors.set(c,y)}$acceptDocumentAndEditorsDelta(s){var c,p,y;if(s.removedDocuments)for(const _ of s.removedDocuments){const F=d.URI.revive(_),x=this._documents.get(F);x&&(x.dispose(),this._documents.delete(F),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:x.apiNotebook.getCells().map(Y=>Y.document.uri)}),this._onDidCloseNotebookDocument.fire(x.apiNotebook));for(const Y of this._editors.values())Y.notebookData.uri.toString()===F.toString()&&this._editors.delete(Y.id)}if(s.addedDocuments){const _=[];for(const F of s.addedDocuments){const x=d.URI.revive(F.uri),Y=F.viewType;if(this._documents.has(x))throw new Error(`adding EXISTING notebook ${x} `);const me=this,j=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(z){me._onDidChangeNotebookCells.fire(z)},emitCellOutputsChange(z){me._onDidChangeCellOutputs.fire(z)},emitCellMetadataChange(z){me._onDidChangeCellMetadata.fire(z)},emitCellExecutionStateChange(z){me._onDidChangeCellExecutionState.fire(z)}},Y,F.metadata?o.NotebookDocumentMetadata.to(F.metadata):new g.NotebookDocumentMetadata,x);j.acceptModelChanged({versionId:F.versionId,rawEvents:[{kind:m.NotebookCellsChangeType.Initialize,changes:[[0,0,F.cells]]}]},!1),_.push(...F.cells.map(z=>E.ExtHostCell.asModelAddData(j.apiNotebook,z))),(c=this._documents.get(x))===null||c===void 0||c.dispose(),this._documents.set(x,j),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:_}),this._onDidOpenNotebookDocument.fire(j.apiNotebook)}}if(s.addedEditors)for(const _ of s.addedEditors){if(this._editors.has(_.id))return;const F=d.URI.revive(_.documentUri),x=this._documents.get(F);x&&this._createExtHostEditor(x,_.id,_)}const v=[];if(s.removedEditors)for(const _ of s.removedEditors){const F=this._editors.get(_);F&&(this._editors.delete(_),((p=this._activeNotebookEditor)===null||p===void 0?void 0:p.id)===F.id&&(this._activeNotebookEditor=void 0),v.push(F))}if(s.visibleEditors){this._visibleNotebookEditors=s.visibleEditors.map(F=>this._editors.get(F)).filter(F=>!!F);const _=new Set;this._visibleNotebookEditors.forEach(F=>_.add(F.id));for(const F of this._editors.values()){const x=_.has(F.id);F._acceptVisibility(x)}this._visibleNotebookEditors=[...this._editors.values()].map(F=>F).filter(F=>F.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}s.newActiveEditor===null?this._activeNotebookEditor=void 0:s.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(s.newActiveEditor)),s.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((y=this._activeNotebookEditor)===null||y===void 0?void 0:y.apiEditor)}createNotebookCellExecution(s,c,p){const y=this.lookupNotebookDocument(s);if(!y)throw new Error(`Invalid uri: ${s} `);const v=y.getCellFromIndex(c);if(!v)throw new Error(`Invalid cell index: ${s}, ${c} `);if(this._activeExecutions.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const _=new n(s,y,v,this._notebookDocumentsProxy);this._activeExecutions.set(v.uri,_);const F=_.onDidChangeState(()=>{_.state===t.Resolved&&(_.dispose(),F.dispose(),this._activeExecutions.delete(v.uri))});return _.asApiObject()}}e.ExtHostNotebookController=b,b._notebookStatusBarItemProviderHandlePool=0;var t;(function(a){a[a.Init=0]="Init",a[a.Started=1]="Started",a[a.Resolved=2]="Resolved"})(t||(t={}));class n extends D.Disposable{constructor(s,c,p,y){super();this._uri=s,this._document=c,this._cell=p,this._proxy=y,this._onDidChangeState=new T.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=t.Init,this._tokenSource=this._register(new A.CancellationTokenSource),this._collector=new l(10,v=>this.applyEdits(v)),this._executionOrder=p.internalMetadata.executionOrder,this.mixinMetadata({runState:g.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(s){await this._collector.addItem(s)}async applyEdits(s){return this._proxy.$applyEdits(this._uri,s,!1)}verifyStateForOutput(){if(this._state===t.Init)throw new Error("Must call start before modifying cell output");if(this._state===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(s){const c={editType:8,handle:this._cell.handle,metadata:s};this.applyEdits([c])}cellIndexToHandle(s){const c=typeof s=="number"?this._document.getCellFromIndex(s):this._cell;if(!!c)return c.handle}asApiObject(){const s=this;return Object.freeze({get document(){return s._document.apiNotebook},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(c){s._executionOrder=c,s.mixinMetadata({executionOrder:c})},start(c){var p;if(s._state===t.Resolved||s._state===t.Started)throw new Error("Cannot call start again");s._state=t.Started,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Executing,runStartTime:(p=c==null?void 0:c.startTime)!==null&&p!==void 0?p:null})},end(c){var p,y;if(s._state===t.Resolved)throw new Error("Cannot call resolve twice");s._state=t.Resolved,s._onDidChangeState.fire(),s.mixinMetadata({runState:g.NotebookCellExecutionState.Idle,lastRunSuccess:(p=c==null?void 0:c.success)!==null&&p!==void 0?p:null,runEndTime:(y=c==null?void 0:c.endTime)!==null&&y!==void 0?y:null})},clearOutput(c){return s.verifyStateForOutput(),this.replaceOutput([],c)},async appendOutput(c,p){s.verifyStateForOutput();const y=s.cellIndexToHandle(p);if(typeof y=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:y,append:!0,outputs:c.map(o.NotebookCellOutput.from)})},async replaceOutput(c,p){s.verifyStateForOutput();const y=s.cellIndexToHandle(p);if(typeof y=="number")return c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:2,handle:y,outputs:c.map(o.NotebookCellOutput.from)})},async appendOutputItems(c,p){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,append:!0,items:c.map(o.NotebookCellOutputItem.from),outputId:p})},async replaceOutputItems(c,p){return s.verifyStateForOutput(),c=Array.isArray(c)?c:[c],s.applyEditSoon({editType:7,items:c.map(o.NotebookCellOutputItem.from),outputId:p})},token:s._tokenSource.token})}}class l{constructor(s,c){this.delay=s,this.callback=c,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,w.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const c=this.batch;return this.batch=[],this.callback(c)})),this.waitPromise}}}),define(we[202],_e([0,1,3,6,5,26,2,9,72]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class k{constructor(I,d,h){this._initData=d,this._extHostNotebook=h,this._kernelData=new Map,this._handlePool=0,this._proxy=I.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(I,d,h,r,o,g){for(let v of this._kernelData.values())if(v.controller.id===d&&T.ExtensionIdentifier.equals(I.identifier,v.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const m=this._handlePool++,E=this,f=()=>console.warn(`NO execute handler from notebook controller '${l.id}' of extension: '${I.identifier}'`);let u=!1;const b=new P.DisposableStore,t=new w.Emitter,n=new w.Emitter,l={id:`${I.identifier.value}/${d}`,viewType:h,extensionId:I.identifier,extensionLocation:I.extensionLocation,label:r||I.identifier.value,preloads:g?g.map(C.NotebookKernelPreload.from):[]};let a=o!=null?o:f,s;this._proxy.$addKernel(m,l).catch(v=>{console.log(v),u=!0});let c=0;const p=()=>{if(!u){const v=++c;Promise.resolve().then(()=>{v===c&&this._proxy.$updateKernel(m,l)})}},y={get id(){return d},get viewType(){return l.viewType},onDidChangeNotebookAssociation:t.event,get label(){return l.label},set label(v){var _;l.label=(_=v!=null?v:I.displayName)!==null&&_!==void 0?_:I.name,p()},get detail(){var v;return(v=l.detail)!==null&&v!==void 0?v:""},set detail(v){l.detail=v,p()},get description(){var v;return(v=l.description)!==null&&v!==void 0?v:""},set description(v){l.description=v,p()},get supportedLanguages(){return l.supportedLanguages},set supportedLanguages(v){l.supportedLanguages=v,p()},get hasExecutionOrder(){var v;return(v=l.hasExecutionOrder)!==null&&v!==void 0?v:!1},set hasExecutionOrder(v){l.hasExecutionOrder=v,p()},get preloads(){return l.preloads?l.preloads.map(C.NotebookKernelPreload.to):[]},get executeHandler(){return a},set executeHandler(v){a=v!=null?v:f},get interruptHandler(){return s},set interruptHandler(v){s=v,l.supportsInterrupt=Boolean(v),p()},createNotebookCellExecutionTask(v){if(u)throw new Error("notebook controller is DISPOSED");return E._extHostNotebook.createNotebookCellExecution(v.notebook.uri,v.index,l.id)},dispose:()=>{u||(u=!0,this._kernelData.delete(m),b.dispose(),t.dispose(),n.dispose(),this._proxy.$removeKernel(m))},onDidReceiveMessage:n.event,postMessage(v,_){return E._proxy.$postMessage(m,_&&E._extHostNotebook.getIdByEditor(_),v)},asWebviewUri(v){return(0,D.asWebviewUri)(E._initData.environment,String(m),v)},updateNotebookAffinity(v,_){E._proxy.$updateNotebookPriority(m,v.uri,_)}};return this._kernelData.set(m,{extensionId:I.identifier,controller:y,onDidChangeSelection:t,onDidReceiveMessage:n}),y}$acceptSelection(I,d,h){const r=this._kernelData.get(I);r&&r.onDidChangeSelection.fire({selected:h,notebook:this._extHostNotebook.lookupNotebookDocument(S.URI.revive(d)).apiNotebook})}async $executeCells(I,d,h){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.lookupNotebookDocument(S.URI.revive(d));if(!o)throw new Error("MISSING notebook");const g=[];for(let m of h){const E=o.getCell(m);E&&g.push(E.apiCell)}try{await r.controller.executeHandler.call(r.controller,g,o.apiNotebook,r.controller)}catch(m){console.error(m)}}}async $cancelCells(I,d,h){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.lookupNotebookDocument(S.URI.revive(d));if(!o)throw new Error("MISSING notebook");r.controller.interruptHandler&&await r.controller.interruptHandler.call(r.controller,o.apiNotebook);for(let g of h){const m=o.getCell(g);m&&this._extHostNotebook.cancelOneNotebookCellExecution(m)}}}$acceptKernelMessageFromRenderer(I,d,h){const r=this._kernelData.get(I);if(!!r){const o=this._extHostNotebook.getEditorById(d);if(!o)throw new Error(`send message for UNKNOWN editor: ${d}`);r.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:h}))}}}e.ExtHostNotebookKernels=k}),define(we[100],_e([0,1,5,3,6,24,4,14]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(r,o,g,m){super();this._onDidAppend=this._register(new P.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=m,this._id=m.$register(this.name,o,g),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(o=>this._proxy.$clear(o,r))}show(r,o){this.validate(),this._id.then(g=>this._proxy.$reveal(g,!!(typeof r=="boolean"?r:o)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class k extends D{constructor(r,o){super(r,!1,void 0,o)}append(r){super.append(r),this._id.then(o=>this._proxy.$append(o,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends D{constructor(r,o,g){super(r,!0,o,g)}append(r){throw new Error("Not supported")}}class I{constructor(r,o){this.name=r,this._channel=o}append(r){this._channel.then(o=>o.append(r))}appendLine(r){this._channel.then(o=>o.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,o){this._channel.then(g=>g.show(r,o))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=I;let d=class{constructor(r){this._proxy=r.getProxy(w.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new k(r,this._proxy)}createOutputChannelFromLogFile(r,o){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new i(r,o,this._proxy)}};d=Ve([qe(0,C.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,S.createDecorator)("IExtHostOutputService")}),define(we[203],_e([0,1,11,20,3,6,5,2,7,12,15,47]),function(Q,e,w,P,A,T,S,C,D,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(h,r,o){const g=h.getProxy(S.MainContext.MainThreadQuickOpen);class m{constructor(a,s){this._sessions=new Map,this._instances=0,this._workspace=a,this._commands=s}showQuickPick(a,s,c,p=P.CancellationToken.None){this._onDidSelectItem=void 0;const y=Promise.resolve(a),v=++this._instances,_=g.$show(v,{title:c==null?void 0:c.title,placeHolder:c==null?void 0:c.placeHolder,matchOnDescription:c==null?void 0:c.matchOnDescription,matchOnDetail:c==null?void 0:c.matchOnDetail,ignoreFocusLost:c==null?void 0:c.ignoreFocusOut,canPickMany:c==null?void 0:c.canPickMany},p),F={},x=_.then(()=>F);return Promise.race([x,y]).then(Y=>{if(Y!==F)return y.then(me=>{const j=[];for(let z=0;z<me.length;z++){const te=me[z];let $,R,L,M,U;typeof te=="string"?$=te:($=te.label,R=te.description,L=te.detail,M=te.picked,U=te.alwaysShow),j.push({label:$,description:R,handle:z,detail:L,picked:M,alwaysShow:U})}return c&&typeof c.onDidSelectItem=="function"&&(this._onDidSelectItem=z=>{c.onDidSelectItem(me[z])}),g.$setItems(v,j),_.then(z=>{if(typeof z=="number")return me[z];if(Array.isArray(z))return z.map(te=>me[te])})})}).then(void 0,Y=>{if(!(0,k.isPromiseCanceledError)(Y))return g.$setError(v,Y),Promise.reject(Y)})}$onItemSelected(a){this._onDidSelectItem&&this._onDidSelectItem(a)}showInput(a,s=P.CancellationToken.None){return this._validateInput=a?a.validateInput:void 0,g.$input(a,typeof this._validateInput=="function",s).then(void 0,c=>{if(!(0,k.isPromiseCanceledError)(c))return Promise.reject(c)})}$validateInput(a){return this._validateInput?(0,w.asPromise)(()=>this._validateInput(a)):Promise.resolve(void 0)}async showWorkspaceFolderPick(a,s=P.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[a]);if(!!c){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(y=>y.uri.toString()===c.uri.toString())}}createQuickPick(a,s){const c=new t(a,s,()=>this._sessions.delete(c._id));return this._sessions.set(c._id,c),c}createInputBox(a){const s=new n(a,()=>this._sessions.delete(s._id));return this._sessions.set(s._id,s),s}$onDidChangeValue(a,s){const c=this._sessions.get(a);c&&c._fireDidChangeValue(s)}$onDidAccept(a){const s=this._sessions.get(a);s&&s._fireDidAccept()}$onDidChangeActive(a,s){const c=this._sessions.get(a);c instanceof t&&c._fireDidChangeActive(s)}$onDidChangeSelection(a,s){const c=this._sessions.get(a);c instanceof t&&c._fireDidChangeSelection(s)}$onDidTriggerButton(a,s){const c=this._sessions.get(a);c&&c._fireDidTriggerButton(s)}$onDidHide(a){const s=this._sessions.get(a);s&&s._fireDidHide()}}class E{constructor(a,s){this._extensionId=a,this._onDidDispose=s,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(a){this._title=a,this.update({title:a})}get step(){return this._steps}set step(a){this._steps=a,this.update({step:a})}get totalSteps(){return this._totalSteps}set totalSteps(a){this._totalSteps=a,this.update({totalSteps:a})}get enabled(){return this._enabled}set enabled(a){this._enabled=a,this.update({enabled:a})}get busy(){return this._busy}set busy(a){this._busy=a,this.update({busy:a})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(a){this._ignoreFocusOut=a,this.update({ignoreFocusOut:a})}get value(){return this._value}set value(a){this._value=a,this.update({value:a})}get placeholder(){return this._placeholder}set placeholder(a){this._placeholder=a,this.update({placeholder:a})}get buttons(){return this._buttons}set buttons(a){this._buttons=a.slice(),this._handlesToButtons.clear(),a.forEach((s,c)=>{const p=s===D.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(p,s)}),this.update({buttons:a.map((s,c)=>({iconPath:f(s.iconPath),tooltip:s.tooltip,handle:s===D.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(a){this._value=a,this._onDidChangeValueEmitter.fire(a)}_fireDidTriggerButton(a){const s=this._handlesToButtons.get(a);s&&this._onDidTriggerButtonEmitter.fire(s)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),g.$dispose(this._id))}update(a){if(!this._disposed){for(const s of Object.keys(a)){const c=a[s];this._pendingUpdate[s]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){g.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function f(l){if(l instanceof D.ThemeIcon)return{id:l.id};const a=b(l),s=u(l);return{dark:typeof a=="string"?C.URI.file(a):a,light:typeof s=="string"?C.URI.file(s):s}}function u(l){return typeof l=="object"&&"light"in l?l.light:l}function b(l){return typeof l=="object"&&"dark"in l?l.dark:l}class t extends E{constructor(a,s,c){super(a,c);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(a){this._items=a.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),a.forEach((s,c)=>{this._handlesToItems.set(c,s),this._itemsToHandles.set(s,c)}),this.update({items:a.map((s,c)=>({label:s.label,description:s.description,handle:c,detail:s.detail,picked:s.picked,alwaysShow:s.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(a){this._canSelectMany=a,this.update({canSelectMany:a})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(a){this._matchOnDescription=a,this.update({matchOnDescription:a})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(a){this._matchOnDetail=a,this.update({matchOnDetail:a})}get sortByLabel(){return this._sortByLabel}set sortByLabel(a){this._sortByLabel=a,this.update({sortByLabel:a})}get activeItems(){return this._activeItems}set activeItems(a){this._activeItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({activeItems:this._activeItems.map(s=>this._itemsToHandles.get(s))})}get selectedItems(){return this._selectedItems}set selectedItems(a){this._selectedItems=a.filter(s=>this._itemsToHandles.has(s)),this.update({selectedItems:this._selectedItems.map(s=>this._itemsToHandles.get(s))})}_fireDidChangeActive(a){const s=(0,i.coalesce)(a.map(c=>this._handlesToItems.get(c)));this._activeItems=s,this._onDidChangeActiveEmitter.fire(s)}_fireDidChangeSelection(a){const s=(0,i.coalesce)(a.map(c=>this._handlesToItems.get(c)));this._selectedItems=s,this._onDidChangeSelectionEmitter.fire(s)}}class n extends E{constructor(a,s){super(a,s);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(a){this._password=a,this.update({password:a})}get prompt(){return this._prompt}set prompt(a){this._prompt=a,this.update({prompt:a})}get validationMessage(){return this._validationMessage}set validationMessage(a){this._validationMessage=a,this.update({validationMessage:a,severity:a?I.default.Error:I.default.Ignore})}}return new m(r,o)}e.createExtHostQuickOpen=d}),define(we[204],_e([0,1,2,3,52,6,11,5,15,112,18,26,33]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(a){if(a)return typeof a.iconPath=="string"?w.URI.file(a.iconPath):a.iconPath}function r(a,s){if(!a.iconPath&&!s.iconPath)return 0;if(a.iconPath){if(!s.iconPath)return 1}else return-1;const c=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath,p=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath;return(0,k.comparePaths)(c,p)}function o(a,s){let c=0;if(a.strikeThrough!==s.strikeThrough)return a.strikeThrough?1:-1;if(a.faded!==s.faded)return a.faded?1:-1;if(a.tooltip!==s.tooltip)return(a.tooltip||"").localeCompare(s.tooltip||"");if(c=r(a,s),c!==0)return c;if(a.light&&s.light)c=r(a.light,s.light);else{if(a.light)return 1;if(s.light)return-1}if(c!==0)return c;if(a.dark&&s.dark)c=r(a.dark,s.dark);else{if(a.dark)return 1;if(s.dark)return-1}return c}function g(a,s){if(a.command!==s.command)return a.command<s.command?-1:1;if(a.title!==s.title)return a.title<s.title?-1:1;if(a.tooltip!==s.tooltip){if(a.tooltip!==void 0&&s.tooltip!==void 0)return a.tooltip<s.tooltip?-1:1;if(a.tooltip!==void 0)return 1;if(s.tooltip!==void 0)return-1}if(a.arguments===s.arguments)return 0;if(a.arguments)if(s.arguments){if(a.arguments.length!==s.arguments.length)return a.arguments.length-s.arguments.length}else return 1;else return-1;for(let c=0;c<a.arguments.length;c++){const p=a.arguments[c],y=s.arguments[c];if(p!==y)return p<y?-1:1}return 0}function m(a,s){let c=(0,k.comparePaths)(a.resourceUri.fsPath,s.resourceUri.fsPath,!0);if(c!==0)return c;if(a.command&&s.command)c=g(a.command,s.command);else{if(a.command)return 1;if(s.command)return-1}if(c!==0)return c;if(a.decorations&&s.decorations)c=o(a.decorations,s.decorations);else{if(a.decorations)return 1;if(s.decorations)return-1}return c}function E(a,s){for(let c=0;c<a.length;c++)if(a[c]!==s[c])return!1;return!0}function f(a,s){return a.command===s.command&&a.title===s.title&&a.tooltip===s.tooltip&&(a.arguments&&s.arguments?E(a.arguments,s.arguments):a.arguments===s.arguments)}function u(a,s){return(0,D.equals)(a,s,f)}class b{constructor(s,c,p){this._extension=s,this._proxy=c,this._sourceControlHandle=p,this._value="",this._onDidChange=new P.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(s){this._proxy.$setInputBoxValue(this._sourceControlHandle,s),this.updateValue(s)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(s){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,s),this._placeholder=s}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(s){if((0,d.checkProposedApiEnabled)(this._extension),s&&typeof s!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=s,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!s)}get visible(){return this._visible}set visible(s){s=!!s,this._visible!==s&&(this._visible=s,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,s))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(s,c){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,s,c)}$onInputBoxValueChange(s){this.updateValue(s)}updateValue(s){this._value=s,this._onDidChange.fire(s)}}e.ExtHostSCMInputBox=b;class t{constructor(s,c,p,y,v){this._proxy=s,this._commands=c,this._sourceControlHandle=p,this._id=y,this._label=v,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new P.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new P.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(s){this._label=s,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,s)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(s){this._hideWhenEmpty=s,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(s){this._resourceStates=[...s],this._onDidUpdateResourceStates.fire()}getResourceState(s){return this._resourceStatesMap.get(s)}$executeResourceCommand(s,c){const p=this._resourceStatesCommandsMap.get(s);return p?(0,S.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],c)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var s;const c=[...this._resourceStates].sort(m),y=(0,D.sortedDiff)(this._resourceSnapshot,c,m).map(F=>{const x=F.toInsert.map(Y=>{const me=this._resourceHandlePool++;this._resourceStatesMap.set(me,Y);const j=Y.resourceUri,z=h(Y.decorations),te=Y.decorations&&h(Y.decorations.light)||z,$=Y.decorations&&h(Y.decorations.dark)||z,R=[];let L;if(Y.command)if(Y.command.command==="vscode.open"||Y.command.command==="vscode.diff"){const pe=new T.DisposableStore;L=this._commands.converter.toInternal(Y.command,pe),this._resourceStatesDisposablesMap.set(me,pe)}else this._resourceStatesCommandsMap.set(me,Y.command);te&&R.push(te),$&&$.toString()!==(te==null?void 0:te.toString())&&R.push($);const M=Y.decorations&&Y.decorations.tooltip||"",U=Y.decorations&&!!Y.decorations.strikeThrough,G=Y.decorations&&!!Y.decorations.faded,J=Y.contextValue||"";return{rawResource:[me,j,R,M,U,G,J,L],handle:me}});return{start:F.start,deleteCount:F.deleteCount,toInsert:x}}),v=y.map(({start:F,deleteCount:x,toInsert:Y})=>[F,x,Y.map(me=>me.rawResource)]),_=y.reverse();for(const{start:F,deleteCount:x,toInsert:Y}of _){const me=Y.map(z=>z.handle),j=this._handlesSnapshot.splice(F,x,...me);for(const z of j)this._resourceStatesMap.delete(z),this._resourceStatesCommandsMap.delete(z),(s=this._resourceStatesDisposablesMap.get(z))===null||s===void 0||s.dispose(),this._resourceStatesDisposablesMap.delete(z)}return this._resourceSnapshot=c,v}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(s,c,p,y,v,_){this._proxy=c,this._commands=p,this._id=y,this._label=v,this._rootUri=_,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new P.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new b(s,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,y,v,_)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(s){this._count!==s&&(this._count=s,this._proxy.$updateSourceControl(this.handle,{count:s}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(s){this._quickDiffProvider=s,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!s})}get commitTemplate(){return this._commitTemplate}set commitTemplate(s){s!==this._commitTemplate&&(this._commitTemplate=s,this._proxy.$updateSourceControl(this.handle,{commitTemplate:s}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(s){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=s;const c=this._commands.converter.toInternal(s,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:c})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(s){if(!(this._statusBarCommands&&s&&u(this._statusBarCommands,s))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=s;const c=(s||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:c})}}get selected(){return this._selected}createResourceGroup(s,c){const p=new t(this._proxy,this._commands,this.handle,s,c),y=P.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,y),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const s=[],c=[];for(const[p,y]of this.createdResourceGroups){y.dispose();const v=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});P.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),v.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),s.push([p.handle,p.id,p.label,p.features]);const _=p._takeResourceStateSnapshot();_.length>0&&c.push([p.handle,_]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,s,c),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const s=[];this.updatedResourceGroups.forEach(c=>{const p=c._takeResourceStateSnapshot();p.length!==0&&s.push([c.handle,p])}),s.length>0&&this._proxy.$spliceResourceStates(this.handle,s),this.updatedResourceGroups.clear()}getResourceGroup(s){return this._groups.get(s)}setSelectionState(s){this._selected=s,this._onDidChangeSelection.fire(s)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(s=>s.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,Ve([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),Ve([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let l=class Rn{constructor(s,c,p){this._commands=c,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new P.Emitter,this._proxy=s.getProxy(C.MainContext.MainThreadSCM),this._telemetry=s.getProxy(C.MainContext.MainThreadTelemetry),c.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===3){const v=this._sourceControls.get(y.sourceControlHandle);if(!v)return y;const _=v.getResourceGroup(y.groupHandle);return _?_.getResourceState(y.handle):y}else if(y&&y.$mid===4){const v=this._sourceControls.get(y.sourceControlHandle);return v?v.getResourceGroup(y.groupHandle):y}else if(y&&y.$mid===5){const v=this._sourceControls.get(y.handle);return v||y}return y}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(s,c,p,y){this.logService.trace("ExtHostSCM#createSourceControl",s.identifier.value,c,p,y),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:s.identifier.value});const v=Rn._handlePool++,_=new n(s,this._proxy,this._commands,c,p,y);this._sourceControls.set(v,_);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier))||[];return F.push(_),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(s.identifier),F),_}getLastInputBox(s){this.logService.trace("ExtHostSCM#getLastInputBox",s.identifier.value);const c=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(s.identifier)),p=c&&c[c.length-1];return p&&p.inputBox}$provideOriginalResource(s,c,p){const y=w.URI.revive(c);this.logService.trace("ExtHostSCM#$provideOriginalResource",s,y.toString());const v=this._sourceControls.get(s);return!v||!v.quickDiffProvider||!v.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>v.quickDiffProvider.provideOriginalResource(y,p)).then(_=>_||null)}$onInputBoxValueChange(s,c){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",s);const p=this._sourceControls.get(s);return p&&p.inputBox.$onInputBoxValueChange(c),Promise.resolve(void 0)}$executeResourceCommand(s,c,p,y){this.logService.trace("ExtHostSCM#$executeResourceCommand",s,c,p);const v=this._sourceControls.get(s);if(!v)return Promise.resolve(void 0);const _=v.getResourceGroup(c);return _?_.$executeResourceCommand(p,y):Promise.resolve(void 0)}$validateInput(s,c,p){this.logService.trace("ExtHostSCM#$validateInput",s);const y=this._sourceControls.get(s);return!y||!y.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>y.inputBox.validateInput(c,p)).then(v=>v?Promise.resolve([v.message,v.type]):Promise.resolve(void 0))}$setSelectedSourceControl(s){var c,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",s),s!==void 0&&((c=this._sourceControls.get(s))===null||c===void 0||c.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=s,Promise.resolve(void 0)}};l._handlePool=0,l=Ve([qe(2,i.ILogService)],l),e.ExtHostSCM=l});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[205],_e([0,1,7,5,134,6]),function(Q,e,w,P,A,T){"use strict";var S,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(d,h,r,o,g=w.StatusBarAlignment.Left,m,E){S.set(this,void 0),C.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,tt(this,S,d,"f"),tt(this,C,h,"f"),this._id=D.ID_GEN++,this._statusId=r,this._statusName=o,this._alignment=g,this._priority=m,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!D.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var h;((h=this._command)===null||h===void 0?void 0:h.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Me(this,C,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Me(this,C,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Me(this,S,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let h=this._color;this._backgroundColor&&(h=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Me(this,S,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,h,this._backgroundColor,this._alignment===w.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,S=new WeakMap,C=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new w.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),w.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const h={message:d};return this._messages.unshift(h),this._update(),new w.Disposable(()=>{const r=this._messages.indexOf(h);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,h){this._proxy=d.getProxy(P.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new k(this)}createStatusBarEntry(d,h,r,o,g){return new D(this._proxy,this._commands,d,h,r,o,g)}setStatusBarMessage(d,h){const r=this._statusMessage.setMessage(d);let o;return typeof h=="number"?o=setTimeout(()=>r.dispose(),h):typeof h!="undefined"&&h.then(()=>r.dispose(),()=>r.dispose()),new w.Disposable(()=>{r.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=i}),define(we[78],_e([0,1,5,3,4]),function(Q,e,w,P,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(C){this._onDidChangeStorage=new P.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=C.getProxy(w.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(C,D){this._proxy.$registerExtensionStorageKeysToSync(C,D)}getValue(C,D,k){return this._proxy.$getValue(C,D).then(i=>i||k)}setValue(C,D,k){return this._proxy.$setValue(C,D,k)}$acceptValue(C,D,k){this._onDidChangeStorage.fire({shared:C,key:D,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(we[79],_e([0,1,4,27,18,77,2]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,w.createDecorator)("IExtensionStoragePaths");let C=class{constructor(k,i,I){var d;this._logService=i,this._extHostFileSystem=I,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=S.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(S.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=S.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),I}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return S.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return S.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};C=Ve([qe(0,P.IExtHostInitDataService),qe(1,A.ILogService),qe(2,T.IExtHostConsumerFileSystem)],C),e.ExtensionStoragePaths=C}),define(we[40],_e([0,1,3,5,4,2,14,6,7,135,12,172,20,31,155]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class o{constructor(t,n,l,a){this._proxy=t,this._id=n,this._creationOptions=l,this._name=a,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(c=>this._pidPromiseComplete=c);const s=this;this.value={get name(){return s._name||""},get processId(){return s._pidPromise},get creationOptions(){return s._creationOptions},get exitStatus(){return s._exitStatus},sendText(c,p=!0){s._checkDisposed(),s._proxy.$sendText(s._id,c,p)},show(c){s._checkDisposed(),s._proxy.$show(s._id,c)},hide(){s._checkDisposed(),s._proxy.$hide(s._id)},dispose(){s._disposed||(s._disposed=!0,s._proxy.$dispose(s._id))},get dimensions(){if(!(s._cols===void 0||s._rows===void 0))return{columns:s._cols,rows:s._rows}}}}async create(t,n,l,a,s,c,p,y,v,_,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:l,env:a,icon:s,initialText:c,waitOnExit:p,strictEnv:y,hideFromUser:v,isFeatureTerminal:_,isExtensionOwnedTerminal:F})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=o;class g{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new w.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new w.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new w.Emitter,this._onProcessTitleChanged=new w.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new w.Emitter,this._onProcessShellTypeChanged=new w.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=g;let m=1,E=class extends C.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new w.Emitter,this._onDidOpenTerminal=new w.Emitter,this._onDidChangeActiveTerminal=new w.Emitter,this._onDidChangeTerminalDimensions=new w.Emitter,this._proxy=n.getProxy(P.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new w.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[l,a]of this._terminalProcesses)a.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new o(this._proxy,(0,h.generateUuid)(),t,t.name),l=new g(t.pty);return n.createExtensionTerminal().then(a=>{const s=this._setupExtHostProcessListeners(a,l);this._terminalProcessDisposables[a]=s}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const a=new g(n),s=this._setupExtHostProcessListeners(t,a);this._terminalProcessDisposables[t]=s}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const l=this._getTerminalById(t);l&&(this._activeTerminal=l,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const l=this._getTerminalById(t);l&&this._onDidWriteTerminalData.fire({terminal:l.value,data:n})}async $acceptTerminalDimensions(t,n,l){const a=this._getTerminalById(t);a&&a.setDimensions(n,l)&&this._onDidChangeTerminalDimensions.fire({terminal:a.value,dimensions:a.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,l){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(n,l)}async $acceptTerminalTitleChange(t,n){const l=this._getTerminalById(t);l&&(l.name=n)}async $acceptTerminalClosed(t,n){const l=this._getTerminalObjectIndexById(this._terminals,t);if(l!==null){const a=this._terminals.splice(l,1)[0];a.setExitCode(n),this._onDidCloseTerminal.fire(a.value)}}$acceptTerminalOpened(t,n,l,a){if(n){const p=this._getTerminalObjectIndexById(this._terminals,n);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const s={name:a.name,shellPath:a.executable,shellArgs:a.args,cwd:typeof a.cwd=="string"?a.cwd:T.URI.revive(a.cwd),env:a.env,hideFromUser:a.hideFromUser},c=new o(this._proxy,t,s,l);this._terminals.push(c),this._onDidOpenTerminal.fire(c.value),c.isOpen=!0}async $acceptTerminalProcessId(t,n){const l=this._getTerminalById(t);l&&l._setProcessId(n)}async $startExtensionTerminal(t,n){const l=this._getTerminalById(t);if(!l)return{message:(0,k.localize)(0,null,t)};l.isOpen||await new Promise(s=>{const c=this.onDidOpenTerminal(async p=>{p===l.value&&(c.dispose(),s())})});const a=this._terminalProcesses.get(t);a?a.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const l=new C.DisposableStore;l.add(n.onProcessReady(s=>this._proxy.$sendProcessReady(t,s.pid,s.cwd))),l.add(n.onProcessTitleChanged(s=>this._proxy.$sendProcessTitle(t,s))),this._bufferer.startBuffering(t,n.onProcessData),l.add(n.onProcessExit(s=>this._onProcessExit(t,s))),n.onProcessOverrideDimensions&&l.add(n.onProcessOverrideDimensions(s=>this._proxy.$sendOverrideDimensions(t,s))),this._terminalProcesses.set(t,n);const a=this._extensionTerminalAwaitingStart[t];return a&&n instanceof g&&(n.startSendingEvents(a.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),l}$acceptProcessAckDataEvent(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.input(n)}$acceptProcessResize(t,n,l){var a;try{(a=this._terminalProcesses.get(t))===null||a===void 0||a.resize(n,l)}catch(s){if(s.code!=="EPIPE"&&s.code!=="ERR_IPC_CHANNEL_CLOSED")throw s}}$acceptProcessShutdown(t,n){var l;(l=this._terminalProcesses.get(t))===null||l===void 0||l.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(l=>this._proxy.$sendProcessInitialCwd(t,l))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(l=>this._proxy.$sendProcessCwd(t,l))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const l=this._getTerminalById(t);if(!l)return[];this._terminalLinkCache.delete(t);const a=this._terminalLinkCancellationSource.get(t);a&&a.dispose(!0);const s=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,s);const c=[],p={terminal:l.value,line:n},y=[];for(const F of this._linkProviders)y.push(new Promise(async x=>{s.token.onCancellationRequested(()=>x({provider:F,links:[]}));const Y=await F.provideTerminalLinks(p,s.token)||[];s.token.isCancellationRequested||x({provider:F,links:Y})}));const v=await Promise.all(y);if(s.token.isCancellationRequested)return[];const _=new Map;for(const F of v)F&&F.links.length>0&&c.push(...F.links.map(x=>{const Y={id:m++,startIndex:x.startIndex,length:x.length,label:x.tooltip};return _.set(Y.id,{provider:F.provider,link:x}),Y}));return this._terminalLinkCache.set(t,_),c}$activateLink(t,n){var l;const a=(l=this._terminalLinkCache.get(t))===null||l===void 0?void 0:l.get(n);!a||a.provider.handleTerminalLink(a.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const l=this._terminalProcessDisposables[t];l&&(l.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const l=this._getTerminalObjectIndexById(t,n);return l!==null?t[l]:null}_getTerminalObjectIndexById(t,n){let l=null;return t.some((a,s)=>a._id===n?(l=s,!0):!1),l}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new f,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const l=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,l.length===0?void 0:l)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const l=n[0],a=new f(n[1]);this._setEnvironmentVariableCollection(l,a)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=Ve([qe(1,S.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class f{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new w.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const l=this.map.get(t);(!l||l.value!==n.value||l.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((l,a)=>t.call(n,a,l,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let u=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,l){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};u=Ve([qe(0,S.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u}),define(we[206],_e([0,1,3,15,5,97,9,7]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new w.Emitter,this._onDidChangeTextEditorOptions=new w.Emitter,this._onDidChangeTextEditorVisibleRanges=new w.Emitter,this._onDidChangeTextEditorViewColumn=new w.Emitter,this._onDidChangeActiveTextEditor=new w.Emitter,this._onDidChangeVisibleTextEditors=new w.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(d=>d.value)}async showTextDocument(i,I,d){let h;typeof I=="number"?h={position:S.ViewColumn.from(I),preserveFocus:d}:typeof I=="object"?h={position:S.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?S.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,h),o=r&&this._extHostDocumentsAndEditors.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(I.options&&d._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(S.Selection.to);d._acceptSelections(h)}if(I.visibleRanges){const h=P.coalesce(I.visibleRanges.map(S.Range.to));d._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:S.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=C.TextEditorSelectionChangeKind.fromValue(I.selections.source),r=I.selections.selections.map(S.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:r,kind:h})}if(I.visibleRanges){const h=P.coalesce(I.visibleRanges.map(S.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:h})}}$acceptEditorPositionData(i){for(const I in i){const d=this._extHostDocumentsAndEditors.getEditor(I);if(!d)throw new Error("Unknown text editor");const h=S.ViewColumn.to(i[I]);d.value.viewColumn!==h&&(d._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:h}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=D});var Qt=this&&this.__rest||function(Q,e){var w={};for(var P in Q)Object.prototype.hasOwnProperty.call(Q,P)&&e.indexOf(P)<0&&(w[P]=Q[P]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(Q);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,P[A])&&(w[P[A]]=Q[P[A]]);return w};define(we[207],_e([0,1,2,4,5,6,7]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class C{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(A.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:d=>{var h,r;if(d&&d.$mid===11){const o=d.uri===void 0?void 0:w.URI.revive(d.uri);return(r=(h=this._itemsBySourceAndUriMap.get(d.source))===null||h===void 0?void 0:h.get(D(o)))===null||r===void 0?void 0:r.get(d.handle)}return d}})}async $getTimeline(i,I,d,h,r){const o=this._providers.get(i);return o==null?void 0:o.provideTimeline(w.URI.revive(I),d,h,r)}registerTimelineProvider(i,I,d,h){const r=new T.DisposableStore,o=this.convertTimelineItem(I.id,h,r).bind(this);let g;I.onDidChange&&(g=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const m=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(E,f,u,b){var t;(b==null?void 0:b.resetCache)&&(r.clear(),(t=m.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(E,f,u);if(n!=null){const l=o(E,b);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(l)})}},dispose(){var E;for(const f of m.values())(E=f.get(I.id))===null||E===void 0||E.clear();g==null||g.dispose(),r.dispose()}}))}convertTimelineItem(i,I,d){return(h,r)=>{let o;if(r==null?void 0:r.cacheResults){let g=this._itemsBySourceAndUriMap.get(i);g===void 0&&(g=new Map,this._itemsBySourceAndUriMap.set(i,g));const m=D(h);o=g.get(m),o===void 0&&(o=new Map,g.set(m,o))}return g=>{var m,E;const{iconPath:f}=g,u=Qt(g,["iconPath"]),b=`${i}|${(m=g.id)!==null&&m!==void 0?m:g.timestamp}`;o==null||o.set(b,g);let t,n,l;return g.iconPath&&(f instanceof S.ThemeIcon?l={id:f.id}:w.URI.isUri(f)?(t=f,n=f):{light:t,dark:n}=f),Object.assign(Object.assign({},u),{id:(E=u.id)!==null&&E!==void 0?E:void 0,handle:b,source:i,command:g.command?I.toInternal(g.command,d):void 0,icon:t,iconDark:n,themeIcon:l,accessibilityInformation:g.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const h of this._itemsBySourceAndUriMap.values())(d=h.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=C;function D(k){return k==null?void 0:k.toString()}}),define(we[208],_e([0,1,6,19,2,5]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,k,i,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=I.schemes.find(h=>!S.supportedSchemes.has(h));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,I.schemes,D,I.label),(0,w.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(D,k,i){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener with id: ${D}`);const d=A.URI.revive(k);return I.canOpenExternalUri(d,i)}async $openUri(D,k,i){const I=this._openers.get(D);if(!I)throw new Error(`Unknown opener id: '${D}'`);return I.openExternalUri(A.URI.revive(k.resolvedUri),{sourceUri:A.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=S,S.supportedSchemes=new Set([P.Schemas.http,P.Schemas.https])}),define(we[209],_e([0,1,5,2,6,12,26]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class C{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(w.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(S.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=C.HandlePool++;return this.handles.add(S.ExtensionIdentifier.toKey(k)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,k),(0,A.toDisposable)(()=>{this.handles.delete(S.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,i){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(P.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return P.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=C,C.HandlePool=0});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[50],_e([0,1,3,2,144,165,72,5]),function(Q,e,w,P,A,T,S,C){"use strict";var D,k,i,I,d,h,r,o,g,m,E,f;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class u{constructor(p,y,v,_,F,x,Y){D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,""),o.set(this,void 0),g.set(this,!1),m.set(this,!1),E.set(this,!1),this._onMessageEmitter=new w.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,f.set(this,new w.Emitter),this._onDidDispose=Me(this,f,"f").event,tt(this,D,p,"f"),tt(this,k,y,"f"),tt(this,o,v,"f"),tt(this,I,_,"f"),tt(this,d,F,"f"),tt(this,h,x,"f"),tt(this,E,b(x),"f"),tt(this,i,Y,"f")}dispose(){tt(this,g,!0,"f"),Me(this,f,"f").fire(),Me(this,f,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return tt(this,m,!0,"f"),(0,S.asWebviewUri)(Me(this,I,"f"),Me(this,D,"f"),p)}get cspSource(){return Me(this,I,"f").webviewCspSource.replace("{{uuid}}",Me(this,D,"f"))}get html(){return this.assertNotDisposed(),Me(this,r,"f")}set html(p){this.assertNotDisposed(),Me(this,r,"f")!==p&&(tt(this,r,p,"f"),!Me(this,m,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(tt(this,m,!0,"f"),Me(this,i,"f").report("Webview vscode-resource: uris",Me(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Me(this,k,"f").$setHtml(Me(this,D,"f"),p))}get options(){return this.assertNotDisposed(),Me(this,o,"f")}set options(p){this.assertNotDisposed(),Me(this,k,"f").$setOptions(Me(this,D,"f"),l(Me(this,h,"f"),Me(this,d,"f"),p)),tt(this,o,p,"f")}async postMessage(p){if(Me(this,g,"f"))return!1;const y=(0,T.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:Me(this,E,"f")});return Me(this,k,"f").$postMessage(Me(this,D,"f"),y.message,...y.buffers)}assertNotDisposed(){if(Me(this,g,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=u,D=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,g=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap;function b(c){try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(c.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=b;class t{constructor(p,y,v,_,F){this.initData=y,this.workspace=v,this._logService=_,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=p.getProxy(C.MainContext.MainThreadWebviews)}$onMessage(p,y,...v){const _=this.getWebview(p);if(_){const{message:F}=(0,T.deserializeWebviewMessage)(y,v);_._onMessageEmitter.fire(F)}}$onMissingCsp(p,y){this._logService.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,y,v){const _=new u(p,this._webviewProxy,a(y),this.initData,this.workspace,v,this._deprecationService);return this._webviews.set(p,_),_._onDidDispose(()=>{this._webviews.delete(p)}),_}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function l(c,p,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||s(c,p)}}e.serializeWebviewOptions=l;function a(c){var p;return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,portMapping:c.portMapping,localResourceRoots:(p=c.localResourceRoots)===null||p===void 0?void 0:p.map(y=>P.URI.from(y))}}e.reviveOptions=a;function s(c,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(y=>y.uri),c.extensionLocation]}}),define(we[210],_e([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=u(this.document.uri)+this._backupCounter++;return(0,S.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,l){const a=this.key(t,n.uri);if(this._documents.has(a))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const s=new h(n,l);return this._documents.set(a,s),s}delete(t,n){const l=this.key(t,n.uri);this._documents.delete(l)}key(t,n){return`${t}@@@${n}`}}var o;(function(b){b[b.Text=0]="Text",b[b.Custom=1]="Custom"})(o||(o={}));class g{constructor(){this._providers=new Map}addTextProvider(t,n,l){return this.add(0,t,n,l)}addCustomProvider(t,n,l){return this.add(1,t,n,l)}get(t){return this._providers.get(t)}add(t,n,l,a){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:l,provider:a}),new d.Disposable(()=>this._providers.delete(n))}}class m{constructor(t,n,l,a,s){this._extHostDocuments=n,this._extensionStoragePaths=l,this._extHostWebview=a,this._extHostWebviewPanels=s,this._editorProviders=new g,this._documents=new r,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,l,a){const s=new A.DisposableStore;return E(l)?(s.add(this._editorProviders.addTextProvider(n,t,l)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,a.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(s.add(this._editorProviders.addCustomProvider(n,t,l)),this.supportEditing(l)&&s.add(l.onDidChangeCustomDocument(c=>{const p=this.getCustomDocumentEntry(n,c.document.uri);if(f(c)){const y=p.addEdit(c);this._proxy.$onDidEdit(c.document.uri,n,y,c.label)}else this._proxy.$onContentChange(c.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(s,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,l,a,s){var c;const p=this._editorProviders.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const y=C.URI.revive(t),v=await p.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:a==null?void 0:a.buffer},s);let _;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(_=(c=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&c!==void 0?c:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(n,v,_),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,n){const l=this._editorProviders.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${n}'`);const a=C.URI.revive(t),{document:s}=this.getCustomDocumentEntry(n,a);this._documents.delete(n,s),s.dispose()}async $resolveWebviewEditor(t,n,l,a,s,c){const p=this._editorProviders.get(l);if(!p)throw new Error(`No provider found for '${l}'`);const y=D.ViewColumn.to(s),v=this._extHostWebview.createNewWebview(n,a.webviewOptions,p.extension),_=this._extHostWebviewPanels.createNewWebviewPanel(n,l,a.title,y,a.panelOptions,v),F=C.URI.revive(t);switch(p.type){case 1:{const{document:x}=this.getCustomDocumentEntry(l,F);return p.provider.resolveCustomEditor(x,_,c)}case 0:{const x=this._extHostDocuments.getDocument(F);return p.provider.resolveCustomTextEditor(x,_,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,l){this.getCustomDocumentEntry(n,t).disposeEdits(l)}async $onMoveCustomEditor(t,n,l){const a=this._editorProviders.get(l);if(!a)throw new Error(`No provider found for '${l}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const s=this._extHostWebviewPanels.getWebviewPanel(t);if(!s)throw new Error("No webview found");const c=C.URI.revive(n),p=this._extHostDocuments.getDocument(c);await a.provider.moveCustomTextEditor(p,s,w.CancellationToken.None)}async $undo(t,n,l,a){return this.getCustomDocumentEntry(n,t).undo(l,a)}async $redo(t,n,l,a){return this.getCustomDocumentEntry(n,t).redo(l,a)}async $revert(t,n,l){const a=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(a.document,l),a.disposeBackup()}async $onSave(t,n,l){const a=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(a.document,l),a.disposeBackup()}async $onSaveAs(t,n,l,a){const s=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(s.document,C.URI.revive(l),a)}async $backup(t,n,l){const a=this.getCustomDocumentEntry(n,t),c=await this.getCustomEditorProvider(n).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},l);return a.updateBackup(c),c.id}getCustomDocumentEntry(t,n){const l=this._documents.get(t,C.URI.revive(n));if(!l)throw new Error("No custom document found");return l}getCustomEditorProvider(t){const n=this._editorProviders.get(t),l=n==null?void 0:n.provider;if(!l||!this.supportEditing(l))throw new Error("Custom document is not editable");return l}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=m;function E(b){return typeof b.resolveCustomTextEditor=="function"}function f(b){return typeof b.undo=="function"&&typeof b.redo=="function"}function u(b){const t=b.scheme===T.Schemas.file||b.scheme===T.Schemas.untitled?b.fsPath:b.toString();return(0,P.hash)(t)+""}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[211],_e([0,1,3,6,2,31,9,50,5,7]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";var i,I,d,h,r,o,g,m,E,f,u,b,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends P.Disposable{constructor(c,p,y,v,_,F,x){super();i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),o.set(this,void 0),g.set(this,void 0),m.set(this,void 0),E.set(this,!0),f.set(this,!0),u.set(this,!1),b.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,b,"f").event,t.set(this,this._register(new w.Emitter)),this.onDidChangeViewState=Me(this,t,"f").event,tt(this,i,c,"f"),tt(this,I,p,"f"),tt(this,d,y,"f"),tt(this,r,F,"f"),tt(this,m,_,"f"),tt(this,o,v,"f"),tt(this,h,x,"f")}dispose(){Me(this,u,"f")||(tt(this,u,!0,"f"),Me(this,b,"f").fire(),Me(this,I,"f").$disposeWebview(Me(this,i,"f")),Me(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Me(this,h,"f")}get viewType(){return this.assertNotDisposed(),Me(this,d,"f")}get title(){return this.assertNotDisposed(),Me(this,o,"f")}set title(c){this.assertNotDisposed(),Me(this,o,"f")!==c&&(tt(this,o,c,"f"),Me(this,I,"f").$setTitle(Me(this,i,"f"),c))}get iconPath(){return this.assertNotDisposed(),Me(this,g,"f")}set iconPath(c){this.assertNotDisposed(),Me(this,g,"f")!==c&&(tt(this,g,c,"f"),Me(this,I,"f").$setIconPath(Me(this,i,"f"),A.URI.isUri(c)?{light:c,dark:c}:c))}get options(){return Me(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Me(this,m,"f")=="number"&&Me(this,m,"f")<0))return Me(this,m,"f")}get active(){return this.assertNotDisposed(),Me(this,f,"f")}get visible(){return this.assertNotDisposed(),Me(this,E,"f")}_updateViewState(c){Me(this,u,"f")||(this.active!==c.active||this.visible!==c.visible||this.viewColumn!==c.viewColumn)&&(tt(this,f,c.active,"f"),tt(this,E,c.visible,"f"),tt(this,m,c.viewColumn,"f"),Me(this,t,"f").fire({webviewPanel:this}))}reveal(c,p){this.assertNotDisposed(),Me(this,I,"f").$reveal(Me(this,i,"f"),{viewColumn:c?S.ViewColumn.from(c):void 0,preserveFocus:!!p})}assertNotDisposed(){if(Me(this,u,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,g=new WeakMap,m=new WeakMap,E=new WeakMap,f=new WeakMap,u=new WeakMap,b=new WeakMap,t=new WeakMap;class l{constructor(c,p,y){this.webviews=p,this.workspace=y,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=c.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(c,p,y,v,_={}){const F=typeof v=="object"?v.viewColumn:v,x={viewColumn:S.ViewColumn.from(F),preserveFocus:typeof v=="object"&&!!v.preserveFocus},Y=(0,C.shouldSerializeBuffersForPostMessage)(c),me=l.newHandle();this._proxy.$createWebviewPanel((0,C.toExtensionData)(c),me,p,{title:y,panelOptions:a(_),webviewOptions:(0,C.serializeWebviewOptions)(c,this.workspace,_),serializeBuffersForPostMessage:Y},x);const j=this.webviews.createNewWebview(me,_,c);return this.createNewWebviewPanel(me,p,y,F,_,j)}$onDidChangeWebviewPanelViewStates(c){const p=Object.keys(c);p.sort((y,v)=>{const _=c[y],F=c[v];return _.active?1:F.active?-1:+_.visible-+F.visible});for(const y of p){const v=this.getWebviewPanel(y);if(!!v){const _=c[y];v._updateViewState({active:_.active,visible:_.visible,viewColumn:S.ViewColumn.to(_.position)})}}}async $onDidDisposeWebviewPanel(c){const p=this.getWebviewPanel(c);p==null||p.dispose(),this._webviewPanels.delete(c),this.webviews.deleteWebview(c)}registerWebviewPanelSerializer(c,p,y){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:y,extension:c}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,C.shouldSerializeBuffersForPostMessage)(c)}),new k.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(c,p,y,v){const _=this._serializers.get(p);if(!_)throw new Error(`No serializer found for '${p}'`);const{serializer:F,extension:x}=_,Y=this.webviews.createNewWebview(c,y.webviewOptions,x),me=this.createNewWebviewPanel(c,p,y.title,v,y.panelOptions,Y);await F.deserializeWebviewPanel(me,y.state)}createNewWebviewPanel(c,p,y,v,_,F){const x=new n(c,this._proxy,p,y,v,_,F);return this._webviewPanels.set(c,x),x}getWebviewPanel(c){return this._webviewPanels.get(c)}}e.ExtHostWebviewPanels=l;function a(s){return{enableFindWidget:s.enableFindWidget,retainContextWhenHidden:s.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[212],_e([0,1,3,6,50,5,7]),function(Q,e,w,P,A,T,S){"use strict";var C,D,k,i,I,d,h,r,o,g;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class m extends P.Disposable{constructor(u,b,t,n,l,a){super();C.set(this,void 0),D.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,!1),d.set(this,void 0),h.set(this,void 0),r.set(this,void 0),o.set(this,this._register(new w.Emitter)),this.onDidChangeVisibility=Me(this,o,"f").event,g.set(this,this._register(new w.Emitter)),this.onDidDispose=Me(this,g,"f").event,tt(this,k,t,"f"),tt(this,h,n,"f"),tt(this,C,u,"f"),tt(this,D,b,"f"),tt(this,i,l,"f"),tt(this,d,a,"f")}dispose(){Me(this,I,"f")||(tt(this,I,!0,"f"),Me(this,g,"f").fire(),Me(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Me(this,h,"f")}set title(u){this.assertNotDisposed(),Me(this,h,"f")!==u&&(tt(this,h,u,"f"),Me(this,D,"f").$setWebviewViewTitle(Me(this,C,"f"),u))}get description(){return this.assertNotDisposed(),Me(this,r,"f")}set description(u){this.assertNotDisposed(),Me(this,r,"f")!==u&&(tt(this,r,u,"f"),Me(this,D,"f").$setWebviewViewDescription(Me(this,C,"f"),u))}get visible(){return Me(this,d,"f")}get webview(){return Me(this,i,"f")}get viewType(){return Me(this,k,"f")}_setVisible(u){u===Me(this,d,"f")||Me(this,I,"f")||(tt(this,d,u,"f"),Me(this,o,"f").fire())}show(u){this.assertNotDisposed(),Me(this,D,"f").$show(Me(this,C,"f"),!!u)}assertNotDisposed(){if(Me(this,I,"f"))throw new Error("Webview is disposed")}}C=new WeakMap,D=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,g=new WeakMap;class E{constructor(u,b){this._extHostWebview=b,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=u.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(u,b,t,n){if(this._viewProviders.has(b))throw new Error(`View provider for '${b}' already registered`);return this._viewProviders.set(b,{provider:t,extension:u}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(u),b,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new S.Disposable(()=>{this._viewProviders.delete(b),this._proxy.$unregisterWebviewViewProvider(b)})}async $resolveWebviewView(u,b,t,n,l){const a=this._viewProviders.get(b);if(!a)throw new Error(`No view provider found for '${b}'`);const{provider:s,extension:c}=a,p=this._extHostWebview.createNewWebview(u,{},c),y=new m(u,this._proxy,b,t,p,!0);this._webviewViews.set(u,y),await s.resolveWebviewView(y,{state:n},l)}async $onDidChangeWebviewViewVisibility(u,b){this.getWebviewView(u)._setVisible(b)}async $disposeWebviewView(u){const b=this.getWebviewView(u);this._webviewViews.delete(u),b.dispose(),this._extHostWebview.deleteWebview(u)}getWebviewView(u){const b=this._webviewViews.get(u);if(!b)throw new Error("No webview found");return b}}e.ExtHostWebviewViews=E}),define(we[101],_e([0,1,3,5,2,19,8,4,14]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Fn{constructor(I){this._onDidChangeWindowState=new w.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=I.getProxy(P.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,d){let h;if(typeof I=="string"){h=I;try{I=A.URI.parse(I)}catch(r){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,S.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,d)}async asExternalUri(I,d){if((0,S.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const h=await this._proxy.$asExternalUri(I,d);return A.URI.from(h)}};k.InitialState={focused:!0},k=Ve([qe(0,D.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,C.createDecorator)("IExtHostWindow")}),define(we[213],_e([0,1,18,5,27,14]),function(Q,e,w,P,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let S=class extends w.AbstractLogger{constructor(D,k){super();this._proxy=D.getProxy(P.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(D){this.setLevel(D)}trace(D,...k){this.getLevel()<=w.LogLevel.Trace&&this._proxy.$log(this._logFile,w.LogLevel.Trace,Array.from(arguments))}debug(D,...k){this.getLevel()<=w.LogLevel.Debug&&this._proxy.$log(this._logFile,w.LogLevel.Debug,Array.from(arguments))}info(D,...k){this.getLevel()<=w.LogLevel.Info&&this._proxy.$log(this._logFile,w.LogLevel.Info,Array.from(arguments))}warn(D,...k){this.getLevel()<=w.LogLevel.Warning&&this._proxy.$log(this._logFile,w.LogLevel.Warning,Array.from(arguments))}error(D,...k){this.getLevel()<=w.LogLevel.Error&&this._proxy.$log(this._logFile,w.LogLevel.Error,Array.from(arguments))}critical(D,...k){this.getLevel()<=w.LogLevel.Critical&&this._proxy.$log(this._logFile,w.LogLevel.Critical,Array.from(arguments))}flush(){}};S=Ve([qe(0,T.IExtHostRpcService),qe(1,A.IExtHostInitDataService)],S),e.ExtHostLogService=S}),define(we[214],_e([0,1,11,20,12,3,6,113,186,98,24]),function(Q,e,w,P,A,T,S,C,D,k,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(a,s){try{return JSON.stringify(a,s)}catch(c){return"null"}}function h(a,s){return JSON.stringify(a,s)}function r(a){return a?(s,c)=>c&&c.$mid===1?a.transformOutgoing(c):c:null}var o;(function(a){a[a.LocalSide=0]="LocalSide",a[a.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(a){a[a.Responsive=0]="Responsive",a[a.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const m=()=>{},E=Symbol.for("rpcProtocol"),f=Symbol.for("rpcProxy");class u extends S.Disposable{constructor(s,c=null,p=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=s,this._logger=c,this._uriTransformer=p,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let y=0,v=k.ProxyIdentifier.count;y<v;y++)this._locals[y]=null,this._proxies[y]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new w.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(y=>this._receiveOneMessage(y))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(s=>{this._pendingRPCReplies[s].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(s){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(s){this._unresponsiveTime=Date.now()+u.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(s){this._responsiveState!==s&&(this._responsiveState=s,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(s){return this._uriTransformer?(0,C.transformIncomingURIs)(s,this._uriTransformer):s}getProxy(s){const{nid:c,sid:p}=s;return this._proxies[c]||(this._proxies[c]=this._createProxy(c,p)),this._proxies[c]}_createProxy(s,c){let p={get:(y,v)=>(typeof v=="string"&&!y[v]&&v.charCodeAt(0)===36&&(y[v]=(..._)=>this._remoteCall(s,v,_)),v===f?c:y[v])};return new Proxy(Object.create(null),p)}set(s,c){return this._locals[s.nid]=c,c}assertRegistered(s){for(let c=0,p=s.length;c<p;c++){const y=s[c];if(!this._locals[y.nid])throw new Error(`Missing actor ${y.sid} (isMain: ${y.isMain})`)}}_receiveOneMessage(s){if(!this._isDisposed){const c=s.byteLength,p=b.read(s,0),y=p.readUInt8(),v=p.readUInt32();switch(y){case 1:case 2:{let{rpcId:_,method:F,args:x}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(c,v,_,F,x,y===2);break}case 3:case 4:{let{rpcId:_,method:F,args:x}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(x=(0,C.transformIncomingURIs)(x,this._uriTransformer)),this._receiveRequest(c,v,_,F,x,y===4);break}case 5:{this._logger&&this._logger.logIncoming(c,v,0,"ack"),this._onDidReceiveAcknowledge(v);break}case 6:{this._receiveCancel(c,v);break}case 7:{this._receiveReply(c,v,void 0);break}case 9:{let _=t.deserializeReplyOKJSON(p);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReply(c,v,_);break}case 8:{let _=t.deserializeReplyOKVSBuffer(p);this._receiveReply(c,v,_);break}case 10:{let _=t.deserializeReplyErrError(p);this._uriTransformer&&(_=(0,C.transformIncomingURIs)(_,this._uriTransformer)),this._receiveReplyErr(c,v,_);break}case 11:{this._receiveReplyErr(c,v,void 0);break}default:console.error("received unexpected message"),console.error(s)}}}_receiveRequest(s,c,p,y,v,_){this._logger&&this._logger.logIncoming(s,c,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(p)}.${y}(`,v);const F=String(c);let x,Y;if(_){const j=new P.CancellationTokenSource;v.push(j.token),x=this._invokeHandler(p,y,v),Y=()=>j.cancel()}else x=this._invokeHandler(p,y,v),Y=m;this._cancelInvokedHandlers[F]=Y;const me=t.serializeAcknowledged(c);this._logger&&this._logger.logOutgoing(me.byteLength,c,1,"ack"),this._protocol.send(me),x.then(j=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyOK(c,j,this._uriReplacer);this._logger&&this._logger.logOutgoing(z.byteLength,c,1,"reply:",j),this._protocol.send(z)},j=>{delete this._cancelInvokedHandlers[F];const z=t.serializeReplyErr(c,j);this._logger&&this._logger.logOutgoing(z.byteLength,c,1,"replyErr:",j),this._protocol.send(z)})}_receiveCancel(s,c){this._logger&&this._logger.logIncoming(s,c,1,"receiveCancel");const p=String(c);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(s,c,p){this._logger&&this._logger.logIncoming(s,c,0,"receiveReply:",p);const y=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(y)){const v=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y],v.resolveOk(p)}}_receiveReplyErr(s,c,p){this._logger&&this._logger.logIncoming(s,c,0,"receiveReplyErr:",p);const y=String(c);if(!!this._pendingRPCReplies.hasOwnProperty(y)){const v=this._pendingRPCReplies[y];delete this._pendingRPCReplies[y];let _;p&&(p.$isError?(_=new Error,_.name=p.name,_.message=p.message,_.stack=p.stack):_=p),v.resolveErr(_)}}_invokeHandler(s,c,p){try{return Promise.resolve(this._doInvokeHandler(s,c,p))}catch(y){return Promise.reject(y)}}_doInvokeHandler(s,c,p){const y=this._locals[s];if(!y)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(s));let v=y[c];if(typeof v!="function")throw new Error("Unknown method "+c+" on actor "+(0,k.getStringIdentifierForProxy)(s));return v.apply(y,p)}_remoteCall(s,c,p){if(this._isDisposed)return Promise.reject(A.canceled());let y=null;if(p.length>0&&P.CancellationToken.isCancellationToken(p[p.length-1])&&(y=p.pop()),y&&y.isCancellationRequested)return Promise.reject(A.canceled());const v=t.serializeRequestArguments(p,this._uriReplacer),_=++this._lastMessageId,F=String(_),x=new D.LazyPromise;y&&y.onCancellationRequested(()=>{const me=t.serializeCancel(_);this._logger&&this._logger.logOutgoing(me.byteLength,_,0,"cancel"),this._protocol.send(t.serializeCancel(_))}),this._pendingRPCReplies[F]=x,this._onWillSendRequest(_);const Y=t.serializeRequest(_,s,c,v,!!y);return this._logger&&this._logger.logOutgoing(Y.byteLength,_,0,`request: ${(0,k.getStringIdentifierForProxy)(s)}.${c}(`,p),this._protocol.send(Y),x}}e.RPCProtocol=u,I=E,u.UNRESPONSIVE_TIME=3*1e3;class b{constructor(s,c){this._buff=s,this._offset=c}static alloc(s,c,p){let y=new b(i.VSBuffer.alloc(p+1+4),0);return y.writeUInt8(s),y.writeUInt32(c),y}static read(s,c){return new b(s,c)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(s){this._buff.writeUInt8(s,this._offset),this._offset+=1}readUInt8(){const s=this._buff.readUInt8(this._offset);return this._offset+=1,s}writeUInt32(s){this._buff.writeUInt32BE(s,this._offset),this._offset+=4}readUInt32(){const s=this._buff.readUInt32BE(this._offset);return this._offset+=4,s}static sizeShortString(s){return 1+s.byteLength}writeShortString(s){this._buff.writeUInt8(s.byteLength,this._offset),this._offset+=1,this._buff.set(s,this._offset),this._offset+=s.byteLength}readShortString(){const s=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,p}static sizeLongString(s){return 4+s.byteLength}writeLongString(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readLongString(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+s).toString();return this._offset+=s,p}writeBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}static sizeVSBuffer(s){return 4+s.byteLength}writeVSBuffer(s){this._buff.writeUInt32BE(s.byteLength,this._offset),this._offset+=4,this._buff.set(s,this._offset),this._offset+=s.byteLength}readVSBuffer(){const s=this._buff.readUInt32BE(this._offset);this._offset+=4;const c=this._buff.slice(this._offset,this._offset+s);return this._offset+=s,c}static sizeMixedArray(s,c){let p=0;p+=1;for(let y=0,v=s.length;y<v;y++){const _=s[y],F=c[y];switch(p+=1,F){case 1:p+=this.sizeLongString(_);break;case 2:p+=this.sizeVSBuffer(_);break;case 3:break}}return p}writeMixedArray(s,c){this._buff.writeUInt8(s.length,this._offset),this._offset+=1;for(let p=0,y=s.length;p<y;p++){const v=s[p];switch(c[p]){case 1:this.writeUInt8(1),this.writeLongString(v);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const s=this._buff.readUInt8(this._offset);this._offset+=1;let c=new Array(s);for(let p=0;p<s;p++)switch(this.readUInt8()){case 1:c[p]=this.readLongString();break;case 2:c[p]=this.readVSBuffer();break;case 3:c[p]=void 0;break}return c}}class t{static _arrayContainsBufferOrUndefined(s){for(let c=0,p=s.length;c<p;c++)if(s[c]instanceof i.VSBuffer||typeof s[c]=="undefined")return!0;return!1}static serializeRequestArguments(s,c){if(this._arrayContainsBufferOrUndefined(s)){let p=[],y=[];for(let v=0,_=s.length;v<_;v++){const F=s[v];F instanceof i.VSBuffer?(p[v]=F,y[v]=2):typeof F=="undefined"?(p[v]=i.VSBuffer.alloc(0),y[v]=3):(p[v]=i.VSBuffer.fromString(h(F,c)),y[v]=1)}return{type:"mixed",args:p,argsType:y}}return{type:"simple",args:h(s,c)}}static serializeRequest(s,c,p,y,v){return y.type==="mixed"?this._requestMixedArgs(s,c,p,y.args,y.argsType,v):this._requestJSONArgs(s,c,p,y.args,v)}static _requestJSONArgs(s,c,p,y,v){const _=i.VSBuffer.fromString(p),F=i.VSBuffer.fromString(y);let x=0;x+=b.sizeUInt8(),x+=b.sizeShortString(_),x+=b.sizeLongString(F);let Y=b.alloc(v?2:1,s,x);return Y.writeUInt8(c),Y.writeShortString(_),Y.writeLongString(F),Y.buffer}static deserializeRequestJSONArgs(s){const c=s.readUInt8(),p=s.readShortString(),y=s.readLongString();return{rpcId:c,method:p,args:JSON.parse(y)}}static _requestMixedArgs(s,c,p,y,v,_){const F=i.VSBuffer.fromString(p);let x=0;x+=b.sizeUInt8(),x+=b.sizeShortString(F),x+=b.sizeMixedArray(y,v);let Y=b.alloc(_?4:3,s,x);return Y.writeUInt8(c),Y.writeShortString(F),Y.writeMixedArray(y,v),Y.buffer}static deserializeRequestMixedArgs(s){const c=s.readUInt8(),p=s.readShortString(),y=s.readMixedArray(),v=new Array(y.length);for(let _=0,F=y.length;_<F;_++){const x=y[_];typeof x=="string"?v[_]=JSON.parse(x):v[_]=x}return{rpcId:c,method:p,args:v}}static serializeAcknowledged(s){return b.alloc(5,s,0).buffer}static serializeCancel(s){return b.alloc(6,s,0).buffer}static serializeReplyOK(s,c,p){return typeof c=="undefined"?this._serializeReplyOKEmpty(s):c instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(s,c):this._serializeReplyOKJSON(s,d(c,p))}static _serializeReplyOKEmpty(s){return b.alloc(7,s,0).buffer}static _serializeReplyOKVSBuffer(s,c){let p=0;p+=b.sizeVSBuffer(c);let y=b.alloc(8,s,p);return y.writeVSBuffer(c),y.buffer}static deserializeReplyOKVSBuffer(s){return s.readVSBuffer()}static _serializeReplyOKJSON(s,c){const p=i.VSBuffer.fromString(c);let y=0;y+=b.sizeLongString(p);let v=b.alloc(9,s,y);return v.writeLongString(p),v.buffer}static deserializeReplyOKJSON(s){const c=s.readLongString();return JSON.parse(c)}static serializeReplyErr(s,c){return c?this._serializeReplyErrEror(s,c):this._serializeReplyErrEmpty(s)}static _serializeReplyErrEror(s,c){const p=i.VSBuffer.fromString(d(A.transformErrorForSerialization(c),null));let y=0;y+=b.sizeLongString(p);let v=b.alloc(10,s,y);return v.writeLongString(p),v.buffer}static deserializeReplyErrError(s){const c=s.readLongString();return JSON.parse(c)}static _serializeReplyErrEmpty(s){return b.alloc(11,s,0).buffer}}var n;(function(a){a[a.RequestJSONArgs=1]="RequestJSONArgs",a[a.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",a[a.RequestMixedArgs=3]="RequestMixedArgs",a[a.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",a[a.Acknowledged=5]="Acknowledged",a[a.Cancel=6]="Cancel",a[a.ReplyOKEmpty=7]="ReplyOKEmpty",a[a.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",a[a.ReplyOKJSON=9]="ReplyOKJSON",a[a.ReplyErrError=10]="ReplyErrError",a[a.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var l;(function(a){a[a.String=1]="String",a[a.VSBuffer=2]="VSBuffer",a[a.Undefined=3]="Undefined"})(l||(l={}))}),define(we[215],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const w=function(T){const S=C=>{self.removeEventListener("message",S);const D=C.data;Object.defineProperties(self,{postMessage:{value(k,i){D.postMessage(k,i)}},onmessage:{get(){return D.onmessage},set(k){D.onmessage=k}}}),D.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",S)}.toString();class P extends EventTarget{constructor(T,S,C){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${w})('${S}'))`,k=new Blob([D],{type:"application/javascript"}),i=URL.createObjectURL(k),I=new MessageChannel,d=i,h={type:"_newWorker",id:d,port:I.port2,url:i,options:C};T(h,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:d};I.port1.postMessage(r),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(r){I.port1.onmessage=r}},onmessageerror:{get(){return I.port1.onmessageerror},set(r){I.port1.onmessageerror=r}}}),I.port1.addEventListener("messageerror",r=>{const o=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(o)}),I.port1.addEventListener("message",r=>{const o=new MessageEvent("message",{data:r.data});this.dispatchEvent(o)}),I.port1.start()}}e.NestedWorker=P}),define(we[216],_e([0,1,4]),function(Q,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,w.createDecorator)("remoteAgentService")}),define(we[217],_e([0,1,19,13,21,2,4,216]),function(Q,e,w,P,A,T,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,S.createDecorator)("pathService");let D=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||A.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?P.win32:P.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const h=i.indexOf("/",2);h===-1?(I=i.substring(2),i="/"):(I=i.substring(2,h),i=i.substring(h)||"/")}return T.URI.from({scheme:w.Schemas.file,authority:I,path:i,query:"",fragment:""})}};D=Ve([qe(1,C.IRemoteAgentService)],D),e.AbstractPathService=D}),define(we[102],_e([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class w{constructor(S,C){this.line=S,this.character=C}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,C){return new w(0,0)}with(S){return new w(0,0)}}e.Position=w;class P{constructor(S,C,D,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(S,C),this.end=new w(D,k)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new P(0,0,0,0)}with(S){return new P(0,0,0,0)}}e.Range=P;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],_e([0,1,15,28,23,37,8,4,13,12,102]),function(Q,e,w,P,A,T,S,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",d=" characters skipped \u27EB",h=(I.length+d.length+5)*2;e.ISearchService=(0,C.createDecorator)("searchService");var r;(function(R){R[R.file=0]="file",R[R.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(R){R[R.File=1]="File",R[R.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function g(R){return!!R.preview}e.resultIsMatch=g;function m(R){return!!R.resource}e.isFileMatch=m;function E(R){return!!R.message}e.isProgressMessage=E;var f;(function(R){R[R.Normal=0]="Normal",R[R.NewSearchStarted=1]="NewSearchStarted"})(f=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class u{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=u;class b{constructor(L,M,U){this.ranges=M;const G=Array.isArray(M)?M:[M];if(U&&U.matchLines===1&&t(G)){L=(0,S.getNLines)(L,U.matchLines);let J="",re=0,pe=0;const Te=Math.floor(U.charsPerLine/5),xe=[];for(const Ae of G){const We=Math.max(Ae.startColumn-Te,0),B=Ae.startColumn+U.charsPerLine;if(We>pe+Te+h){const q=I+(We-pe)+d;J+=q+L.slice(We,B),re+=We-(pe+q.length)}else J+=L.slice(pe,B);xe.push(new l(0,Ae.startColumn-re,Ae.endColumn-re)),pe=B}this.preview={text:J,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const J=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,w.mapArrayOrNot)(M,re=>new n(re.startLineNumber-J,re.startColumn,re.endLineNumber-J,re.endColumn))}}}}e.TextSearchMatch=b;function t(R){const L=R[0].startLineNumber;for(const M of R)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,U,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=U,this.endColumn=G}}e.SearchRange=n;class l extends n{constructor(L,M,U){super(L,M,L,U)}}e.OneLineRange=l;var a;(function(R){R.Default="default",R.FileNames="fileNames",R.Type="type",R.Modified="modified",R.CountDescending="countDescending",R.CountAscending="countAscending"})(a=e.SearchSortOrder||(e.SearchSortOrder={}));function s(R,L=!0){const M=R&&R.files&&R.files.exclude,U=L&&R&&R.search&&R.search.exclude;if(!(!M&&!U)){if(!M||!U)return M||U;let G=Object.create(null);return G=A.mixin(G,A.deepClone(M)),G=A.mixin(G,A.deepClone(U),!0),G}}e.getExcludes=s;function c(R,L){return R.excludePattern&&P.match(R.excludePattern,L)?!1:R.includePattern||R.usingSearchPaths?R.includePattern&&P.match(R.includePattern,L)?!0:R.usingSearchPaths?!!R.folderQueries&&R.folderQueries.some(M=>{const U=M.folder.fsPath;if(T.isEqualOrParent(L,U)){const G=D.relative(U,L);return!M.includePattern||!!P.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var p;(function(R){R[R.unknownEncoding=1]="unknownEncoding",R[R.regexParseError=2]="regexParseError",R[R.globParseError=3]="globParseError",R[R.invalidLiteral=4]="invalidLiteral",R[R.rgProcessError=5]="rgProcessError",R[R.other=6]="other",R[R.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class y extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=y;function v(R){const L=R.message;if((0,k.isPromiseCanceledError)(R))return new y(L,p.canceled);try{const M=JSON.parse(L);return new y(M.message,M.code)}catch(M){return new y(L,p.other)}}e.deserializeSearchError=v;function _(R){const L={message:R.message,code:R.code};return new Error(JSON.stringify(L))}e.serializeSearchError=_;function F(R){return R.type==="error"?!0:R.type==="success"}e.isSerializedSearchComplete=F;function x(R){return R.type==="success"}e.isSerializedSearchSuccess=x;function Y(R){return!!R.path}e.isSerializedFileMatch=Y;function me(R,L){const M=R.searchPath?R.searchPath:R.relativePath;return(0,S.fuzzyContains)(M,L)}e.isFilePatternMatch=me;class j{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=j;function z(R,L){const M=Object.assign(Object.assign({},R||{}),L||{});return Object.keys(M).filter(U=>{const G=M[U];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=z;class te{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=P.parse(this._excludeExpression);let U=L.includePattern;M.includePattern&&(U?U=Object.assign(Object.assign({},U),M.includePattern):U=M.includePattern),U&&(this._parsedIncludeExpression=P.parse(U))}includedInQuerySync(L,M,U){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,U)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,U))}includedInQuery(L,M,U){return Promise.resolve(this._parsedExcludeExpression(L,M,U)).then(J=>!!J).then(J=>J?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,U)).then(re=>!!re):Promise.resolve(!0)).then(J=>J)}hasSiblingExcludeClauses(){return $(this._excludeExpression)}}e.QueryGlobTester=te;function $(R){for(const L in R)if(typeof R[L]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,15,11,20,3,22,19,81,25,8,10,2,137,4,18,152,48,49,27,14,7,41,5]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u,b,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function l(F,x,Y){return new k.ExtUri(me=>p(me,Y)).isEqual(F,x)}function a(F,x,Y){return l(F.uri,x.uri,Y)?0:(0,i.compare)(F.uri.toString(),x.uri.toString())}function s(F,x,Y){return F.index!==x.index?F.index<x.index?-1:1:l(F.uri,x.uri,Y)?(0,i.compare)(F.name,x.name):(0,i.compare)(F.uri.toString(),x.uri.toString())}function c(F,x,Y,me){const j=F.slice(0).sort((te,$)=>Y(te,$,me)),z=x.slice(0).sort((te,$)=>Y(te,$,me));return(0,w.delta)(j,z,(te,$)=>Y(te,$,me))}function p(F,x){const Y=x.getCapabilities(F.scheme);return!(Y&&Y&1024)}class y extends m.Workspace{constructor(x,Y,me,j,z,te){super(x,me.map($=>new m.WorkspaceFolder($)),j,te);this._name=Y,this._isUntitled=z,this._workspaceFolders=[],this._structure=S.TernarySearchTree.forUris(te),me.forEach($=>{this._workspaceFolders.push($),this._structure.set($.uri,$)})}static toExtHostWorkspace(x,Y,me,j){if(!x)return{workspace:null,added:[],removed:[]};const{id:z,name:te,folders:$,configuration:R,isUntitled:L}=x,M=[],U=Y;Y?$.forEach((pe,Te)=>{const xe=d.URI.revive(pe.uri),Ae=y._findFolder(me||Y,xe,j);Ae?(Ae.name=pe.name,Ae.index=pe.index,M.push(Ae)):M.push({uri:xe,name:pe.name,index:Te})}):M.push(...$.map(({uri:pe,name:Te,index:xe})=>({uri:d.URI.revive(pe),name:Te,index:xe}))),M.sort((pe,Te)=>pe.index<Te.index?-1:1);const G=new y(z,te,M,R?d.URI.revive(R):null,!!L,pe=>p(pe,j)),{added:J,removed:re}=c(U?U.workspaceFolders:[],G.workspaceFolders,a,j);return{workspace:G,added:J,removed:re}}static _findFolder(x,Y,me){for(let j=0;j<x.folders.length;j++){const z=x.workspaceFolders[j];if(l(z.uri,Y,me))return z}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(x,Y){return Y&&this._structure.get(x)&&(x=(0,k.dirname)(x)),this._structure.findSubstr(x)}resolveWorkspaceFolder(x){return this._structure.get(x)}}let v=class{constructor(x,Y,me,j){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=j,this._extHostFileSystemInfo=me,this._requestIdProvider=new D.Counter,this._barrier=new P.Barrier,this._proxy=x.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=x.getProxy(n.MainContext.MainThreadMessageService);const z=Y.workspace;this._confirmedWorkspace=z?new y(z.id,z.name,[],z.configuration?d.URI.revive(z.configuration):null,!!z.isUntitled,te=>p(te,me)):void 0}$initializeWorkspace(x,Y){this._trusted=Y,this.$acceptWorkspaceData(x),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:C.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(x,Y,me,...j){const z=[];if(Array.isArray(j)&&j.forEach(M=>{d.URI.isUri(M.uri)&&!z.some(U=>l(U.uri,M.uri,this._extHostFileSystemInfo))&&z.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[Y,me].some(M=>typeof M!="number"||M<0)||me===0&&z.length===0)return!1;const te=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(Y+me>te.length)return!1;const $=te.slice(0);$.splice(Y,me,...z.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<$.length;M++){const U=$[M];if($.some((G,J)=>J!==M&&l(U.uri,G.uri,this._extHostFileSystemInfo)))return!1}$.forEach((M,U)=>M.index=U);const{added:R,removed:L}=c(te,$,s,this._extHostFileSystemInfo);if(R.length===0&&L.length===0)return!1;if(this._proxy){const M=x.displayName||x.name;this._proxy.$updateWorkspaceFolders(M,Y,me,z).then(void 0,U=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(g.Severity.Error,(0,h.localize)(0,null,M,U.toString()),{extension:x},[])})}return this.trySetWorkspaceFolders($),!0}getWorkspaceFolder(x,Y){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,Y)}async getWorkspaceFolder2(x,Y){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(x,Y)}async resolveWorkspaceFolder(x){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(x)}getPath(){if(!!this._actualWorkspace){const{folders:x}=this._actualWorkspace;if(x.length!==0)return x[0].uri.fsPath}}getRelativePath(x,Y){let me,j="";if(typeof x=="string"?(me=d.URI.file(x),j=x):typeof x!="undefined"&&(me=x,j=x.fsPath),!me)return j;const z=this.getWorkspaceFolder(me,!0);if(!z)return j;typeof Y=="undefined"&&this._actualWorkspace&&(Y=this._actualWorkspace.folders.length>1);let te=(0,k.relativePath)(z.uri,me);return Y&&z.name&&(te=`${z.name}/${te}`),te}trySetWorkspaceFolders(x){this._actualWorkspace&&(this._unconfirmedWorkspace=y.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:x,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(x){const{workspace:Y,added:me,removed:j}=y.toExtHostWorkspace(x,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=Y||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:me,removed:j}))}findFiles(x,Y,me,j,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let te;if(Y===null?te=!1:Y&&(typeof Y=="string"?te=Y:te=Y.pattern),z&&z.isCancellationRequested)return Promise.resolve([]);const{includePattern:$,folder:R}=_(x);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)($),(0,I.withUndefinedAsNull)(R),(0,I.withUndefinedAsNull)(te),(0,I.withUndefinedAsNull)(me),z).then(L=>Array.isArray(L)?L.map(M=>d.URI.revive(M)):[])}async findTextInFiles(x,Y,me,j,z=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const te=this._requestIdProvider.getNext(),$=typeof Y.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:Y.previewOptions,{includePattern:R,folder:L}=_(Y.include),M=typeof Y.exclude=="string"?Y.exclude:Y.exclude?Y.exclude.pattern:void 0,U={ignoreSymlinks:typeof Y.followSymlinks=="boolean"?!Y.followSymlinks:void 0,disregardIgnoreFiles:typeof Y.useIgnoreFiles=="boolean"?!Y.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof Y.useGlobalIgnoreFiles=="boolean"?!Y.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof Y.useDefaultExcludes=="boolean"?!Y.useDefaultExcludes:!0,fileEncoding:Y.encoding,maxResults:Y.maxResults,previewOptions:$,afterContext:Y.afterContext,beforeContext:Y.beforeContext,includePattern:R,excludePattern:M},G=!1;if(this._activeSearchCallbacks[te]=J=>{if(!G){const re=d.URI.revive(J.resource);J.results.forEach(pe=>{(0,t.resultIsMatch)(pe)?me({uri:re,preview:{text:pe.preview.text,matches:(0,w.mapArrayOrNot)(pe.preview.matches,Te=>new b.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))},ranges:(0,w.mapArrayOrNot)(pe.ranges,Te=>new b.Range(Te.startLineNumber,Te.startColumn,Te.endLineNumber,Te.endColumn))}):me({uri:re,text:pe.text,lineNumber:pe.lineNumber})})}},z.isCancellationRequested)return{};try{const J=await this._proxy.$startTextSearch(x,(0,I.withUndefinedAsNull)(L),U,te,z);return delete this._activeSearchCallbacks[te],J||{}}catch(J){throw delete this._activeSearchCallbacks[te],J}}$handleTextSearchResult(x,Y){this._activeSearchCallbacks[Y]&&this._activeSearchCallbacks[Y](x)}saveAll(x){return this._proxy.$saveAll(x)}resolveProxy(x){return this._proxy.$resolveProxy(x)}get trusted(){return this._trusted}requestWorkspaceTrust(x){return this._proxy.$requestWorkspaceTrust(x)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};v=Ve([qe(0,u.IExtHostRpcService),qe(1,f.IExtHostInitDataService),qe(2,E.IExtHostFileSystemInfo),qe(3,o.ILogService)],v),e.ExtHostWorkspace=v,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function _(F){let x,Y;return F&&(typeof F=="string"?x=F:(x=F.pattern,Y=F.baseFolder||d.URI.file(F.base))),{includePattern:x,folder:Y}}}),define(we[34],_e([0,1,23,3,30,5,7,154,66,10,11,4,14,18,2]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(n,l){if(l){const a=l.split(".");let s=n;for(let c=0;s&&c<a.length;c++)s=s[a[c]];return s}}function g(n){return n instanceof r.URI}function m(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function f(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function u(n){if(g(n))return{resource:n};if(m(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(f(n))return{resource:n.uri};if(n===null)return{resource:null}}let b=class{constructor(l,a,s){this._proxy=l.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=a,this._logService=s,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(l=>this._actual)}$initializeConfiguration(l){this._actual=new t(this._proxy,this._extHostWorkspace,l,this._logService),this._barrier.open()}$acceptConfigurationChanged(l,a){this.getConfigProvider().then(s=>s.$acceptConfigurationChanged(l,a))}};b=Ve([qe(0,d.IExtHostRpcService),qe(1,A.IExtHostWorkspace),qe(2,h.ILogService)],b),e.ExtHostConfiguration=b;class t{constructor(l,a,s,c){this._onDidChangeConfiguration=new P.Emitter,this._proxy=l,this._logService=c,this._extHostWorkspace=a,this._configuration=C.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(l,a){const s={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=C.Configuration.parse(l),this._configurationScopes=this._toMap(l.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(a,s))}getConfiguration(l,a,s){const c=u(a)||{},p=this._toReadonlyValue(l?o(this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace),l):this._configuration.getValue(void 0,c,this._extHostWorkspace.workspace));l&&this._validateConfigurationAccess(l,c,s==null?void 0:s.identifier);function y(_){if(_==null)return null;if(typeof _=="boolean")return _?1:4;switch(_){case S.ConfigurationTarget.Global:return 1;case S.ConfigurationTarget.Workspace:return 4;case S.ConfigurationTarget.WorkspaceFolder:return 5}}const v={has(_){return typeof o(p,_)!="undefined"},get:(_,F)=>{this._validateConfigurationAccess(l?`${l}.${_}`:_,c,s==null?void 0:s.identifier);let x=o(p,_);if(typeof x=="undefined")x=F;else{let Y;const me=(j,z)=>{let te;const $=()=>{Y=Y||(0,w.deepClone)(p),te=te||o(Y,z)};return(0,k.isObject)(j)?new Proxy(j,{get:(R,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return $(),()=>te;if(Y)return te=te||o(Y,z),te[L];const M=R[L];return typeof L=="string"?me(M,`${z}.${L}`):M},set:(R,L,M)=>($(),te&&(te[L]=M),!0),deleteProperty:(R,L)=>($(),te&&delete te[L],!0),defineProperty:(R,L,M)=>($(),te&&Object.defineProperty(te,L,M),!0)}):j};x=me(x,_)}return x},update:(_,F,x,Y)=>{_=l?`${l}.${_}`:_;const me=y(x);return F!==void 0?this._proxy.$updateConfigurationOption(me,_,F,c,Y):this._proxy.$removeConfigurationOption(me,_,c,Y)},inspect:_=>{var F,x,Y,me,j,z,te,$;_=l?`${l}.${_}`:_;const R=(0,w.deepClone)(this._configuration.inspect(_,c,this._extHostWorkspace.workspace));if(R)return{key:_,defaultValue:(F=R.default)===null||F===void 0?void 0:F.value,globalValue:(x=R.user)===null||x===void 0?void 0:x.value,workspaceValue:(Y=R.workspace)===null||Y===void 0?void 0:Y.value,workspaceFolderValue:(me=R.workspaceFolder)===null||me===void 0?void 0:me.value,defaultLanguageValue:(j=R.default)===null||j===void 0?void 0:j.override,globalLanguageValue:(z=R.user)===null||z===void 0?void 0:z.override,workspaceLanguageValue:(te=R.workspace)===null||te===void 0?void 0:te.override,workspaceFolderLanguageValue:($=R.workspaceFolder)===null||$===void 0?void 0:$.override,languageIds:R.overrideIdentifiers}}};return typeof p=="object"&&(0,w.mixin)(v,p,!1),Object.freeze(v)}_toReadonlyValue(l){const a=s=>(0,k.isObject)(s)?new Proxy(s,{get:(c,p)=>a(c[p]),set:(c,p,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(c,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(c,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:c=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):s;return a(l)}_validateConfigurationAccess(l,a,s){const c=D.OVERRIDE_PROPERTY_PATTERN.test(l)?4:this._configurationScopes.get(l),p=s?`[${s.value}] `:"";if(c===4){typeof(a==null?void 0:a.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(c===3){(a==null?void 0:a.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(l,a){const s=new C.ConfigurationChangeEvent(l,a,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(c,p)=>s.affectsConfiguration(c,u(p))})}_toMap(l){return l.reduce((a,s)=>(a.set(s[0],s[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[103],_e([0,1,2,11,3,5,7,30,39,34,20,40,14,27,4,19,21,18,75,171,12]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(j){function z($){if($!=null)return $}j.from=z;function te($){if($!=null)return $}j.to=te})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(j){function z($){if($!=null)return $}j.from=z;function te($){if($!=null)return $}j.to=te})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var l;(function(j){function z($){if($!=null)return $}j.from=z;function te($){if($!=null)return $}j.to=te})(l=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var a;(function(j){function z(R){if(R){const L=R;return L&&!!L.process}else return!1}j.is=z;function te(R){if(R!=null){const L={process:R.process,args:R.args};return R.options&&(L.options=l.from(R.options)),L}}j.from=te;function $(R){if(R!=null)return new S.ProcessExecution(R.process,R.args,R.options)}j.to=$})(a=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var s;(function(j){function z($){if($!=null)return $}j.from=z;function te($){if($!=null)return $}j.to=te})(s=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var c;(function(j){function z(R){if(R){const L=R;return L&&(!!L.commandLine||!!L.command)}else return!1}j.is=z;function te(R){if(R!=null){const L={};return R.commandLine!==void 0?L.commandLine=R.commandLine:(L.command=R.command,L.args=R.args),R.options&&(L.options=s.from(R.options)),L}}j.from=te;function $(R){if(!(R==null||R.command===void 0&&R.commandLine===void 0))return R.commandLine?new S.ShellExecution(R.commandLine,R.options):new S.ShellExecution(R.command,R.args?R.args:[],R.options)}j.to=$})(c=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(j){function z(R){if(R){let L=R;return L&&L.customExecution==="customExecution"}else return!1}j.is=z;function te(R){return{customExecution:"customExecution"}}j.from=te;function $(R,L){return L.get(R)}j.to=$})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var y;(function(j){function z(te,$){let R;return te.scope!==void 0&&typeof te.scope!="number"?R=te.scope.uri:te.scope!==void 0&&typeof te.scope=="number"&&(te.scope===S.TaskScope.Workspace&&$&&$.workspaceFile?R=$.workspaceFile:R=f.USER_TASKS_GROUP_KEY),{id:te._id,workspaceFolder:R}}j.from=z})(y=e.TaskHandleDTO||(e.TaskHandleDTO={}));var v;(function(j){function z(R,L){if(R==null)return[];const M=[];for(let U of R){const G=te(U,L);G&&M.push(G)}return M}j.fromMany=z;function te(R,L){if(R!=null){let M;R.execution instanceof S.ProcessExecution?M=a.from(R.execution):R.execution instanceof S.ShellExecution?M=c.from(R.execution):R.execution&&R.execution instanceof S.CustomExecution&&(M=p.from(R.execution));const U=t.from(R.definition);let G;if(R.scope?typeof R.scope=="number"?G=R.scope:G=R.scope.uri:G=S.TaskScope.Workspace,!(!U||!G)){const J=R.group?R.group.id:void 0;return{_id:R._id,definition:U,name:R.name,source:{extensionId:L.identifier.value,label:R.source,scope:G},execution:M,isBackground:R.isBackground,group:J,presentationOptions:n.from(R.presentationOptions),problemMatchers:R.problemMatchers,hasDefinedMatchers:R.hasDefinedMatchers,runOptions:R.runOptions?R.runOptions:{reevaluateOnRerun:!0},detail:R.detail}}}}j.from=te;async function $(R,L,M){if(R!=null){let U;a.is(R.execution)?U=a.to(R.execution):c.is(R.execution)?U=c.to(R.execution):p.is(R.execution)&&(U=p.to(R._id,M));const G=t.to(R.definition);let J;if(R.source&&(R.source.scope!==void 0?typeof R.source.scope=="number"?J=R.source.scope:J=await L.resolveWorkspaceFolder(w.URI.revive(R.source.scope)):J=S.TaskScope.Workspace),!(!G||!J)){const re=new S.Task(G,J,R.name,R.source.label,U,R.problemMatchers);return R.isBackground!==void 0&&(re.isBackground=R.isBackground),R.group!==void 0&&(re.group=S.TaskGroup.from(R.group)),R.presentationOptions&&(re.presentationOptions=n.to(R.presentationOptions)),R._id&&(re._id=R._id),R.detail&&(re.detail=R.detail),re}}}j.to=$})(v=e.TaskDTO||(e.TaskDTO={}));var _;(function(j){function z($){return $}j.from=z;function te($){if(!!$)return Object.assign(Object.create(null),$)}j.to=te})(_=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(z,te,$){this._id=te,this._task=$,b.set(this,void 0),tt(this,b,z,"f")}get task(){return this._task}terminate(){Me(this,b,"f").terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}b=new WeakMap;var x;(function(j){function z(te){return{id:te._id,task:void 0}}j.from=z})(x=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Y=class{constructor(z,te,$,R,L,M,U,G){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=z.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=$,this._editorService=R,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=U,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(z,te,$){if(!$)return new S.Disposable(()=>{});const R=this.nextHandle();return this._handlers.set(R,{type:te,provider:$,extension:z}),this._proxy.$registerTaskProvider(R,te),new S.Disposable(()=>{this._handlers.delete(R),this._proxy.$unregisterTaskProvider(R)})}registerTaskSystem(z,te){this._proxy.$registerTaskSystem(z,te)}fetchTasks(z){return this._proxy.$fetchTasks(_.from(z)).then(async te=>{const $=[];for(let R of te){const L=await v.to(R,this._workspaceProvider,this._providedCustomExecutions2);L&&$.push(L)}return $})}get taskExecutions(){const z=[];return this._taskExecutions.forEach(te=>z.push(te)),z}terminateTask(z){if(!(z instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(z._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(z,te,$){const R=this._providedCustomExecutions2.get(z.id);if(R){if(this._activeCustomExecutions2.get(z.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(z.id,R),this._terminalService.attachPtyToTerminal(te,await R.callback($))}this._lastStartedTask=z.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(z)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(z){const te=await this.getTaskExecution(z);this._taskExecutionPromises.delete(z.id),this._taskExecutions.delete(z.id),this.customExecutionComplete(z),this._onDidTerminateTask.fire({execution:te})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(z){const te=await this.getTaskExecution(z.id);this._onDidTaskProcessStarted.fire({execution:te,processId:z.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(z){const te=await this.getTaskExecution(z.id);this._onDidTaskProcessEnded.fire({execution:te,exitCode:z.exitCode})}$provideTasks(z,te){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));const R=[],L=(0,P.asPromise)(()=>$.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(te,R,$,M));return new Promise(M=>{L.then(U=>{Promise.all(R).then(()=>{M(U)})})})}async $resolveTask(z,te){const $=this._handlers.get(z);if(!$)return Promise.reject(new Error("no handler found"));if(te.definition.type!==$.type)throw new Error(`Unexpected: Task of type [${te.definition.type}] cannot be resolved by provider of type [${$.type}].`);const R=await v.to(te,this._workspaceProvider,this._providedCustomExecutions2);if(!R)throw new Error("Unexpected: Task cannot be resolved.");const L=await $.provider.resolveTask(R,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,$);const M=v.from(L,$.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==R.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(z,te,$){const R=await this._proxy.$createTaskId(z);!$&&!this._providedCustomExecutions2.has(R)&&this._notProvidedCustomExecutions.add(R),this._providedCustomExecutions2.set(R,te.execution)}async getTaskExecution(z,te){if(typeof z=="string"){const L=this._taskExecutionPromises.get(z);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let $=this._taskExecutionPromises.get(z.id);if($)return $;const R=new Promise(async(L,M)=>{const U=te||await v.to(z.task,this._workspaceProvider,this._providedCustomExecutions2);U?L(new F(this,z.id,U)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(z.id,R),R.then(L=>(this._taskExecutions.set(z.id,L),L),L=>Promise.reject(L))}checkDeprecation(z,te){z._deprecated&&this._deprecationService.report("Task.constructor",te.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(z){this._activeCustomExecutions2.get(z.id)&&this._activeCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.has(z.id)&&this._lastStartedTask!==z.id&&(this._providedCustomExecutions2.delete(z.id),this._notProvidedCustomExecutions.delete(z.id));let $=this._notProvidedCustomExecutions.values(),R=$.next();for(;!R.done;)!this._activeCustomExecutions2.has(R.value)&&this._lastStartedTask!==R.value&&(this._providedCustomExecutions2.delete(R.value),this._notProvidedCustomExecutions.delete(R.value)),R=$.next()}};Y=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],Y),e.ExtHostTaskBase=Y;let me=class extends Y{constructor(z,te,$,R,L,M,U,G){super(z,te,$,R,L,M,U,G);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:g.PlatformToString(0)})}async executeTask(z,te){if(!te.execution)throw new Error("Tasks to execute must include an execution");const $=v.from(te,z);if($===void 0)throw new Error("Task is not valid");if(p.is($.execution))await this.addCustomExecution($,te,!1);else throw new u.NotSupportedError;const R=await this.getTaskExecution(await this._proxy.$getTaskExecution($),te);return this._proxy.$executeTask($).catch(L=>{throw new Error(L)}),R}provideTasksInternal(z,te,$,R){const L=[];if(R)for(let M of R){this.checkDeprecation(M,$),(!M.definition||!z[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const U=v.from(M,$.extension);U&&p.is(U.execution)?(L.push(U),te.push(this.addCustomExecution(U,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:$.extension}}async resolveTaskInternal(z){if(p.is(z.execution))return z;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(z,te){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(z,te,$){}};me=Ve([qe(0,d.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,C.IExtHostWorkspace),qe(3,D.IExtHostDocumentsAndEditors),qe(4,k.IExtHostConfiguration),qe(5,I.IExtHostTerminalService),qe(6,m.ILogService),qe(7,E.IExtHostApiDeprecationService)],me),e.WorkerExtHostTask=me,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)},Qt=this&&this.__rest||function(Q,e){var w={};for(var P in Q)Object.prototype.hasOwnProperty.call(Q,P)&&e.indexOf(P)<0&&(w[P]=Q[P]);if(Q!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,P=Object.getOwnPropertySymbols(Q);A<P.length;A++)e.indexOf(P[A])<0&&Object.prototype.propertyIsEnumerable.call(Q,P[A])&&(w[P[A]]=Q[P[A]]);return w};define(we[218],_e([0,1,15,11,24,20,3,53,43,6,23,10,2,31,5,39,14,69,9,7,30,182,96]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u,b,t){"use strict";var n,l,a,s;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const c=($,R)=>`${$}:${R.toString()}`;let p=class{constructor(R,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new S.Emitter,this.controllers=new Map,this.ownedTests=new b.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=R.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new y(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new te(this.proxy,L)}registerTestController(R,L){const M=(0,h.generateUuid)();this.controllers.set(M,{instance:L,extensionId:R}),this.proxy.$registerTestController(M);const U=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const J of U)(G=this.testControllers.get(J))===null||G===void 0||G.subscribeFn(M,L)},0),new f.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(R){return this.textDocumentObservers.checkout(R.uri)}createWorkspaceTestObserver(R){return this.workspaceObservers.checkout(R.uri)}async runTests(R,L=T.CancellationToken.None){const M=U=>U.map(this.getInternalTestForReference,this).filter(I.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:R.exclude?M(R.exclude).map(U=>U.testId):void 0,tests:M(R.tests),debug:R.debug},L)}createTestRun(R,L,M,U=!0){return this.runQueue.createTestRun(R,L,M,U)}$publishTestResults(R){this.results=Object.freeze(R.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(R,L){const M=d.URI.revive(L),U=c(R,M);if(!this.testControllers.has(U)){const G=new T.CancellationTokenSource;let J;if(R===1){let Ae=this.documents.getDocument(M);if(!Ae){const We=new k.DisposableStore;Ae=await new Promise(B=>{We.add((0,P.disposableTimeout)(()=>B(void 0),5e3)),We.add(this.documents.onDidAddDocuments(q=>{const ne=q.find(le=>le.document.uri.toString()===M.toString());ne&&B(ne)}))}).finally(()=>We.dispose())}if(Ae){const We=await this.workspace.getWorkspaceFolder2(M,!1);J=B=>B.createDocumentTestRoot?B.createDocumentTestRoot(Ae.document,G.token):(0,e.createDefaultDocumentTestRoot)(B,Ae.document,We,G.token)}}else{const Ae=await this.workspace.getWorkspaceFolder2(M,!1);Ae&&(J=We=>We.createWorkspaceTestRoot(Ae,G.token))}if(!!J){const re=async(Ae,We)=>{try{const B=await J(We);B&&Te.addRoot(B,Ae)}catch(B){console.error(B)}},pe=new k.DisposableStore,Te=pe.add(this.ownedTests.createForHierarchy(Ae=>this.proxy.$publishDiff(R,L,Ae)));pe.add((0,k.toDisposable)(()=>G.dispose(!0)));const xe=[];for(const[Ae,We]of this.controllers)xe.push(re(Ae,We.instance));Promise.all(xe).then(()=>Te.pushDiff([3,-1])),this.testControllers.set(U,{store:pe,collection:Te,subscribeFn:re})}}}async $expandTest(R,L){const M=(0,w.mapFind)(this.testControllers.values(),U=>U.collection.treeId===R.src.tree?U:void 0);await(M==null?void 0:M.collection.expand(R.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(R,L){var M;const U=d.URI.revive(L),G=c(R,U);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(R,L,M){R===1?this.textDocumentObservers.acceptDiff(d.URI.revive(L),M):this.workspaceObservers.acceptDiff(d.URI.revive(L),M)}async $runTestsForProvider(R,L){const M=this.controllers.get(R.tests[0].src.controller);if(!!M){const U=R.tests.map(({testId:re,src:pe})=>this.ownedTests.getTestById(re,pe==null?void 0:pe.tree)).filter(I.isDefined).map(([re,pe])=>pe),G=R.excludeExtIds.map(re=>this.ownedTests.getTestById(re)).filter(I.isDefined).filter(([re,pe])=>U.some(Te=>re.comparePositions(Te,pe)===1));if(!!U.length){const J={tests:U.map(re=>x.unwrap(re.actual)),exclude:G.map(([,re])=>x.unwrap(re.actual)),debug:R.debug};await this.runQueue.enqueueRun({dto:v.fromInternal(R),token:L,extensionId:M.extensionId,req:J,doRun:()=>M.instance.runTests(J,L)})}}}$lookupTest(R){const L=this.ownedTests.getTestById(R.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:U,discoverCts:G,expandLevels:J}=M,re=Qt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(re)}flushCollectionDiffs(){for(const{collection:R}of this.testControllers.values())R.flushDiff()}getInternalTestForReference(R){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(R))!==null&&L!==void 0?L:(0,w.mapFind)(this.testControllers.values(),U=>U.collection.getTestByReference(R)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(R)}};p=Ve([qe(0,g.IExtHostRpcService),qe(1,o.IExtHostDocumentsAndEditors),qe(2,u.IExtHostWorkspace)],p),e.ExtHostTesting=p;class y{constructor(R){this.proxy=R,this.state=new Map}enqueueRun(R){let L=this.state.get(R.extensionId);L||(L={queue:[],current:void 0},this.state.set(R.extensionId,L));const M=new P.DeferredPromise,U=()=>{const G=[],J=new Set;L.current={publicReq:R.req,factory:re=>{const pe=new _(re,R.dto,J,this.proxy);return G.push(pe),R.token.onCancellationRequested(()=>pe.end()),pe}},this.invokeRunner(R.extensionId,R.dto.id,R.doRun,G).finally(()=>M.complete())};return L.queue.push(U),L.queue.length===1&&U(),M.p}createTestRun(R,L,M,U){var G,J;const re=this.state.get(R);if((re==null?void 0:re.current.publicReq)===L)return re.current.factory(M);const pe=v.fromPublic(L),Te=new _(M,pe,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(J=(G=L.exclude)===null||G===void 0?void 0:G.map(xe=>xe.id))!==null&&J!==void 0?J:[],id:pe.id,tests:L.tests.map(xe=>xe.id),persist:U}),Te.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(pe.id)),Te}invokeRunner(R,L,M,U){try{const G=M();return(0,P.isThenable)(G)?G.then(()=>this.handleInvokeResult(R,L,U,void 0)).catch(J=>this.handleInvokeResult(R,L,U,J)):this.handleInvokeResult(R,L,U,void 0)}catch(G){return this.handleInvokeResult(R,L,U,G)}}async handleInvokeResult(R,L,M,U){const G=this.state.get(R);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(R),await Promise.all(M.map(J=>J.onEnd.wait())))}}class v{constructor(R,L,M){this.id=R,this.include=L,this.exclude=M}static fromPublic(R){var L,M;return new v((0,h.generateUuid)(),new Set(R.tests.map(U=>U.id)),new Set((M=(L=R.exclude)===null||L===void 0?void 0:L.map(U=>U.id))!==null&&M!==void 0?M:D.Iterable.empty()))}static fromInternal(R){return new v(R.runId,new Set(R.tests.map(L=>L.testId)),new Set(R.excludeExtIds))}isIncluded(R){for(let L=R;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class _{constructor(R,L,M,U){this.name=R,n.set(this,void 0),l.set(this,void 0),a.set(this,(0,h.generateUuid)()),s.set(this,void 0),this.onEnd=new P.Barrier,tt(this,n,U,"f"),tt(this,l,L,"f"),tt(this,s,M,"f"),U.$startedTestRunTask(L.id,{id:Me(this,a,"f"),name:R,running:!0})}setState(R,L,M){Me(this,l,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$updateTestStateInRun(Me(this,l,"f").id,Me(this,a,"f"),R.id,L,M))}appendMessage(R,L){Me(this,l,"f").isIncluded(R)&&(this.ensureTestIsKnown(R),Me(this,n,"f").$appendTestMessageInRun(Me(this,l,"f").id,Me(this,a,"f"),R.id,E.TestMessage.from(L)))}appendOutput(R){Me(this,n,"f").$appendOutputToRun(Me(this,l,"f").id,Me(this,a,"f"),A.VSBuffer.fromString(R))}end(){Me(this,n,"f").$finishedTestRunTask(Me(this,l,"f").id,Me(this,a,"f")),this.onEnd.open()}ensureTestIsKnown(R){const L=Me(this,s,"f");if(!L.has(R.id)){const M=[];for(;M.unshift(E.TestItem.from(R)),!(L.has(R.id)||(L.add(R.id),!R.parent));)R=R.parent;Me(this,n,"f").$addTestsToRun(Me(this,l,"f").id,M)}}}n=new WeakMap,l=new WeakMap,a=new WeakMap,s=new WeakMap;const F=async($,R,L,M)=>{if(!!L){const U=await $.createWorkspaceTestRoot(L,M);if(!!U){M.onCancellationRequested(()=>{x.removeFilter(R)});const G=x.getWrapperForTestItem(U,R);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=F;class x extends f.TestItemImpl{constructor(R,L,M){super(R.id,R.label,R.uri,void 0);if(this.actual=R,this.filterDocument=L,this.actualParent=M,!(R instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${R.id} did not`);this.debuggable=R.debuggable,this.runnable=R.runnable,this.description=R.description,this.error=R.error,this.status=R.status,this.range=R.range,this.resolveHandler=R.resolveHandler;const U=(0,m.getPrivateApiFor)(this);(0,m.getPrivateApiFor)(R).bus.event(J=>{switch(J[0]){case 3:this[J[1]]=J[2];break;case 0:const re=x.getWrapperForTestItem(J[1],this.filterDocument,this);(0,m.getPrivateApiFor)(re).parent=R,re.refreshMatch();break;default:U.bus.fire(J)}})}static removeFilter(R){this.wrapperMap.delete(R)}static getWrapperForTestItem(R,L,M){let U=this.wrapperMap.get(L);if(U==null?void 0:U.has(R))return U.get(R);U||(U=new WeakMap,this.wrapperMap.set(L,U));const G=new x(R,L,M);return U.set(R,G),G}static unwrap(R){return R instanceof x?R.actual:R}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var R;const L=this._cachedMatchesFilter;for(const U of this.actual.children.values()){const G=x.getWrapperForTestItem(U,this.filterDocument,this);G.hasNodeMatchingFilter?this.children.has(G.id)||this.addChild(G):G.dispose()}const M=this.children.size>0||this.actual.uri.toString()===this.filterDocument.uri.toString();return this._cachedMatchesFilter=M,M!==L&&((R=this.actualParent)===null||R===void 0||R.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,m.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,m.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=x,x.wrapperMap=new WeakMap;class Y extends t.IncrementalChangeCollector{constructor(R){super();this.emitter=R,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(R){this.added.add(R)}update(R){Object.assign(R.revived,E.TestItem.toPlain(R.item)),this.added.has(R)||this.updated.add(R)}remove(R){if(this.added.has(R)){this.added.delete(R);return}if(this.updated.delete(R),R.parent&&this.alreadyRemoved.has(R.parent)){this.alreadyRemoved.add(R.item.extId);return}this.removed.add(R)}getChangeEvent(){const{added:R,updated:L,removed:M}=this;return{get added(){return[...R].map(U=>U.revived)},get updated(){return[...L].map(U=>U.revived)},get removed(){return[...M].map(U=>U.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class me extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new S.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(R){let L=[];for(const M of R){const U=this.items.get(M);U&&L.push(U.revived)}return L}getMirroredTestDataById(R){return this.items.get(R)}getMirroredTestDataByReference(R){return this.items.get(R.id)}createItem(R,L){return Object.assign(Object.assign({},R),{revived:E.TestItem.toPlain(R.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new Y(this.changeEmitter)}}e.MirroredTestCollection=me;class j{constructor(){this.resources=new Map}checkout(R){var L,M;const U=R.toString(),G=(L=this.resources.get(U))!==null&&L!==void 0?L:this.createObserverData(R);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new S.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,C.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(R))})}}getMirroredTestDataByReference(R){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(R);if(M)return M}}eventuallyDispose(R){return(0,P.disposableTimeout)(()=>this.unlisten(R),10*1e3)}createObserverData(R){const L=new me,M=this.listen(R,G=>L.apply(G)),U={observers:0,tests:L,listener:M};return this.resources.set(R.toString(),U),U}unlisten(R){var L;const M=R.toString(),U=this.resources.get(M);U&&(U.observers=-1,(L=U.pendingDeletion)===null||L===void 0||L.dispose(),U.listener.dispose(),this.resources.delete(M))}}class z extends j{constructor(R){super();this.proxy=R,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){this.proxy.$subscribeToDiffs(0,R);const M=R.toString();return this.diffListeners.set(M,L),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,R),this.diffListeners.delete(M)})}}class te extends j{constructor(R,L){super();this.proxy=R,this.documents=L,this.diffListeners=new Map}acceptDiff(R,L){var M;(M=this.diffListeners.get(R.toString()))===null||M===void 0||M(L)}listen(R,L){if(!this.documents.getDocument(R))return new f.Disposable(()=>{});const U=R.toString();return this.diffListeners.set(U,L),this.proxy.$subscribeToDiffs(1,R),new f.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,R),this.diffListeners.delete(U)})}}}),define(we[219],_e([0,1,15,51,28,58,22,19,13,25,8,10,2,116,140,92,48,174,217,41]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let u=class{constructor(y,v,_,F){this.configurationService=y,this.workspaceContextService=v,this.editorGroupsService=_,this.pathService=F}text(y,v,_={}){y=this.getContentPattern(y,_);const F=this.configurationService.getValue(),x=v&&v.some(me=>!this.configurationService.getValue({resource:me}).search.useRipgrep),Y=this.commonQuery(v==null?void 0:v.map(g.toWorkspaceFolder),_);return Object.assign(Object.assign({},Y),{type:2,contentPattern:y,previewOptions:_.previewOptions,maxFileSize:_.maxFileSize,usePCRE2:F.search.usePCRE2||x||!1,beforeContext:_.beforeContext,afterContext:_.afterContext,userDisabledExcludesAndIgnoreFiles:_.disregardExcludeSettings&&_.disregardIgnoreFiles})}getContentPattern(y,v){const _=this.configurationService.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},y),{wordSeparators:_.editor.wordSeparators});return this.isCaseSensitive(y,v)&&(F.isCaseSensitive=!0),this.isMultiline(y)&&(F.isMultiline=!0),F}file(y,v={}){const _=this.commonQuery(y,v);return Object.assign(Object.assign({},_),{type:1,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey})}handleIncludeExclude(y,v){return y?(y=Array.isArray(y)?y.map(a):a(y),v?this.parseSearchPaths(y):{pattern:t(...Array.isArray(y)?y:[y])}):{}}commonQuery(y=[],v={}){const _=this.handleIncludeExclude(v.includePattern,v.expandPatterns),F=this.handleIncludeExclude(v.excludePattern,v.expandPatterns),x=y.length>1,Y=(_.searchPaths&&_.searchPaths.length?_.searchPaths.map(z=>this.getFolderQueryForSearchPath(z,v,F)):y.map(z=>this.getFolderQueryForRoot(z,v,F,x))).filter(z=>!!z),me={_reason:v._reason,folderQueries:Y,usingSearchPaths:!!(_.searchPaths&&_.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:F.pattern,includePattern:_.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const te=w.coalesce(w.flatten(this.editorGroupsService.groups.map(R=>R.editors.map(L=>L.resource)))).filter(R=>(0,f.pathIncludedInQuery)(me,R.fsPath)),$=this.commonQueryFromFileList(te);return Object.assign(Object.assign({},me),$)}const j=v.extraFileResources&&v.extraFileResources.filter(z=>(0,f.pathIncludedInQuery)(me,z.fsPath));return me.extraFileResources=j&&j.length?j:void 0,me}commonQueryFromFileList(y){const v=[],_=new S.ResourceMap,F={};let x=!1;return y.forEach(Y=>{var me,j;if(Y.scheme!==C.Schemas.walkThrough)if((0,k.isAbsolutePath)(Y)){const te=(j=(me=this.workspaceContextService.getWorkspaceFolder(Y))===null||me===void 0?void 0:me.uri)!==null&&j!==void 0?j:Y.with({path:D.dirname(Y.fsPath)});let $=_.get(te);$||(x=!0,$={folder:te,includePattern:{}},v.push($),_.set(te,$));const R=D.relative(te.fsPath,Y.fsPath);(0,I.assertIsDefined)($.includePattern)[R.replace(/\\/g,"/")]=!0}else Y.fsPath&&(x=!0,F[Y.fsPath]=!0)}),{folderQueries:v,includePattern:F,usingSearchPaths:!0,excludePattern:x?void 0:{"**/*":!0}}}isCaseSensitive(y,v){if(v.isSmartCase){if(y.isRegExp){if(i.containsUppercaseCharacter(y.pattern,!0))return!0}else if(i.containsUppercaseCharacter(y.pattern))return!0}return!!y.isCaseSensitive}isMultiline(y){return y.isMultiline||y.isRegExp&&(0,h.isMultilineRegexSource)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const v=$=>D.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),F=(Array.isArray(y)?y:n(y)).map($=>{const R=this.pathService.resolvedUserHome;return R?(0,T.untildify)($,R.scheme===C.Schemas.file?R.fsPath:R.path):$}),x=P.groupBy(F,$=>v($)?"searchPaths":"exprSegments"),Y=(x.exprSegments||[]).map($=>i.rtrim($,"/")).map($=>i.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),l($))),me={},j=this.expandSearchPathPatterns(x.searchPaths||[]);j&&j.length&&(me.searchPaths=j);const z=w.flatten(Y),te=t(...z);return te&&(me.pattern=te),me}getExcludesForFolder(y,v){return v.disregardExcludeSettings?void 0:(0,f.getExcludes)(y,!v.disregardSearchExcludeSettings)}expandSearchPathPatterns(y){if(!y||!y.length)return[];const v=w.flatten(y.map(F=>{let{pathPortion:x,globPortion:Y}=b(F);Y&&(Y=s(Y));const me=this.expandOneSearchPath(x);return w.flatten(me.map(j=>this.resolveOneSearchPathPattern(j,Y)))})),_=new Map;return v.forEach(F=>{const x=F.searchPath.toString(),Y=_.get(x);Y?F.pattern&&(Y.pattern=Y.pattern||{},Y.pattern[F.pattern]=!0):_.set(x,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(_.values())}expandOneSearchPath(y){if(D.isAbsolute(y)){const v=this.workspaceContextService.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==C.Schemas.file?[{searchPath:v[0].uri.with({path:y})}]:[{searchPath:d.URI.file(D.normalize(y))}]}if(this.workspaceContextService.getWorkbenchState()===2){const v=this.workspaceContextService.getWorkspace().folders[0].uri;if(y=a(y),y.startsWith("../")||y===".."){const F=D.posix.resolve(v.path,y);return[{searchPath:v.with({path:F})}]}const _=s(y);return[{searchPath:v,pattern:_}]}else{if(y==="./"||y===".\\")return[];{const v=y.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(x=>{const Y=v.match(new RegExp(`^${x.name}(?:/(.*))?`));return Y?{match:Y,folder:x}:null}).filter(I.isDefined);if(F.length)return F.map(x=>{const Y=x.match[1];return{searchPath:x.folder.uri,pattern:Y&&s(Y)}});{const x=y.match(/\.[\/\\](.+)[\/\\]?/),Y=x?x[1]:y,me=r.localize(0,null,Y);throw new Error(me)}}}}resolveOneSearchPathPattern(y,v){const _=y.pattern&&v?`${y.pattern}/${v}`:y.pattern||v,F=[{searchPath:y.searchPath,pattern:_}];return _&&!_.endsWith("**")&&F.push({searchPath:y.searchPath,pattern:_+"/**"}),F}getFolderQueryForSearchPath(y,v,_){const F=this.getFolderQueryForRoot((0,g.toWorkspaceFolder)(y.searchPath),v,_,!1);return F?Object.assign(Object.assign({},F),{includePattern:y.pattern}):null}getFolderQueryForRoot(y,v,_,F){let x;const Y=d.URI.isUri(y)?y:y.uri;if(_.searchPaths){const $=_.searchPaths.filter(R=>(0,k.isEqual)(R.searchPath,Y))[0];if($&&!$.pattern)return null;$&&(x=$.pattern)}const me=this.configurationService.getValue({resource:Y}),j=this.getExcludesForFolder(me,v),z=Object.assign(Object.assign({},j||{}),x||{}),te=d.URI.isUri(y)?(0,k.basename)(y):y.name;return{folder:Y,folderName:F?te:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:me.files&&me.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!me.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!me.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!me.search.followSymlinks}}};u=Ve([qe(0,o.IConfigurationService),qe(1,g.IWorkspaceContextService),qe(2,m.IEditorGroupsService),qe(3,E.IPathService)],u),e.QueryBuilder=u;function b(p){const y=p.match(/[\*\{\}\(\)\[\]\?]/);if(y){const v=y.index,_=p.substr(0,v).match(/[/|\\][^/\\]*$/);if(_){let F=p.substr(0,_.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:p.substr((_.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((y,v)=>(y[v]=!0,y),Object.create(null)):void 0}function n(p){return A.splitGlobAware(p,",").map(y=>y.trim()).filter(y=>!!y.length)}function l(p){return[`**/${p}/**`,`**/${p}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function a(p){return p.replace(/\\/g,"/")}function s(p){return a(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(p,y){p=w.distinct(p,F=>F.toString());const v=[],_=y.getWorkspace();return p&&p.forEach(F=>{let x;if(y.getWorkbenchState()===2)x=(0,k.relativePath)(_.folders[0].uri,F),x&&x!=="."&&(x="./"+x);else{const Y=y.getWorkspaceFolder(F);if(Y){const me=Y.name;if(_.folders.filter(z=>z.name===me).length===1){const z=(0,k.relativePath)(Y.uri,F);z===""?x=`./${Y.name}`:x=`./${Y.name}/${z}`}else x=F.fsPath}}x&&v.push(x)}),v}e.resolveResourcesForSearchIncludes=c}),define(we[220],_e([0,1,25,2,20,12,4,219,41,48]),function(Q,e,w,P,A,T,S,C,D,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(o,g){const m=g.activationEvents;if(!m)return Promise.resolve(void 0);const E=[],f=[];for(const a of m)if(/^workspaceContains:/.test(a)){const s=a.substr("workspaceContains:".length);s.indexOf("*")>=0||s.indexOf("?")>=0||o.forceUsingSearch?f.push(s):E.push(s)}if(E.length===0&&f.length===0)return Promise.resolve(void 0);let u;const b=new Promise((a,s)=>{u=a}),t=a=>u({activationEvent:a}),n=Promise.all(E.map(a=>d(o,a,t))).then(()=>{}),l=h(o,g.identifier,f,t);return Promise.all([n,l]).then(()=>{u(void 0)}),b}e.checkActivateWorkspaceContainsExtension=I;async function d(o,g,m){for(const E of o.folders)if(await o.exists(w.joinPath(P.URI.revive(E),g))){m(`workspaceContains:${g}`);return}}async function h(o,g,m,E){if(m.length===0)return Promise.resolve(void 0);const f=new A.CancellationTokenSource,u=o.checkExists(o.folders,m,f.token),b=setTimeout(async()=>{f.cancel(),E(`workspaceContainsTimeout:${m.join(",")}`)},i);let t=!1;try{t=await u}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}f.dispose(),clearTimeout(b),t&&E(`workspaceContains:${m.join(",")}`)}function r(o,g,m,E){const f=o.get(S.IInstantiationService),u=o.get(D.ISearchService),t=f.createInstance(C.QueryBuilder).file(g.map(n=>(0,k.toWorkspaceFolder)(P.URI.revive(n))),{_reason:"checkExists",includePattern:m,exists:!0});return u.fileSearch(t,E).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var tt=this&&this.__classPrivateFieldSet||function(Q,e,w,P,A){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!A:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?A.call(Q,w):A?A.value=w:e.set(Q,w),w},Me=this&&this.__classPrivateFieldGet||function(Q,e,w,P){if(w==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!P:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return w==="m"?P:w==="a"?P.call(Q):P?P.value:e.get(Q)};define(we[35],_e([0,1,132,13,80,25,11,6,22,2,18,5,34,185,78,30,33,183,12,26,24,161,7,67,4,27,79,14,65,70,40,3,220,74,162]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u,b,t,n,l,a,s,c,p,y,v,_,F,x,Y){"use strict";var me,j,z;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,l.createDecorator)("IHostUtils");let te=class Ln extends C.Disposable{constructor(M,U,G,J,re,pe,Te,xe,Ae,We){super();this._onDidChangeRemoteConnectionData=this._register(new _.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=U,this._extHostContext=G,this._initData=Te,this._extHostWorkspace=J,this._extHostConfiguration=re,this._logService=pe,this._extHostTunnelService=Ae,this._extHostTerminalService=We,this._disposables=new C.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new S.Barrier,this._readyToStartExtensionHost=new S.Barrier,this._readyToRunExtensions=new S.Barrier,this._eagerExtensionsActivated=new S.Barrier,this._registry=new m.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new x.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=M.createChild(new p.ServiceCollection([r.IExtHostStorage,this._storage],[x.IExtHostSecretState,this._secretState]));const B=new Set;this._initData.hostExtensions.forEach(q=>B.add(f.ExtensionIdentifier.toKey(q))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(q,ne,le)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(q,E.transformErrorForSerialization(ne),le)},actualActivateExtension:async(q,ne)=>{if(B.has(f.ExtensionIdentifier.toKey(q)))return await this._mainThreadExtensionsProxy.$activateExtension(q,ne),new h.HostExtension;const le=this._registry.getExtensionDescription(q);return this._activateExtension(le,ne)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(re=>re.identifier).filter(re=>this.isActivated(re)).map(re=>this._deactivate(re))}catch(U){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,U){return this._activator.activateByEvent(M,U)}_activateById(M,U){return this._activator.activateById(M,U)}activateByIdWithErrors(M,U){return this._activateById(M,U).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),U=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(J=>M.set(k.URI.file(J).fsPath,G))});this._extensionPathIndex=Promise.all(U).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let U=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return U;const G=this._activator.getActivatedExtension(M);if(!G)return U;try{typeof G.module.deactivate=="function"&&(U=Promise.resolve(G.module.deactivate()).then(void 0,J=>Promise.resolve(void 0)))}catch(J){}try{(0,C.dispose)(G.subscriptions)}catch(J){}return U}async _activateExtension(M,U){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,U).then(G=>{const J=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,J.codeLoadingTime,J.activateCallTime,J.activateResolvedTime,U),this._logExtensionActivationTimes(M,U,"success",J),G},G=>{throw this._logExtensionActivationTimes(M,U,"failure"),G})}_logExtensionActivationTimes(M,U,G,J){const re=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},re),J||{}),{outcome:G}))}_doActivateExtension(M,U){const G=$(M,U);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const J=this._getEntryPoint(M);if(!J)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(U)}`),this._logService.flush();const re=new h.ExtensionActivationTimesBuilder(U.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,J),re),this._loadExtensionContext(M)]).then(pe=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,pe[0],pe[1],re))).then(pe=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),pe))}_loadExtensionContext(M){const U=new b.ExtensionGlobalMemento(M,this._storage),G=new b.ExtensionMemento(M.identifier.value,!1,this._storage),J=new Y.ExtensionSecrets(M,this._secretState),re=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,pe=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([U.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Te=this;let xe;return Object.freeze({globalState:U,workspaceState:G,secrets:J,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Ae){return P.join(M.extensionLocation.fsPath,Ae)},get storagePath(){var Ae;return(Ae=Te._storagePath.workspaceValue(M))===null||Ae===void 0?void 0:Ae.fsPath},get globalStoragePath(){return Te._storagePath.globalValue(M).fsPath},get logPath(){return P.join(Te._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Te._initData.logsLocation,M.identifier.value)},get storageUri(){return Te._storagePath.workspaceValue(M)},get globalStorageUri(){return Te._storagePath.globalValue(M)},get extensionMode(){return re},get extension(){return xe===void 0&&(xe=new R(Te,M.identifier,M,pe)),xe},get extensionRuntime(){return(0,g.checkProposedApiEnabled)(M),Te.extensionRuntime},get environmentVariableCollection(){return Te._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,U,G,J,re){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,U,G,J,re).then(pe=>new h.ActivatedExtension(!1,null,re.build(),G,pe,J.subscriptions))}static _callActivateOptional(M,U,G,J,re){if(typeof G.activate=="function")try{re.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${U.value}`);const pe=typeof global=="object"?global:self,Te=G.activate.apply(pe,[J]);return re.activateCallStop(),re.activateResolveStart(),Promise.resolve(Te).then(xe=>(re.activateResolveStop(),xe))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(G)}_activateOneStartupFinished(M,U){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:U}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const U of M.activationEvents)U==="onStartupFinished"&&this._activateOneStartupFinished(M,U)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,re=>{this._logService.error(re)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(re=>this._handleWorkspaceContainsEagerExtensions(re.added)));const U=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(U),J=Promise.all([M,G]).then(()=>{});return Promise.race([J,(0,S.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),J}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(U=>this._handleWorkspaceContainsEagerExtension(M,U))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,U){if(!this.isActivated(U.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,J={folders:M.map(pe=>pe.uri),forceUsingSearch:G,exists:pe=>this._hostUtils.exists(pe.fsPath),checkExists:(pe,Te,xe)=>this._mainThreadWorkspaceProxy.$checkExists(pe,Te,xe)},re=await(0,F.checkActivateWorkspaceContainsExtension)(J,U);if(!!re)return this._activateById(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:re.activationEvent}).then(void 0,pe=>this._logService.error(pe))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:U}=this._initData.environment;if(!M||!U)throw new Error(w.localize(0,null));const G=await this._loadCommonJSModule(null,U,new h.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(w.localize(1,null,U.toString()));return new Promise((J,re)=>{const pe=(Ae,We)=>{Ae?re(Ae):J(typeof We=="number"&&We>0?1:0)},Te=(0,T.originalFSPath)(U),xe=G.run(Te,pe);xe&&xe.then&&xe.then(()=>{J(0)}).catch(Ae=>{re(Ae.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,U){return this._resolvers[M]=U,(0,C.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,U){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const J=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${J}`,!1);const re=this._resolvers[J];if(!re)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${J}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(re)),A.mark(`code/extHost/willResolveAuthority/${J}`);const pe=await re.resolve(M,{resolveAttempt:U});A.mark(`code/extHost/didResolveAuthorityOK/${J}`);const Te={authority:M,host:pe.host,port:pe.port,connectionToken:pe.connectionToken},xe={extensionHostEnv:pe.extensionHostEnv,trust:pe.trust};return{type:"ok",value:{authority:Te,options:xe,tunnelInformation:{environmentTunnels:pe.environmentTunnels}}}}catch(pe){if(A.mark(`code/extHost/didResolveAuthorityError/${J}`),pe instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:pe._code,message:pe._message,detail:pe._detail}};throw pe}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,U){return U===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,U){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,U),!0):!1}async $deltaExtensions(M,U){M.forEach(J=>J.extensionLocation=k.URI.revive(J.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(U.map(async J=>{const re=this._registry.getExtensionDescription(J);if(!!re){const pe=await this._hostUtils.realpath(re.extensionLocation.fsPath);G.delete(k.URI.file(pe).fsPath)}})),await Promise.all(M.map(async J=>{const re=await this._hostUtils.realpath(J.extensionLocation.fsPath);G.set(k.URI.file(re).fsPath,J)})),this._registry.deltaExtensions(M,U),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let U=u.VSBuffer.alloc(M),G=Math.random()%256;for(let J=0;J<M;J++)U.writeUInt8(G,J);return U}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};te=Ve([qe(0,l.IInstantiationService),qe(1,e.IHostUtils),qe(2,c.IExtHostRpcService),qe(3,o.IExtHostWorkspace),qe(4,d.IExtHostConfiguration),qe(5,i.ILogService),qe(6,a.IExtHostInitDataService),qe(7,s.IExtensionStoragePaths),qe(8,y.IExtHostTunnelService),qe(9,v.IExtHostTerminalService)],te),e.AbstractExtHostExtensionService=te;function $(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,l.createDecorator)("IExtHostExtensionService");class R{constructor(M,U,G,J){me.set(this,void 0),j.set(this,void 0),z.set(this,void 0),tt(this,me,M,"f"),tt(this,j,U,"f"),tt(this,z,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=P.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=J}get isActive(){return Me(this,me,"f").isActivated(Me(this,z,"f"))}get exports(){if(this.packageJSON.api!=="none")return Me(this,me,"f").getExtensionExports(Me(this,z,"f"))}activate(){return Me(this,me,"f").activateByIdWithErrors(Me(this,z,"f"),{startup:!1,extensionId:Me(this,j,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=R,me=new WeakMap,j=new WeakMap,z=new WeakMap}),define(we[104],_e([0,1,13,2,3,11,5,7,169,30,35,39,173,34,170,14,4,10,46]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,g.createDecorator)("IExtHostDebugService");let f=class{constructor(c,p,y,v,_){this._workspaceService=p,this._extensionService=y,this._editorsService=v,this._configurationService=_,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=c.getProxy(S.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new b(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(F=>{F.onDidChange(x=>{this.registerAllDebugTypes(F)}),this.registerAllDebugTypes(F)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(c,p){const y=c;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let v=`debug:${encodeURIComponent(y.path||"")}`,_="?";return p&&(v+=`${_}session=${encodeURIComponent(p.id)}`,_="&"),v+=`${_}ref=${y.sourceReference}`,P.URI.parse(v)}else{if(y.path)return P.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(c){const p=[];for(const y of c.getAllExtensionDescriptions())if(y.contributes){const v=y.contributes.debuggers;if(v&&v.length>0)for(const _ of v)(0,r.isDebuggerMainContribution)(_)&&p.push(_.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const c=[];return this._breakpoints.forEach(p=>c.push(p)),c}addBreakpoints(c){this.startBreakpoints();const p=c.filter(_=>{const F=_.id;return this._breakpoints.has(F)?!1:(this._breakpoints.set(F,_),!0)});this.fireBreakpointChanges(p,[],[]);const y=[],v=new Map;for(const _ of p)if(_ instanceof C.SourceBreakpoint){let F=v.get(_.location.uri.toString());F||(F={type:"sourceMulti",uri:_.location.uri,lines:[]},v.set(_.location.uri.toString(),F),y.push(F)),F.lines.push({id:_.id,enabled:_.enabled,condition:_.condition,hitCondition:_.hitCondition,logMessage:_.logMessage,line:_.location.range.start.line,character:_.location.range.start.character})}else _ instanceof C.FunctionBreakpoint&&y.push({type:"function",id:_.id,enabled:_.enabled,hitCondition:_.hitCondition,logMessage:_.logMessage,condition:_.condition,functionName:_.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(c){this.startBreakpoints();const p=c.filter(F=>this._breakpoints.delete(F.id));this.fireBreakpointChanges([],p,[]);const y=p.filter(F=>F instanceof C.SourceBreakpoint).map(F=>F.id),v=p.filter(F=>F instanceof C.FunctionBreakpoint).map(F=>F.id),_=p.filter(F=>F instanceof C.DataBreakpoint).map(F=>F.id);return this._debugServiceProxy.$unregisterBreakpoints(y,v,_)}startDebugging(c,p,y){return this._debugServiceProxy.$startDebugging(c?c.uri:void 0,p,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(c){return this._debugServiceProxy.$stopDebugging(c?c.id:void 0)}registerDebugConfigurationProvider(c,p,y){if(!p)return new C.Disposable(()=>{});const v=this._configProviderHandleCounter++;return this._configProviders.push({type:c,handle:v,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(c,y,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,v),new C.Disposable(()=>{this._configProviders=this._configProviders.filter(_=>_.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(c,p,y){if(!y)return new C.Disposable(()=>{});if(!this.definesDebugType(c,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:v,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,v),new C.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(_=>_.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(c,p){if(!p)return new C.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:c,handle:y,factory:p}),new C.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(v=>v.factory!==p)})}async $runInTerminal(c,p){return Promise.resolve(void 0)}async $substituteVariables(c,p){if(!this._variableResolver){const[_,F]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(_||[],this._editorsService,F)}let y;const v=await this.getFolder(c);return v&&(y={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,p)}createDebugAdapter(c,p){if(c.type==="implementation")return new l(c.implementation)}createSignService(){}async $startDASession(c,p){const y=this,v=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(v.type),v).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const F=this.convertToDto(_),x=this.createDebugAdapter(F,v);if(!x)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const Y=x;return this._debugAdapters.set(c,Y),this.getDebugAdapterTrackers(v).then(me=>(me&&this._debugAdaptersTrackers.set(c,me),Y.onMessage(async j=>{if(j.type==="request"&&j.command==="handshake"){const z=j,te={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const $=await this._signService.sign(z.arguments.value);te.body={signature:$},Y.sendResponse(te)}else throw new Error("no signer")}catch($){te.success=!1,te.message=$.message,Y.sendResponse(te)}}else me&&me.onDidSendMessage&&me.onDidSendMessage(j),j=(0,r.convertToVSCPaths)(j,!0),y._debugServiceProxy.$acceptDAMessage(c,j)}),Y.onError(j=>{me&&me.onError&&me.onError(j),this._debugServiceProxy.$acceptDAError(c,j.name,j.message,j.stack)}),Y.onExit(j=>{me&&me.onExit&&me.onExit((0,m.withNullAsUndefined)(j),void 0),this._debugServiceProxy.$acceptDAExit(c,(0,m.withNullAsUndefined)(j),void 0)}),me&&me.onWillStartSession&&me.onWillStartSession(),Y.startSession()))})}$sendDAMessage(c,p){p=(0,r.convertToDAPaths)(p,!1);const y=this._debugAdaptersTrackers.get(c);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(p);const v=this._debugAdapters.get(c);v&&v.sendMessage(p)}$stopDASession(c){const p=this._debugAdaptersTrackers.get(c);this._debugAdaptersTrackers.delete(c),p&&p.onWillStopSession&&p.onWillStopSession();const y=this._debugAdapters.get(c);return this._debugAdapters.delete(c),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(c){const p=[],y=[],v=[];if(c.added)for(const _ of c.added){const F=_.id;if(F&&!this._breakpoints.has(F)){let x;if(_.type==="function")x=new C.FunctionBreakpoint(_.functionName,_.enabled,_.condition,_.hitCondition,_.logMessage);else if(_.type==="data")x=new C.DataBreakpoint(_.label,_.dataId,_.canPersist,_.enabled,_.hitCondition,_.condition,_.logMessage);else{const Y=P.URI.revive(_.uri);x=new C.SourceBreakpoint(new C.Location(Y,new C.Position(_.line,_.character)),_.enabled,_.condition,_.hitCondition,_.logMessage)}x._id=F,this._breakpoints.set(F,x),p.push(x)}}if(c.removed)for(const _ of c.removed){const F=this._breakpoints.get(_);F&&(this._breakpoints.delete(_),y.push(F))}if(c.changed){for(const _ of c.changed)if(_.id){const F=this._breakpoints.get(_.id);if(F){if(F instanceof C.FunctionBreakpoint&&_.type==="function"){const x=F;x.enabled=_.enabled,x.condition=_.condition,x.hitCondition=_.hitCondition,x.logMessage=_.logMessage,x.functionName=_.functionName}else if(F instanceof C.SourceBreakpoint&&_.type==="source"){const x=F;x.enabled=_.enabled,x.condition=_.condition,x.hitCondition=_.hitCondition,x.logMessage=_.logMessage,x.location=new C.Location(P.URI.revive(_.uri),new C.Position(_.line,_.character))}v.push(F)}}}this.fireBreakpointChanges(p,y,v)}$provideDebugConfigurations(c,p,y){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(c);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const _=await this.getFolder(p);return v.provideDebugConfigurations(_,y)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(c,p,y,v){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(c);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const F=await this.getFolder(p);return _.resolveDebugConfiguration(F,y,v)})}$resolveDebugConfigurationWithSubstitutedVariables(c,p,y,v){return(0,T.asPromise)(async()=>{const _=this.getConfigProviderByHandle(c);if(!_)throw new Error("no DebugConfigurationProvider found");if(!_.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const F=await this.getFolder(p);return _.resolveDebugConfigurationWithSubstitutedVariables(F,y,v)})}async $provideDebugAdapter(c,p){const y=this.getAdapterDescriptorFactoryByHandle(c);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.getSession(p);return this.getAdapterDescriptor(y,v).then(_=>{if(!_)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.convertToDto(_)})}async $acceptDebugSessionStarted(c){const p=await this.getSession(c);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(c){const p=await this.getSession(c);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(c){this._activeDebugSession=c?await this.getSession(c):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(c,p){const y=await this.getSession(c);y&&y._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(c,p){const v={session:await this.getSession(c),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(v)}convertToDto(c){if(c instanceof C.DebugAdapterExecutable)return{type:"executable",command:c.command,args:c.args,options:c.options};if(c instanceof C.DebugAdapterServer)return{type:"server",port:c.port,host:c.host};if(c instanceof C.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:c.path};if(c instanceof C.DebugAdapterInlineImplementation)return{type:"implementation",implementation:c.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(c){const p=this._adapterFactories.filter(y=>y.type===c);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(c){const p=this._adapterFactories.filter(y=>y.handle===c);if(p.length>0)return p[0].factory}getConfigProviderByHandle(c){const p=this._configProviders.filter(y=>y.handle===c);if(p.length>0)return p[0].provider}definesDebugType(c,p){if(c.contributes){const y=c.contributes.debuggers;if(y&&y.length>0){for(const v of y)if(v.label&&v.type&&v.type===p)return!0}}return!1}getDebugAdapterTrackers(c){const y=c.configuration.type,v=this._trackerFactories.filter(_=>_.type===y||_.type==="*").map(_=>(0,T.asPromise)(()=>_.factory.createDebugAdapterTracker(c)).then(F=>F,F=>null));return Promise.race([Promise.all(v).then(_=>{const F=_.filter(x=>!!x);if(F.length>0)return new n(F)}),new Promise((_,F)=>{const x=setTimeout(()=>{clearTimeout(x),F(new Error("timeout"))},1e3)})]).catch(_=>{})}async getAdapterDescriptor(c,p){const y=p.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new C.DebugAdapterServer(y));if(c){const _=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>c.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,_))).then(F=>{if(F)return F})}const v=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,v))}daExecutableFromPackage(c,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(c,p,y){(c.length>0||p.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:c,removed:p,changed:y}))}async getSession(c){if(c)if(typeof c=="string"){const p=this._debugSessions.get(c);if(p)return p}else{let p=this._debugSessions.get(c.id);if(!p){const y=await this.getFolder(c.folderUri);p=new u(this._debugServiceProxy,c.id,c.type,c.name,y,c.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(c){if(c){const p=P.URI.revive(c);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};f=Ve([qe(0,o.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],f),e.ExtHostDebugServiceBase=f;class u{constructor(c,p,y,v,_,F){this._debugServiceProxy=c,this._id=p,this._type=y,this._name=v,this._workspaceFolder=_,this._configuration=F}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(c){this._name=c,this._debugServiceProxy.$setDebugSessionName(this._id,c)}_acceptNameChanged(c){this._name=c}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(c,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,c,p)}getDebugProtocolBreakpoint(c){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,c.id)}}e.ExtHostDebugSession=u;class b{constructor(c){this.value=Object.freeze({append(p){c.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=b;class t extends d.AbstractVariableResolverService{constructor(c,p,y,v){super({getFolderUri:_=>{const F=c.filter(x=>x.name===_);if(F&&F.length>0)return F[0].uri},getWorkspaceFolderCount:()=>c.length,getConfigurationValue:(_,F)=>y.getConfiguration(void 0,_).get(F),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const _=p.activeEditor();if(_)return w.normalize(_.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&v){const _=p.activeEditor();if(_){const F=v.getWorkspaceFolder(_.document.uri);if(F)return w.normalize(F.uri.fsPath)}}},getSelectedText:()=>{if(p){const _=p.activeEditor();if(_&&!_.selection.isEmpty)return _.document.getText(_.selection)}},getLineNumber:()=>{if(p){const _=p.activeEditor();if(_)return String(_.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=t;class n{constructor(c){this.trackers=c}onWillStartSession(){this.trackers.forEach(c=>c.onWillStartSession?c.onWillStartSession():void 0)}onWillReceiveMessage(c){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(c):void 0)}onDidSendMessage(c){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(c):void 0)}onWillStopSession(){this.trackers.forEach(c=>c.onWillStopSession?c.onWillStopSession():void 0)}onError(c){this.trackers.forEach(p=>p.onError?p.onError(c):void 0)}onExit(c,p){this.trackers.forEach(y=>y.onExit?y.onExit(c,p):void 0)}}class l extends D.AbstractDebugAdapter{constructor(c){super();this.implementation=c,c.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(c){this.implementation.handleMessage(c)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let a=class extends f{constructor(c,p,y,v,_){super(c,p,y,v,_)}createVariableResolver(c,p,y){return new t(c,p,y)}};a=Ve([qe(0,o.IExtHostRpcService),qe(1,k.IExtHostWorkspace),qe(2,i.IExtHostExtensionService),qe(3,I.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration)],a),e.WorkerExtHostDebugService=a}),define(we[221],_e([0,1,80,2,5,34,33,26,14,27,4,35,46,18]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(f,u,b,t,n,l,a){this._apiFactory=f,this._extensionRegistry=u,this._instaService=b,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=l,this._logService=a,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),w.mark("code/extHost/willWaitForConfig");const f=await this._extHostConfiguration.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const u=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,u,this._extensionRegistry,f,this._logService)),this.register(this._instaService.createInstance(g)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(m,u,this._initData.environment.appUriScheme))}register(f){if(Array.isArray(f.nodeModuleName))for(let u of f.nodeModuleName)this._factories.set(u,f);else this._factories.set(f.nodeModuleName,f);typeof f.alternativeModuleName=="function"&&this._alternatives.push(u=>f.alternativeModuleName(u))}};r=Ve([qe(2,i.IInstantiationService),qe(3,T.IExtHostConfiguration),qe(4,I.IExtHostExtensionService),qe(5,k.IExtHostInitDataService),qe(6,h.ILogService)],r),e.RequireInterceptor=r;class o{constructor(f,u,b,t,n){this._apiFactory=f,this._extensionPaths=u,this._extensionRegistry=b,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(f,u){const b=this._extensionPaths.findSubstr(u.fsPath);if(b){let t=this._extApiImpl.get(C.ExtensionIdentifier.toKey(b.identifier));return t||(t=this._apiFactory(b,this._extensionRegistry,this._configProvider),this._extApiImpl.set(C.ExtensionIdentifier.toKey(b.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,l)=>t+=`	${l} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${u.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(S.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let g=class{constructor(f,u){this.nodeModuleName="keytar";const{environment:b}=u,t=f.getProxy(A.MainContext.MainThreadKeytar);if(b.appRoot){let n=b.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,l)=>t.$getPassword(n,l),setPassword:(n,l,a)=>t.$setPassword(n,l,a),deletePassword:(n,l)=>t.$deletePassword(n,l),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(f,u){return this._impl}alternativeModuleName(f){const u=f.length;if(!(u<=7||!this.alternativeNames)){const b=u-7;if((f.charAt(b)==="/"||f.charAt(b)==="\\")&&f.endsWith("keytar")&&(f=f.replace(/\\/g,"/"),this.alternativeNames.has(f)))return"keytar"}}};g=Ve([qe(0,D.IExtHostRpcService),qe(1,k.IExtHostInitDataService)],g);let m=class{constructor(f,u,b){this._extensionPaths=f,this._appUriScheme=u,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=b.getProxy(A.MainContext.MainThreadTelemetry);const t=b.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,l)=>{const a=P.URI.parse(n);return l?this.callOriginal(n,l):a.scheme==="http"||a.scheme==="https"?t.$openUri(a,n,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this._appUriScheme?t.$openUri(a,n,{}):this.callOriginal(n,l)}}load(f,u,b){const t=this._extensionPaths.findSubstr(u.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=b(f),this._impl}callOriginal(f,u){return this.sendNoForwardTelemetry(),this._original(f,u)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};m=Ve([qe(2,D.IExtHostRpcService)],m)}),define(we[222],_e([0,1,11,12,80,6,2,5,214,18,61,65,27,151,14,71,35,40]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(u,b,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const l=new D.RPCProtocol(u,null,n);b=E._transform(b,l);const a=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());a.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},b)),a.set(r.IExtHostRpcService,new r.ExtHostRpcService(l)),a.set(o.IURITransformerService,new o.URITransformerService(n)),a.set(g.IHostUtils,t);const s=new h.InstantiationService(a,!0),c=s.invokeFunction(_=>_.get(m.IExtHostTerminalService));this._disposables.add(c),this._logService=s.invokeFunction(_=>_.get(k.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",b),this._extensionService=s.invokeFunction(_=>_.get(g.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(_=>{Error.prepareStackTrace=(F,x)=>{let Y="",me,j;for(const z of x)Y+=`
	at ${z.toString()}`,j=z.getFileName(),!me&&j&&(me=_.findSubstr(j));return p.set(F,me),`${F.name||"Error"}: ${F.message||""}${Y}`}});const y=l.getProxy(C.MainContext.MainThreadExtensionService),v=l.getProxy(C.MainContext.MainThreadErrors);P.setUnexpectedErrorHandler(_=>{const F=P.transformErrorForSerialization(_),x=p.get(_);x?y.$onExtensionRuntimeError(x.identifier,F):v.$onUnexpectedError(F)})}terminate(u){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${u}`),this._logService.flush(),this._disposables.dispose(),P.setUnexpectedErrorHandler(t=>{});const b=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,w.timeout)(4e3),b]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(u,b){u.extensions.forEach(n=>n.extensionLocation=S.URI.revive(b.transformIncomingURIs(n.extensionLocation))),u.environment.appRoot=S.URI.revive(b.transformIncomingURIs(u.environment.appRoot));const t=u.environment.extensionDevelopmentLocationURI;return t&&(u.environment.extensionDevelopmentLocationURI=t.map(n=>S.URI.revive(b.transformIncomingURIs(n)))),u.environment.extensionTestsLocationURI=S.URI.revive(b.transformIncomingURIs(u.environment.extensionTestsLocationURI)),u.environment.globalStorageHome=S.URI.revive(b.transformIncomingURIs(u.environment.globalStorageHome)),u.environment.workspaceStorageHome=S.URI.revive(b.transformIncomingURIs(u.environment.workspaceStorageHome)),u.logsLocation=S.URI.revive(b.transformIncomingURIs(u.logsLocation)),u.logFile=S.URI.revive(b.transformIncomingURIs(u.logFile)),u.workspace=b.transformIncomingURIs(u.workspace),u}}e.ExtensionHostMain=E}),define(we[223],_e([0,1,13,20,60,28,25,55,41]),function(Q,e,w,P,A,T,S,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,h,r){this.config=d,this.provider=h,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const h=this.config.folderQueries||[];return new Promise((r,o)=>{const g=m=>{this.resultCount++,d(m)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(m=>{const E=m.toString(),f=w.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,f)||this.matchFile(g,{base:m,basename:f})}),Promise.all(h.map(m=>this.searchInFolder(m,g))).then(m=>{r({limitHit:this.isLimitHit,stats:m[0]||void 0})},m=>{o(new Error((0,A.toErrorMessage)(m)))})})}async searchInFolder(d,h){const r=new P.CancellationTokenSource,o=this.getSearchOptionsForFolder(d),g=this.initDirectoryTree(),m=new D.QueryGlobTester(this.config,d),E=!m.hasSiblingExcludeClauses();let f;try{this.activeCancellationTokens.add(r),f=C.StopWatch.create();const u=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,r.token),b=f.elapsed(),t=C.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(u&&u.forEach(n=>{const l=w.posix.relative(d.folder.path,n.path);if(E){const a=w.basename(n.path);this.matchFile(h,{base:d.folder,relativePath:l,basename:a});return}this.addDirectoryEntries(g,d.folder,l,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(g,m,h),{providerTime:b,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(d){const h=(0,D.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),r=(0,D.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:r,includes:h,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},h,r,o){if(r===this.filePattern){const m=w.basename(this.filePattern);this.matchFile(o,{base:h,relativePath:this.filePattern,basename:m})}function g(m){const E=w.basename(m),f=w.dirname(m);let u=d[f];u||(u=d[f]=[],g(f)),u.push({base:h,relativePath:m,basename:E})}g(r)}matchDirectoryTree({rootEntries:d,pathToEntries:h},r,o){const g=this,m=this.filePattern;function E(f){const u=T.hasSiblingFn(()=>f.map(b=>b.basename));for(let b=0,t=f.length;b<t;b++){const n=f[b],{relativePath:l,basename:a}=n;if(!!r.includedInQuerySync(l,a,m!==a?u:void 0)){const s=h[l];if(s)E(s);else{if(l===m)continue;g.matchFile(o,n)}if(g.isLimitHit)break}}}E(d)}matchFile(d,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(h))}}class i{constructor(){this.sessions=new Map}fileSearch(d,h,r,o){const g=this.getSessionTokenSource(d.cacheKey),m=new k(d,h,g&&g.token);let E=0;const f=u=>{E+=u.length,r(u.map(b=>this.rawMatchToSearchItem(b)))};return this.doSearch(m,i.BATCH_SIZE,f,o).then(u=>({limitHit:u.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:u.stats}}))}clearCache(d){const h=this.getSessionTokenSource(d);h&&h.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new P.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:S.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,h,r,o){o.onCancellationRequested(()=>{d.cancel()});const g=E=>{E&&(m.push(E),h>0&&m.length>=h&&(r(m),m=[]))};let m=[];return d.search(g).then(E=>(m.length&&r(m),E),E=>(m.length&&r(m),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(we[224],_e([0,1,13,15,20,60,25,28,2,41,19,10]),function(Q,e,w,P,A,T,S,C,D,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(f,u,b){this.query=f,this.provider=u,this.fileUtils=b,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(f,u){const b=this.query.folderQueries||[],t=new A.CancellationTokenSource;return u.onCancellationRequested(()=>t.cancel()),new Promise((n,l)=>{this.collector=new r(f);let a=!1;const s=(c,p)=>{if(!a&&!this.isLimitHit){const y=this.resultSize(c);g(c)&&typeof this.query.maxResults=="number"&&this.resultCount+y>this.query.maxResults&&(this.isLimitHit=!0,a=!0,t.cancel(),c=this.trimResultToSize(c,this.query.maxResults-this.resultCount));const v=this.resultSize(c);this.resultCount+=v,(v>0||!g(c))&&this.collector.add(c,p)}};Promise.all(b.map((c,p)=>this.searchInFolder(c,y=>s(y,p),t.token))).then(c=>{t.dispose(),this.collector.flush();const p=c.some(y=>!!y&&!!y.limitHit);n({limitHit:this.isLimitHit||p,messages:(0,P.flatten)(c.map(y=>(y==null?void 0:y.message)?(0,I.isArray)(y.message)?y.message:[y.message]:[])),stats:{type:"textSearchProvider"}})},c=>{t.dispose();const p=(0,T.toErrorMessage)(c);l(new Error(p))})})}resultSize(f){return g(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}trimResultToSize(f,u){const b=Array.isArray(f.ranges)?f.ranges:[f.ranges],t=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:b.slice(0,u),preview:{matches:t.slice(0,u),text:f.preview.text},uri:f.uri}}async searchInFolder(f,u,b){const t=new k.QueryGlobTester(this.query,f),n=[],l={report:c=>{if(!!this.validateProviderResult(c)){const p=f.folder.scheme===i.Schemas.file?C.hasSiblingPromiseFn(()=>this.fileUtils.readdir(S.dirname(c.uri))):void 0,y=S.relativePath(f.folder,c.uri);y&&n.push(t.includedInQuery(y,w.basename(y),p).then(v=>{v&&u(c)}))}}},a=this.getSearchOptionsForFolder(f),s=await this.provider.provideTextSearchResults(h(this.query.contentPattern),a,l,b);return await Promise.all(n),s}validateProviderResult(f){if(g(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(f){const u=(0,k.resolvePatternsForProvider)(this.query.includePattern,f.includePattern),b=(0,k.resolvePatternsForProvider)(this.query.excludePattern,f.excludePattern),t={folder:D.URI.from(f.folder),excludes:b,includes:u,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.fileUtils.toCanonicalName(f.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function h(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(f){this._onResult=f,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new m(512,u=>this.sendItems(u))}add(f,u){this._currentFileMatch&&(this._currentFolderIdx!==u||!S.isEqual(this._currentUri,f.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=u,this._currentFileMatch={resource:f.uri,results:[]}),this._currentFileMatch.results.push(o(f))}pushToCollector(){const f=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,f)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(f){this._onResult(f)}}e.TextSearchResultsCollector=r;function o(E){return g(E)?{preview:{matches:(0,P.mapArrayOrNot)(E.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:E.preview.text},ranges:(0,P.mapArrayOrNot)(E.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function g(E){return!!E.preview}e.extensionResultIsMatch=g;class m{constructor(f,u){this.maxBatchSize=f,this.cb=u,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(f,u){!f||this.addItemToBatch(f,u)}addItems(f,u){!f||this.addItemsToBatch(f,u)}addItemToBatch(f,u){this.batch.push(f),this.batchSize+=u,this.onUpdate()}addItemsToBatch(f,u){this.batch=this.batch.concat(f),this.batchSize+=u,this.onUpdate()}onUpdate(){this.totalNumberCompleted<m.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},m.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=m,m.TIMEOUT=4e3,m.START_BATCH_AFTER_COUNT=50}),define(we[105],_e([0,1,6,5,4,223,14,71,18,2,224]),function(Q,e,w,P,A,T,S,C,D,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let I=class{constructor(o,g,m){this.extHostRpc=o,this._uriTransformer=g,this._logService=m,this._proxy=this.extHostRpc.getProxy(P.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,g){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const m=this._handlePool++;return this._textSearchProvider.set(m,g),this._proxy.$registerTextSearchProvider(m,this._transformScheme(o)),(0,w.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}registerFileSearchProvider(o,g){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const m=this._handlePool++;return this._fileSearchProvider.set(m,g),this._proxy.$registerFileSearchProvider(m,this._transformScheme(o)),(0,w.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(m),this._proxy.$unregisterProvider(m)})}$provideFileSearchResults(o,g,m,E){const f=d(m),u=this._fileSearchProvider.get(o);if(u)return this._fileSearchManager.fileSearch(f,u,b=>{this._proxy.$handleFileMatch(o,g,b.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,g,m,E){const f=this._textSearchProvider.get(o);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const u=d(m);return this.createTextSearchManager(u,f).search(t=>this._proxy.$handleTextMatch(o,g,t),E)}createTextSearchManager(o,g){return new i.TextSearchManager(o,g,{readdir:m=>Promise.resolve([]),toCanonicalName:m=>m})}};I=Ve([qe(0,S.IExtHostRpcService),qe(1,C.IURITransformerService),qe(2,D.ILogService)],I),e.ExtHostSearch=I;function d(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(h),extraFileResources:r.extraFileResources&&r.extraFileResources.map(o=>k.URI.revive(o))})}e.reviveQuery=d;function h(r){return Object.assign(Object.assign({},r),{folder:k.URI.revive(r.folder)})}}),define(we[225],_e([0,1,130,20,12,3,47,2,123,85,117,59,64,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,50,101,30,33,51,166,197,93,99,103,104,105,18,71,14,27,201,164,70,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,67,102]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u,b,t,n,l,a,s,c,p,y,v,_,F,x,Y,me,j,z,te,$,R,L,M,U,G,J,re,pe,Te,xe,Ae,We,B,q,ne,le,fe,Se,Oe,ge,Ce,Pe,$e,Ee,je,H,ee,ve,Le,He,Ue,Xe,W,ie,ce,V,X,ae,he,ye,ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Be(Ne){const Ge=Ne.get(Oe.IExtHostInitDataService),nt=Ne.get(W.IExtHostFileSystemInfo),dt=Ne.get(ve.IExtHostConsumerFileSystem),it=Ne.get(a.IExtHostExtensionService),Je=Ne.get(J.IExtHostWorkspace),mt=Ne.get(ae.IExtHostTelemetry),bt=Ne.get(E.IExtHostConfiguration),be=Ne.get(fe.IURITransformerService),de=Ne.get(Se.IExtHostRpcService),oe=Ne.get(j.IExtHostStorage),K=Ne.get(ee.IExtensionStoragePaths),Re=Ne.get(le.ILogService),Ie=Ne.get(Pe.IExtHostTunnelService),Qe=Ne.get($e.IExtHostApiDeprecationService),Ze=Ne.get(G.IExtHostWindow),ut=Ne.get(V.IExtHostSecretState);de.set(h.ExtHostContext.ExtHostFileSystemInfo,nt),de.set(h.ExtHostContext.ExtHostLogService,Re),de.set(h.ExtHostContext.ExtHostWorkspace,Je),de.set(h.ExtHostContext.ExtHostConfiguration,bt),de.set(h.ExtHostContext.ExtHostExtensionService,it),de.set(h.ExtHostContext.ExtHostStorage,oe),de.set(h.ExtHostContext.ExtHostTunnelService,Ie),de.set(h.ExtHostContext.ExtHostWindow,Ze),de.set(h.ExtHostContext.ExtHostSecretState,ut),de.set(h.ExtHostContext.ExtHostTelemetry,mt);const ht=de.set(h.ExtHostContext.ExtHostDecorations,Ne.get(We.IExtHostDecorations)),Ye=de.set(h.ExtHostContext.ExtHostDocumentsAndEditors,Ne.get(l.IExtHostDocumentsAndEditors)),ot=de.set(h.ExtHostContext.ExtHostCommands,Ne.get(g.IExtHostCommands)),ft=de.set(h.ExtHostContext.ExtHostTerminalService,Ne.get(z.IExtHostTerminalService)),at=de.set(h.ExtHostContext.ExtHostDebugService,Ne.get(q.IExtHostDebugService)),Et=de.set(h.ExtHostContext.ExtHostSearch,Ne.get(ne.IExtHostSearch)),vt=de.set(h.ExtHostContext.ExtHostTask,Ne.get(B.IExtHostTask)),kt=de.set(h.ExtHostContext.ExtHostOutputService,Ne.get(_.IExtHostOutputService)),At=de.set(h.ExtHostContext.ExtHostEditorTabs,new X.ExtHostEditorTabs),Tt=de.set(h.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(de)),_t=de.set(h.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(de,Ye)),Yt=de.set(h.ExtHostContext.ExtHostDocumentContentProviders,new b.ExtHostDocumentContentProvider(de,Ye,Re)),Jt=de.set(h.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Re,_t,de.getProxy(h.MainContext.MainThreadBulkEdits))),gt=de.set(h.ExtHostContext.ExtHostNotebook,new ge.ExtHostNotebookController(de,ot,Ye,_t,Re,K)),Xt=de.set(h.ExtHostContext.ExtHostNotebookKernels,new he.ExtHostNotebookKernels(de,Ge,gt)),St=de.set(h.ExtHostContext.ExtHostEditors,new te.ExtHostEditors(de,Ye)),jt=de.set(h.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(de.getProxy(h.MainContext.MainThreadTreeViews),ot,Re)),Zt=de.set(h.ExtHostContext.ExtHostEditorInsets,new Te.ExtHostEditorInsets(de.getProxy(h.MainContext.MainThreadEditorInsets),St,Ge.environment)),qt=de.set(h.ExtHostContext.ExtHostDiagnostics,new f.ExtHostDiagnostics(de,Re)),lt=de.set(h.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(de,be,_t,ot,qt,Re,Qe)),en=de.set(h.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(de,lt)),Rt=de.set(h.ExtHostContext.ExtHostFileSystemEventService,new c.ExtHostFileSystemEventService(de,Re,Ye)),xt=de.set(h.ExtHostContext.ExtHostQuickOpen,(0,x.createExtHostQuickOpen)(de,Je,ot)),dn=de.set(h.ExtHostContext.ExtHostSCM,new Y.ExtHostSCM(de,ot,Re)),_n=de.set(h.ExtHostContext.ExtHostComments,new m.ExtHostComments(de,ot,_t)),hn=de.set(h.ExtHostContext.ExtHostProgress,new F.ExtHostProgress(de.getProxy(h.MainContext.MainThreadProgress))),tn=de.set(h.ExtHostContext.ExtHosLabelService,new xe.ExtHostLabelService(de)),Kt=de.set(h.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(de)),Nt=de.set(h.ExtHostContext.ExtHostAuthentication,new Ee.ExtHostAuthentication(de)),En=de.set(h.ExtHostContext.ExtHostTimeline,new je.ExtHostTimeline(de,ot)),nn=de.set(h.ExtHostContext.ExtHostWebviews,new U.ExtHostWebviews(de,Ge.environment,Je,Re,Qe)),rn=de.set(h.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(de,nn,Je)),Gt=de.set(h.ExtHostContext.ExtHostCustomEditors,new He.ExtHostCustomEditors(de,_t,K,nn,rn)),yn=de.set(h.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(de,nn)),Ft=de.set(h.ExtHostContext.ExtHostTesting,new ie.ExtHostTesting(de,Ye,Je)),sn=de.set(h.ExtHostContext.ExtHostUriOpeners,new ce.ExtHostUriOpeners(de)),Sn=(0,pe.values)(h.ExtHostContext);de.assertRegistered(Sn);const $t=new Xe.ExtHostBulkEdits(de,Ye),on=new o.ExtHostClipboard(de),Ut=new v.ExtHostMessageService(de,Re),Lt=new u.ExtHostDialogs(de),fn=new me.ExtHostStatusBar(de,ot.converter),Wt=new y.ExtHostLanguages(de,_t);return r.ExtHostApiCommands.register(ot),function(Fe,an,ln){const pt=function(){let Z=!Fe.isUnderDevelopment;function ue(ke){Z||(Re.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function ke(rt){if(Array.isArray(rt))rt.forEach(ke);else if(typeof rt=="string")ue(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ue(rt),!Fe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,re.throwProposedApiError)(Fe)}return rt}}(),Dn={getSession(Z,ue,ke){return Nt.getSession(Fe,Z,ue,ke)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(Z,ue,ke,rt){return Nt.registerAuthenticationProvider(Z,ue,ke,rt)},get onDidChangeAuthenticationProviders(){return(0,re.checkProposedApiEnabled)(Fe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,re.checkProposedApiEnabled)(Fe),Nt.providers},logout(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),Nt.removeSession(Z,ue)}},Cn={registerCommand(Z,ue,ke){return ot.registerCommand(!0,Z,ue,ke)},registerTextEditorCommand(Z,ue,ke){return ot.registerCommand(!0,Z,(...rt)=>{const wt=St.getActiveTextEditor();if(!wt){Re.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Dt=>{ue.apply(ke,[wt,Dt,...rt])}).then(Dt=>{Dt||Re.warn("Edits from command "+Z+" were not applied.")},Dt=>{Re.warn("An error occurred while running command "+Z,Dt)})})},registerDiffInformationCommand:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),ot.registerCommand(!0,Z,async(...rt)=>{const wt=Ye.activeEditor(!0);if(!wt){Re.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);ue.apply(ke,[Dt,...rt])})),executeCommand(Z,...ue){return ot.executeCommand(Z,...ue)},getCommands(Z=!1){return ot.getCommands(Z)}},mn={get machineId(){return Ge.telemetryInfo.machineId},get sessionId(){return Ge.telemetryInfo.sessionId},get language(){return Ge.environment.appLanguage},get appName(){return Ge.environment.appName},get appRoot(){var Z,ue;return(ue=(Z=Ge.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return Ge.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ft.getDefaultShell(!1,ln)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(Ge.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ue){return Ze.openUri(Z,{allowTunneling:!!Ge.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===Ge.environment.appUriScheme?Tt.createAppUri(Z):Ze.asExternalUri(Z,{allowTunneling:!!Ge.remote.authority})},get remoteName(){return(0,Ae.getRemoteName)(Ge.remote.authority)},get uiKind(){return Ge.uiKind}};Ge.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=Ge.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.registerTestController(Fe.identifier.value,Z)},createDocumentTestObserver(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.createWorkspaceTestObserver(Z)},runTests(Z){return(0,re.checkProposedApiEnabled)(Fe),Ft.runTests(Z)},createTestItem(Z,ue){return new L.TestItemImpl(Z.id,Z.label,Z.uri,ue)},createTestRun(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),Ft.createTestRun(Fe.identifier.value,Z,ue,ke)},get onDidChangeTestResults(){return(0,re.checkProposedApiEnabled)(Fe),Ft.onResultsChanged},get testResults(){return(0,re.checkProposedApiEnabled)(Fe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const kn={getExtension(Z){const ue=an.getExtensionDescription(Z);if(ue)return new a.Extension(it,Fe.identifier,ue,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new a.Extension(it,Fe.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},In={createDiagnosticCollection(Z){return qt.createDiagnosticCollection(Fe.identifier,Z)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:Z=>qt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,ue){return Wt.changeLanguage(Z.uri,ue)},match(Z,ue){return(0,I.score)(R.LanguageSelector.from(Z),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Z,ue,ke){return lt.registerCodeActionProvider(Fe,pt(Z),ue,ke)},registerCodeLensProvider(Z,ue){return lt.registerCodeLensProvider(Fe,pt(Z),ue)},registerDefinitionProvider(Z,ue){return lt.registerDefinitionProvider(Fe,pt(Z),ue)},registerDeclarationProvider(Z,ue){return lt.registerDeclarationProvider(Fe,pt(Z),ue)},registerImplementationProvider(Z,ue){return lt.registerImplementationProvider(Fe,pt(Z),ue)},registerTypeDefinitionProvider(Z,ue){return lt.registerTypeDefinitionProvider(Fe,pt(Z),ue)},registerHoverProvider(Z,ue){return lt.registerHoverProvider(Fe,pt(Z),ue,Fe.identifier)},registerEvaluatableExpressionProvider(Z,ue){return lt.registerEvaluatableExpressionProvider(Fe,pt(Z),ue,Fe.identifier)},registerInlineValuesProvider(Z,ue){return lt.registerInlineValuesProvider(Fe,pt(Z),ue,Fe.identifier)},registerDocumentHighlightProvider(Z,ue){return lt.registerDocumentHighlightProvider(Fe,pt(Z),ue)},registerLinkedEditingRangeProvider(Z,ue){return lt.registerLinkedEditingRangeProvider(Fe,pt(Z),ue)},registerReferenceProvider(Z,ue){return lt.registerReferenceProvider(Fe,pt(Z),ue)},registerRenameProvider(Z,ue){return lt.registerRenameProvider(Fe,pt(Z),ue)},registerDocumentSymbolProvider(Z,ue,ke){return lt.registerDocumentSymbolProvider(Fe,pt(Z),ue,ke)},registerWorkspaceSymbolProvider(Z){return lt.registerWorkspaceSymbolProvider(Fe,Z)},registerDocumentFormattingEditProvider(Z,ue){return lt.registerDocumentFormattingEditProvider(Fe,pt(Z),ue)},registerDocumentRangeFormattingEditProvider(Z,ue){return lt.registerDocumentRangeFormattingEditProvider(Fe,pt(Z),ue)},registerOnTypeFormattingEditProvider(Z,ue,ke,...rt){return lt.registerOnTypeFormattingEditProvider(Fe,pt(Z),ue,[ke].concat(rt))},registerDocumentSemanticTokensProvider(Z,ue,ke){return lt.registerDocumentSemanticTokensProvider(Fe,pt(Z),ue,ke)},registerDocumentRangeSemanticTokensProvider(Z,ue,ke){return lt.registerDocumentRangeSemanticTokensProvider(Fe,pt(Z),ue,ke)},registerSignatureHelpProvider(Z,ue,ke,...rt){return typeof ke=="object"?lt.registerSignatureHelpProvider(Fe,pt(Z),ue,ke):lt.registerSignatureHelpProvider(Fe,pt(Z),ue,typeof ke=="undefined"?[]:[ke,...rt])},registerCompletionItemProvider(Z,ue,...ke){return lt.registerCompletionItemProvider(Fe,pt(Z),ue,ke)},registerDocumentLinkProvider(Z,ue){return lt.registerDocumentLinkProvider(Fe,pt(Z),ue)},registerColorProvider(Z,ue){return lt.registerColorProvider(Fe,pt(Z),ue)},registerFoldingRangeProvider(Z,ue){return lt.registerFoldingRangeProvider(Fe,pt(Z),ue)},registerSelectionRangeProvider(Z,ue){return lt.registerSelectionRangeProvider(Fe,Z,ue)},registerCallHierarchyProvider(Z,ue){return lt.registerCallHierarchyProvider(Fe,Z,ue)},setLanguageConfiguration:(Z,ue)=>lt.setLanguageConfiguration(Fe,Z,ue),getTokenInformationAtPosition(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),Wt.tokenAtPosition(Z,ue)},registerInlayHintsProvider(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),lt.registerInlayHintsProvider(Fe,Z,ue)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(Z,ue,ke){const rt=await(C.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return St.showTextDocument(rt,ue,ke)},createTextEditorDecorationType(Z){return St.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,ue,ke){return St.onDidChangeActiveTextEditor(Z,ue,ke)},onDidChangeVisibleTextEditors(Z,ue,ke){return St.onDidChangeVisibleTextEditors(Z,ue,ke)},onDidChangeTextEditorSelection(Z,ue,ke){return St.onDidChangeTextEditorSelection(Z,ue,ke)},onDidChangeTextEditorOptions(Z,ue,ke){return St.onDidChangeTextEditorOptions(Z,ue,ke)},onDidChangeTextEditorVisibleRanges(Z,ue,ke){return St.onDidChangeTextEditorVisibleRanges(Z,ue,ke)},onDidChangeTextEditorViewColumn(Z,ue,ke){return St.onDidChangeTextEditorViewColumn(Z,ue,ke)},onDidCloseTerminal(Z,ue,ke){return ft.onDidCloseTerminal(Z,ue,ke)},onDidOpenTerminal(Z,ue,ke){return ft.onDidOpenTerminal(Z,ue,ke)},onDidChangeActiveTerminal(Z,ue,ke){return ft.onDidChangeActiveTerminal(Z,ue,ke)},onDidChangeTerminalDimensions(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),ft.onDidChangeTerminalDimensions(Z,ue,ke)},onDidWriteTerminalData(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),ft.onDidWriteTerminalData(Z,ue,ke)},get state(){return Ze.state},onDidChangeWindowState(Z,ue,ke){return Ze.onDidChangeWindowState(Z,ue,ke)},showInformationMessage(Z,...ue){return Ut.showMessage(Fe,S.default.Info,Z,ue[0],ue.slice(1))},showWarningMessage(Z,...ue){return Ut.showMessage(Fe,S.default.Warning,Z,ue[0],ue.slice(1))},showErrorMessage(Z,...ue){return Ut.showMessage(Fe,S.default.Error,Z,ue[0],ue.slice(1))},showQuickPick(Z,ue,ke){return xt.showQuickPick(Z,!!Fe.enableProposedApi,ue,ke)},showWorkspaceFolderPick(Z){return xt.showWorkspaceFolderPick(Z)},showInputBox(Z,ue){return xt.showInput(Z,ue)},showOpenDialog(Z){return Lt.showOpenDialog(Z)},showSaveDialog(Z){return Lt.showSaveDialog(Z)},createStatusBarItem(Z,ue){let ke,rt,wt,Dt;return Z&&typeof Z!="number"?(ke=Z.id,rt=Z.name,wt=Z.alignment,ue=Z.priority,Dt=Z.accessibilityInformation):(ke=Fe.identifier.value,rt=w.localize(0,null,Fe.displayName||Fe.name),wt=Z),fn.createStatusBarEntry(ke,rt,wt,ue,Dt)},setStatusBarMessage(Z,ue){return fn.setStatusBarMessage(Z,ue)},withScmProgress(Z){return Qe.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),hn.withProgress(Fe,{location:L.ProgressLocation.SourceControl},(ue,ke)=>Z({report(rt){}}))},withProgress(Z,ue){return hn.withProgress(Fe,Z,ue)},createOutputChannel(Z){return kt.createOutputChannel(Z)},createWebviewPanel(Z,ue,ke,rt){return rn.createWebviewPanel(Fe,Z,ue,ke,rt)},createWebviewTextEditorInset(Z,ue,ke,rt){return(0,re.checkProposedApiEnabled)(Fe),Zt.createWebviewEditorInset(Z,ue,ke,rt,Fe)},createTerminal(Z,ue,ke){return typeof Z=="object"?"pty"in Z?ft.createExtensionTerminal(Z):(Z.icon&&(0,re.checkProposedApiEnabled)(Fe),ft.createTerminalFromOptions(Z)):ft.createTerminal(Z,ue,ke)},registerTerminalLinkProvider(Z){return ft.registerLinkProvider(Z)},registerTreeDataProvider(Z,ue){return jt.registerTreeDataProvider(Z,ue,Fe)},createTreeView(Z,ue){return jt.createTreeView(Z,ue,Fe)},registerWebviewPanelSerializer:(Z,ue)=>rn.registerWebviewPanelSerializer(Fe,Z,ue),registerCustomEditorProvider:(Z,ue,ke={})=>Gt.registerCustomEditorProvider(Fe,Z,ue,ke),registerFileDecorationProvider(Z){return ht.registerFileDecorationProvider(Z,Fe.identifier)},registerUriHandler(Z){return Tt.registerUriHandler(Fe.identifier,Z)},createQuickPick(){return xt.createQuickPick(Fe.identifier,!!Fe.enableProposedApi)},createInputBox(){return xt.createInputBox(Fe.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(Z,ue,ke){return Kt.onDidChangeActiveColorTheme(Z,ue,ke)},registerWebviewViewProvider(Z,ue,ke){return yn.registerWebviewViewProvider(Fe,Z,ue,ke==null?void 0:ke.webviewOptions)},get activeNotebookEditor(){return(0,re.checkProposedApiEnabled)(Fe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeActiveNotebookEditor(Z,ue,ke)},get visibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorSelection(Z,ue,ke)},onDidChangeNotebookEditorVisibleRanges(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookEditorVisibleRanges(Z,ue,ke)},showNotebookDocument(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),gt.showNotebookDocument(Z,ue)},registerExternalUriOpener(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),sn.registerExternalUriOpener(Fe.identifier,Z,ue,ke)},get openEditors(){return(0,re.checkProposedApiEnabled)(Fe),At.tabs},get onDidChangeOpenEditors(){return(0,re.checkProposedApiEnabled)(Fe),At.onDidChangeTabs}},pn={get rootPath(){return Qe.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Je.getPath()},set rootPath(Z){throw A.readonly()},getWorkspaceFolder(Z){return Je.getWorkspaceFolder(Z)},get workspaceFolders(){return Je.getWorkspaceFolders()},get name(){return Je.name},set name(Z){throw A.readonly()},get workspaceFile(){return Je.workspaceFile},set workspaceFile(Z){throw A.readonly()},updateWorkspaceFolders:(Z,ue,...ke)=>Je.updateWorkspaceFolders(Fe,Z,ue||0,...ke),onDidChangeWorkspaceFolders:function(Z,ue,ke){return Je.onDidChangeWorkspace(Z,ue,ke)},asRelativePath:(Z,ue)=>Je.getRelativePath(Z,ue),findFiles:(Z,ue,ke,rt)=>Je.findFiles(R.GlobPattern.from(Z),R.GlobPattern.from(ue),ke,Fe.identifier,rt),findTextInFiles:(Z,ue,ke,rt)=>{let wt,Dt;return typeof ue=="object"?(wt=ue,Dt=ke):(wt={},Dt=ue,rt=ke),Je.findTextInFiles(Z,wt||{},Dt,Fe.identifier,rt)},saveAll:Z=>Je.saveAll(Z),applyEdit(Z){return $t.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ue,ke,rt)=>Rt.createFileSystemWatcher(R.GlobPattern.from(Z),ue,ke,rt),get textDocuments(){return _t.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw A.readonly()},openTextDocument(Z){let ue;const ke=Z;if(typeof Z=="string")ue=Promise.resolve(C.URI.file(Z));else if(C.URI.isUri(Z))ue=Promise.resolve(Z);else if(!ke||typeof ke=="object")ue=_t.createDocumentData(ke);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(rt=>_t.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(Z,ue,ke)=>_t.onDidAddDocument(Z,ue,ke),onDidCloseTextDocument:(Z,ue,ke)=>_t.onDidRemoveDocument(Z,ue,ke),onDidChangeTextDocument:(Z,ue,ke)=>_t.onDidChangeDocument(Z,ue,ke),onDidSaveTextDocument:(Z,ue,ke)=>_t.onDidSaveDocument(Z,ue,ke),onWillSaveTextDocument:(Z,ue,ke)=>Jt.getOnWillSaveTextDocumentEvent(Fe)(Z,ue,ke),onDidChangeConfiguration:(Z,ue,ke)=>ln.onDidChangeConfiguration(Z,ue,ke),getConfiguration(Z,ue){return ue=arguments.length===1?void 0:ue,ln.getConfiguration(Z,ue,Fe)},registerTextDocumentContentProvider(Z,ue){return Yt.registerTextDocumentContentProvider(Z,ue)},registerTaskProvider:(Z,ue)=>(Qe.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Fe,Z,ue)),registerFileSystemProvider(Z,ue,ke){return en.registerFileSystemProvider(Fe.identifier,Z,ue,ke)},get fs(){return dt.value},registerFileSearchProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Et.registerFileSearchProvider(Z,ue)),registerTextSearchProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Et.registerTextSearchProvider(Z,ue)),registerRemoteAuthorityResolver:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),it.registerRemoteAuthorityResolver(Z,ue)),registerResourceLabelFormatter:Z=>((0,re.checkProposedApiEnabled)(Fe),tn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ue,ke)=>Rt.onDidCreateFile(Z,ue,ke),onDidDeleteFiles:(Z,ue,ke)=>Rt.onDidDeleteFile(Z,ue,ke),onDidRenameFiles:(Z,ue,ke)=>Rt.onDidRenameFile(Z,ue,ke),onWillCreateFiles:(Z,ue,ke)=>Rt.getOnWillCreateFileEvent(Fe)(Z,ue,ke),onWillDeleteFiles:(Z,ue,ke)=>Rt.getOnWillDeleteFileEvent(Fe)(Z,ue,ke),onWillRenameFiles:(Z,ue,ke)=>Rt.getOnWillRenameFileEvent(Fe)(Z,ue,ke),openTunnel:Z=>((0,re.checkProposedApiEnabled)(Fe),Ie.openTunnel(Fe,Z).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,re.checkProposedApiEnabled)(Fe),Ie.getTunnels()},onDidChangeTunnels:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),Ie.onDidChangeTunnels(Z,ue,ke)),registerPortAttributesProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),Ie.registerPortsAttributesProvider(Z,ue)),registerTimelineProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),En.registerTimelineProvider(Z,ue,Fe.identifier,ot.converter)),get isTrusted(){return Je.trusted},requestWorkspaceTrust:Z=>((0,re.checkProposedApiEnabled)(Fe),Je.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ue,ke)=>Je.onDidGrantWorkspaceTrust(Z,ue,ke)},An={get inputBox(){return Qe.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Fe)},createSourceControl(Z,ue,ke){return dn.createSourceControl(Fe,Z,ue,ke)}},vn={createCommentController(Z,ue){return _n.createCommentController(Fe,Z,ue)}},bn={get activeDebugSession(){return at.activeDebugSession},get activeDebugConsole(){return at.activeDebugConsole},get breakpoints(){return at.breakpoints},onDidStartDebugSession(Z,ue,ke){return at.onDidStartDebugSession(Z,ue,ke)},onDidTerminateDebugSession(Z,ue,ke){return at.onDidTerminateDebugSession(Z,ue,ke)},onDidChangeActiveDebugSession(Z,ue,ke){return at.onDidChangeActiveDebugSession(Z,ue,ke)},onDidReceiveDebugSessionCustomEvent(Z,ue,ke){return at.onDidReceiveDebugSessionCustomEvent(Z,ue,ke)},onDidChangeBreakpoints(Z,ue,ke){return at.onDidChangeBreakpoints(Z,ue,ke)},registerDebugConfigurationProvider(Z,ue,ke){return at.registerDebugConfigurationProvider(Z,ue,ke||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ue){return at.registerDebugAdapterDescriptorFactory(Fe,Z,ue)},registerDebugAdapterTrackerFactory(Z,ue){return at.registerDebugAdapterTrackerFactory(Z,ue)},startDebugging(Z,ue,ke){return!ke||typeof ke=="object"&&"configuration"in ke?at.startDebugging(Z,ue,{parentSession:ke}):at.startDebugging(Z,ue,ke||{})},stopDebugging(Z){return at.stopDebugging(Z)},addBreakpoints(Z){return at.addBreakpoints(Z)},removeBreakpoints(Z){return at.removeBreakpoints(Z)},asDebugSourceUri(Z,ue){return at.asDebugSourceUri(Z,ue)}},Bt={registerTaskProvider:(Z,ue)=>vt.registerTaskProvider(Fe,Z,ue),fetchTasks:Z=>vt.fetchTasks(Z),executeTask:Z=>vt.executeTask(Fe,Z),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(Z,ue,ke)=>vt.onDidStartTask(Z,ue,ke),onDidEndTask:(Z,ue,ke)=>vt.onDidEndTask(Z,ue,ke),onDidStartTaskProcess:(Z,ue,ke)=>vt.onDidStartTaskProcess(Z,ue,ke),onDidEndTaskProcess:(Z,ue,ke)=>vt.onDidEndTaskProcess(Z,ue,ke)},zt={openNotebookDocument:Z=>((0,re.checkProposedApiEnabled)(Fe),gt.openNotebookDocument(Z)),get onDidOpenNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,re.checkProposedApiEnabled)(Fe),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookSerializer(Fe,Z,ue,ke)},registerNotebookContentProvider:(Z,ue,ke)=>((0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookContentProvider(Fe,Z,ue,ke)),registerNotebookCellStatusBarItemProvider:(Z,ue)=>((0,re.checkProposedApiEnabled)(Fe),gt.registerNotebookCellStatusBarItemProvider(Fe,Z,ue)),createNotebookEditorDecorationType(Z){return(0,re.checkProposedApiEnabled)(Fe),gt.createNotebookEditorDecorationType(Z)},onDidChangeNotebookDocumentMetadata(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookDocumentMetadata(Z,ue,ke)},onDidChangeNotebookCells(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCells(Z,ue,ke)},onDidChangeCellExecutionState(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeNotebookCellExecutionState(Z,ue,ke)},onDidChangeCellOutputs(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeCellOutputs(Z,ue,ke)},onDidChangeCellMetadata(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.onDidChangeCellMetadata(Z,ue,ke)},createConcatTextDocument(Z,ue){return(0,re.checkProposedApiEnabled)(Fe),new H.ExtHostNotebookConcatDocument(gt,_t,Z,ue)},createNotebookCellExecutionTask(Z,ue,ke){return(0,re.checkProposedApiEnabled)(Fe),gt.createNotebookCellExecution(Z,ue,ke)},createNotebookController(Z,ue,ke,rt,wt){return(0,re.checkProposedApiEnabled)(Fe),Xt.createNotebookController(Fe,Z,ue,ke,rt,wt)}};return{version:Ge.version,authentication:Dn,commands:Cn,comments:vn,debug:bn,env:mn,extensions:kn,languages:In,notebook:zt,scm:An,tasks:Bt,test:Ht,window:Pn,workspace:pn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:P.CancellationTokenSource,CandidatePortSource:h.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:d.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:h.UIKind,Uri:C.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ye.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ze.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Be}),define(we[226],_e([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(Q,e,w,P,A,T,S,C,D,k,i,I,d,h,r,o,g,m,E,f,u,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(h.IExtensionStoragePaths,h.ExtensionStoragePaths),(0,w.registerSingleton)(g.IExtHostApiDeprecationService,g.ExtHostApiDeprecationService),(0,w.registerSingleton)(C.IExtHostCommands,C.ExtHostCommands),(0,w.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration),(0,w.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,w.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,w.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,w.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,w.registerSingleton)(f.IExtHostFileSystemInfo,f.ExtHostFileSystemInfo),(0,w.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService),(0,w.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,w.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,w.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,w.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,w.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,w.registerSingleton)(m.IExtHostWindow,m.ExtHostWindow),(0,w.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,w.registerSingleton)(u.IExtHostSecretState,u.ExtHostSecretState),(0,w.registerSingleton)(b.IExtHostTelemetry,b.ExtHostTelemetry)}),define(we[227],_e([0,1,225,35,221,7,11,5]),function(Q,e,w,P,A,T,S,C){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(r){var o;const g=(o=self.trustedTypes)===null||o===void 0?void 0:o.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...f)=>{f.forEach(n=>{var l;if(!((l=self.trustedTypes)===null||l===void 0?void 0:l.isScript(n)))throw new Error("TrustedScripts only, please")});const u=f.slice(0,-1).join(","),b=f.pop().toString();return`(function anonymous(${u}) {
${b}
})`}});function m(...E){return g?self.eval(g.createScript("",...E)):new Function(...E)}r.create=m})(k||(k={}));class i extends A.RequireInterceptor{_installInterceptor(){}getModule(o,g){for(let m of this._alternatives){let E=m(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,g,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(C.MainContext.MainThreadConsole);h(o,this._initData.environment.isExtensionDevelopmentDebug);const g=this._instaService.invokeFunction(w.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,g,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,g,m){var E,f,u,b,t,n,l,a;g=g.with({path:d(g.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const s=await fetch(g.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),s.status!==200)throw new Error(s.statusText);const c=await s.text(),p=`${g.toString(!0)}#vscode-extension`,y=`${c}
//# sourceURL=${p}`;let v;try{v=k.create((f=(E=I._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&f!==void 0?f:"module",(b=(u=I._ttpExtensionScripts)===null||u===void 0?void 0:u.createScript("exports"))!==null&&b!==void 0?b:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(a=(l=I._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript(y))!==null&&a!==void 0?a:y)}catch(Y){throw o?console.error(`Loading code for extension ${o.value} failed: ${Y.message}`):console.error(`Loading code failed: ${Y.message}`),console.error(`${g.toString(!0)}${typeof Y.line=="number"?` line ${Y.line}`:""}${typeof Y.column=="number"?` column ${Y.column}`:""}`),console.error(Y),Y}const _={},F={exports:_},x=Y=>{const me=this._fakeModules.getModule(Y,g);if(me===void 0)throw new Error(`Cannot load module '${Y}'`);return me};try{return m.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),v(F,_,x),F.exports!==_?F.exports:_}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),m.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const g=Date.now()+o;for(;Date.now()<g&&!("__jsDebugIsReady"in globalThis);)await(0,S.timeout)(10)}}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(D=self.trustedTypes)===null||D===void 0?void 0:D.createPolicy("ExtensionScripts",{createScript:r=>r});function d(r,o){return r.endsWith(o)?r:r+o}function h(r,o){g("info","log"),g("log","log"),g("warn","warn"),g("error","error");function g(f,u){const b=console[f];console[f]=function(){r.$logExtensionHostMessage({type:"__$console",severity:u,arguments:E(arguments)}),o&&b.apply(console,arguments)}}const m=1e5;function E(f){const u=[],b=[];if(f.length)for(let t=0;t<f.length;t++){if(typeof f[t]=="undefined")f[t]="undefined";else if(f[t]instanceof Error){const n=f[t];n.stack?f[t]=n.stack:f[t]=n.toString()}b.push(f[t])}try{const t=JSON.stringify(b,function(n,l){if(l&&typeof l=="object"){if(u.indexOf(l)!==-1)return"[Circular]";u.push(l)}return l});return t.length>m?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[228],_e([0,1,61,18,35,227,213]),function(Q,e,w,P,A,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.registerSingleton)(A.IExtHostExtensionService,T.ExtHostExtensionService),(0,w.registerSingleton)(P.ILogService,S.ExtHostLogService)}),define(we[230],_e([0,1,24,3,184,222,215,13,80,226,228]),function(Q,e,w,P,A,T,S,C,D){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),m=self.Worker;Worker=function(E,f){const u=`importScripts('${E}');`;f=f||{},f.name=f.name||C.basename(E.toString());const b=new Blob([u],{type:"application/javascript"}),t=URL.createObjectURL(b);return new m(g?g.createScriptURL(t):t,f)}}else self.Worker=class extends S.NestedWorker{constructor(g,m){super(I,g,Object.assign({name:C.basename(g.toString())},m))}};const d=new class{exit(g){i()}async exists(g){return!0}async realpath(g){return g}};class h{constructor(){const m=new MessageChannel,E=new P.Emitter;let f=!1;I(m.port2,[m.port2]),m.port1.onmessage=u=>{const{data:b}=u;if(!(b instanceof ArrayBuffer)){console.warn("UNKNOWN data received",b);return}const t=w.VSBuffer.wrap(new Uint8Array(b,0,b.byteLength));if((0,A.isMessageOfType)(t,2)){f=!0,o("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:u=>{if(!f){const b=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);m.port1.postMessage(b,[b])}}}}}function r(g){return new Promise(m=>{const E=g.onMessage(f=>{E.dispose();const u=JSON.parse(f.toString());g.send((0,A.createMessageOfType)(0)),m({protocol:g,initData:u})});g.send((0,A.createMessageOfType)(1))})}let o=g=>i();(function(){const m=new h;D.mark("code/extHost/willConnectToRenderer"),r(m.protocol).then(E=>{D.mark("code/extHost/didWaitForInitData");const f=new T.ExtensionHostMain(E.protocol,E.initData,d,null);o=u=>f.terminate(u)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b95b73b7b074f5dddccd57e5e290617f1a767ec1/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
